define(["pgadmin.browser.constants","pgadmin.browser.endpoints","pgadmin.browser.messages","pgadmin.browser.utils","pgadmin.user_management.current_user","translations"], (__WEBPACK_EXTERNAL_MODULE__92026__, __WEBPACK_EXTERNAL_MODULE__8012__, __WEBPACK_EXTERNAL_MODULE__1506__, __WEBPACK_EXTERNAL_MODULE__96481__, __WEBPACK_EXTERNAL_MODULE__6537__, __WEBPACK_EXTERNAL_MODULE__52536__) => { return /******/ (() => { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ({

/***/ 31126:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



__webpack_require__(69070);

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.pgBrowser = void 0;

__webpack_require__(32564);

__webpack_require__(89554);

var _jquery = _interopRequireDefault(__webpack_require__(19755));

var _underscore = _interopRequireDefault(__webpack_require__(81311));

var _pgadmin = _interopRequireDefault(__webpack_require__(55112));

var _window = _interopRequireDefault(__webpack_require__(1950));

var _utils = __webpack_require__(44092);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/////////////////////////////////////////////////////////////
//
// pgAdmin 4 - PostgreSQL Tools
//
// Copyright (C) 2013 - 2022, The pgAdmin Development Team
// This software is released under the PostgreSQL Licence
//
//////////////////////////////////////////////////////////////
var pgBrowser = _pgadmin["default"].Browser = _pgadmin["default"].Browser || {};
exports.pgBrowser = pgBrowser;
var MIN_ACTIVITY_TIME_UNIT = 1000;
/* in seconds */

/*
 * User UI activity related functions.
 */

_underscore["default"].extend(pgBrowser, {
  inactivity_timeout_at: null,
  logging_activity: false,
  inactivity_timeout_daemon_running: false,
  is_pgadmin_timedout: function is_pgadmin_timedout() {
    return !_window["default"].pgAdmin;
  },
  is_inactivity_timeout: function is_inactivity_timeout() {
    return _window["default"].pgAdmin.Browser.inactivity_timeout_at < this.get_epoch_now();
  },
  get_epoch_now: function get_epoch_now() {
    return (0, _utils.getEpoch)();
  },
  log_activity: function log_activity() {
    var _this = this;

    if (!this.logging_activity) {
      this.logging_activity = true;
      this.inactivity_timeout_at = this.get_epoch_now() + _pgadmin["default"].user_inactivity_timeout;
      /* No need to log events till next MIN_ACTIVITY_TIME_UNIT second as the
       * value of inactivity_timeout_at won't change
       */

      setTimeout(function () {
        _this.logging_activity = false;
      }, MIN_ACTIVITY_TIME_UNIT);
    }
  },

  /* Call this to register element for acitivity monitoring
   * Generally, document is passed to cover all.
   */
  register_to_activity_listener: function register_to_activity_listener(target, timeout_callback) {
    var inactivity_events = ['mousemove', 'mousedown', 'keydown'];
    var self = this;
    inactivity_events.forEach(function (event) {
      /* Bind events in the event capture phase, the bubble phase might stop propagation */
      var eventHandler = function eventHandler() {
        if (self.is_pgadmin_timedout()) {
          /* If the main page has logged out then remove the listener and call the timeout callback */
          inactivity_events.forEach(function (events) {
            target.removeEventListener(events, eventHandler, true);
          });
          timeout_callback();
        } else {
          _window["default"].pgAdmin.Browser.log_activity();
        }
      };

      target.addEventListener(event, eventHandler, true);
    });
  },

  /*
   * This function can be used by tools like sqleditor where
   * poll call is as good as user activity. Decorate such functions
   * with this to consider them as events. Note that, this is controlled
   * by override_user_inactivity_timeout.
   */
  override_activity_event_decorator: function override_activity_event_decorator(input_func) {
    return function () {
      /* Log only if override_user_inactivity_timeout true */
      if (_pgadmin["default"].override_user_inactivity_timeout) {
        _window["default"].pgAdmin.Browser.log_activity();
      }

      return input_func.apply(this, arguments);
    };
  },
  logout_inactivity_user: function logout_inactivity_user() {
    if (!_underscore["default"].isUndefined(pgBrowser.utils) && !_underscore["default"].isUndefined(pgBrowser.utils.logout_url)) {
      window.location.href = pgBrowser.utils.logout_url;
    }
  },

  /* The daemon will track and logout when timeout occurs */
  start_inactivity_timeout_daemon: function start_inactivity_timeout_daemon() {
    var self = this;

    if (_pgadmin["default"].user_inactivity_timeout > 0 && !self.inactivity_timeout_daemon_running) {
      var timeout_daemon_id = setInterval(function () {
        self.inactivity_timeout_daemon_running = true;

        if (self.is_inactivity_timeout()) {
          clearInterval(timeout_daemon_id);
          self.inactivity_timeout_daemon_running = false;
          (0, _jquery["default"])(window).off('beforeunload');
          self.logout_inactivity_user();
        }
      }, MIN_ACTIVITY_TIME_UNIT);
    }
  }
});

/***/ }),

/***/ 40634:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

__webpack_require__(4129);

__webpack_require__(41539);

__webpack_require__(78783);

__webpack_require__(66992);

__webpack_require__(33948);

__webpack_require__(69070);

__webpack_require__(38880);

__webpack_require__(82526);

__webpack_require__(41817);

__webpack_require__(32165);

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.url_dialog = url_dialog;

__webpack_require__(32564);

__webpack_require__(68309);

var _gettext = _interopRequireDefault(__webpack_require__(91669));

var alertify = _interopRequireWildcard(__webpack_require__(55455));

var _url_for = _interopRequireDefault(__webpack_require__(28008));

var _pgadmin2 = _interopRequireDefault(__webpack_require__(55112));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/////////////////////////////////////////////////////////////
//
// pgAdmin 4 - PostgreSQL Tools
//
// Copyright (C) 2013 - 2022, The pgAdmin Development Team
// This software is released under the PostgreSQL Licence
//
//////////////////////////////////////////////////////////////
var counter = 1;

function url_dialog(_title, _url, _help_filename, _width, _height) {
  var pgBrowser = _pgadmin2["default"].Browser;
  var dlgName = 'UrlDialog' + counter++;
  alertify.dialog(dlgName, function factory() {
    return {
      main: function main(_title) {
        this.set({
          'title': _title
        });
      },
      build: function build() {
        alertify.pgDialogBuild.apply(this);
      },
      settings: {
        url: _url,
        title: _title
      },
      setup: function setup() {
        return {
          buttons: [{
            text: '',
            key: 112,
            className: 'btn btn-primary-icon pull-left fa fa-question pg-alertify-icon-button',
            attrs: {
              name: 'dialog_help',
              type: 'button',
              label: _title,
              url: (0, _url_for["default"])('help.static', {
                'filename': _help_filename
              })
            }
          }, {
            text: (0, _gettext["default"])('Close'),
            key: 27,
            className: 'btn btn-secondary fa fa-lg fa-times pg-alertify-button',
            attrs: {
              name: 'close',
              type: 'button'
            }
          }],
          // Set options for dialog
          options: {
            //disable both padding and overflow control.
            padding: !1,
            overflow: !1,
            modal: false,
            resizable: true,
            maximizable: true,
            pinnable: false,
            closableByDimmer: false,
            closable: false
          }
        };
      },
      hooks: {
        // Triggered when the dialog is closed
        onclose: function onclose() {
          // Clear the view
          return setTimeout(function () {
            return alertify[dlgName]().destroy();
          }, 1000);
        }
      },
      prepare: function prepare() {
        // create the iframe element
        var iframe = document.createElement('iframe');
        iframe.frameBorder = 'no';
        iframe.width = '100%';
        iframe.height = '100%';
        iframe.src = this.setting('url'); // add it to the dialog

        this.elements.content.appendChild(iframe);
      },
      callback: function callback(e) {
        if (e.button.element.name == 'dialog_help') {
          e.cancel = true;
          pgBrowser.showHelp(e.button.element.name, e.button.element.getAttribute('url'), null, null);
          return;
        }
      }
    };
  });
  alertify[dlgName](_title).show().resizeTo(_width || pgBrowser.stdW.lg, _height || pgBrowser.stdH.md);
}

_pgadmin2["default"].ui.dialogs.url_dialog = url_dialog;

/***/ }),

/***/ 89769:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {



function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

__webpack_require__(4129);

__webpack_require__(41539);

__webpack_require__(78783);

__webpack_require__(66992);

__webpack_require__(33948);

__webpack_require__(69070);

__webpack_require__(38880);

__webpack_require__(82526);

__webpack_require__(41817);

__webpack_require__(32165);

__webpack_require__(24812);

__webpack_require__(32564);

__webpack_require__(69826);

var _underscore = _interopRequireDefault(__webpack_require__(81311));

var _pgadmin = _interopRequireDefault(__webpack_require__(55112));

var _jquery = _interopRequireDefault(__webpack_require__(19755));

var _mousetrap = _interopRequireDefault(__webpack_require__(42441));

var commonUtils = _interopRequireWildcard(__webpack_require__(44092));

var _dialog_tab_navigator = _interopRequireDefault(__webpack_require__(89087));

var keyboardFunc = _interopRequireWildcard(__webpack_require__(72945));

var _window = _interopRequireDefault(__webpack_require__(1950));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/////////////////////////////////////////////////////////////
//
// pgAdmin 4 - PostgreSQL Tools
//
// Copyright (C) 2013 - 2022, The pgAdmin Development Team
// This software is released under the PostgreSQL Licence
//
//////////////////////////////////////////////////////////////
var pgBrowser = _pgadmin["default"].Browser = _pgadmin["default"].Browser || {};
pgBrowser.keyboardNavigation = pgBrowser.keyboardNavigation || {};

_underscore["default"].extend(pgBrowser.keyboardNavigation, {
  init: function init() {
    _mousetrap["default"].reset();

    if (pgBrowser.preferences_cache.length > 0) {
      this.keyboardShortcut = {
        'file_shortcut': commonUtils.parseShortcutValue(pgBrowser.get_preference('browser', 'main_menu_file').value),
        'object_shortcut': commonUtils.parseShortcutValue(pgBrowser.get_preference('browser', 'main_menu_object').value),
        'tools_shortcut': commonUtils.parseShortcutValue(pgBrowser.get_preference('browser', 'main_menu_tools').value),
        'help_shortcut': commonUtils.parseShortcutValue(pgBrowser.get_preference('browser', 'main_menu_help').value),
        'left_tree_shortcut': commonUtils.parseShortcutValue(pgBrowser.get_preference('browser', 'browser_tree').value),
        'tabbed_panel_backward': commonUtils.parseShortcutValue(pgBrowser.get_preference('browser', 'tabbed_panel_backward').value),
        'tabbed_panel_forward': commonUtils.parseShortcutValue(pgBrowser.get_preference('browser', 'tabbed_panel_forward').value),
        'sub_menu_query_tool': commonUtils.parseShortcutValue(pgBrowser.get_preference('browser', 'sub_menu_query_tool').value),
        'sub_menu_view_data': commonUtils.parseShortcutValue(pgBrowser.get_preference('browser', 'sub_menu_view_data').value),
        'sub_menu_search_objects': commonUtils.parseShortcutValue(pgBrowser.get_preference('browser', 'sub_menu_search_objects').value),
        'sub_menu_properties': commonUtils.parseShortcutValue(pgBrowser.get_preference('browser', 'sub_menu_properties').value),
        'sub_menu_create': commonUtils.parseShortcutValue(pgBrowser.get_preference('browser', 'sub_menu_create').value),
        'sub_menu_delete': commonUtils.parseShortcutValue(pgBrowser.get_preference('browser', 'sub_menu_delete').value),
        'sub_menu_refresh': commonUtils.parseShortcutValue(pgBrowser.get_preference('browser', 'sub_menu_refresh').value),
        'context_menu': commonUtils.parseShortcutValue(pgBrowser.get_preference('browser', 'context_menu').value),
        'direct_debugging': commonUtils.parseShortcutValue(pgBrowser.get_preference('browser', 'direct_debugging').value),
        'drop_multiple_objects': commonUtils.parseShortcutValue(pgBrowser.get_preference('browser', 'grid_menu_drop_multiple').value),
        'drop_cascade_multiple_objects': commonUtils.parseShortcutValue(pgBrowser.get_preference('browser', 'grid_menu_drop_cascade_multiple').value),
        'add_grid_row': commonUtils.parseShortcutValue(pgBrowser.get_preference('browser', 'add_grid_row').value),
        'open_quick_search': commonUtils.parseShortcutValue(pgBrowser.get_preference('browser', 'open_quick_search').value)
      };
      this.shortcutMethods = {
        'bindMainMenu': {
          'shortcuts': [this.keyboardShortcut.file_shortcut, this.keyboardShortcut.object_shortcut, this.keyboardShortcut.tools_shortcut, this.keyboardShortcut.help_shortcut]
        },
        // Main menu
        'bindRightPanel': {
          'shortcuts': [this.keyboardShortcut.tabbed_panel_backward, this.keyboardShortcut.tabbed_panel_forward]
        },
        // Main window panels
        'bindLeftTree': {
          'shortcuts': this.keyboardShortcut.left_tree_shortcut
        },
        // Main menu,
        'bindSubMenuQueryTool': {
          'shortcuts': this.keyboardShortcut.sub_menu_query_tool
        },
        // Sub menu - Open Query Tool,
        'bindSubMenuViewData': {
          'shortcuts': this.keyboardShortcut.sub_menu_view_data
        },
        // Sub menu - Open View Data,
        'bindSubMenuSearchObjects': {
          'shortcuts': this.keyboardShortcut.sub_menu_search_objects
        },
        // Sub menu - Open search objects,
        'bindSubMenuProperties': {
          'shortcuts': this.keyboardShortcut.sub_menu_properties
        },
        // Sub menu - Edit Properties,
        'bindSubMenuCreate': {
          'shortcuts': this.keyboardShortcut.sub_menu_create
        },
        // Sub menu - Create Object,
        'bindSubMenuDelete': {
          'shortcuts': this.keyboardShortcut.sub_menu_delete
        },
        // Sub menu - Delete object,
        'bindSubMenuRefresh': {
          'shortcuts': this.keyboardShortcut.sub_menu_refresh,
          'bindElem': '#tree'
        },
        // Sub menu - Refresh object,
        'bindContextMenu': {
          'shortcuts': this.keyboardShortcut.context_menu
        },
        // Sub menu - Open context menu,
        'bindDirectDebugging': {
          'shortcuts': this.keyboardShortcut.direct_debugging
        },
        // Sub menu - Direct Debugging
        'bindDropMultipleObjects': {
          'shortcuts': this.keyboardShortcut.drop_multiple_objects
        },
        // Grid Menu Drop Multiple
        'bindDropCascadeMultipleObjects': {
          'shortcuts': this.keyboardShortcut.drop_cascade_multiple_objects
        },
        // Grid Menu Drop Cascade Multiple
        'bindAddGridRow': {
          'shortcuts': this.keyboardShortcut.add_grid_row
        },
        // Subnode Grid Add Row
        'bindOpenQuickSearch': {
          'shortcuts': this.keyboardShortcut.open_quick_search
        } // Subnode Grid Refresh Row

      };
      this.bindShortcuts();
    }
  },
  bindShortcuts: function bindShortcuts() {
    var self = this;

    _underscore["default"].each(self.shortcutMethods, function (keyCombo, callback) {
      self._bindWithMousetrap(keyCombo.shortcuts, self[callback], keyCombo.bindElem);
    });
    /* Dropdown submenu was not working properly for up/down arrow keys.
     * So up/down/right/left events for dropdown were removed from Mousetrap and were
     * handled manually.
     */


    var LEFT_KEY = 37,
        UP_KEY = 38,
        RIGHT_KEY = 39,
        DOWN_KEY = 40;
    (0, _jquery["default"])('.pg-navbar').on('keydown', function (event) {
      switch (event.keyCode) {
        case LEFT_KEY:
          self.bindMainMenuLeft(event);
          break;

        case UP_KEY:
          self.bindMainMenuUpDown(event, 'up');
          break;

        case RIGHT_KEY:
          self.bindMainMenuRight(event);
          break;

        case DOWN_KEY:
          self.bindMainMenuUpDown(event, 'down');
          break;
      }
    });
  },
  _bindWithMousetrap: function _bindWithMousetrap(shortcuts, callback, bindElem) {
    var self = this;

    _mousetrap["default"].unbind(shortcuts);

    if (bindElem) {
      var elem = document.querySelector(bindElem);
      (0, _mousetrap["default"])(elem).bind(shortcuts, function () {
        callback.apply(this, arguments);
      }.bind(elem));
    } else {
      _mousetrap["default"].bind(shortcuts, function () {
        callback.apply(self, arguments);
      });
    }
  },
  unbindShortcuts: function unbindShortcuts() {
    // Reset previous events on each instance
    var self = this;

    _underscore["default"].each(self.mousetrapInstances, function (obj) {
      obj['instance'].reset();
    }); // Clear already processed events


    self.mousetrapInstances = [];
  },
  bindMainMenu: function bindMainMenu(event, combo) {
    var shortcut_obj = this.keyboardShortcut;
    if (combo === shortcut_obj.file_shortcut) (0, _jquery["default"])('#mnu_file a.dropdown-toggle').dropdown('toggle');
    if (combo === shortcut_obj.object_shortcut) (0, _jquery["default"])('#mnu_obj a.dropdown-toggle').first().dropdown('toggle');
    if (combo === shortcut_obj.tools_shortcut) (0, _jquery["default"])('#mnu_tools a.dropdown-toggle').dropdown('toggle');
    if (combo === shortcut_obj.help_shortcut) (0, _jquery["default"])('#mnu_help a.dropdown-toggle').dropdown('toggle');
  },
  bindRightPanel: function bindRightPanel(event, combo) {
    var allPanels = _pgadmin["default"].Browser.docker.findPanels();

    var activePanel = 0;
    var nextPanel = allPanels.length - 1;
    var prevPanel = 1;
    var activePanelId = 0;
    var activePanelFlag = false;
    var shortcut_obj = this.keyboardShortcut;

    _underscore["default"].each(_pgadmin["default"].Browser.docker.findPanels(), function (panel, index) {
      if (panel.isVisible() && !activePanelFlag && panel._type !== 'browser') {
        activePanelId = index;
        activePanelFlag = true;
      }
    });

    if (combo === shortcut_obj.tabbed_panel_backward) activePanel = activePanelId > 0 ? activePanelId - 1 : prevPanel;else if (combo === shortcut_obj.tabbed_panel_forward) activePanel = activePanelId < nextPanel ? activePanelId + 1 : nextPanel;

    _pgadmin["default"].Browser.docker.findPanels()[activePanel].focus();

    setTimeout(function () {
      if (document.activeElement instanceof HTMLIFrameElement) {
        document.activeElement.blur();
      }
    }, 1000);
  },
  bindMainMenuLeft: function bindMainMenuLeft(event) {
    if ((0, _jquery["default"])(event.target).hasClass('nav-link')) {
      // Menu items
      var currNavMenu = (0, _jquery["default"])(event.target).closest('.nav-item');

      keyboardFunc._stopEventPropagation(event);

      currNavMenu = currNavMenu.prev('.nav-item'); // Skip hidden menus

      while (currNavMenu.hasClass('d-none')) {
        currNavMenu = currNavMenu.prev('.nav-item');
      }

      currNavMenu.find('.dropdown-toggle').first().dropdown('toggle');
    } else if ((0, _jquery["default"])(event.target).closest('.dropdown-menu').length > 0) {
      var currLi = (0, _jquery["default"])(event.target).closest('li');

      keyboardFunc._stopEventPropagation(event);
      /*close submenu*/


      var currMenu = currLi.closest('.dropdown-menu');

      if (currMenu.closest('.dropdown-submenu').length > 0) {
        currMenu.removeClass('show');
        currMenu.closest('.dropdown-submenu').removeClass('dropdown-submenu-visible');
        currLi = currMenu.closest('.dropdown-submenu');
        currLi.find('.dropdown-item').trigger('focus');
      }
    }
  },
  bindMainMenuRight: function bindMainMenuRight(event) {
    if ((0, _jquery["default"])(event.target).hasClass('nav-link')) {
      // Menu items
      var currNavMenu = (0, _jquery["default"])(event.target).closest('.nav-item');

      keyboardFunc._stopEventPropagation(event);

      currNavMenu = currNavMenu.next('.nav-item'); // Skip hidden menus

      while (currNavMenu.hasClass('d-none')) {
        currNavMenu = currNavMenu.next('.nav-item');
      }

      currNavMenu.find('.dropdown-toggle').first().dropdown('toggle');
    } else if ((0, _jquery["default"])(event.target).closest('.dropdown-menu').length > 0) {
      var currLi = (0, _jquery["default"])(event.target).closest('li');

      keyboardFunc._stopEventPropagation(event);
      /*open submenu if any*/


      if (currLi.hasClass('dropdown-submenu')) {
        currLi.addClass('dropdown-submenu-visible');
        currLi.find('.dropdown-menu').addClass('show');
        currLi.find('.dropdown-menu .dropdown-item').first().trigger('focus');
      }
    }
  },
  bindMainMenuUpDown: function bindMainMenuUpDown(event, combo) {
    // Handle Sub-menus
    if ((0, _jquery["default"])(event.target).closest('.dropdown-menu').length > 0) {
      keyboardFunc._stopEventPropagation(event);

      var currLi = (0, _jquery["default"])(event.target).closest('li');
      /*close all the submenus on movement*/

      var dropMenu = (0, _jquery["default"])(event.target).closest('.dropdown-menu');
      dropMenu.find('.show').removeClass('show');
      dropMenu.find('.dropdown-submenu').removeClass('dropdown-submenu-visible');

      if (combo === 'up') {
        currLi = currLi.prev();
      } else if (combo === 'down') {
        currLi = currLi.next();
      }
      /*do not focus on divider and disabled */


      while (currLi.hasClass('dropdown-divider') || currLi.find('.dropdown-item').first().hasClass('disabled')) {
        if (combo === 'up') {
          currLi = currLi.prev();
        } else if (combo === 'down') {
          currLi = currLi.next();
        }
      }

      currLi.find('.dropdown-item').trigger('focus');
    }
  },
  bindLeftTree: function bindLeftTree() {
    var tree = this.getTreeDetails();
    (0, _jquery["default"])('#tree').trigger('focus'); // tree.t.focus(tree.i);

    tree.t.select(tree.i);
  },
  bindSubMenuQueryTool: function bindSubMenuQueryTool() {
    var tree = this.getTreeDetails();
    if (!tree.d) return; // Call data grid method to render query tool

    _pgadmin["default"].DataGrid.show_query_tool('', tree.i);
  },
  bindSubMenuViewData: function bindSubMenuViewData() {
    var tree = this.getTreeDetails();
    if (!tree.d) return; // Call data grid method to render view data

    _pgadmin["default"].DataGrid.show_data_grid({
      'mnuid': 1
    }, tree.i);
  },
  bindSubMenuSearchObjects: function bindSubMenuSearchObjects() {
    var tree = this.getTreeDetails();
    if (!tree.d) return; // Call data grid method to render view data

    _pgadmin["default"].SearchObjects.show_search_objects('', tree.i);
  },
  bindSubMenuProperties: function bindSubMenuProperties() {
    var tree = this.getTreeDetails();
    if (!tree.d || _pgadmin["default"].Browser.Nodes[tree.t.itemData(tree.i)._type].collection_node === true) return; // Open properties dialog in edit mode

    _pgadmin["default"].Browser.Node.callbacks.show_obj_properties.call(_pgadmin["default"].Browser.Nodes[tree.t.itemData(tree.i)._type], {
      action: 'edit'
    });
  },
  bindSubMenuCreate: function bindSubMenuCreate() {
    var tree = this.getTreeDetails();

    var node_obj = _pgadmin["default"].Browser.Nodes[tree.t.itemData(tree.i)._type];

    if (!tree.d) {
      return;
    } else if (node_obj.collection_node === true) {
      if (node_obj.node) {
        node_obj = _pgadmin["default"].Browser.Nodes[node_obj.node];
      } else {
        return;
      }
    } // Open properties dialog in edit mode


    _pgadmin["default"].Browser.Node.callbacks.show_obj_properties.call(node_obj, {
      action: 'create',
      item: tree.i
    });
  },
  bindSubMenuDelete: function bindSubMenuDelete() {
    var tree = this.getTreeDetails();
    if (!tree.d || _pgadmin["default"].Browser.Nodes[tree.t.itemData(tree.i)._type].collection_node === true) return; // Call delete object callback

    _pgadmin["default"].Browser.Node.callbacks.delete_obj.call(_pgadmin["default"].Browser.Nodes[tree.t.itemData(tree.i)._type]);
  },
  bindSubMenuRefresh: function bindSubMenuRefresh(event) {
    event.preventDefault();
    var tree = pgBrowser.keyboardNavigation.getTreeDetails(); // Call refresh object callback

    _pgadmin["default"].Browser.Node.callbacks.refresh.call(_pgadmin["default"].Browser.Nodes[tree.t.itemData(tree.i)._type]);
  },
  bindContextMenu: function bindContextMenu(event) {
    var tree = this.getTreeDetails();

    var _srcElement = event.srcElement || event.target;

    var left = (0, _jquery["default"])(_srcElement).find('.aciTreeEntry').position().left + 70;
    var top = (0, _jquery["default"])(_srcElement).find('.aciTreeEntry').position().top + 70;
    tree.t.blur(tree.i);
    (0, _jquery["default"])('#tree').trigger('blur'); // Call context menu and set position

    tree.i.children().contextMenu({
      x: left,
      y: top
    });
  },
  bindDirectDebugging: function bindDirectDebugging() {
    var tree = this.getTreeDetails();

    var type = tree.t.itemData(tree.i)._type;

    if (!tree.d || type !== 'function' && type !== 'procedure') return;

    if (_pgadmin["default"].Tools.Debugger.can_debug(tree.d, tree.i, {
      'debug_type': 'direct'
    })) {
      // Call debugger callback
      _pgadmin["default"].Tools.Debugger.get_function_information(_pgadmin["default"].Browser.Nodes[type]);
    }
  },
  bindDropMultipleObjects: function bindDropMultipleObjects() {
    var isPropertyPanelVisible = this.isPropertyPanelVisible();

    if (isPropertyPanelVisible === true && (0, _jquery["default"])('button.delete_multiple').length > 0) {
      (0, _jquery["default"])('button.delete_multiple').click();
    }
  },
  bindDropCascadeMultipleObjects: function bindDropCascadeMultipleObjects() {
    var isPropertyPanelVisible = this.isPropertyPanelVisible();

    if (isPropertyPanelVisible === true && (0, _jquery["default"])('button.delete_multiple_cascade').length > 0) {
      (0, _jquery["default"])('button.delete_multiple_cascade').click();
    }
  },
  bindAddGridRow: function bindAddGridRow() {
    var subNode = (0, _jquery["default"])(document.activeElement).closest('.object.subnode');

    if ((0, _jquery["default"])(subNode).length) {
      (0, _jquery["default"])(subNode).find('.add').click();
    }
  },
  isPropertyPanelVisible: function isPropertyPanelVisible() {
    var isPanelVisible = false;

    _underscore["default"].each(_pgadmin["default"].Browser.docker.findPanels(), function (panel) {
      if (panel._type === 'properties') isPanelVisible = panel.isVisible();
    });

    return isPanelVisible;
  },
  getTreeDetails: function getTreeDetails() {
    var aciTree = _pgadmin["default"].Browser.tree;
    var selectedTreeNode = aciTree.selected() ? aciTree.selected() : aciTree.first();
    var selectedTreeNodeData = selectedTreeNode ? aciTree.itemData(selectedTreeNode) : undefined;
    return {
      t: aciTree,
      i: selectedTreeNode,
      d: selectedTreeNodeData
    };
  },
  getDialogTabNavigator: function getDialogTabNavigator(dialogContainer) {
    var backward_shortcut = _window["default"].pgAdmin.Browser.get_preference('browser', 'dialog_tab_backward').value;

    var forward_shortcut = _window["default"].pgAdmin.Browser.get_preference('browser', 'dialog_tab_forward').value;

    return new _dialog_tab_navigator["default"].dialogTabNavigator(dialogContainer, backward_shortcut, forward_shortcut);
  },
  bindOpenQuickSearch: function bindOpenQuickSearch() {
    (0, _jquery["default"])('#search_icon').trigger('click');
  }
});

module.exports = _pgadmin["default"].Browser.keyboardNavigation;

/***/ }),

/***/ 88799:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

/* provided dependency */ var _ = __webpack_require__(10084);


__webpack_require__(69070);

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.pgBrowser = void 0;

__webpack_require__(32564);

__webpack_require__(68309);

var _pgadmin = _interopRequireDefault(__webpack_require__(55112));

var _url_for = _interopRequireDefault(__webpack_require__(28008));

var _jquery = _interopRequireDefault(__webpack_require__(19755));

var _gettext = _interopRequireDefault(__webpack_require__(91669));

__webpack_require__(35816);

var _window = _interopRequireDefault(__webpack_require__(1950));

var _Notifier = _interopRequireDefault(__webpack_require__(55958));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/////////////////////////////////////////////////////////////
//
// pgAdmin 4 - PostgreSQL Tools
//
// Copyright (C) 2013 - 2022, The pgAdmin Development Team
// This software is released under the PostgreSQL Licence
//
//////////////////////////////////////////////////////////////
var pgBrowser = _pgadmin["default"].Browser = _pgadmin["default"].Browser || {};
exports.pgBrowser = pgBrowser;
var wcDocker = window.wcDocker;
/* Add cache related methods and properties */

_.extend(pgBrowser, {
  lock_layout_levels: {
    PREVENT_DOCKING: 'docking',
    FULL: 'full',
    NONE: 'none'
  },
  // Build the default layout
  buildDefaultLayout: function buildDefaultLayout(docker) {
    var browserPanel = docker.addPanel('browser', wcDocker.DOCK.LEFT);
    var dashboardPanel = docker.addPanel('dashboard', wcDocker.DOCK.RIGHT, browserPanel);
    docker.addPanel('properties', wcDocker.DOCK.STACKED, dashboardPanel, {
      tabOrientation: wcDocker.TAB.TOP
    });
    docker.addPanel('sql', wcDocker.DOCK.STACKED, dashboardPanel);
    docker.addPanel('statistics', wcDocker.DOCK.STACKED, dashboardPanel);
    docker.addPanel('dependencies', wcDocker.DOCK.STACKED, dashboardPanel);
    docker.addPanel('dependents', wcDocker.DOCK.STACKED, dashboardPanel);
  },
  save_current_layout: function save_current_layout(layout_id, docker) {
    if (docker) {
      var layout = docker.save(),
          settings = {
        setting: layout_id,
        value: layout
      };

      _jquery["default"].ajax({
        type: 'POST',
        url: (0, _url_for["default"])('settings.store_bulk'),
        data: settings
      });
    }
  },
  restore_layout: function restore_layout(docker, layout, defaultLayoutCallback) {
    var checkLayout = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;

    // Try to restore the layout if there is one
    if (layout != '') {
      try {
        docker.restore(layout);

        if (checkLayout) {
          // Check restore layout is restored pgAdmin 4 layout successfully if not then reset layout to default pgAdmin 4 layout.
          var _panel = docker.findPanels('properties');

          if (_panel.length == 0 && defaultLayoutCallback) {
            // clear the wcDocker before reset layout.
            docker.clear();

            _Notifier["default"].info((0, _gettext["default"])('pgAdmin has reset the layout because the previously saved layout is invalid.'), null);

            if (defaultLayoutCallback) {
              defaultLayoutCallback(docker);
            }
          }
        }
      } catch (err) {
        docker.clear();

        if (defaultLayoutCallback) {
          defaultLayoutCallback(docker);
        }
      }
    } else {
      if (defaultLayoutCallback) {
        defaultLayoutCallback(docker);
      }
    }
    /* preference available only with top/opener browser. */


    var browser = _window["default"].pgAdmin.Browser;
    /* interval required initially as preference load may take time */

    var cacheIntervalId = setInterval(function () {
      var browserPref = browser.get_preferences_for_module('browser');

      if (browserPref) {
        clearInterval(cacheIntervalId);
        browser.reflectLocklayoutChange(docker);
        browser.onPreferencesChange('browser', function () {
          browser.reflectLocklayoutChange(docker);
        });
      }
    }, 5000);
  },
  reflectLocklayoutChange: function reflectLocklayoutChange(docker) {
    var browser = _window["default"].pgAdmin.Browser;
    var browserPref = browser.get_preferences_for_module('browser');
    browser.lock_layout(docker, browserPref.lock_layout);
  },
  lock_layout: function lock_layout(docker, op) {
    var menu_items = [];

    if ('mnu_locklayout' in this.menus['file']) {
      menu_items = this.menus['file']['mnu_locklayout']['menu_items'];
    }

    switch (op) {
      case this.lock_layout_levels.PREVENT_DOCKING:
        docker.lockLayout(wcDocker.LOCK_LAYOUT_LEVEL.PREVENT_DOCKING);
        break;

      case this.lock_layout_levels.FULL:
        docker.lockLayout(wcDocker.LOCK_LAYOUT_LEVEL.FULL);
        break;

      case this.lock_layout_levels.NONE:
        docker.lockLayout(wcDocker.LOCK_LAYOUT_LEVEL.NONE);
        break;
    }

    if (menu_items) {
      _.each(menu_items, function (menu_item) {
        if (menu_item.name != 'mnu_lock_' + op) {
          menu_item.change_checked(false);
        } else {
          menu_item.change_checked(true);
        }
      });
    }
  },
  save_lock_layout: function save_lock_layout(op) {
    var browser = _window["default"].pgAdmin.Browser;

    _jquery["default"].ajax({
      url: (0, _url_for["default"])('browser.lock_layout'),
      method: 'PUT',
      contentType: 'application/json',
      data: JSON.stringify({
        'value': op
      })
    }).done(function () {
      browser.cache_preferences('browser');
    }).fail(function (xhr, error) {
      _Notifier["default"].pgNotifier(error, xhr, (0, _gettext["default"])('Failed to save the lock layout setting.'));
    });
  },
  mnu_lock_docking: function mnu_lock_docking() {
    this.lock_layout(this.docker, this.lock_layout_levels.PREVENT_DOCKING);
    this.save_lock_layout(this.lock_layout_levels.PREVENT_DOCKING);
  },
  mnu_lock_full: function mnu_lock_full() {
    this.lock_layout(this.docker, this.lock_layout_levels.FULL);
    this.save_lock_layout(this.lock_layout_levels.FULL);
  },
  mnu_lock_none: function mnu_lock_none() {
    this.lock_layout(this.docker, this.lock_layout_levels.NONE);
    this.save_lock_layout(this.lock_layout_levels.NONE);
  }
});

/***/ }),

/***/ 77077:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



__webpack_require__(47941);

__webpack_require__(82526);

__webpack_require__(57327);

__webpack_require__(38880);

__webpack_require__(89554);

__webpack_require__(54747);

__webpack_require__(49337);

__webpack_require__(33321);

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.generateNodeUrl = generateNodeUrl;
exports.getNodeAjaxOptions = getNodeAjaxOptions;
exports.getNodeListById = getNodeListById;
exports.getNodeListByName = getNodeListByName;

__webpack_require__(88674);

__webpack_require__(41539);

__webpack_require__(69070);

var _lodash = _interopRequireDefault(__webpack_require__(96486));

var _api_instance = _interopRequireDefault(__webpack_require__(2832));

var _generate_url = __webpack_require__(61329);

var _pgadmin = _interopRequireDefault(__webpack_require__(55112));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/* It generates the URL based on tree node selected */
function generateNodeUrl(treeNodeInfo, actionType, itemNodeData, withId, jumpAfterNode) {
  var opURL = {
    'create': 'obj',
    'drop': 'obj',
    'edit': 'obj',
    'properties': 'obj',
    'statistics': 'stats'
  },
      priority = -Infinity;
  var nodeObj = this;
  var itemID = withId && itemNodeData._type == nodeObj.type ? encodeURIComponent(itemNodeData._id) : '';
  actionType = actionType in opURL ? opURL[actionType] : actionType;

  if (nodeObj.parent_type) {
    if (_lodash["default"].isString(nodeObj.parent_type)) {
      var p = treeNodeInfo[nodeObj.parent_type];

      if (p) {
        priority = p.priority;
      }
    } else {
      _lodash["default"].each(nodeObj.parent_type, function (o) {
        var p = treeNodeInfo[o];

        if (p) {
          if (priority < p.priority) {
            priority = p.priority;
          }
        }
      });
    }
  }

  var jump_after_priority = priority;

  if (jumpAfterNode && treeNodeInfo[jumpAfterNode]) {
    jump_after_priority = treeNodeInfo[jumpAfterNode].priority;
  }

  var nodePickFunction = function nodePickFunction(treeInfoValue) {
    return treeInfoValue.priority <= jump_after_priority || treeInfoValue.priority == priority;
  };

  return (0, _generate_url.generate_url)(_pgadmin["default"].Browser.URL, treeNodeInfo, actionType, nodeObj.type, nodePickFunction, itemID);
}
/* Get the nodes list as options required by select controls
 * The options are cached for performance reasons.
 */


function getNodeAjaxOptions(url, nodeObj, treeNodeInfo, itemNodeData) {
  var params = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : {};
  var transform = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : function (data) {
    return data;
  };

  var otherParams = _objectSpread({
    urlWithId: false,
    jumpAfterNode: null,
    useCache: true,
    customGenerateUrl: null
  }, params);

  return new Promise(function (resolve, reject) {
    var api = (0, _api_instance["default"])();
    var fullUrl = '';

    if (url) {
      if (otherParams.customGenerateUrl) {
        fullUrl = otherParams.customGenerateUrl.call(nodeObj, treeNodeInfo, url, itemNodeData, otherParams.urlWithId, otherParams.jumpAfterNode);
      } else {
        fullUrl = generateNodeUrl.call(nodeObj, treeNodeInfo, url, itemNodeData, otherParams.urlWithId, otherParams.jumpAfterNode);
      }
    }

    if (url) {
      var cacheNode = _pgadmin["default"].Browser.Nodes[otherParams.cacheNode] || nodeObj;
      var cacheLevel = otherParams.cacheLevel || cacheNode.cache_level(treeNodeInfo, otherParams.urlWithId);
      /*
      * We needs to check, if we have already cached data for this url.
      * If yes - use that, and do not bother about fetching it again,
      * and use it.
      */

      var data = cacheNode.cache(nodeObj.type + '#' + url, treeNodeInfo, cacheLevel);

      if (_lodash["default"].isUndefined(data) || _lodash["default"].isNull(data)) {
        api.get(fullUrl, {
          params: otherParams.urlParams
        }).then(function (res) {
          data = res.data;

          if (res.data.data) {
            data = res.data.data;
          }

          otherParams.useCache && cacheNode.cache(nodeObj.type + '#' + url, treeNodeInfo, cacheLevel, data);
          resolve(transform(data));
        })["catch"](function (err) {
          reject(err);
        });
      } else {
        // To fetch only options from cache, we do not need time from 'at'
        // attribute but only options.
        resolve(transform(data.data || []));
      }
    }
  });
}
/* Get the nodes list based on current selected node id */


function getNodeListById(nodeObj, treeNodeInfo, itemNodeData) {
  var params = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};
  var filter = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : function () {
    return true;
  };

  /* Transform the result to add image details */
  var transform = function transform(rows) {
    var res = [];

    _lodash["default"].each(rows, function (r) {
      if (filter(r)) {
        var l = _lodash["default"].isFunction(nodeObj['node_label']) ? nodeObj['node_label'].apply(nodeObj, [r]) : r.label,
            image = _lodash["default"].isFunction(nodeObj['node_image']) ? nodeObj['node_image'].apply(nodeObj, [r]) : nodeObj['node_image'] || 'icon-' + nodeObj.type;
        res.push({
          'value': r._id,
          'image': image,
          'label': l
        });
      }
    });

    return res;
  };

  return getNodeAjaxOptions('nodes', nodeObj, treeNodeInfo, itemNodeData, params, transform);
}
/* Get the nodes list based on node name passed */


function getNodeListByName(node, treeNodeInfo, itemNodeData) {
  var params = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};
  var filter = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : function () {
    return true;
  };
  var postTransform = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : function (res) {
    return res;
  };
  var nodeObj = _pgadmin["default"].Browser.Nodes[node];
  var includeItemKeys = params.includeItemKeys;
  /* Transform the result to add image details */

  var transform = function transform(rows) {
    var res = [];

    _lodash["default"].each(rows, function (r) {
      if (filter(r)) {
        var l = _lodash["default"].isFunction(nodeObj['node_label']) ? nodeObj['node_label'].apply(nodeObj, [r]) : r.label,
            image = _lodash["default"].isFunction(nodeObj['node_image']) ? nodeObj['node_image'].apply(nodeObj, [r]) : nodeObj['node_image'] || 'icon-' + nodeObj.type;
        res.push(_objectSpread({
          'value': r.label,
          'image': image,
          'label': l
        }, _lodash["default"].pick(r, includeItemKeys)));
      }
    });

    return postTransform(res);
  };

  return getNodeAjaxOptions('nodes', nodeObj, treeNodeInfo, itemNodeData, params, transform);
}

/***/ }),

/***/ 49929:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



__webpack_require__(69070);

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.getNodeView = getNodeView;
exports.removeNodeView = removeNodeView;

__webpack_require__(88674);

__webpack_require__(41539);

__webpack_require__(24812);

var _react = _interopRequireDefault(__webpack_require__(67294));

var _reactDom = _interopRequireDefault(__webpack_require__(73935));

var _pgadmin = _interopRequireDefault(__webpack_require__(55112));

var _api_instance = _interopRequireDefault(__webpack_require__(2832));

var _pgadmin2 = __webpack_require__(68363);

var _SchemaView = _interopRequireDefault(__webpack_require__(52237));

var _node_ajax = __webpack_require__(77077);

var _Notifier = _interopRequireDefault(__webpack_require__(55958));

var _gettext = _interopRequireDefault(__webpack_require__(91669));

__webpack_require__(35816);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/////////////////////////////////////////////////////////////
//
// pgAdmin 4 - PostgreSQL Tools
//
// Copyright (C) 2013 - 2022, The pgAdmin Development Team
// This software is released under the PostgreSQL Licence
//
//////////////////////////////////////////////////////////////

/* The entry point for rendering React based view in properties, called in node.js */
function getNodeView(nodeType, treeNodeInfo, actionType, itemNodeData, formType, container, containerPanel, onEdit, onSave) {
  var nodeObj = _pgadmin["default"].Browser.Nodes[nodeType];
  var serverInfo = treeNodeInfo && 'server' in treeNodeInfo && _pgadmin["default"].Browser.serverInfo && _pgadmin["default"].Browser.serverInfo[treeNodeInfo.server._id];
  var inCatalog = treeNodeInfo && 'catalog' in treeNodeInfo;

  var urlBase = _node_ajax.generateNodeUrl.call(nodeObj, treeNodeInfo, actionType, itemNodeData, false, nodeObj.url_jump_after_node);

  var api = (0, _api_instance["default"])();

  var url = function url(isNew) {
    return urlBase + (isNew ? '' : itemNodeData._id);
  };

  var isDirty = false; // usefull for warnings

  var warnOnCloseFlag = true;

  var confirmOnCloseReset = _pgadmin["default"].Browser.get_preferences_for_module('browser').confirm_on_properties_close;
  /* Called when dialog is opened in edit mode, promise required */


  var initData = function initData() {
    return new Promise(function (resolve, reject) {
      api.get(url(false)).then(function (res) {
        resolve(res.data);
      })["catch"](function (err) {
        if (err.response) {
          console.error('error resp', err.response);
        } else if (err.request) {
          console.error('error req', err.request);
        } else if (err.message) {
          console.error('error msg', err.message);
        }

        reject(err);
      });
    });
  };
  /* on save button callback, promise required */


  var onSaveClick = function onSaveClick(isNew, data) {
    return new Promise(function (resolve, reject) {
      return api({
        url: url(isNew),
        method: isNew ? 'POST' : 'PUT',
        data: data
      }).then(function (res) {
        /* Don't warn the user before closing dialog */
        warnOnCloseFlag = false;
        resolve(res.data);
        onSave && onSave(res.data);
      })["catch"](function (err) {
        reject(err);
      });
    });
  };
  /* Called when switched to SQL tab, promise required */


  var getSQLValue = function getSQLValue(isNew, changedData) {
    var msqlUrl = _node_ajax.generateNodeUrl.call(nodeObj, treeNodeInfo, 'msql', itemNodeData, !isNew, nodeObj.url_jump_after_node);

    return new Promise(function (resolve, reject) {
      api({
        url: msqlUrl,
        method: 'GET',
        params: changedData
      }).then(function (res) {
        resolve(res.data.data);
      })["catch"](function (err) {
        if (err.response) {
          console.error('error resp', err.response);
        } else if (err.request) {
          console.error('error req', err.request);
        } else if (err.message) {
          console.error('error msg', err.message);
        }

        reject(err);
      });
    });
  };
  /* Callback for help button */


  var onHelp = function onHelp() {
    var isSqlHelp = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
    var isNew = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

    if (isSqlHelp) {
      var server = treeNodeInfo.server;
      var _url = _pgadmin["default"].Browser.utils.pg_help_path;
      var fullUrl = '';

      if (server.server_type == 'ppas' && nodeObj.epasHelp) {
        fullUrl = (0, _pgadmin2.getEPASHelpUrl)(server.version);
      } else {
        if (nodeObj.sqlCreateHelp == '' && nodeObj.sqlAlterHelp != '') {
          fullUrl = (0, _pgadmin2.getHelpUrl)(_url, nodeObj.sqlAlterHelp, server.version);
        } else if (nodeObj.sqlCreateHelp != '' && nodeObj.sqlAlterHelp == '') {
          fullUrl = (0, _pgadmin2.getHelpUrl)(_url, nodeObj.sqlCreateHelp, server.version);
        } else {
          if (isNew) {
            fullUrl = (0, _pgadmin2.getHelpUrl)(_url, nodeObj.sqlCreateHelp, server.version);
          } else {
            fullUrl = (0, _pgadmin2.getHelpUrl)(_url, nodeObj.sqlAlterHelp, server.version);
          }
        }
      }

      window.open(fullUrl, 'postgres_help');
    } else {
      window.open(nodeObj.dialogHelp, 'pgadmin_help');
    }
  };
  /* A warning before closing the dialog with unsaved changes, based on preference */


  var warnBeforeChangesLost = function warnBeforeChangesLost(yesCallback) {
    var confirmOnClose = _pgadmin["default"].Browser.get_preferences_for_module('browser').confirm_on_properties_close;

    if (warnOnCloseFlag && confirmOnClose) {
      if (isDirty) {
        _Notifier["default"].confirm((0, _gettext["default"])('Warning'), (0, _gettext["default"])('Changes will be lost. Are you sure you want to close the dialog?'), function () {
          yesCallback();
          return true;
        }, function () {
          return true;
        });
      } else {
        return true;
      }

      return false;
    } else {
      yesCallback();
      return true;
    }
  };
  /* Bind the wcDocker dialog close event and check if user should be warned */


  if (containerPanel.closeable()) {
    containerPanel.on(window.wcDocker.EVENT.CLOSING, warnBeforeChangesLost.bind(containerPanel, function () {
      containerPanel.off(window.wcDocker.EVENT.CLOSING);
      /* Always clean up the react mounted dom before closing */

      removeNodeView(container);
      containerPanel.close();
    }));
  }
  /* All other useful details can go with this object */


  var viewHelperProps = {
    mode: actionType,
    serverInfo: serverInfo ? {
      type: serverInfo.server_type,
      version: serverInfo.version
    } : undefined,
    inCatalog: inCatalog
  };
  var schema = nodeObj.getSchema.call(nodeObj, treeNodeInfo, itemNodeData); // Show/Hide security group for nodes under the catalog

  if ('catalog' in treeNodeInfo && formType !== 'tab') {
    schema.filterGroups = [(0, _gettext["default"])('Security')];
  }
  /* Fire at will, mount the DOM */


  _reactDom["default"].render( /*#__PURE__*/_react["default"].createElement(_SchemaView["default"], {
    formType: formType,
    getInitData: initData,
    schema: schema,
    viewHelperProps: viewHelperProps,
    onSave: onSaveClick,
    onClose: function onClose() {
      return containerPanel.close();
    },
    onHelp: onHelp,
    onEdit: onEdit,
    onDataChange: function onDataChange(dataChanged) {
      isDirty = dataChanged;
    },
    confirmOnCloseReset: confirmOnCloseReset,
    hasSQL: nodeObj.hasSQL && (actionType === 'create' || actionType === 'edit'),
    getSQLValue: getSQLValue,
    disableSqlHelp: nodeObj.sqlAlterHelp == '' && nodeObj.sqlCreateHelp == '' && !nodeObj.epasHelp,
    disableDialogHelp: nodeObj.dialogHelp == undefined || nodeObj.dialogHelp == ''
  }), container);
}
/* When switching from normal node to collection node, clean up the React mounted DOM */


function removeNodeView(container) {
  _reactDom["default"].unmountComponentAtNode(container);
}

/***/ }),

/***/ 3650:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

/* provided dependency */ var _ = __webpack_require__(10084);


function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

__webpack_require__(4129);

__webpack_require__(41539);

__webpack_require__(78783);

__webpack_require__(66992);

__webpack_require__(33948);

__webpack_require__(69070);

__webpack_require__(38880);

__webpack_require__(82526);

__webpack_require__(41817);

__webpack_require__(32165);

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.pgBrowser = void 0;

__webpack_require__(83710);

__webpack_require__(68309);

__webpack_require__(47941);

__webpack_require__(32564);

var _pgadmin = _interopRequireDefault(__webpack_require__(55112));

var _url_for = _interopRequireDefault(__webpack_require__(28008));

var _jquery = _interopRequireDefault(__webpack_require__(19755));

var SqlEditorUtils = _interopRequireWildcard(__webpack_require__(81240));

var _window = _interopRequireDefault(__webpack_require__(1950));

var _Notifier = _interopRequireDefault(__webpack_require__(55958));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/////////////////////////////////////////////////////////////
//
// pgAdmin 4 - PostgreSQL Tools
//
// Copyright (C) 2013 - 2022, The pgAdmin Development Team
// This software is released under the PostgreSQL Licence
//
//////////////////////////////////////////////////////////////
//var modifyAnimation = require('sources/modify_animation');
var pgBrowser = _pgadmin["default"].Browser = _pgadmin["default"].Browser || {};
/* Add cache related methods and properties */

exports.pgBrowser = pgBrowser;

_.extend(pgBrowser, {
  /* This will hold preference data (Works as a cache object)
   * Here node will be a key and it's preference data will be value
   */
  preferences_cache: [],

  /* This will be used by poller of new tabs/windows to check
   * if preference cache is updated in parent/window.opener.
   */
  prefcache_version: 0,

  /* Generate a unique version number */
  generate_preference_version: function generate_preference_version() {
    return new Date().getTime();
  },
  preference_version: function preference_version(version) {
    if (version) {
      this.prefcache_version = version;
    } else {
      return this.prefcache_version;
    }
  },

  /* Get cached preference */
  get_preference: function get_preference(module, preference) {
    var self = this;
    return _.findWhere(self.preferences_cache, {
      'module': module,
      'name': preference
    });
  },

  /* Get all the preferences of a module */
  get_preferences_for_module: function get_preferences_for_module(module) {
    var self = this;
    var preferences = {};

    _.each(_.where(self.preferences_cache, {
      'module': module
    }), function (preference) {
      preferences[preference.name] = preference.value;
    });

    if (Object.keys(preferences).length > 0) {
      return preferences;
    }
  },

  /* Get preference of an id, id is numeric */
  get_preference_for_id: function get_preference_for_id(id) {
    var self = this;
    /* findWhere returns undefined if not found */

    return _.findWhere(self.preferences_cache, {
      'id': id
    });
  },
  // Get and cache the preferences
  cache_preferences: function cache_preferences(modulesChanged) {
    var self = this,
        headers = {};
    headers[_pgadmin["default"].csrf_token_header] = _pgadmin["default"].csrf_token;
    setTimeout(function () {
      _jquery["default"].ajax({
        url: (0, _url_for["default"])('preferences.get_all'),
        headers: headers
      }).done(function (res) {
        self.preferences_cache = res;
        self.preference_version(self.generate_preference_version());
        pgBrowser.keyboardNavigation.init(); // Initialize Tree saving/reloading

        pgBrowser.browserTreeState.init();
        /* Once the cache is loaded after changing the preferences,
        * notify the modules of the change
        */

        if (modulesChanged) {
          if (typeof modulesChanged === 'string') {
            _jquery["default"].event.trigger('prefchange:' + modulesChanged);
          } else {
            _.each(modulesChanged, function (val, key) {
              _jquery["default"].event.trigger('prefchange:' + key);
            });
          }
        }
      }).fail(function (xhr, status, error) {
        _Notifier["default"].pgRespErrorNotify(xhr, error);
      });
    }, 500);
  },
  reflectPreferences: function reflectPreferences(module) {
    var obj = this;

    if (module === 'sqleditor' || module === null || typeof module === 'undefined') {
      var _obj$editor, _obj$editor2, _obj$editor3, _obj$editor4, _obj$editor5, _obj$editor6;

      var sqlEditPreferences = obj.get_preferences_for_module('sqleditor');
      (0, _jquery["default"])(obj === null || obj === void 0 ? void 0 : (_obj$editor = obj.editor) === null || _obj$editor === void 0 ? void 0 : _obj$editor.getWrapperElement()).css('font-size', SqlEditorUtils.calcFontSize(sqlEditPreferences.sql_font_size));
      obj === null || obj === void 0 ? void 0 : (_obj$editor2 = obj.editor) === null || _obj$editor2 === void 0 ? void 0 : _obj$editor2.setOption('tabSize', sqlEditPreferences.tab_size);
      obj === null || obj === void 0 ? void 0 : (_obj$editor3 = obj.editor) === null || _obj$editor3 === void 0 ? void 0 : _obj$editor3.setOption('lineWrapping', sqlEditPreferences.wrap_code);
      obj === null || obj === void 0 ? void 0 : (_obj$editor4 = obj.editor) === null || _obj$editor4 === void 0 ? void 0 : _obj$editor4.setOption('autoCloseBrackets', sqlEditPreferences.insert_pair_brackets);
      obj === null || obj === void 0 ? void 0 : (_obj$editor5 = obj.editor) === null || _obj$editor5 === void 0 ? void 0 : _obj$editor5.setOption('matchBrackets', sqlEditPreferences.brace_matching);
      obj === null || obj === void 0 ? void 0 : (_obj$editor6 = obj.editor) === null || _obj$editor6 === void 0 ? void 0 : _obj$editor6.refresh();
    }
  },
  onPreferencesChange: function onPreferencesChange(module, eventHandler) {
    (0, _jquery["default"])(_window["default"]).on('prefchange:' + module, function (event) {
      eventHandler(event);
    });
  }
});

/***/ }),

/***/ 37944:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

/* provided dependency */ var _ = __webpack_require__(10084);


__webpack_require__(69070);

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.pgBrowser = void 0;

var _pgadmin = _interopRequireDefault(__webpack_require__(55112));

var _url_for = _interopRequireDefault(__webpack_require__(28008));

var _jquery = _interopRequireDefault(__webpack_require__(19755));

var _gettext = _interopRequireDefault(__webpack_require__(91669));

var _Notifier = _interopRequireDefault(__webpack_require__(55958));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/////////////////////////////////////////////////////////////
//
// pgAdmin 4 - PostgreSQL Tools
//
// Copyright (C) 2013 - 2022, The pgAdmin Development Team
// This software is released under the PostgreSQL Licence
//
//////////////////////////////////////////////////////////////
var pgBrowser = _pgadmin["default"].Browser = _pgadmin["default"].Browser || {};
exports.pgBrowser = pgBrowser;

_.extend(pgBrowser, {
  // This function is used to send signal to runtime.
  send_signal_to_runtime: function send_signal_to_runtime(cmd_string) {
    _jquery["default"].ajax({
      url: (0, _url_for["default"])('browser.signal_runtime'),
      method: 'POST',
      contentType: 'application/json',
      data: JSON.stringify({
        'command': cmd_string
      })
    }).fail(function (xhr, error) {
      _Notifier["default"].pgNotifier(error, xhr, (0, _gettext["default"])('Failed to send signal to runtime.'));
    });
  },
  // This function is callback function when 'Configure...' menu is clicked.
  mnu_configure_runtime: function mnu_configure_runtime() {
    this.send_signal_to_runtime('Runtime Open Configuration');
  },
  // This function is callback function when 'View log...' menu is clicked.
  mnu_viewlog_runtime: function mnu_viewlog_runtime() {
    this.send_signal_to_runtime('Runtime Open View Log');
  },
  // This function is callback function when 'Enter Full Screen' menu is clicked.
  mnu_toggle_fullscreen_runtime: function mnu_toggle_fullscreen_runtime() {
    this.send_signal_to_runtime('Runtime Toggle Full Screen');
  },
  // This function is callback function when 'Actual Size' menu is clicked.
  mnu_actual_size_runtime: function mnu_actual_size_runtime() {
    this.send_signal_to_runtime('Runtime Actual Size');
  },
  // This function is callback function when 'Zoom In' menu is clicked.
  mnu_zoomin_runtime: function mnu_zoomin_runtime() {
    this.send_signal_to_runtime('Runtime Zoom In');
  },
  // This function is callback function when 'Zoom Out' menu is clicked.
  mnu_zoomout_runtime: function mnu_zoomout_runtime() {
    this.send_signal_to_runtime('Runtime Zoom Out');
  }
});

/***/ }),

/***/ 85530:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



__webpack_require__(69070);

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.initializeToolbar = initializeToolbar;
exports.enable = enable;

__webpack_require__(34553);

__webpack_require__(68309);

var _gettext = _interopRequireDefault(__webpack_require__(91669));

var _underscore = _interopRequireDefault(__webpack_require__(81311));

var _pgadmin = _interopRequireDefault(__webpack_require__(55112));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/////////////////////////////////////////////////////////////
//
// pgAdmin 4 - PostgreSQL Tools
//
// Copyright (C) 2013 - 2022, The pgAdmin Development Team
// This software is released under the PostgreSQL Licence
//
//////////////////////////////////////////////////////////////
var _toolbarButtons = {};
var _browserPanel = null; // Default Tool Bar Buttons.

var _defaultToolBarButtons = [{
  label: (0, _gettext["default"])('Search objects'),
  ariaLabel: (0, _gettext["default"])('Search objects'),
  btnClass: 'fa fa-search',
  text: '',
  toggled: false,
  toggleClass: '',
  parentClass: 'pg-toolbar-btn btn-primary-icon',
  enabled: false
}, {
  label: (0, _gettext["default"])('Filtered Rows'),
  ariaLabel: (0, _gettext["default"])('Filtered Rows'),
  btnClass: 'pg-font-icon icon-row_filter',
  text: '',
  toggled: false,
  toggleClass: '',
  parentClass: 'pg-toolbar-btn btn-primary-icon',
  enabled: false
}, {
  label: (0, _gettext["default"])('View Data'),
  ariaLabel: (0, _gettext["default"])('View Data'),
  btnClass: 'pg-font-icon sql-icon-lg icon-view_data',
  text: '',
  toggled: false,
  toggleClass: '',
  parentClass: 'pg-toolbar-btn btn-primary-icon',
  enabled: false
}, {
  label: (0, _gettext["default"])('Query Tool'),
  ariaLabel: (0, _gettext["default"])('Query Tool'),
  btnClass: 'pg-font-icon icon-query_tool',
  text: '',
  toggled: false,
  toggleClass: '',
  parentClass: 'pg-toolbar-btn btn-primary-icon',
  enabled: false
}];

if (_pgadmin["default"]['enable_psql']) {
  _defaultToolBarButtons.unshift({
    label: (0, _gettext["default"])('PSQL Tool'),
    ariaLabel: (0, _gettext["default"])('PSQL Tool'),
    btnClass: 'fas fa-terminal',
    text: '',
    toggled: false,
    toggleClass: '',
    parentClass: 'pg-toolbar-btn btn-primary-icon pg-toolbar-psql',
    enabled: false
  });
} // Place holder for non default tool bar buttons.


var _otherToolbarButtons = []; // This function is used to add button into the browser panel.

function registerToolBarButton(btn) {
  /* Sometimes the panel onCreate is called two times.
   * Add buttons if not present in the panel also.
   */
  if (!(btn.label in _toolbarButtons) || _underscore["default"].findIndex(_browserPanel._buttonList, {
    name: btn.label
  }) < 0) {
    _browserPanel.addButton(btn.label, btn.btnClass, btn.text, btn.label, btn.toggled, btn.toggleClass, btn.parentClass, btn.enabled, btn.ariaLabel);

    _toolbarButtons[btn.label] = btn;
  }
} // This function is used to add tool bar button and
// listen on the button event.


function initializeToolbar(panel, wcDocker) {
  _browserPanel = panel; // Iterate through default tool bar buttons and add them into the
  // browser panel.

  _underscore["default"].each(_defaultToolBarButtons, function (btn) {
    registerToolBarButton(btn);
  }); // Iterate through other tool bar buttons and add them into the
  // browser panel.


  _underscore["default"].each(_otherToolbarButtons, function (btn) {
    registerToolBarButton(btn);
  }); // Listen on button click event.


  panel.on(wcDocker.EVENT.BUTTON, function (data) {
    if ('name' in data && data.name === (0, _gettext["default"])('Query Tool')) _pgadmin["default"].DataGrid.show_query_tool('', _pgadmin["default"].Browser.tree.selected());else if ('name' in data && data.name === (0, _gettext["default"])('View Data')) _pgadmin["default"].DataGrid.show_data_grid({
      mnuid: 3
    }, _pgadmin["default"].Browser.tree.selected());else if ('name' in data && data.name === (0, _gettext["default"])('Filtered Rows')) _pgadmin["default"].DataGrid.show_filtered_row({
      mnuid: 4
    }, _pgadmin["default"].Browser.tree.selected());else if ('name' in data && data.name === (0, _gettext["default"])('Search objects')) _pgadmin["default"].SearchObjects.show_search_objects('', _pgadmin["default"].Browser.tree.selected());else if ('name' in data && data.name === (0, _gettext["default"])('PSQL Tool')) {
      var input = {},
          t = _pgadmin["default"].Browser.tree,
          i = input.item || t.selected(),
          d = i ? t.itemData(i) : undefined;

      _pgadmin["default"].Browser.psql.psql_tool(d, i, true);
    }
  });
} // This function is used to enable/disable the specific button
// based on their label.


function enable(label, enable_btn) {
  if (label in _toolbarButtons) {
    _browserPanel.buttonEnable(label, enable_btn);
  } else {
    console.warn('Developer warning: No tool button found with label: ' + label);
  }
}

/***/ }),

/***/ 10426:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



__webpack_require__(69070);

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.fetch_ticket = fetch_ticket;
exports.validate_kerberos_ticket = validate_kerberos_ticket;
exports.fetch_ticket_lifetime = fetch_ticket_lifetime;

__webpack_require__(88674);

__webpack_require__(41539);

__webpack_require__(32564);

var _url_for = _interopRequireDefault(__webpack_require__(28008));

var _pgadminUser_management = _interopRequireDefault(__webpack_require__(6537));

var _pgadminBrowser = _interopRequireDefault(__webpack_require__(92026));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/////////////////////////////////////////////////////////////
//
// pgAdmin 4 - PostgreSQL Tools
//
// Copyright (C) 2013 - 2022, The pgAdmin Development Team
// This software is released under the PostgreSQL Licence
//
//////////////////////////////////////////////////////////////
function fetch_ticket() {
  // Fetch the Kerberos Updated ticket through SPNEGO
  return fetch((0, _url_for["default"])('kerberos.update_ticket')).then(function (response) {
    if (response.status >= 200 && response.status < 300) {
      return Promise.resolve(response);
    } else {
      return Promise.reject(new Error(response.statusText));
    }
  });
}

function fetch_ticket_lifetime() {
  // Fetch the Kerberos ticket lifetime left
  return fetch((0, _url_for["default"])('kerberos.validate_ticket')).then(function (response) {
    if (response.status >= 200 && response.status < 300) {
      return response.json();
    } else {
      return Promise.reject(new Error(response.statusText));
    }
  }).then(function (response) {
    var ticket_lifetime = response.data.ticket_lifetime;

    if (ticket_lifetime > 0) {
      return Promise.resolve(ticket_lifetime);
    } else {
      return Promise.reject();
    }
  });
}

function validate_kerberos_ticket() {
  // Ping pgAdmin server every 10 seconds
  // to fetch the Kerberos ticket lifetime left
  if (_pgadminUser_management["default"]['current_auth_source'] != _pgadminBrowser["default"]['KERBEROS']) return;
  return setInterval(function () {
    var newPromise = fetch_ticket_lifetime();
    newPromise.then(function () {
      return;
    }, fetch_ticket);
  }, 10000);
}

/***/ }),

/***/ 68363:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



__webpack_require__(69070);

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.getHelpUrl = getHelpUrl;
exports.getEPASHelpUrl = getEPASHelpUrl;

__webpack_require__(15306);

__webpack_require__(74916);

//////////////////////////////////////////////////////////////////////////
//
// pgAdmin 4 - PostgreSQL Tools
//
// Copyright (C) 2013 - 2022, The pgAdmin Development Team
// This software is released under the PostgreSQL Licence
//
//////////////////////////////////////////////////////////////////////////
function getHelpUrl(base_path, file, version) {
  var major = Math.floor(version / 10000),
      minor = Math.floor(version / 100) - major * 100,
      url = '',
      replace_string = major + '.' + minor;

  if (major >= 10) {
    // Handle the version number format change in PG 10+
    replace_string = major;
  }

  url = base_path.replace('$VERSION$', replace_string);

  if (url.substr(-1) != '/') {
    url = url + '/';
  }

  return url + file;
}

function getEPASHelpUrl(version) {
  var major = Math.floor(version / 10000),
      minor = Math.floor(version / 100) - major * 100,
      epasHelp11Plus = 'https://www.enterprisedb.com/docs/epas/$VERSION$/epas_compat_sql/',
      epasHelp = 'https://www.enterprisedb.com/docs/epas/$VERSION$/',
      url = '';
  url = epasHelp11Plus.replace('$VERSION$', major);

  if (major == 10) {
    url = epasHelp.replace('$VERSION$', major);
  } else if (major < 10) {
    url = epasHelp.replace('$VERSION$', major + '.' + minor);
  }

  return url;
}

/***/ }),

/***/ 20811:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



__webpack_require__(69070);

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.default = void 0;

__webpack_require__(69826);

var _codemirror = _interopRequireDefault(__webpack_require__(4631));

__webpack_require__(54086);

__webpack_require__(64020);

__webpack_require__(20017);

__webpack_require__(88657);

__webpack_require__(89700);

__webpack_require__(71707);

__webpack_require__(3585);

__webpack_require__(69109);

__webpack_require__(55292);

__webpack_require__(81699);

__webpack_require__(32095);

__webpack_require__(14568);

__webpack_require__(4328);

__webpack_require__(82801);

__webpack_require__(29424);

__webpack_require__(90338);

__webpack_require__(18473);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/////////////////////////////////////////////////////////////
//
// pgAdmin 4 - PostgreSQL Tools
//
// Copyright (C) 2013 - 2022, The pgAdmin Development Team
// This software is released under the PostgreSQL Licence
//
//////////////////////////////////////////////////////////////
var cmds = _codemirror["default"].commands;

cmds.focusOut = function () {
  event.stopPropagation();
  document.activeElement.blur();

  if (event.currentTarget.hasOwnProperty('parents') && event.currentTarget.parents().find('.sql-code-control')) {
    // for code mirror in dialogs
    event.currentTarget.parents().find('.sql-code-control').focus();
  }
};

_codemirror["default"].defineInitHook(function (codeMirror) {
  codeMirror.addKeyMap({
    Tab: function Tab(cm) {
      if (cm.somethingSelected()) {
        cm.execCommand('indentMore');
      } else {
        if (cm.getOption('indentWithTabs')) {
          cm.replaceSelection('\t', 'end', '+input');
        } else {
          cm.execCommand('insertSoftTab');
        }
      }
    }
  });
});

_codemirror["default"].keyMap["default"]['Esc'] = 'focusOut';
var _default = _codemirror["default"];
exports.default = _default;

/***/ }),

/***/ 8593:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

__webpack_require__(82526);

__webpack_require__(38880);

__webpack_require__(49337);

__webpack_require__(33321);

__webpack_require__(19601);

__webpack_require__(79753);

__webpack_require__(41817);

__webpack_require__(32165);

__webpack_require__(78783);

__webpack_require__(47042);

__webpack_require__(68309);

__webpack_require__(91038);

__webpack_require__(4129);

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.DataGridHeader = DataGridHeader;
exports.default = DataGridView;

__webpack_require__(21249);

__webpack_require__(41539);

__webpack_require__(66992);

__webpack_require__(33948);

__webpack_require__(57327);

__webpack_require__(47941);

__webpack_require__(23157);

__webpack_require__(89554);

__webpack_require__(54747);

__webpack_require__(92222);

__webpack_require__(2707);

__webpack_require__(82772);

__webpack_require__(69826);

__webpack_require__(88674);

__webpack_require__(26699);

__webpack_require__(32023);

__webpack_require__(86535);

__webpack_require__(99244);

__webpack_require__(69070);

var _react = _interopRequireWildcard(__webpack_require__(67294));

var _core = __webpack_require__(65770);

var _styles = __webpack_require__(30398);

var _Buttons = __webpack_require__(87451);

var _AddOutlined = _interopRequireDefault(__webpack_require__(3550));

var _MappedControl = __webpack_require__(26850);

var _EditRounded = _interopRequireDefault(__webpack_require__(66631));

var _DeleteRounded = _interopRequireDefault(__webpack_require__(62015));

var _reactTable = __webpack_require__(79521);

var _clsx = _interopRequireDefault(__webpack_require__(86010));

var _propTypes = _interopRequireDefault(__webpack_require__(45697));

var _lodash = _interopRequireDefault(__webpack_require__(96486));

var _gettext = _interopRequireDefault(__webpack_require__(91669));

var _2 = __webpack_require__(52237);

var _FormView = _interopRequireWildcard(__webpack_require__(75835));

var _legacyConnector = __webpack_require__(81922);

var _custom_prop_types = _interopRequireDefault(__webpack_require__(41832));

var _utils = __webpack_require__(44092);

var _DepListener = __webpack_require__(64519);

var _custom_hooks = __webpack_require__(50464);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var useStyles = (0, _styles.makeStyles)(function (theme) {
  return {
    grid: _objectSpread(_objectSpread({}, theme.mixins.panelBorder), {}, {
      backgroundColor: theme.palette.background["default"]
    }),
    gridHeader: _objectSpread(_objectSpread({
      display: 'flex'
    }, theme.mixins.panelBorder.bottom), {}, {
      backgroundColor: theme.otherVars.headerBg
    }),
    gridHeaderText: {
      padding: theme.spacing(0.5, 1),
      fontWeight: theme.typography.fontWeightBold
    },
    gridControls: {
      marginLeft: 'auto'
    },
    gridControlsButton: _objectSpread({
      border: 0,
      borderRadius: 0
    }, theme.mixins.panelBorder.left),
    gridRowButton: {
      border: 0,
      borderRadius: 0,
      padding: 0,
      minWidth: 0,
      backgroundColor: 'inherit',
      '&.Mui-disabled': {
        border: 0
      }
    },
    gridTableContainer: {
      overflow: 'auto',
      width: '100%'
    },
    table: {
      borderSpacing: 0,
      width: '100%',
      overflow: 'auto',
      backgroundColor: theme.otherVars.tableBg
    },
    tableCell: _objectSpread(_objectSpread(_objectSpread({
      margin: 0,
      padding: theme.spacing(0.5)
    }, theme.mixins.panelBorder.bottom), theme.mixins.panelBorder.right), {}, {
      position: 'relative',
      overflow: 'hidden',
      textOverflow: 'ellipsis',
      whiteSpace: 'nowrap'
    }),
    tableCellHeader: {
      fontWeight: theme.typography.fontWeightBold,
      padding: theme.spacing(1, 0.5),
      textAlign: 'left'
    },
    tableContentWidth: {
      width: 'calc(100% - 3px)'
    },
    btnCell: {
      padding: theme.spacing(0.5, 0),
      textAlign: 'center'
    },
    resizer: {
      display: 'inline-block',
      width: '5px',
      height: '100%',
      position: 'absolute',
      right: 0,
      top: 0,
      transform: 'translateX(50%)',
      zIndex: 1,
      touchAction: 'none'
    },
    expandedForm: {
      borderTopWidth: theme.spacing(0.5),
      borderStyle: 'solid ',
      borderColor: theme.palette.grey[400]
    },
    expandedIconCell: {
      backgroundColor: theme.palette.grey[400],
      borderBottom: 'none'
    }
  };
});

function DataTableHeader(_ref) {
  var headerGroups = _ref.headerGroups;
  var classes = useStyles();
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: classes.tableContentWidth
  }, headerGroups.map(function (headerGroup, hi) {
    return /*#__PURE__*/_react["default"].createElement("div", _extends({
      key: hi
    }, headerGroup.getHeaderGroupProps()), headerGroup.headers.map(function (column, ci) {
      return /*#__PURE__*/_react["default"].createElement("div", _extends({
        key: ci
      }, column.getHeaderProps()), /*#__PURE__*/_react["default"].createElement("div", _extends({}, column.sortable ? column.getSortByToggleProps() : {}, {
        className: (0, _clsx["default"])(classes.tableCell, classes.tableCellHeader)
      }), column.render('Header'), /*#__PURE__*/_react["default"].createElement("span", null, column.isSorted ? column.isSortedDesc ? ' 🔽' : ' 🔼' : '')), !column.disableResizing && /*#__PURE__*/_react["default"].createElement("div", _extends({}, column.getResizerProps(), {
        className: classes.resizer
      })));
    }));
  }));
}

DataTableHeader.propTypes = {
  headerGroups: _propTypes["default"].array.isRequired
};

function DataTableRow(_ref2) {
  var row = _ref2.row,
      totalRows = _ref2.totalRows,
      isResizing = _ref2.isResizing,
      schema = _ref2.schema,
      schemaRef = _ref2.schemaRef,
      accessPath = _ref2.accessPath;
  var classes = useStyles();

  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      key = _useState2[0],
      setKey = _useState2[1];

  var depListener = (0, _react.useContext)(_DepListener.DepListenerContext);
  /* Memoize the row to avoid unnecessary re-render.
   * If table data changes, then react-table re-renders the complete tables
   * We can avoid re-render by if row data is not changed
   */

  var depsMap = _lodash["default"].values(row.values, Object.keys(row.values).filter(function (k) {
    return !k.startsWith('btn');
  }));

  var externalDeps = (0, _react.useMemo)(function () {
    var retVal = [];
    /* Calculate the fields which depends on the current field
    deps has info on fields which the current field depends on. */

    schema.fields.forEach(function (field) {
      ((0, _utils.evalFunc)(null, field.deps) || []).forEach(function (dep) {
        var source = accessPath.concat(dep);

        if (_lodash["default"].isArray(dep)) {
          source = dep;
          /* If its an array, then dep is from the top schema and external */

          retVal.push(source);
        }
      });
    });
    return retVal;
  }, []);
  (0, _react.useEffect)(function () {
    schemaRef.current.fields.forEach(function (field) {
      /* Self change is also dep change */
      if (field.depChange || field.deferredDepChange) {
        depListener === null || depListener === void 0 ? void 0 : depListener.addDepListener(accessPath.concat(field.id), accessPath.concat(field.id), field.depChange, field.deferredDepChange);
      }

      ((0, _utils.evalFunc)(null, field.deps) || []).forEach(function (dep) {
        var source = accessPath.concat(dep);

        if (_lodash["default"].isArray(dep)) {
          source = dep;
        }

        if (field.depChange) {
          depListener === null || depListener === void 0 ? void 0 : depListener.addDepListener(source, accessPath.concat(field.id), field.depChange);
        }
      });
    });
    return function () {
      /* Cleanup the listeners when unmounting */
      depListener === null || depListener === void 0 ? void 0 : depListener.removeDepListener(accessPath);
    };
  }, []);
  /* External deps values are from top schema sess data */

  depsMap = depsMap.concat(externalDeps.map(function (source) {
    var _schemaRef$current$to;

    return _lodash["default"].get((_schemaRef$current$to = schemaRef.current.top) === null || _schemaRef$current$to === void 0 ? void 0 : _schemaRef$current$to.sessData, source);
  }));
  depsMap = depsMap.concat([totalRows, row.isExpanded, key, isResizing]);
  return (0, _react.useMemo)(function () {
    return /*#__PURE__*/_react["default"].createElement("div", _extends({}, row.getRowProps(), {
      className: "tr"
    }), row.cells.map(function (cell, ci) {
      var classNames = [classes.tableCell];

      if (typeof cell.column.id == 'string' && cell.column.id.startsWith('btn-')) {
        classNames.push(classes.btnCell);
      }

      if (cell.column.id == 'btn-edit' && row.isExpanded) {
        classNames.push(classes.expandedIconCell);
      }

      return /*#__PURE__*/_react["default"].createElement("div", _extends({
        key: ci
      }, cell.getCellProps(), {
        className: (0, _clsx["default"])(classNames)
      }), cell.render('Cell', {
        reRenderRow: function reRenderRow() {
          setKey(function (currKey) {
            return !currKey;
          });
        }
      }));
    }));
  }, depsMap);
}

function DataGridHeader(_ref3) {
  var label = _ref3.label,
      canAdd = _ref3.canAdd,
      onAddClick = _ref3.onAddClick;
  var classes = useStyles();
  return /*#__PURE__*/_react["default"].createElement(_core.Box, {
    className: classes.gridHeader
  }, /*#__PURE__*/_react["default"].createElement(_core.Box, {
    className: classes.gridHeaderText
  }, label), /*#__PURE__*/_react["default"].createElement(_core.Box, {
    className: classes.gridControls
  }, canAdd && /*#__PURE__*/_react["default"].createElement(_Buttons.PgIconButton, {
    "data-test": "add-row",
    title: (0, _gettext["default"])('Add row'),
    onClick: onAddClick,
    icon: /*#__PURE__*/_react["default"].createElement(_AddOutlined["default"], null),
    className: classes.gridControlsButton
  })));
}

DataGridHeader.propTypes = {
  label: _propTypes["default"].string,
  canAdd: _propTypes["default"].bool,
  onAddClick: _propTypes["default"].func
};

function DataGridView(_ref4) {
  var value = _ref4.value,
      viewHelperProps = _ref4.viewHelperProps,
      schema = _ref4.schema,
      accessPath = _ref4.accessPath,
      dataDispatch = _ref4.dataDispatch,
      containerClassName = _ref4.containerClassName,
      fixedRows = _ref4.fixedRows,
      props = _objectWithoutProperties(_ref4, ["value", "viewHelperProps", "schema", "accessPath", "dataDispatch", "containerClassName", "fixedRows"]);

  var classes = useStyles();
  var stateUtils = (0, _react.useContext)(_2.StateUtilsContext);
  var checkIsMounted = (0, _custom_hooks.useIsMounted)();
  /* Using ref so that schema variable is not frozen in columns closure */

  var schemaRef = (0, _react.useRef)(schema);
  var columns = (0, _react.useMemo)(function () {
    var cols = [];

    if (props.canEdit) {
      var colInfo = {
        Header: /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, "\xA0"),
        id: 'btn-edit',
        accessor: function accessor() {},
        disableResizing: true,
        sortable: false,
        dataType: 'edit',
        width: 26,
        minWidth: 26,
        maxWidth: 26,
        Cell: function Cell(_ref5) {
          var row = _ref5.row;
          var canEditRow = true;

          if (props.canEditRow) {
            canEditRow = (0, _utils.evalFunc)(schemaRef.current, props.canEditRow, row.original || {});
          }

          return /*#__PURE__*/_react["default"].createElement(_Buttons.PgIconButton, {
            "data-test": "expand-row",
            title: (0, _gettext["default"])('Edit row'),
            icon: /*#__PURE__*/_react["default"].createElement(_EditRounded["default"], {
              fontSize: "small"
            }),
            className: classes.gridRowButton,
            onClick: function onClick() {
              row.toggleRowExpanded(!row.isExpanded);
            },
            disabled: !canEditRow
          });
        }
      };
      colInfo.Cell.displayName = 'Cell', colInfo.Cell.propTypes = {
        row: _propTypes["default"].object.isRequired
      };
      cols.push(colInfo);
    }

    if (props.canDelete) {
      var _colInfo = {
        Header: /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, "\xA0"),
        id: 'btn-delete',
        accessor: function accessor() {},
        disableResizing: true,
        sortable: false,
        dataType: 'delete',
        width: 26,
        minWidth: 26,
        maxWidth: 26,
        Cell: function Cell(_ref6) {
          var row = _ref6.row;
          var canDeleteRow = true;

          if (props.canDeleteRow) {
            canDeleteRow = (0, _utils.evalFunc)(schemaRef.current, props.canDeleteRow, row.original || {});
          }

          return /*#__PURE__*/_react["default"].createElement(_Buttons.PgIconButton, {
            "data-test": "delete-row",
            title: (0, _gettext["default"])('Delete row'),
            icon: /*#__PURE__*/_react["default"].createElement(_DeleteRounded["default"], {
              fontSize: "small"
            }),
            onClick: function onClick() {
              (0, _legacyConnector.confirmDeleteRow)(function () {
                /* Get the changes on dependent fields as well */
                dataDispatch({
                  type: _2.SCHEMA_STATE_ACTIONS.DELETE_ROW,
                  path: accessPath,
                  value: row.index
                });
              }, function () {}, props.customDeleteTitle, props.customDeleteMsg);
            },
            className: classes.gridRowButton,
            disabled: !canDeleteRow
          });
        }
      };
      _colInfo.Cell.displayName = 'Cell', _colInfo.Cell.propTypes = {
        row: _propTypes["default"].object.isRequired
      };
      cols.push(_colInfo);
    }

    cols = cols.concat(schemaRef.current.fields.filter(function (f) {
      return _lodash["default"].isArray(props.columns) ? props.columns.indexOf(f.id) > -1 : true;
    }).sort(function (firstF, secondF) {
      if (_lodash["default"].isArray(props.columns)) {
        return props.columns.indexOf(firstF.id) < props.columns.indexOf(secondF.id) ? -1 : 1;
      }

      return 0;
    }).map(function (field) {
      var widthParms = {};

      if (field.width) {
        widthParms.width = field.width;
        widthParms.minWidth = field.width;
      } else {
        widthParms.width = 75;
        widthParms.minWidth = 75;
      }

      if (field.minWidth) {
        widthParms.minWidth = field.minWidth;
      }

      if (field.maxWidth) {
        widthParms.maxWidth = field.maxWidth;
      }

      widthParms.disableResizing = Boolean(field.disableResizing);

      var colInfo = _objectSpread(_objectSpread({
        Header: field.label || /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, "\xA0"),
        accessor: field.id,
        field: field,
        disableResizing: false,
        sortable: true
      }, widthParms), {}, {
        Cell: function Cell(_ref7) {
          var value = _ref7.value,
              row = _ref7.row,
              other = _objectWithoutProperties(_ref7, ["value", "row"]);

          /* Make sure to take the latest field info from schema */
          field = _lodash["default"].find(schemaRef.current.fields, function (f) {
            return f.id == field.id;
          }) || field;

          var _getFieldMetaData = (0, _FormView.getFieldMetaData)(field, schemaRef.current, row.original || {}, viewHelperProps),
              editable = _getFieldMetaData.editable;

          if (_lodash["default"].isUndefined(field.cell)) {
            console.error('cell is required ', field);
          }

          return /*#__PURE__*/_react["default"].createElement(_MappedControl.MappedCellControl, _extends({
            rowIndex: row.index,
            value: value,
            row: row.original
          }, field, {
            readonly: !editable,
            disabled: false,
            visible: true,
            onCellChange: function onCellChange(value) {
              dataDispatch({
                type: _2.SCHEMA_STATE_ACTIONS.SET_VALUE,
                path: accessPath.concat([row.index, field.id]),
                value: value
              });
            },
            reRenderRow: other.reRenderRow
          }));
        }
      });

      colInfo.Cell.displayName = 'Cell', colInfo.Cell.propTypes = {
        row: _propTypes["default"].object.isRequired,
        value: _propTypes["default"].any,
        onCellChange: _propTypes["default"].func
      };
      return colInfo;
    }));
    return cols;
  }, [props.canEdit, props.canDelete]);
  var onAddClick = (0, _react.useCallback)(function () {
    if (!props.canAddRow) {
      return;
    }

    var newRow = schemaRef.current.getNewData();
    dataDispatch({
      type: _2.SCHEMA_STATE_ACTIONS.ADD_ROW,
      path: accessPath,
      value: newRow
    });
  }, [props.canAddRow]);
  var defaultColumn = (0, _react.useMemo)(function () {
    return {};
  }, []);
  var tablePlugins = [_reactTable.useFlexLayout, _reactTable.useResizeColumns, _reactTable.useSortBy, _reactTable.useExpanded];

  var _useTable = _reactTable.useTable.apply(void 0, [{
    columns: columns,
    data: value || [],
    defaultColumn: defaultColumn,
    manualSortBy: true,
    autoResetSortBy: false,
    autoResetExpanded: false
  }].concat(tablePlugins)),
      getTableProps = _useTable.getTableProps,
      getTableBodyProps = _useTable.getTableBodyProps,
      headerGroups = _useTable.headerGroups,
      rows = _useTable.rows,
      prepareRow = _useTable.prepareRow;

  (0, _react.useEffect)(function () {
    var rowsPromise = fixedRows;
    /* If fixedRows is defined, fetch the details */

    if (typeof rowsPromise === 'function') {
      rowsPromise = rowsPromise();
    }

    if (rowsPromise) {
      Promise.resolve(rowsPromise).then(function (res) {
        /* If component unmounted, dont update state */
        if (checkIsMounted()) {
          stateUtils.initOrigData(accessPath, res);
        }
      });
    }
  }, []);

  var isResizing = _lodash["default"].flatMap(headerGroups, function (headerGroup) {
    return headerGroup.headers.map(function (col) {
      return col.isResizing;
    });
  }).includes(true);

  if (!props.visible) {
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null);
  }

  return /*#__PURE__*/_react["default"].createElement(_core.Box, {
    className: containerClassName
  }, /*#__PURE__*/_react["default"].createElement(_core.Box, {
    className: classes.grid
  }, (props.label || props.canAdd) && /*#__PURE__*/_react["default"].createElement(DataGridHeader, {
    label: props.label,
    canAdd: props.canAdd,
    onAddClick: onAddClick
  }), /*#__PURE__*/_react["default"].createElement("div", _extends({}, getTableProps(), {
    className: classes.table
  }), /*#__PURE__*/_react["default"].createElement(DataTableHeader, {
    headerGroups: headerGroups
  }), /*#__PURE__*/_react["default"].createElement("div", _extends({}, getTableBodyProps(), {
    className: classes.tableContentWidth
  }), rows.map(function (row, i) {
    prepareRow(row);
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, {
      key: i
    }, /*#__PURE__*/_react["default"].createElement(DataTableRow, {
      row: row,
      totalRows: rows.length,
      isResizing: isResizing,
      schema: schemaRef.current,
      schemaRef: schemaRef,
      accessPath: accessPath.concat([row.index])
    }), props.canEdit && row.isExpanded && /*#__PURE__*/_react["default"].createElement(_FormView["default"], {
      value: row.original,
      viewHelperProps: viewHelperProps,
      dataDispatch: dataDispatch,
      schema: schemaRef.current,
      accessPath: accessPath.concat([row.index]),
      isNested: true,
      className: classes.expandedForm,
      isDataGridForm: true
    }));
  })))));
}

DataGridView.propTypes = {
  label: _propTypes["default"].string,
  value: _propTypes["default"].array,
  viewHelperProps: _propTypes["default"].object,
  schema: _custom_prop_types["default"].schemaUI,
  accessPath: _propTypes["default"].array.isRequired,
  dataDispatch: _propTypes["default"].func,
  containerClassName: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].string]),
  fixedRows: _propTypes["default"].oneOfType([_propTypes["default"].array, _propTypes["default"].instanceOf(Promise), _propTypes["default"].func]),
  columns: _propTypes["default"].array,
  canEdit: _propTypes["default"].bool,
  canAdd: _propTypes["default"].bool,
  canDelete: _propTypes["default"].bool,
  visible: _propTypes["default"].bool,
  canAddRow: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
  canEditRow: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
  canDeleteRow: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
  customDeleteTitle: _propTypes["default"].string,
  customDeleteMsg: _propTypes["default"].string
};

/***/ }),

/***/ 64519:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



__webpack_require__(41539);

__webpack_require__(68309);

__webpack_require__(91038);

__webpack_require__(78783);

__webpack_require__(82526);

__webpack_require__(41817);

__webpack_require__(32165);

__webpack_require__(66992);

__webpack_require__(33948);

__webpack_require__(79753);

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.default = exports.DepListenerContext = void 0;

__webpack_require__(57327);

__webpack_require__(23157);

__webpack_require__(69600);

__webpack_require__(47042);

__webpack_require__(69070);

var _lodash = _interopRequireDefault(__webpack_require__(96486));

var _react = _interopRequireDefault(__webpack_require__(67294));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var DepListenerContext = /*#__PURE__*/_react["default"].createContext();

exports.DepListenerContext = DepListenerContext;

var DepListener = /*#__PURE__*/function () {
  function DepListener() {
    _classCallCheck(this, DepListener);

    this._depListeners = [];
  }
  /* Will keep track of the dependent fields and there callbacks */


  _createClass(DepListener, [{
    key: "addDepListener",
    value: function addDepListener(source, dest, callback, defCallback) {
      this._depListeners = this._depListeners || [];

      this._depListeners.push({
        source: source,
        dest: dest,
        callback: callback,
        defCallback: defCallback
      });
    }
  }, {
    key: "removeDepListener",
    value: function removeDepListener(dest) {
      this._depListeners = _lodash["default"].filter(this._depListeners, function (l) {
        return !_lodash["default"].join(l.dest, '|').startsWith(_lodash["default"].join(dest, '|'));
      });
    }
  }, {
    key: "_getListenerData",
    value: function _getListenerData(state, listener, actionObj) {
      /* Get data at same level */
      var data = state;

      var dataPath = _lodash["default"].slice(listener.dest, 0, -1);

      if (dataPath.length > 0) {
        data = _lodash["default"].get(state, dataPath);
      }

      _lodash["default"].assign(data, listener.callback && listener.callback(data, listener.source, state, actionObj) || {});

      return state;
    }
  }, {
    key: "_getDefListenerPromise",
    value: function _getDefListenerPromise(state, listener, actionObj) {
      /* Get data at same level */
      var data = state;

      var dataPath = _lodash["default"].slice(listener.dest, 0, -1);

      if (dataPath.length > 0) {
        data = _lodash["default"].get(state, dataPath);
      }

      return listener.defCallback && listener.defCallback(data, listener.source, state, actionObj);
    }
    /* Called when any field changed and trigger callbacks */

  }, {
    key: "getDepChange",
    value: function getDepChange(currPath, state, actionObj) {
      var _actionObj$listener;

      /* If this comes from deferred change */
      if ((_actionObj$listener = actionObj.listener) !== null && _actionObj$listener !== void 0 && _actionObj$listener.callback) {
        state = this._getListenerData(state, actionObj.listener, actionObj);
      } else {
        var allListeners = _lodash["default"].filter(this._depListeners, function (entry) {
          return _lodash["default"].join(currPath, '|').startsWith(_lodash["default"].join(entry.source, '|'));
        });

        if (allListeners) {
          var _iterator = _createForOfIteratorHelper(allListeners),
              _step;

          try {
            for (_iterator.s(); !(_step = _iterator.n()).done;) {
              var listener = _step.value;
              state = this._getListenerData(state, listener, actionObj);
            }
          } catch (err) {
            _iterator.e(err);
          } finally {
            _iterator.f();
          }
        }
      }

      return state;
    }
  }, {
    key: "getDeferredDepChange",
    value: function getDeferredDepChange(currPath, state, actionObj) {
      var deferredList = [];

      var allListeners = _lodash["default"].filter(this._depListeners, function (entry) {
        return _lodash["default"].join(currPath, '|').startsWith(_lodash["default"].join(entry.source, '|'));
      });

      if (allListeners) {
        var _iterator2 = _createForOfIteratorHelper(allListeners),
            _step2;

        try {
          for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
            var listener = _step2.value;

            if (listener.defCallback) {
              var thePromise = this._getDefListenerPromise(state, listener, actionObj);

              if (thePromise) {
                deferredList.push({
                  action: actionObj,
                  promise: thePromise,
                  listener: listener
                });
              }
            }
          }
        } catch (err) {
          _iterator2.e(err);
        } finally {
          _iterator2.f();
        }
      }

      return deferredList;
    }
  }]);

  return DepListener;
}();

exports.default = DepListener;

/***/ }),

/***/ 57674:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

__webpack_require__(19601);

__webpack_require__(79753);

__webpack_require__(82526);

__webpack_require__(41817);

__webpack_require__(41539);

__webpack_require__(32165);

__webpack_require__(78783);

__webpack_require__(66992);

__webpack_require__(33948);

__webpack_require__(91038);

__webpack_require__(47042);

__webpack_require__(4129);

__webpack_require__(69070);

__webpack_require__(38880);

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.default = FieldSetView;

__webpack_require__(89554);

__webpack_require__(54747);

__webpack_require__(92222);

__webpack_require__(68309);

__webpack_require__(21249);

var _react = _interopRequireWildcard(__webpack_require__(67294));

var _lodash = _interopRequireDefault(__webpack_require__(96486));

var _propTypes = _interopRequireDefault(__webpack_require__(45697));

var _MappedControl = __webpack_require__(26850);

var _2 = __webpack_require__(52237);

var _utils = __webpack_require__(44092);

var _custom_prop_types = _interopRequireDefault(__webpack_require__(41832));

var _DepListener = __webpack_require__(64519);

var _FormView = __webpack_require__(75835);

var _FieldSet = _interopRequireDefault(__webpack_require__(84963));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function FieldSetView(_ref) {
  var value = _ref.value,
      _ref$schema = _ref.schema,
      schema = _ref$schema === void 0 ? {} : _ref$schema,
      viewHelperProps = _ref.viewHelperProps,
      accessPath = _ref.accessPath,
      dataDispatch = _ref.dataDispatch,
      controlClassName = _ref.controlClassName,
      _ref$isDataGridForm = _ref.isDataGridForm,
      isDataGridForm = _ref$isDataGridForm === void 0 ? false : _ref$isDataGridForm,
      label = _ref.label,
      visible = _ref.visible;
  var depListener = (0, _react.useContext)(_DepListener.DepListenerContext);
  var stateUtils = (0, _react.useContext)(_2.StateUtilsContext);
  (0, _react.useEffect)(function () {
    /* Calculate the fields which depends on the current field */
    if (!isDataGridForm && depListener) {
      schema.fields.forEach(function (field) {
        /* Self change is also dep change */
        if (field.depChange || field.deferredDepChange) {
          depListener.addDepListener(accessPath.concat(field.id), accessPath.concat(field.id), field.depChange, field.deferredDepChange);
        }

        ((0, _utils.evalFunc)(null, field.deps) || []).forEach(function (dep) {
          var source = accessPath.concat(dep);

          if (_lodash["default"].isArray(dep)) {
            source = dep;
          }

          if (field.depChange) {
            depListener.addDepListener(source, accessPath.concat(field.id), field.depChange);
          }
        });
      });
    }
  }, []);
  var viewFields = [];
  /* Prepare the array of components based on the types */

  schema.fields.forEach(function (field) {
    var _getFieldMetaData = (0, _FormView.getFieldMetaData)(field, schema, value, viewHelperProps),
        visible = _getFieldMetaData.visible,
        disabled = _getFieldMetaData.disabled,
        readonly = _getFieldMetaData.readonly,
        modeSupported = _getFieldMetaData.modeSupported;

    if (modeSupported) {
      /* Its a form control */
      var hasError = field.id == (stateUtils === null || stateUtils === void 0 ? void 0 : stateUtils.formErr.name);
      /* When there is a change, the dependent values can change
        * lets pass the new changes to dependent and get the new values
        * from there as well.
        */

      viewFields.push((0, _react.useMemo)(function () {
        return /*#__PURE__*/_react["default"].createElement(_MappedControl.MappedFormControl, _extends({
          state: value,
          key: field.id,
          viewHelperProps: viewHelperProps,
          name: field.id,
          value: value[field.id]
        }, field, {
          readonly: readonly,
          disabled: disabled,
          visible: visible,
          onChange: function onChange(value) {
            /* Get the changes on dependent fields as well */
            dataDispatch({
              type: _2.SCHEMA_STATE_ACTIONS.SET_VALUE,
              path: accessPath.concat(field.id),
              value: value
            });
          },
          hasError: hasError,
          className: controlClassName
        }));
      }, [value[field.id], readonly, disabled, visible, hasError, controlClassName].concat(_toConsumableArray(((0, _utils.evalFunc)(null, field.deps) || []).map(function (dep) {
        return value[dep];
      })))));
    }
  });

  if (!visible) {
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null);
  }

  return /*#__PURE__*/_react["default"].createElement(_FieldSet["default"], {
    title: label,
    className: controlClassName
  }, viewFields);
}

FieldSetView.propTypes = {
  value: _propTypes["default"].any,
  schema: _custom_prop_types["default"].schemaUI.isRequired,
  viewHelperProps: _propTypes["default"].object,
  isDataGridForm: _propTypes["default"].bool,
  accessPath: _propTypes["default"].array.isRequired,
  dataDispatch: _propTypes["default"].func,
  controlClassName: _custom_prop_types["default"].className,
  label: _propTypes["default"].string,
  visible: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func])
};

/***/ }),

/***/ 75835:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

__webpack_require__(82526);

__webpack_require__(41817);

__webpack_require__(41539);

__webpack_require__(32165);

__webpack_require__(78783);

__webpack_require__(66992);

__webpack_require__(33948);

__webpack_require__(47042);

__webpack_require__(91038);

__webpack_require__(19601);

__webpack_require__(69070);

__webpack_require__(57327);

__webpack_require__(38880);

__webpack_require__(49337);

__webpack_require__(33321);

__webpack_require__(4129);

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.getFieldMetaData = getFieldMetaData;
exports.default = FormView;

__webpack_require__(82772);

__webpack_require__(89554);

__webpack_require__(54747);

__webpack_require__(92222);

__webpack_require__(68309);

__webpack_require__(21249);

__webpack_require__(47941);

__webpack_require__(79753);

var _react = _interopRequireWildcard(__webpack_require__(67294));

var _core = __webpack_require__(65770);

var _lodash = _interopRequireDefault(__webpack_require__(96486));

var _propTypes = _interopRequireDefault(__webpack_require__(45697));

var _clsx = _interopRequireDefault(__webpack_require__(86010));

var _MappedControl = __webpack_require__(26850);

var _TabPanel = _interopRequireDefault(__webpack_require__(32982));

var _DataGridView = _interopRequireDefault(__webpack_require__(8593));

var _2 = __webpack_require__(52237);

var _FormComponents = __webpack_require__(93299);

var _gettext = _interopRequireDefault(__webpack_require__(91669));

var _utils = __webpack_require__(44092);

var _custom_prop_types = _interopRequireDefault(__webpack_require__(41832));

var _custom_hooks = __webpack_require__(50464);

var _DepListener = __webpack_require__(64519);

var _FieldSetView = _interopRequireDefault(__webpack_require__(57674));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var useStyles = (0, _core.makeStyles)(function (theme) {
  return {
    fullSpace: {
      padding: 0,
      height: '100%'
    },
    controlRow: {
      marginBottom: theme.spacing(1)
    },
    nestedTabPanel: {
      backgroundColor: theme.otherVars.headerBg
    },
    nestedControl: {
      height: 'unset'
    },
    sqlTabInput: {
      border: 0
    }
  };
});
/* Optional SQL tab */

function SQLTab(_ref) {
  var active = _ref.active,
      getSQLValue = _ref.getSQLValue;
  var classes = useStyles();

  var _useState = (0, _react.useState)('Loading...'),
      _useState2 = _slicedToArray(_useState, 2),
      sql = _useState2[0],
      setSql = _useState2[1];

  (0, _react.useEffect)(function () {
    var unmounted = false;

    if (active) {
      setSql('Loading...');
      getSQLValue().then(function (value) {
        if (!unmounted) {
          setSql(value);
        }
      });
    }

    return function () {
      unmounted = true;
    };
  }, [active]);
  return /*#__PURE__*/_react["default"].createElement(_FormComponents.InputSQL, {
    value: sql,
    options: {
      readOnly: true
    },
    readonly: true,
    className: classes.sqlTabInput
  });
}

SQLTab.propTypes = {
  active: _propTypes["default"].bool,
  getSQLValue: _propTypes["default"].func.isRequired
};

function getFieldMetaData(field, schema, value, viewHelperProps) {
  var onlyModeCheck = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : false;
  var retData = {
    readonly: false,
    disabled: false,
    visible: true,
    editable: true,
    canAdd: true,
    canEdit: false,
    canDelete: true,
    modeSupported: true,
    canAddRow: true
  };

  if (field.mode) {
    retData.modeSupported = field.mode.indexOf(viewHelperProps.mode) > -1;
  }

  if (!retData.modeSupported) {
    return retData;
  }

  if (onlyModeCheck) {
    return retData;
  }

  var visible = field.visible,
      disabled = field.disabled,
      readonly = field.readonly,
      editable = field.editable;
  var verInLimit = _lodash["default"].isUndefined(viewHelperProps.serverInfo) ? true : (_lodash["default"].isUndefined(field.server_type) ? true : viewHelperProps.serverInfo.type in field.server_type) && (_lodash["default"].isUndefined(field.min_version) ? true : viewHelperProps.serverInfo.version >= field.min_version) && (_lodash["default"].isUndefined(field.max_version) ? true : viewHelperProps.serverInfo.version <= field.max_version);
  retData.readonly = viewHelperProps.inCatalog || viewHelperProps.mode == 'properties';

  if (!retData.readonly) {
    retData.readonly = (0, _utils.evalFunc)(schema, readonly, value);
  }

  var _visible = verInLimit;
  _visible = _visible && (0, _utils.evalFunc)(schema, _lodash["default"].isUndefined(visible) ? true : visible, value);
  retData.visible = Boolean(_visible);
  retData.disabled = Boolean((0, _utils.evalFunc)(schema, disabled, value));
  retData.editable = !(viewHelperProps.inCatalog || viewHelperProps.mode == 'properties');

  if (retData.editable) {
    retData.editable = (0, _utils.evalFunc)(schema, _lodash["default"].isUndefined(editable) ? true : editable, value);
  }

  var canAdd = field.canAdd,
      canEdit = field.canEdit,
      canDelete = field.canDelete,
      canAddRow = field.canAddRow;
  retData.canAdd = _lodash["default"].isUndefined(canAdd) ? retData.canAdd : (0, _utils.evalFunc)(schema, canAdd, value);
  retData.canAdd = !retData.disabled && retData.canAdd;
  retData.canEdit = _lodash["default"].isUndefined(canEdit) ? retData.canEdit : (0, _utils.evalFunc)(schema, canEdit, value);
  retData.canEdit = !retData.disabled && retData.canEdit;
  retData.canDelete = _lodash["default"].isUndefined(canDelete) ? retData.canDelete : (0, _utils.evalFunc)(schema, canDelete, value);
  retData.canDelete = !retData.disabled && retData.canDelete;
  retData.canAddRow = _lodash["default"].isUndefined(canAddRow) ? retData.canAddRow : (0, _utils.evalFunc)(schema, canAddRow, value);
  return retData;
}
/* The first component of schema view form */


function FormView(_ref2) {
  var value = _ref2.value,
      _ref2$schema = _ref2.schema,
      schema = _ref2$schema === void 0 ? {} : _ref2$schema,
      viewHelperProps = _ref2.viewHelperProps,
      _ref2$isNested = _ref2.isNested,
      isNested = _ref2$isNested === void 0 ? false : _ref2$isNested,
      accessPath = _ref2.accessPath,
      dataDispatch = _ref2.dataDispatch,
      hasSQLTab = _ref2.hasSQLTab,
      getSQLValue = _ref2.getSQLValue,
      onTabChange = _ref2.onTabChange,
      firstEleRef = _ref2.firstEleRef,
      className = _ref2.className,
      _ref2$isDataGridForm = _ref2.isDataGridForm,
      isDataGridForm = _ref2$isDataGridForm === void 0 ? false : _ref2$isDataGridForm,
      _ref2$isTabView = _ref2.isTabView,
      isTabView = _ref2$isTabView === void 0 ? true : _ref2$isTabView,
      visible = _ref2.visible;
  var defaultTab = 'General';
  var tabs = {};
  var tabsClassname = {};

  var _useState3 = (0, _react.useState)(0),
      _useState4 = _slicedToArray(_useState3, 2),
      tabValue = _useState4[0],
      setTabValue = _useState4[1];

  var classes = useStyles();
  var firstElement = (0, _react.useRef)();
  var formRef = (0, _react.useRef)();
  var onScreenTracker = (0, _react.useRef)(false);
  var depListener = (0, _react.useContext)(_DepListener.DepListenerContext);
  var groupLabels = {};
  var schemaRef = (0, _react.useRef)(schema);
  var stateUtils = (0, _react.useContext)(_2.StateUtilsContext);
  var isOnScreen = (0, _custom_hooks.useOnScreen)(formRef);

  if (isOnScreen) {
    /* Don't do it when the form is alredy visible */
    if (onScreenTracker.current == false) {
      /* Re-select the tab. If form is hidden then sometimes it is not selected */
      setTabValue(tabValue);
      onScreenTracker.current = true;
    }
  } else {
    onScreenTracker.current = false;
  }

  (0, _react.useEffect)(function () {
    /* Calculate the fields which depends on the current field */
    if (!isDataGridForm) {
      schemaRef.current.fields.forEach(function (field) {
        /* Self change is also dep change */
        if (field.depChange || field.deferredDepChange) {
          depListener.addDepListener(accessPath.concat(field.id), accessPath.concat(field.id), field.depChange, field.deferredDepChange);
        }

        ((0, _utils.evalFunc)(null, field.deps) || []).forEach(function (dep) {
          var source = accessPath.concat(dep);

          if (_lodash["default"].isArray(dep)) {
            source = dep;
          }

          if (field.depChange) {
            depListener.addDepListener(source, accessPath.concat(field.id), field.depChange);
          }
        });
      });
      return function () {
        /* Cleanup the listeners when unmounting */
        depListener.removeDepListener(accessPath);
      };
    }
  }, []);
  /* Upon reset, set the tab to first */

  (0, _react.useEffect)(function () {
    setTabValue(0);
  }, [stateUtils.formResetKey]);
  var fullTabs = [];
  /* Prepare the array of components based on the types */

  schemaRef.current.fields.forEach(function (field) {
    var _getFieldMetaData = getFieldMetaData(field, schema, value, viewHelperProps),
        visible = _getFieldMetaData.visible,
        disabled = _getFieldMetaData.disabled,
        readonly = _getFieldMetaData.readonly,
        canAdd = _getFieldMetaData.canAdd,
        canEdit = _getFieldMetaData.canEdit,
        canDelete = _getFieldMetaData.canDelete,
        canAddRow = _getFieldMetaData.canAddRow,
        modeSupported = _getFieldMetaData.modeSupported;

    if (modeSupported) {
      var group = field.group,
          CustomControl = field.CustomControl;

      if (field.type === 'group') {
        groupLabels[field.id] = field.label;

        if (!visible) {
          schemaRef.current.filterGroups.push(field.label);
        }

        return;
      }

      group = groupLabels[group] || group || defaultTab;
      if (!tabs[group]) tabs[group] = [];
      /* Lets choose the path based on type */

      if (field.type === 'nested-tab') {
        /* Pass on the top schema */
        if (isNested) {
          field.schema.top = schemaRef.current.top;
        } else {
          field.schema.top = schema;
        }

        tabs[group].push( /*#__PURE__*/_react["default"].createElement(FormView, _extends({
          key: "nested".concat(tabs[group].length),
          value: value,
          viewHelperProps: viewHelperProps,
          schema: field.schema,
          accessPath: accessPath,
          dataDispatch: dataDispatch,
          isNested: true,
          isDataGridForm: isDataGridForm
        }, field, {
          visible: visible
        })));
      } else if (field.type === 'nested-fieldset') {
        /* Pass on the top schema */
        if (isNested) {
          field.schema.top = schemaRef.current.top;
        } else {
          field.schema.top = schema;
        }

        tabs[group].push( /*#__PURE__*/_react["default"].createElement(_FieldSetView["default"], _extends({
          key: "nested".concat(tabs[group].length),
          value: value,
          viewHelperProps: viewHelperProps,
          schema: field.schema,
          accessPath: accessPath,
          dataDispatch: dataDispatch,
          isNested: true,
          isDataGridForm: isDataGridForm,
          controlClassName: classes.controlRow
        }, field, {
          visible: visible
        })));
      } else if (field.type === 'collection') {
        /* If its a collection, let data grid view handle it */

        /* Pass on the top schema */
        if (isNested) {
          field.schema.top = schemaRef.current.top;
        } else {
          field.schema.top = schemaRef.current;
        }

        if (!_lodash["default"].isUndefined(field.fixedRows)) {
          canAdd = false;
          canDelete = false;
        }

        var props = _objectSpread(_objectSpread({
          key: field.id,
          value: value[field.id],
          viewHelperProps: viewHelperProps,
          schema: field.schema,
          accessPath: accessPath.concat(field.id),
          dataDispatch: dataDispatch,
          containerClassName: classes.controlRow
        }, field), {}, {
          canAdd: canAdd,
          canEdit: canEdit,
          canDelete: canDelete,
          visible: visible,
          canAddRow: canAddRow
        });

        if (CustomControl) {
          tabs[group].push( /*#__PURE__*/_react["default"].createElement(CustomControl, props));
        } else {
          tabs[group].push( /*#__PURE__*/_react["default"].createElement(_DataGridView["default"], props));
        }
      } else {
        /* Its a form control */
        var hasError = _lodash["default"].isEqual(accessPath.concat(field.id), stateUtils.formErr.name);
        /* When there is a change, the dependent values can change
         * lets pass the new changes to dependent and get the new values
         * from there as well.
         */


        if (field.isFullTab) {
          tabsClassname[group] = classes.fullSpace;
          fullTabs.push(group);
        }

        var id = field.id || "control".concat(tabs[group].length);
        tabs[group].push((0, _react.useMemo)(function () {
          return /*#__PURE__*/_react["default"].createElement(_MappedControl.MappedFormControl, _extends({
            inputRef: function inputRef(ele) {
              if (firstEleRef && !firstEleRef.current) {
                firstEleRef.current = ele;
              }
            },
            state: value,
            key: id,
            viewHelperProps: viewHelperProps,
            name: id,
            value: value[id]
          }, field, {
            id: id,
            readonly: readonly,
            disabled: disabled,
            visible: visible,
            onChange: function onChange(value) {
              /* Get the changes on dependent fields as well */
              dataDispatch({
                type: _2.SCHEMA_STATE_ACTIONS.SET_VALUE,
                path: accessPath.concat(id),
                value: value
              });
            },
            hasError: hasError,
            className: classes.controlRow,
            noLabel: field.isFullTab
          }));
        }, [value[id], readonly, disabled, visible, hasError, classes.controlRow].concat(_toConsumableArray(((0, _utils.evalFunc)(null, field.deps) || []).map(function (dep) {
          return value[dep];
        })))));
      }
    }
  });

  var finalTabs = _lodash["default"].pickBy(tabs, function (v, tabName) {
    return schemaRef.current.filterGroups.indexOf(tabName) <= -1;
  });
  /* Add the SQL tab if required */


  var sqlTabActive = false;
  var sqlTabName = (0, _gettext["default"])('SQL');

  if (hasSQLTab) {
    sqlTabActive = Object.keys(finalTabs).length === tabValue;
    /* Re-render and fetch the SQL tab when it is active */

    finalTabs[sqlTabName] = [(0, _react.useMemo)(function () {
      return /*#__PURE__*/_react["default"].createElement(SQLTab, {
        key: "sqltab",
        active: sqlTabActive,
        getSQLValue: getSQLValue
      });
    }, [sqlTabActive, value])];
    tabsClassname[sqlTabName] = classes.fullSpace;
    fullTabs.push(sqlTabName);
  }

  (0, _react.useEffect)(function () {
    firstElement.current && firstElement.current.focus();
  }, []);
  (0, _react.useEffect)(function () {
    onTabChange && onTabChange(tabValue, Object.keys(tabs)[tabValue], sqlTabActive);
  }, [tabValue]);
  /* check whether form is kept hidden by visible prop */

  if (!_lodash["default"].isUndefined(visible) && !visible) {
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null);
  }

  if (isTabView) {
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_core.Box, {
      height: "100%",
      display: "flex",
      flexDirection: "column",
      className: className,
      ref: formRef
    }, /*#__PURE__*/_react["default"].createElement(_core.Box, null, /*#__PURE__*/_react["default"].createElement(_core.Tabs, {
      value: tabValue,
      onChange: function onChange(event, selTabValue) {
        setTabValue(selTabValue);
      } // indicatorColor="primary"
      ,
      variant: "scrollable",
      scrollButtons: "auto",
      action: function action(ref) {
        return ref && ref.updateIndicator();
      }
    }, Object.keys(finalTabs).map(function (tabName) {
      return /*#__PURE__*/_react["default"].createElement(_core.Tab, {
        key: tabName,
        label: tabName
      });
    }))), Object.keys(finalTabs).map(function (tabName, i) {
      return /*#__PURE__*/_react["default"].createElement(_TabPanel["default"], {
        key: tabName,
        value: tabValue,
        index: i,
        classNameRoot: (0, _clsx["default"])(tabsClassname[tabName], isNested ? classes.nestedTabPanel : null),
        className: fullTabs.indexOf(tabName) == -1 ? classes.nestedControl : null
      }, finalTabs[tabName]);
    })));
  } else {
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_core.Box, {
      height: "100%",
      display: "flex",
      flexDirection: "column",
      className: className,
      ref: formRef
    }, Object.keys(finalTabs).map(function (tabName) {
      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, {
        key: tabName
      }, finalTabs[tabName]);
    })));
  }
}

FormView.propTypes = {
  value: _propTypes["default"].any,
  schema: _custom_prop_types["default"].schemaUI.isRequired,
  viewHelperProps: _propTypes["default"].object,
  isNested: _propTypes["default"].bool,
  isDataGridForm: _propTypes["default"].bool,
  isTabView: _propTypes["default"].bool,
  visible: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
  accessPath: _propTypes["default"].array.isRequired,
  dataDispatch: _propTypes["default"].func,
  hasSQLTab: _propTypes["default"].bool,
  getSQLValue: _propTypes["default"].func,
  onTabChange: _propTypes["default"].func,
  firstEleRef: _custom_prop_types["default"].ref,
  className: _custom_prop_types["default"].className
};

/***/ }),

/***/ 26850:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



__webpack_require__(82526);

__webpack_require__(19601);

__webpack_require__(69070);

__webpack_require__(57327);

__webpack_require__(38880);

__webpack_require__(89554);

__webpack_require__(54747);

__webpack_require__(49337);

__webpack_require__(33321);

__webpack_require__(41817);

__webpack_require__(41539);

__webpack_require__(32165);

__webpack_require__(78783);

__webpack_require__(66992);

__webpack_require__(33948);

__webpack_require__(4129);

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.MappedCellControl = exports.MappedFormControl = void 0;

__webpack_require__(68309);

__webpack_require__(47941);

__webpack_require__(82772);

var _react = _interopRequireWildcard(__webpack_require__(67294));

var _lodash = _interopRequireDefault(__webpack_require__(96486));

var _FormComponents = __webpack_require__(93299);

var _Privilege = _interopRequireDefault(__webpack_require__(19928));

var _utils = __webpack_require__(44092);

var _propTypes = _interopRequireDefault(__webpack_require__(45697));

var _custom_prop_types = _interopRequireDefault(__webpack_require__(41832));

var _SelectRefresh = __webpack_require__(3622);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

/* Control mapping for form view */
function MappedFormControlBase(_ref) {
  var type = _ref.type,
      value = _ref.value,
      id = _ref.id,
      onChange = _ref.onChange,
      className = _ref.className,
      visible = _ref.visible,
      inputRef = _ref.inputRef,
      noLabel = _ref.noLabel,
      props = _objectWithoutProperties(_ref, ["type", "value", "id", "onChange", "className", "visible", "inputRef", "noLabel"]);

  var name = id;
  var onTextChange = (0, _react.useCallback)(function (e) {
    var value = e;

    if (e && e.target) {
      value = e.target.value;
    }

    onChange && onChange(value);
  }, []);
  var onSqlChange = (0, _react.useCallback)(function (value) {
    onChange && onChange(value);
  }, []);

  if (!visible) {
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null);
  }
  /* The mapping uses Form* components as it comes with labels */


  switch (type) {
    case 'int':
      return /*#__PURE__*/_react["default"].createElement(_FormComponents.FormInputText, _extends({
        name: name,
        value: value,
        onChange: onTextChange,
        className: className,
        inputRef: inputRef
      }, props, {
        type: "int"
      }));

    case 'numeric':
      return /*#__PURE__*/_react["default"].createElement(_FormComponents.FormInputText, _extends({
        name: name,
        value: value,
        onChange: onTextChange,
        className: className,
        inputRef: inputRef
      }, props, {
        type: "numeric"
      }));

    case 'tel':
      return /*#__PURE__*/_react["default"].createElement(_FormComponents.FormInputText, _extends({
        name: name,
        value: value,
        onChange: onTextChange,
        className: className,
        inputRef: inputRef
      }, props, {
        type: "tel"
      }));

    case 'text':
      return /*#__PURE__*/_react["default"].createElement(_FormComponents.FormInputText, _extends({
        name: name,
        value: value,
        onChange: onTextChange,
        className: className,
        inputRef: inputRef
      }, props));

    case 'multiline':
      return /*#__PURE__*/_react["default"].createElement(_FormComponents.FormInputText, _extends({
        name: name,
        value: value,
        onChange: onTextChange,
        className: className,
        inputRef: inputRef,
        controlProps: {
          multiline: true
        }
      }, props));

    case 'password':
      return /*#__PURE__*/_react["default"].createElement(_FormComponents.FormInputText, _extends({
        name: name,
        value: value,
        onChange: onTextChange,
        className: className,
        type: "password",
        inputRef: inputRef
      }, props));

    case 'select':
      return /*#__PURE__*/_react["default"].createElement(_FormComponents.FormInputSelect, _extends({
        name: name,
        value: value,
        onChange: onTextChange,
        className: className,
        inputRef: inputRef
      }, props));

    case 'select-refresh':
      return /*#__PURE__*/_react["default"].createElement(_SelectRefresh.SelectRefresh, _extends({
        name: name,
        value: value,
        onChange: onTextChange,
        className: className
      }, props));

    case 'switch':
      return /*#__PURE__*/_react["default"].createElement(_FormComponents.FormInputSwitch, _extends({
        name: name,
        value: value,
        onChange: function onChange(e) {
          return onTextChange(e.target.checked, e.target.name);
        },
        className: className
      }, props));

    case 'checkbox':
      return /*#__PURE__*/_react["default"].createElement(_FormComponents.FormInputCheckbox, _extends({
        name: name,
        value: value,
        onChange: function onChange(e) {
          return onTextChange(e.target.checked, e.target.name);
        },
        className: className
      }, props));

    case 'toggle':
      return /*#__PURE__*/_react["default"].createElement(_FormComponents.FormInputToggle, _extends({
        name: name,
        value: value,
        onChange: onTextChange,
        className: className
      }, props));

    case 'color':
      return /*#__PURE__*/_react["default"].createElement(_FormComponents.FormInputColor, _extends({
        name: name,
        value: value,
        onChange: onTextChange,
        className: className
      }, props));

    case 'file':
      return /*#__PURE__*/_react["default"].createElement(_FormComponents.FormInputFileSelect, _extends({
        name: name,
        value: value,
        onChange: onTextChange,
        className: className
      }, props));

    case 'sql':
      return /*#__PURE__*/_react["default"].createElement(_FormComponents.FormInputSQL, _extends({
        name: name,
        value: value,
        onChange: onSqlChange,
        className: className,
        noLabel: noLabel
      }, props));

    case 'note':
      return /*#__PURE__*/_react["default"].createElement(_FormComponents.FormNote, _extends({
        className: className
      }, props));

    case 'datetimepicker':
      return /*#__PURE__*/_react["default"].createElement(_FormComponents.FormInputDateTimePicker, _extends({
        name: name,
        value: value,
        onChange: onTextChange,
        className: className
      }, props));

    default:
      return /*#__PURE__*/_react["default"].createElement(_FormComponents.PlainString, _extends({
        value: value
      }, props));
  }
}

MappedFormControlBase.propTypes = {
  type: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].func]).isRequired,
  value: _propTypes["default"].any,
  id: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]).isRequired,
  onChange: _propTypes["default"].func,
  className: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].object]),
  visible: _propTypes["default"].bool,
  inputRef: _custom_prop_types["default"].ref,
  noLabel: _propTypes["default"].bool
};
/* Control mapping for grid cell view */

function MappedCellControlBase(_ref2) {
  var cell = _ref2.cell,
      value = _ref2.value,
      id = _ref2.id,
      optionsLoaded = _ref2.optionsLoaded,
      onCellChange = _ref2.onCellChange,
      visible = _ref2.visible,
      reRenderRow = _ref2.reRenderRow,
      props = _objectWithoutProperties(_ref2, ["cell", "value", "id", "optionsLoaded", "onCellChange", "visible", "reRenderRow"]);

  var name = id;
  var onTextChange = (0, _react.useCallback)(function (e) {
    var value = e;

    if (e && e.target) {
      value = e.target.value;
    }

    onCellChange && onCellChange(value);
  }, []);
  /* Some grid cells are based on options selected in other cells.
   * lets trigger a re-render for the row if optionsLoaded
   */

  var optionsLoadedRerender = (0, _react.useCallback)(function (res) {
    /* optionsLoaded is called when select options are fetched */
    optionsLoaded && optionsLoaded(res);
    reRenderRow && reRenderRow();
  }, []);

  if (!visible) {
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null);
  }
  /* The mapping does not need Form* components as labels are not needed for grid cells */


  switch (cell) {
    case 'int':
      return /*#__PURE__*/_react["default"].createElement(_FormComponents.InputText, _extends({
        name: name,
        value: value,
        onChange: onTextChange
      }, props, {
        type: "int"
      }));

    case 'numeric':
      return /*#__PURE__*/_react["default"].createElement(_FormComponents.InputText, _extends({
        name: name,
        value: value,
        onChange: onTextChange
      }, props, {
        type: "numeric"
      }));

    case 'text':
      return /*#__PURE__*/_react["default"].createElement(_FormComponents.InputText, _extends({
        name: name,
        value: value,
        onChange: onTextChange
      }, props));

    case 'password':
      return /*#__PURE__*/_react["default"].createElement(_FormComponents.InputText, _extends({
        name: name,
        value: value,
        onChange: onTextChange
      }, props));

    case 'select':
      return /*#__PURE__*/_react["default"].createElement(_FormComponents.InputSelect, _extends({
        name: name,
        value: value,
        onChange: onTextChange,
        optionsLoaded: optionsLoadedRerender
      }, props));

    case 'switch':
      return /*#__PURE__*/_react["default"].createElement(_FormComponents.InputSwitch, _extends({
        name: name,
        value: value,
        onChange: function onChange(e) {
          return onTextChange(e.target.checked, e.target.name);
        }
      }, props));

    case 'checkbox':
      return /*#__PURE__*/_react["default"].createElement(_FormComponents.InputCheckbox, _extends({
        name: name,
        value: value,
        onChange: function onChange(e) {
          return onTextChange(e.target.checked, e.target.name);
        }
      }, props));

    case 'privilege':
      return /*#__PURE__*/_react["default"].createElement(_Privilege["default"], _extends({
        name: name,
        value: value,
        onChange: onTextChange
      }, props));

    case 'datetimepicker':
      return /*#__PURE__*/_react["default"].createElement(_FormComponents.InputDateTimePicker, _extends({
        name: name,
        value: value,
        onChange: onTextChange
      }, props));

    default:
      return /*#__PURE__*/_react["default"].createElement(_FormComponents.PlainString, _extends({
        value: value
      }, props));
  }
}

MappedCellControlBase.propTypes = {
  cell: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].func]).isRequired,
  value: _propTypes["default"].any,
  id: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]).isRequired,
  onChange: _propTypes["default"].func,
  reRenderRow: _propTypes["default"].func,
  optionsLoaded: _propTypes["default"].func,
  onCellChange: _propTypes["default"].func,
  visible: _propTypes["default"].bool
};
var ALLOWED_PROPS_FIELD_COMMON = ['mode', 'value', 'readonly', 'disabled', 'hasError', 'id', 'label', 'options', 'optionsLoaded', 'controlProps', 'schema', 'inputRef', 'visible', 'autoFocus', 'helpMessage', 'className', 'optionsReloadBasis'];
var ALLOWED_PROPS_FIELD_FORM = ['type', 'onChange', 'state', 'noLabel', 'text'];
var ALLOWED_PROPS_FIELD_CELL = ['cell', 'onCellChange', 'row', 'reRenderRow'];

var MappedFormControl = function MappedFormControl(props) {
  var newProps = _objectSpread({}, props);

  var typeProps = (0, _utils.evalFunc)(null, newProps.type, newProps.state);

  if (_typeof(typeProps) === 'object') {
    newProps = _objectSpread(_objectSpread({}, newProps), typeProps);
  } else {
    newProps.type = typeProps;
  }
  /* Filter out garbage props if any using ALLOWED_PROPS_FIELD */


  return /*#__PURE__*/_react["default"].createElement(MappedFormControlBase, _lodash["default"].pick(newProps, _lodash["default"].union(ALLOWED_PROPS_FIELD_COMMON, ALLOWED_PROPS_FIELD_FORM)));
};

exports.MappedFormControl = MappedFormControl;

var MappedCellControl = function MappedCellControl(props) {
  var newProps = _objectSpread({}, props);

  var cellProps = (0, _utils.evalFunc)(null, newProps.cell, newProps.row);

  if (_typeof(cellProps) === 'object') {
    newProps = _objectSpread(_objectSpread({}, newProps), cellProps);
  } else {
    newProps.cell = cellProps;
  }
  /* Filter out garbage props if any using ALLOWED_PROPS_FIELD */


  return /*#__PURE__*/_react["default"].createElement(MappedCellControlBase, _lodash["default"].pick(newProps, _lodash["default"].union(ALLOWED_PROPS_FIELD_COMMON, ALLOWED_PROPS_FIELD_CELL)));
};

exports.MappedCellControl = MappedCellControl;

/***/ }),

/***/ 89406:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



__webpack_require__(47941);

__webpack_require__(82526);

__webpack_require__(38880);

__webpack_require__(49337);

__webpack_require__(33321);

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.default = void 0;

__webpack_require__(41539);

__webpack_require__(66992);

__webpack_require__(33948);

__webpack_require__(57327);

__webpack_require__(82772);

__webpack_require__(23157);

__webpack_require__(89554);

__webpack_require__(54747);

__webpack_require__(69070);

var _lodash = _interopRequireDefault(__webpack_require__(96486));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

/* This is the base schema class for SchemaView.
 * A UI schema must inherit this to use SchemaView for UI.
 */
var BaseUISchema = /*#__PURE__*/function () {
  function BaseUISchema(defaults) {
    _classCallCheck(this, BaseUISchema);

    /* Pass the initial data to constructor so that
    they will set to defaults */
    this._defaults = defaults;
    this.keys = null; // If set, other fields except keys will be filtered

    this.filterGroups = []; // If set, these groups will be filtered out

    this.informText = null; // Inform text to show after save, this only saves it

    this._top = null;
  }
  /* Top schema is helpful if this is used as child */


  _createClass(BaseUISchema, [{
    key: "top",
    get: function get() {
      return this._top;
    }
    /* The original data before any changes */
    ,
    set: function set(val) {
      this._top = val;
    }
  }, {
    key: "origData",
    get: function get() {
      return this._origData || {};
    }
    /* The session data, can be useful but setting this will not affect UI
    this._sessData is set by SchemaView directly. set sessData should not be allowed anywhere */
    ,
    set: function set(val) {
      this._origData = val;
    }
  }, {
    key: "sessData",
    get: function get() {
      return this._sessData || {};
    },
    set: function set(val) {
      throw new Error('Property sessData is readonly.', val);
    }
    /* Property allows to restrict setting this later */

  }, {
    key: "defaults",
    get: function get() {
      return this._defaults || {};
    }
    /* ID key for the view state */

  }, {
    key: "idAttribute",
    get: function get() {
      return 'id';
    }
    /* Schema fields, to be defined by inherited UI schema. Override this */

  }, {
    key: "baseFields",
    get: function get() {
      throw new Error('Property method \'baseFields()\' must be implemented.');
    }
    /* Used by schema view component. Do not override this, it will
    concat base fields with extraFields.
    */

  }, {
    key: "fields",
    get: function get() {
      var _this = this;

      return this.baseFields.filter(function (field) {
        var retval;
        /* If any groups are to be filtered */

        retval = _this.filterGroups.indexOf(field.group) == -1;
        /* Select only keys, if specified */

        if (_this.keys) {
          retval = retval && _this.keys.indexOf(field.id) > -1;
        }

        return retval;
      });
    }
  }, {
    key: "initialise",
    value: function initialise() {
      /* Called when initial data loaded */
      return;
    }
    /* Check if current data is new or existing */

  }, {
    key: "isNew",
    value: function isNew(state) {
      if (_lodash["default"].isUndefined(state)) {
        state = this.origData;
      }

      if (_lodash["default"].has(state, this.idAttribute)) {
        return _lodash["default"].isUndefined(state[this.idAttribute]) || _lodash["default"].isNull(state[this.idAttribute]);
      }
      /* Nested collection rows may or may not have idAttribute.
      So to decide whether row is new or not set, the cid starts with
      nn (not new) for existing rows. Newly added will start with 'c' (created)
      */


      if (_lodash["default"].has(state, 'cid')) {
        return !state.cid.startsWith('nn');
      }

      return true;
    }
    /* Called by SchemaView to validate data, return true indicates invalid.
    validate will receive two params state and setError func
    Eg - setError('fieldname', 'Some error').
    And return true if invalid, otherwise false.
    */

  }, {
    key: "validate",
    value: function validate() {
      return false;
    }
    /* Returns the new data row for the schema based on defaults and input */

  }, {
    key: "getNewData",
    value: function getNewData() {
      var _this2 = this;

      var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var newRow = {};
      this.fields.forEach(function (field) {
        newRow[field.id] = _this2.defaults[field.id];
      });
      newRow = _objectSpread(_objectSpread({}, newRow), data);
      return newRow;
    }
    /* Used in header schema */

  }, {
    key: "addDisabled",
    value: function addDisabled() {
      return false;
    }
    /* Check if node in catalog */

  }, {
    key: "inCatalog",
    value: function inCatalog() {
      if (this.nodeInfo && 'catalog' in this.nodeInfo) {
        return true;
      }

      return false;
    }
    /* Get the server version */

  }, {
    key: "getServerVersion",
    value: function getServerVersion() {
      if (!_lodash["default"].isUndefined(this.nodeInfo) && !_lodash["default"].isUndefined(this.nodeInfo.server) && !_lodash["default"].isUndefined(this.nodeInfo.server.version)) {
        return this.nodeInfo.server.version;
      }
    }
  }]);

  return BaseUISchema;
}();

exports.default = BaseUISchema;

/***/ }),

/***/ 52237:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



__webpack_require__(82526);

__webpack_require__(38880);

__webpack_require__(49337);

__webpack_require__(33321);

__webpack_require__(47042);

__webpack_require__(91038);

__webpack_require__(78783);

__webpack_require__(41817);

__webpack_require__(32165);

__webpack_require__(79753);

__webpack_require__(19601);

__webpack_require__(4129);

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.default = SchemaView;
exports.SCHEMA_STATE_ACTIONS = exports.StateUtilsContext = void 0;

__webpack_require__(89554);

__webpack_require__(54747);

__webpack_require__(47941);

__webpack_require__(41539);

__webpack_require__(39714);

__webpack_require__(83710);

__webpack_require__(23157);

__webpack_require__(21249);

__webpack_require__(69826);

__webpack_require__(34553);

__webpack_require__(92222);

__webpack_require__(69600);

__webpack_require__(57327);

__webpack_require__(82772);

__webpack_require__(66992);

__webpack_require__(33948);

__webpack_require__(40561);

__webpack_require__(32564);

__webpack_require__(17727);

__webpack_require__(88674);

__webpack_require__(68309);

__webpack_require__(15306);

__webpack_require__(74916);

__webpack_require__(69070);

var _react = _interopRequireWildcard(__webpack_require__(67294));

var _core = __webpack_require__(65770);

var _ExpandMore = _interopRequireDefault(__webpack_require__(64566));

var _Save = _interopRequireDefault(__webpack_require__(53375));

var _Publish = _interopRequireDefault(__webpack_require__(95409));

var _Done = _interopRequireDefault(__webpack_require__(10637));

var _SettingsBackupRestore = _interopRequireDefault(__webpack_require__(19439));

var _Close = _interopRequireDefault(__webpack_require__(80366));

var _InfoRounded = _interopRequireDefault(__webpack_require__(36782));

var _HelpRounded = _interopRequireDefault(__webpack_require__(51159));

var _Edit = _interopRequireDefault(__webpack_require__(59067));

var _diffArraysOfObjects = _interopRequireDefault(__webpack_require__(31682));

var _lodash = _interopRequireDefault(__webpack_require__(96486));

var _FormComponents = __webpack_require__(93299);

var _Theme = _interopRequireDefault(__webpack_require__(4394));

var _Buttons = __webpack_require__(87451);

var _Loader = _interopRequireDefault(__webpack_require__(85650));

var _validators = __webpack_require__(76055);

var _MappedControl = __webpack_require__(26850);

var _gettext = _interopRequireDefault(__webpack_require__(91669));

var _base_schema = _interopRequireDefault(__webpack_require__(89406));

var _FormView = _interopRequireWildcard(__webpack_require__(75835));

var _propTypes = _interopRequireDefault(__webpack_require__(45697));

var _custom_prop_types = _interopRequireDefault(__webpack_require__(41832));

var _api_instance = __webpack_require__(2832);

var _DepListener = _interopRequireWildcard(__webpack_require__(64519));

var _FieldSetView = _interopRequireDefault(__webpack_require__(57674));

var _DataGridView = _interopRequireDefault(__webpack_require__(8593));

var _custom_hooks = __webpack_require__(50464);

var _Notifier = _interopRequireDefault(__webpack_require__(55958));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e2) { throw _e2; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e3) { didErr = true; err = _e3; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var useDialogStyles = (0, _core.makeStyles)(function (theme) {
  return {
    root: {
      display: 'flex',
      flexDirection: 'column',
      height: '100%'
    },
    form: {
      flexGrow: 1,
      position: 'relative',
      minHeight: 0,
      display: 'flex',
      flexDirection: 'column'
    },
    footer: _objectSpread({
      padding: theme.spacing(1),
      background: theme.otherVars.headerBg,
      display: 'flex',
      zIndex: 1010
    }, theme.mixins.panelBorder.top),
    mappedControl: {
      paddingBottom: theme.spacing(1)
    },
    buttonMargin: {
      marginRight: '0.5rem'
    }
  };
});

var StateUtilsContext = /*#__PURE__*/_react["default"].createContext();

exports.StateUtilsContext = StateUtilsContext;

function getForQueryParams(data) {
  var retData = _objectSpread({}, data);

  Object.keys(retData).forEach(function (key) {
    var value = retData[key];

    if (_lodash["default"].isObject(value)) {
      retData[key] = JSON.stringify(value);
    }
  });
  return retData;
}
/* Compare the sessData with schema.origData
schema.origData is set to incoming or default data
*/


function isValueEqual(val1, val2) {
  var attrDefined = !_lodash["default"].isUndefined(val1) && !_lodash["default"].isUndefined(val2) && !_lodash["default"].isNull(val1) && !_lodash["default"].isNull(val2);
  /* If the orig value was null and new one is empty string, then its a "no change" */

  /* If the orig value and new value are of different datatype but of same value(numeric) "no change" */

  /* If the orig value is undefined or null and new value is boolean false "no change" */

  if (_lodash["default"].isEqual(val1, val2) || (val1 === null || _lodash["default"].isUndefined(val1)) && val2 === '' || (val1 === null || _lodash["default"].isUndefined(val1)) && typeof val2 === 'boolean' && !val2 || (attrDefined ? _lodash["default"].isEqual(val1.toString(), val2.toString()) : false)) {
    return true;
  } else {
    return false;
  }
}

function getChangedData(topSchema, viewHelperProps, sessData) {
  var stringify = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
  var includeSkipChange = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : true;
  var changedData = {};
  var isEdit = viewHelperProps.mode === 'edit';
  /* Will be called recursively as data can be nested */

  var parseChanges = function parseChanges(schema, origVal, sessVal) {
    var levelChanges = {};
    parseChanges.depth = _lodash["default"].isUndefined(parseChanges.depth) ? 0 : parseChanges.depth + 1;
    /* The comparator and setter */

    var attrChanged = function attrChanged(id, change) {
      var force = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

      if (isValueEqual(_lodash["default"].get(origVal, id), _lodash["default"].get(sessVal, id)) && !force) {
        return;
      } else {
        change = change || _lodash["default"].get(sessVal, id);

        if (stringify && (_lodash["default"].isArray(change) || _lodash["default"].isObject(change))) {
          change = JSON.stringify(change);
        }
        /* Null values are not passed in URL params, pass it as an empty string
        Nested values does not need this */


        if (_lodash["default"].isNull(change) && parseChanges.depth === 0) {
          change = '';
        }

        return levelChanges[id] = change;
      }
    };

    schema.fields.forEach(function (field) {
      /* At this point the schema assignments like top may not have been done
      So, only check the mode by passing true to getFieldMetaData */
      var _getFieldMetaData = (0, _FormView.getFieldMetaData)(field, schema, {}, viewHelperProps, true),
          modeSupported = _getFieldMetaData.modeSupported;
      /* If skipChange is true, then field will not be considered for changed data,
      This is helpful when Save or Reset should not be enabled on this field change alone.
      No change in other behaviour */


      if (!modeSupported || field.skipChange && !includeSkipChange) {
        return;
      }

      if (typeof field.type == 'string' && field.type.startsWith('nested-')) {
        /* Even if its nested, state is on same hierarchical level.
        Find the changes and merge */
        levelChanges = _objectSpread(_objectSpread({}, levelChanges), parseChanges(field.schema, origVal, sessVal));
      } else {
        /* Check for changes only if its in edit mode, otherwise everything can go through comparator */
        if (isEdit && !_lodash["default"].isEqual(_lodash["default"].get(origVal, field.id), _lodash["default"].get(sessVal, field.id))) {
          var change = null;

          if (field.type === 'collection') {
            /* Use diffArray package to get the array diff and extract the info.
            cid is used to identify the rows uniquely */
            var changeDiff = (0, _diffArraysOfObjects["default"])(_lodash["default"].get(origVal, field.id) || [], _lodash["default"].get(sessVal, field.id) || [], 'cid');
            change = {};

            if (changeDiff.added.length > 0) {
              change['added'] = cleanCid(changeDiff.added, viewHelperProps.keepCid);
            }

            if (changeDiff.removed.length > 0) {
              change['deleted'] = cleanCid(changeDiff.removed.map(function (row) {
                /* Deleted records should be original, not the changed */
                return _lodash["default"].find(_lodash["default"].get(origVal, field.id), ['cid', row.cid]);
              }), viewHelperProps.keepCid);
            }

            if (changeDiff.updated.length > 0) {
              /* There is change in collection. Parse further to go deep */
              change['changed'] = [];

              var _iterator = _createForOfIteratorHelper(changeDiff.updated),
                  _step;

              try {
                var _loop = function _loop() {
                  var changedRow = _step.value;
                  var finalChangedRow = {};

                  var rowIndx = _lodash["default"].findIndex(_lodash["default"].get(sessVal, field.id), function (r) {
                    return r.cid == changedRow.cid;
                  });

                  finalChangedRow = parseChanges(field.schema, _lodash["default"].get(origVal, [field.id, rowIndx]), _lodash["default"].get(sessVal, [field.id, rowIndx]));
                  /* If the id attr value is present, then only changed keys can be passed.
                  Otherwise, passing all the keys is useful */

                  var idAttrValue = _lodash["default"].get(sessVal, [field.id, rowIndx, field.schema.idAttribute]);

                  if (_lodash["default"].isUndefined(idAttrValue)) {
                    change['changed'].push(_objectSpread(_objectSpread({}, changedRow), finalChangedRow));
                  } else {
                    change['changed'].push(_objectSpread(_defineProperty({}, field.schema.idAttribute, idAttrValue), finalChangedRow));
                  }
                };

                for (_iterator.s(); !(_step = _iterator.n()).done;) {
                  _loop();
                }
              } catch (err) {
                _iterator.e(err);
              } finally {
                _iterator.f();
              }

              change['changed'] = cleanCid(change['changed'], viewHelperProps.keepCid);
            }

            if (Object.keys(change).length > 0) {
              attrChanged(field.id, change, true);
            }
          } else {
            attrChanged(field.id);
          }
        } else if (!isEdit) {
          if (field.type === 'collection') {
            var _changeDiff = (0, _diffArraysOfObjects["default"])(_lodash["default"].get(origVal, field.id) || [], _lodash["default"].get(sessVal, field.id) || [], 'cid');
            /* For fixed rows, check only the updated changes */


            if (!_lodash["default"].isUndefined(field.fixedRows) && _changeDiff.updated.length > 0 || _lodash["default"].isUndefined(field.fixedRows) && (_changeDiff.added.length > 0 || _changeDiff.removed.length > 0 || _changeDiff.updated.length > 0)) {
              var _change = cleanCid(_lodash["default"].get(sessVal, field.id), viewHelperProps.keepCid);

              attrChanged(field.id, _change, true);
            }
          } else {
            attrChanged(field.id);
          }
        }
      }
    });
    parseChanges.depth--;
    return levelChanges;
  };

  changedData = parseChanges(topSchema, topSchema.origData, sessData);
  return changedData;
}

function validateSchema(schema, sessData, setError) {
  var accessPath = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : [];
  var collLabel = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : null;
  sessData = sessData || {};

  var _iterator2 = _createForOfIteratorHelper(schema.fields),
      _step2;

  try {
    var _loop2 = function _loop2() {
      var field = _step2.value;

      /* Skip id validation */
      if (schema.idAttribute == field.id) {
        return "continue";
      }
      /* If the field is has nested schema then validate the schema */


      if (field.schema && field.schema instanceof _base_schema["default"]) {
        /* A collection is an array */
        if (field.type === 'collection') {
          var rows = sessData[field.id] || [];
          var currPath = accessPath.concat(field.id);
          /* Validate duplicate rows */

          var dupInd = (0, _validators.checkUniqueCol)(rows, field.uniqueCol);

          if (dupInd > 0) {
            var uniqueColNames = _lodash["default"].filter(field.schema.fields, function (uf) {
              return field.uniqueCol.indexOf(uf.id) > -1;
            }).map(function (uf) {
              return uf.label;
            }).join(', ');

            if ((0, _validators.isEmptyString)(field.label)) {
              setError(currPath, (0, _gettext["default"])('%s must be unique.', uniqueColNames));
            } else {
              setError(currPath, (0, _gettext["default"])('%s in %s must be unique.', uniqueColNames, field.label));
            }

            return {
              v: true
            };
          }
          /* Loop through data */


          var _iterator3 = _createForOfIteratorHelper(rows.entries()),
              _step3;

          try {
            for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
              var _step3$value = _slicedToArray(_step3.value, 2),
                  rownum = _step3$value[0],
                  row = _step3$value[1];

              if (validateSchema(field.schema, row, setError, currPath.concat(rownum), field.label)) {
                return {
                  v: true
                };
              }
            }
          } catch (err) {
            _iterator3.e(err);
          } finally {
            _iterator3.f();
          }
        } else {
          /* A nested schema ? Recurse */
          if (validateSchema(field.schema, sessData, setError, accessPath)) {
            return {
              v: true
            };
          }
        }
      } else {
        /* Normal field, default validations */
        var value = sessData[field.id];
        var message = null;

        if (field.noEmpty) {
          var label = field.label;

          if (collLabel) {
            label = (0, _gettext["default"])('%s in %s', field.label, collLabel);
          }

          if (field.noEmptyLabel) {
            label = field.noEmptyLabel;
          }

          message = (0, _validators.emptyValidator)(label, value);
        }

        if (!message && (field.type == 'int' || field.type == 'numeric')) {
          message = (0, _validators.minMaxValidator)(field.label, value, field.min, field.max);
        }

        if (!message && field.type == 'int') {
          message = (0, _validators.integerValidator)(field.label, value);
        } else if (!message && field.type == 'numeric') {
          message = (0, _validators.numberValidator)(field.label, value);
        }

        if (message) {
          setError(accessPath.concat(field.id), message);
          return {
            v: true
          };
        }
      }
    };

    for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
      var _ret = _loop2();

      if (_ret === "continue") continue;
      if (_typeof(_ret) === "object") return _ret.v;
    }
  } catch (err) {
    _iterator2.e(err);
  } finally {
    _iterator2.f();
  }

  return schema.validate(sessData, function (id, message) {
    return setError(accessPath.concat(id), message);
  });
}

var SCHEMA_STATE_ACTIONS = {
  INIT: 'init',
  SET_VALUE: 'set_value',
  ADD_ROW: 'add_row',
  DELETE_ROW: 'delete_row',
  RERENDER: 'rerender',
  CLEAR_DEFERRED_QUEUE: 'clear_deferred_queue',
  DEFERRED_DEPCHANGE: 'deferred_depchange'
};
exports.SCHEMA_STATE_ACTIONS = SCHEMA_STATE_ACTIONS;

var getDepChange = function getDepChange(currPath, newState, oldState, action) {
  if (action.depChange) {
    newState = action.depChange(currPath, newState, {
      type: action.type,
      path: action.path,
      value: action.value,
      oldState: _lodash["default"].cloneDeep(oldState),
      listener: action.listener
    });
  }

  return newState;
};

var getDeferredDepChange = function getDeferredDepChange(currPath, newState, oldState, action) {
  if (action.deferredDepChange) {
    var deferredPromiseList = action.deferredDepChange(currPath, newState, {
      type: action.type,
      path: action.path,
      value: action.value,
      depChange: action.depChange,
      oldState: _lodash["default"].cloneDeep(oldState)
    });
    return deferredPromiseList;
  }
};
/* The main function which manipulates the session state based on actions */

/*
The state is managed based on path array of a particular key
For Eg. if the state is
{
  key1: {
    ckey1: [
      {a: 0, b: 0},
      {a: 1, b: 1}
    ]
  }
}
The path for b in first row will be [key1, ckey1, 0, b]
The path for second row of ckey1 will be [key1, ckey1, 1]
The path for key1 is [key1]
The state starts with path []
*/


var sessDataReducer = function sessDataReducer(state, action) {
  var data = _lodash["default"].cloneDeep(state);

  var rows, cid, deferredList;
  data.__deferred__ = data.__deferred__ || [];

  switch (action.type) {
    case SCHEMA_STATE_ACTIONS.INIT:
      data = action.payload;
      break;

    case SCHEMA_STATE_ACTIONS.SET_VALUE:
      _lodash["default"].set(data, action.path, action.value);
      /* If there is any dep listeners get the changes */


      data = getDepChange(action.path, data, state, action);
      deferredList = getDeferredDepChange(action.path, data, state, action);
      data.__deferred__ = deferredList || [];
      break;

    case SCHEMA_STATE_ACTIONS.ADD_ROW:
      /* Create id to identify a row uniquely, usefull when getting diff */
      cid = _lodash["default"].uniqueId('c');
      action.value['cid'] = cid;
      rows = (_lodash["default"].get(data, action.path) || []).concat(action.value);

      _lodash["default"].set(data, action.path, rows);
      /* If there is any dep listeners get the changes */


      data = getDepChange(action.path, data, state, action);
      break;

    case SCHEMA_STATE_ACTIONS.DELETE_ROW:
      rows = _lodash["default"].get(data, action.path) || [];
      rows.splice(action.value, 1);

      _lodash["default"].set(data, action.path, rows);
      /* If there is any dep listeners get the changes */


      data = getDepChange(action.path, data, state, action);
      break;

    case SCHEMA_STATE_ACTIONS.CLEAR_DEFERRED_QUEUE:
      data.__deferred__ = [];
      break;

    case SCHEMA_STATE_ACTIONS.DEFERRED_DEPCHANGE:
      data = getDepChange(action.path, data, state, action);
      break;
  }

  return data;
};
/* Remove cid key added by prepareData */


function cleanCid(coll) {
  var keepCid = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

  if (!coll || keepCid) {
    return coll;
  }

  return coll.map(function (o) {
    return _lodash["default"].pickBy(o, function (v, k) {
      return k != 'cid';
    });
  });
}

function prepareData(val) {
  var createMode = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

  if (_lodash["default"].isPlainObject(val)) {
    _lodash["default"].forIn(val, function (el) {
      if (_lodash["default"].isObject(el)) {
        prepareData(el, createMode);
      }
    });
  } else if (_lodash["default"].isArray(val)) {
    val.forEach(function (el) {
      if (_lodash["default"].isPlainObject(el)) {
        /* The each row in collection need to have an id to identify them uniquely
        This helps in easily getting what has changed */

        /* Nested collection rows may or may not have idAttribute.
        So to decide whether row is new or not set, the cid starts with
        nn (not new) for existing rows. Newly added will start with 'c' (created)
        */
        el['cid'] = createMode ? _lodash["default"].uniqueId('c') : _lodash["default"].uniqueId('nn');
        prepareData(el, createMode);
      }
    });
  }

  return val;
}
/* If its the dialog */


function SchemaDialogView(_ref) {
  var _sessData$__deferred_2;

  var getInitData = _ref.getInitData,
      viewHelperProps = _ref.viewHelperProps,
      _ref$schema = _ref.schema,
      schema = _ref$schema === void 0 ? {} : _ref$schema,
      _ref$showFooter = _ref.showFooter,
      showFooter = _ref$showFooter === void 0 ? true : _ref$showFooter,
      _ref$isTabView = _ref.isTabView,
      isTabView = _ref$isTabView === void 0 ? true : _ref$isTabView,
      props = _objectWithoutProperties(_ref, ["getInitData", "viewHelperProps", "schema", "showFooter", "isTabView"]);

  var classes = useDialogStyles();
  /* Some useful states */

  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      dirty = _useState2[0],
      setDirty = _useState2[1];
  /* formErr has 2 keys - name and message.
  Footer message will be displayed if message is set.
  */


  var _useState3 = (0, _react.useState)({}),
      _useState4 = _slicedToArray(_useState3, 2),
      formErr = _useState4[0],
      setFormErr = _useState4[1];

  var _useState5 = (0, _react.useState)(''),
      _useState6 = _slicedToArray(_useState5, 2),
      loaderText = _useState6[0],
      setLoaderText = _useState6[1];

  var _useState7 = (0, _react.useState)(false),
      _useState8 = _slicedToArray(_useState7, 2),
      saving = _useState8[0],
      setSaving = _useState8[1];

  var _useState9 = (0, _react.useState)(false),
      _useState10 = _slicedToArray(_useState9, 2),
      formReady = _useState10[0],
      setFormReady = _useState10[1];

  var _useState11 = (0, _react.useState)(0),
      _useState12 = _slicedToArray(_useState11, 2),
      formResetKey = _useState12[0],
      setFormResetKey = _useState12[1];

  var firstEleRef = (0, _react.useRef)();
  var isNew = schema.isNew(schema.origData);
  var checkIsMounted = (0, _custom_hooks.useIsMounted)();
  var depListenerObj = (0, _react.useRef)(new _DepListener["default"]());
  /* The session data */

  var _useReducer = (0, _react.useReducer)(sessDataReducer, {}),
      _useReducer2 = _slicedToArray(_useReducer, 2),
      sessData = _useReducer2[0],
      sessDispatch = _useReducer2[1];

  (0, _react.useEffect)(function () {
    /* if sessData changes, validate the schema */
    if (!formReady) return;
    /* Set the _sessData, can be usefull to some deep controls */

    schema._sessData = sessData;
    var isNotValid = validateSchema(schema, sessData, function (path, message) {
      if (message) {
        setFormErr({
          name: path,
          message: message
        });
      }
    });
    if (!isNotValid) setFormErr({});
    /* check if anything changed */

    var changedData = getChangedData(schema, viewHelperProps, sessData, false, false);
    var isDataChanged = Object.keys(changedData).length > 0;
    setDirty(isDataChanged);
    /* tell the callbacks the data has changed */

    props.onDataChange && props.onDataChange(isDataChanged, changedData);
  }, [sessData, formReady]);
  (0, _react.useEffect)(function () {
    var _sessData$__deferred_;

    if (((_sessData$__deferred_ = sessData.__deferred__) === null || _sessData$__deferred_ === void 0 ? void 0 : _sessData$__deferred_.length) > 0) {
      sessDispatch({
        type: SCHEMA_STATE_ACTIONS.CLEAR_DEFERRED_QUEUE
      });
      var item = sessData.__deferred__[0];
      item.promise.then(function (resFunc) {
        sessDispatch({
          type: SCHEMA_STATE_ACTIONS.DEFERRED_DEPCHANGE,
          path: item.action.path,
          depChange: item.action.depChange,
          listener: _objectSpread(_objectSpread({}, item.listener), {}, {
            callback: resFunc
          })
        });
      });
    }
  }, [(_sessData$__deferred_2 = sessData.__deferred__) === null || _sessData$__deferred_2 === void 0 ? void 0 : _sessData$__deferred_2.length]);
  (0, _react.useEffect)(function () {
    /* Docker on load focusses itself, so our focus should execute later */
    var focusTimeout = setTimeout(function () {
      firstEleRef.current && firstEleRef.current.focus();
    }, 250);
    /* Re-triggering focus on already focussed loses the focus */

    if (viewHelperProps.mode === 'edit') {
      setLoaderText('Loading...');
      /* If its an edit mode, get the initial data using getInitData
      getInitData should be a promise */

      if (!getInitData) {
        throw new Error('getInitData must be passed for edit');
      }

      getInitData && getInitData().then(function (data) {
        data = data || {};
        /* Set the origData to incoming data, useful for comparing and reset */

        schema.origData = prepareData(data || {});
        schema.initialise(schema.origData);
        sessDispatch({
          type: SCHEMA_STATE_ACTIONS.INIT,
          payload: schema.origData
        });
        setFormReady(true);
        setLoaderText('');
      })["catch"](function (err) {
        setLoaderText('');

        if (err.response && err.response.data && err.response.data.errormsg) {
          _Notifier["default"].alert((0, _gettext["default"])(err.response.statusText), (0, _gettext["default"])(err.response.data.errormsg));
        }
      });
    } else {
      /* Use the defaults as the initital data */
      schema.origData = prepareData(schema.defaults, true);
      schema.initialise(schema.origData);
      sessDispatch({
        type: SCHEMA_STATE_ACTIONS.INIT,
        payload: schema.origData
      });
      setFormReady(true);
      setLoaderText('');
    }
    /* Clear the focus timeout if unmounted */


    return function () {
      return clearTimeout(focusTimeout);
    };
  }, []);
  (0, _react.useEffect)(function () {
    /* If reset key changes, reset the form */
    sessDispatch({
      type: SCHEMA_STATE_ACTIONS.INIT,
      payload: schema.origData
    });
    return true;
  }, [props.resetKey]);

  var onResetClick = function onResetClick() {
    var resetIt = function resetIt() {
      firstEleRef.current && firstEleRef.current.focus();
      setFormResetKey(function (prev) {
        return prev + 1;
      });
      sessDispatch({
        type: SCHEMA_STATE_ACTIONS.INIT,
        payload: schema.origData
      });
      return true;
    };
    /* Confirm before reset */


    if (props.confirmOnCloseReset) {
      _Notifier["default"].confirm((0, _gettext["default"])('Warning'), (0, _gettext["default"])('Changes will be lost. Are you sure you want to reset?'), resetIt, function () {
        return true;
      });
    } else {
      resetIt();
    }
  };

  var onSaveClick = function onSaveClick() {
    setSaving(true);
    setLoaderText('Saving...');
    /* Get the changed data */

    var changeData = getChangedData(schema, viewHelperProps, sessData);
    /* Add the id when in edit mode */

    if (viewHelperProps.mode !== 'edit') {
      /* If new then merge the changed data with origData */
      changeData = _lodash["default"].assign({}, schema.origData, changeData);
    } else {
      changeData[schema.idAttribute] = schema.origData[schema.idAttribute];
    }

    if (schema.warningText) {
      _Notifier["default"].confirm((0, _gettext["default"])('Warning'), schema.warningText, function () {
        save(changeData);
      }, function () {
        setSaving(false);
        setLoaderText('');
        return true;
      });
    } else {
      save(changeData);
    }
  };

  var save = function save(changeData) {
    props.onSave(isNew, changeData).then(function () {
      if (schema.informText) {
        _Notifier["default"].alert((0, _gettext["default"])('Warning'), schema.informText);
      }
    })["catch"](function (err) {
      console.error(err);
      setFormErr({
        name: 'apierror',
        message: (0, _api_instance.parseApiError)(err)
      });
    })["finally"](function () {
      if (checkIsMounted()) {
        setSaving(false);
        setLoaderText('');
      }
    });
  };

  var onErrClose = (0, _react.useCallback)(function () {
    /* Unset the error message, but not the name */
    setFormErr(function (prev) {
      return _objectSpread(_objectSpread({}, prev), {}, {
        message: ''
      });
    });
  });

  var getSQLValue = function getSQLValue() {
    /* Called when SQL tab is active */
    if (dirty) {
      if (!formErr.name) {
        var changeData = getChangedData(schema, viewHelperProps, sessData);

        if (viewHelperProps.mode !== 'edit') {
          /* If new then merge the changed data with origData */
          changeData = _lodash["default"].assign({}, schema.origData, changeData);
        } else {
          changeData[schema.idAttribute] = schema.origData[schema.idAttribute];
        }
        /* Call the passed incoming getSQLValue func to get the SQL
        return of getSQLValue should be a promise.
        */


        return props.getSQLValue(isNew, getForQueryParams(changeData));
      } else {
        return Promise.resolve('-- ' + (0, _gettext["default"])('Definition incomplete.'));
      }
    } else {
      return Promise.resolve('-- ' + (0, _gettext["default"])('No updates.'));
    }
  };

  var sessDispatchWithListener = function sessDispatchWithListener(action) {
    sessDispatch(_objectSpread(_objectSpread({}, action), {}, {
      depChange: function depChange() {
        var _depListenerObj$curre;

        return (_depListenerObj$curre = depListenerObj.current).getDepChange.apply(_depListenerObj$curre, arguments);
      },
      deferredDepChange: function deferredDepChange() {
        var _depListenerObj$curre2;

        return (_depListenerObj$curre2 = depListenerObj.current).getDeferredDepChange.apply(_depListenerObj$curre2, arguments);
      }
    }));
  };

  var stateUtils = (0, _react.useMemo)(function () {
    return {
      dataDispatch: sessDispatchWithListener,
      initOrigData: function initOrigData(path, value) {
        if (path) {
          var data = prepareData(value);

          _lodash["default"].set(schema.origData, path, data);

          sessDispatchWithListener({
            type: SCHEMA_STATE_ACTIONS.SET_VALUE,
            path: path,
            value: data
          });
        }
      },
      formResetKey: formResetKey,
      formErr: formErr
    };
  }, [formResetKey, formErr]);

  var getButtonIcon = function getButtonIcon() {
    if (props.customSaveBtnIconType == 'upload') {
      return /*#__PURE__*/_react["default"].createElement(_Publish["default"], null);
    } else if (props.customSaveBtnIconType == 'done') {
      return /*#__PURE__*/_react["default"].createElement(_Done["default"], null);
    }

    return /*#__PURE__*/_react["default"].createElement(_Save["default"], null);
  };

  var ButtonIcon = getButtonIcon();
  /* I am Groot */

  return /*#__PURE__*/_react["default"].createElement(StateUtilsContext.Provider, {
    value: stateUtils
  }, /*#__PURE__*/_react["default"].createElement(_DepListener.DepListenerContext.Provider, {
    value: depListenerObj.current
  }, /*#__PURE__*/_react["default"].createElement(_core.Box, {
    className: classes.root
  }, /*#__PURE__*/_react["default"].createElement(_core.Box, {
    className: classes.form
  }, /*#__PURE__*/_react["default"].createElement(_Loader["default"], {
    message: loaderText
  }), /*#__PURE__*/_react["default"].createElement(_FormView["default"], {
    value: sessData,
    viewHelperProps: viewHelperProps,
    schema: schema,
    accessPath: [],
    dataDispatch: sessDispatchWithListener,
    hasSQLTab: props.hasSQL,
    getSQLValue: getSQLValue,
    firstEleRef: firstEleRef,
    isTabView: isTabView
  }), /*#__PURE__*/_react["default"].createElement(_FormComponents.FormFooterMessage, {
    type: _FormComponents.MESSAGE_TYPE.ERROR,
    message: formErr.message,
    onClose: onErrClose
  })), showFooter && /*#__PURE__*/_react["default"].createElement(_core.Box, {
    className: classes.footer
  }, (0, _react.useMemo)(function () {
    return /*#__PURE__*/_react["default"].createElement(_core.Box, null, /*#__PURE__*/_react["default"].createElement(_Buttons.PgIconButton, {
      "data-test": "sql-help",
      onClick: function onClick() {
        return props.onHelp(true, isNew);
      },
      icon: /*#__PURE__*/_react["default"].createElement(_InfoRounded["default"], null),
      disabled: props.disableSqlHelp,
      className: classes.buttonMargin,
      title: "SQL help for this object type."
    }), /*#__PURE__*/_react["default"].createElement(_Buttons.PgIconButton, {
      "data-test": "dialog-help",
      onClick: function onClick() {
        return props.onHelp(false, isNew);
      },
      icon: /*#__PURE__*/_react["default"].createElement(_HelpRounded["default"], null),
      title: "Help for this dialog.",
      disabled: props.disableDialogHelp
    }));
  }, []), /*#__PURE__*/_react["default"].createElement(_core.Box, {
    marginLeft: "auto"
  }, /*#__PURE__*/_react["default"].createElement(_Buttons.DefaultButton, {
    "data-test": "Close",
    onClick: props.onClose,
    startIcon: /*#__PURE__*/_react["default"].createElement(_Close["default"], null),
    className: classes.buttonMargin
  }, (0, _gettext["default"])('Close')), /*#__PURE__*/_react["default"].createElement(_Buttons.DefaultButton, {
    "data-test": "Reset",
    onClick: onResetClick,
    startIcon: /*#__PURE__*/_react["default"].createElement(_SettingsBackupRestore["default"], null),
    disabled: !dirty || saving,
    className: classes.buttonMargin
  }, (0, _gettext["default"])('Reset')), /*#__PURE__*/_react["default"].createElement(_Buttons.PrimaryButton, {
    "data-test": "Save",
    onClick: onSaveClick,
    startIcon: ButtonIcon,
    disabled: !(viewHelperProps.mode === 'edit' ? dirty : true) || saving || Boolean(formErr.name) || !formReady
  }, props.customSaveBtnName ? (0, _gettext["default"])(props.customSaveBtnName) : (0, _gettext["default"])('Save')))))));
}

SchemaDialogView.propTypes = {
  getInitData: _propTypes["default"].func,
  viewHelperProps: _propTypes["default"].shape({
    mode: _propTypes["default"].string.isRequired,
    serverInfo: _propTypes["default"].shape({
      type: _propTypes["default"].string,
      version: _propTypes["default"].number
    }),
    inCatalog: _propTypes["default"].bool
  }).isRequired,
  schema: _custom_prop_types["default"].schemaUI,
  onSave: _propTypes["default"].func,
  onClose: _propTypes["default"].func,
  onHelp: _propTypes["default"].func,
  onDataChange: _propTypes["default"].func,
  confirmOnCloseReset: _propTypes["default"].bool,
  isTabView: _propTypes["default"].bool,
  hasSQL: _propTypes["default"].bool,
  getSQLValue: _propTypes["default"].func,
  disableSqlHelp: _propTypes["default"].bool,
  disableDialogHelp: _propTypes["default"].bool,
  showFooter: _propTypes["default"].bool,
  resetKey: _propTypes["default"].any,
  customSaveBtnName: _propTypes["default"].string,
  customSaveBtnIconType: _propTypes["default"].string
};
var usePropsStyles = (0, _core.makeStyles)(function (theme) {
  return {
    root: {
      height: '100%',
      minHeight: 0,
      display: 'flex',
      flexDirection: 'column'
    },
    controlRow: {
      marginBottom: theme.spacing(1)
    },
    form: {
      padding: theme.spacing(1),
      overflow: 'auto',
      flexGrow: 1
    },
    toolbar: _objectSpread({
      padding: theme.spacing(0.5),
      background: theme.palette.background["default"]
    }, theme.mixins.panelBorder.bottom),
    buttonMargin: {
      marginRight: '0.5rem'
    },
    noPadding: {
      padding: 0
    }
  };
});
/* If its the properties tab */

function SchemaPropertiesView(_ref2) {
  var getInitData = _ref2.getInitData,
      viewHelperProps = _ref2.viewHelperProps,
      _ref2$schema = _ref2.schema,
      schema = _ref2$schema === void 0 ? {} : _ref2$schema,
      props = _objectWithoutProperties(_ref2, ["getInitData", "viewHelperProps", "schema"]);

  var classes = usePropsStyles();
  var defaultTab = 'General';
  var tabs = {};
  var tabsClassname = {};
  var groupLabels = {};

  var _useState13 = (0, _react.useState)({}),
      _useState14 = _slicedToArray(_useState13, 2),
      origData = _useState14[0],
      setOrigData = _useState14[1];

  var _useState15 = (0, _react.useState)(''),
      _useState16 = _slicedToArray(_useState15, 2),
      loaderText = _useState16[0],
      setLoaderText = _useState16[1];

  var checkIsMounted = (0, _custom_hooks.useIsMounted)();
  (0, _react.useEffect)(function () {
    setLoaderText('Loading...');
    getInitData().then(function (data) {
      data = data || {};
      schema.initialise(data);

      if (checkIsMounted()) {
        setOrigData(data || {});
        setLoaderText('');
      }
    })["catch"](function (err) {
      setLoaderText('');

      if (err.response && err.response.data && err.response.data.errormsg) {
        _Notifier["default"].alert((0, _gettext["default"])(err.response.statusText), (0, _gettext["default"])(err.response.data.errormsg));
      }
    });
  }, [getInitData]);
  var fullTabs = [];
  /* A simple loop to get all the controls for the fields */

  schema.fields.forEach(function (field) {
    var group = field.group;

    var _getFieldMetaData2 = (0, _FormView.getFieldMetaData)(field, schema, origData, viewHelperProps),
        visible = _getFieldMetaData2.visible,
        disabled = _getFieldMetaData2.disabled,
        readonly = _getFieldMetaData2.readonly,
        modeSupported = _getFieldMetaData2.modeSupported;

    group = group || defaultTab;

    if (field.isFullTab) {
      tabsClassname[group] = classes.noPadding;
      fullTabs.push(group);
    }

    readonly = true;

    if (modeSupported) {
      group = groupLabels[group] || group || defaultTab;

      if (field.helpMessageMode && field.helpMessageMode.indexOf(viewHelperProps.mode) == -1) {
        field.helpMessage = '';
      }

      if (!tabs[group]) tabs[group] = [];

      if (field && field.type === 'nested-fieldset') {
        tabs[group].push( /*#__PURE__*/_react["default"].createElement(_FieldSetView["default"], _extends({
          key: "nested".concat(tabs[group].length),
          value: origData,
          viewHelperProps: viewHelperProps,
          schema: field.schema,
          accessPath: [],
          controlClassName: classes.controlRow
        }, field, {
          visible: visible
        })));
      } else if (field.type === 'collection') {
        tabs[group].push( /*#__PURE__*/_react["default"].createElement(_DataGridView["default"], {
          key: field.id,
          viewHelperProps: viewHelperProps,
          name: field.id,
          value: origData[field.id],
          schema: field.schema,
          accessPath: [field.id],
          formErr: {},
          containerClassName: classes.controlRow,
          canAdd: false,
          canEdit: false,
          canDelete: false,
          visible: visible
        }));
      } else if (field.type === 'group') {
        groupLabels[field.id] = field.label;

        if (!visible) {
          schema.filterGroups.push(field.label);
        }
      } else {
        tabs[group].push( /*#__PURE__*/_react["default"].createElement(_MappedControl.MappedFormControl, _extends({
          key: field.id,
          viewHelperProps: viewHelperProps,
          state: origData,
          name: field.id,
          value: origData[field.id]
        }, field, {
          readonly: readonly,
          disabled: disabled,
          visible: visible,
          className: field.isFullTab ? null : classes.controlRow,
          noLabel: field.isFullTab
        })));
      }
    }
  });

  var finalTabs = _lodash["default"].pickBy(tabs, function (v, tabName) {
    return schema.filterGroups.indexOf(tabName) <= -1;
  });

  return /*#__PURE__*/_react["default"].createElement(_core.Box, {
    className: classes.root
  }, /*#__PURE__*/_react["default"].createElement(_Loader["default"], {
    message: loaderText
  }), /*#__PURE__*/_react["default"].createElement(_core.Box, {
    className: classes.toolbar
  }, /*#__PURE__*/_react["default"].createElement(_Buttons.PgIconButton, {
    "data-test": "help",
    onClick: function onClick() {
      return props.onHelp(true, false);
    },
    icon: /*#__PURE__*/_react["default"].createElement(_InfoRounded["default"], null),
    disabled: props.disableSqlHelp,
    title: "SQL help for this object type.",
    className: classes.buttonMargin
  }), /*#__PURE__*/_react["default"].createElement(_Buttons.PgIconButton, {
    "data-test": "edit",
    onClick: props.onEdit,
    icon: /*#__PURE__*/_react["default"].createElement(_Edit["default"], null),
    title: "Edit the object"
  })), /*#__PURE__*/_react["default"].createElement(_core.Box, {
    className: classes.form
  }, /*#__PURE__*/_react["default"].createElement(_core.Box, null, Object.keys(finalTabs).map(function (tabName) {
    var id = tabName.replace(' ', '');
    return /*#__PURE__*/_react["default"].createElement(_core.Accordion, {
      key: id
    }, /*#__PURE__*/_react["default"].createElement(_core.AccordionSummary, {
      expandIcon: /*#__PURE__*/_react["default"].createElement(_ExpandMore["default"], null),
      "aria-controls": "".concat(id, "-content"),
      id: "".concat(id, "-header")
    }, tabName), /*#__PURE__*/_react["default"].createElement(_core.AccordionDetails, {
      className: tabsClassname[tabName]
    }, /*#__PURE__*/_react["default"].createElement(_core.Box, {
      style: {
        width: '100%'
      }
    }, finalTabs[tabName])));
  }))));
}

SchemaPropertiesView.propTypes = {
  getInitData: _propTypes["default"].func.isRequired,
  viewHelperProps: _propTypes["default"].shape({
    mode: _propTypes["default"].string.isRequired,
    serverInfo: _propTypes["default"].shape({
      type: _propTypes["default"].string,
      version: _propTypes["default"].number
    }),
    inCatalog: _propTypes["default"].bool
  }).isRequired,
  schema: _custom_prop_types["default"].schemaUI,
  onHelp: _propTypes["default"].func,
  disableSqlHelp: _propTypes["default"].bool,
  onEdit: _propTypes["default"].func
};

function SchemaView(_ref3) {
  var formType = _ref3.formType,
      props = _objectWithoutProperties(_ref3, ["formType"]);

  /* Switch the view based on formType */
  if (formType === 'tab') {
    return /*#__PURE__*/_react["default"].createElement(_Theme["default"], null, /*#__PURE__*/_react["default"].createElement(SchemaPropertiesView, props));
  }

  return /*#__PURE__*/_react["default"].createElement(_Theme["default"], null, /*#__PURE__*/_react["default"].createElement(SchemaDialogView, props));
}

SchemaView.propTypes = {
  formType: _propTypes["default"].oneOf(['tab', 'dialog'])
};

/***/ }),

/***/ 24912:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



__webpack_require__(69070);

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.default = _default;

var _styles = __webpack_require__(30398);

var _colorManipulator = __webpack_require__(59114);

/////////////////////////////////////////////////////////////
//
// pgAdmin 4 - PostgreSQL Tools
//
// Copyright (C) 2013 - 2022, The pgAdmin Development Team
// This software is released under the PostgreSQL Licence
//
//////////////////////////////////////////////////////////////

/* The dark theme */
function _default(basicSettings) {
  return (0, _styles.createMuiTheme)(basicSettings, {
    palette: {
      "default": {
        main: '#6b6b6b',
        contrastText: '#fff',
        borderColor: '#2e2e2e',
        disabledBorderColor: '#2e2e2e',
        disabledContrastText: '#fff',
        hoverMain: '#303030',
        hoverContrastText: '#fff',
        hoverBorderColor: '#2e2e2e'
      },
      primary: {
        main: '#234d6e',
        light: '#323E43',
        contrastText: '#fff',
        hoverMain: (0, _colorManipulator.darken)('#234d6e', 0.25),
        hoverBorderColor: (0, _colorManipulator.darken)('#234d6e', 0.25),
        disabledMain: '#234d6e'
      },
      success: {
        main: '#26852B',
        light: '#2B472C',
        contrastText: '#000'
      },
      error: {
        main: '#da6758',
        light: '#212121',
        contrastText: '#fff',
        lighter: '#212121'
      },
      warning: {
        main: '#eea236',
        light: '#b18d5a',
        contrastText: '#fff'
      },
      info: {
        main: '#fde74c'
      },
      grey: {
        '200': '#424242',
        '400': '#303030',
        '600': '#2e2e2e',
        '800': '#212121'
      },
      text: {
        primary: '#d4d4d4',
        muted: '#8A8A8A'
      },
      checkbox: {
        disabled: '#6b6b6b'
      },
      background: {
        paper: '#212121',
        "default": '#212121'
      }
    },
    custom: {
      icon: {
        main: '#6b6b6b',
        contrastText: '#fff',
        borderColor: '#2e2e2e',
        disabledMain: '#6b6b6b',
        disabledContrastText: '#fff',
        disabledBorderColor: '#2e2e2e',
        hoverMain: '#303030',
        hoverContrastText: '#fff'
      }
    },
    otherVars: {
      borderColor: '#4a4a4a',
      inputBorderColor: '#6b6b6b',
      inputDisabledBg: 'inherit',
      headerBg: '#424242',
      activeColor: '#d4d4d4',
      tableBg: '#424242',
      activeStepBg: '#234d6e',
      activeStepFg: '#FFFFFF',
      stepBg: '#FFFFFF',
      stepFg: '#000',
      toggleBtnBg: '#000'
    }
  });
}

/***/ }),

/***/ 89592:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



__webpack_require__(69070);

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.default = _default;

var _styles = __webpack_require__(30398);

/////////////////////////////////////////////////////////////
//
// pgAdmin 4 - PostgreSQL Tools
//
// Copyright (C) 2013 - 2022, The pgAdmin Development Team
// This software is released under the PostgreSQL Licence
//
//////////////////////////////////////////////////////////////

/* The dark theme */
function _default(basicSettings) {
  return (0, _styles.createMuiTheme)(basicSettings, {
    palette: {
      "default": {
        main: 'transparent',
        contrastText: '#84d6ff',
        borderColor: '#84d6ff',
        disabledBorderColor: '#8B9CAD',
        disabledContrastText: '#8B9CAD',
        hoverMain: 'transparent',
        hoverContrastText: '#fff',
        hoverBorderColor: '#fff'
      },
      primary: {
        main: '#84D6FF',
        light: '#84D6FF',
        contrastText: '#010B15',
        hoverMain: '#fff',
        hoverBorderColor: '#fff',
        disabledMain: '#8B9CAD'
      },
      success: {
        main: '#45D48A',
        light: '#010B15',
        contrastText: '#000'
      },
      error: {
        main: '#EE7A55',
        light: '#EE7A55',
        contrastText: '#010B15'
      },
      warning: {
        main: '#F4D35E',
        light: '#F4D35E',
        contrastText: '#010B15'
      },
      info: {
        main: '#fde74c'
      },
      grey: {
        '200': '#8B9CAD',
        '400': '#2D3A48',
        '600': '#1F2932',
        '800': '#010B15'
      },
      text: {
        primary: '#fff',
        muted: '#8b9cac'
      },
      checkbox: {
        disabled: '#6b6b6b'
      },
      background: {
        paper: '#010B15',
        "default": '#010B15'
      }
    },
    custom: {
      icon: {
        main: '#010B15',
        contrastText: '#fff',
        borderColor: '#fff',
        disabledMain: '#1F2932',
        disabledContrastText: '#8B9CAD',
        disabledBorderColor: '#8B9CAD',
        hoverMain: '#fff',
        hoverContrastText: '#010B15'
      }
    },
    otherVars: {
      borderColor: '#4a4a4a',
      inputBorderColor: '#6b6b6b',
      inputDisabledBg: '#1F2932',
      headerBg: '#010B15',
      activeColor: '#d4d4d4',
      tableBg: '#010B15',
      activeStepBg: '#84D6FF',
      activeStepFg: '#010b15',
      stepBg: '#FFFFFF',
      stepFg: '#000',
      toggleBtnBg: '#6B6B6B'
    }
  });
}

/***/ }),

/***/ 4394:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

__webpack_require__(47941);

__webpack_require__(82526);

__webpack_require__(57327);

__webpack_require__(38880);

__webpack_require__(89554);

__webpack_require__(54747);

__webpack_require__(49337);

__webpack_require__(33321);

__webpack_require__(4129);

__webpack_require__(41539);

__webpack_require__(78783);

__webpack_require__(66992);

__webpack_require__(33948);

__webpack_require__(41817);

__webpack_require__(32165);

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.default = Theme;
exports.commonTableStyles = void 0;

__webpack_require__(69070);

var _react = _interopRequireWildcard(__webpack_require__(67294));

var _styles = __webpack_require__(30398);

var _custom_prop_types = _interopRequireDefault(__webpack_require__(41832));

var _standard = _interopRequireDefault(__webpack_require__(84272));

var _dark = _interopRequireDefault(__webpack_require__(24912));

var _high_contrast = _interopRequireDefault(__webpack_require__(89592));

var _root;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/* Common settings across all themes */
var basicSettings = (0, _styles.createMuiTheme)();
basicSettings = (0, _styles.createMuiTheme)(basicSettings, {
  typography: {
    fontSize: 14,
    htmlFontSize: 14
  },
  shape: {
    borderRadius: 4
  },
  palette: {
    action: {
      disabledOpacity: 0.32
    }
  },
  overrides: {
    MuiTabs: {
      root: {
        minHeight: 0
      }
    },
    PrivateTabIndicator: {
      root: {
        height: '3px',
        transition: basicSettings.transitions.create(['all'], {
          duration: '150ms'
        })
      }
    },
    MuiTab: {
      root: (_root = {
        textTransform: 'none',
        minHeight: 0,
        padding: '3px 10px'
      }, _defineProperty(_root, basicSettings.breakpoints.up('xs'), {
        minWidth: 0
      }), _defineProperty(_root, basicSettings.breakpoints.up('sm'), {
        minWidth: 0
      }), _defineProperty(_root, basicSettings.breakpoints.up('md'), {
        minWidth: 0
      }), _defineProperty(_root, basicSettings.breakpoints.up('lg'), {
        minWidth: 0
      }), _root),
      textColorInherit: {
        textTransform: 'none',
        opacity: 1
      }
    },
    MuiButton: {
      root: {
        textTransform: 'none,',
        padding: basicSettings.spacing(0.5, 1.5),
        '&.Mui-disabled': {
          opacity: 0.65
        },
        '&.MuiButton-outlinedSizeSmall': {
          height: '28px',
          fontSize: '0.875rem',
          '& .MuiSvgIcon-root': {
            height: '0.8em'
          }
        }
      },
      contained: {
        boxShadow: 'none',
        '&:hover': {
          boxShadow: 'none'
        }
      },
      outlined: {
        padding: basicSettings.spacing(0.375, 1)
      },
      startIcon: {
        marginRight: basicSettings.spacing(0.5)
      }
    },
    MuiOutlinedInput: {
      multiline: {
        padding: '0px'
      },
      input: {
        padding: basicSettings.spacing(0.75, 1.5),
        borderRadius: 'inherit'
      },
      inputMultiline: {
        padding: basicSettings.spacing(0.75, 1.5),
        resize: 'vertical'
      },
      adornedEnd: {
        paddingRight: basicSettings.spacing(1.5)
      }
    },
    MuiAccordion: {
      root: {
        boxShadow: 'none'
      }
    },
    MuiAccordionSummary: {
      root: {
        minHeight: 0,
        '&.Mui-expanded': {
          minHeight: 0
        },
        padding: basicSettings.spacing(0, 1),
        fontWeight: basicSettings.typography.fontWeightBold
      },
      content: {
        margin: basicSettings.spacing(1),
        '&.Mui-expanded': {
          margin: basicSettings.spacing(1)
        }
      },
      expandIcon: {
        order: -1
      }
    },
    MuiAccordionDetails: {
      root: {
        padding: basicSettings.spacing(1)
      }
    },
    MuiFormControlLabel: {
      root: {
        marginBottom: 0,
        marginLeft: 0,
        marginRight: 0
      }
    },
    MuiFormHelperText: {
      root: {
        fontSize: '1em'
      },
      contained: {
        marginLeft: 0,
        marginRight: 0
      }
    },
    MuiTypography: {
      body1: {
        fontSize: '1em'
      }
    },
    MuiDialog: {
      paper: {
        margin: 0
      }
    },
    MuiTooltip: {
      popper: {
        top: 0,
        zIndex: 9999
      }
    },
    MuiMenu: {
      list: {
        padding: '0'
      }
    },
    MuiMenuItem: {
      root: {
        fontSize: 14
      }
    }
  },
  transitions: {
    create: function create() {
      return 'none';
    }
  },
  zIndex: {
    modal: 2000
  },
  props: {
    MuiTextField: {
      variant: 'outlined'
    },
    MuiButton: {
      disableTouchRipple: true
    },
    MuiIconButton: {
      size: 'small',
      disableTouchRipple: true
    },
    MuiAccordion: {
      defaultExpanded: true
    },
    MuiTab: {
      textColor: 'inherit'
    },
    MuiCheckbox: {
      disableTouchRipple: true
    },
    MuiDialogTitle: {
      disableTypography: true
    },
    MuiCardHeader: {
      disableTypography: true
    },
    MuiListItem: {
      disableGutters: true
    }
  }
});
/* Get the final theme after merging base theme with selected theme */

function getFinalTheme(baseTheme) {
  var mixins = {
    panelBorder: {
      border: '1px solid ' + baseTheme.otherVars.borderColor,
      all: {
        border: '1px solid ' + baseTheme.otherVars.borderColor
      },
      top: {
        borderTop: '1px solid ' + baseTheme.otherVars.borderColor
      },
      bottom: {
        borderBottom: '1px solid ' + baseTheme.otherVars.borderColor
      },
      right: {
        borderRight: '1px solid ' + baseTheme.otherVars.borderColor
      }
    },
    nodeIcon: {
      backgroundPosition: 'center',
      padding: baseTheme.spacing(0, 1.5)
    },
    tabPanel: {
      height: '100%',
      padding: baseTheme.spacing(1),
      overflow: 'auto',
      backgroundColor: baseTheme.palette.grey[400],
      position: 'relative'
    },
    fontSourceCode: {
      fontFamily: '"Source Code Pro", SFMono-Regular, Menlo, Monaco, Consolas, "Liberation Mono", "Courier New", monospace'
    }
  };
  return (0, _styles.createMuiTheme)({
    mixins: mixins,
    overrides: {
      MuiOutlinedInput: {
        root: {
          '&.Mui-disabled .MuiOutlinedInput-notchedOutline': {
            borderColor: baseTheme.otherVars.inputBorderColor
          }
        },
        notchedOutline: {
          borderColor: baseTheme.otherVars.inputBorderColor
        }
      },
      MuiFormControlLabel: {
        label: {
          '&.Mui-disabled': {
            color: baseTheme.palette.text.muted
          }
        }
      },
      MuiTabs: {
        root: _objectSpread({
          backgroundColor: baseTheme.otherVars.headerBg
        }, mixins.panelBorder.bottom),
        indicator: {
          backgroundColor: baseTheme.otherVars.activeColor
        }
      },
      MuiFormLabel: {
        root: {
          color: baseTheme.palette.text.primary,
          fontSize: baseTheme.typography.fontSize
        },
        asterisk: {
          color: baseTheme.palette.error.main
        }
      },
      MuiInputBase: {
        root: {
          backgroundColor: baseTheme.palette.background["default"],
          textOverflow: 'ellipsis',
          '&.Mui-disabled': {
            backgroundColor: baseTheme.otherVars.inputDisabledBg
          }
        },
        inputMultiline: {
          fontSize: baseTheme.typography.fontSize,
          height: 'unset',
          backgroundColor: baseTheme.palette.background["default"],
          '&[readonly], &.Mui-disabled': {
            color: baseTheme.palette.text.muted,
            backgroundColor: baseTheme.otherVars.inputDisabledBg
          }
        },
        input: {
          fontSize: baseTheme.typography.fontSize,
          height: 'unset',
          backgroundColor: baseTheme.palette.background["default"],
          '&[readonly], &.Mui-disabled': {
            color: baseTheme.palette.text.muted,
            backgroundColor: baseTheme.otherVars.inputDisabledBg
          }
        }
      },
      MuiIconButton: {
        root: {
          color: baseTheme.palette.text.primary,
          '&$disabled': {
            color: 'abc'
          }
        }
      },
      MuiAccordion: {
        root: _objectSpread({}, mixins.panelBorder)
      },
      MuiAccordionSummary: {
        root: _objectSpread(_objectSpread({}, mixins.panelBorder.bottom), {}, {
          backgroundColor: baseTheme.otherVars.headerBg
        })
      },
      MuiToggleButtonGroup: {
        groupedHorizontal: {
          '&:not(:first-child)': {
            borderLeft: 'abc'
          }
        }
      },
      MuiSwitch: {
        root: {
          width: 54,
          height: 28,
          padding: '7px 12px'
        },
        colorPrimary: {
          '&$disabled': {
            color: 'abc',
            '& + .MuiSwitch-track': {
              backgroundColor: 'abc'
            }
          }
        },
        switchBase: {
          padding: baseTheme.spacing(0.5),
          '&$disabled': {
            color: 'abc',
            '& + .MuiSwitch-track': {
              opacity: baseTheme.palette.action.disabledOpacity
            }
          },
          '&.Mui-checked': {
            color: baseTheme.palette.success.main,
            transform: 'translateX(24px)',
            '& .MuiSwitch-thumb': {
              border: 0
            }
          },
          '&.Mui-checked + .MuiSwitch-track': {
            backgroundColor: baseTheme.palette.success.light
          }
        },
        thumb: {
          border: '1px solid ' + baseTheme.otherVars.inputBorderColor
        },
        track: {
          backgroundColor: baseTheme.otherVars.toggleBtnBg
        }
      },
      MuiCheckbox: {
        root: {
          padding: '0px',
          color: baseTheme.otherVars.inputBorderColor
        },
        colorPrimary: {
          '&.Mui-disabled': {
            color: baseTheme.palette.checkbox.disabled
          }
        }
      },
      MuiToggleButton: {
        root: {
          padding: 'abc',
          paddingRight: baseTheme.spacing(2.5),
          paddingLeft: baseTheme.spacing(0.5),
          color: 'abc',
          '&:hover': {
            backgroundColor: 'abc'
          },
          '&$selected': {
            color: 'abc',
            backgroundColor: 'abc',
            '&:hover': {
              backgroundColor: 'abc'
            }
          }
        }
      },
      MuiFormHelperText: {
        root: {
          color: baseTheme.palette.text.muted
        }
      },
      MuiDialogContent: {
        root: {
          padding: 0,
          userSelect: 'text'
        }
      },
      MuiDialogTitle: {
        root: _objectSpread({
          fontWeight: 'bold',
          padding: '5px 10px',
          cursor: 'move',
          display: 'flex',
          alignItems: 'center'
        }, mixins.panelBorder.bottom)
      },
      MuiCardHeader: {
        root: _objectSpread({
          padding: '4px 8px'
        }, mixins.panelBorder.bottom)
      },
      MuiCardContent: {
        root: {
          padding: 0,
          '&:last-child': {
            paddingBottom: 0
          }
        }
      },
      MuiListItem: {
        root: _objectSpread(_objectSpread(_objectSpread({
          color: baseTheme.palette.text.primary,
          backgroundColor: baseTheme.palette.background["default"],
          flexDirection: 'column',
          alignItems: 'initial',
          padding: '0px 4px',
          paddingTop: '0px',
          paddingBottom: '0px'
        }, mixins.panelBorder.top), mixins.panelBorder.bottom), {}, {
          borderTopColor: 'transparent',
          cursor: 'pointer',
          '&$selected': {
            backgroundColor: baseTheme.palette.primary.light,
            borderColor: baseTheme.palette.primary.main,
            '&:hover': {
              backgroundColor: baseTheme.palette.primary.light
            }
          }
        })
      }
    }
  }, baseTheme);
}
/* Theme wrapper used by DOM containers to apply theme */

/* In future, this will be moved to App container */


function Theme(props) {
  var theme = (0, _react.useMemo)(function () {
    var _document$querySelect;

    /* We'll remove this in future, we can get the value from preferences directly */
    var themeName = (_document$querySelect = document.querySelector('link[data-theme]')) === null || _document$querySelect === void 0 ? void 0 : _document$querySelect.getAttribute('data-theme');
    var baseTheme = (0, _standard["default"])(basicSettings);

    switch (themeName) {
      case 'dark':
        baseTheme = (0, _dark["default"])(baseTheme);
        break;

      case 'high_contrast':
        baseTheme = (0, _high_contrast["default"])(baseTheme);
        break;
    }

    return getFinalTheme(baseTheme);
  }, []);
  return /*#__PURE__*/_react["default"].createElement(_styles.ThemeProvider, {
    theme: theme
  }, props.children);
}

Theme.propTypes = {
  children: _custom_prop_types["default"].children
};
var commonTableStyles = (0, _styles.makeStyles)(function (theme) {
  return {
    table: {
      borderSpacing: 0,
      width: '100%',
      overflow: 'auto',
      backgroundColor: theme.otherVars.tableBg,
      border: '1px solid ' + theme.otherVars.borderColor,
      '& tbody td, & thead th': {
        margin: 0,
        padding: theme.spacing(0.5),
        border: '1px solid ' + theme.otherVars.borderColor,
        borderBottom: 'none',
        position: 'relative',
        overflow: 'hidden',
        textOverflow: 'ellipsis',
        whiteSpace: 'nowrap',
        userSelect: 'text',
        '&:first-of-type': {
          borderLeft: 'none'
        }
      },
      '& thead tr:first-of-type th': {
        borderTop: 'none'
      },
      '& tbody tr:last-of-type': {
        '&:hover td': {
          borderBottomColor: theme.palette.primary.main
        },
        '& td': {
          borderBottomColor: theme.otherVars.borderColor
        }
      },
      '& th': {
        fontWeight: theme.typography.fontWeightBold,
        padding: theme.spacing(1, 0.5),
        textAlign: 'left'
      },
      '& tbody > tr': {
        '&:hover': {
          backgroundColor: theme.palette.primary.light,
          '& td': {
            borderBottom: '1px solid ' + theme.palette.primary.main,
            borderTop: '1px solid ' + theme.palette.primary.main
          },
          '&:last-of-type td': {
            borderBottomColor: theme.palette.primary.main
          }
        }
      }
    },
    noBorder: {
      border: 0
    },
    borderBottom: {
      '& tbody tr:last-of-type td': {
        borderBottom: '1px solid ' + theme.otherVars.borderColor
      }
    },
    noHover: {
      '& tbody > tr': {
        '&:hover': {
          backgroundColor: theme.otherVars.tableBg,
          '& td': {
            borderBottomColor: theme.otherVars.borderColor,
            borderTopColor: theme.otherVars.borderColor
          },
          '&:last-of-type td': {
            borderBottomColor: theme.otherVars.borderColor
          }
        }
      }
    }
  };
});
exports.commonTableStyles = commonTableStyles;

/***/ }),

/***/ 84272:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



__webpack_require__(69070);

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.default = _default;

var _styles = __webpack_require__(30398);

var _colorManipulator = __webpack_require__(59114);

/////////////////////////////////////////////////////////////
//
// pgAdmin 4 - PostgreSQL Tools
//
// Copyright (C) 2013 - 2022, The pgAdmin Development Team
// This software is released under the PostgreSQL Licence
//
//////////////////////////////////////////////////////////////

/* The standard theme */
function _default(basicSettings) {
  return (0, _styles.createMuiTheme)(basicSettings, {
    palette: {
      "default": {
        main: '#fff',
        contrastText: '#222',
        borderColor: '#bac1cd',
        disabledBorderColor: '#bac1cd',
        disabledContrastText: '#222',
        hoverMain: '#ebeef3',
        hoverContrastText: '#222',
        hoverBorderColor: '#bac1cd'
      },
      primary: {
        main: '#326690',
        light: '#d6effc',
        contrastText: '#fff',
        hoverMain: (0, _colorManipulator.darken)('#326690', 0.25),
        hoverBorderColor: (0, _colorManipulator.darken)('#326690', 0.25),
        disabledMain: '#326690'
      },
      success: {
        main: '#26852B',
        light: '#D9ECDA',
        contrastText: '#000'
      },
      error: {
        main: '#CC0000',
        light: '#FAECEC',
        contrastText: '#fff'
      },
      warning: {
        main: '#eea236',
        light: '#fce5c5',
        contrastText: '#000'
      },
      info: {
        main: '#fde74c'
      },
      grey: {
        '200': '#f3f5f9',
        '400': '#ebeef3',
        '600': '#bac1cd',
        '800': '#848ea0'
      },
      text: {
        primary: '#222',
        muted: '#646B82'
      },
      checkbox: {
        disabled: '#ebeef3'
      },
      background: {
        paper: '#fff',
        "default": '#fff'
      }
    },
    custom: {
      icon: {
        main: '#fff',
        contrastText: '#222',
        borderColor: '#bac1cd',
        disabledMain: '#fff',
        disabledContrastText: '#222',
        disabledBorderColor: '#bac1cd',
        hoverMain: '#ebeef3',
        hoverContrastText: '#222'
      }
    },
    otherVars: {
      reactSelect: {
        padding: '5px 8px'
      },
      borderColor: '#dde0e6',
      loader: {
        backgroundColor: (0, _colorManipulator.fade)('#000', 0.65),
        color: '#fff'
      },
      inputBorderColor: '#dde0e6',
      inputDisabledBg: '#f3f5f9',
      headerBg: '#fff',
      activeColor: '#326690',
      tableBg: '#fff',
      activeStepBg: '#326690',
      activeStepFg: '#FFFFFF',
      stepBg: '#ddd',
      stepFg: '#000',
      toggleBtnBg: '#000'
    }
  });
}

/***/ }),

/***/ 2832:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



__webpack_require__(47941);

__webpack_require__(82526);

__webpack_require__(57327);

__webpack_require__(38880);

__webpack_require__(89554);

__webpack_require__(54747);

__webpack_require__(49337);

__webpack_require__(33321);

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.default = getApiInstance;
exports.parseApiError = parseApiError;

__webpack_require__(69070);

var _pgadmin = _interopRequireDefault(__webpack_require__(55112));

var _gettext = _interopRequireDefault(__webpack_require__(91669));

var _axios = _interopRequireDefault(__webpack_require__(9669));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/* Get the axios instance to call back end APIs.
Do not import axios directly, instead use this */
function getApiInstance() {
  var headers = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  var api = _axios["default"].create({
    headers: _objectSpread(_defineProperty({
      'Content-type': 'application/json'
    }, _pgadmin["default"].csrf_token_header, _pgadmin["default"].csrf_token), headers)
  });

  return api;
}

function parseApiError(error) {
  if (error.response) {
    // The request was made and the server responded with a status code
    // that falls out of the range of 2xx
    if (error.response.headers['content-type'] == 'application/json') {
      return error.response.data.errormsg;
    } else {
      return error.response.statusText;
    }
  } else if (error.request) {
    // The request was made but no response was received
    // `error.request` is an instance of XMLHttpRequest in the browser and an instance of
    // http.ClientRequest in node.js
    return (0, _gettext["default"])('Connection to pgAdmin server has been lost');
  } else {
    // Something happened in setting up the request that triggered an Error
    return error.message;
  }
}

/***/ }),

/***/ 61329:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {



__webpack_require__(92222);

var _underscore = _interopRequireDefault(__webpack_require__(81311));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/////////////////////////////////////////////////////////////
//
// pgAdmin 4 - PostgreSQL Tools
//
// Copyright (C) 2013 - 2022, The pgAdmin Development Team
// This software is released under the PostgreSQL Licence
//
//////////////////////////////////////////////////////////////
function generate_url(baseUrl, treeInfo, actionType, nodeType, pickFunction, itemDataID) {
  var ref = '';

  _underscore["default"].each(_underscore["default"].sortBy(_underscore["default"].pick(treeInfo, pickFunction), function (treeInfoItems) {
    return treeInfoItems.priority;
  }), function (treeInfoItems) {
    ref = "".concat(ref, "/").concat(encodeURI(treeInfoItems._id));
  });

  ref = itemDataID ? "".concat(ref, "/").concat(itemDataID) : "".concat(ref, "/");
  return "".concat(baseUrl).concat(nodeType, "/").concat(actionType).concat(ref);
}

module.exports = {
  generate_url: generate_url
};

/***/ }),

/***/ 86620:
/***/ ((module, exports, __webpack_require__) => {

var __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;

__webpack_require__(23157);

__webpack_require__(15306);

__webpack_require__(74916);

__webpack_require__(82772);

//////////////////////////////////////////////////////////////////////////
//
// pgAdmin 4 - PostgreSQL Tools
//
// Copyright (C) 2013 - 2022, The pgAdmin Development Team
// This software is released under the PostgreSQL Licence
//
//////////////////////////////////////////////////////////////////////////
!(__WEBPACK_AMD_DEFINE_ARRAY__ = [__webpack_require__(19755), __webpack_require__(81311)], __WEBPACK_AMD_DEFINE_RESULT__ = (function ($, _) {
  var check_node_visibility = function check_node_visibility(pgBrowser, node_type) {
    if (_.isUndefined(node_type) || _.isNull(node_type)) {
      return true;
    } // Target actual node instead of collection.
    // If node is disabled then there is no meaning of
    // adding collection node menu


    if (node_type.startsWith('coll-')) {
      node_type = node_type.replace('coll-', '');
    } // Exclude non-applicable nodes


    var nodes_not_supported = ['server_group', 'server', 'catalog_object_column'];

    if (_.indexOf(nodes_not_supported, node_type) >= 0) {
      return true;
    }

    var preference = pgBrowser.get_preference('browser', 'show_node_' + node_type);

    if (preference) {
      return preference.value;
    } else {
      return true;
    }
  };

  return check_node_visibility;
}).apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__),
		__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));

/***/ }),

/***/ 90338:
/***/ ((module, exports, __webpack_require__) => {

/* module decorator */ module = __webpack_require__.nmd(module);
var __WEBPACK_AMD_DEFINE_FACTORY__, __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;

__webpack_require__(94986);

__webpack_require__(82772);

__webpack_require__(26699);

__webpack_require__(32023);

__webpack_require__(92222);

__webpack_require__(24603);

__webpack_require__(74916);

__webpack_require__(39714);

__webpack_require__(82526);

__webpack_require__(41817);

__webpack_require__(41539);

__webpack_require__(32165);

__webpack_require__(78783);

__webpack_require__(66992);

__webpack_require__(33948);

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

/////////////////////////////////////////////////////////////
//
// pgAdmin 4 - PostgreSQL Tools
//
// Copyright (C) 2013 - 2022, The pgAdmin Development Team
// This software is released under the PostgreSQL Licence
//
//////////////////////////////////////////////////////////////
(function (mod) {
  if (( false ? 0 : _typeof(exports)) == 'object' && ( false ? 0 : _typeof(module)) == 'object') // CommonJS
    mod(__webpack_require__(4631));else if (true) // AMD
    !(__WEBPACK_AMD_DEFINE_ARRAY__ = [__webpack_require__(4631)], __WEBPACK_AMD_DEFINE_FACTORY__ = (mod),
		__WEBPACK_AMD_DEFINE_RESULT__ = (typeof __WEBPACK_AMD_DEFINE_FACTORY__ === 'function' ?
		(__WEBPACK_AMD_DEFINE_FACTORY__.apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__)) : __WEBPACK_AMD_DEFINE_FACTORY__),
		__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));else // Plain browser env
    {}
})(function (CodeMirror) {
  'use strict';

  var pgadminKeywordRangeFinder = function pgadminKeywordRangeFinder(cm, start, tokenSet) {
    var line = start.line,
        lineText = cm.getLine(line);
    var at = lineText.length,
        startChar,
        tokenType;
    var tokenSetNo = 0;
    var startTkn = tokenSet[tokenSetNo].start,
        endTkn = tokenSet[tokenSetNo].end;

    while (at > 0) {
      var found = lineText.toUpperCase().lastIndexOf(startTkn, at);
      found = checkStartTokenFoundOnEndToken(found, lineText.toUpperCase(), endTkn, startTkn);
      var startToken = startTkn;
      var endToken = endTkn;

      if (found < start.ch) {
        /* If the start token is not found then search for the next set of token */
        tokenSetNo++;

        if (tokenSetNo >= tokenSet.length) {
          return undefined;
        }

        startTkn = tokenSet[tokenSetNo].start;
        endTkn = tokenSet[tokenSetNo].end;
        at = lineText.length;
        continue;
      }

      tokenType = cm.getTokenAt(CodeMirror.Pos(line, found + 1)).type;

      if (!/^(comment|string)/.test(tokenType)) {
        startChar = found;
        break;
      }

      at = found - 1;
    }

    if (startChar == null || lineText.toUpperCase().lastIndexOf(startToken) > startChar) return;
    var count = 1,
        lastLine = cm.lineCount(),
        end,
        endCh;

    outer: for (var i = line + 1; i < lastLine; ++i) {
      var text = cm.getLine(i).toUpperCase(),
          pos = 0;
      var whileloopvar = 0;

      while (whileloopvar < 1) {
        var nextOpen = text.indexOf(startToken, pos);
        nextOpen = checkStartTokenFoundOnEndToken(nextOpen, text, endToken, startToken);
        var nextClose = text.indexOf(endToken, pos);
        if (nextOpen < 0) nextOpen = text.length;
        if (nextClose < 0) nextClose = text.length;
        pos = Math.min(nextOpen, nextClose);

        if (pos == text.length) {
          whileloopvar = 1;
          break;
        }

        if (cm.getTokenAt(CodeMirror.Pos(i, pos + 1)).type == tokenType) {
          if (pos == nextOpen) ++count;else if (! --count) {
            end = i;
            endCh = pos;
            break outer;
          }
        }

        ++pos;
      }
    }

    if (end == null || end == line + 1) return;
    return {
      from: CodeMirror.Pos(line, startChar + startTkn.length),
      to: CodeMirror.Pos(end, endCh)
    };
  };
  /**
   * This function is responsible for finding whether the startToken is present
   * in the endToken as well, to avoid mismatch of start and end points.
   * e.g. In case of IF and END IF, IF is detected in both tokens, which creates
   * confusion. The said function will resolve such issues.
   * @function checkStartTokenFoundOnEndToken
   * @returns {Number} - returns found
   */


  function checkStartTokenFoundOnEndToken(found, text, endToken, startToken) {
    if (found > 0) {
      if (text.includes(endToken) || !checkTokenMixedWithOtherAlphabets(text, startToken)) {
        found = -1;
      }
    }

    return found;
  }
  /**
   * This function is responsible for finding whether the startToken is mixed
   * with other alphabets of the text. To avoid word like NOTIFY to be mistakenly treat as keyword.
   * e.g. to avoid the IF detected as keyword in the word NOTIFY.
   * Function also works with other tokens like LOOP, CASE, etc.
   * @function checkTokenMixedWithOtherAlphabets
   * @returns {Boolean} - returns true/false
   */


  function checkTokenMixedWithOtherAlphabets(text, startToken) {
    //this reg will check the token should be in format as - IF condition or IF(condition)
    var reg = "\\b\\".concat(startToken, "\\s*\\(\\w*\\)(?!\\w)|\\b\\").concat(startToken, "\\(\\w*\\)(?!\\w)|\\b\\").concat(startToken, "\\s*(?!\\w)");
    var regex = RegExp(reg, 'g');

    if (regex.exec(text) !== null) {
      return true;
    }

    return false;
  }

  CodeMirror.registerHelper('fold', 'sql', function (cm, start) {
    var fromToPos = pgadminKeywordRangeFinder(cm, start, [{
      start: 'BEGIN',
      end: 'END;'
    }, {
      start: 'IF',
      end: 'END IF'
    }, {
      start: 'LOOP',
      end: 'END LOOP'
    }, {
      start: 'CASE',
      end: 'END CASE'
    }]);
    return fromToPos;
  });
});

/***/ }),

/***/ 18473:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {



var _codemirror = _interopRequireDefault(__webpack_require__(4631));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/////////////////////////////////////////////////////////////
//
// pgAdmin 4 - PostgreSQL Tools
//
// Copyright (C) 2013 - 2022, The pgAdmin Development Team
// This software is released under the PostgreSQL Licence
//
//////////////////////////////////////////////////////////////
_codemirror["default"].defineExtension('centerOnLine', function (line) {
  var ht = this.getScrollInfo().clientHeight;
  var coords = this.charCoords({
    line: line,
    ch: 0
  }, 'local');
  this.scrollTo(null, (coords.top + coords.bottom - ht) / 2);
});

/***/ }),

/***/ 87451:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

__webpack_require__(82526);

__webpack_require__(19601);

__webpack_require__(4129);

__webpack_require__(41539);

__webpack_require__(78783);

__webpack_require__(66992);

__webpack_require__(33948);

__webpack_require__(69070);

__webpack_require__(38880);

__webpack_require__(41817);

__webpack_require__(32165);

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.PgIconButton = exports.DefaultButton = exports.PrimaryButton = void 0;

__webpack_require__(47941);

__webpack_require__(82772);

var _core = __webpack_require__(65770);

var _react = _interopRequireWildcard(__webpack_require__(67294));

var _clsx = _interopRequireDefault(__webpack_require__(86010));

var _propTypes = _interopRequireDefault(__webpack_require__(45697));

var _custom_prop_types = _interopRequireDefault(__webpack_require__(41832));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var useStyles = (0, _core.makeStyles)(function (theme) {
  return {
    primaryButton: {
      '&.MuiButton-outlinedSizeSmall': {
        height: '28px',
        '& .MuiSvgIcon-root': {
          height: '0.8em'
        }
      },
      '&.Mui-disabled': {
        color: theme.palette.primary.contrastText,
        backgroundColor: theme.palette.primary.disabledMain
      },
      '&:hover': {
        backgroundColor: theme.palette.primary.hoverMain,
        borderColor: theme.palette.primary.hoverBorderColor
      }
    },
    defaultButton: {
      backgroundColor: theme.palette["default"].main,
      color: theme.palette["default"].contrastText,
      border: '1px solid ' + theme.palette["default"].borderColor,
      whiteSpace: 'nowrap',
      '&.MuiButton-outlinedSizeSmall': {
        height: '28px',
        '& .MuiSvgIcon-root': {
          height: '0.8em'
        }
      },
      '&.Mui-disabled': {
        color: theme.palette["default"].disabledContrastText,
        borderColor: theme.palette["default"].disabledBorderColor
      },
      '&:hover': {
        backgroundColor: theme.palette["default"].hoverMain,
        color: theme.palette["default"].hoverContrastText,
        borderColor: theme.palette["default"].hoverBorderColor
      }
    },
    iconButton: {
      padding: '3px 6px',
      borderColor: theme.custom.icon.borderColor,
      color: theme.custom.icon.contrastText,
      backgroundColor: theme.custom.icon.main,
      '&.Mui-disabled': {
        borderColor: theme.custom.icon.disabledBorderColor,
        backgroundColor: theme.custom.icon.disabledMain,
        color: theme.custom.icon.disabledContrastText
      },
      '&:hover': {
        backgroundColor: theme.custom.icon.hoverMain,
        color: theme.custom.icon.hoverContrastText
      }
    },
    xsButton: {
      padding: '2px 1px',
      height: '24px',
      '& .MuiSvgIcon-root': {
        height: '0.8em'
      }
    },
    noBorder: {
      border: 0
    }
  };
});
/* pgAdmin primary button */

var PrimaryButton = /*#__PURE__*/(0, _react.forwardRef)(function (props, ref) {
  var children = props.children,
      className = props.className,
      size = props.size,
      noBorder = props.noBorder,
      otherProps = _objectWithoutProperties(props, ["children", "className", "size", "noBorder"]);

  var classes = useStyles();
  var allClassName = [classes.primaryButton, className];

  if (size == 'xs') {
    size = undefined;
    allClassName.push(classes.xsButton);
  }

  noBorder && allClassName.push(classes.noBorder);
  return /*#__PURE__*/_react["default"].createElement(_core.Button, _extends({
    ref: ref,
    variant: "contained",
    color: "primary",
    size: size,
    className: (0, _clsx["default"])(allClassName)
  }, otherProps), children);
});
exports.PrimaryButton = PrimaryButton;
PrimaryButton.displayName = 'PrimaryButton';
PrimaryButton.propTypes = {
  size: _propTypes["default"].string,
  noBorder: _propTypes["default"].bool,
  children: _custom_prop_types["default"].children,
  className: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].object])
};
/* pgAdmin default button */

var DefaultButton = /*#__PURE__*/(0, _react.forwardRef)(function (props, ref) {
  var children = props.children,
      className = props.className,
      size = props.size,
      noBorder = props.noBorder,
      otherProps = _objectWithoutProperties(props, ["children", "className", "size", "noBorder"]);

  var classes = useStyles();
  var allClassName = [classes.defaultButton, className];

  if (size == 'xs') {
    size = undefined;
    allClassName.push(classes.xsButton);
  }

  noBorder && allClassName.push(classes.noBorder);
  return /*#__PURE__*/_react["default"].createElement(_core.Button, _extends({
    ref: ref,
    variant: "outlined",
    color: "default",
    size: size,
    className: (0, _clsx["default"])(allClassName)
  }, otherProps), children);
});
exports.DefaultButton = DefaultButton;
DefaultButton.displayName = 'DefaultButton';
DefaultButton.propTypes = {
  size: _propTypes["default"].string,
  noBorder: _propTypes["default"].bool,
  children: _custom_prop_types["default"].children,
  className: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].object])
};
/* pgAdmin Icon button, takes Icon component as input */

var PgIconButton = /*#__PURE__*/(0, _react.forwardRef)(function (_ref, ref) {
  var icon = _ref.icon,
      title = _ref.title,
      className = _ref.className,
      props = _objectWithoutProperties(_ref, ["icon", "title", "className"]);

  var classes = useStyles();
  /* Tooltip does not work for disabled items */

  return /*#__PURE__*/_react["default"].createElement(_core.Tooltip, {
    title: title || '',
    "aria-label": title || ''
  }, /*#__PURE__*/_react["default"].createElement("span", null, /*#__PURE__*/_react["default"].createElement(DefaultButton, _extends({
    ref: ref,
    style: {
      minWidth: 0
    },
    className: (0, _clsx["default"])(classes.iconButton, className)
  }, props), icon)));
});
exports.PgIconButton = PgIconButton;
PgIconButton.displayName = 'PgIconButton';
PgIconButton.propTypes = {
  icon: _custom_prop_types["default"].children,
  title: _propTypes["default"].string.isRequired,
  className: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].object])
};

/***/ }),

/***/ 65621:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

__webpack_require__(4129);

__webpack_require__(41539);

__webpack_require__(78783);

__webpack_require__(66992);

__webpack_require__(33948);

__webpack_require__(69070);

__webpack_require__(38880);

__webpack_require__(82526);

__webpack_require__(41817);

__webpack_require__(32165);

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.default = CodeMirror;

__webpack_require__(68309);

__webpack_require__(89554);

__webpack_require__(54747);

__webpack_require__(47941);

var _react = _interopRequireWildcard(__webpack_require__(67294));

var _bundled_codemirror = _interopRequireDefault(__webpack_require__(20811));

var _custom_hooks = __webpack_require__(50464);

var _propTypes = _interopRequireDefault(__webpack_require__(45697));

var _custom_prop_types = _interopRequireDefault(__webpack_require__(41832));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/////////////////////////////////////////////////////////////
//
// pgAdmin 4 - PostgreSQL Tools
//
// Copyright (C) 2013 - 2022, The pgAdmin Development Team
// This software is released under the PostgreSQL Licence
//
//////////////////////////////////////////////////////////////

/* React wrapper for CodeMirror */
function CodeMirror(_ref) {
  var currEditor = _ref.currEditor,
      name = _ref.name,
      value = _ref.value,
      options = _ref.options,
      events = _ref.events,
      readonly = _ref.readonly,
      disabled = _ref.disabled,
      className = _ref.className;
  var taRef = (0, _react.useRef)();
  var editor = (0, _react.useRef)();
  var cmWrapper = (0, _react.useRef)();
  var isVisibleTrack = (0, _react.useRef)();
  (0, _react.useEffect)(function () {
    /* Create the object only once on mount */
    editor.current = new _bundled_codemirror["default"].fromTextArea(taRef.current, options);
    editor.current.setValue(value);
    currEditor && currEditor(editor.current);

    if (editor.current) {
      try {
        cmWrapper.current = editor.current.getWrapperElement();
      } catch (e) {
        cmWrapper.current = null;
      }
    }

    Object.keys(events || {}).forEach(function (eventName) {
      editor.current.on(eventName, events[eventName]);
    });
  }, []);
  (0, _react.useEffect)(function () {
    if (editor.current) {
      if (disabled) {
        cmWrapper.current.classList.add('cm_disabled');
        editor.current.setOption('readOnly', 'nocursor');
      } else if (readonly) {
        cmWrapper.current.classList.add('cm_disabled');
        editor.current.setOption('readOnly', true);
        editor.current.addKeyMap({
          'Tab': false
        });
        editor.current.addKeyMap({
          'Shift-Tab': false
        });
      } else {
        cmWrapper.current.classList.remove('cm_disabled');
        editor.current.setOption('readOnly', false);
        editor.current.removeKeyMap('Tab');
        editor.current.removeKeyMap('Shift-Tab');
      }
    }
  }, [readonly, disabled]);
  (0, _react.useMemo)(function () {
    if (editor.current) {
      if (value != editor.current.getValue()) {
        editor.current.setValue(value);
      }
    }
  }, [value]);
  var onScreenVisible = (0, _custom_hooks.useOnScreen)(cmWrapper);

  if (!isVisibleTrack.current && onScreenVisible) {
    var _editor$current;

    isVisibleTrack.current = true;
    (_editor$current = editor.current) === null || _editor$current === void 0 ? void 0 : _editor$current.refresh();
  } else if (!onScreenVisible) {
    isVisibleTrack.current = false;
  }

  return /*#__PURE__*/_react["default"].createElement("div", {
    className: className
  }, /*#__PURE__*/_react["default"].createElement("textarea", {
    ref: taRef,
    name: name
  }));
}

CodeMirror.propTypes = {
  currEditor: _propTypes["default"].func,
  name: _propTypes["default"].string,
  value: _propTypes["default"].string,
  options: _propTypes["default"].object,
  change: _propTypes["default"].func,
  events: _propTypes["default"].object,
  readonly: _propTypes["default"].bool,
  disabled: _propTypes["default"].bool,
  className: _custom_prop_types["default"].className
};

/***/ }),

/***/ 84963:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



__webpack_require__(69070);

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.default = FieldSet;

var _core = __webpack_require__(65770);

var _react = _interopRequireDefault(__webpack_require__(67294));

var _clsx = _interopRequireDefault(__webpack_require__(86010));

var _propTypes = _interopRequireDefault(__webpack_require__(45697));

var _custom_prop_types = _interopRequireDefault(__webpack_require__(41832));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var useStyles = (0, _core.makeStyles)(function (theme) {
  return {
    fieldset: {
      padding: theme.spacing(0.5),
      borderRadius: theme.shape.borderRadius,
      backgroundColor: 'inherit',
      border: '1px solid ' + theme.otherVars.borderColor
    },
    legend: {
      width: 'unset',
      fontSize: 'inherit',
      fontWeight: 'bold'
    }
  };
});

function FieldSet(_ref) {
  var _ref$title = _ref.title,
      title = _ref$title === void 0 ? '' : _ref$title,
      className = _ref.className,
      children = _ref.children;
  var classes = useStyles();
  return /*#__PURE__*/_react["default"].createElement("fieldset", {
    className: (0, _clsx["default"])(classes.fieldset, className)
  }, /*#__PURE__*/_react["default"].createElement("legend", {
    className: classes.legend
  }, title), children);
}

FieldSet.propTypes = {
  title: _propTypes["default"].string,
  className: _custom_prop_types["default"].className,
  children: _custom_prop_types["default"].children
};

/***/ }),

/***/ 93299:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

__webpack_require__(47941);

__webpack_require__(82526);

__webpack_require__(38880);

__webpack_require__(89554);

__webpack_require__(54747);

__webpack_require__(49337);

__webpack_require__(33321);

__webpack_require__(19601);

__webpack_require__(79753);

__webpack_require__(41817);

__webpack_require__(32165);

__webpack_require__(78783);

__webpack_require__(66992);

__webpack_require__(33948);

__webpack_require__(91038);

__webpack_require__(47042);

__webpack_require__(4129);

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.FormInput = FormInput;
exports.InputSQL = InputSQL;
exports.FormInputSQL = FormInputSQL;
exports.InputDateTimePicker = InputDateTimePicker;
exports.FormInputDateTimePicker = FormInputDateTimePicker;
exports.FormInputText = FormInputText;
exports.InputFileSelect = InputFileSelect;
exports.FormInputFileSelect = FormInputFileSelect;
exports.InputSwitch = InputSwitch;
exports.FormInputSwitch = FormInputSwitch;
exports.InputCheckbox = InputCheckbox;
exports.FormInputCheckbox = FormInputCheckbox;
exports.InputToggle = InputToggle;
exports.FormInputToggle = FormInputToggle;
exports.InputSelect = InputSelect;
exports.FormInputSelect = FormInputSelect;
exports.InputColor = InputColor;
exports.FormInputColor = FormInputColor;
exports.PlainString = PlainString;
exports.FormNote = FormNote;
exports.FormFooterMessage = FormFooterMessage;
exports.NotifierMessage = NotifierMessage;
exports.InputText = exports.MESSAGE_TYPE = void 0;

__webpack_require__(26833);

__webpack_require__(83710);

__webpack_require__(82772);

__webpack_require__(21249);

__webpack_require__(69826);

__webpack_require__(88674);

__webpack_require__(41539);

__webpack_require__(57327);

__webpack_require__(68309);

__webpack_require__(92222);

__webpack_require__(39714);

__webpack_require__(69070);

var _react = _interopRequireWildcard(__webpack_require__(67294));

var _styles = __webpack_require__(30398);

var _core = __webpack_require__(65770);

var _lab = __webpack_require__(20975);

var _ErrorOutlineRounded = _interopRequireDefault(__webpack_require__(77914));

var _InfoRounded = _interopRequireDefault(__webpack_require__(36782));

var _CloseRounded = _interopRequireDefault(__webpack_require__(79138));

var _CheckRounded = _interopRequireDefault(__webpack_require__(45569));

var _WarningRounded = _interopRequireDefault(__webpack_require__(16327));

var _FolderOpenRounded = _interopRequireDefault(__webpack_require__(85347));

var _Description = _interopRequireDefault(__webpack_require__(67879));

var _reactSelect = _interopRequireWildcard(__webpack_require__(14504));

var _creatable = _interopRequireDefault(__webpack_require__(49153));

var _pickr = _interopRequireDefault(__webpack_require__(39612));

var _clsx = _interopRequireDefault(__webpack_require__(86010));

var _propTypes = _interopRequireDefault(__webpack_require__(45697));

var _htmlReactParser = _interopRequireDefault(__webpack_require__(15020));

var _pickers = __webpack_require__(43413);

var _dateFns = _interopRequireDefault(__webpack_require__(75365));

var DateFns = _interopRequireWildcard(__webpack_require__(45321));

var _CodeMirror = _interopRequireDefault(__webpack_require__(65621));

var _gettext = _interopRequireDefault(__webpack_require__(91669));

var _legacyConnector = __webpack_require__(81922);

var _lodash = _interopRequireDefault(__webpack_require__(96486));

var _Buttons = __webpack_require__(87451);

var _custom_prop_types = _interopRequireDefault(__webpack_require__(41832));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var useStyles = (0, _styles.makeStyles)(function (theme) {
  return {
    formRoot: {
      padding: '1rem'
    },
    img: {
      maxWidth: '100%',
      height: 'auto'
    },
    info: {
      color: theme.palette.info.main,
      marginLeft: '0.25rem',
      fontSize: '1rem'
    },
    formLabel: {
      margin: theme.spacing(0.75, 0.75, 0.75, 0.75),
      display: 'flex'
    },
    formLabelError: {
      color: theme.palette.error.main
    },
    sql: {
      border: '1px solid ' + theme.otherVars.inputBorderColor,
      borderRadius: theme.shape.borderRadius,
      height: '100%'
    },
    optionIcon: _objectSpread({}, theme.mixins.nodeIcon),
    colorBtn: {
      height: theme.spacing(3.5),
      minHeight: theme.spacing(3.5),
      width: theme.spacing(3.5),
      minWidth: theme.spacing(3.5)
    },
    noteRoot: {
      display: 'flex',
      backgroundColor: theme.otherVars.borderColor,
      padding: theme.spacing(1)
    },
    readOnlySwitch: {
      opacity: 0.75,
      '& .MuiSwitch-track': {
        opacity: theme.palette.action.disabledOpacity
      }
    }
  };
});
var MESSAGE_TYPE = {
  SUCCESS: 'Success',
  ERROR: 'Error',
  INFO: 'Info',
  CLOSE: 'Close',
  WARNING: 'Warning'
};
/* Icon based on MESSAGE_TYPE */

exports.MESSAGE_TYPE = MESSAGE_TYPE;

function FormIcon(_ref) {
  var type = _ref.type,
      _ref$close = _ref.close,
      close = _ref$close === void 0 ? false : _ref$close,
      props = _objectWithoutProperties(_ref, ["type", "close"]);

  var TheIcon = null;

  if (close) {
    TheIcon = _CloseRounded["default"];
  } else if (type === MESSAGE_TYPE.SUCCESS) {
    TheIcon = _CheckRounded["default"];
  } else if (type === MESSAGE_TYPE.ERROR) {
    TheIcon = _ErrorOutlineRounded["default"];
  } else if (type === MESSAGE_TYPE.INFO) {
    TheIcon = _InfoRounded["default"];
  } else if (type === MESSAGE_TYPE.WARNING) {
    TheIcon = _WarningRounded["default"];
  }

  return /*#__PURE__*/_react["default"].createElement(TheIcon, _extends({
    fontSize: "small"
  }, props));
}

FormIcon.propTypes = {
  type: _propTypes["default"].oneOf(Object.values(MESSAGE_TYPE)),
  close: _propTypes["default"].bool
};
/* Wrapper on any form component to add label, error indicator and help message */

function FormInput(_ref2) {
  var children = _ref2.children,
      error = _ref2.error,
      className = _ref2.className,
      label = _ref2.label,
      helpMessage = _ref2.helpMessage,
      required = _ref2.required,
      testcid = _ref2.testcid;
  var classes = useStyles();

  var cid = testcid || _lodash["default"].uniqueId('c');

  var helpid = "h".concat(cid);
  return /*#__PURE__*/_react["default"].createElement(_core.Grid, {
    container: true,
    spacing: 0,
    className: className
  }, /*#__PURE__*/_react["default"].createElement(_core.Grid, {
    item: true,
    lg: 3,
    md: 3,
    sm: 3,
    xs: 12
  }, /*#__PURE__*/_react["default"].createElement(_core.InputLabel, {
    htmlFor: cid,
    className: (0, _clsx["default"])(classes.formLabel, error ? classes.formLabelError : null),
    required: required
  }, label, /*#__PURE__*/_react["default"].createElement(FormIcon, {
    type: MESSAGE_TYPE.ERROR,
    style: {
      marginLeft: 'auto',
      visibility: error ? 'unset' : 'hidden'
    }
  }))), /*#__PURE__*/_react["default"].createElement(_core.Grid, {
    item: true,
    lg: 9,
    md: 9,
    sm: 9,
    xs: 12
  }, /*#__PURE__*/_react["default"].createElement(_core.FormControl, {
    error: Boolean(error),
    fullWidth: true
  }, /*#__PURE__*/_react["default"].cloneElement(children, {
    cid: cid,
    helpid: helpid
  })), /*#__PURE__*/_react["default"].createElement(_core.FormHelperText, {
    id: helpid,
    variant: "outlined"
  }, (0, _htmlReactParser["default"])(helpMessage || ''))));
}

FormInput.propTypes = {
  children: _custom_prop_types["default"].children,
  error: _propTypes["default"].bool,
  className: _custom_prop_types["default"].className,
  label: _propTypes["default"].string,
  helpMessage: _propTypes["default"].string,
  required: _propTypes["default"].bool,
  testcid: _propTypes["default"].any
};

function InputSQL(_ref3) {
  var value = _ref3.value,
      options = _ref3.options,
      onChange = _ref3.onChange,
      className = _ref3.className,
      props = _objectWithoutProperties(_ref3, ["value", "options", "onChange", "className"]);

  var classes = useStyles();
  var editor = (0, _react.useRef)();
  return /*#__PURE__*/_react["default"].createElement(_CodeMirror["default"], _extends({
    currEditor: function currEditor(obj) {
      return editor.current = obj;
    },
    value: value || '',
    options: _objectSpread({
      lineNumbers: true,
      mode: 'text/x-pgsql'
    }, options),
    className: (0, _clsx["default"])(classes.sql, className),
    events: {
      change: function change(cm) {
        onChange && onChange(cm.getValue());
      }
    }
  }, props));
}

InputSQL.propTypes = {
  value: _propTypes["default"].string,
  options: _propTypes["default"].object,
  onChange: _propTypes["default"].func,
  readonly: _propTypes["default"].bool,
  className: _custom_prop_types["default"].className
};

function FormInputSQL(_ref4) {
  var hasError = _ref4.hasError,
      required = _ref4.required,
      label = _ref4.label,
      className = _ref4.className,
      helpMessage = _ref4.helpMessage,
      testcid = _ref4.testcid,
      value = _ref4.value,
      controlProps = _ref4.controlProps,
      noLabel = _ref4.noLabel,
      props = _objectWithoutProperties(_ref4, ["hasError", "required", "label", "className", "helpMessage", "testcid", "value", "controlProps", "noLabel"]);

  if (noLabel) {
    return /*#__PURE__*/_react["default"].createElement(InputSQL, _extends({
      value: value,
      options: controlProps
    }, props));
  } else {
    return /*#__PURE__*/_react["default"].createElement(FormInput, {
      required: required,
      label: label,
      error: hasError,
      className: className,
      helpMessage: helpMessage,
      testcid: testcid
    }, /*#__PURE__*/_react["default"].createElement(InputSQL, _extends({
      value: value,
      options: controlProps
    }, props)));
  }
}

FormInputSQL.propTypes = {
  hasError: _propTypes["default"].bool,
  required: _propTypes["default"].bool,
  label: _propTypes["default"].string,
  className: _custom_prop_types["default"].className,
  helpMessage: _propTypes["default"].string,
  testcid: _propTypes["default"].string,
  value: _propTypes["default"].string,
  controlProps: _propTypes["default"].object,
  noLabel: _propTypes["default"].bool,
  change: _propTypes["default"].func
};
/* https://date-fns.org/v2.24.0/docs/format */

var DATE_TIME_FORMAT = {
  DATE_TIME_12: 'yyyy-MM-dd hh:mm:ss aa xxx',
  DATE_TIME_24: 'yyyy-MM-dd HH:mm:ss xxx',
  DATE: 'yyyy-MM-dd',
  TIME_12: 'hh:mm:ss aa',
  TIME_24: 'HH:mm:ss'
};

function InputDateTimePicker(_ref5) {
  var value = _ref5.value,
      onChange = _ref5.onChange,
      readonly = _ref5.readonly,
      controlProps = _ref5.controlProps,
      props = _objectWithoutProperties(_ref5, ["value", "onChange", "readonly", "controlProps"]);

  var format = '';
  var placeholder = '';

  if ((controlProps === null || controlProps === void 0 ? void 0 : controlProps.pickerType) === 'Date') {
    format = controlProps.format || DATE_TIME_FORMAT.DATE;
    placeholder = controlProps.placeholder || 'YYYY-MM-DD';
  } else if ((controlProps === null || controlProps === void 0 ? void 0 : controlProps.pickerType) === 'Time') {
    format = controlProps.format || (controlProps.ampm ? DATE_TIME_FORMAT.TIME_12 : DATE_TIME_FORMAT.TIME_24);
    placeholder = controlProps.placeholder || 'HH:mm:ss';
  } else {
    format = controlProps.format || (controlProps.ampm ? DATE_TIME_FORMAT.DATE_TIME_12 : DATE_TIME_FORMAT.DATE_TIME_24);
    placeholder = controlProps.placeholder || 'YYYY-MM-DD HH:mm:ss Z';
  }

  var handleChange = function handleChange(dateVal, stringVal) {
    onChange(stringVal);
  };
  /* Value should be a date object instead of string */


  value = _lodash["default"].isUndefined(value) ? null : value;

  if (!_lodash["default"].isNull(value)) {
    var parseValue = DateFns.parse(value, format, new Date());

    if (!DateFns.isValid(parseValue)) {
      parseValue = DateFns.parseISO(value);
    }

    value = !DateFns.isValid(parseValue) ? value : parseValue;
  }

  if (readonly) {
    return /*#__PURE__*/_react["default"].createElement(InputText, _extends({
      value: value ? DateFns.format(value, format) : value,
      readonly: readonly,
      controlProps: {
        placeholder: controlProps.placeholder
      }
    }, props));
  }

  var commonProps = _objectSpread(_objectSpread({}, props), {}, {
    value: value,
    format: format,
    placeholder: placeholder,
    label: '',
    variant: 'inline',
    readOnly: Boolean(readonly),
    autoOk: controlProps.autoOk || false,
    ampm: controlProps.ampm || false,
    disablePast: controlProps.disablePast || false,
    invalidDateMessage: '',
    maxDateMessage: '',
    minDateMessage: '',
    onChange: handleChange,
    fullWidth: true
  });

  if ((controlProps === null || controlProps === void 0 ? void 0 : controlProps.pickerType) === 'Date') {
    return /*#__PURE__*/_react["default"].createElement(_pickers.MuiPickersUtilsProvider, {
      utils: _dateFns["default"]
    }, /*#__PURE__*/_react["default"].createElement(_pickers.KeyboardDatePicker, commonProps));
  } else if ((controlProps === null || controlProps === void 0 ? void 0 : controlProps.pickerType) === 'Time') {
    return /*#__PURE__*/_react["default"].createElement(_pickers.MuiPickersUtilsProvider, {
      utils: _dateFns["default"]
    }, /*#__PURE__*/_react["default"].createElement(_pickers.KeyboardTimePicker, commonProps));
  }

  return /*#__PURE__*/_react["default"].createElement(_pickers.MuiPickersUtilsProvider, {
    utils: _dateFns["default"]
  }, /*#__PURE__*/_react["default"].createElement(_pickers.KeyboardDateTimePicker, commonProps));
}

InputDateTimePicker.propTypes = {
  value: _propTypes["default"].string,
  options: _propTypes["default"].object,
  onChange: _propTypes["default"].func,
  readonly: _propTypes["default"].bool,
  controlProps: _propTypes["default"].object
};

function FormInputDateTimePicker(_ref6) {
  var hasError = _ref6.hasError,
      required = _ref6.required,
      label = _ref6.label,
      className = _ref6.className,
      helpMessage = _ref6.helpMessage,
      testcid = _ref6.testcid,
      props = _objectWithoutProperties(_ref6, ["hasError", "required", "label", "className", "helpMessage", "testcid"]);

  return /*#__PURE__*/_react["default"].createElement(FormInput, {
    required: required,
    label: label,
    error: hasError,
    className: className,
    helpMessage: helpMessage,
    testcid: testcid
  }, /*#__PURE__*/_react["default"].createElement(InputDateTimePicker, props));
}

FormInputDateTimePicker.propTypes = {
  hasError: _propTypes["default"].bool,
  required: _propTypes["default"].bool,
  label: _propTypes["default"].string,
  className: _custom_prop_types["default"].className,
  helpMessage: _propTypes["default"].string,
  testcid: _propTypes["default"].string,
  value: _propTypes["default"].string,
  controlProps: _propTypes["default"].object,
  change: _propTypes["default"].func
};
/* Use forwardRef to pass ref prop to OutlinedInput */

var InputText = /*#__PURE__*/(0, _react.forwardRef)(function (_ref7, ref) {
  var cid = _ref7.cid,
      helpid = _ref7.helpid,
      readonly = _ref7.readonly,
      disabled = _ref7.disabled,
      _ref7$maxlength = _ref7.maxlength,
      maxlength = _ref7$maxlength === void 0 ? 255 : _ref7$maxlength,
      value = _ref7.value,
      onChange = _ref7.onChange,
      controlProps = _ref7.controlProps,
      type = _ref7.type,
      props = _objectWithoutProperties(_ref7, ["cid", "helpid", "readonly", "disabled", "maxlength", "value", "onChange", "controlProps", "type"]);

  var classes = useStyles();
  var patterns = {
    'numeric': '^-?[0-9]\\d*\\.?\\d*$',
    'int': '^-?[0-9]\\d*$'
  };

  var onChangeFinal = function onChangeFinal(e) {
    var changeVal = e.target.value;
    /* For type number, we set type as tel with number regex to get validity.*/

    if (['numeric', 'int', 'tel'].indexOf(type) > -1) {
      if (!e.target.validity.valid && changeVal !== '' && changeVal !== '-') {
        return;
      }
    }

    if (controlProps !== null && controlProps !== void 0 && controlProps.formatter) {
      changeVal = controlProps.formatter.toRaw(changeVal);
    }

    onChange && onChange(changeVal);
  };

  var finalValue = _lodash["default"].isNull(value) || _lodash["default"].isUndefined(value) ? '' : value;

  if (controlProps !== null && controlProps !== void 0 && controlProps.formatter) {
    finalValue = controlProps.formatter.fromRaw(finalValue);
  }

  return /*#__PURE__*/_react["default"].createElement(_core.OutlinedInput, _extends({
    ref: ref,
    color: "primary",
    fullWidth: true,
    className: classes.formInput,
    inputProps: _objectSpread({
      id: cid,
      maxLength: controlProps !== null && controlProps !== void 0 && controlProps.multiline ? null : maxlength,
      'aria-describedby': helpid
    }, type ? {
      pattern: !_lodash["default"].isUndefined(controlProps) && !_lodash["default"].isUndefined(controlProps.pattern) ? controlProps.pattern : patterns[type]
    } : {}),
    readOnly: Boolean(readonly),
    disabled: Boolean(disabled),
    rows: 4,
    notched: false,
    value: _lodash["default"].isNull(finalValue) || _lodash["default"].isUndefined(finalValue) ? '' : finalValue,
    onChange: onChangeFinal
  }, controlProps, props, ['numeric', 'int'].indexOf(type) > -1 ? {
    type: 'tel'
  } : {
    type: type
  }));
});
exports.InputText = InputText;
InputText.displayName = 'InputText';
InputText.propTypes = {
  cid: _propTypes["default"].string,
  helpid: _propTypes["default"].string,
  label: _propTypes["default"].string,
  readonly: _propTypes["default"].bool,
  disabled: _propTypes["default"].bool,
  maxlength: _propTypes["default"].number,
  value: _propTypes["default"].any,
  onChange: _propTypes["default"].func,
  controlProps: _propTypes["default"].object,
  type: _propTypes["default"].string
};

function FormInputText(_ref8) {
  var hasError = _ref8.hasError,
      required = _ref8.required,
      label = _ref8.label,
      className = _ref8.className,
      helpMessage = _ref8.helpMessage,
      testcid = _ref8.testcid,
      props = _objectWithoutProperties(_ref8, ["hasError", "required", "label", "className", "helpMessage", "testcid"]);

  return /*#__PURE__*/_react["default"].createElement(FormInput, {
    required: required,
    label: label,
    error: hasError,
    className: className,
    helpMessage: helpMessage,
    testcid: testcid
  }, /*#__PURE__*/_react["default"].createElement(InputText, _extends({
    label: label
  }, props)));
}

FormInputText.propTypes = {
  hasError: _propTypes["default"].bool,
  required: _propTypes["default"].bool,
  label: _propTypes["default"].string,
  className: _custom_prop_types["default"].className,
  helpMessage: _propTypes["default"].string,
  testcid: _propTypes["default"].string
};
/* Using the existing file dialog functions using showFileDialog */

function InputFileSelect(_ref9) {
  var controlProps = _ref9.controlProps,
      onChange = _ref9.onChange,
      disabled = _ref9.disabled,
      readonly = _ref9.readonly,
      props = _objectWithoutProperties(_ref9, ["controlProps", "onChange", "disabled", "readonly"]);

  var inpRef = (0, _react.useRef)();

  var onFileSelect = function onFileSelect(value) {
    onChange && onChange(decodeURI(value));
    inpRef.current.focus();
  };

  return /*#__PURE__*/_react["default"].createElement(InputText, _extends({
    ref: inpRef,
    disabled: disabled,
    readonly: readonly,
    onChange: onChange
  }, props, {
    endAdornment: /*#__PURE__*/_react["default"].createElement(_core.IconButton, {
      onClick: function onClick() {
        return (0, _legacyConnector.showFileDialog)(controlProps, onFileSelect);
      },
      disabled: disabled || readonly,
      "aria-label": (0, _gettext["default"])('Select a file')
    }, /*#__PURE__*/_react["default"].createElement(_FolderOpenRounded["default"], null))
  }));
}

InputFileSelect.propTypes = {
  controlProps: _propTypes["default"].object,
  onChange: _propTypes["default"].func,
  disabled: _propTypes["default"].bool,
  readonly: _propTypes["default"].bool
};

function FormInputFileSelect(_ref10) {
  var hasError = _ref10.hasError,
      required = _ref10.required,
      label = _ref10.label,
      className = _ref10.className,
      helpMessage = _ref10.helpMessage,
      testcid = _ref10.testcid,
      props = _objectWithoutProperties(_ref10, ["hasError", "required", "label", "className", "helpMessage", "testcid"]);

  return /*#__PURE__*/_react["default"].createElement(FormInput, {
    required: required,
    label: label,
    error: hasError,
    className: className,
    helpMessage: helpMessage,
    testcid: testcid
  }, /*#__PURE__*/_react["default"].createElement(InputFileSelect, _extends({
    required: required,
    label: label
  }, props)));
}

FormInputFileSelect.propTypes = {
  hasError: _propTypes["default"].bool,
  required: _propTypes["default"].bool,
  label: _propTypes["default"].string,
  className: _custom_prop_types["default"].className,
  helpMessage: _propTypes["default"].string,
  testcid: _propTypes["default"].string
};

function InputSwitch(_ref11) {
  var cid = _ref11.cid,
      helpid = _ref11.helpid,
      value = _ref11.value,
      onChange = _ref11.onChange,
      readonly = _ref11.readonly,
      controlProps = _ref11.controlProps,
      props = _objectWithoutProperties(_ref11, ["cid", "helpid", "value", "onChange", "readonly", "controlProps"]);

  var classes = useStyles();
  return /*#__PURE__*/_react["default"].createElement(_core.Switch, _extends({
    color: "primary",
    checked: Boolean(value),
    onChange: readonly ? function () {} : onChange,
    id: cid,
    inputProps: {
      'aria-describedby': helpid
    }
  }, controlProps, props, {
    className: readonly || props.disabled ? classes.readOnlySwitch : null
  }));
}

InputSwitch.propTypes = {
  cid: _propTypes["default"].string,
  helpid: _propTypes["default"].string,
  value: _propTypes["default"].any,
  onChange: _propTypes["default"].func,
  readonly: _propTypes["default"].bool,
  disabled: _propTypes["default"].bool,
  controlProps: _propTypes["default"].object
};

function FormInputSwitch(_ref12) {
  var hasError = _ref12.hasError,
      required = _ref12.required,
      label = _ref12.label,
      className = _ref12.className,
      helpMessage = _ref12.helpMessage,
      testcid = _ref12.testcid,
      props = _objectWithoutProperties(_ref12, ["hasError", "required", "label", "className", "helpMessage", "testcid"]);

  return /*#__PURE__*/_react["default"].createElement(FormInput, {
    required: required,
    label: label,
    error: hasError,
    className: className,
    helpMessage: helpMessage,
    testcid: testcid
  }, /*#__PURE__*/_react["default"].createElement(InputSwitch, props));
}

FormInputSwitch.propTypes = {
  hasError: _propTypes["default"].bool,
  required: _propTypes["default"].bool,
  label: _propTypes["default"].string,
  className: _custom_prop_types["default"].className,
  helpMessage: _propTypes["default"].string,
  testcid: _propTypes["default"].string
};

function InputCheckbox(_ref13) {
  var cid = _ref13.cid,
      helpid = _ref13.helpid,
      value = _ref13.value,
      onChange = _ref13.onChange,
      controlProps = _ref13.controlProps,
      readonly = _ref13.readonly,
      props = _objectWithoutProperties(_ref13, ["cid", "helpid", "value", "onChange", "controlProps", "readonly"]);

  controlProps = controlProps || {};
  return /*#__PURE__*/_react["default"].createElement(_core.FormControlLabel, {
    control: /*#__PURE__*/_react["default"].createElement(_core.Checkbox, _extends({
      id: cid,
      checked: Boolean(value),
      onChange: readonly ? function () {} : onChange,
      color: "primary",
      inputProps: {
        'aria-describedby': helpid
      }
    }, props)),
    label: controlProps.label
  });
}

InputCheckbox.propTypes = {
  cid: _propTypes["default"].string,
  helpid: _propTypes["default"].string,
  value: _propTypes["default"].bool,
  controlProps: _propTypes["default"].object,
  onChange: _propTypes["default"].func,
  readonly: _propTypes["default"].bool
};

function FormInputCheckbox(_ref14) {
  var hasError = _ref14.hasError,
      required = _ref14.required,
      label = _ref14.label,
      className = _ref14.className,
      helpMessage = _ref14.helpMessage,
      testcid = _ref14.testcid,
      props = _objectWithoutProperties(_ref14, ["hasError", "required", "label", "className", "helpMessage", "testcid"]);

  return /*#__PURE__*/_react["default"].createElement(FormInput, {
    required: required,
    label: label,
    error: hasError,
    className: className,
    helpMessage: helpMessage,
    testcid: testcid
  }, /*#__PURE__*/_react["default"].createElement(InputCheckbox, props));
}

FormInputCheckbox.propTypes = {
  hasError: _propTypes["default"].bool,
  required: _propTypes["default"].bool,
  label: _propTypes["default"].string,
  className: _custom_prop_types["default"].className,
  helpMessage: _propTypes["default"].string,
  testcid: _propTypes["default"].string
};

function InputToggle(_ref15) {
  var cid = _ref15.cid,
      value = _ref15.value,
      _onChange = _ref15.onChange,
      options = _ref15.options,
      disabled = _ref15.disabled,
      readonly = _ref15.readonly,
      props = _objectWithoutProperties(_ref15, ["cid", "value", "onChange", "options", "disabled", "readonly"]);

  return /*#__PURE__*/_react["default"].createElement(_lab.ToggleButtonGroup, _extends({
    id: cid,
    value: value,
    exclusive: true,
    onChange: function onChange(e, val) {
      val !== null && _onChange(val);
    }
  }, props), (options || []).map(function (option) {
    var isSelected = option.value === value;
    var isDisabled = disabled || option.disabled || readonly && !isSelected;
    return /*#__PURE__*/_react["default"].createElement(_lab.ToggleButton, {
      key: option.label,
      value: option.value,
      component: isSelected ? _Buttons.PrimaryButton : _Buttons.DefaultButton,
      disabled: isDisabled,
      "aria-label": option.label
    }, /*#__PURE__*/_react["default"].createElement(_CheckRounded["default"], {
      style: {
        visibility: isSelected ? 'visible' : 'hidden'
      }
    }), "\xA0", option.label);
  }));
}

InputToggle.propTypes = {
  cid: _propTypes["default"].string,
  value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number, _propTypes["default"].bool]),
  options: _propTypes["default"].array,
  controlProps: _propTypes["default"].object,
  onChange: _propTypes["default"].func,
  disabled: _propTypes["default"].bool,
  readonly: _propTypes["default"].bool
};

function FormInputToggle(_ref16) {
  var hasError = _ref16.hasError,
      required = _ref16.required,
      label = _ref16.label,
      className = _ref16.className,
      helpMessage = _ref16.helpMessage,
      testcid = _ref16.testcid,
      props = _objectWithoutProperties(_ref16, ["hasError", "required", "label", "className", "helpMessage", "testcid"]);

  return /*#__PURE__*/_react["default"].createElement(FormInput, {
    required: required,
    label: label,
    error: hasError,
    className: className,
    helpMessage: helpMessage,
    testcid: testcid
  }, /*#__PURE__*/_react["default"].createElement(InputToggle, props));
}

FormInputToggle.propTypes = {
  hasError: _propTypes["default"].bool,
  required: _propTypes["default"].bool,
  label: _propTypes["default"].string,
  className: _custom_prop_types["default"].className,
  helpMessage: _propTypes["default"].string,
  testcid: _propTypes["default"].string
};
/* react-select package is used for select input
 * Customizing the select styles to fit existing theme
 */

var customReactSelectStyles = function customReactSelectStyles(theme, readonly) {
  return {
    input: function input(provided) {
      return _objectSpread(_objectSpread({}, provided), {}, {
        padding: 0,
        margin: 0,
        color: 'inherit'
      });
    },
    singleValue: function singleValue(provided) {
      return _objectSpread(_objectSpread({}, provided), {}, {
        color: 'inherit'
      });
    },
    control: function control(provided, state) {
      return _objectSpread(_objectSpread({}, provided), {}, {
        minHeight: '0',
        backgroundColor: readonly ? theme.otherVars.inputDisabledBg : theme.palette.background["default"],
        color: readonly ? theme.palette.text.muted : theme.palette.text.primary,
        borderColor: theme.otherVars.inputBorderColor
      }, state.isFocused ? {
        borderColor: theme.palette.primary.main,
        boxShadow: 'inset 0 0 0 1px ' + theme.palette.primary.main,
        '&:hover': {
          borderColor: theme.palette.primary.main
        }
      } : {});
    },
    dropdownIndicator: function dropdownIndicator(provided) {
      return _objectSpread(_objectSpread({}, provided), {}, {
        padding: '0rem 0.25rem'
      });
    },
    indicatorsContainer: function indicatorsContainer(provided) {
      return _objectSpread(_objectSpread({}, provided), readonly ? {
        display: 'none'
      } : {});
    },
    clearIndicator: function clearIndicator(provided) {
      return _objectSpread(_objectSpread({}, provided), {}, {
        padding: '0rem 0.25rem'
      });
    },
    valueContainer: function valueContainer(provided) {
      return _objectSpread(_objectSpread({}, provided), {}, {
        padding: theme.otherVars.reactSelect.padding
      });
    },
    menu: function menu(provided) {
      return _objectSpread(_objectSpread({}, provided), {}, {
        backgroundColor: theme.palette.background["default"],
        color: theme.palette.text.primary,
        boxShadow: 'none',
        border: '1px solid ' + theme.otherVars.inputBorderColor,
        marginTop: '2px'
      });
    },
    menuPortal: function menuPortal(provided) {
      return _objectSpread(_objectSpread({}, provided), {}, {
        zIndex: 9999,
        backgroundColor: 'inherit',
        color: 'inherit'
      });
    },
    option: function option(provided, state) {
      return _objectSpread(_objectSpread({}, provided), {}, {
        padding: '0.5rem',
        color: 'inherit',
        backgroundColor: state.isFocused ? theme.palette.grey[400] : state.isSelected ? theme.palette.primary.light : 'inherit'
      });
    },
    multiValue: function multiValue(provided) {
      return _objectSpread(_objectSpread({}, provided), {}, {
        backgroundColor: theme.palette.grey[400]
      });
    },
    multiValueLabel: function multiValueLabel(provided) {
      return _objectSpread(_objectSpread({}, provided), {}, {
        fontSize: '1em',
        zIndex: 99,
        color: theme.palette.text.primary
      });
    },
    multiValueRemove: function multiValueRemove(provided) {
      return _objectSpread(_objectSpread({}, provided), {}, {
        '&:hover': {
          backgroundColor: 'unset',
          color: theme.palette.error.main
        }
      }, readonly ? {
        display: 'none'
      } : {});
    }
  };
};

function OptionView(_ref17) {
  var image = _ref17.image,
      label = _ref17.label;
  var classes = useStyles();
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, image && /*#__PURE__*/_react["default"].createElement("span", {
    className: (0, _clsx["default"])(classes.optionIcon, image)
  }), /*#__PURE__*/_react["default"].createElement("span", null, label));
}

OptionView.propTypes = {
  image: _propTypes["default"].string,
  label: _propTypes["default"].string
};

function CustomSelectOption(props) {
  return /*#__PURE__*/_react["default"].createElement(_reactSelect.components.Option, props, /*#__PURE__*/_react["default"].createElement(OptionView, {
    image: props.data.image,
    label: props.data.label
  }));
}

CustomSelectOption.propTypes = {
  data: _propTypes["default"].object
};

function CustomSelectSingleValue(props) {
  return /*#__PURE__*/_react["default"].createElement(_reactSelect.components.SingleValue, props, /*#__PURE__*/_react["default"].createElement(OptionView, {
    image: props.data.image,
    label: props.data.label
  }));
}

CustomSelectSingleValue.propTypes = {
  data: _propTypes["default"].object
};

function getRealValue(options, value, creatable, formatter) {
  var realValue = null;

  if (_lodash["default"].isArray(value)) {
    realValue = _toConsumableArray(value);
    /* If multi select options need to be in some format by UI, use formatter */

    if (formatter) {
      realValue = formatter.fromRaw(realValue, options);
    } else {
      if (creatable) {
        realValue = realValue.map(function (val) {
          return {
            label: val,
            value: val
          };
        });
      } else {
        realValue = realValue.map(function (val) {
          return _lodash["default"].find(options, function (option) {
            return _lodash["default"].isEqual(option.value, val);
          });
        });
      }
    }
  } else {
    realValue = _lodash["default"].find(options, function (option) {
      return option.value == value;
    }) || (creatable && !_lodash["default"].isUndefined(value) && !_lodash["default"].isNull(value) ? {
      label: value,
      value: value
    } : null);
  }

  return realValue;
}

function InputSelect(_ref18) {
  var cid = _ref18.cid,
      onChange = _ref18.onChange,
      options = _ref18.options,
      _ref18$readonly = _ref18.readonly,
      readonly = _ref18$readonly === void 0 ? false : _ref18$readonly,
      value = _ref18.value,
      _ref18$controlProps = _ref18.controlProps,
      controlProps = _ref18$controlProps === void 0 ? {} : _ref18$controlProps,
      optionsLoaded = _ref18.optionsLoaded,
      optionsReloadBasis = _ref18.optionsReloadBasis,
      disabled = _ref18.disabled,
      props = _objectWithoutProperties(_ref18, ["cid", "onChange", "options", "readonly", "value", "controlProps", "optionsLoaded", "optionsReloadBasis", "disabled"]);

  var _useState = (0, _react.useState)([[], true]),
      _useState2 = _slicedToArray(_useState, 2),
      _useState2$ = _slicedToArray(_useState2[0], 2),
      finalOptions = _useState2$[0],
      isLoading = _useState2$[1],
      setFinalOptions = _useState2[1];

  var theme = (0, _core.useTheme)();
  /* React will always take options var as changed parameter. So,
  We cannot run the below effect with options dependency as it will keep on
  loading the options. optionsReloadBasis is helpful to avoid repeated
  options load. If optionsReloadBasis value changes, then options will be loaded again.
  */

  (0, _react.useEffect)(function () {
    var optPromise = options,
        umounted = false;

    if (typeof options === 'function') {
      optPromise = options();
    }

    Promise.resolve(optPromise).then(function (res) {
      /* If component unmounted, dont update state */
      if (!umounted) {
        optionsLoaded && optionsLoaded(res, value);
        setFinalOptions([res || [], false]);
      }
    });
    return function () {
      return umounted = true;
    };
  }, [optionsReloadBasis]);
  /* Apply filter if any */

  var filteredOptions = controlProps.filter && controlProps.filter(finalOptions) || finalOptions;
  var realValue = getRealValue(filteredOptions, value, controlProps.creatable, controlProps.formatter);

  if (realValue && _lodash["default"].isPlainObject(realValue) && _lodash["default"].isUndefined(realValue.value)) {
    console.error('Undefined option value not allowed', realValue, filteredOptions);
  }

  var otherProps = {
    isSearchable: !readonly,
    isClearable: !readonly && (!_lodash["default"].isUndefined(controlProps.allowClear) ? controlProps.allowClear : true),
    isDisabled: Boolean(disabled)
  };
  var styles = customReactSelectStyles(theme, readonly || disabled);
  var onChangeOption = (0, _react.useCallback)(function (selectVal, action) {
    if (_lodash["default"].isArray(selectVal)) {
      // Check if select all option is selected
      if (!_lodash["default"].isUndefined(selectVal.find(function (x) {
        return x.label === 'Select All';
      }))) {
        selectVal = filteredOptions;
      }
      /* If multi select options need to be in some format by UI, use formatter */


      if (controlProps.formatter) {
        selectVal = controlProps.formatter.toRaw(selectVal, filteredOptions);
      } else {
        selectVal = selectVal.map(function (option) {
          return option.value;
        });
      }

      onChange && onChange(selectVal, action.name);
    } else {
      onChange && onChange(selectVal ? selectVal.value : null, action.name);
    }
  }, [onChange, filteredOptions]);

  var commonProps = _objectSpread(_objectSpread({
    components: {
      Option: CustomSelectOption,
      SingleValue: CustomSelectSingleValue
    },
    isMulti: Boolean(controlProps.multiple),
    openMenuOnClick: !readonly,
    onChange: onChangeOption,
    isLoading: isLoading,
    options: controlProps.allowSelectAll ? [{
      label: (0, _gettext["default"])('Select All'),
      value: '*'
    }].concat(_toConsumableArray(filteredOptions)) : filteredOptions,
    value: realValue,
    menuPortalTarget: document.body,
    styles: styles,
    inputId: cid,
    placeholder: readonly || disabled ? '' : controlProps.placeholder || (0, _gettext["default"])('Select an item...')
  }, otherProps), props);

  if (!controlProps.creatable) {
    return /*#__PURE__*/_react["default"].createElement(_reactSelect["default"], commonProps);
  } else {
    return /*#__PURE__*/_react["default"].createElement(_creatable["default"], commonProps);
  }
}

InputSelect.propTypes = {
  cid: _propTypes["default"].string,
  value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number, _propTypes["default"].array, _propTypes["default"].bool]),
  options: _propTypes["default"].oneOfType([_propTypes["default"].array, _propTypes["default"].instanceOf(Promise), _propTypes["default"].func]),
  controlProps: _propTypes["default"].object,
  optionsLoaded: _propTypes["default"].func,
  optionsReloadBasis: _propTypes["default"].any,
  onChange: _propTypes["default"].func,
  disabled: _propTypes["default"].bool,
  readonly: _propTypes["default"].bool
};

function FormInputSelect(_ref19) {
  var hasError = _ref19.hasError,
      required = _ref19.required,
      className = _ref19.className,
      label = _ref19.label,
      helpMessage = _ref19.helpMessage,
      testcid = _ref19.testcid,
      props = _objectWithoutProperties(_ref19, ["hasError", "required", "className", "label", "helpMessage", "testcid"]);

  return /*#__PURE__*/_react["default"].createElement(FormInput, {
    required: required,
    label: label,
    error: hasError,
    className: className,
    helpMessage: helpMessage,
    testcid: testcid
  }, /*#__PURE__*/_react["default"].createElement(InputSelect, props));
}

FormInputSelect.propTypes = {
  hasError: _propTypes["default"].bool,
  required: _propTypes["default"].bool,
  label: _propTypes["default"].string,
  className: _custom_prop_types["default"].className,
  helpMessage: _propTypes["default"].string,
  testcid: _propTypes["default"].string
};
/* React wrapper on color pickr */

function InputColor(_ref20) {
  var value = _ref20.value,
      controlProps = _ref20.controlProps,
      disabled = _ref20.disabled,
      onChange = _ref20.onChange,
      currObj = _ref20.currObj;

  var pickrOptions = _objectSpread(_objectSpread({
    showPalette: true,
    allowEmpty: true,
    colorFormat: 'HEX',
    defaultColor: null,
    position: 'right-middle',
    clearText: (0, _gettext["default"])('No color')
  }, controlProps), {}, {
    disabled: disabled
  });

  var eleRef = (0, _react.useRef)();
  var pickrObj = (0, _react.useRef)();
  var classes = useStyles();

  var setColor = function setColor(value) {
    pickrObj.current && pickrObj.current.setColor(_lodash["default"].isUndefined(value) || value == '' ? pickrOptions.defaultColor : value);
  };

  var destroyPickr = function destroyPickr() {
    if (pickrObj.current) {
      pickrObj.current.destroy();
      pickrObj.current = null;
    }
  };

  var initPickr = function initPickr() {
    /* pickr does not have way to update options, need to
    destroy and recreate pickr to reflect options */
    destroyPickr();
    pickrObj.current = new _pickr["default"]({
      el: eleRef.current,
      useAsButton: true,
      theme: 'monolith',
      swatches: ['#000', '#666', '#ccc', '#fff', '#f90', '#ff0', '#0f0', '#f0f', '#f4cccc', '#fce5cd', '#d0e0e3', '#cfe2f3', '#ead1dc', '#ea9999', '#b6d7a8', '#a2c4c9', '#d5a6bd', '#e06666', '#93c47d', '#76a5af', '#c27ba0', '#f1c232', '#6aa84f', '#45818e', '#a64d79', '#bf9000', '#0c343d', '#4c1130'],
      position: pickrOptions.position,
      strings: {
        clear: pickrOptions.clearText
      },
      components: {
        palette: pickrOptions.showPalette,
        preview: true,
        hue: pickrOptions.showPalette,
        interaction: {
          clear: pickrOptions.allowEmpty,
          defaultRepresentation: pickrOptions.colorFormat,
          disabled: pickrOptions.disabled
        }
      }
    }).on('init', function (instance) {
      setColor(value);
      disabled && instance.disable();
      var lastColor = instance.getRoot().preview.lastColor;
      var clear = instance.getRoot().interaction.clear;
      /* Cycle the keyboard navigation within the color picker */

      clear.addEventListener('keydown', function (e) {
        if (e.keyCode === 9) {
          e.preventDefault();
          e.stopPropagation();
          lastColor.focus();
        }
      });
      lastColor.addEventListener('keydown', function (e) {
        if (e.keyCode === 9 && e.shiftKey) {
          e.preventDefault();
          e.stopPropagation();
          clear.focus();
        }
      });
    }).on('clear', function () {
      onChange && onChange('');
    }).on('change', function (color) {
      onChange && onChange(color.toHEXA().toString());
    }).on('show', function (color, instance) {
      var palette = instance.getRoot().palette.palette;
      palette.focus();
    }).on('hide', function (instance) {
      var button = instance.getRoot().button;
      button.focus();
    });

    if (currObj) {
      currObj(pickrObj.current);
    }
  };

  (0, _react.useEffect)(function () {
    initPickr();
    return function () {
      destroyPickr();
    };
  }, _toConsumableArray(Object.values(pickrOptions)));
  (0, _react.useEffect)(function () {
    if (pickrObj.current) {
      setColor(value);
    }
  }, [value]);
  var btnStyles = {
    backgroundColor: value
  };
  return /*#__PURE__*/_react["default"].createElement(_Buttons.PgIconButton, {
    ref: eleRef,
    title: (0, _gettext["default"])('Select the color'),
    className: classes.colorBtn,
    style: btnStyles,
    disabled: pickrOptions.disabled,
    icon: (_lodash["default"].isUndefined(value) || _lodash["default"].isNull(value) || value === '') && /*#__PURE__*/_react["default"].createElement(_CloseRounded["default"], null)
  });
}

InputColor.propTypes = {
  value: _propTypes["default"].string,
  controlProps: _propTypes["default"].object,
  onChange: _propTypes["default"].func,
  disabled: _propTypes["default"].bool,
  currObj: _propTypes["default"].func
};

function FormInputColor(_ref21) {
  var hasError = _ref21.hasError,
      required = _ref21.required,
      className = _ref21.className,
      label = _ref21.label,
      helpMessage = _ref21.helpMessage,
      testcid = _ref21.testcid,
      props = _objectWithoutProperties(_ref21, ["hasError", "required", "className", "label", "helpMessage", "testcid"]);

  return /*#__PURE__*/_react["default"].createElement(FormInput, {
    required: required,
    label: label,
    error: hasError,
    className: className,
    helpMessage: helpMessage,
    testcid: testcid
  }, /*#__PURE__*/_react["default"].createElement(InputColor, props));
}

FormInputColor.propTypes = {
  hasError: _propTypes["default"].bool,
  required: _propTypes["default"].bool,
  className: _custom_prop_types["default"].className,
  label: _propTypes["default"].string,
  helpMessage: _propTypes["default"].string,
  testcid: _propTypes["default"].string
};

function PlainString(_ref22) {
  var controlProps = _ref22.controlProps,
      value = _ref22.value;
  var finalValue = value;

  if (controlProps !== null && controlProps !== void 0 && controlProps.formatter) {
    finalValue = controlProps.formatter.fromRaw(finalValue);
  }

  return /*#__PURE__*/_react["default"].createElement("span", null, finalValue);
}

PlainString.propTypes = {
  controlProps: _propTypes["default"].object,
  value: _propTypes["default"].any
};

function FormNote(_ref23) {
  var text = _ref23.text,
      className = _ref23.className;
  var classes = useStyles();
  return /*#__PURE__*/_react["default"].createElement(_core.Box, {
    className: className
  }, /*#__PURE__*/_react["default"].createElement(_core.Paper, {
    elevation: 0,
    className: classes.noteRoot
  }, /*#__PURE__*/_react["default"].createElement(_core.Box, {
    paddingRight: "0.25rem"
  }, /*#__PURE__*/_react["default"].createElement(_Description["default"], {
    fontSize: "small"
  })), /*#__PURE__*/_react["default"].createElement(_core.Box, null, (0, _htmlReactParser["default"])(text || ''))));
}

FormNote.propTypes = {
  text: _propTypes["default"].string,
  className: _custom_prop_types["default"].className
};
var useStylesFormFooter = (0, _styles.makeStyles)(function (theme) {
  return {
    root: {
      padding: theme.spacing(0.5),
      position: 'absolute',
      bottom: 0,
      left: 0,
      right: 0,
      zIndex: 10
    },
    container: {
      borderWidth: '1px',
      borderStyle: 'solid',
      borderRadius: theme.shape.borderRadius,
      padding: theme.spacing(0.5),
      display: 'flex',
      alignItems: 'center'
    },
    containerSuccess: {
      borderColor: theme.palette.success.main,
      backgroundColor: theme.palette.success.light
    },
    iconSuccess: {
      color: theme.palette.success.main
    },
    containerError: {
      borderColor: theme.palette.error.main,
      backgroundColor: theme.palette.error.light
    },
    iconError: {
      color: theme.palette.error.main
    },
    containerInfo: {
      borderColor: theme.palette.primary.main,
      backgroundColor: theme.palette.primary.light
    },
    iconInfo: {
      color: theme.palette.primary.main
    },
    containerWarning: {
      borderColor: theme.palette.warning.main,
      backgroundColor: theme.palette.warning.light
    },
    iconWarning: {
      color: theme.palette.warning.main
    },
    message: {
      marginLeft: theme.spacing(0.5)
    },
    closeButton: {
      marginLeft: 'auto'
    }
  };
});
/* The form footer used mostly for showing error */

function FormFooterMessage(props) {
  var classes = useStylesFormFooter();

  if (!props.message) {
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null);
  }

  return /*#__PURE__*/_react["default"].createElement(_core.Box, {
    className: classes.root
  }, /*#__PURE__*/_react["default"].createElement(NotifierMessage, props));
}

FormFooterMessage.propTypes = {
  message: _propTypes["default"].string
};

function NotifierMessage(_ref24) {
  var _ref24$type = _ref24.type,
      type = _ref24$type === void 0 ? MESSAGE_TYPE.SUCCESS : _ref24$type,
      message = _ref24.message,
      _ref24$closable = _ref24.closable,
      closable = _ref24$closable === void 0 ? true : _ref24$closable,
      _ref24$onClose = _ref24.onClose,
      onClose = _ref24$onClose === void 0 ? function () {} : _ref24$onClose;
  var classes = useStylesFormFooter();
  return /*#__PURE__*/_react["default"].createElement(_core.Box, {
    className: (0, _clsx["default"])(classes.container, classes["container".concat(type)])
  }, /*#__PURE__*/_react["default"].createElement(FormIcon, {
    type: type,
    className: classes["icon".concat(type)]
  }), /*#__PURE__*/_react["default"].createElement(_core.Box, {
    className: classes.message
  }, message), closable && /*#__PURE__*/_react["default"].createElement(_core.IconButton, {
    className: (0, _clsx["default"])(classes.closeButton, classes["icon".concat(type)]),
    onClick: onClose
  }, /*#__PURE__*/_react["default"].createElement(FormIcon, {
    close: true
  })));
}

NotifierMessage.propTypes = {
  type: _propTypes["default"].oneOf(Object.values(MESSAGE_TYPE)).isRequired,
  message: _propTypes["default"].string,
  closable: _propTypes["default"].bool,
  onClose: _propTypes["default"].func
};

/***/ }),

/***/ 85650:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



__webpack_require__(69070);

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.default = Loader;

var _core = __webpack_require__(65770);

var _react = _interopRequireDefault(__webpack_require__(67294));

var _propTypes = _interopRequireDefault(__webpack_require__(45697));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/////////////////////////////////////////////////////////////
//
// pgAdmin 4 - PostgreSQL Tools
//
// Copyright (C) 2013 - 2022, The pgAdmin Development Team
// This software is released under the PostgreSQL Licence
//
//////////////////////////////////////////////////////////////
var useStyles = (0, _core.makeStyles)(function (theme) {
  return {
    root: {
      position: 'absolute',
      top: 0,
      bottom: 0,
      left: 0,
      right: 0,
      backgroundColor: theme.otherVars.loader.backgroundColor,
      color: theme.otherVars.loader.color,
      zIndex: 1000,
      display: 'flex'
    },
    loaderRoot: {
      color: theme.otherVars.loader.color,
      display: 'flex',
      alignItems: 'center',
      margin: 'auto',
      '.MuiTypography-root': {
        marginLeft: theme.spacing(1)
      }
    },
    loader: {
      color: theme.otherVars.loader.color
    },
    message: {
      marginLeft: '0.5rem'
    }
  };
});

function Loader(_ref) {
  var message = _ref.message;
  var classes = useStyles();

  if (!message) {
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null);
  }

  return /*#__PURE__*/_react["default"].createElement(_core.Box, {
    className: classes.root
  }, /*#__PURE__*/_react["default"].createElement(_core.Box, {
    className: classes.loaderRoot
  }, /*#__PURE__*/_react["default"].createElement(_core.CircularProgress, {
    className: classes.loader
  }), /*#__PURE__*/_react["default"].createElement(_core.Typography, {
    className: classes.message
  }, message)));
}

Loader.propTypes = {
  message: _propTypes["default"].string
};

/***/ }),

/***/ 19928:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



__webpack_require__(47042);

__webpack_require__(41539);

__webpack_require__(91038);

__webpack_require__(78783);

__webpack_require__(82526);

__webpack_require__(41817);

__webpack_require__(32165);

__webpack_require__(66992);

__webpack_require__(33948);

__webpack_require__(79753);

__webpack_require__(69070);

__webpack_require__(47941);

__webpack_require__(57327);

__webpack_require__(38880);

__webpack_require__(49337);

__webpack_require__(33321);

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.default = Privilege;

__webpack_require__(21249);

__webpack_require__(69826);

__webpack_require__(89554);

__webpack_require__(54747);

__webpack_require__(68309);

__webpack_require__(26541);

var _core = __webpack_require__(65770);

var _lodash = _interopRequireDefault(__webpack_require__(96486));

var _react = _interopRequireDefault(__webpack_require__(67294));

var _FormComponents = __webpack_require__(93299);

var _clsx = _interopRequireDefault(__webpack_require__(86010));

var _propTypes = _interopRequireDefault(__webpack_require__(45697));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var useStyles = (0, _core.makeStyles)(function () {
  return {
    /* Display the privs table only when focussed */
    root: {
      '&:not(:focus-within) .priv-table': {
        display: 'none'
      }
    },
    table: {
      borderSpacing: 0,
      width: '100%',
      fontSize: '0.8em'
    },
    tableCell: {
      textAlign: 'left'
    }
  };
});

function Privilege(_ref) {
  var value = _ref.value,
      onChange = _ref.onChange,
      controlProps = _ref.controlProps;
  // All available privileges in the PostgreSQL database server for
  // generating the label for the specific Control
  var LABELS = {
    'C': 'CREATE',
    'T': 'TEMPORARY',
    'c': 'CONNECT',
    'a': 'INSERT',
    'r': 'SELECT',
    'w': 'UPDATE',
    'd': 'DELETE',
    'D': 'TRUNCATE',
    'x': 'REFERENCES',
    't': 'TRIGGER',
    'U': 'USAGE',
    'X': 'EXECUTE'
  };
  var all = false;
  var allWithGrant = false;
  var classes = useStyles();
  var textValue = '';

  var _iterator = _createForOfIteratorHelper(value || []),
      _step;

  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      var v = _step.value;

      if (v.privilege) {
        textValue += v.privilege_type;

        if (v.with_grant) {
          textValue += '*';
        }
      }
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }

  var checkboxId = _lodash["default"].uniqueId();
  /* Calculate the real display value by merging all supported privs with incoming value */


  var realVal = ((controlProps === null || controlProps === void 0 ? void 0 : controlProps.supportedPrivs) || []).map(function (priv) {
    var inValue = _lodash["default"].find(value, function (v) {
      return v.privilege_type === priv;
    }) || {
      privilege: false,
      with_grant: false
    };
    return {
      privilege_type: priv,
      privilege: Boolean(inValue.privilege),
      with_grant: Boolean(inValue.with_grant)
    };
  });

  var onCheckAll = function onCheckAll(e, forWithGrant) {
    var newValue = [];
    /* Push all the privs or ignore if unchecked and return empty */

    realVal.forEach(function (v) {
      if (forWithGrant) {
        newValue.push(_objectSpread(_objectSpread({}, v), {}, {
          privilege: true,
          with_grant: e.target.checked
        }));
      } else if (e.target.checked) {
        newValue.push(_objectSpread(_objectSpread({}, v), {}, {
          privilege: e.target.checked
        }));
      }
    });
    onChange(newValue);
  };

  var onCheck = function onCheck(e, forWithGrant) {
    var exists = false;
    var newValue = [];
    /* Calculate the newValue by pushing all selected and ignore if unchecked */

    (value || []).forEach(function (v) {
      if (v.privilege_type === e.target.name) {
        exists = true;

        if (forWithGrant) {
          newValue.push(_objectSpread(_objectSpread({}, v), {}, {
            with_grant: e.target.checked
          }));
        }
      } else {
        newValue.push(v);
      }
    });

    if (!exists && e.target.checked) {
      newValue.push({
        privilege_type: e.target.name,
        privilege: e.target.checked,
        with_grant: false
      });
    }

    onChange(newValue);
  };
  /* If all supported privs and incoming value length matches, clearly all are selected */


  all = realVal.length === (value || []).length;
  allWithGrant = realVal.length === (value || []).length && (value || []).every(function (d) {
    return d.with_grant;
  });
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: classes.root
  }, /*#__PURE__*/_react["default"].createElement(_FormComponents.InputText, {
    value: textValue,
    readOnly: true
  }), /*#__PURE__*/_react["default"].createElement("table", {
    className: (0, _clsx["default"])(classes.table, 'priv-table')
  }, realVal.length > 1 && /*#__PURE__*/_react["default"].createElement("thead", null, /*#__PURE__*/_react["default"].createElement("tr", null, /*#__PURE__*/_react["default"].createElement("td", {
    className: classes.tableCell
  }, /*#__PURE__*/_react["default"].createElement(_FormComponents.InputCheckbox, {
    name: "all",
    controlProps: {
      label: 'ALL'
    },
    id: checkboxId,
    size: "small",
    onChange: function onChange(e) {
      return onCheckAll(e, false);
    },
    value: all
  })), /*#__PURE__*/_react["default"].createElement("td", {
    className: classes.tableCell
  }, /*#__PURE__*/_react["default"].createElement(_FormComponents.InputCheckbox, {
    name: "all",
    controlProps: {
      label: 'WITH GRANT OPTION'
    },
    id: checkboxId,
    size: "small",
    disabled: !all,
    onChange: function onChange(e) {
      return onCheckAll(e, true);
    },
    value: allWithGrant
  })))), /*#__PURE__*/_react["default"].createElement("tbody", null, realVal.map(function (d) {
    return /*#__PURE__*/_react["default"].createElement("tr", {
      key: d.privilege_type
    }, /*#__PURE__*/_react["default"].createElement("td", {
      className: classes.tableCell
    }, /*#__PURE__*/_react["default"].createElement(_FormComponents.InputCheckbox, {
      name: d.privilege_type,
      controlProps: {
        label: LABELS[d.privilege_type]
      },
      id: checkboxId,
      value: Boolean(d.privilege),
      size: "small",
      onChange: function onChange(e) {
        return onCheck(e, false);
      }
    })), /*#__PURE__*/_react["default"].createElement("td", {
      className: classes.tableCell
    }, /*#__PURE__*/_react["default"].createElement(_FormComponents.InputCheckbox, {
      name: d.privilege_type,
      controlProps: {
        label: 'WITH GRANT OPTION'
      },
      id: checkboxId,
      value: Boolean(d.with_grant),
      size: "small",
      disabled: !d.privilege,
      onChange: function onChange(e) {
        return onCheck(e, true);
      }
    })));
  }))));
}

Privilege.propTypes = {
  value: _propTypes["default"].array,
  onChange: _propTypes["default"].func,
  controlProps: _propTypes["default"].object
};

/***/ }),

/***/ 3622:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

__webpack_require__(82526);

__webpack_require__(79753);

__webpack_require__(41817);

__webpack_require__(41539);

__webpack_require__(32165);

__webpack_require__(78783);

__webpack_require__(66992);

__webpack_require__(33948);

__webpack_require__(47042);

__webpack_require__(68309);

__webpack_require__(91038);

__webpack_require__(19601);

__webpack_require__(4129);

__webpack_require__(69070);

__webpack_require__(38880);

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.SelectRefresh = SelectRefresh;

__webpack_require__(47941);

__webpack_require__(82772);

var _react = _interopRequireWildcard(__webpack_require__(67294));

var _core = __webpack_require__(65770);

var _FormComponents = __webpack_require__(93299);

var _propTypes = _interopRequireDefault(__webpack_require__(45697));

var _custom_prop_types = _interopRequireDefault(__webpack_require__(41832));

var _Refresh = _interopRequireDefault(__webpack_require__(36210));

var _Buttons = __webpack_require__(87451);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function SelectRefresh(_ref) {
  var required = _ref.required,
      className = _ref.className,
      label = _ref.label,
      helpMessage = _ref.helpMessage,
      testcid = _ref.testcid,
      controlProps = _ref.controlProps,
      props = _objectWithoutProperties(_ref, ["required", "className", "label", "helpMessage", "testcid", "controlProps"]);

  var _useState = (0, _react.useState)([]),
      _useState2 = _slicedToArray(_useState, 2),
      options = _useState2[0],
      setOptions = _useState2[1];

  var _useState3 = (0, _react.useState)(false),
      _useState4 = _slicedToArray(_useState3, 2),
      optionsReloadBasis = _useState4[0],
      setOptionsReloadBasis = _useState4[1];

  var getOptionsOnRefresh = controlProps.getOptionsOnRefresh,
      selectControlProps = _objectWithoutProperties(controlProps, ["getOptionsOnRefresh"]);

  var onRefreshClick = function onRefreshClick() {
    getOptionsOnRefresh && getOptionsOnRefresh().then(function (res) {
      setOptions(res);
      setOptionsReloadBasis(function (prevVal) {
        return !prevVal;
      });
    });
  };

  return /*#__PURE__*/_react["default"].createElement(_FormComponents.FormInput, {
    required: required,
    label: label,
    className: className,
    helpMessage: helpMessage,
    testcid: testcid
  }, /*#__PURE__*/_react["default"].createElement(_core.Box, {
    display: "flex"
  }, /*#__PURE__*/_react["default"].createElement(_core.Box, {
    flexGrow: "1"
  }, /*#__PURE__*/_react["default"].createElement(_FormComponents.InputSelect, _extends({}, props, {
    options: options,
    optionsReloadBasis: optionsReloadBasis,
    controlProps: selectControlProps
  }))), /*#__PURE__*/_react["default"].createElement(_core.Box, null, /*#__PURE__*/_react["default"].createElement(_Buttons.PgIconButton, {
    onClick: onRefreshClick,
    icon: /*#__PURE__*/_react["default"].createElement(_Refresh["default"], null),
    title: label || ''
  }))));
}

SelectRefresh.propTypes = {
  required: _propTypes["default"].bool,
  label: _propTypes["default"].string,
  className: _custom_prop_types["default"].className,
  helpMessage: _propTypes["default"].string,
  testcid: _propTypes["default"].string,
  controlProps: _propTypes["default"].object
};

/***/ }),

/***/ 32982:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



__webpack_require__(69070);

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.default = TabPanel;

var _react = _interopRequireDefault(__webpack_require__(67294));

var _core = __webpack_require__(65770);

var _clsx = _interopRequireDefault(__webpack_require__(86010));

var _propTypes = _interopRequireDefault(__webpack_require__(45697));

var _custom_prop_types = _interopRequireDefault(__webpack_require__(41832));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/////////////////////////////////////////////////////////////
//
// pgAdmin 4 - PostgreSQL Tools
//
// Copyright (C) 2013 - 2022, The pgAdmin Development Team
// This software is released under the PostgreSQL Licence
//
//////////////////////////////////////////////////////////////
var useStyles = (0, _core.makeStyles)(function (theme) {
  return {
    root: {
      height: '100%',
      padding: theme.spacing(1),
      overflow: 'auto',
      backgroundColor: theme.palette.grey[400]
    },
    content: {
      height: '100%'
    }
  };
});
/* Material UI does not have any tabpanel component, we create one for us */

function TabPanel(_ref) {
  var children = _ref.children,
      classNameRoot = _ref.classNameRoot,
      className = _ref.className,
      value = _ref.value,
      index = _ref.index;
  var classes = useStyles();
  var active = value === index;
  return /*#__PURE__*/_react["default"].createElement(_core.Box, {
    className: (0, _clsx["default"])(classes.root, classNameRoot),
    component: "div",
    hidden: !active
  }, /*#__PURE__*/_react["default"].createElement(_core.Box, {
    className: (0, _clsx["default"])(classes.content, className)
  }, children));
}

TabPanel.propTypes = {
  children: _custom_prop_types["default"].children,
  classNameRoot: _custom_prop_types["default"].className,
  className: _custom_prop_types["default"].className,
  value: _propTypes["default"].any.isRequired,
  index: _propTypes["default"].any.isRequired
};

/***/ }),

/***/ 87789:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



__webpack_require__(69070);

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.setPGCSRFToken = setPGCSRFToken;

__webpack_require__(88674);

__webpack_require__(41539);

var _jquery = _interopRequireDefault(__webpack_require__(19755));

var _backbone = _interopRequireDefault(__webpack_require__(72316));

var _axios = _interopRequireDefault(__webpack_require__(9669));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/////////////////////////////////////////////////////////////
//
// pgAdmin 4 - PostgreSQL Tools
//
// Copyright (C) 2013 - 2022, The pgAdmin Development Team
// This software is released under the PostgreSQL Licence
//
//////////////////////////////////////////////////////////////
function setPGCSRFToken(header, token) {
  if (!token) {
    // Throw error message.
    throw 'csrf-token meta tag has not been set';
  } // Configure Backbone.sync to set CSRF-Token-header request header for
  // every requests except GET.


  var origBackboneSync = _backbone["default"].sync;

  _backbone["default"].sync = function (method, model, options) {
    options.beforeSend = function (xhr) {
      xhr.setRequestHeader(header, token);
    };

    return origBackboneSync(method, model, options);
  }; // Configure Backbone.get to set 'X-CSRFToken' request header for
  // GET requests.


  var origBackboneGet = _backbone["default"].get;

  _backbone["default"].get = function (method, model, options) {
    options.beforeSend = function (xhr) {
      xhr.setRequestHeader(header, token);
    };

    return origBackboneGet(method, model, options);
  }; // Configure jquery.ajax to set 'X-CSRFToken' request header for
  // every requests.


  _jquery["default"].ajaxSetup({
    beforeSend: function beforeSend(xhr) {
      xhr.setRequestHeader(header, token);
    }
  }); // Configure axios to set 'X-CSRFToken' request header for
  // every requests.


  _axios["default"].interceptors.request.use(function (config) {
    config.headers[header] = token;
    return config;
  }, function (error) {
    return Promise.reject(error);
  });
}

/***/ }),

/***/ 50464:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



__webpack_require__(79753);

__webpack_require__(82526);

__webpack_require__(41817);

__webpack_require__(41539);

__webpack_require__(32165);

__webpack_require__(78783);

__webpack_require__(66992);

__webpack_require__(33948);

__webpack_require__(47042);

__webpack_require__(68309);

__webpack_require__(91038);

__webpack_require__(69070);

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.useInterval = useInterval;
exports.usePrevious = usePrevious;
exports.useDelayDebounce = useDelayDebounce;
exports.useOnScreen = useOnScreen;
exports.useIsMounted = useIsMounted;

__webpack_require__(32564);

var _react = __webpack_require__(67294);

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

/* React hook for setInterval */
function useInterval(callback, delay) {
  var savedCallback = (0, _react.useRef)();
  (0, _react.useEffect)(function () {
    savedCallback.current = callback;
  });
  (0, _react.useEffect)(function () {
    function tick() {
      savedCallback.current();
    }

    if (delay > -1) {
      var id = setInterval(tick, delay);
      return function () {
        return clearInterval(id);
      };
    }
  }, [delay]);
}

function usePrevious(value) {
  var ref = (0, _react.useRef)();
  (0, _react.useEffect)(function () {
    ref.current = value;
  });
  return ref.current;
}

function useDelayDebounce(callback, args, delay) {
  (0, _react.useEffect)(function () {
    var delayDebounceFn = setTimeout(function () {
      if (args) {
        callback(args);
      }
    }, delay);
    return function () {
      return clearTimeout(delayDebounceFn);
    };
  }, [args]);
}

function useOnScreen(ref) {
  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      isIntersecting = _useState2[0],
      setIntersecting = _useState2[1];

  var observer = new IntersectionObserver(function (_ref) {
    var _ref2 = _slicedToArray(_ref, 1),
        entry = _ref2[0];

    setIntersecting(entry.isIntersecting);
  });
  (0, _react.useEffect)(function () {
    if (ref !== null && ref !== void 0 && ref.current) {
      observer.observe(ref.current);
    } // Remove the observer as soon as the component is unmounted


    return function () {
      observer.disconnect();
    };
  }, []);
  return isIntersecting;
}

function useIsMounted() {
  var ref = (0, _react.useRef)(true);
  (0, _react.useEffect)(function () {
    return function () {
      ref.current = false;
    };
  }, []);
  return (0, _react.useCallback)(function () {
    return ref.current;
  }, []);
}

/***/ }),

/***/ 41832:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



__webpack_require__(69070);

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.default = void 0;

var _propTypes = _interopRequireDefault(__webpack_require__(45697));

var _base_schema = _interopRequireDefault(__webpack_require__(89406));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/////////////////////////////////////////////////////////////
//
// pgAdmin 4 - PostgreSQL Tools
//
// Copyright (C) 2013 - 2022, The pgAdmin Development Team
// This software is released under the PostgreSQL Licence
//
//////////////////////////////////////////////////////////////

/* Common Prop types */
var CustomPropTypes = {
  ref: _propTypes["default"].oneOfType([_propTypes["default"].func, _propTypes["default"].shape({
    current: _propTypes["default"].instanceOf(Element)
  })]),
  schemaUI: _propTypes["default"].instanceOf(_base_schema["default"]),
  children: _propTypes["default"].oneOfType([_propTypes["default"].arrayOf(_propTypes["default"].node), _propTypes["default"].node]),
  className: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].object])
};
var _default = CustomPropTypes;
exports.default = _default;

/***/ }),

/***/ 89087:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {



__webpack_require__(69826);

__webpack_require__(24812);

__webpack_require__(32564);

__webpack_require__(69070);

var _jquery = _interopRequireDefault(__webpack_require__(19755));

var _mousetrap = _interopRequireDefault(__webpack_require__(42441));

var _utils = __webpack_require__(44092);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var dialogTabNavigator = /*#__PURE__*/function () {
  function dialogTabNavigator(dialogContainer, backwardShortcut, forwardShortcut) {
    _classCallCheck(this, dialogTabNavigator);

    this.dialogContainer = dialogContainer;
    this.tabSwitching = false;
    this.tabs = this.dialogContainer.find('.nav-tabs:visible');

    if (this.tabs.length > 0) {
      this.tabs = this.tabs[0];
    }

    this.dialogTabBackward = (0, _utils.parseShortcutValue)(backwardShortcut);
    this.dialogTabForward = (0, _utils.parseShortcutValue)(forwardShortcut);
    (0, _mousetrap["default"])(this.dialogContainer[0]).bind(this.dialogTabBackward, this.onKeyboardEvent.bind(this));
    (0, _mousetrap["default"])(this.dialogContainer[0]).bind(this.dialogTabForward, this.onKeyboardEvent.bind(this));
  }

  _createClass(dialogTabNavigator, [{
    key: "onKeyboardEvent",
    value: function onKeyboardEvent(event, shortcut) {
      var currentTabPane = this.dialogContainer.find('.tab-content:first > .tab-pane.active:first:visible'),
          childTabData = this.isActivePaneHasChildTabs(currentTabPane);

      if (this.tabSwitching) {
        return;
      }

      this.tabSwitching = true;

      if (childTabData) {
        var res = this.navigate(shortcut, childTabData.childTab, childTabData.childTabPane, event);

        if (!res) {
          this.navigate(shortcut, this.tabs, currentTabPane, event);
        }
      } else {
        this.navigate(shortcut, this.tabs, currentTabPane, event);
      }
    }
  }, {
    key: "isActivePaneHasChildTabs",
    value: function isActivePaneHasChildTabs(currentTabPane) {
      var childTab = currentTabPane.find('.nav-tabs:first:visible'),
          childTabPane;

      if (childTab.length > 0) {
        childTabPane = currentTabPane.find('.tab-content:first > .tab-pane.active:first:visible');
        return {
          'childTab': childTab,
          'childTabPane': childTabPane
        };
      }

      return null;
    }
  }, {
    key: "navigate",
    value: function navigate(shortcut, tabs, tab_pane, event) {
      if (shortcut == this.dialogTabBackward) {
        return this.navigateBackward(tabs, tab_pane, event);
      } else if (shortcut == this.dialogTabForward) {
        return this.navigateForward(tabs, tab_pane, event);
      }

      return false;
    }
  }, {
    key: "navigateBackward",
    value: function navigateBackward(tabs, tab_pane, event) {
      var self = this,
          nextTabPane,
          innerTabContainer,
          prevtab = (0, _jquery["default"])(tabs).find('li').has('a.active').prev('li');

      if (prevtab.length > 0) {
        prevtab.find('a').tab('show');
        nextTabPane = tab_pane.prev();
        innerTabContainer = nextTabPane.find('.tab-content:first > .tab-pane.active:first:visible');

        if (innerTabContainer.length > 0) {
          (0, _utils.findAndSetFocus)(innerTabContainer);
        } else {
          (0, _utils.findAndSetFocus)(nextTabPane);
        }

        setTimeout(function () {
          self.tabSwitching = false;
        }, 200);
        event.stopPropagation();
        return true;
      }

      this.tabSwitching = false;
      return false;
    }
  }, {
    key: "navigateForward",
    value: function navigateForward(tabs, tab_pane, event) {
      var self = this,
          nextTabPane,
          innerTabContainer,
          nexttab = (0, _jquery["default"])(tabs).find('li').has('a.active').next('li');

      if (nexttab.length > 0) {
        nexttab.find('a').tab('show');
        nextTabPane = tab_pane.next();
        innerTabContainer = nextTabPane.find('.tab-content:first > .tab-pane.active:first:visible');

        if (innerTabContainer.length > 0) {
          (0, _utils.findAndSetFocus)(innerTabContainer);
        } else {
          (0, _utils.findAndSetFocus)(nextTabPane);
        }

        setTimeout(function () {
          self.tabSwitching = false;
        }, 200);
        event.stopPropagation();
        return true;
      }

      this.tabSwitching = false;
      return false;
    }
  }, {
    key: "detach",
    value: function detach() {
      (0, _mousetrap["default"])(this.dialogContainer[0]).unbind(this.dialogTabBackward);
      (0, _mousetrap["default"])(this.dialogContainer[0]).unbind(this.dialogTabForward);
    }
  }]);

  return dialogTabNavigator;
}();

module.exports = {
  dialogTabNavigator: dialogTabNavigator
};

/***/ }),

/***/ 91669:
/***/ ((module, exports, __webpack_require__) => {

var __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;

__webpack_require__(69600);

__webpack_require__(21249);

__webpack_require__(23123);

__webpack_require__(74916);

/////////////////////////////////////////////////////////////
//
// pgAdmin 4 - PostgreSQL Tools
//
// Copyright (C) 2013 - 2022, The pgAdmin Development Team
// This software is released under the PostgreSQL Licence
//
//////////////////////////////////////////////////////////////
!(__WEBPACK_AMD_DEFINE_ARRAY__ = [__webpack_require__(52536)], __WEBPACK_AMD_DEFINE_RESULT__ = (function (translations) {
  /***
   * This method behaves as a drop-in replacement for flask translation rendering.
   * It uses the same translation file under the hood and uses flask to determine the language.
   * It is slightly tweaked to work like sprintf
   * ex. translate("some %s text", "cool")
   *
   * @param {String} text
   */
  return function gettext(text) {
    var rawTranslation = translations[text] ? translations[text] : text;

    if (arguments.length == 1) {
      return rawTranslation;
    }

    try {
      var replaceArgs = arguments;
      return rawTranslation.split('%s').map(function (w, i) {
        if (i > 0) {
          if (i < replaceArgs.length) {
            return [replaceArgs[i], w].join('');
          } else {
            return ['%s', w].join('');
          }
        } else {
          return w;
        }
      }).join('');
    } catch (e) {
      console.error(e);
      return rawTranslation;
    }
  };
}).apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__),
		__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));

/***/ }),

/***/ 96066:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



__webpack_require__(82526);

__webpack_require__(41817);

__webpack_require__(32165);

__webpack_require__(78783);

__webpack_require__(66992);

__webpack_require__(33948);

__webpack_require__(47042);

__webpack_require__(68309);

__webpack_require__(91038);

__webpack_require__(69070);

__webpack_require__(47941);

__webpack_require__(38880);

__webpack_require__(89554);

__webpack_require__(54747);

__webpack_require__(49337);

__webpack_require__(33321);

__webpack_require__(19601);

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.useModal = useModal;
exports.default = ModalProvider;

__webpack_require__(41539);

__webpack_require__(39714);

__webpack_require__(83710);

__webpack_require__(92222);

__webpack_require__(57327);

__webpack_require__(21249);

__webpack_require__(79753);

var _core = __webpack_require__(65770);

var _react = _interopRequireDefault(__webpack_require__(67294));

var _utils = __webpack_require__(44092);

var _Buttons = __webpack_require__(87451);

var _reactDraggable = _interopRequireDefault(__webpack_require__(61193));

var _CloseRounded = _interopRequireDefault(__webpack_require__(79138));

var _custom_prop_types = _interopRequireDefault(__webpack_require__(41832));

var _propTypes = _interopRequireDefault(__webpack_require__(45697));

var _gettext = _interopRequireDefault(__webpack_require__(91669));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var ModalContext = /*#__PURE__*/_react["default"].createContext({});

function useModal() {
  return _react["default"].useContext(ModalContext);
}

function ModalProvider(_ref) {
  var children = _ref.children;

  var _React$useState = _react["default"].useState([]),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      modals = _React$useState2[0],
      setModals = _React$useState2[1];

  var showModal = function showModal(title, content, modalOptions) {
    var id = (0, _utils.getEpoch)().toString() + Math.random();
    setModals(function (prev) {
      return [].concat(_toConsumableArray(prev), [_objectSpread({
        id: id,
        title: title,
        content: content
      }, modalOptions)]);
    });
  };

  var closeModal = function closeModal(id) {
    setModals(function (prev) {
      return prev.filter(function (o) {
        return o.id != id;
      });
    });
  };

  var modalContext = _react["default"].useMemo(function () {
    return {
      showModal: showModal,
      closeModal: closeModal
    };
  }, []);

  return /*#__PURE__*/_react["default"].createElement(ModalContext.Provider, {
    value: modalContext
  }, children, modals.map(function (modalOptions, i) {
    return /*#__PURE__*/_react["default"].createElement(ModalContainer, _extends({
      key: i
    }, modalOptions));
  }));
}

ModalProvider.propTypes = {
  children: _custom_prop_types["default"].children
};

function PaperComponent(props) {
  return /*#__PURE__*/_react["default"].createElement(_reactDraggable["default"], {
    cancel: '[class*="MuiDialogContent-root"]'
  }, /*#__PURE__*/_react["default"].createElement(_core.Paper, _extends({}, props, {
    style: {
      minWidth: '600px'
    }
  })));
}

function ModalContainer(_ref2) {
  var id = _ref2.id,
      title = _ref2.title,
      content = _ref2.content;
  var useModalRef = useModal();

  var closeModal = function closeModal() {
    return useModalRef.closeModal(id);
  };

  return /*#__PURE__*/_react["default"].createElement(_core.Dialog, {
    open: true,
    onClose: closeModal,
    PaperComponent: PaperComponent,
    disableBackdropClick: true
  }, /*#__PURE__*/_react["default"].createElement(_core.DialogTitle, null, /*#__PURE__*/_react["default"].createElement(_core.Box, {
    marginRight: "0.25rem"
  }, title), /*#__PURE__*/_react["default"].createElement(_core.Box, {
    marginLeft: "auto"
  }, /*#__PURE__*/_react["default"].createElement(_Buttons.PgIconButton, {
    title: (0, _gettext["default"])('Close'),
    icon: /*#__PURE__*/_react["default"].createElement(_CloseRounded["default"], null),
    size: "xs",
    noBorder: true,
    onClick: closeModal
  }))), /*#__PURE__*/_react["default"].createElement(_core.DialogContent, null, content(closeModal)));
}

ModalContainer.propTypes = {
  id: _propTypes["default"].string,
  title: _custom_prop_types["default"].children,
  content: _propTypes["default"].func
};

/***/ }),

/***/ 55958:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

__webpack_require__(47941);

__webpack_require__(82526);

__webpack_require__(57327);

__webpack_require__(38880);

__webpack_require__(89554);

__webpack_require__(54747);

__webpack_require__(49337);

__webpack_require__(33321);

__webpack_require__(4129);

__webpack_require__(41539);

__webpack_require__(78783);

__webpack_require__(66992);

__webpack_require__(33948);

__webpack_require__(41817);

__webpack_require__(32165);

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.initializeNotifier = initializeNotifier;
exports.initializeModalProvider = initializeModalProvider;
exports.default = void 0;

__webpack_require__(82772);

__webpack_require__(15306);

__webpack_require__(74916);

__webpack_require__(24603);

__webpack_require__(39714);

__webpack_require__(69070);

var _notistack = __webpack_require__(73400);

var _react = _interopRequireDefault(__webpack_require__(67294));

var _reactDom = _interopRequireDefault(__webpack_require__(73935));

var _Theme = _interopRequireDefault(__webpack_require__(4394));

var _FormComponents = __webpack_require__(93299);

var _custom_prop_types = _interopRequireDefault(__webpack_require__(41832));

var _gettext = _interopRequireDefault(__webpack_require__(91669));

var _lodash = _interopRequireDefault(__webpack_require__(96486));

var _window = _interopRequireDefault(__webpack_require__(1950));

var _ModalProvider = _interopRequireWildcard(__webpack_require__(96066));

var _Buttons = __webpack_require__(87451);

var _core = __webpack_require__(65770);

var _styles = __webpack_require__(7361);

var _htmlReactParser = _interopRequireDefault(__webpack_require__(15020));

var _CloseRounded = _interopRequireDefault(__webpack_require__(79138));

var _CheckRounded = _interopRequireDefault(__webpack_require__(45569));

var _propTypes = _interopRequireDefault(__webpack_require__(45697));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var AUTO_HIDE_DURATION = 3000; // In milliseconds

var snackbarRef;
var notifierInitialized = false;

function initializeNotifier(notifierContainer) {
  notifierInitialized = true;

  var RefLoad = function RefLoad() {
    snackbarRef = (0, _notistack.useSnackbar)();
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null);
  };

  if (!notifierContainer) {
    notifierContainer = document.createElement('div');
    document.body.appendChild(notifierContainer);
  }

  _reactDom["default"].render( /*#__PURE__*/_react["default"].createElement(_Theme["default"], null, /*#__PURE__*/_react["default"].createElement(_notistack.SnackbarProvider, {
    maxSnack: 30,
    anchorOrigin: {
      horizontal: 'right',
      vertical: 'bottom'
    }
  }, /*#__PURE__*/_react["default"].createElement(RefLoad, null))), notifierContainer);
}

var modalRef;
var modalInitialized = false;

function initializeModalProvider(modalContainer) {
  modalInitialized = true;

  var RefLoad = function RefLoad() {
    modalRef = (0, _ModalProvider.useModal)();
    return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null);
  };

  if (!modalContainer) {
    modalContainer = document.createElement('div');
    document.body.appendChild(modalContainer);
  }

  _reactDom["default"].render( /*#__PURE__*/_react["default"].createElement(_Theme["default"], null, /*#__PURE__*/_react["default"].createElement(_ModalProvider["default"], null, /*#__PURE__*/_react["default"].createElement(RefLoad, null))), modalContainer);
}

var FinalNotifyContent = /*#__PURE__*/_react["default"].forwardRef(function (_ref, ref) {
  var children = _ref.children;
  return /*#__PURE__*/_react["default"].createElement(_notistack.SnackbarContent, {
    style: {
      justifyContent: 'end'
    },
    ref: ref
  }, children);
});

FinalNotifyContent.displayName = 'FinalNotifyContent';
FinalNotifyContent.propTypes = {
  children: _custom_prop_types["default"].children
};
var useAlertStyles = (0, _styles.makeStyles)(function (theme) {
  return {
    footer: _objectSpread({
      display: 'flex',
      justifyContent: 'flex-end',
      padding: '0.5rem'
    }, theme.mixins.panelBorder.top),
    margin: {
      marginLeft: '0.25rem'
    }
  };
});

function AlertContent(_ref2) {
  var text = _ref2.text,
      confirm = _ref2.confirm,
      _ref2$okLabel = _ref2.okLabel,
      okLabel = _ref2$okLabel === void 0 ? (0, _gettext["default"])('OK') : _ref2$okLabel,
      _ref2$cancelLabel = _ref2.cancelLabel,
      cancelLabel = _ref2$cancelLabel === void 0 ? (0, _gettext["default"])('Cancel') : _ref2$cancelLabel,
      onOkClick = _ref2.onOkClick,
      onCancelClick = _ref2.onCancelClick;
  var classes = useAlertStyles();
  return /*#__PURE__*/_react["default"].createElement(_core.Box, {
    display: "flex",
    flexDirection: "column",
    height: "100%"
  }, /*#__PURE__*/_react["default"].createElement(_core.Box, {
    flexGrow: "1",
    p: 2
  }, (0, _htmlReactParser["default"])(text)), /*#__PURE__*/_react["default"].createElement(_core.Box, {
    className: classes.footer
  }, confirm && /*#__PURE__*/_react["default"].createElement(_Buttons.DefaultButton, {
    startIcon: /*#__PURE__*/_react["default"].createElement(_CloseRounded["default"], null),
    onClick: onCancelClick
  }, cancelLabel), /*#__PURE__*/_react["default"].createElement(_Buttons.PrimaryButton, {
    className: classes.margin,
    startIcon: /*#__PURE__*/_react["default"].createElement(_CheckRounded["default"], null),
    onClick: onOkClick,
    autoFocus: true
  }, okLabel)));
}

AlertContent.propTypes = {
  text: _propTypes["default"].string,
  confirm: _propTypes["default"].bool,
  onOkClick: _propTypes["default"].func,
  onCancelClick: _propTypes["default"].func,
  okLabel: _propTypes["default"].string,
  cancelLabel: _propTypes["default"].string
};
var Notifier = {
  success: function success(msg) {
    var autoHideDuration = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : AUTO_HIDE_DURATION;

    this._callNotify(msg, _FormComponents.MESSAGE_TYPE.SUCCESS, autoHideDuration);
  },
  warning: function warning(msg) {
    var autoHideDuration = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : AUTO_HIDE_DURATION;

    this._callNotify(msg, _FormComponents.MESSAGE_TYPE.WARNING, autoHideDuration);
  },
  info: function info(msg) {
    var autoHideDuration = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : AUTO_HIDE_DURATION;

    this._callNotify(msg, _FormComponents.MESSAGE_TYPE.INFO, autoHideDuration);
  },
  error: function error(msg) {
    var autoHideDuration = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : AUTO_HIDE_DURATION;

    this._callNotify(msg, _FormComponents.MESSAGE_TYPE.ERROR, autoHideDuration);
  },
  notify: function notify(_content, autoHideDuration) {
    if (_content) {
      if (!notifierInitialized) {
        initializeNotifier();
      }

      var options = {
        autoHideDuration: autoHideDuration,
        content: function content(key) {
          return /*#__PURE__*/_react["default"].createElement(FinalNotifyContent, null, /*#__PURE__*/_react["default"].cloneElement(_content, {
            onClose: function onClose() {
              snackbarRef.closeSnackbar(key);
            }
          }));
        }
      };
      options.content.displayName = 'content';
      snackbarRef.enqueueSnackbar(null, options);
    }
  },
  _callNotify: function _callNotify(msg, type, autoHideDuration) {
    if (!_lodash["default"].isNull(autoHideDuration)) {
      this.notify( /*#__PURE__*/_react["default"].createElement(_FormComponents.NotifierMessage, {
        type: type,
        message: msg,
        closable: false
      }), autoHideDuration);
    } else {
      this.notify( /*#__PURE__*/_react["default"].createElement(_FormComponents.NotifierMessage, {
        type: type,
        message: msg
      }), null);
    }
  },
  pgRespErrorNotify: function pgRespErrorNotify(xhr, error) {
    var prefixMsg = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '';
    var contentType = xhr.getResponseHeader('Content-Type');

    if (xhr.status === 410) {
      var pgBrowser = window.pgAdmin.Browser;
      pgBrowser.report_error((0, _gettext["default"])('Error: Object not found - %s.', xhr.statusText), xhr.responseJSON.errormsg);
    } else {
      try {
        if (xhr.status === 0) {
          error = (0, _gettext["default"])('Connection to the server has been lost.');
        } else {
          if (contentType) {
            if (contentType.indexOf('application/json') >= 0) {
              var resp = JSON.parse(xhr.responseText);
              error = _lodash["default"].escape(resp.result) || _lodash["default"].escape(resp.errormsg) || (0, _gettext["default"])('Unknown error');
            }
          }

          if (contentType.indexOf('text/html') >= 0) {
            error = (0, _gettext["default"])('INTERNAL SERVER ERROR');
            console.warn(xhr.responseText);
          }
        }
      } catch (e) {
        error = e.message;
      }

      this.error(prefixMsg + ' ' + error);
    }
  },
  pgNotifier: function pgNotifier(type, xhr, promptmsg, onJSONResult) {
    var msg = xhr.responseText,
        contentType = xhr.getResponseHeader('Content-Type');

    if (xhr.status == 0) {
      msg = (0, _gettext["default"])('Connection to the server has been lost.');
      promptmsg = (0, _gettext["default"])('Connection Lost');
    } else {
      if (contentType) {
        try {
          if (contentType.indexOf('application/json') == 0) {
            var resp = JSON.parse(msg);

            if (resp.info == 'CRYPTKEY_MISSING') {
              var pgBrowser = window.pgAdmin.Browser;
              pgBrowser.set_master_password('', function () {
                if (onJSONResult && typeof onJSONResult == 'function') {
                  onJSONResult('CRYPTKEY_SET');
                }
              });
              return;
            } else if (resp.result != null && (!resp.errormsg || resp.errormsg == '') && onJSONResult && typeof onJSONResult == 'function') {
              return onJSONResult(resp.result);
            }

            msg = _lodash["default"].escape(resp.result) || _lodash["default"].escape(resp.errormsg) || 'Unknown error';
          }

          if (contentType.indexOf('text/html') == 0) {
            if (type === 'error') {
              this.alert('Error', promptmsg);
            }

            return;
          }
        } catch (e) {
          this.alert('Error', e.message);
        }
      }
    }

    this.alert(promptmsg, msg.replace(new RegExp(/\r?\n/, 'g'), '<br />'));
  },
  alert: function alert(title, text) {
    var okLabel = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : (0, _gettext["default"])('OK');
    var onOkClick = arguments.length > 3 ? arguments[3] : undefined;

    if (!modalInitialized) {
      initializeModalProvider();
    }

    modalRef.showModal(title, function (closeModal) {
      var onOkClickClose = function onOkClickClose() {
        onOkClick && onOkClick();
        closeModal();
      };

      return /*#__PURE__*/_react["default"].createElement(AlertContent, {
        text: text,
        onOkClick: onOkClickClose,
        okLabel: okLabel
      });
    });
  },
  confirm: function confirm(title, text, onOkClick, onCancelClick) {
    var okLabel = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : (0, _gettext["default"])('Yes');
    var cancelLabel = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : (0, _gettext["default"])('No');

    if (!modalInitialized) {
      initializeModalProvider();
    }

    modalRef.showModal(title, function (closeModal) {
      var onCancelClickClose = function onCancelClickClose() {
        onCancelClick && onCancelClick();
        closeModal();
      };

      var onOkClickClose = function onOkClickClose() {
        onOkClick && onOkClick();
        closeModal();
      };

      return /*#__PURE__*/_react["default"].createElement(AlertContent, {
        text: text,
        confirm: true,
        onOkClick: onOkClickClose,
        onCancelClick: onCancelClickClose,
        okLabel: okLabel,
        cancelLabel: cancelLabel
      });
    });
  }
};

if (window.frameElement) {
  Notifier = _window["default"].Notifier || Notifier;
} else if (!_window["default"].Notifier) {
  _window["default"].Notifier = Notifier;
}

var _default = Notifier;
exports.default = _default;

/***/ }),

/***/ 81922:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



__webpack_require__(69070);

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.confirmDeleteRow = confirmDeleteRow;
exports.showFileDialog = showFileDialog;
exports.onPgadminEvent = onPgadminEvent;
exports.offPgadminEvent = offPgadminEvent;

var _gettext = _interopRequireDefault(__webpack_require__(91669));

var _pgadmin = _interopRequireDefault(__webpack_require__(55112));

var _Notifier = _interopRequireDefault(__webpack_require__(55958));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/////////////////////////////////////////////////////////////
//
// pgAdmin 4 - PostgreSQL Tools
//
// Copyright (C) 2013 - 2022, The pgAdmin Development Team
// This software is released under the PostgreSQL Licence
//
//////////////////////////////////////////////////////////////

/* This file will have wrappers and connectors used by React components to
 * re-use any existing non-react components.
 * These functions may not be needed once all are migrated
 */
function confirmDeleteRow(onOK, onCancel, title, message) {
  _Notifier["default"].confirm(title || (0, _gettext["default"])('Delete Row'), message || (0, _gettext["default"])('Are you sure you wish to delete this row?'), function () {
    onOK();
    return true;
  }, function () {
    onCancel();
    return true;
  });
}
/* Used by file select component to re-use existing logic */


function showFileDialog(dialogParams, onFileSelect) {
  var params = {
    supported_types: dialogParams.supportedTypes || [],
    dialog_type: dialogParams.dialogType || 'select_file',
    dialog_title: dialogParams.dialogTitle || '',
    btn_primary: dialogParams.btnPrimary || ''
  };

  _pgadmin["default"].FileManager.init();

  _pgadmin["default"].FileManager.show_dialog(params);

  var onFileSelectClose = function onFileSelectClose(value) {
    removeListeners();
    onFileSelect(value);
  };

  var onDialogClose = function onDialogClose() {
    return removeListeners();
  };

  _pgadmin["default"].Browser.Events.on('pgadmin-storage:finish_btn:' + params.dialog_type, onFileSelectClose);

  _pgadmin["default"].Browser.Events.on('pgadmin-storage:cancel_btn:' + params.dialog_type, onDialogClose);

  var removeListeners = function removeListeners() {
    _pgadmin["default"].Browser.Events.off('pgadmin-storage:finish_btn:' + params.dialog_type, onFileSelectClose);

    _pgadmin["default"].Browser.Events.off('pgadmin-storage:cancel_btn:' + params.dialog_type, onDialogClose);
  };
}

function onPgadminEvent(eventName, handler) {
  _pgadmin["default"].Browser.Events.on(eventName, handler);
}

function offPgadminEvent(eventName, handler) {
  _pgadmin["default"].Browser.Events.off(eventName, handler);
}

/***/ }),

/***/ 72945:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



__webpack_require__(69070);

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.processEventDebugger = keyboardShortcutsDebugger;
exports.processEventQueryTool = keyboardShortcutsQueryTool;
exports.focusDockerPanel = focusDockerPanel;
exports.validateShortcutKeys = validateShortcutKeys;
exports.validateMacros = validateMacros;
exports._stopEventPropagation = _stopEventPropagation;
exports.isMac = isMac;
exports.isKeyCtrlAlt = isKeyCtrlAlt;
exports.isKeyAltShift = isKeyAltShift;
exports.isKeyCtrlShift = isKeyCtrlShift;
exports.isKeyCtrlAltShift = isKeyCtrlAltShift;
exports.isAltShiftBoth = isAltShiftBoth;
exports.isCtrlShiftBoth = isCtrlShiftBoth;
exports.isCtrlAltBoth = isCtrlAltBoth;
exports.shortcut_key = shortcut_key;
exports.shortcut_title = shortcut_title;
exports.shortcut_accesskey_title = shortcut_accesskey_title;

__webpack_require__(64765);

__webpack_require__(74916);

__webpack_require__(92222);

__webpack_require__(69826);

__webpack_require__(57327);

var _jquery = _interopRequireDefault(__webpack_require__(19755));

var _gettext = _interopRequireDefault(__webpack_require__(91669));

var _utils = __webpack_require__(44092);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

//////////////////////////////////////////////////////////////////////////
//
// pgAdmin 4 - PostgreSQL Tools
//
// Copyright (C) 2013 - 2022, The pgAdmin Development Team
// This software is released under the PostgreSQL Licence
//
//////////////////////////////////////////////////////////////////////////
var PERIOD_KEY = 190,
    FWD_SLASH_KEY = 191,
    ESC_KEY = 27,
    LEFT_KEY = 37,
    UP_KEY = 38,
    RIGHT_KEY = 39,
    DOWN_KEY = 40,
    K_KEY = 75;

function isMac() {
  return window.navigator.platform.search('Mac') != -1;
}

function isKeyCtrlAlt(event) {
  return event.ctrlKey || event.altKey;
}

function isKeyAltShift(event) {
  return event.altKey || event.shiftKey;
}

function isKeyCtrlShift(event) {
  return event.ctrlKey || event.shiftKey;
}

function isKeyCtrlAltShift(event) {
  return event.ctrlKey || event.altKey || event.shiftKey;
}

function isAltShiftBoth(event) {
  return event.altKey && event.shiftKey && !event.ctrlKey;
}

function isCtrlShiftBoth(event) {
  return event.ctrlKey && event.shiftKey && !event.altKey;
}

function isCtrlAltBoth(event) {
  return event.ctrlKey && event.altKey && !event.shiftKey;
}
/* Returns the key of shortcut */


function shortcut_key(shortcut) {
  var key = '';

  if (shortcut['key'] && shortcut['key']['char']) {
    key = shortcut['key']['char'].toUpperCase();
  }

  return key;
}
/* Converts shortcut object to title representation
 * Shortcut object is browser.get_preference().value
 */


function shortcut_title(title, shortcut) {
  var text_representation = '';

  if (typeof shortcut === 'undefined' || shortcut === null) {
    return text_representation;
  }

  if (shortcut['alt']) {
    text_representation = (0, _gettext["default"])('Alt') + '+';
  }

  if (shortcut['shift']) {
    text_representation += (0, _gettext["default"])('Shift') + '+';
  }

  if (shortcut['control']) {
    text_representation += (0, _gettext["default"])('Ctrl') + '+';
  }

  text_representation += shortcut_key(shortcut);
  return "".concat(title, " (").concat(text_representation, ")");
}
/* Returns the key char of shortcut
 * shortcut object is browser.get_preference().value
 */


function shortcut_accesskey_title(title, shortcut) {
  return "".concat(title, " (") + (0, _gettext["default"])('accesskey') + " + ".concat(shortcut_key(shortcut), ")");
}

function _stopEventPropagation(event) {
  event.cancelBubble = true;
  event.preventDefault();
  event.stopPropagation();
  event.stopImmediatePropagation();
}
/* Function use to validate shortcut keys */


function validateShortcutKeys(user_defined_shortcut, event) {
  if (!user_defined_shortcut) {
    return false;
  }

  var keyCode = event.which || event.keyCode;
  return user_defined_shortcut.alt == event.altKey && user_defined_shortcut.shift == event.shiftKey && user_defined_shortcut.control == event.ctrlKey && user_defined_shortcut.key.key_code == keyCode;
} // Finds the desired panel on which user wants to navigate to


function focusDockerPanel(docker, op) {
  if (!docker) {
    return;
  } // If no frame in focus, focus the first one


  if (!docker._focusFrame) {
    if (docker._frameList.length == 0 && docker._frameList[0]._panelList.length == 0) {
      return;
    }

    docker._frameList[0]._panelList[docker._frameList[0]._curTab].focus();
  }

  var focus_frame = docker._focusFrame,
      focus_id = 0,
      flash = false; // Mod is used to cycle the op

  if (op == 'switch') {
    var i,
        total_frames = docker._frameList.length;

    for (i = 0; i < total_frames; i++) {
      if (focus_frame === docker._frameList[i]) break;
    }

    focus_frame = docker._frameList[(0, _utils.getMod)(i + 1, total_frames)];
    focus_id = focus_frame._curTab;
    flash = true;
  } else if (op == 'left') {
    focus_id = (0, _utils.getMod)(focus_frame._curTab - 1, focus_frame._panelList.length);
  } else if (op == 'right') {
    focus_id = (0, _utils.getMod)(focus_frame._curTab + 1, focus_frame._panelList.length);
  }

  var focus_panel = focus_frame._panelList[focus_id];
  focus_panel.$container.find('*[tabindex]:not([tabindex="-1"])').trigger('focus');
  focus_panel.focus(flash);
  return focus_panel._type;
}
/* Debugger: Keyboard Shortcuts handling */


function keyboardShortcutsDebugger($el, event, preferences, docker) {
  var panel_type = '',
      panel_content,
      $input;

  if (this.validateShortcutKeys(preferences.edit_grid_values, event)) {
    this._stopEventPropagation(event);

    panel_content = $el.find('div.wcPanelTabContent:not(".wcPanelTabContentHidden")');

    if (panel_content.length) {
      $input = (0, _jquery["default"])(panel_content).find('td.editable:first');
      if ($input.length) $input.trigger('click');
    }
  } else if (this.validateShortcutKeys(preferences.move_next, event)) {
    this._stopEventPropagation(event);

    panel_type = focusDockerPanel(docker, 'right');
  } else if (this.validateShortcutKeys(preferences.move_previous, event)) {
    this._stopEventPropagation(event);

    panel_type = focusDockerPanel(docker, 'left');
  } else if (this.validateShortcutKeys(preferences.switch_panel, event)) {
    this._stopEventPropagation(event);

    panel_type = focusDockerPanel(docker, 'switch');
  }

  return panel_type;
}
/* Query tool: Keyboard Shortcuts handling */


function keyboardShortcutsQueryTool(sqlEditorController, queryToolActions, event, docker) {
  if (sqlEditorController.isQueryRunning()) {
    return;
  }

  var keyCode = event.which || event.keyCode,
      panel_type = '';
  var executeKeys = sqlEditorController.preferences.execute_query;
  var explainKeys = sqlEditorController.preferences.explain_query;
  var explainAnalyzeKeys = sqlEditorController.preferences.explain_analyze_query;
  var downloadCsvKeys = sqlEditorController.preferences.download_results;
  var nextTabKeys = sqlEditorController.preferences.move_next;
  var previousTabKeys = sqlEditorController.preferences.move_previous;
  var switchPanelKeys = sqlEditorController.preferences.switch_panel;
  var toggleCaseKeys = sqlEditorController.preferences.toggle_case;
  var commitKeys = sqlEditorController.preferences.commit_transaction;
  var rollbackKeys = sqlEditorController.preferences.rollback_transaction;
  var saveDataKeys = sqlEditorController.preferences.save_data;
  var queryToolKeys = sqlEditorController.preferences.show_query_tool;

  if (this.validateShortcutKeys(executeKeys, event)) {
    this._stopEventPropagation(event);

    queryToolActions.executeQuery(sqlEditorController);
  } else if (this.validateShortcutKeys(explainKeys, event)) {
    this._stopEventPropagation(event);

    queryToolActions.explain(sqlEditorController);
  } else if (this.validateShortcutKeys(explainAnalyzeKeys, event)) {
    this._stopEventPropagation(event);

    queryToolActions.explainAnalyze(sqlEditorController);
  } else if (this.validateShortcutKeys(downloadCsvKeys, event)) {
    if (!sqlEditorController.is_save_results_to_file_disabled) {
      this._stopEventPropagation(event);

      queryToolActions.download(sqlEditorController);
    }
  } else if (this.validateShortcutKeys(toggleCaseKeys, event)) {
    this._stopEventPropagation(event);

    queryToolActions.toggleCaseOfSelectedText(sqlEditorController);
  } else if (this.validateShortcutKeys(commitKeys, event)) {
    // If transaction buttons are disabled then no need to execute commit.
    if (!sqlEditorController.is_transaction_buttons_disabled) {
      this._stopEventPropagation(event);

      queryToolActions.executeCommit(sqlEditorController);
    }
  } else if (this.validateShortcutKeys(rollbackKeys, event)) {
    // If transaction buttons are disabled then no need to execute rollback.
    if (!sqlEditorController.is_transaction_buttons_disabled) {
      this._stopEventPropagation(event);

      queryToolActions.executeRollback(sqlEditorController);
    }
  } else if (this.validateShortcutKeys(saveDataKeys, event)) {
    this._stopEventPropagation(event);

    queryToolActions.saveDataChanges(sqlEditorController);
  } else if (this.validateShortcutKeys(queryToolKeys, event)) {
    this._stopEventPropagation(event);

    queryToolActions.openQueryTool(sqlEditorController);
  } else if ((this.isMac() && event.metaKey || !this.isMac() && event.ctrlKey) && !event.altKey && event.shiftKey && keyCode === FWD_SLASH_KEY) {
    this._stopEventPropagation(event);

    queryToolActions.commentBlockCode(sqlEditorController);
  } else if ((this.isMac() && !this.isKeyCtrlAltShift(event) && event.metaKey || !this.isMac() && !this.isKeyAltShift(event) && event.ctrlKey) && keyCode === FWD_SLASH_KEY) {
    this._stopEventPropagation(event);

    queryToolActions.commentLineCode(sqlEditorController);
  } else if ((this.isMac() && !this.isKeyCtrlAltShift(event) && event.metaKey || !this.isMac() && !this.isKeyAltShift(event) && event.ctrlKey) && keyCode === PERIOD_KEY) {
    this._stopEventPropagation(event);

    queryToolActions.uncommentLineCode(sqlEditorController);
  } else if ((this.isMac() && event.metaKey || !this.isMac() && event.ctrlKey) && !event.altKey && event.shiftKey && keyCode === K_KEY) {
    this._stopEventPropagation(event);

    queryToolActions.formatSql(sqlEditorController);
  } else if (keyCode == ESC_KEY) {
    queryToolActions.focusOut(sqlEditorController);
    /*Apply only for sub-dropdown*/

    if ((0, _jquery["default"])(event.target).hasClass('dropdown-item') && (0, _jquery["default"])(event.target).closest('.dropdown-submenu').length > 0) {
      (0, _jquery["default"])(event.target).closest('.dropdown-submenu').find('.dropdown-menu').removeClass('show');
    }
  } else if (this.validateShortcutKeys(nextTabKeys, event)) {
    this._stopEventPropagation(event);

    panel_type = focusDockerPanel(docker, 'right');
  } else if (this.validateShortcutKeys(previousTabKeys, event)) {
    this._stopEventPropagation(event);

    panel_type = focusDockerPanel(docker, 'left');
  } else if (this.validateShortcutKeys(switchPanelKeys, event)) {
    this._stopEventPropagation(event);

    panel_type = focusDockerPanel(docker, 'switch');
  } else if (keyCode === UP_KEY || keyCode === DOWN_KEY) {
    /*Apply only for dropdown*/
    if ((0, _jquery["default"])(event.target).closest('.dropdown-menu').length > 0) {
      this._stopEventPropagation(event);

      var currLi = (0, _jquery["default"])(event.target).closest('li');
      /*close all the submenus on movement*/

      (0, _jquery["default"])(event.target).closest('.dropdown-menu').find('.show').removeClass('show');

      if (keyCode === UP_KEY) {
        currLi = currLi.prev();
      } else if (keyCode === DOWN_KEY) {
        currLi = currLi.next();
      }
      /*do not focus on divider, disabled and d-none */


      while (currLi.hasClass('dropdown-divider') || currLi.hasClass('d-none') || currLi.find('.dropdown-item').first().hasClass('disabled')) {
        if (keyCode === UP_KEY) {
          currLi = currLi.prev();
        } else if (keyCode === DOWN_KEY) {
          currLi = currLi.next();
        }
      }

      currLi.find('.dropdown-item').trigger('focus');
    }
  } else if (keyCode === LEFT_KEY || keyCode === RIGHT_KEY) {
    /*Apply only for dropdown*/
    if ((0, _jquery["default"])(event.target).closest('.dropdown-menu').length > 0) {
      this._stopEventPropagation(event);

      var _currLi = (0, _jquery["default"])(event.target).closest('li');

      if (keyCode === RIGHT_KEY) {
        /*open submenu if any*/
        if (_currLi.hasClass('dropdown-submenu')) {
          _currLi.find('.dropdown-menu').addClass('show');

          _currLi.find('.dropdown-menu .dropdown-item').first().trigger('focus');
        }
      } else if (keyCode === LEFT_KEY) {
        /*close submenu*/
        var currMenu = _currLi.closest('.dropdown-menu');

        if (currMenu.closest('.dropdown-submenu').length > 0) {
          currMenu.removeClass('show');
          _currLi = currMenu.closest('.dropdown-submenu');

          _currLi.find('.dropdown-item').trigger('focus');
        }
      }
    }
  } else {
    // Macros
    var macroId = this.validateMacros(sqlEditorController, event);

    if (macroId !== false) {
      this._stopEventPropagation(event);

      queryToolActions.executeMacro(sqlEditorController, macroId);
    }
  }

  return panel_type;
}

function validateMacros(sqlEditorController, event) {
  var keyCode = event.which || event.keyCode;
  var macro = sqlEditorController.macros.filter(function (mc) {
    return mc.alt == event.altKey && mc.control == event.ctrlKey && mc.key_code == keyCode;
  });

  if (macro.length == 1) {
    return macro[0].id;
  }

  return false;
}

/***/ }),

/***/ 55112:
/***/ ((module, exports, __webpack_require__) => {

var __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;

__webpack_require__(82526);

__webpack_require__(41817);

__webpack_require__(32165);

__webpack_require__(78783);

__webpack_require__(66992);

__webpack_require__(33948);

__webpack_require__(4723);

__webpack_require__(74916);

__webpack_require__(54678);

__webpack_require__(47042);

__webpack_require__(15306);

__webpack_require__(23123);

__webpack_require__(91058);

__webpack_require__(83710);

__webpack_require__(41539);

__webpack_require__(39714);

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

/////////////////////////////////////////////////////////////
//
// pgAdmin 4 - PostgreSQL Tools
//
// Copyright (C) 2013 - 2022, The pgAdmin Development Team
// This software is released under the PostgreSQL Licence
//
//////////////////////////////////////////////////////////////
!(__WEBPACK_AMD_DEFINE_ARRAY__ = [], __WEBPACK_AMD_DEFINE_RESULT__ = (function () {
  var pgAdmin = window.pgAdmin = window.pgAdmin || {}; // Reference:
  // https://github.com/heygrady/Units/blob/master/Length.min.js
  // Changed it to save the function in pgAdmin object.

  (function (t, e, o) {
    'use strict';

    function r(_t, _e, _r, _p) {
      _r = _r || 'width';

      var _n,
          _l,
          _m,
          _c = (_e.match(s) || [])[2],
          _f = 'px' === _c ? 1 : d[_c + 'toPx'],
          _u = /r?em/i;

      if (_f || _u.test(_c) && !_p) {
        _t = _f ? _t : 'rem' === _c ? i : 'fontSize' === _r ? +t.parentNode || _t : _t;
        _f = _f || parseFloat(a(_t, 'fontSize'));
        _m = parseFloat(_e) * _f;
      } else {
        _n = _t.style;
        _l = _n[_r];

        try {
          _n[_r] = _e;
        } catch (x) {
          return 0;
        }

        _m = _n[_r] ? parseFloat(a(_t, _r)) : 0;
        _n[_r] = _l !== o ? _l : null;
      }

      return _m;
    }

    function a(_t, _e) {
      var _o,
          _n,
          _i,
          _l,
          _d,
          _c = /^top|bottom/,
          _f = ['paddingTop', 'paddingBottom', 'borderTop', 'borderBottom'],
          _u = 4;

      _n = _t.style['pixel' + _e.charAt(0).toUpperCase() + _e.slice(1)];
      _o = m ? m(_t)[_e] : _n ? _n + 'px' : 'fontSize' === _e ? r(_t, '1em', 'left', 1) + 'px' : _t.currentStyle[_e];
      _i = (_o.match(s) || [])[2];
      if ('%' === _i && p) {
        if (_c.test(_e)) {
          for (_l = (_d = _t.parentNode || _t).offsetHeight; _u--;) {
            _l -= parseFloat(a(_d, _f[_u]));
          }

          _o = parseFloat(_o) / 100 * _l + 'px';
        } else _o = r(_t, _o);
      } else ('auto' === _o || _i && 'px' !== _i) && m ? _o = 0 : _i && 'px' !== _i && !m && (_o = r(_t, _o) + 'px');
      return _o;
    }

    var p,
        n = e.createElement('test'),
        i = e.documentElement,
        l = e.defaultView,
        m = l && l.getComputedStyle,
        s = /^(-?[\d+\.\-]+)([a-z]+|%)$/i,
        d = {},
        c = [1 / 25.4, 1 / 2.54, 1 / 72, 1 / 6],
        f = ['mm', 'cm', 'pt', 'pc', 'in', 'mozmm'],
        u = 6;

    for (i.appendChild(n), m && (n.style.marginTop = '1%', p = '1%' === m(n).marginTop); u--;) {
      d[f[u] + 'toPx'] = c[u] ? c[u] * d.inToPx : r(n, '1' + f[u]);
    }

    i.removeChild(n);
    t.toPx = r;
  })(pgAdmin, window.document); // Reference:
  // https://github.com/javve/natural-sort/blob/master/index.js
  // Changed it to save the function in pgAdmin object.


  pgAdmin.natural_sort = function (a, b, options) {
    options = options || {};

    var re = /(^-?[0-9]+(\.?[0-9]*)[df]?e?[0-9]?$|^0x[0-9a-f]+$|[0-9]+)/gi,
        sre = /(^[ ]*|[ ]*$)/g,
        dre = /(^([\w ]+,?[\w ]+)?[\w ]+,?[\w ]+\d+:\d+(:\d+)?[\w ]?|^\d{1,4}[\/\-]\d{1,4}[\/\-]\d{1,4}|^\w+, \w+ \d+, \d{4})/,
        hre = /^0x[0-9a-f]+$/i,
        ore = /^0/,
        i = function i(s) {
      return options.insensitive && ('' + s).toLowerCase() || '' + s;
    },
        // convert all to strings strip whitespace
    x = i(a).replace(sre, '') || '',
        y = i(b).replace(sre, '') || '',
        // chunk/tokenize
    xN = x.replace(re, '\0$1\0').replace(/\0$/, '').replace(/^\0/, '').split('\0'),
        yN = y.replace(re, '\0$1\0').replace(/\0$/, '').replace(/^\0/, '').split('\0'),
        // numeric, hex or date detection
    xD = parseInt(x.match(hre)) || xN.length !== 1 && x.match(dre) && Date.parse(x),
        yD = parseInt(y.match(hre)) || xD && y.match(dre) && Date.parse(y) || null,
        oFxNcL,
        oFyNcL,
        mult = options.desc ? -1 : 1; // first try and sort Hex codes or Dates


    if (yD) if (xD < yD) return -1 * mult;else if (xD > yD) return 1 * mult; // natural sorting through split numeric strings and default strings

    for (var cLoc = 0, numS = Math.max(xN.length, yN.length); cLoc < numS; cLoc++) {
      // find floats not starting with '0', string or 0 if not defined (Clint Priest)
      oFxNcL = !(xN[cLoc] || '').match(ore) && parseFloat(xN[cLoc]) || xN[cLoc] || 0;
      oFyNcL = !(yN[cLoc] || '').match(ore) && parseFloat(yN[cLoc]) || yN[cLoc] || 0; // handle numeric vs string comparison - number < string - (Kyle Adams)

      if (isNaN(oFxNcL) !== isNaN(oFyNcL)) {
        return (isNaN(oFxNcL) ? 1 : -1) * mult;
      } // rely on string comparison if different types - i.e. '02' < 2 != '02' < '2'
      else if (_typeof(oFxNcL) !== _typeof(oFyNcL)) {
          oFxNcL += '';
          oFyNcL += '';
        }

      if (oFxNcL < oFyNcL) return -1 * mult;
      if (oFxNcL > oFyNcL) return 1 * mult;
    }

    return 0;
  };

  pgAdmin.numeric_comparator = function (a, b) {
    a = parseInt(a);
    b = parseInt(b);
    if (a < b) return -1;else if (a == b) return 0;else return 1;
  };
  /**
   * Decimal adjustment of a number.
   *
   * @param {String}  type  The type of adjustment.
   * @param {Number}  value The number.
   * @param {Integer} exp   The exponent (the 10 logarithm of the adjustment base).
   * @returns {Number} The adjusted value.
   */


  function decimalAdjust(type, value, exp) {
    // If the exp is undefined or zero...
    if (typeof exp === 'undefined' || +exp === 0) {
      return Math[type](value);
    }

    value = +value;
    exp = +exp; // If the value is not a number or the exp is not an integer...

    if (isNaN(value) || exp % 1 !== 0) {
      return NaN;
    } // Shift


    value = value.toString().split('e');
    value = Math[type](+(value[0] + 'e' + (value[1] ? +value[1] - exp : -exp))); // Shift back

    value = value.toString().split('e');
    return +(value[0] + 'e' + (value[1] ? +value[1] + exp : exp));
  } // Decimal round


  if (!Math.round10) {
    Math.round10 = function (value, exp) {
      return decimalAdjust('round', value, exp);
    };
  } // Decimal floor


  if (!Math.floor10) {
    Math.floor10 = function (value, exp) {
      return decimalAdjust('floor', value, exp);
    };
  } // Decimal ceil


  if (!Math.ceil10) {
    Math.ceil10 = function (value, exp) {
      return decimalAdjust('ceil', value, exp);
    };
  }

  pgAdmin.ui = {
    dialogs: {}
  };
  return pgAdmin;
}).apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__),
		__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));

/***/ }),

/***/ 75471:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



__webpack_require__(69070);

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.default = _default;

__webpack_require__(47042);

__webpack_require__(20454);

var _jquery = _interopRequireDefault(__webpack_require__(19755));

var _underscore = _interopRequireDefault(__webpack_require__(81311));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _default(options) {
  if (options.showOnScroll) {
    var Utils = _jquery["default"].fn.select2.amd.require('select2/utils');
    /* Define on scroll showing of dropdown items.
     * This also requires ajax option of select2 to be set.
     * The trick is, ajax: {} will also work even if you're actually not
     * using ajax.
     */


    var ScrollDataAdapter = function ScrollDataAdapter($element, dropdownOptions) {
      this.$element = $element;
      this.options = dropdownOptions;
      this._dataToConvert = dropdownOptions.get('data') || [];
    };

    var BaseAdapter = null;

    if (options.data != null) {
      BaseAdapter = _jquery["default"].fn.select2.amd.require('select2/data/array');
    } else {
      BaseAdapter = _jquery["default"].fn.select2.amd.require('select2/data/select');
    }

    Utils.Extend(ScrollDataAdapter, BaseAdapter);

    ScrollDataAdapter.prototype.query = function (params, callback) {
      var data = [];
      var self = this;

      if (!params.page) {
        params.page = 1;
      }

      var pageSize = 20;
      var $options = this.$element.children();
      $options.each(function () {
        var $option = (0, _jquery["default"])(this);

        if (!$option.is('option') && !$option.is('optgroup')) {
          return;
        }

        var option = self.item($option);
        var matches = self.matches(params, option);

        if (matches !== null) {
          data.push(matches);
        }
      });
      callback({
        results: data.slice((params.page - 1) * pageSize, params.page * pageSize),
        pagination: {
          more: data.length >= params.page * pageSize
        }
      });
    };

    if (options.minimumInputLength > 0) {
      ScrollDataAdapter = Utils.Decorate(ScrollDataAdapter, _jquery["default"].fn.select2.amd.require('select2/data/minimumInputLength'));
    }

    if (options.maximumInputLength > 0) {
      ScrollDataAdapter = Utils.Decorate(ScrollDataAdapter, _jquery["default"].fn.select2.amd.require('select2/data/maximumInputLength'));
    }

    if (options.maximumSelectionLength > 0) {
      ScrollDataAdapter = Utils.Decorate(ScrollDataAdapter, _jquery["default"].fn.select2.amd.require('select2/data/maximumSelectionLength'));
    }

    if (options.tags) {
      ScrollDataAdapter = Utils.Decorate(ScrollDataAdapter, _jquery["default"].fn.select2.amd.require('select2/data/tags'));
    }

    if (options.tokenSeparators != null || options.tokenizer != null) {
      ScrollDataAdapter = Utils.Decorate(ScrollDataAdapter, _jquery["default"].fn.select2.amd.require('select2/data/tokenizer'));
    }

    options.dataAdapter = ScrollDataAdapter;
    /* Setting empty ajax option will enable infinite scrolling. */

    if (_underscore["default"].isUndefined(options.ajax)) {
      options.ajax = {};
    }
  }

  return options;
}

/***/ }),

/***/ 81240:
/***/ ((module, exports, __webpack_require__) => {

var __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;

__webpack_require__(41539);

__webpack_require__(68309);

__webpack_require__(91038);

__webpack_require__(78783);

__webpack_require__(82526);

__webpack_require__(41817);

__webpack_require__(32165);

__webpack_require__(66992);

__webpack_require__(33948);

__webpack_require__(69600);

__webpack_require__(15306);

__webpack_require__(74916);

__webpack_require__(47042);

__webpack_require__(54678);

__webpack_require__(9653);

__webpack_require__(79753);

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

//////////////////////////////////////////////////////////////////////////
//
// pgAdmin 4 - PostgreSQL Tools
//
// Copyright (C) 2013 - 2022, The pgAdmin Development Team
// This software is released under the PostgreSQL Licence
//
//////////////////////////////////////////////////////////////////////////
// This file contains common utilities functions used in sqleditor modules
!(__WEBPACK_AMD_DEFINE_ARRAY__ = [__webpack_require__(19755), __webpack_require__(81311), __webpack_require__(91669), __webpack_require__(28008), __webpack_require__(55455)], __WEBPACK_AMD_DEFINE_RESULT__ = (function ($, _, gettext, url_for, alertify) {
  var sqlEditorUtils = {
    /* Reference link http://stackoverflow.com/questions/105034/create-guid-uuid-in-javascript
     * Modified as per requirement.
     */
    epicRandomString: function epicRandomString(length) {
      var s = [];
      var hexDigits = '0123456789abcdef';

      for (var i = 0; i < 36; i++) {
        s[i] = hexDigits.substr(Math.floor(Math.random() * 0x10), 1);
      } // bits 12-15 of the time_hi_and_version field to 0010


      s[14] = '4'; // bits 6-7 of the clock_seq_hi_and_reserved to 01

      s[19] = hexDigits.substr(s[19] & 0x3 | 0x8, 1);
      s[8] = s[13] = s[18] = s[23] = '-';
      var uuid = s.join('');
      return uuid.replace(/-/g, '').substr(0, length);
    },
    // Returns a unique hash for input string
    getHash: function getHash(input) {
      var hash = 0,
          len = input.length;

      for (var i = 0; i < len; i++) {
        hash = (hash << 5) - hash + input.charCodeAt(i);
        hash |= 0; // to 32bit integer
      }

      return hash;
    },
    calculateColumnWidth: function calculateColumnWidth(text) {
      // Calculate column header width based on column name or type
      // Create a temporary element with given label, append to body
      // calculate its width and remove the element.
      $('body').append('<span id="pg_text" style="visibility: hidden;">' + text + '</span>');
      var width = $('#pg_text').width() + 23;
      $('#pg_text').remove(); // remove element

      return width;
    },
    capitalizeFirstLetter: function capitalizeFirstLetter(string) {
      return string.charAt(0).toUpperCase() + string.slice(1);
    },
    // Disables arrow to change connection
    disable_connection_dropdown: function disable_connection_dropdown(status) {
      if (status) {
        $('.conn-info-dd').prop('disabled', true);
        $('.connection-data').css({
          pointerEvents: 'none',
          cursor: 'arrow'
        });
      } else {
        $('.conn-info-dd').prop('disabled', false);
        $('.connection-data').css({
          pointerEvents: 'auto',
          cursor: 'pointer'
        });
      }
    },
    // Status flag
    previousStatus: null,
    // This function will fetch the connection status via ajax
    fetchConnectionStatus: function fetchConnectionStatus(target, $el, $status_el) {
      // If user has switch the browser Tab or Minimized window or
      // if wcDocker panel is not in focus then don't fire AJAX
      var url = url_for('sqleditor.connection_status', {
        'trans_id': target.transId
      });

      if (document.visibilityState !== 'visible' || $el.data('panel-visible') !== 'visible') {
        return;
      }

      if ($status_el.hasClass('obtaining-conn')) {
        return;
      }

      var sqleditor_obj = target; // Start polling..

      $.ajax({
        url: url,
        method: 'GET'
      }).done(function (res) {
        if (res && res.data) {
          var status = res.data.status,
              msg = res.data.message,
              is_status_changed = false; // Raise notify messages comes from database server.

          sqleditor_obj.update_notifications(res.data.notifies); // Inject CSS as required

          switch (status) {
            // Busy
            case 1:
              // if received busy status more than once then only
              if (status == sqlEditorUtils.previousStatus && !$status_el.hasClass('fa-hourglass-half')) {
                $status_el.removeClass().addClass('fa fa-hourglass-half');
                is_status_changed = true;
              }

              break;
            // Idle in transaction

            case 2:
              if (sqlEditorUtils.previousStatus != status && !$status_el.hasClass('fa-clock')) {
                $status_el.removeClass().addClass('fa fa-clock');
                is_status_changed = true;
              }

              break;
            // Failed in transaction

            case 3:
              if (sqlEditorUtils.previousStatus != status && !$status_el.hasClass('fa-exclamation-circle')) {
                $status_el.removeClass().addClass('fa fa-exclamation-circle');
                is_status_changed = true;
              }

              break;
            // Failed in transaction with unknown server side error

            case 4:
              if (sqlEditorUtils.previousStatus != status && !$status_el.hasClass('fa-exclamation-triangle')) {
                $status_el.removeClass().addClass('fa fa-exclamation-triangle');
                is_status_changed = true;
              }

              break;

            default:
              if (sqlEditorUtils.previousStatus != status && !$status_el.hasClass('fa-query_tool_connected')) {
                $status_el.removeClass().addClass('pg-font-icon icon-connected');
                is_status_changed = true;
              }

          }

          sqlEditorUtils.previousStatus = status; // Set bootstrap popover message

          if (is_status_changed) {
            $el.popover('hide');
            $el.attr('data-content', msg);
          }
        } else {
          // We come here means we did not receive expected response
          // from server, we need to error out
          sqlEditorUtils.previousStatus = -99;
          msg = gettext('An unexpected error occurred - ' + 'ensure you are logged into the application.');
          $el.attr('data-content', msg);

          if (!$status_el.hasClass('icon-disconnected')) {
            $el.popover('hide');
            $status_el.removeClass().addClass('pg-icon-font icon-disconnected');
          }
        }
      }).fail(function (e) {
        sqlEditorUtils.previousStatus = -1;
        var msg = gettext('Transaction status check failed.');

        if (e.readyState == 0) {
          msg = gettext('Not connected to the server or the connection to ' + 'the server has been closed.');
        } else if (e.responseJSON && e.responseJSON.errormsg) {
          msg = e.responseJSON.errormsg;
        } // Set bootstrap popover


        $el.attr('data-content', msg); // Add error class

        if (!$status_el.hasClass('icon-disconnected')) {
          $el.popover('hide');
          $status_el.removeClass().addClass('pg-font-icon icon-disconnected');
        }
      });
    },
    // Updates the flag for connection status poll
    updateConnectionStatusFlag: function updateConnectionStatusFlag(status) {
      var $el = $('.connection_status');

      if ($el.data('panel-visible') != status) {
        $el.data('panel-visible', status);
      }
    },
    calcFontSize: function calcFontSize(fontSize) {
      if (fontSize) {
        fontSize = parseFloat(Math.round(parseFloat(fontSize + 'e+2')) + 'e-2');
        var rounded = Number(fontSize);

        if (rounded > 0) {
          return rounded + 'em';
        }
      }

      return '1em';
    },
    addEditableIcon: function addEditableIcon(columnDefinition, is_editable) {
      /* This uses Slickgrid.HeaderButtons plugin to add an icon to the
      columns headers. Instead of a button, an icon is created */
      var content = null;

      if (is_editable) {
        content = '<i class="fa fa-pencil-alt"></i>';
      } else {
        content = '<i class="fa fa-lock"></i>';
      }

      var button = {
        cssClass: 'editable-column-header-icon',
        content: content
      }; // Check for existing buttons

      if (!_.isUndefined(columnDefinition.header) && !_.isUndefined(columnDefinition.header.buttons)) {
        columnDefinition.header.buttons.push(button);
      } else {
        columnDefinition.header = {
          buttons: [button]
        };
      }
    },
    isModalOpen: function isModalOpen(dialog_list) {
      /* check the modals inside the sqleditor are open or not */
      if (Array.isArray(dialog_list)) {
        var _iterator = _createForOfIteratorHelper(dialog_list),
            _step;

        try {
          for (_iterator.s(); !(_step = _iterator.n()).done;) {
            var d = _step.value;

            try {
              if (alertify.dialog(d) && alertify.dialog(d).isOpen()) return true;
            } catch (err) {
              // Do nothing
              console.warn(err.stack || err);
            }
          }
        } catch (err) {
          _iterator.e(err);
        } finally {
          _iterator.f();
        }
      }

      return false;
    }
  };
  return sqlEditorUtils;
}).apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__),
		__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));

/***/ }),

/***/ 77019:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



__webpack_require__(79753);

__webpack_require__(82526);

__webpack_require__(41817);

__webpack_require__(41539);

__webpack_require__(32165);

__webpack_require__(78783);

__webpack_require__(66992);

__webpack_require__(33948);

__webpack_require__(91038);

__webpack_require__(47042);

__webpack_require__(68309);

__webpack_require__(69070);

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.browserTreeState = exports.pgBrowser = void 0;

__webpack_require__(32564);

__webpack_require__(69600);

__webpack_require__(69826);

__webpack_require__(64765);

__webpack_require__(74916);

__webpack_require__(82772);

__webpack_require__(23123);

__webpack_require__(40561);

var _underscore = _interopRequireDefault(__webpack_require__(81311));

var _jquery = _interopRequireDefault(__webpack_require__(19755));

var _url_for = _interopRequireDefault(__webpack_require__(28008));

var _gettext = _interopRequireDefault(__webpack_require__(91669));

var _pgadmin = _interopRequireDefault(__webpack_require__(55112));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var pgBrowser = _pgadmin["default"].Browser = _pgadmin["default"].Browser || {};
exports.pgBrowser = pgBrowser;
var browserTreeState = pgBrowser.browserTreeState = pgBrowser.browserTreeState || {};
exports.browserTreeState = browserTreeState;

_underscore["default"].extend(pgBrowser.browserTreeState, {
  // Parent node to start saving / reloading the tree state
  parent: 'server',
  // The original parent of the browser tree
  orig_parent: 'server_group',
  // Stored tree state
  // Sample Object
  //  {1:
  //    'paths': [
  //      server_group/1,/server/1,/coll-database/1,/database/1,
  //      server_group/1,/server/1,/coll-database/1,/database/2,
  //    ],
  //    'selected': {
  //       'server/1': 'database/2',
  //       'database/1': 'table/1',
  //     },
  //    'conn_status': {
  //      'database/1': 1,
  //      'database/2': 0 ,
  //    },
  //  }
  // Here key is server ID
  stored_state: {},
  // Previous tree state
  last_state: {},
  // Current tree state
  current_state: {},
  init: function init() {
    var save_tree_state_period = pgBrowser.get_preference('browser', 'browser_tree_state_save_interval');

    if (!_underscore["default"].isUndefined(save_tree_state_period) && save_tree_state_period.value !== -1) {
      // Save the tree state every 30 seconds
      setInterval(this.save_state, save_tree_state_period.value * 1000); // Fetch the tree last state while loading the browser tree

      this.fetch_state.apply(this);
      pgBrowser.Events.on('pgadmin:browser:tree:expand-from-previous-tree-state', this.expand_from_previous_state, this);
      pgBrowser.Events.on('pgadmin:browser:tree:remove-from-tree-state', this.remove_from_cache, this);
      pgBrowser.Events.on('pgadmin:browser:tree:update-tree-state', this.update_cache, this);
    } else if (!_underscore["default"].isUndefined(save_tree_state_period)) {
      _jquery["default"].ajax({
        url: (0, _url_for["default"])('settings.reset_tree_state'),
        type: 'DELETE'
      }).fail(function (jqx) {
        var msg = jqx.responseText;
        /* Error from the server */

        if (jqx.status == 417 || jqx.status == 410 || jqx.status == 500) {
          try {
            var data = JSON.parse(jqx.responseText);
            msg = data.errormsg;
          } catch (e) {
            console.warn(e.stack || e);
          }
        }

        console.warn((0, _gettext["default"])('Error resetting the tree saved state."'), msg);
      });
    }
  },
  save_state: function save_state() {
    var self = pgBrowser.browserTreeState;
    if (self.last_state == JSON.stringify(self.current_state)) return;

    _jquery["default"].ajax({
      url: (0, _url_for["default"])('settings.save_tree_state'),
      type: 'POST',
      contentType: 'application/json',
      data: JSON.stringify(self.current_state)
    }).done(function () {
      self.last_state = JSON.stringify(self.current_state);
    }).fail(function (jqx) {
      var msg = jqx.responseText;
      /* Error from the server */

      if (jqx.status == 417 || jqx.status == 410 || jqx.status == 500) {
        try {
          var data = JSON.parse(jqx.responseText);
          msg = data.errormsg;
        } catch (e) {
          console.warn(e.stack || e);
        }
      }

      console.warn((0, _gettext["default"])('Error saving the tree state."'), msg);
    });
  },
  fetch_state: function fetch_state() {
    var self = this;

    _jquery["default"].ajax({
      url: (0, _url_for["default"])('settings.get_tree_state'),
      type: 'GET',
      dataType: 'json',
      contentType: 'application/json'
    }).done(function (res) {
      self.stored_state = res;
    }).fail(function (jqx) {
      var msg = jqx.responseText;
      /* Error from the server */

      if (jqx.status == 417 || jqx.status == 410 || jqx.status == 500) {
        try {
          var data = JSON.parse(jqx.responseText);
          msg = data.errormsg;
        } catch (e) {
          console.warn(e.stack || e);
        }
      }

      console.warn((0, _gettext["default"])('Error fetching the tree state.'), msg);
    });
  },
  update_cache: function update_cache(item) {
    var data = item && pgBrowser.tree.itemData(item),
        treeHierarchy = pgBrowser.tree.getTreeNodeHierarchy(item),
        topParent = undefined,
        pathIDs = pgBrowser.tree.pathId(pgBrowser.tree.parent(item)),
        oldPath = pathIDs.join(),
        path = [],
        tmpIndex = -1; // If no parent or the server not in tree hierarchy then return

    if (!pgBrowser.tree.hasParent(item) || !(this.parent in treeHierarchy)) return;
    topParent = treeHierarchy[this.parent]['_id'];

    if (pgBrowser.tree.isOpen(item)) {
      // Store paths
      pathIDs.push(data.id);
      path = pathIDs.join();

      if (!(topParent in this.current_state)) {
        this.current_state[topParent] = {
          'paths': [],
          'selected': {},
          'conn_status': {},
          'is_opened': {}
        };
      } // IF the current path is already saved then return


      var index = _underscore["default"].find(this.current_state[topParent]['paths'], function (tData) {
        return tData.search(path) !== -1;
      });

      if (_underscore["default"].isUndefined(index)) {
        // Add / Update the current item into the tree path
        if (!_underscore["default"].isUndefined(this.current_state[topParent]['paths'])) {
          tmpIndex = this.current_state[topParent]['paths'].indexOf(oldPath);
        } else {
          this.current_state[topParent]['paths'] = [];
        }

        if (tmpIndex !== -1) {
          this.current_state[topParent]['paths'][tmpIndex] = path;
        } else {
          this.current_state[topParent]['paths'].push(path);
        }
      }
    } // Store current selected item and database connection status


    this.update_database_status(item);
    this.update_current_selected_item(treeHierarchy);
  },
  remove_from_cache: function remove_from_cache(item) {
    var self = this,
        treeData = self.stored_state || {},
        data = item && pgBrowser.tree.itemData(item),
        treeHierarchy = pgBrowser.tree.getTreeNodeHierarchy(item);
    if (treeHierarchy === null || !pgBrowser.tree.hasParent(item) || !treeHierarchy.hasOwnProperty(self.parent)) return;
    var topParent = treeHierarchy && treeHierarchy[self.parent]['_id'],
        origParent = treeHierarchy && treeHierarchy[self.orig_parent]['id'];
    this.update_database_status(item);

    if (data._type == self.parent || data._type == 'database') {
      if (topParent in treeData && 'paths' in treeData[topParent]) {
        treeData[topParent]['paths'] = self.current_state[topParent]['paths'];
        self.save_state();
      }

      return;
    }

    if (pgBrowser.tree.isClosed(item)) {
      var tmpTreeData = self.current_state[topParent]['paths'],
          databaseId = undefined;
      if (treeHierarchy.hasOwnProperty('database')) databaseId = treeHierarchy['database']['id'];

      if (!_underscore["default"].isUndefined(tmpTreeData) && !_underscore["default"].isUndefined(tmpTreeData.length)) {
        var tcnt = 0,
            tmpItemDataStr = undefined;

        _underscore["default"].each(tmpTreeData, function (tData) {
          if (_underscore["default"].isUndefined(tData)) return;
          var tmpItemData = tData.split(',');

          if (tmpItemData.indexOf(data.id) !== -1) {
            if (databaseId === undefined || databaseId !== undefined && tmpItemData.indexOf(databaseId) !== -1) {
              var index = tmpItemData.indexOf(data.id);
              tmpItemData.splice(index);
              tmpItemDataStr = tmpItemData.join();
              if (tmpItemDataStr == origParent) self.current_state[topParent]['paths'].splice(tData, 1);else self.current_state[topParent]['paths'][tcnt] = tmpItemDataStr;
            }
          }

          tcnt++;
        });
      }
    }
  },
  expand_from_previous_state: function expand_from_previous_state(item) {
    var self = this,
        treeData = self.stored_state || {},
        data = item && pgBrowser.tree.itemData(item),
        treeHierarchy = pgBrowser.tree.getTreeNodeHierarchy(item);
    if (treeHierarchy === null || !pgBrowser.tree.hasParent(item) || !treeHierarchy.hasOwnProperty(self.parent)) return; // If the server node is open then only we should populate the tree

    if (data['_type'] == self.parent && pgBrowser.tree.isOpen(item) === false) return;
    var tmpTreeData = treeData[treeHierarchy[self.parent]['_id']]; // If the server node is open then only we should populate the tree

    if (data['_type'] == 'database' && tmpTreeData && 'conn_status' in tmpTreeData && 'is_opened' in tmpTreeData && (tmpTreeData['conn_status'][data['id']] === 0 || tmpTreeData['is_opened'][data['id']] === 0 || !(data['id'] in tmpTreeData['is_opened']))) return;

    if (!_underscore["default"].isUndefined(tmpTreeData) && 'paths' in tmpTreeData && !_underscore["default"].isUndefined(tmpTreeData['paths'].length)) {
      var tmpTreeDataPaths = _toConsumableArray(tmpTreeData['paths']),
          databaseId = undefined;

      if (treeHierarchy.hasOwnProperty('database')) databaseId = treeHierarchy['database']['id'];

      _underscore["default"].each(tmpTreeDataPaths, function (tData) {
        if (_underscore["default"].isUndefined(tData)) return;
        var tmpItemData = tData.split(','); // If the item is in the lastTreeState then open it

        if (tmpItemData.indexOf(data.id) !== -1) {
          if (databaseId === undefined || databaseId !== undefined && tmpItemData.indexOf(databaseId) !== -1) {
            var index = tmpItemData.indexOf(data.id);
            pgBrowser.tree.open(item);
            pgBrowser.tree.ensureLoaded(item);

            if (index == tmpItemData.length - 1) {
              var tIndex = treeData[treeHierarchy[self.parent]['_id']]['paths'].indexOf(tData);
              treeData[treeHierarchy[self.parent]['_id']]['paths'].splice(tIndex, 1);
            }
          }
        }
      });
    } // Select the previously selected item


    this.select_tree_item(item);
  },
  update_database_status: function update_database_status(item) {
    var data = item && pgBrowser.tree.itemData(item),
        treeHierarchy = pgBrowser.tree.getTreeNodeHierarchy(item);

    if (treeHierarchy.hasOwnProperty('database')) {
      var databaseItem = treeHierarchy['database']['id'],
          topParent = treeHierarchy && treeHierarchy[this.parent]['_id'];

      if (topParent in this.current_state && 'selected' in this.current_state[topParent]) {
        if (treeHierarchy['database'].connected) {
          this.current_state[topParent]['conn_status'][databaseItem] = 1;
        } else {
          this.current_state[topParent]['conn_status'][databaseItem] = 0;
        }

        if (data._type == 'database') {
          if (pgBrowser.tree.isOpen(item)) {
            this.current_state[topParent]['is_opened'][databaseItem] = 1;
          } else {
            this.current_state[topParent]['is_opened'][databaseItem] = 0;
          }
        }
      }
    }
  },
  update_current_selected_item: function update_current_selected_item(treeHierarchy) {
    if (!(this.parent in treeHierarchy)) return;
    var topParent = treeHierarchy && treeHierarchy[this.parent]['_id'],
        selectedItem = pgBrowser.tree.itemData(pgBrowser.tree.selected()),
        databaseItem = undefined;
    selectedItem = selectedItem ? selectedItem.id : undefined;

    if (treeHierarchy.hasOwnProperty('database')) {
      databaseItem = treeHierarchy['database']['id'];
    }

    if (topParent in this.current_state && 'selected' in this.current_state[topParent] && !_underscore["default"].isUndefined(selectedItem)) {
      this.current_state[topParent]['selected'][treeHierarchy[this.parent]['id']] = selectedItem;
      if (!_underscore["default"].isUndefined(databaseItem)) this.current_state[topParent]['selected'][databaseItem] = selectedItem;
    }
  },
  select_tree_item: function select_tree_item(item) {
    var treeData = this.stored_state || {},
        data = item && pgBrowser.tree.itemData(item),
        treeHierarchy = pgBrowser.tree.getTreeNodeHierarchy(item),
        tmpTreeData = treeData[treeHierarchy[this.parent]['_id']];

    if (treeHierarchy.hasOwnProperty('server')) {
      var selectedItem = treeHierarchy['server']['id'];

      if (tmpTreeData && 'selected' in tmpTreeData && selectedItem in tmpTreeData['selected']) {
        if (tmpTreeData['selected'][selectedItem] == data.id) {
          pgBrowser.tree.select(item, true, 'center');
        }
      }
    }
  }
});

/***/ }),

/***/ 79226:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



__webpack_require__(82526);

__webpack_require__(41817);

__webpack_require__(32165);

__webpack_require__(78783);

__webpack_require__(66992);

__webpack_require__(33948);

__webpack_require__(38880);

__webpack_require__(49337);

__webpack_require__(33321);

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.findInTree = findInTree;
exports.isValidTreeNodeData = exports.Tree = void 0;

__webpack_require__(82772);

__webpack_require__(23123);

__webpack_require__(74916);

__webpack_require__(40561);

__webpack_require__(57327);

__webpack_require__(79753);

__webpack_require__(88674);

__webpack_require__(41539);

__webpack_require__(69600);

__webpack_require__(23157);

__webpack_require__(89554);

__webpack_require__(54747);

__webpack_require__(47941);

__webpack_require__(15306);

__webpack_require__(69070);

__webpack_require__(35666);

var _lodash = _interopRequireDefault(__webpack_require__(96486));

var _jquery = _interopRequireDefault(__webpack_require__(19755));

var _pgadmin = _interopRequireDefault(__webpack_require__(55112));

var _reactAspen = __webpack_require__(46521);

var _tree_nodes = __webpack_require__(95197);

var _utils = __webpack_require__(44092);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function manageTreeEvents(event, eventName, item) {
  var d = item ? item._metadata.data : [];
  var node;
  var obj = _pgadmin["default"].Browser;

  if (d && obj.Nodes[d._type]) {
    node = obj.Nodes[d._type]; // If the Browser tree is not initialised yet

    if (obj.tree === null) return;

    if (eventName == 'dragstart') {
      obj.tree.handleDraggable(event, item);
    }

    if (eventName == 'added' || eventName == 'beforeopen' || eventName == 'loaded') {
      obj.tree.addNewNode(item.getMetadata('data').id, item.getMetadata('data'), item, item.parent.path);
    }

    if (_lodash["default"].isObject(node.callbacks) && eventName in node.callbacks && typeof node.callbacks[eventName] == 'function' && !node.callbacks[eventName].apply(node, [item, d, obj, [], eventName])) {
      return true;
    }
    /* Raise tree events for the nodes */


    try {
      node.trigger('browser-node.' + eventName, node, item, d);
      obj.Events.trigger('pgadmin-browser:tree:' + eventName, item, d, node);
    } catch (e) {
      console.warn(e.stack || e);
      return false;
    }
  }

  return true;
}

var Tree = /*#__PURE__*/function () {
  function Tree(tree, manageTree, pgBrowser) {
    _classCallCheck(this, Tree);

    this.tree = tree;
    this.tree.onTreeEvents(manageTreeEvents);
    this.rootNode = manageTree.tempTree;
    this.Nodes = pgBrowser ? pgBrowser.Nodes : _pgadmin["default"].Browser.Nodes;
    this.draggableTypes = {};
  }

  _createClass(Tree, [{
    key: "refresh",
    value: function () {
      var _refresh = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(item) {
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return this.tree.refresh(item);

              case 2:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function refresh(_x) {
        return _refresh.apply(this, arguments);
      }

      return refresh;
    }()
  }, {
    key: "add",
    value: function () {
      var _add = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(item, data) {
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return this.tree.create(item.parent, data.itemData);

              case 2:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function add(_x2, _x3) {
        return _add.apply(this, arguments);
      }

      return add;
    }()
  }, {
    key: "before",
    value: function () {
      var _before = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(item, data) {
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return this.tree.create(item.parent, data);

              case 2:
                return _context3.abrupt("return", _context3.sent);

              case 3:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function before(_x4, _x5) {
        return _before.apply(this, arguments);
      }

      return before;
    }()
  }, {
    key: "update",
    value: function () {
      var _update = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(item, data) {
        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _context4.next = 2;
                return this.tree.update(item, data);

              case 2:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function update(_x6, _x7) {
        return _update.apply(this, arguments);
      }

      return update;
    }()
  }, {
    key: "remove",
    value: function () {
      var _remove = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(item) {
        return regeneratorRuntime.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                _context5.next = 2;
                return this.tree.remove(item);

              case 2:
                return _context5.abrupt("return", _context5.sent);

              case 3:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function remove(_x8) {
        return _remove.apply(this, arguments);
      }

      return remove;
    }()
  }, {
    key: "append",
    value: function () {
      var _append = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6(item, data) {
        return regeneratorRuntime.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                _context6.next = 2;
                return this.tree.create(item, data);

              case 2:
                return _context6.abrupt("return", _context6.sent);

              case 3:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function append(_x9, _x10) {
        return _append.apply(this, arguments);
      }

      return append;
    }()
  }, {
    key: "destroy",
    value: function () {
      var _destroy = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee7() {
        var model;
        return regeneratorRuntime.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                model = this.tree.getModel();
                this.rootNode.children = [];

                if (!model.root) {
                  _context7.next = 6;
                  break;
                }

                model.root.isExpanded = false;
                _context7.next = 6;
                return model.root.hardReloadChildren();

              case 6:
              case "end":
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));

      function destroy() {
        return _destroy.apply(this, arguments);
      }

      return destroy;
    }()
  }, {
    key: "next",
    value: function next(item) {
      if (item) {
        var _parent = this.parent(item);

        if (_parent && _parent.children.length > 0) {
          var idx = _parent.children.indexOf(item);

          if (idx !== -1 && _parent.children.length !== idx + 1) {
            return _parent.children[idx + 1];
          }
        }
      }

      return null;
    }
  }, {
    key: "prev",
    value: function prev(item) {
      if (item) {
        var _parent2 = this.parent(item);

        if (_parent2 && _parent2.children.length > 0) {
          var idx = _parent2.children.indexOf(item);

          if (idx !== -1 && idx !== 0) {
            return _parent2.children[idx - 1];
          }
        }
      }

      return null;
    }
  }, {
    key: "open",
    value: function () {
      var _open = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee8(item) {
        return regeneratorRuntime.wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                if (!this.isOpen(item)) {
                  _context8.next = 2;
                  break;
                }

                return _context8.abrupt("return", true);

              case 2:
                _context8.next = 4;
                return this.tree.toggleDirectory(item);

              case 4:
              case "end":
                return _context8.stop();
            }
          }
        }, _callee8, this);
      }));

      function open(_x11) {
        return _open.apply(this, arguments);
      }

      return open;
    }()
  }, {
    key: "ensureLoaded",
    value: function () {
      var _ensureLoaded = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee9(item) {
        return regeneratorRuntime.wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                _context9.next = 2;
                return item.ensureLoaded();

              case 2:
              case "end":
                return _context9.stop();
            }
          }
        }, _callee9);
      }));

      function ensureLoaded(_x12) {
        return _ensureLoaded.apply(this, arguments);
      }

      return ensureLoaded;
    }()
  }, {
    key: "ensureVisible",
    value: function () {
      var _ensureVisible = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee10(item) {
        return regeneratorRuntime.wrap(function _callee10$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                _context10.next = 2;
                return this.tree.ensureVisible(item);

              case 2:
              case "end":
                return _context10.stop();
            }
          }
        }, _callee10, this);
      }));

      function ensureVisible(_x13) {
        return _ensureVisible.apply(this, arguments);
      }

      return ensureVisible;
    }()
  }, {
    key: "openPath",
    value: function () {
      var _openPath = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee11(item) {
        return regeneratorRuntime.wrap(function _callee11$(_context11) {
          while (1) {
            switch (_context11.prev = _context11.next) {
              case 0:
                parent = item.parent;
                _context11.next = 3;
                return this.tree.openDirectory(parent);

              case 3:
              case "end":
                return _context11.stop();
            }
          }
        }, _callee11, this);
      }));

      function openPath(_x14) {
        return _openPath.apply(this, arguments);
      }

      return openPath;
    }()
  }, {
    key: "close",
    value: function () {
      var _close = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee12(item) {
        return regeneratorRuntime.wrap(function _callee12$(_context12) {
          while (1) {
            switch (_context12.prev = _context12.next) {
              case 0:
                _context12.next = 2;
                return this.tree.closeDirectory(item);

              case 2:
              case "end":
                return _context12.stop();
            }
          }
        }, _callee12, this);
      }));

      function close(_x15) {
        return _close.apply(this, arguments);
      }

      return close;
    }()
  }, {
    key: "toggle",
    value: function () {
      var _toggle = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee13(item) {
        return regeneratorRuntime.wrap(function _callee13$(_context13) {
          while (1) {
            switch (_context13.prev = _context13.next) {
              case 0:
                _context13.next = 2;
                return this.tree.toggleDirectory(item);

              case 2:
              case "end":
                return _context13.stop();
            }
          }
        }, _callee13, this);
      }));

      function toggle(_x16) {
        return _toggle.apply(this, arguments);
      }

      return toggle;
    }()
  }, {
    key: "select",
    value: function () {
      var _select = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee14(item) {
        var ensureVisible,
            align,
            _args14 = arguments;
        return regeneratorRuntime.wrap(function _callee14$(_context14) {
          while (1) {
            switch (_context14.prev = _context14.next) {
              case 0:
                ensureVisible = _args14.length > 1 && _args14[1] !== undefined ? _args14[1] : false;
                align = _args14.length > 2 && _args14[2] !== undefined ? _args14[2] : 'auto';
                _context14.next = 4;
                return this.tree.setActiveFile(item, ensureVisible, align);

              case 4:
              case "end":
                return _context14.stop();
            }
          }
        }, _callee14, this);
      }));

      function select(_x17) {
        return _select.apply(this, arguments);
      }

      return select;
    }()
  }, {
    key: "selectNode",
    value: function () {
      var _selectNode = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee15(item) {
        var ensureVisible,
            align,
            _args15 = arguments;
        return regeneratorRuntime.wrap(function _callee15$(_context15) {
          while (1) {
            switch (_context15.prev = _context15.next) {
              case 0:
                ensureVisible = _args15.length > 1 && _args15[1] !== undefined ? _args15[1] : false;
                align = _args15.length > 2 && _args15[2] !== undefined ? _args15[2] : 'auto';
                this.tree.setActiveFile(item, ensureVisible, align);

              case 3:
              case "end":
                return _context15.stop();
            }
          }
        }, _callee15, this);
      }));

      function selectNode(_x18) {
        return _selectNode.apply(this, arguments);
      }

      return selectNode;
    }()
  }, {
    key: "unload",
    value: function () {
      var _unload = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee16(item) {
        return regeneratorRuntime.wrap(function _callee16$(_context16) {
          while (1) {
            switch (_context16.prev = _context16.next) {
              case 0:
                _context16.next = 2;
                return this.tree.unload(item);

              case 2:
              case "end":
                return _context16.stop();
            }
          }
        }, _callee16, this);
      }));

      function unload(_x19) {
        return _unload.apply(this, arguments);
      }

      return unload;
    }()
  }, {
    key: "addIcon",
    value: function () {
      var _addIcon = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee17(item, icon) {
        return regeneratorRuntime.wrap(function _callee17$(_context17) {
          while (1) {
            switch (_context17.prev = _context17.next) {
              case 0:
                if (item !== undefined && item.getMetadata('data') !== undefined) {
                  item.getMetadata('data').icon = icon.icon;
                }

                _context17.next = 3;
                return this.tree.addIcon(item, icon);

              case 3:
              case "end":
                return _context17.stop();
            }
          }
        }, _callee17, this);
      }));

      function addIcon(_x20, _x21) {
        return _addIcon.apply(this, arguments);
      }

      return addIcon;
    }()
  }, {
    key: "removeIcon",
    value: function removeIcon() {// TBD
    }
  }, {
    key: "setLeaf",
    value: function setLeaf() {// TBD
    }
  }, {
    key: "setLabel",
    value: function () {
      var _setLabel = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee18(item, label) {
        return regeneratorRuntime.wrap(function _callee18$(_context18) {
          while (1) {
            switch (_context18.prev = _context18.next) {
              case 0:
                if (!item) {
                  _context18.next = 3;
                  break;
                }

                _context18.next = 3;
                return this.tree.setLabel(item, label);

              case 3:
              case "end":
                return _context18.stop();
            }
          }
        }, _callee18, this);
      }));

      function setLabel(_x22, _x23) {
        return _setLabel.apply(this, arguments);
      }

      return setLabel;
    }()
  }, {
    key: "setInode",
    value: function () {
      var _setInode = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee19(item) {
        return regeneratorRuntime.wrap(function _callee19$(_context19) {
          while (1) {
            switch (_context19.prev = _context19.next) {
              case 0:
                if (item._children) item._children = null;
                _context19.next = 3;
                return this.tree.closeDirectory(item);

              case 3:
              case "end":
                return _context19.stop();
            }
          }
        }, _callee19, this);
      }));

      function setInode(_x24) {
        return _setInode.apply(this, arguments);
      }

      return setInode;
    }()
  }, {
    key: "setId",
    value: function () {
      var _setId = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee20(item, data) {
        return regeneratorRuntime.wrap(function _callee20$(_context20) {
          while (1) {
            switch (_context20.prev = _context20.next) {
              case 0:
                if (item) {
                  item.getMetadata('data').id = data.id;
                }

              case 1:
              case "end":
                return _context20.stop();
            }
          }
        }, _callee20);
      }));

      function setId(_x25, _x26) {
        return _setId.apply(this, arguments);
      }

      return setId;
    }()
  }, {
    key: "deselect",
    value: function deselect(item) {
      this.tree.deSelectActiveFile(item);
    }
  }, {
    key: "wasInit",
    value: function wasInit() {
      // TBD
      return true;
    }
  }, {
    key: "wasLoad",
    value: function wasLoad(item) {
      if (item && item.type === _reactAspen.FileType.Directory) {
        return item.isExpanded && item.children != null && item.children.length > 0;
      }

      return true;
    }
  }, {
    key: "parent",
    value: function parent(item) {
      return item.parent;
    }
  }, {
    key: "first",
    value: function first(item) {
      var model = this.tree.getModel();

      if ((item === undefined || item === null) && model.root.children !== null) {
        return model.root.children[0];
      }

      if (item !== undefined && item !== null && item.branchSize > 0) {
        return item.children[0];
      }

      return null;
    }
  }, {
    key: "children",
    value: function children(item) {
      var model = this.tree.getModel();
      return item ? item.children !== null ? item.children : [] : model.root.children;
    }
  }, {
    key: "itemFrom",
    value: function itemFrom(domElem) {
      return this.tree.getItemFromDOM(domElem[0]);
    }
  }, {
    key: "DOMFrom",
    value: function DOMFrom(item) {
      return this.tree.getDOMFromItem(item);
    }
  }, {
    key: "addCssClass",
    value: function addCssClass(item, cssClass) {
      this.tree.addCssClass(item, cssClass);
    }
  }, {
    key: "path",
    value: function path(item) {
      if (item) return item.path;
    }
  }, {
    key: "pathId",
    value: function pathId(item) {
      if (item) {
        var pathIds = item.path.split('/');
        pathIds.splice(0, 1);
        return pathIds;
      }

      return [];
    }
  }, {
    key: "itemFromDOM",
    value: function itemFromDOM(domElem) {
      return this.tree.getItemFromDOM(domElem[0]);
    }
  }, {
    key: "siblings",
    value: function siblings(item) {
      if (this.hasParent(item)) {
        var _siblings = this.parent(item).children.filter(function (_item) {
          return _item.path !== item.path;
        });

        if (_typeof(_siblings) !== 'object') return [_siblings];else return _siblings;
      }

      return [];
    }
  }, {
    key: "hasParent",
    value: function hasParent(item) {
      return item && item.parent ? true : false;
    }
  }, {
    key: "isOpen",
    value: function isOpen(item) {
      if (item.type === _reactAspen.FileType.Directory) {
        return item.isExpanded;
      }

      return false;
    }
  }, {
    key: "isClosed",
    value: function isClosed(item) {
      if (item.type === _reactAspen.FileType.Directory) {
        return !item.isExpanded;
      }

      return false;
    }
  }, {
    key: "itemData",
    value: function itemData(item) {
      return item !== undefined && item !== null && item.getMetadata('data') !== undefined ? item._metadata.data : [];
    }
  }, {
    key: "getData",
    value: function getData(item) {
      return item !== undefined && item.getMetadata('data') !== undefined ? item._metadata.data : [];
    }
  }, {
    key: "isRootNode",
    value: function isRootNode(item) {
      var model = this.tree.getModel();
      return item === model.root;
    }
  }, {
    key: "isInode",
    value: function isInode(item) {
      var children = this.children(item);
      if (children === null || children === undefined) return false;
      return children.length > 0 ? true : false;
    }
  }, {
    key: "selected",
    value: function selected() {
      return this.tree.getActiveFile();
    }
  }, {
    key: "resizeTree",
    value: function resizeTree() {
      this.tree.resize();
    }
  }, {
    key: "findNodeWithToggle",
    value: function findNodeWithToggle(path) {
      var tree = this;

      if (path == null || !Array.isArray(path)) {
        return Promise.reject();
      }

      path = '/browser/' + path.join('/');

      var onCorrectPath = function onCorrectPath(matchPath) {
        return matchPath !== undefined && path !== undefined && (path.startsWith(matchPath) || path === matchPath);
      };

      return function findInNode(currentNode) {
        return new Promise(function (resolve, reject) {
          if (path === null || path === undefined || path.length === 0) {
            resolve(null);
          }
          /* No point in checking the children if
           * the path for currentNode itself is not matching
           */


          if (currentNode.path !== undefined && !onCorrectPath(currentNode.path)) {
            reject(null);
          } else if (currentNode.path === path) {
            resolve(currentNode);
          } else {
            tree.open(currentNode).then(function () {
              var children = currentNode.children;

              for (var i = 0, length = children.length; i < length; i++) {
                var childNode = children[i];

                if (onCorrectPath(childNode.path)) {
                  resolve(findInNode(childNode));
                  return;
                }
              }

              reject(null);
            })["catch"](function () {
              reject(null);
            });
          }
        });
      }(tree.tree.getModel().root);
    }
  }, {
    key: "findNodeByDomElement",
    value: function findNodeByDomElement(domElement) {
      var path = domElement.path;

      if (!path || !path[0]) {
        return undefined;
      }

      return this.findNode(path);
    }
  }, {
    key: "addNewNode",
    value: function addNewNode(id, data, item, parentPath) {
      var parent;
      parent = this.findNode(parentPath);
      return this.createOrUpdateNode(id, data, parent, item);
    }
  }, {
    key: "findNode",
    value: function findNode(path) {
      if (path === null || path === undefined || path.length === 0) {
        return this.rootNode;
      }

      return findInTree(this.rootNode, path);
    }
  }, {
    key: "createOrUpdateNode",
    value: function createOrUpdateNode(id, data, parent, domNode) {
      var oldNodePath = id;

      if (parent !== null && parent !== undefined && parent.path !== undefined && parent.path != '/browser') {
        oldNodePath = parent.path + '/' + id;
      }

      var oldNode = this.findNode(oldNodePath);

      if (oldNode !== null) {
        oldNode.data = data;
        oldNode.domNode = domNode;
        return oldNode;
      }

      var node = new _tree_nodes.TreeNode(id, data, domNode, parent);

      if (parent === this.rootNode) {
        node.parentNode = null;
      }

      if (parent !== null && parent !== undefined) parent.children.push(node);
      return node;
    }
  }, {
    key: "translateTreeNodeIdFromReactTree",
    value: function translateTreeNodeIdFromReactTree(aciTreeNode) {
      var currentTreeNode = aciTreeNode;
      var path = [];

      while (currentTreeNode !== null && currentTreeNode !== undefined) {
        if (currentTreeNode.path !== '/browser') path.unshift(currentTreeNode.path);

        if (this.hasParent(currentTreeNode)) {
          currentTreeNode = this.parent(currentTreeNode);
        } else {
          break;
        }
      }

      return path;
    }
  }, {
    key: "getTreeNodeHierarchy",
    value: function getTreeNodeHierarchy(identifier) {
      var idx = 0;
      var node_cnt = 0;
      var result = {};
      if (identifier === undefined) return;
      var item = _tree_nodes.TreeNode.prototype.isPrototypeOf(identifier) ? identifier : this.findNode(identifier.path);
      if (item === undefined) return;

      do {
        var currentNodeData = item.getData();

        if (currentNodeData._type in this.Nodes && this.Nodes[currentNodeData._type].hasId) {
          var nodeType = mapType(currentNodeData._type, node_cnt);

          if (result[nodeType] === undefined) {
            result[nodeType] = _lodash["default"].extend({}, currentNodeData, {
              'priority': idx
            });
            idx -= 1;
          }
        }

        node_cnt += 1;
        item = item.hasParent() ? item.parent() : null;
      } while (item);

      return result;
    }
    /*
     *
     * The dropDetailsFunc should return an object of sample
     * {text: 'xyz', cur: {from:0, to:0} where text is the drop text and
     * cur is selection range of text after dropping. If returned as
     * string, by default cursor will be set to the end of text
     */

  }, {
    key: "registerDraggableType",
    value: function registerDraggableType(typeOrTypeDict) {
      var _this = this;

      var dropDetailsFunc = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

      if (_typeof(typeOrTypeDict) == 'object') {
        Object.keys(typeOrTypeDict).forEach(function (type) {
          _this.registerDraggableType(type, typeOrTypeDict[type]);
        });
      } else {
        if (dropDetailsFunc != null) {
          typeOrTypeDict.replace(/ +/, ' ').split(' ').forEach(function (type) {
            _this.draggableTypes[type] = dropDetailsFunc;
          });
        }
      }
    }
  }, {
    key: "getDraggable",
    value: function getDraggable(type) {
      if (this.draggableTypes[type]) {
        return this.draggableTypes[type];
      } else {
        return null;
      }
    }
  }, {
    key: "handleDraggable",
    value: function handleDraggable(e, item) {
      var data = item.getMetadata('data');
      var dropDetailsFunc = this.getDraggable(data._type);

      if (dropDetailsFunc != null) {
        /* addEventListener is used here because import jquery.drag.event
         * overrides the dragstart event set using element.on('dragstart')
         * This will avoid conflict.
         */
        var dropDetails = dropDetailsFunc(data, item, this.getTreeNodeHierarchy(item));

        if (typeof dropDetails == 'string') {
          dropDetails = {
            text: dropDetails,
            cur: {
              from: dropDetails.length,
              to: dropDetails.length
            }
          };
        } else {
          if (!dropDetails.cur) {
            dropDetails = _objectSpread(_objectSpread({}, dropDetails), {}, {
              cur: {
                from: dropDetails.text.length,
                to: dropDetails.text.length
              }
            });
          }
        }

        e.dataTransfer.setData('text', JSON.stringify(dropDetails));
        /* Required by Firefox */

        if (e.dataTransfer.dropEffect) {
          e.dataTransfer.dropEffect = 'move';
        }
        /* setDragImage is not supported in IE. We leave it to
           * its default look and feel
           */


        if (e.dataTransfer.setDragImage) {
          var dragItem = (0, _jquery["default"])("\n            <div class=\"drag-tree-node\">\n              <span>".concat(_lodash["default"].escape(dropDetails.text), "</span>\n            </div>"));
          (0, _jquery["default"])('body .drag-tree-node').remove();
          (0, _jquery["default"])('body').append(dragItem);
          e.dataTransfer.setDragImage(dragItem[0], 0, 0);
        }
      }
    }
  }]);

  return Tree;
}();

exports.Tree = Tree;

function mapType(type, idx) {
  return type === 'partition' && idx > 0 ? 'table' : type;
}
/**
 * Given an initial node and a path, it will navigate through
 * the new tree to find the node that matches the path
 */


function findInTree(rootNode, path) {
  if (path === null) {
    return rootNode;
  }

  return function findInNode(currentNode) {
    /* No point in checking the children if
     * the path for currentNode itself is not matching
     */
    if (currentNode.path !== undefined && path !== undefined && !path.startsWith(currentNode.path)) {
      return null;
    }

    for (var i = 0, length = currentNode.children.length; i < length; i++) {
      var calculatedNode = findInNode(currentNode.children[i]);

      if (calculatedNode !== null) {
        return calculatedNode;
      }
    }

    if (currentNode.path === path) {
      return currentNode;
    } else {
      return null;
    }
  }(rootNode);
}

var isValidTreeNodeData = _utils.isValidData;
exports.isValidTreeNodeData = isValidTreeNodeData;

/***/ }),

/***/ 28008:
/***/ ((module, exports, __webpack_require__) => {

var __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;

__webpack_require__(15306);

__webpack_require__(74916);

/////////////////////////////////////////////////////////////
//
// pgAdmin 4 - PostgreSQL Tools
//
// Copyright (C) 2013 - 2022, The pgAdmin Development Team
// This software is released under the PostgreSQL Licence
//
//////////////////////////////////////////////////////////////
!(__WEBPACK_AMD_DEFINE_ARRAY__ = [__webpack_require__(8012)], __WEBPACK_AMD_DEFINE_RESULT__ = (function (endpoints) {
  /***
   * This method behaves as a drop-in replacement for flask url_for function.
   * It uses the exposed URLs file under the hood, and replace the substitions provided by the modules.
   *
   * ex.
   * url_for("help.static", {filename: "server_dialog.html"}) will produce the
   * output string '/help/help/server_dialog.html' from the url ->
   * '/help/help/<path:filename>'.
   *
   * @param {String} text
   * @param {Object} substitutions
   */
  return function url_for(endpoint, substitutions) {
    var rawURL = endpoints[endpoint]; // captures things of the form <path:substitutionName>

    var substitutionGroupsRegExp = /([<])([^:^>]*:)?([^>]+)([>])/g,
        interpolated = rawURL;
    if (!rawURL) return rawURL;
    interpolated = interpolated.replace(substitutionGroupsRegExp, function (_origin, _1, _2, substitutionName) {
      if (substitutionName in substitutions) {
        return substitutions[substitutionName];
      }

      return _origin;
    });
    return interpolated;
  };
}).apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__),
		__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));

/***/ }),

/***/ 44092:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



__webpack_require__(69070);

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.parseShortcutValue = parseShortcutValue;
exports.handleKeyNavigation = handleKeyNavigation;
exports.findAndSetFocus = findAndSetFocus;
exports.getEpoch = getEpoch;
exports.getGCD = getGCD;
exports.getMod = getMod;
exports.parseFuncParams = parseFuncParams;
exports.quote_ident = quote_ident;
exports.fully_qualify = fully_qualify;
exports.getRandomInt = getRandomInt;
exports.titleize = titleize;
exports.sprintf = sprintf;
exports.CSVToArray = CSVToArray;
exports.hasBinariesConfiguration = hasBinariesConfiguration;
exports.evalFunc = evalFunc;
exports.registerDetachEvent = registerDetachEvent;
exports.isString = exports.isFunction = exports.isValidData = void 0;

__webpack_require__(69826);

__webpack_require__(32564);

__webpack_require__(83710);

__webpack_require__(91058);

__webpack_require__(27852);

__webpack_require__(82772);

__webpack_require__(64765);

__webpack_require__(74916);

__webpack_require__(15306);

__webpack_require__(69600);

__webpack_require__(21249);

__webpack_require__(23123);

__webpack_require__(24603);

__webpack_require__(39714);

__webpack_require__(73210);

var _underscore = _interopRequireDefault(__webpack_require__(81311));

var _jquery = _interopRequireDefault(__webpack_require__(19755));

var _gettext = _interopRequireDefault(__webpack_require__(91669));

__webpack_require__(35816);

var _Notifier = _interopRequireDefault(__webpack_require__(55958));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

//////////////////////////////////////////////////////////////////////////
//
// pgAdmin 4 - PostgreSQL Tools
//
// Copyright (C) 2013 - 2022, The pgAdmin Development Team
// This software is released under the PostgreSQL Licence
//
//////////////////////////////////////////////////////////////////////////
var wcDocker = window.wcDocker;

function parseShortcutValue(obj) {
  var shortcut = '';

  if (obj.alt) {
    shortcut += 'alt+';
  }

  if (obj.shift) {
    shortcut += 'shift+';
  }

  if (obj.control) {
    shortcut += 'ctrl+';
  }

  shortcut += obj.key["char"].toLowerCase();
  return shortcut;
}

function handleKeyNavigation(event) {
  var wizardHeader = (0, _jquery["default"])(event.currentTarget).find('.wizard-header');
  var wizardFooter = (0, _jquery["default"])(event.currentTarget).find('.wizard-footer');
  var gridElement = (0, _jquery["default"])(event.currentTarget).find('.select-row-cell:first');
  var gridElementLast = (0, _jquery["default"])(event.currentTarget).find('.select-row-cell:last');
  var firstWizardHeaderButton = (0, _jquery["default"])(wizardHeader).find('button:enabled:first');
  var lastWizardHeaderButton = (0, _jquery["default"])(wizardHeader).find('button:enabled:last');
  var lastWizardFooterBtn = (0, _jquery["default"])(wizardFooter).find('button:enabled:last');
  var firstWizardFooterBtn = (0, _jquery["default"])(wizardFooter).find('button:enabled:first');

  if (event.shiftKey && event.keyCode === 9) {
    // Move backwards
    if (firstWizardHeaderButton && (0, _jquery["default"])(firstWizardHeaderButton).is((0, _jquery["default"])(event.target))) {
      if (lastWizardFooterBtn) {
        (0, _jquery["default"])(lastWizardFooterBtn).focus();
        event.preventDefault();
        event.stopPropagation();
      }
    } else if ((0, _jquery["default"])(firstWizardFooterBtn).is((0, _jquery["default"])(event.target))) {
      if ((0, _jquery["default"])(gridElement).find('.custom-control-input').is(':visible')) {
        (0, _jquery["default"])(gridElementLast).find('.custom-control-input').focus();
        event.preventDefault();
        event.stopPropagation();
      } else if ((0, _jquery["default"])(event.currentTarget).find('.wizard-content').find('.CodeMirror-scroll').is(':visible')) {
        (0, _jquery["default"])(lastWizardHeaderButton).focus();
      }
    }
  } else if (event.keyCode === 9) {
    // Move forwards
    // If taget is last button then goto first element
    if (lastWizardFooterBtn && (0, _jquery["default"])(lastWizardFooterBtn).is((0, _jquery["default"])(event.target))) {
      (0, _jquery["default"])(firstWizardHeaderButton).focus();
      event.preventDefault();
      event.stopPropagation();
    } else if (event.target.innerText == 'Name') {
      if ((0, _jquery["default"])(gridElement).find('.custom-control-input').is(':visible')) {
        (0, _jquery["default"])(gridElement).find('.custom-control-input').focus();
      } else {
        (0, _jquery["default"])(firstWizardFooterBtn).focus();
      }

      event.preventDefault();
      event.stopPropagation();
    } else if (event.target.tagName == 'DIV') {
      (0, _jquery["default"])(event.currentTarget).find('.custom-control-input:first').trigger('focus');
      event.preventDefault();
      event.stopPropagation();
    } else if (event.target.tagName == 'TEXTAREA') {
      (0, _jquery["default"])(firstWizardFooterBtn).focus();
    }
  } else if (event.keyCode === 27) {
    //close the wizard when esc key is pressed
    (0, _jquery["default"])(wizardHeader).find('button.ajs-close').click();
  }
}

function findAndSetFocus(container) {
  if (container.length == 0) {
    return;
  }

  setTimeout(function () {
    var first_el = container.find('button.fa-plus:first');
    /* Adding the tabindex condition makes sure that
     * when testing accessibility it works consistently across all
     * browser. For eg, in safari focus() works only when element has
     * tabindex="0", whereas in Chrome it works in any case
     */

    if (first_el.length == 0) {
      first_el = container.find("\n          .pgadmin-controls:first .btn:not(.toggle),\n          .pgadmin-controls:first,\n          .ajs-commands:first,\n          .CodeMirror-scroll,\n          .pgadmin-wizard").find('*[tabindex]:not([tabindex="-1"]),input:enabled');
    }

    if (first_el.length > 0) {
      first_el[0].focus();
    } else {
      container[0].focus();
    }
  }, 200);
}

var isValidData = function isValidData(data) {
  return !_underscore["default"].isUndefined(data) && !_underscore["default"].isNull(data);
};

exports.isValidData = isValidData;

var isFunction = function isFunction(fn) {
  return _underscore["default"].isFunction(fn);
};

exports.isFunction = isFunction;

var isString = function isString(str) {
  return _underscore["default"].isString(str);
};

exports.isString = isString;

function getEpoch(inp_date) {
  var date_obj = inp_date ? inp_date : new Date();
  return parseInt(date_obj.getTime() / 1000);
}
/* Eucladian GCD */


function getGCD(inp_arr) {
  var gcd_for_two = function gcd_for_two(a, b) {
    return a == 0 ? b : gcd_for_two(b % a, a);
  };

  var inp_len = inp_arr.length;

  if (inp_len <= 2) {
    return gcd_for_two(inp_arr[0], inp_arr[1]);
  }

  var result = inp_arr[0];

  for (var i = 1; i < inp_len; i++) {
    result = gcd_for_two(inp_arr[i], result);
  }

  return result;
}

function getMod(no, divisor) {
  return (no % divisor + divisor) % divisor;
}

function parseFuncParams(label) {
  var paramArr = [],
      funcName = '',
      paramStr = '';

  if (label.endsWith('()')) {
    funcName = label.substring(0, label.length - 2);
  } else if (!label.endsWith(')')) {
    funcName = label;
  } else if (!label.endsWith('()') && label.endsWith(')')) {
    var i = 0,
        startBracketPos = label.length;
    /* Parse through the characters in reverse to find the param start bracket */

    i = label.length - 2;

    while (i >= 0) {
      if (label[i] == '(') {
        startBracketPos = i;
        break;
      } else if (label[i] == '"') {
        /* If quotes, skip all the chars till next quote */
        i--;

        while (label[i] != '"') {
          i--;
        }
      }

      i--;
    }

    funcName = label.substring(0, startBracketPos);
    paramStr = label.substring(startBracketPos + 1, label.length - 1);
    var paramStart = 0,
        paramName = '',
        paramModes = ['IN', 'OUT', 'INOUT', 'VARIADIC'];
    i = 0;

    while (i < paramStr.length) {
      if (paramStr[i] == '"') {
        /* If quotes, skip all the chars till next quote */
        i++;

        while (paramStr[i] != '"') {
          i++;
        }
      } else if (paramStr[i] == ' ') {
        /* if paramName is already set, ignore till comma
         * Or if paramName is parsed as one of the modes, reset.
         */
        if (paramName == '' || paramModes.indexOf(paramName) > -1) {
          paramName = paramStr.substring(paramStart, i);
          paramStart = i + 1;
        }
      } else if (paramStr[i] == ',') {
        paramArr.push([paramName, paramStr.substring(paramStart, i)]);
        paramName = '';
        paramStart = i + 1;
      }

      i++;
    }

    paramArr.push([paramName, paramStr.substring(paramStart)]);
  }

  return {
    'func_name': funcName,
    'param_string': paramStr,
    'params': paramArr
  };
}

function quote_ident(value) {
  /* check if the string is number or not */
  var quoteIt = false;

  if (!isNaN(parseInt(value))) {
    quoteIt = true;
  }

  if (value.search(/[^a-z0-9_]/g) > -1) {
    /* escape double quotes */
    value = value.replace(/"/g, '""');
    quoteIt = true;
  }

  if (quoteIt) {
    return "\"".concat(value, "\"");
  } else {
    return value;
  }
}

function fully_qualify(pgBrowser, data, item) {
  var parentData = pgBrowser.tree.getTreeNodeHierarchy(item);
  var namespace = '';

  if (parentData.schema !== undefined) {
    namespace = quote_ident(parentData.schema._label);
  } else if (parentData.view !== undefined) {
    namespace = quote_ident(parentData.view._label);
  } else if (parentData.catalog !== undefined) {
    namespace = quote_ident(parentData.catalog._label);
  }

  if (parentData["package"] !== undefined && data._type != 'package') {
    if (namespace == '') {
      namespace = quote_ident(parentData["package"]._label);
    } else {
      namespace += '.' + quote_ident(parentData["package"]._label);
    }
  }

  if (namespace != '') {
    return namespace + '.' + quote_ident(data._label);
  } else {
    return quote_ident(data._label);
  }
}

function getRandomInt(min, max) {
  min = Math.ceil(min);
  max = Math.floor(max);
  return Math.floor(Math.random() * (max - min + 1)) + min;
}

function titleize(i_str) {
  if (i_str === '' || i_str === null) return i_str;
  return i_str.split(' ').map(function (w) {
    return w[0].toUpperCase() + w.substr(1).toLowerCase();
  }).join(' ');
}

function sprintf(i_str) {
  try {
    var replaceArgs = arguments;
    return i_str.split('%s').map(function (w, i) {
      if (i > 0) {
        if (i < replaceArgs.length) {
          return [replaceArgs[i], w].join('');
        } else {
          return ['%s', w].join('');
        }
      } else {
        return w;
      }
    }).join('');
  } catch (e) {
    console.error(e);
    return i_str;
  }
} // Modified ref: http://stackoverflow.com/a/1293163/2343 to suite pgAdmin.
// This will parse a delimited string into an array of arrays.


function CSVToArray(strData, strDelimiter, quoteChar) {
  strDelimiter = strDelimiter || ',';
  quoteChar = quoteChar || '"'; // Create a regular expression to parse the CSV values.

  var objPattern = new RegExp( // Delimiters.
  '(\\' + strDelimiter + '|\\r?\\n|\\r|^)' + ( // Quoted fields.
  quoteChar == '"' ? '(?:"([^"]*(?:""[^"]*)*)"|' : '(?:\'([^\']*(?:\'\'[^\']*)*)\'|') + ( // Standard fields.
  quoteChar == '"' ? '([^"\\' + strDelimiter + '\\r\\n]*))' : '([^\'\\' + strDelimiter + '\\r\\n]*))'), 'gi'); // Create an array to hold our data. Give the array
  // a default empty first row.

  var arrData = [[]]; // Create an array to hold our individual pattern
  // matching groups.

  var arrMatches = null; // Keep looping over the regular expression matches
  // until we can no longer find a match.

  while (arrMatches = objPattern.exec(strData)) {
    // Get the delimiter that was found.
    var strMatchedDelimiter = arrMatches[1]; // Check to see if the given delimiter has a length
    // (is not the start of string) and if it matches
    // field delimiter. If id does not, then we know
    // that this delimiter is a row delimiter.

    if (strMatchedDelimiter.length && strMatchedDelimiter !== strDelimiter) {
      // Since we have reached a new row of data,
      // add an empty row to our data array.
      arrData.push([]);
    }

    var strMatchedValue; // Now that we have our delimiter out of the way,
    // let's check to see which kind of value we
    // captured (quoted or unquoted).

    if (arrMatches[2]) {
      // We found a quoted value. When we capture
      // this value, unescape any quotes.
      strMatchedValue = arrMatches[2].replace(new RegExp(quoteChar + quoteChar, 'g'), quoteChar);
    } else {
      // We found a non-quoted value.
      strMatchedValue = arrMatches[3];
    } // Now that we have our value string, let's add
    // it to the data array.


    arrData[arrData.length - 1].push(strMatchedValue);
  } // Return the parsed data.


  return arrData;
}

function hasBinariesConfiguration(pgBrowser, serverInformation) {
  var module = 'paths';
  var preference_name = 'pg_bin_dir';
  var msg = (0, _gettext["default"])('Please configure the PostgreSQL Binary Path in the Preferences dialog.');

  if (serverInformation.type && serverInformation.type === 'ppas' || serverInformation.server_type === 'ppas') {
    preference_name = 'ppas_bin_dir';
    msg = (0, _gettext["default"])('Please configure the EDB Advanced Server Binary Path in the Preferences dialog.');
  }

  var preference = pgBrowser.get_preference(module, preference_name);

  if (preference) {
    if (_underscore["default"].isUndefined(preference.value) || !checkBinaryPathExists(preference.value, serverInformation.version)) {
      _Notifier["default"].alert((0, _gettext["default"])('Configuration required'), msg);

      return false;
    }
  } else {
    _Notifier["default"].alert((0, _gettext["default"])('Preferences Error'), (0, _gettext["default"])('Failed to load preference %s of module %s', preference_name, module));

    return false;
  }

  return true;
}

function checkBinaryPathExists(binaryPathArray, selectedServerVersion) {
  var foundDefaultPath = false,
      serverSpecificPathExist = false,
      binPathArray = JSON.parse(binaryPathArray);

  _underscore["default"].each(binPathArray, function (binPath) {
    if (selectedServerVersion >= binPath.version && selectedServerVersion < binPath.next_major_version) {
      if (!_underscore["default"].isUndefined(binPath.binaryPath) && !_underscore["default"].isNull(binPath.binaryPath) && binPath.binaryPath.trim() !== '') serverSpecificPathExist = true;
    } // Check for default path


    if (binPath.isDefault) {
      foundDefaultPath = true;
    }
  });

  return serverSpecificPathExist | foundDefaultPath;
}
/* If a function, then evaluate */


function evalFunc(obj, func, param) {
  if (_underscore["default"].isFunction(func)) {
    return func.apply(obj, [param]);
  }

  return func;
}

function registerDetachEvent(panel) {
  panel.on(wcDocker.EVENT.DETACHED, function () {
    (0, _jquery["default"])(this.$container[0].ownerDocument).find('.wcIFrameFloating').attr({
      style: 'z-index: 1200'
    });
  });
  panel.on(wcDocker.EVENT.ORDER_CHANGED, function () {
    (0, _jquery["default"])(this.$container[0].ownerDocument).find('.wcIFrameFloating').attr({
      style: 'z-index: 1200'
    });
  });
  panel.on(wcDocker.EVENT.ORDER_CHANGED, function () {
    var docker = this.docker(this._panel);
    var dockerPos = docker.$container.offset();
    var pos = this.$container.offset();
    var width = this.$container.width();
    var height = this.$container.height();
    (0, _jquery["default"])(this.$container[0].ownerDocument).find('.wcIFrameFloating').css('top', pos.top - dockerPos.top);
    (0, _jquery["default"])(this.$container[0].ownerDocument).find('.wcIFrameFloating').css('left', pos.left - dockerPos.left);
    (0, _jquery["default"])(this.$container[0].ownerDocument).find('.wcIFrameFloating').css('width', width);
    (0, _jquery["default"])(this.$container[0].ownerDocument).find('.wcIFrameFloating').find('.wcIFrameFloating').css('height', height);
  });
}

/***/ }),

/***/ 76055:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



__webpack_require__(68309);

__webpack_require__(91038);

__webpack_require__(78783);

__webpack_require__(82526);

__webpack_require__(41817);

__webpack_require__(32165);

__webpack_require__(79753);

__webpack_require__(69070);

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.minMaxValidator = minMaxValidator;
exports.numberValidator = numberValidator;
exports.integerValidator = integerValidator;
exports.emptyValidator = emptyValidator;
exports.isEmptyString = isEmptyString;
exports.checkUniqueCol = checkUniqueCol;

__webpack_require__(24603);

__webpack_require__(74916);

__webpack_require__(39714);

__webpack_require__(73210);

__webpack_require__(15306);

__webpack_require__(41539);

__webpack_require__(66992);

__webpack_require__(33948);

__webpack_require__(47042);

var _utils = __webpack_require__(44092);

var _lodash = _interopRequireDefault(__webpack_require__(96486));

var _pgadmin = _interopRequireDefault(__webpack_require__(55112));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e2) { throw _e2; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e3) { didErr = true; err = _e3; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

/* Validate value for min max range */
function minMaxValidator(label, value, minValue, maxValue) {
  if (_lodash["default"].isUndefined(value) || _lodash["default"].isNull(value) || String(value) === '') return null;

  if (!_lodash["default"].isUndefined(minValue) && value < minValue) {
    return (0, _utils.sprintf)(_pgadmin["default"].Browser.messages.MUST_GR_EQ, label, minValue);
  } else if (!_lodash["default"].isUndefined(maxValue) && value > maxValue) {
    return (0, _utils.sprintf)(_pgadmin["default"].Browser.messages.MUST_LESS_EQ, label, maxValue);
  }

  return null;
}
/* Validate value to check if it is a number */


function numberValidator(label, value) {
  if (_lodash["default"].isUndefined(value) || _lodash["default"].isNull(value) || String(value) === '') return null;
  var pattern = new RegExp('^-?[0-9]+(\.?[0-9]*)?$');

  if (!pattern.test(value)) {
    return (0, _utils.sprintf)(_pgadmin["default"].Browser.messages.MUST_BE_NUM, label);
  }

  return null;
}
/* Validate value to check if it is an integer */


function integerValidator(label, value) {
  if (_lodash["default"].isUndefined(value) || _lodash["default"].isNull(value) || String(value) === '') return null;
  var pattern = new RegExp('^-?[0-9]*$');

  if (!pattern.test(value)) {
    return (0, _utils.sprintf)(_pgadmin["default"].Browser.messages.MUST_BE_INT, label);
  }

  return null;
}
/* Validate value to check if it is empty */


function emptyValidator(label, value) {
  if (isEmptyString(value)) {
    return (0, _utils.sprintf)(_pgadmin["default"].Browser.messages.CANNOT_BE_EMPTY, label);
  }

  return null;
}

function isEmptyString(value) {
  return _lodash["default"].isUndefined(value) || _lodash["default"].isNull(value) || String(value).trim() === '' || String(value).replace(/^\s+|\s+$/g, '') == '';
}
/* Validate rows to check for any duplicate rows based on uniqueCols-columns array */


function checkUniqueCol(rows, uniqueCols) {
  if (uniqueCols) {
    var _iterator = _createForOfIteratorHelper(rows.entries()),
        _step;

    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var _step$value = _slicedToArray(_step.value, 2),
            i = _step$value[0],
            row = _step$value[1];

        var _iterator2 = _createForOfIteratorHelper(rows.slice(0, i)),
            _step2;

        try {
          for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
            var checkRow = _step2.value;
            if (_lodash["default"].isEqual(_lodash["default"].pick(checkRow, uniqueCols), _lodash["default"].pick(row, uniqueCols))) return i;
          }
        } catch (err) {
          _iterator2.e(err);
        } finally {
          _iterator2.f();
        }
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
  }

  return -1;
}

/***/ }),

/***/ 1950:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



__webpack_require__(69070);

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.default = void 0;

/////////////////////////////////////////////////////////////
//
// pgAdmin 4 - PostgreSQL Tools
//
// Copyright (C) 2013 - 2022, The pgAdmin Development Team
// This software is released under the PostgreSQL Licence
//
//////////////////////////////////////////////////////////////
var getWindowOpener = function getWindowOpener(opener) {
  return opener.opener && opener.opener.pgAdmin ? getWindowOpener(opener.opener) : opener;
};

var pgWindow = function () {
  var localPgWindow = null;

  try {
    if (window.opener && window.opener.pgAdmin) {
      /* Windows can be opened at multiple levels */
      localPgWindow = getWindowOpener(window.opener);
    } else if (window.parent && window.parent.pgAdmin) {
      localPgWindow = window.parent;
    } else if (window.top && window.top.pgAdmin) {
      localPgWindow = window.top;
    } else {
      localPgWindow = window;
    }
  } catch (error) {
    localPgWindow = window;
  }

  return localPgWindow;
}();

var _default = pgWindow;
exports.default = _default;

/***/ }),

/***/ 9807:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

/* provided dependency */ var _ = __webpack_require__(10084);


__webpack_require__(69070);

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.getDatabaseLabel = getDatabaseLabel;
exports.getPanelTitle = getPanelTitle;
exports.setQueryToolDockerTitle = setQueryToolDockerTitle;
exports.set_renamable_option = set_renamable_option;
exports.generateTitle = generateTitle;
exports.refresh_db_node = refresh_db_node;

__webpack_require__(68309);

__webpack_require__(15306);

__webpack_require__(74916);

__webpack_require__(24603);

__webpack_require__(39714);

var _gettext = _interopRequireDefault(__webpack_require__(91669));

var _window = _interopRequireDefault(__webpack_require__(1950));

var _Notifier = _interopRequireDefault(__webpack_require__(55958));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/////////////////////////////////////////////////////////////
//
// pgAdmin 4 - PostgreSQL Tools
//
// Copyright (C) 2013 - 2022, The pgAdmin Development Team
// This software is released under the PostgreSQL Licence
//
//////////////////////////////////////////////////////////////
var pgAdmin = _window["default"].pgAdmin;

function getDatabaseLabel(parentData) {
  return parentData.database ? parentData.database.label : parentData.server.db;
}

function isServerInformationAvailable(parentData) {
  return parentData.server === undefined;
}

function getPanelTitle(pgBrowser) {
  var selected_item = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
  var custom_title = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
  var parentData = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
  var conn_title = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : false;
  var db_label = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : null;
  var preferences = pgBrowser.get_preferences_for_module('browser');

  if (selected_item == null && parentData == null) {
    selected_item = pgBrowser.tree.selected();
  }

  if (parentData == null) {
    parentData = pgBrowser.tree.getTreeNodeHierarchy(selected_item);
    if (parentData == null) return;

    if (isServerInformationAvailable(parentData)) {
      return;
    }
  }

  if (!db_label) {
    db_label = getDatabaseLabel(parentData);
  }

  var qt_title_placeholder = '';

  if (!conn_title) {
    if (custom_title) {
      qt_title_placeholder = custom_title;
    } else {
      qt_title_placeholder = preferences['qt_tab_title_placeholder'];
    }
  } else {
    qt_title_placeholder = pgAdmin['qt_default_placeholder'];
  }

  var title_data = {
    'database': db_label,
    'username': parentData.server.user.name,
    'server': parentData.server.label,
    'type': 'query_tool'
  };
  var title = generateTitle(qt_title_placeholder, title_data);
  return title;
}

function setQueryToolDockerTitle(panel, is_query_tool, panel_title, is_file) {
  var panel_icon = '',
      panel_tooltip = ''; // Enable/ Disabled the rename panel option if file is open.

  set_renamable_option(panel, is_file);

  if (is_file || is_file == 'true') {
    panel_tooltip = (0, _gettext["default"])('File - ') + panel_title;
    panel_icon = 'fa fa-file-alt';
  } else if (is_query_tool == 'false' || is_query_tool == false) {
    // Edit grid titles
    panel_tooltip = (0, _gettext["default"])('View/Edit Data - ') + panel_title;
    panel_icon = 'pg-font-icon icon-view_data';
  } else {
    // Query tool titles
    panel_tooltip = (0, _gettext["default"])('Query Tool - ') + panel_title;
    panel_icon = 'pg-font-icon icon-query_tool';
  }

  panel.title('<span title="' + _.escape(panel_tooltip) + '">' + _.escape(panel_title) + '</span>');
  panel.icon(panel_icon);
}

function set_renamable_option(panel, is_file) {
  if (is_file || is_file == 'true') {
    panel.renamable(false);
  } else {
    panel.renamable(true);
  }
}

function generateTitle(title_placeholder, title_data) {
  if (title_data.type == 'query_tool') {
    title_placeholder = title_placeholder.replace(new RegExp('%DATABASE%'), _.unescape(title_data.database));
    title_placeholder = title_placeholder.replace(new RegExp('%USERNAME%'), _.unescape(title_data.username));
    title_placeholder = title_placeholder.replace(new RegExp('%SERVER%'), _.unescape(title_data.server));
  } else if (title_data.type == 'datagrid') {
    title_placeholder = title_placeholder.replace(new RegExp('%DATABASE%'), _.unescape(title_data.database));
    title_placeholder = title_placeholder.replace(new RegExp('%USERNAME%'), _.unescape(title_data.username));
    title_placeholder = title_placeholder.replace(new RegExp('%SERVER%'), _.unescape(title_data.server));
    title_placeholder = title_placeholder.replace(new RegExp('%SCHEMA%'), _.unescape(title_data.schema));
    title_placeholder = title_placeholder.replace(new RegExp('%TABLE%'), _.unescape(title_data.table));
  } else if (title_data.type == 'debugger') {
    title_placeholder = title_placeholder.replace(new RegExp('%FUNCTION%'), _.unescape(title_data.function_name));
    title_placeholder = title_placeholder.replace(new RegExp('%ARGS%'), _.unescape(title_data.args));
    title_placeholder = title_placeholder.replace(new RegExp('%SCHEMA%'), _.unescape(title_data.schema));
    title_placeholder = title_placeholder.replace(new RegExp('%DATABASE%'), _.unescape(title_data.database));
  } else if (title_data.type == 'psql_tool') {
    title_placeholder = title_placeholder.replace(new RegExp('%DATABASE%'), _.unescape(title_data.database));
    title_placeholder = title_placeholder.replace(new RegExp('%USERNAME%'), _.unescape(title_data.username));
    title_placeholder = title_placeholder.replace(new RegExp('%SERVER%'), _.unescape(title_data.server));
  }

  return _.escape(title_placeholder);
}
/*
 * This function is used refresh the db node after showing alert to the user
 */


function refresh_db_node(message, dbNode) {
  _Notifier["default"].alert().setting({
    'title': (0, _gettext["default"])('Database moved/renamed'),
    'label': (0, _gettext["default"])('OK'),
    'message': (0, _gettext["default"])(message),
    'onok': function onok() {
      //Set the original db name as soon as user clicks ok button
      pgAdmin.Browser.Nodes.database.callbacks.refresh(undefined, dbNode);
    }
  }).show();
}

/***/ }),

/***/ 7167:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



__webpack_require__(69070);

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.showQueryTool = showQueryTool;
exports.generateScript = generateScript;
exports.showERDSqlTool = showERDSqlTool;
exports.launchDataGrid = launchDataGrid;
exports._set_dynamic_tab = _set_dynamic_tab;

__webpack_require__(92222);

__webpack_require__(89554);

__webpack_require__(54747);

var _gettext = _interopRequireDefault(__webpack_require__(91669));

var _url_for = _interopRequireDefault(__webpack_require__(28008));

var _datagrid_panel_title = __webpack_require__(9807);

var _utils = __webpack_require__(44092);

var _jquery = _interopRequireDefault(__webpack_require__(19755));

var _Notifier = _interopRequireDefault(__webpack_require__(55958));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/////////////////////////////////////////////////////////////
//
// pgAdmin 4 - PostgreSQL Tools
//
// Copyright (C) 2013 - 2022, The pgAdmin Development Team
// This software is released under the PostgreSQL Licence
//
//////////////////////////////////////////////////////////////
function hasDatabaseInformation(parentData) {
  return parentData.database;
}

function generateUrl(trans_id, title, parentData, sqlId) {
  var url_endpoint = (0, _url_for["default"])('datagrid.panel', {
    'trans_id': trans_id
  });
  url_endpoint += "?is_query_tool=".concat(true) + "&sgid=".concat(parentData.server_group._id) + "&sid=".concat(parentData.server._id) + "&server_type=".concat(parentData.server.server_type);

  if (hasDatabaseInformation(parentData)) {
    url_endpoint += "&did=".concat(parentData.database._id);
  }

  if (sqlId) {
    url_endpoint += "&sql_id=".concat(sqlId);
  }

  return url_endpoint;
}

function hasServerInformations(parentData) {
  return parentData.server === undefined;
}

function generateTitle(pgBrowser, aciTreeIdentifier) {
  var baseTitle = (0, _datagrid_panel_title.getPanelTitle)(pgBrowser, aciTreeIdentifier);
  return baseTitle;
}

function showQueryTool(datagrid, pgBrowser, url, aciTreeIdentifier, transId) {
  var sURL = url || '';
  var queryToolTitle = generateTitle(pgBrowser, aciTreeIdentifier);
  var currentNode = pgBrowser.tree.findNodeByDomElement(aciTreeIdentifier);

  if (currentNode === undefined) {
    _Notifier["default"].alert((0, _gettext["default"])('Query Tool Error'), (0, _gettext["default"])('No object selected.'));

    return;
  }

  var parentData = pgBrowser.tree.getTreeNodeHierarchy(currentNode);

  if (hasServerInformations(parentData)) {
    return;
  }

  var gridUrl = generateUrl(transId, queryToolTitle, parentData);
  launchDataGrid(datagrid, transId, gridUrl, queryToolTitle, sURL);
}

function generateScript(parentData, datagrid) {
  var queryToolTitle = "".concat(parentData.database, "/").concat(parentData.user, "@").concat(parentData.server);
  var transId = (0, _utils.getRandomInt)(1, 9999999);
  var url_endpoint = (0, _url_for["default"])('datagrid.panel', {
    'trans_id': transId
  });
  url_endpoint += "?is_query_tool=".concat(true) + "&sgid=".concat(parentData.sgid) + "&sid=".concat(parentData.sid) + "&server_type=".concat(parentData.stype) + "&did=".concat(parentData.did);
  launchDataGrid(datagrid, transId, url_endpoint, queryToolTitle, '');
}

function showERDSqlTool(parentData, erdSqlId, queryToolTitle, datagrid) {
  var transId = (0, _utils.getRandomInt)(1, 9999999);
  parentData = {
    server_group: {
      _id: parentData.sgid
    },
    server: {
      _id: parentData.sid,
      server_type: parentData.stype
    },
    database: {
      _id: parentData.did
    }
  };
  var gridUrl = generateUrl(transId, queryToolTitle, parentData, erdSqlId);
  launchDataGrid(datagrid, transId, gridUrl, queryToolTitle, '');
}

function launchDataGrid(datagrid, transId, gridUrl, queryToolTitle, sURL) {
  var retVal = datagrid.launch_grid(transId, gridUrl, true, queryToolTitle, sURL);

  if (!retVal) {
    _Notifier["default"].alert((0, _gettext["default"])('Query tool launch error'), (0, _gettext["default"])('Please allow pop-ups for this site to perform the desired action. If the main window of pgAdmin is closed then close this window and open a new pgAdmin session.'));
  }
}

function _set_dynamic_tab(pgBrowser, value) {
  var datagrid_panels = pgBrowser.docker.findPanels('frm_datagrid');
  datagrid_panels.forEach(function (panel) {
    if (value) {
      (0, _jquery["default"])('#' + panel.$title.index() + ' div:first').addClass('wcPanelTab-dynamic');
    } else {
      (0, _jquery["default"])('#' + panel.$title.index() + ' div:first').removeClass('wcPanelTab-dynamic');
    }
  });
  var debugger_panels = pgBrowser.docker.findPanels('frm_debugger');
  debugger_panels.forEach(function (panel) {
    if (value) {
      (0, _jquery["default"])('#' + panel.$title.index() + ' div:first').addClass('wcPanelTab-dynamic');
    } else {
      (0, _jquery["default"])('#' + panel.$title.index() + ' div:first').removeClass('wcPanelTab-dynamic');
    }
  });
}

/***/ }),

/***/ 92323:
/***/ ((module, exports, __webpack_require__) => {

var __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;

__webpack_require__(82772);

__webpack_require__(15306);

__webpack_require__(74916);

__webpack_require__(91058);

__webpack_require__(54678);

__webpack_require__(23123);

__webpack_require__(69826);

__webpack_require__(32564);

__webpack_require__(26699);

__webpack_require__(32023);

__webpack_require__(73210);

var _Notifier = _interopRequireDefault(__webpack_require__(55958));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/////////////////////////////////////////////////////////////
//
// pgAdmin 4 - PostgreSQL Tools
//
// Copyright (C) 2013 - 2022, The pgAdmin Development Team
// This software is released under the PostgreSQL Licence
//
//////////////////////////////////////////////////////////////
!(__WEBPACK_AMD_DEFINE_ARRAY__ = [__webpack_require__(91669), __webpack_require__(28008), __webpack_require__(19755), __webpack_require__(81311), __webpack_require__(72316), __webpack_require__(55455), __webpack_require__(55112), __webpack_require__(33883), __webpack_require__(71158), __webpack_require__(1950), __webpack_require__(6715), __webpack_require__(44092), __webpack_require__(35816)], __WEBPACK_AMD_DEFINE_RESULT__ = (function (gettext, url_for, $, _, Backbone, Alertify, pgAdmin, pgBrowser, Backgrid, pgWindow, debuggerUtils, commonUtils) {
  var wcDocker = window.wcDocker;
  /*
   * Function used to return the respective Backgrid control based on the data type
   * of function input argument.
   */

  var cellFunction = function cellFunction(model) {
    var variable_type = model.get('type'); // if variable type is an array then we need to render the custom control to take the input from user.

    if (variable_type.indexOf('[]') != -1) {
      var data_type = variable_type.replace('[]', '');

      switch (data_type) {
        case 'boolean':
          return Backgrid.Extension.InputBooleanArrayCell;

        case 'integer':
        case 'smallint':
        case 'bigint':
        case 'serial':
        case 'smallserial':
        case 'bigserial':
        case 'oid':
        case 'cid':
        case 'xid':
        case 'tid':
          return Backgrid.Extension.InputIntegerArrayCell;

        case 'real':
        case 'numeric':
        case 'double precision':
        case 'decimal':
          return Backgrid.Extension.InputNumberArrayCell;

        default:
          return Backgrid.Extension.InputStringArrayCell;
      }
    } else {
      switch (variable_type) {
        case 'boolean':
          return Backgrid.BooleanCell.extend({
            formatter: Backgrid.BooleanCellFormatter
          });

        case 'integer':
        case 'smallint':
        case 'bigint':
        case 'serial':
        case 'smallserial':
        case 'bigserial':
        case 'oid':
        case 'cid':
        case 'xid':
        case 'tid':
          // As we are getting this value as text from sqlite database so we need to type cast it.
          if (model.get('value') != undefined) {
            model.set({
              'value': isNaN(parseInt(model.get('value'))) ? null : parseInt(model.get('value'))
            }, {
              silent: true
            });
          }

          return Backgrid.IntegerCell;

        case 'real':
        case 'numeric':
        case 'double precision':
        case 'decimal':
          // As we are getting this value as text from sqlite database so we need to type cast it.
          if (model.get('value') != undefined) {
            model.set({
              'value': parseFloat(model.get('value'))
            }, {
              silent: true
            });
          }

          return Backgrid.NumberCell;

        case 'string':
          return Backgrid.StringCell;

        case 'date':
          return Backgrid.DateCell;

        default:
          return Backgrid.Cell;
      }
    }
  };
  /*
   * Function used to return the respective Backgrid string or boolean control based on the data type
   * of function input argument.
   */


  var cellExprControlFunction = function cellExprControlFunction(model) {
    var variable_type = model.get('type');

    if (variable_type.indexOf('[]') != -1) {
      return Backgrid.StringCell;
    }

    return Backgrid.BooleanCell;
  };
  /**
   *  DebuggerInputArgsModel used to represent input parameters for the function to debug
   *  for function objects.
   **/


  var DebuggerInputArgsModel = Backbone.Model.extend({
    defaults: {
      name: undefined,
      type: undefined,
      is_null: undefined,
      expr: undefined,
      value: undefined,
      use_default: undefined,
      default_value: undefined
    },
    validate: function validate() {
      if (_.isUndefined(this.get('value')) || _.isNull(this.get('value')) || String(this.get('value')).replace(/^\s+|\s+$/g, '') == '') {
        var msg = gettext('Please enter a value for the parameter.');
        this.errorModel.set('value', msg);
        return msg;
      } else {
        this.errorModel.unset('value');
      }

      return null;
    }
  }); // Collection which contains the model for function informations.

  var DebuggerInputArgCollections = Backbone.Collection.extend({
    model: DebuggerInputArgsModel
  }); // function will enable/disable the use_default column based on the value received.

  var disableDefaultCell = function disableDefaultCell(d) {
    if (d instanceof Backbone.Model) {
      return d.get('use_default');
    }

    return false;
  }; // Enable/Disable the control based on the array data type of the function input arguments


  var disableExpressionControl = function disableExpressionControl(d) {
    if (d instanceof Backbone.Model) {
      var argType = d.get('type');

      if (argType.indexOf('[]') != -1) {
        return false;
      }

      return true;
    }
  };

  var res = function res(debugInfo, restartDebug, isEdbProc, transId) {
    if (!Alertify.debuggerInputArgsDialog) {
      Alertify.dialog('debuggerInputArgsDialog', function factory() {
        return {
          main: function main(title, debug_info, restart_debug, is_edb_proc, trans_id) {
            this.preferences = pgWindow["default"].pgAdmin.Browser.get_preferences_for_module('debugger');
            this.set('title', title); // setting value in alertify settings allows us to access it from
            // other functions other than main function.

            this.set('debug_info', debug_info);
            this.set('restart_debug', restart_debug);
            this.set('trans_id', trans_id);
            this.set('is_edb_proc', is_edb_proc); // Variables to store the data sent from sqlite database

            var func_args_data = this.func_args_data = []; // As we are not getting pgBrowser.tree when we debug again
            // so tree info will be updated from the server data

            if (restart_debug == 0) {
              var t = pgBrowser.tree,
                  i = t.selected(),
                  d = i ? t.itemData(i) : undefined;
              if (!d) return;

              var treeInfo = t.getTreeNodeHierarchy(i),
                  _Url;

              if (d._type == 'function') {
                // Get the existing function parameters available from sqlite database
                _Url = url_for('debugger.get_arguments', {
                  'sid': treeInfo.server._id,
                  'did': treeInfo.database._id,
                  'scid': treeInfo.schema._id,
                  'func_id': treeInfo["function"]._id
                });
              } else if (d._type == 'procedure') {
                // Get the existing function parameters available from sqlite database
                _Url = url_for('debugger.get_arguments', {
                  'sid': treeInfo.server._id,
                  'did': treeInfo.database._id,
                  'scid': treeInfo.schema._id,
                  'func_id': treeInfo.procedure._id
                });
              } else if (d._type == 'edbfunc') {
                // Get the existing function parameters available from sqlite database
                _Url = url_for('debugger.get_arguments', {
                  'sid': treeInfo.server._id,
                  'did': treeInfo.database._id,
                  'scid': treeInfo.schema._id,
                  'func_id': treeInfo.edbfunc._id
                });
              } else if (d._type == 'edbproc') {
                // Get the existing function parameters available from sqlite database
                _Url = url_for('debugger.get_arguments', {
                  'sid': treeInfo.server._id,
                  'did': treeInfo.database._id,
                  'scid': treeInfo.schema._id,
                  'func_id': treeInfo.edbproc._id
                });
              }
            } else {
              // Get the existing function parameters available from sqlite database
              _Url = url_for('debugger.get_arguments', {
                'sid': debug_info.server_id,
                'did': debug_info.database_id,
                'scid': debug_info.schema_id,
                'func_id': debug_info.function_id
              });
            }

            $.ajax({
              url: _Url,
              method: 'GET',
              async: false
            }).done(function (res_get) {
              if (res_get.data.args_count != 0) {
                for (i = 0; i < res_get.data.result.length; i++) {
                  // Below will format the data to be stored in sqlite database
                  func_args_data.push({
                    'arg_id': res_get.data.result[i]['arg_id'],
                    'is_null': res_get.data.result[i]['is_null'],
                    'is_expression': res_get.data.result[i]['is_expression'],
                    'use_default': res_get.data.result[i]['use_default'],
                    'value': res_get.data.result[i]['value']
                  });
                }
              }
            }).fail(function () {
              _Notifier["default"].alert(gettext('Debugger Error'), gettext('Unable to fetch the arguments from server'));
            });
            var argname, argtype, argmode, default_args_count, default_args, arg_cnt;
            var value_header = Backgrid.HeaderCell.extend({
              // Add fixed width to the "value" column
              className: 'width_percent_25'
            });
            var def_val_list = [],
                gridCols = [{
              name: 'name',
              label: gettext('Name'),
              type: 'text',
              editable: false,
              cell: 'string'
            }, {
              name: 'type',
              label: gettext('Type'),
              type: 'text',
              editable: false,
              cell: 'string'
            }, {
              name: 'is_null',
              label: gettext('Null?'),
              type: 'boolean',
              cell: 'boolean',
              align_center: true
            }, {
              name: 'expr',
              label: gettext('Expression?'),
              type: 'boolean',
              cellFunction: cellExprControlFunction,
              editable: disableExpressionControl,
              align_center: true
            }, {
              name: 'value',
              label: gettext('Value'),
              type: 'text',
              editable: true,
              cellFunction: cellFunction,
              headerCell: value_header,
              align_center: true
            }, {
              name: 'use_default',
              label: gettext('Use Default?'),
              type: 'boolean',
              cell: 'boolean',
              editable: disableDefaultCell
            }, {
              name: 'default_value',
              label: gettext('Default'),
              type: 'text',
              editable: false,
              cell: 'string'
            }];
            var my_obj = [];
            var func_obj = []; // Below will calculate the input argument id required to store in sqlite database

            var input_arg_id = this.input_arg_id = [],
                k;

            if (debug_info['proargmodes'] != null) {
              var argmode_1 = debug_info['proargmodes'].split(',');

              for (k = 0; k < argmode_1.length; k++) {
                if (argmode_1[k] == 'i' || argmode_1[k] == 'b' || is_edb_proc && argmode_1[k] == 'o') {
                  input_arg_id.push(k);
                }
              }
            } else {
              var argtype_1 = debug_info['proargtypenames'].split(',');

              for (k = 0; k < argtype_1.length; k++) {
                input_arg_id.push(k);
              }
            }

            argtype = debug_info['proargtypenames'].split(',');

            if (debug_info['proargmodes'] != null) {
              argmode = debug_info['proargmodes'].split(',');
            }

            if (debug_info['pronargdefaults']) {
              default_args_count = debug_info['pronargdefaults'];
              default_args = debug_info['proargdefaults'].split(',');
              arg_cnt = default_args_count;
            }

            var vals, values, index, use_def_value, j;

            if (debug_info['proargnames'] != null) {
              argname = debug_info['proargnames'].split(','); // It will assign default values to "Default value" column

              for (j = argname.length - 1; j >= 0; j--) {
                if (debug_info['proargmodes'] != null) {
                  if (argmode && (argmode[j] == 'i' || argmode[j] == 'b' || is_edb_proc && argmode[j] == 'o')) {
                    if (arg_cnt) {
                      arg_cnt = arg_cnt - 1;
                      def_val_list[j] = default_args[arg_cnt];
                    } else {
                      def_val_list[j] = '<no default>';
                    }
                  }
                } else if (arg_cnt) {
                  arg_cnt = arg_cnt - 1;
                  def_val_list[j] = default_args[arg_cnt];
                } else {
                  def_val_list[j] = '<no default>';
                }
              }

              if (argtype.length != 0) {
                for (i = 0; i < argtype.length; i++) {
                  if (debug_info['proargmodes'] != null) {
                    if (argmode && (argmode[i] == 'i' || argmode[i] == 'b' || is_edb_proc && argmode[i] == 'o')) {
                      use_def_value = false;

                      if (def_val_list[i] != '<no default>') {
                        use_def_value = true;
                      }

                      my_obj.push({
                        'name': argname[i],
                        'type': argtype[i],
                        'use_default': use_def_value,
                        'default_value': def_val_list[i]
                      });
                    }
                  } else {
                    use_def_value = false;

                    if (def_val_list[i] != '<no default>') {
                      use_def_value = true;
                    }

                    my_obj.push({
                      'name': argname[i],
                      'type': argtype[i],
                      'use_default': use_def_value,
                      'default_value': def_val_list[i]
                    });
                  }
                }
              } // Need to update the func_obj variable from sqlite database if available


              if (func_args_data.length != 0) {
                for (i = 0; i < func_args_data.length; i++) {
                  index = func_args_data[i]['arg_id'];

                  if (debug_info['proargmodes'] != null && argmode && argmode[index] == 'o' && !is_edb_proc) {
                    continue;
                  }

                  values = [];

                  if (argtype[index].indexOf('[]') != -1) {
                    vals = func_args_data[i]['value'].split(',');

                    _.each(vals, function (val) {
                      values.push({
                        'value': val
                      });
                    });
                  } else {
                    values = func_args_data[i]['value'];
                  }

                  func_obj.push({
                    'name': argname[index],
                    'type': argtype[index],
                    'is_null': func_args_data[i]['is_null'] ? true : false,
                    'expr': func_args_data[i]['is_expression'] ? true : false,
                    'value': values,
                    'use_default': func_args_data[i]['use_default'] ? true : false,
                    'default_value': def_val_list[index]
                  });
                }
              }
            } else {
              /*
               Generate the name parameter if function do not have arguments name
               like dbgparam1, dbgparam2 etc.
              */
              var myargname = [];

              for (i = 0; i < argtype.length; i++) {
                myargname[i] = 'dbgparam' + (i + 1);
              } // If there is no default arguments


              if (!debug_info['pronargdefaults']) {
                for (i = 0; i < argtype.length; i++) {
                  my_obj.push({
                    'name': myargname[i],
                    'type': argtype[i],
                    'use_default': false,
                    'default_value': '<No default value>'
                  });
                  def_val_list[i] = '<No default value>';
                }
              } else {
                // If there is default arguments
                //Below logic will assign default values to "Default value" column
                for (j = myargname.length - 1; j >= 0; j--) {
                  if (arg_cnt) {
                    arg_cnt = arg_cnt - 1;
                    def_val_list[j] = default_args[arg_cnt];
                  } else {
                    def_val_list[j] = '<No default value>';
                  }
                }

                for (i = 0; i < argtype.length; i++) {
                  if (debug_info['proargmodes'] == null) {
                    use_def_value = false;

                    if (def_val_list[i] != '<No default value>') {
                      use_def_value = true;
                    }

                    my_obj.push({
                      'name': myargname[i],
                      'type': argtype[i],
                      'use_default': use_def_value,
                      'default_value': def_val_list[i]
                    });
                  } else {
                    if (argmode && (argmode[i] == 'i' || argmode[i] == 'b' || is_edb_proc && argmode[i] == 'o')) {
                      use_def_value = false;

                      if (def_val_list[i] != '<No default value>') {
                        use_def_value = true;
                      }

                      my_obj.push({
                        'name': myargname[i],
                        'type': argtype[i],
                        'use_default': use_def_value,
                        'default_value': def_val_list[i]
                      });
                    }
                  }
                }
              } // Need to update the func_obj variable from sqlite database if available


              if (func_args_data.length != 0) {
                for (i = 0; i < func_args_data.length; i++) {
                  index = func_args_data[i]['arg_id'];
                  values = [];

                  if (argtype[index].indexOf('[]') != -1) {
                    vals = func_args_data[i]['value'].split(',');

                    _.each(vals, function (val) {
                      values.push({
                        'value': val
                      });
                    });
                  } else {
                    values = func_args_data[i]['value'];
                  }

                  func_obj.push({
                    'name': myargname[index],
                    'type': argtype[index],
                    'is_null': func_args_data[i]['is_null'] ? true : false,
                    'expr': func_args_data[i]['is_expression'] ? true : false,
                    'value': values,
                    'use_default': func_args_data[i]['use_default'] ? true : false,
                    'default_value': def_val_list[index]
                  });
                }
              }
            } // Check if the arguments already available in the sqlite database
            // then we should use the existing arguments


            if (func_args_data.length == 0) {
              this.debuggerInputArgsColl = new DebuggerInputArgCollections(my_obj);
            } else {
              this.debuggerInputArgsColl = new DebuggerInputArgCollections(func_obj);
            } // Initialize a new Grid instance


            if (this.grid) {
              this.grid.remove();
              this.grid = null;
            }

            var grid = this.grid = new Backgrid.Grid({
              columns: gridCols,
              collection: this.debuggerInputArgsColl,
              className: 'backgrid table table-bordered table-noouter-border table-bottom-border'
            });
            grid.render();
            var wrap_div = document.createElement('div');
            wrap_div.classList.add('debugger-args');
            wrap_div.appendChild(grid.el);
            $(this.elements.content).html(wrap_div); // For keyboard navigation in the grid
            // we'll set focus on checkbox from the first row if any

            var grid_checkbox = $(grid.el).find('input:checkbox').first();

            if (grid_checkbox.length) {
              setTimeout(function () {
                grid_checkbox.trigger('focus');
              }, 250);
            }
          },
          settings: {
            debug_info: undefined,
            restart_debug: undefined,
            trans_id: undefined
          },
          setup: function setup() {
            return {
              buttons: [{
                text: gettext('Clear All'),
                className: 'btn btn-secondary pull-left fa fa-eraser pg-alertify-button'
              }, {
                text: gettext('Cancel'),
                key: 27,
                className: 'btn btn-secondary fa fa-times pg-alertify-button'
              }, {
                text: gettext('Debug'),
                key: 13,
                className: 'btn btn-primary fa fa-bug pg-alertify-button'
              }],
              // Set options for dialog
              options: {
                //disable both padding and overflow control.
                padding: !1,
                overflow: !1,
                model: 0,
                resizable: true,
                maximizable: true,
                pinnable: false,
                closableByDimmer: false,
                modal: false
              }
            };
          },
          // Callback functions when click on the buttons of the Alertify dialogs
          callback: function callback(e) {
            if (e.button.text === gettext('Debug')) {
              // Initialize the target once the debug button is clicked and
              // create asynchronous connection and unique transaction ID
              var self = this; // If the debugging is started again then treeInfo is already
              // stored in this.data so we can use the same.

              if (self.setting('restart_debug') == 0) {
                var t = pgBrowser.tree,
                    i = t.selected(),
                    d = i ? t.itemData(i) : undefined;
                if (!d) return;
                var treeInfo = t.getTreeNodeHierarchy(i);
              }

              var args_value_list = [];
              var sqlite_func_args_list = this.sqlite_func_args_list = [];
              var int_count = 0;
              this.grid.collection.each(function (m) {
                // Check if value is set to NULL then we should ignore the value field
                if (m.get('is_null')) {
                  args_value_list.push({
                    'name': m.get('name'),
                    'type': m.get('type'),
                    'value': 'NULL'
                  });
                } else {
                  // Check if default value to be used or not
                  if (m.get('use_default')) {
                    args_value_list.push({
                      'name': m.get('name'),
                      'type': m.get('type'),
                      'value': m.get('default_value')
                    });
                  } else {
                    args_value_list.push({
                      'name': m.get('name'),
                      'type': m.get('type'),
                      'value': m.get('value')
                    });
                  }
                }

                if (self.setting('restart_debug') == 0) {
                  var f_id;

                  if (d._type == 'function') {
                    f_id = treeInfo["function"]._id;
                  } else if (d._type == 'procedure') {
                    f_id = treeInfo.procedure._id;
                  } else if (d._type == 'edbfunc') {
                    f_id = treeInfo.edbfunc._id;
                  } else if (d._type == 'edbproc') {
                    f_id = treeInfo.edbproc._id;
                  } // Below will format the data to be stored in sqlite database


                  sqlite_func_args_list.push({
                    'server_id': treeInfo.server._id,
                    'database_id': treeInfo.database._id,
                    'schema_id': treeInfo.schema._id,
                    'function_id': f_id,
                    'arg_id': self.input_arg_id[int_count],
                    'is_null': m.get('is_null') ? 1 : 0,
                    'is_expression': m.get('expr') ? 1 : 0,
                    'use_default': m.get('use_default') ? 1 : 0,
                    'value': m.get('value')
                  });
                } else {
                  // Below will format the data to be stored in sqlite database
                  sqlite_func_args_list.push({
                    'server_id': self.setting('debug_info').server_id,
                    'database_id': self.setting('debug_info').database_id,
                    'schema_id': self.setting('debug_info').schema_id,
                    'function_id': self.setting('debug_info').function_id,
                    'arg_id': self.input_arg_id[int_count],
                    'is_null': m.get('is_null') ? 1 : 0,
                    'is_expression': m.get('expr') ? 1 : 0,
                    'use_default': m.get('use_default') ? 1 : 0,
                    'value': m.get('value')
                  });
                }

                int_count = int_count + 1;
              });
              var baseUrl; // If debugging is not started again then we should initialize the target otherwise not

              if (self.setting('restart_debug') == 0) {
                if (d && d._type == 'function') {
                  baseUrl = url_for('debugger.initialize_target_for_function', {
                    'debug_type': 'direct',
                    'trans_id': self.setting('trans_id'),
                    'sid': treeInfo.server._id,
                    'did': treeInfo.database._id,
                    'scid': treeInfo.schema._id,
                    'func_id': treeInfo["function"]._id
                  });
                } else if (d && d._type == 'procedure') {
                  baseUrl = url_for('debugger.initialize_target_for_function', {
                    'debug_type': 'direct',
                    'trans_id': self.setting('trans_id'),
                    'sid': treeInfo.server._id,
                    'did': treeInfo.database._id,
                    'scid': treeInfo.schema._id,
                    'func_id': treeInfo.procedure._id
                  });
                } else if (d && d._type == 'edbfunc') {
                  baseUrl = url_for('debugger.initialize_target_for_function', {
                    'debug_type': 'direct',
                    'trans_id': self.setting('trans_id'),
                    'sid': treeInfo.server._id,
                    'did': treeInfo.database._id,
                    'scid': treeInfo.schema._id,
                    'func_id': treeInfo.edbfunc._id
                  });
                } else if (d && d._type == 'edbproc') {
                  baseUrl = url_for('debugger.initialize_target_for_function', {
                    'debug_type': 'direct',
                    'trans_id': self.setting('trans_id'),
                    'sid': treeInfo.server._id,
                    'did': treeInfo.database._id,
                    'scid': treeInfo.schema._id,
                    'func_id': treeInfo.edbproc._id
                  });
                }

                $.ajax({
                  url: baseUrl,
                  method: 'POST',
                  data: {
                    'data': JSON.stringify(args_value_list)
                  }
                }).done(function (res_post) {
                  var url = url_for('debugger.direct', {
                    'trans_id': res_post.data.debuggerTransId
                  });
                  var browserPreferences = pgWindow["default"].pgAdmin.Browser.get_preferences_for_module('browser');
                  var open_new_tab = browserPreferences.new_browser_tab_open;

                  if (open_new_tab && open_new_tab.includes('debugger')) {
                    window.open(url, '_blank'); // Send the signal to runtime, so that proper zoom level will be set.

                    setTimeout(function () {
                      pgBrowser.send_signal_to_runtime('Runtime new window opened');
                    }, 500);
                  } else {
                    pgBrowser.Events.once('pgadmin-browser:frame:urlloaded:frm_debugger', function (frame) {
                      frame.openURL(url);
                    }); // Create the debugger panel as per the data received from user input dialog.

                    var dashboardPanel = pgBrowser.docker.findPanels('properties'),
                        panel = pgBrowser.docker.addPanel('frm_debugger', wcDocker.DOCK.STACKED, dashboardPanel[0]);
                    var browser_pref = pgBrowser.get_preferences_for_module('browser');
                    var label = treeInfo["function"] ? treeInfo["function"].label : treeInfo.trigger_function ? treeInfo.trigger_function.label : treeInfo.trigger ? treeInfo.trigger.label : treeInfo.procedure.label;
                    debuggerUtils.setDebuggerTitle(panel, browser_pref, label, treeInfo.schema.label, treeInfo.database.label, null, pgBrowser);
                    panel.focus(); // Panel Closed event

                    panel.on(wcDocker.EVENT.CLOSED, function () {
                      var closeUrl = url_for('debugger.close', {
                        'trans_id': res_post.data.debuggerTransId
                      });
                      $.ajax({
                        url: closeUrl,
                        method: 'DELETE'
                      });
                    });
                    commonUtils.registerDetachEvent(panel); // Panel Rename event

                    panel.on(wcDocker.EVENT.RENAME, function (panel_data) {
                      Alertify.prompt('', panel_data.$titleText[0].textContent, // We will execute this function when user clicks on the OK button
                      function (evt, value) {
                        if (value) {
                          // Remove the leading and trailing white spaces.
                          value = value.trim();
                          var name = treeInfo["function"] ? treeInfo["function"].label : treeInfo.trigger_function ? treeInfo.trigger_function.label : treeInfo.trigger ? treeInfo.trigger.label : treeInfo.procedure.label;
                          debuggerUtils.setDebuggerTitle(panel, self.preferences, name, treeInfo.schema.label, treeInfo.database.label, value, pgBrowser);
                        }
                      }, // We will execute this function when user clicks on the Cancel
                      // button.  Do nothing just close it.
                      function (evt) {
                        evt.cancel = false;
                      }).set({
                        'title': gettext('Rename Panel')
                      });
                    });
                  }

                  var _url;

                  if (d._type == 'function') {
                    _url = url_for('debugger.set_arguments', {
                      'sid': treeInfo.server._id,
                      'did': treeInfo.database._id,
                      'scid': treeInfo.schema._id,
                      'func_id': treeInfo["function"]._id
                    });
                  } else if (d._type == 'procedure') {
                    _url = url_for('debugger.set_arguments', {
                      'sid': treeInfo.server._id,
                      'did': treeInfo.database._id,
                      'scid': treeInfo.schema._id,
                      'func_id': treeInfo.procedure._id
                    });
                  } else if (d._type == 'edbfunc') {
                    // Get the existing function parameters available from sqlite database
                    _url = url_for('debugger.set_arguments', {
                      'sid': treeInfo.server._id,
                      'did': treeInfo.database._id,
                      'scid': treeInfo.schema._id,
                      'func_id': treeInfo.edbfunc._id
                    });
                  } else if (d._type == 'edbproc') {
                    // Get the existing function parameters available from sqlite database
                    _url = url_for('debugger.set_arguments', {
                      'sid': treeInfo.server._id,
                      'did': treeInfo.database._id,
                      'scid': treeInfo.schema._id,
                      'func_id': treeInfo.edbproc._id
                    });
                  }

                  $.ajax({
                    url: _url,
                    method: 'POST',
                    data: {
                      'data': JSON.stringify(sqlite_func_args_list)
                    }
                  }).done(function () {}).fail(function () {
                    _Notifier["default"].alert(gettext('Debugger Error'), gettext('Unable to set the arguments on the server'));
                  });
                }).fail(function (er) {
                  _Notifier["default"].alert(gettext('Debugger Target Initialization Error'), er.responseJSON.errormsg);
                });
              } else {
                // If the debugging is started again then we should only set the
                // arguments and start the listener again
                baseUrl = url_for('debugger.start_listener', {
                  'trans_id': self.setting('debug_info').trans_id
                });
                $.ajax({
                  url: baseUrl,
                  method: 'POST',
                  data: {
                    'data': JSON.stringify(args_value_list)
                  }
                }).done(function () {}).fail(function (er) {
                  _Notifier["default"].alert(gettext('Debugger Listener Startup Error'), er.responseJSON.errormsg);
                }); // Set the new input arguments given by the user during debugging

                var _Url = url_for('debugger.set_arguments', {
                  'sid': self.setting('debug_info').server_id,
                  'did': self.setting('debug_info').database_id,
                  'scid': self.setting('debug_info').schema_id,
                  'func_id': self.setting('debug_info').function_id
                });

                $.ajax({
                  url: _Url,
                  method: 'POST',
                  data: {
                    'data': JSON.stringify(sqlite_func_args_list)
                  }
                }).done(function () {}).fail(function () {
                  _Notifier["default"].alert(gettext('Debugger Error'), gettext('Unable to set the arguments on the server'));
                });
              }

              return true;
            }

            if (e.button.text === gettext('Cancel')) {
              /* Clear the trans id */
              $.ajax({
                method: 'DELETE',
                url: url_for('debugger.close', {
                  'trans_id': this.setting('trans_id')
                })
              });
              return false;
            }

            if (e.button.text === gettext('Clear All')) {
              var _self = this;

              var base_url = null;

              if (_self.setting('restart_debug') == 0) {
                var selected_item = pgBrowser.tree.selected();
                var item_data = pgBrowser.tree.itemData(selected_item);
                if (!item_data) return;
                var tree_info = pgBrowser.tree.getTreeNodeHierarchy(selected_item);
                base_url = url_for('debugger.clear_arguments', {
                  'sid': tree_info.server._id,
                  'did': tree_info.database._id,
                  'scid': tree_info.schema._id,
                  'func_id': item_data._id
                });
              } else {
                base_url = url_for('debugger.clear_arguments', {
                  'sid': _self.setting('debug_info').server_id,
                  'did': _self.setting('debug_info').database_id,
                  'scid': _self.setting('debug_info').schema_id,
                  'func_id': _self.setting('debug_info').function_id
                });
              }

              $.ajax({
                url: base_url,
                method: 'POST',
                data: {
                  'data': JSON.stringify(args_value_list)
                }
              }).done(function () {
                /* Disable debug button */
                _self.__internal.buttons[2].element.disabled = true;

                _self.main(_self.setting('title'), _self.setting('debug_info'), _self.setting('restart_debug'), _self.setting('is_edb_proc'), _self.setting('trans_id'));

                _self.prepare();
              }).fail(function (er) {
                _Notifier["default"].alert(gettext('Clear failed'), er.responseJSON.errormsg);
              });
              e.cancel = true;
              return true;
            }
          },
          build: function build() {
            Alertify.pgDialogBuild.apply(this);
          },
          prepare: function prepare() {
            // Add our class to alertify
            $(this.elements.body.childNodes[0]).addClass('alertify_tools_dialog_properties obj_properties');
            /*
             If we already have data available in sqlite database then we should
             enable the debug button otherwise disable the debug button.
            */

            if (this.func_args_data.length == 0) {
              this.__internal.buttons[2].element.disabled = true;
            } else {
              this.__internal.buttons[2].element.disabled = false;
            }
            /*
             Listen to the grid change event so that if any value changed by user then we can enable/disable the
             debug button.
            */


            this.grid.listenTo(this.debuggerInputArgsColl, 'backgrid:edited', function (obj) {
              return function () {
                var enable_btn = false;

                for (var i = 0; i < this.collection.length; i++) {
                  if (this.collection.models[i].get('is_null')) {
                    obj.__internal.buttons[2].element.disabled = false;
                    enable_btn = true;
                    continue;
                  } // TODO: Need to check the "Expression" column value to
                  // enable/disable the "Debug" button


                  if (this.collection.models[i].get('value') == null || this.collection.models[i].get('value') == undefined) {
                    enable_btn = true;

                    if (this.collection.models[i].get('use_default')) {
                      obj.__internal.buttons[2].element.disabled = false;
                    } else {
                      obj.__internal.buttons[2].element.disabled = true;
                      break;
                    }
                  }
                }

                if (!enable_btn) obj.__internal.buttons[2].element.disabled = false;
              };
            }(this));
            this.grid.listenTo(this.debuggerInputArgsColl, 'backgrid:error', function (obj) {
              return function () {
                obj.__internal.buttons[2].element.disabled = true;
              };
            }(this));
          }
        };
      });
    }

    Alertify.debuggerInputArgsDialog(gettext('Debugger'), debugInfo, restartDebug, isEdbProc, transId).resizeTo(pgBrowser.stdW.md, pgBrowser.stdH.md);
  };

  return res;
}).apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__),
		__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));

/***/ }),

/***/ 6715:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {



__webpack_require__(23123);

__webpack_require__(74916);

__webpack_require__(92222);

__webpack_require__(40561);

var _datagrid_panel_title = __webpack_require__(9807);

var _show_query_tool = __webpack_require__(7167);

//////////////////////////////////////////////////////////////////////////
//
// pgAdmin 4 - PostgreSQL Tools
//
// Copyright (C) 2013 - 2022, The pgAdmin Development Team
// This software is released under the PostgreSQL Licence
//
//////////////////////////////////////////////////////////////////////////
function setFocusToDebuggerEditor(editor, command) {
  var TAB = 9;
  if (!command) return;
  var key = command.which || command.keyCode; // Keys other than Tab key

  if (key !== TAB) {
    editor.focus();
  }
}

function getFunctionId(treeInfoObject) {
  var objectId;

  if (treeInfoObject) {
    if (treeInfoObject["function"] && treeInfoObject["function"]._id) {
      objectId = treeInfoObject["function"]._id;
    } else if (treeInfoObject.edbfunc && treeInfoObject.edbfunc._id) {
      objectId = treeInfoObject.edbfunc._id;
    }
  }

  return objectId;
}

function getProcedureId(treeInfoObject) {
  var objectId;

  if (treeInfoObject) {
    if (treeInfoObject.procedure && treeInfoObject.procedure._id) {
      objectId = treeInfoObject.procedure._id;
    } else if (treeInfoObject.edbproc && treeInfoObject.edbproc._id) {
      objectId = treeInfoObject.edbproc._id;
    }
  }

  return objectId;
}

function setDebuggerTitle(panel, preferences, function_name, schema_name, database_name) {
  var custom_title = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : null;
  var pgBrowser = arguments.length > 6 && arguments[6] !== undefined ? arguments[6] : null;
  var debugger_title_placeholder = '';

  if (custom_title) {
    debugger_title_placeholder = custom_title;
  } else {
    debugger_title_placeholder = preferences['debugger_tab_title_placeholder'];
  }

  var function_data = function_name.split('(');
  function_name = get_function_name(function_name);
  var args_list = function_data[function_data.length - 1].split(')');
  var args = '';

  if (args_list.length > 0) {
    args = args.concat(args_list[0]);
  }

  var title_data = {
    'function_name': function_name,
    'args': args,
    'schema': schema_name,
    'database': database_name,
    'type': 'debugger'
  };
  var title = (0, _datagrid_panel_title.generateTitle)(debugger_title_placeholder, title_data);
  (0, _show_query_tool._set_dynamic_tab)(pgBrowser, preferences['dynamic_tabs']);
  panel.title('<span>' + title + '</span>');
}

function get_function_name(function_name) {
  var function_data = function_name.split('(');
  function_data.splice(-1, 1);
  var index = null;
  var func_name = '';

  for (index = 0; index < function_data.length; index++) {
    func_name = func_name.concat(function_data[index]);

    if (index != function_data.length - 1) {
      func_name = func_name.concat('(');
    }
  }

  return func_name;
}

module.exports = {
  setFocusToDebuggerEditor: setFocusToDebuggerEditor,
  getFunctionId: getFunctionId,
  getProcedureId: getProcedureId,
  setDebuggerTitle: setDebuggerTitle
};

/***/ }),

/***/ 22074:
/***/ ((module, exports, __webpack_require__) => {

var __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;

__webpack_require__(32564);

__webpack_require__(69826);

__webpack_require__(15306);

__webpack_require__(74916);

__webpack_require__(69600);

__webpack_require__(68309);

__webpack_require__(24812);

__webpack_require__(26699);

__webpack_require__(32023);

var _Notifier = _interopRequireDefault(__webpack_require__(55958));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/////////////////////////////////////////////////////////////
//
// pgAdmin 4 - PostgreSQL Tools
//
// Copyright (C) 2013 - 2022, The pgAdmin Development Team
// This software is released under the PostgreSQL Licence
//
//////////////////////////////////////////////////////////////
!(__WEBPACK_AMD_DEFINE_ARRAY__ = [__webpack_require__(91669), __webpack_require__(28008), __webpack_require__(19755), __webpack_require__(81311), __webpack_require__(55455), __webpack_require__(55112), __webpack_require__(33883), __webpack_require__(72316), __webpack_require__(71158), __webpack_require__(12030), __webpack_require__(20811), __webpack_require__(92323), __webpack_require__(72945), __webpack_require__(6715), __webpack_require__(1950), __webpack_require__(35816)], __WEBPACK_AMD_DEFINE_RESULT__ = (function (gettext, url_for, $, _, Alertify, pgAdmin, pgBrowser, Backbone, Backgrid, Backform, codemirror, debug_function_again, keyboardShortcuts, debuggerUtils, pgWindow) {
  var CodeMirror = codemirror["default"],
      wcDocker = window.wcDocker;

  if (pgAdmin.Browser.tree != null) {
    pgAdmin = pgAdmin || window.pgAdmin || {};
  }

  var pgTools = pgAdmin.Tools = pgAdmin.Tools || {};
  if (pgTools.DirectDebug) return pgTools.DirectDebug;
  var controller = new function () {}();

  _.extend(controller, Backbone.Events, {
    enable: function enable(btn, _enable) {
      // trigger the event and change the button view to enable/disable the buttons for debugging
      this.trigger('pgDebugger:button:state:' + btn, _enable);
    },
    enable_toolbar_buttons: function enable_toolbar_buttons() {
      var self = this;
      self.enable('stop', true);
      self.enable('step_over', true);
      self.enable('step_into', true);
      self.enable('toggle_breakpoint', true);
      self.enable('clear_all_breakpoints', true);
      self.enable('continue', true);
    },
    disable_toolbar_buttons: function disable_toolbar_buttons() {
      var self = this;
      self.enable('stop', false);
      self.enable('step_over', false);
      self.enable('step_into', false);
      self.enable('toggle_breakpoint', false);
      self.enable('clear_all_breakpoints', false);
      self.enable('continue', false);
    },

    /*
      Function to set the breakpoint and send the line no. which is set to server
      trans_id :- Unique Transaction ID, line_no - line no. to set the breakpoint,
      set_type = 0 - clear , 1 - set
    */
    set_breakpoint: function set_breakpoint(trans_id, line_no, set_type) {
      // Make ajax call to set/clear the break point by user
      var baseUrl = url_for('debugger.set_breakpoint', {
        'trans_id': trans_id,
        'line_no': line_no,
        'set_type': set_type
      });
      $.ajax({
        url: baseUrl,
        method: 'GET'
      }).done(function (res) {
        if (res.data.status) {// Breakpoint has been set by the user
        }
      }).fail(function () {
        _Notifier["default"].alert(gettext('Debugger Error'), gettext('Error while setting debugging breakpoint.'));
      });
    },
    // Function to get the latest breakpoint information and update the
    // gutters of codemirror
    UpdateBreakpoint: function UpdateBreakpoint(trans_id) {
      var self = this;
      var br_list = self.GetBreakpointInformation(trans_id); // If there is no break point to clear then we should return from here.

      if (br_list.length == 1 && br_list[0].linenumber == -1) return;
      var breakpoint_list = new Array();

      for (var i = 0; i < br_list.length; i++) {
        if (br_list[i].linenumber != -1) {
          breakpoint_list.push(br_list[i].linenumber);
        }
      }

      for (i = 0; i < breakpoint_list.length; i++) {
        var info = pgTools.DirectDebug.editor.lineInfo(breakpoint_list[i] - 1);

        if (info.gutterMarkers != undefined) {
          pgTools.DirectDebug.editor.setGutterMarker(breakpoint_list[i] - 1, 'breakpoints', null);
        } else {
          pgTools.DirectDebug.editor.setGutterMarker(breakpoint_list[i] - 1, 'breakpoints', function () {
            var marker = document.createElement('div');
            marker.style.color = '#822';
            marker.innerHTML = '●';
            return marker;
          }());
        }
      }
    },
    // Function to get the breakpoint information from the server
    GetBreakpointInformation: function GetBreakpointInformation(trans_id) {
      var result = ''; // Make ajax call to listen the database message

      var baseUrl = url_for('debugger.execute_query', {
        'trans_id': trans_id,
        'query_type': 'get_breakpoints'
      });
      $.ajax({
        url: baseUrl,
        method: 'GET',
        async: false
      }).done(function (res) {
        if (res.data.status === 'Success') {
          result = res.data.result;
        } else if (res.data.status === 'NotConnected') {
          _Notifier["default"].alert(gettext('Debugger Error'), gettext('Error while fetching breakpoint information.'));
        }
      }).fail(function () {
        _Notifier["default"].alert(gettext('Debugger Error'), gettext('Error while fetching breakpoint information.'));
      });
      return result;
    },
    setActiveLine: function setActiveLine(lineNo) {
      var self = this;
      var editor = pgTools.DirectDebug.editor;
      /* If lineNo sent, remove active line */

      if (lineNo && self.active_line_no) {
        editor.removeLineClass(self.active_line_no, 'wrap', 'CodeMirror-activeline-background');
      }
      /* If lineNo not sent, set it to active line */


      if (!lineNo && self.active_line_no) {
        lineNo = self.active_line_no;
      }
      /* Set new active line only if positive */


      if (lineNo > 0) {
        self.active_line_no = lineNo;
        editor.addLineClass(self.active_line_no, 'wrap', 'CodeMirror-activeline-background');
        /* centerOnLine is codemirror extension in bundle/codemirror.js */

        editor.centerOnLine(self.active_line_no);
      }
    },
    // Function to start the executer and execute the user requested option for debugging
    start_execution: function start_execution(trans_id, port_num) {
      var self = this; // Make ajax call to listen the database message

      var baseUrl = url_for('debugger.start_execution', {
        'trans_id': trans_id,
        'port_num': port_num
      });
      $.ajax({
        url: baseUrl,
        method: 'GET'
      }).done(function (res) {
        if (res.data.status === 'Success') {
          // If status is Success then find the port number to attach the executer.
          self.execute_query(trans_id);
        } else if (res.data.status === 'NotConnected') {
          _Notifier["default"].alert(gettext('Debugger Error'), gettext('Error while starting debugging session.'));
        }
      }).fail(function () {
        _Notifier["default"].alert(gettext('Debugger Error'), gettext('Error while starting debugging session.'));
      });
    },
    // Execute the query and get the first functions debug information from the server
    execute_query: function execute_query(trans_id) {
      var self = this; // Make ajax call to listen the database message

      var baseUrl = url_for('debugger.execute_query', {
        'trans_id': trans_id,
        'query_type': 'wait_for_breakpoint'
      });
      $.ajax({
        url: baseUrl,
        method: 'GET'
      }).done(function (res) {
        if (res.data.status === 'Success') {
          // set the return code to the code editor text area
          if (res.data.result[0].src != null && res.data.result[0].linenumber != null) {
            pgTools.DirectDebug.editor.setValue(res.data.result[0].src);
            self.setActiveLine(res.data.result[0].linenumber - 2);
          } // Call function to create and update local variables ....


          self.GetStackInformation(trans_id);

          if (pgTools.DirectDebug.debug_type) {
            self.poll_end_execution_result(trans_id);
          }
        } else if (res.data.status === 'NotConnected') {
          _Notifier["default"].alert(gettext('Debugger Error'), gettext('Error while executing requested debugging information.'));
        }
      }).fail(function () {
        _Notifier["default"].alert(gettext('Debugger Error'), gettext('Error while executing requested debugging information.'));
      });
    },
    // Get the local variable information of the functions and update the grid
    GetLocalVariables: function GetLocalVariables(trans_id) {
      var self = this; // Make ajax call to listen the database message

      var baseUrl = url_for('debugger.execute_query', {
        'trans_id': trans_id,
        'query_type': 'get_variables'
      });
      $.ajax({
        url: baseUrl,
        method: 'GET'
      }).done(function (res) {
        if (res.data.status === 'Success') {
          // Call function to create and update local variables
          self.AddLocalVariables(res.data.result);
          self.AddParameters(res.data.result); // If debug function is restarted then again start listener to
          // read the updated messages.

          if (pgTools.DirectDebug.debug_restarted) {
            if (pgTools.DirectDebug.debug_type) {
              self.poll_end_execution_result(trans_id);
            }

            pgTools.DirectDebug.debug_restarted = false;
          }
        } else if (res.data.status === 'NotConnected') {
          _Notifier["default"].alert(gettext('Debugger Error'), gettext('Error while fetching variable information.'));
        }
      }).fail(function () {
        _Notifier["default"].alert(gettext('Debugger Error'), gettext('Error while fetching variable information.'));
      });
    },
    // Get the stack information of the functions and update the grid
    GetStackInformation: function GetStackInformation(trans_id) {
      var self = this; // Make ajax call to listen the database message

      var baseUrl = url_for('debugger.execute_query', {
        'trans_id': trans_id,
        'query_type': 'get_stack_info'
      });
      $.ajax({
        url: baseUrl,
        method: 'GET'
      }).done(function (res) {
        if (res.data.status === 'Success') {
          // Call function to create and update stack information
          self.AddStackInformation(res.data.result);
          self.GetLocalVariables(pgTools.DirectDebug.trans_id);
        } else if (res.data.status === 'NotConnected') {
          _Notifier["default"].alert(gettext('Debugger Error'), gettext('Error while fetching stack information.'));
        }
      }).fail(function () {
        _Notifier["default"].alert(gettext('Debugger Error'), gettext('Error while fetching stack information.'));
      });
    },

    /*
      poll the actual result after user has executed the "continue", "step-into",
      "step-over" actions and get the other updated information from the server.
    */
    poll_result: function poll_result(trans_id) {
      var self = this; // Do we need to poll?

      if (!pgTools.DirectDebug.is_polling_required) {
        return;
      } // Make ajax call to listen the database message


      var baseUrl = url_for('debugger.poll_result', {
        'trans_id': trans_id
      }),
          poll_timeout;
      /*
        During the execution we should poll the result in minimum seconds but
        once the execution is completed and wait for the another debugging
        session then we should decrease the polling frequency.
      */

      if (pgTools.DirectDebug.polling_timeout_idle) {
        // Poll the result after 1 second
        poll_timeout = 1000;
      } else {
        // Poll the result after 200 ms
        poll_timeout = 200;
      }

      setTimeout(function () {
        $.ajax({
          url: baseUrl,
          method: 'GET',
          beforeSend: function beforeSend(xhr) {
            xhr.setRequestHeader(pgAdmin.csrf_token_header, pgAdmin.csrf_token); // set cursor to progress before every poll.

            $('.debugger-container').addClass('show_progress');
          }
        }).done(function (res) {
          // remove progress cursor
          $('.debugger-container').removeClass('show_progress');

          if (res.data.status === 'Success') {
            // If no result then poll again to wait for results.
            if (res.data.result == null || res.data.result.length == 0) {
              self.poll_result(trans_id);
            } else {
              if (!pgTools.DirectDebug.debug_type && !pgTools.DirectDebug.first_time_indirect_debug) {
                pgTools.DirectDebug.docker.finishLoading(50);
                self.setActiveLine(-1);
                self.clear_all_breakpoint(trans_id);
                self.execute_query(trans_id);
                pgTools.DirectDebug.first_time_indirect_debug = true;
                pgTools.DirectDebug.polling_timeout_idle = false;
              } else {
                pgTools.DirectDebug.polling_timeout_idle = false;
                pgTools.DirectDebug.docker.finishLoading(50); // If the source is really changed then only update the breakpoint information

                if (res.data.result[0].src != pgTools.DirectDebug.editor.getValue()) {
                  pgTools.DirectDebug.editor.setValue(res.data.result[0].src);
                  self.UpdateBreakpoint(trans_id);
                }

                self.setActiveLine(res.data.result[0].linenumber - 2); // Update the stack, local variables and parameters information

                self.GetStackInformation(trans_id);
              } // Enable all the buttons as we got the results
              // TODO: Fix this properly so a timeout isn't required.


              setTimeout(function () {
                self.enable_toolbar_buttons();
              }, 500);
            }
          } else if (res.data.status === 'Busy') {
            pgTools.DirectDebug.polling_timeout_idle = true; // If status is Busy then poll the result by recursive call to the poll function

            if (!pgTools.DirectDebug.debug_type) {
              pgTools.DirectDebug.docker.startLoading(gettext('Waiting for another session to invoke the target...')); // As we are waiting for another session to invoke the target,disable all the buttons

              self.disable_toolbar_buttons();
              pgTools.DirectDebug.first_time_indirect_debug = false;
              self.poll_result(trans_id);
            } else {
              self.poll_result(trans_id);
            }
          } else if (res.data.status === 'NotConnected') {
            _Notifier["default"].alert(gettext('Debugger Error'), gettext('Error while polling result.'));
          }
        }).fail(function () {
          _Notifier["default"].alert(gettext('Debugger Error'), gettext('Error while polling result.'));
        });
      }, poll_timeout);
    },
    // This function will update messages tab
    update_messages: function update_messages(msg) {
      // To prevent xss
      msg = _.escape(msg);
      var old_msgs = '',
          new_msgs = '';
      old_msgs = pgTools.DirectDebug.messages_panel.$container.find('.messages').html();

      if (old_msgs) {
        new_msgs = (old_msgs + '\n' + msg).replace(/(?:\r\n|\r|\n)/g, '<br />') // Newlines with <br>
        .replace(/(<br\ ?\/?>)+/g, '<br />'); // multiple <br> with single <br>
      } else {
        new_msgs = msg;
      }

      pgTools.DirectDebug.messages_panel.$container.find('.messages').html(new_msgs);
    },

    /*
      For the direct debugging, we need to check weather the functions execution
      is completed or not. After completion of the debugging, we will stop polling
      the result  until new execution starts.
    */
    poll_end_execution_result: function poll_end_execution_result(trans_id) {
      var self = this; // Do we need to poll?

      if (!pgTools.DirectDebug.is_polling_required) {
        return;
      } // Make ajax call to listen the database message


      var baseUrl = url_for('debugger.poll_end_execution_result', {
        'trans_id': trans_id
      }),
          poll_end_timeout;
      /*
       * During the execution we should poll the result in minimum seconds
       * but once the execution is completed and wait for the another
       * debugging session then we should decrease the polling frequency.
       */

      if (pgTools.DirectDebug.polling_timeout_idle) {
        // Poll the result to check that execution is completed or not
        // after 1200 ms
        poll_end_timeout = 1200;
      } else {
        // Poll the result to check that execution is completed or not
        // after 350 ms
        poll_end_timeout = 250;
      }

      setTimeout(function () {
        $.ajax({
          url: baseUrl,
          method: 'GET'
        }).done(function (res) {
          if (res.data.status === 'Success') {
            if (res.data.result == undefined) {
              /*
               "result" is undefined only in case of EDB procedure.
               As Once the EDB procedure execution is completed then we are
               not getting any result so we need ignore the result.
              */
              self.setActiveLine(-1);
              pgTools.DirectDebug.direct_execution_completed = true;
              pgTools.DirectDebug.polling_timeout_idle = true; //Set the alertify message to inform the user that execution is completed.

              _Notifier["default"].success(res.info, 3000); // Update the message tab of the debugger


              if (res.data.status_message) {
                self.update_messages(res.data.status_message);
              } // remove progress cursor


              $('.debugger-container').removeClass('show_progress'); // Execution completed so disable the buttons other than
              // "Continue/Start" button because user can still
              // start the same execution again.

              setTimeout(function () {
                self.enable('stop', false);
                self.enable('step_over', false);
                self.enable('step_into', false);
                self.enable('toggle_breakpoint', false);
                self.enable('clear_all_breakpoints', false);
                self.enable('continue', true);
              }, 500); // Stop further polling

              pgTools.DirectDebug.is_polling_required = false;
            } else {
              // Call function to create and update local variables ....
              if (res.data.result != null) {
                self.setActiveLine(-1);
                self.AddResults(res.data.col_info, res.data.result);
                pgTools.DirectDebug.results_panel.focus();
                pgTools.DirectDebug.direct_execution_completed = true;
                pgTools.DirectDebug.polling_timeout_idle = true; //Set the alertify message to inform the user that execution is completed.

                _Notifier["default"].success(res.info, 3000); // Update the message tab of the debugger


                if (res.data.status_message) {
                  self.update_messages(res.data.status_message);
                } // remove progress cursor


                $('.debugger-container').removeClass('show_progress'); // Execution completed so disable the buttons other than
                // "Continue/Start" button because user can still
                // start the same execution again.

                setTimeout(function () {
                  self.enable('stop', false);
                  self.enable('step_over', false);
                  self.enable('step_into', false);
                  self.enable('toggle_breakpoint', false);
                  self.enable('clear_all_breakpoints', false);
                  self.enable('continue', true);
                }, 500); // Stop further pooling

                pgTools.DirectDebug.is_polling_required = false;
              }
            }
          } else if (res.data.status === 'Busy') {
            // If status is Busy then poll the result by recursive call to
            // the poll function
            self.poll_end_execution_result(trans_id); // Update the message tab of the debugger

            if (res.data.status_message) {
              self.update_messages(res.data.status_message);
            }
          } else if (res.data.status === 'NotConnected') {
            _Notifier["default"].alert(gettext('Debugger poll end execution error'), res.data.result);
          } else if (res.data.status === 'ERROR') {
            pgTools.DirectDebug.direct_execution_completed = true;
            self.setActiveLine(-1); //Set the Alertify message to inform the user that execution is
            // completed with error.

            if (!pgTools.DirectDebug.is_user_aborted_debugging) {
              _Notifier["default"].error(res.info, 3000);
            } // Update the message tab of the debugger


            if (res.data.status_message) {
              self.update_messages(res.data.status_message);
            }

            pgTools.DirectDebug.messages_panel.focus(); // remove progress cursor

            $('.debugger-container').removeClass('show_progress'); // Execution completed so disable the buttons other than
            // "Continue/Start" button because user can still start the
            // same execution again.

            self.enable('stop', false);
            self.enable('step_over', false);
            self.enable('step_into', false);
            self.enable('toggle_breakpoint', false);
            self.enable('clear_all_breakpoints', false); // If debugging is stopped by user then do not enable
            // continue/restart button

            if (!pgTools.DirectDebug.is_user_aborted_debugging) {
              self.enable('continue', true);
              pgTools.DirectDebug.is_user_aborted_debugging = false;
            } // Stop further pooling


            pgTools.DirectDebug.is_polling_required = false;
          }
        }).fail(function () {
          _Notifier["default"].alert(gettext('Debugger Error'), gettext('Error while polling result.'));
        });
      }, poll_end_timeout);
    },
    Restart: function Restart(trans_id) {
      var self = this,
          baseUrl = url_for('debugger.restart', {
        'trans_id': trans_id
      });
      self.disable_toolbar_buttons(); // Clear msg tab

      pgTools.DirectDebug.messages_panel.$container.find('.messages').html('');
      $.ajax({
        url: baseUrl
      }).done(function (res) {
        // Restart the same function debugging with previous arguments
        var restart_dbg = res.data.restart_debug ? 1 : 0; // Start pooling again

        pgTools.DirectDebug.polling_timeout_idle = false;
        pgTools.DirectDebug.is_polling_required = true;
        self.poll_result(trans_id);

        if (restart_dbg) {
          pgTools.DirectDebug.debug_restarted = true;
        }
        /*
        Need to check if restart debugging really require to open the input
        dialog? If yes then we will get the previous arguments from database
        and populate the input dialog, If no then we should directly start the
        listener.
        */


        if (res.data.result.require_input) {
          debug_function_again(res.data.result, restart_dbg);
        } else {
          // Debugging of void function is started again so we need to start
          // the listener again
          var base_url = url_for('debugger.start_listener', {
            'trans_id': trans_id
          });
          $.ajax({
            url: base_url,
            method: 'GET'
          }).done(function () {
            if (pgTools.DirectDebug.debug_type) {
              self.poll_end_execution_result(trans_id);
            }
          }).fail(function () {
            _Notifier["default"].alert(gettext('Debugger Error'), gettext('Error while polling result.'));
          });
        }
      }).fail(function (xhr) {
        try {
          var err = JSON.parse(xhr.responseText);

          if (err.success == 0) {
            _Notifier["default"].alert(gettext('Debugger Error'), err.errormsg);
          }
        } catch (e) {
          console.warn(e.stack || e);
        }
      });
    },
    // Continue the execution until the next breakpoint
    Continue: function Continue(trans_id) {
      var self = this;
      self.disable_toolbar_buttons(); //Check first if previous execution was completed or not

      if (pgTools.DirectDebug.direct_execution_completed && pgTools.DirectDebug.direct_execution_completed == pgTools.DirectDebug.polling_timeout_idle) {
        self.Restart(trans_id);
      } else {
        // Make ajax call to listen the database message
        var baseUrl = url_for('debugger.execute_query', {
          'trans_id': trans_id,
          'query_type': 'continue'
        });
        $.ajax({
          url: baseUrl,
          method: 'GET'
        }).done(function (res) {
          if (res.data.status) {
            self.poll_result(trans_id);
          } else {
            _Notifier["default"].alert(gettext('Debugger Error'), gettext('Error while executing continue in debugging session.'));
          }
        }).fail(function () {
          _Notifier["default"].alert(gettext('Debugger Error'), gettext('Error while executing continue in debugging session.'));
        });
      }
    },
    Step_over: function Step_over(trans_id) {
      var self = this;
      self.disable_toolbar_buttons(); // Make ajax call to listen the database message

      var baseUrl = url_for('debugger.execute_query', {
        'trans_id': trans_id,
        'query_type': 'step_over'
      });
      $.ajax({
        url: baseUrl,
        method: 'GET'
      }).done(function (res) {
        if (res.data.status) {
          self.poll_result(trans_id);
        } else {
          _Notifier["default"].alert(gettext('Debugger Error'), gettext('Error while executing step over in debugging session.'));
        }
      }).fail(function () {
        _Notifier["default"].alert(gettext('Debugger Error'), gettext('Error while executing step over in debugging session.'));
      });
    },
    Step_into: function Step_into(trans_id) {
      var self = this;
      self.disable_toolbar_buttons(); // Make ajax call to listen the database message

      var baseUrl = url_for('debugger.execute_query', {
        'trans_id': trans_id,
        'query_type': 'step_into'
      });
      $.ajax({
        url: baseUrl,
        method: 'GET'
      }).done(function (res) {
        if (res.data.status) {
          self.poll_result(trans_id);
        } else {
          _Notifier["default"].alert(gettext('Debugger Error'), gettext('Error while executing step into in debugging session.'));
        }
      }).fail(function () {
        _Notifier["default"].alert(gettext('Debugger Error'), gettext('Error while executing step into in debugging session.'));
      });
    },
    Stop: function Stop(trans_id) {
      var self = this;
      self.disable_toolbar_buttons(); // Make ajax call to listen the database message

      var baseUrl = url_for('debugger.execute_query', {
        'trans_id': trans_id,
        'query_type': 'abort_target'
      });
      $.ajax({
        url: baseUrl,
        method: 'GET'
      }).done(function (res) {
        if (res.data.status) {
          // Call function to create and update local variables ....
          self.setActiveLine(-1);
          pgTools.DirectDebug.direct_execution_completed = true;
          pgTools.DirectDebug.is_user_aborted_debugging = true; // Stop further pooling

          pgTools.DirectDebug.is_polling_required = false; // Restarting debugging in the same transaction do not work
          // We will give same behaviour as pgAdmin3 and disable all buttons

          self.enable('continue', false); // Set the Alertify message to inform the user that execution
          // is completed.

          _Notifier["default"].success(res.info, 3000);
        } else if (res.data.status === 'NotConnected') {
          _Notifier["default"].alert(gettext('Debugger Error'), gettext('Error while executing stop in debugging session.'));
        }
      }).fail(function () {
        _Notifier["default"].alert(gettext('Debugger Error'), gettext('Error while executing stop in debugging session.'));
      });
    },
    toggle_breakpoint: function toggle_breakpoint(trans_id) {
      var self = this;
      self.disable_toolbar_buttons();
      var info = pgTools.DirectDebug.editor.lineInfo(self.active_line_no);
      var baseUrl = ''; // If gutterMarker is undefined that means there is no marker defined previously
      // So we need to set the breakpoint command here...

      if (info.gutterMarkers == undefined) {
        baseUrl = url_for('debugger.set_breakpoint', {
          'trans_id': trans_id,
          'line_no': self.active_line_no + 1,
          'set_type': '1'
        });
      } else {
        baseUrl = url_for('debugger.set_breakpoint', {
          'trans_id': trans_id,
          'line_no': self.active_line_no + 1,
          'set_type': '0'
        });
      }

      $.ajax({
        url: baseUrl,
        method: 'GET'
      }).done(function (res) {
        if (res.data.status) {
          // Call function to create and update local variables ....
          var info_local = pgTools.DirectDebug.editor.lineInfo(self.active_line_no);

          if (info_local.gutterMarkers != undefined) {
            pgTools.DirectDebug.editor.setGutterMarker(self.active_line_no, 'breakpoints', null);
          } else {
            pgTools.DirectDebug.editor.setGutterMarker(self.active_line_no, 'breakpoints', function () {
              var marker = document.createElement('div');
              marker.style.color = '#822';
              marker.innerHTML = '●';
              return marker;
            }());
          }

          self.enable_toolbar_buttons();
        } else if (res.data.status === 'NotConnected') {
          _Notifier["default"].alert(gettext('Debugger Error'), gettext('Error while toggling breakpoint.'));
        }
      }).fail(function () {
        _Notifier["default"].alert(gettext('Debugger Error'), gettext('Error while toggling breakpoint.'));
      });
    },
    clear_all_breakpoint: function clear_all_breakpoint(trans_id) {
      var self = this,
          br_list = self.GetBreakpointInformation(trans_id); // If there is no break point to clear then we should return from here.

      if (br_list.length == 1 && br_list[0].linenumber == -1) return;
      self.disable_toolbar_buttons();
      var breakpoint_list = new Array();

      for (var i = 0; i < br_list.length; i++) {
        if (br_list[i].linenumber != -1) {
          breakpoint_list.push(br_list[i].linenumber);
        }
      } // Make ajax call to listen the database message


      var baseUrl = url_for('debugger.clear_all_breakpoint', {
        'trans_id': trans_id
      });
      $.ajax({
        url: baseUrl,
        method: 'POST',
        data: {
          'breakpoint_list': breakpoint_list.join()
        }
      }).done(function (res) {
        if (res.data.status) {
          for (var j = 0; j < breakpoint_list.length; j++) {
            var info = pgTools.DirectDebug.editor.lineInfo(breakpoint_list[j] - 1);

            if (info) {
              if (info.gutterMarkers != undefined) {
                pgTools.DirectDebug.editor.setGutterMarker(breakpoint_list[j] - 1, 'breakpoints', null);
              }
            }
          }
        }

        self.enable_toolbar_buttons();
      }).fail(function () {
        _Notifier["default"].alert(gettext('Debugger Error'), gettext('Error while clearing all breakpoint.'));
      });
    },
    AddStackInformation: function AddStackInformation(result) {
      var self = this; // Remove the existing created grid and update the stack values

      if (self.stack_grid) {
        self.stack_grid.remove();
        self.stack_grid = null;
      }

      var DebuggerStackModel = Backbone.Model.extend({
        defaults: {
          frame_id: 0,
          name: undefined,
          value: undefined,
          line_no: undefined
        }
      }); // Collection which contains the model for function informations.

      var StackCollection = Backbone.Collection.extend({
        model: DebuggerStackModel
      });
      var stackGridCols = [{
        name: 'name',
        label: gettext('Name'),
        type: 'text',
        editable: false,
        cell: 'string'
      }, {
        name: 'value',
        label: gettext('Value'),
        type: 'text',
        editable: false,
        cell: 'string'
      }, {
        name: 'line_no',
        label: gettext('Line No.'),
        type: 'text',
        editable: false,
        cell: 'string'
      }];
      var my_obj = [];

      for (var i = 0; i < result.length; i++) {
        my_obj.push({
          'frame_id': i,
          'name': result[i].targetname,
          'value': result[i].args,
          'line_no': result[i].linenumber
        });
      }

      var stackColl = this.stackColl = new StackCollection(my_obj);
      this.stackColl.on('backgrid:row:selected', self.select_frame, self); // Initialize a new Grid instance

      var stack_grid = this.stack_grid = new Backgrid.Grid({
        emptyText: gettext('No data found'),
        columns: stackGridCols,
        row: Backgrid.Row.extend({
          events: {
            click: 'rowClick'
          },
          rowClick: function rowClick() {
            //Find which row is selected and depending on that send the frame id
            self.frame_id = this.model.get('frame_id');
            this.model.trigger('backgrid:row:selected', this);
            self.stack_grid.$el.find('td').css('background-color', this.disabledColor);
            this.$el.find('td').css('background-color', this.highlightColor);
          }
        }),
        collection: stackColl,
        className: 'backgrid table table-bordered table-noouter-border table-bottom-border'
      });
      stack_grid.render(); // Render the stack grid into stack panel

      pgTools.DirectDebug.stack_pane_panel.$container.find('.stack_pane').append(stack_grid.el);
    },
    AddResults: function AddResults(columns, result) {
      var self = this; // Remove the existing created grid and update the result values

      if (self.result_grid) {
        self.result_grid.remove();
        self.result_grid = null;
      }

      var DebuggerResultsModel = Backbone.Model.extend({
        defaults: {
          name: undefined
        }
      }); // Collection which contains the model for function informations.

      var ResultsCollection = Backbone.Collection.extend({
        model: DebuggerResultsModel
      });
      var resultGridCols = [];

      if (_.size(columns)) {
        _.each(columns, function (c) {
          var column = {
            type: 'text',
            editable: false,
            cell: 'string'
          };
          column['name'] = column['label'] = c.name;
          resultGridCols.push(column);
        });
      } // Initialize a new Grid instance


      var result_grid = this.result_grid = new Backgrid.Grid({
        emptyText: gettext('No data found'),
        columns: resultGridCols,
        collection: new ResultsCollection(result),
        className: 'backgrid table table-bordered table-noouter-border table-bottom-border'
      });
      result_grid.render(); // Render the result grid into result panel

      pgTools.DirectDebug.results_panel.$container.find('.debug_results').append(result_grid.el);
    },
    AddLocalVariables: function AddLocalVariables(result) {
      var self = this; // Remove the existing created grid and update the variables values

      if (self.variable_grid) {
        self.variable_grid.remove();
        self.variable_grid = null;
      }

      var DebuggerVariablesModel = Backbone.Model.extend({
        defaults: {
          name: undefined,
          type: undefined,
          value: undefined
        }
      }); // Collection which contains the model for function information.

      var VariablesCollection = Backbone.Collection.extend({
        model: DebuggerVariablesModel
      });
      VariablesCollection.prototype.on('change', self.deposit_parameter_value, self);
      var gridCols = [{
        name: 'name',
        label: gettext('Name'),
        type: 'text',
        editable: false,
        cell: 'string'
      }, {
        name: 'type',
        label: gettext('Type'),
        type: 'text',
        editable: false,
        cell: 'string'
      }, {
        name: 'value',
        label: gettext('Value'),
        type: 'text',
        cell: 'string'
      }];
      var my_obj = [];

      if (result.length != 0) {
        for (var i = 0; i < result.length; i++) {
          if (result[i].varclass == 'L') {
            my_obj.push({
              'name': result[i].name,
              'type': result[i].dtype,
              'value': result[i].value
            });
          }
        }
      } // Initialize a new Grid instance


      var variable_grid = this.variable_grid = new Backgrid.Grid({
        emptyText: gettext('No data found'),
        columns: gridCols,
        collection: new VariablesCollection(my_obj),
        className: 'backgrid table table-bordered table-noouter-border table-bottom-border'
      });
      variable_grid.collection.on('backgrid:edited', function (ch1, ch2, command) {
        debuggerUtils.setFocusToDebuggerEditor(pgTools.DirectDebug.editor, command);
      });
      variable_grid.render(); // Render the variables grid into local variables panel

      pgTools.DirectDebug.local_variables_panel.$container.find('.local_variables').append(variable_grid.el);
    },
    AddParameters: function AddParameters(result) {
      var self = this; // Remove the existing created grid and update the parameter values

      if (self.param_grid) {
        self.param_grid.remove();
        self.param_grid = null;
      }

      var DebuggerParametersModel = Backbone.Model.extend({
        defaults: {
          name: undefined,
          type: undefined,
          value: undefined
        }
      }); // Collection which contains the model for function informations.

      var ParametersCollection = self.ParametersCollection = Backbone.Collection.extend({
        model: DebuggerParametersModel
      });
      ParametersCollection.prototype.on('change', self.deposit_parameter_value, self);
      var paramGridCols = [{
        name: 'name',
        label: gettext('Name'),
        type: 'text',
        editable: false,
        cell: 'string'
      }, {
        name: 'type',
        label: gettext('Type'),
        type: 'text',
        editable: false,
        cell: 'string'
      }, {
        name: 'value',
        label: gettext('Value'),
        type: 'text',
        cell: 'string'
      }];
      var param_obj = [];

      if (result.length != 0) {
        for (var i = 0; i < result.length; i++) {
          if (result[i].varclass == 'A') {
            param_obj.push({
              'name': result[i].name,
              'type': result[i].dtype,
              'value': result[i].value
            });
          }
        }
      } // Initialize a new Grid instance


      var param_grid = this.param_grid = new Backgrid.Grid({
        emptyText: gettext('No data found'),
        columns: paramGridCols,
        collection: new ParametersCollection(param_obj),
        className: 'backgrid table table-bordered table-noouter-border table-bottom-border'
      });
      param_grid.collection.on('backgrid:edited', function (ch1, ch2, command) {
        debuggerUtils.setFocusToDebuggerEditor(pgTools.DirectDebug.editor, command);
      });
      param_grid.render(); // Render the parameters grid into parameter panel

      pgTools.DirectDebug.parameters_panel.$container.find('.parameters').append(param_grid.el);
    },
    deposit_parameter_value: function deposit_parameter_value(model) {
      var self = this; // variable name and value list that is changed by user

      var name_value_list = [];
      name_value_list.push({
        'name': model.get('name'),
        'type': model.get('type'),
        'value': model.get('value')
      }); // Make ajax call to listen the database message

      var baseUrl = url_for('debugger.deposit_value', {
        'trans_id': pgTools.DirectDebug.trans_id
      });
      $.ajax({
        url: baseUrl,
        method: 'POST',
        data: {
          'data': JSON.stringify(name_value_list)
        }
      }).done(function (res) {
        if (res.data.status) {
          // Get the updated variables value
          self.GetLocalVariables(pgTools.DirectDebug.trans_id); // Show the message to the user that deposit value is success or failure

          if (res.data.result) {
            _Notifier["default"].success(res.data.info, 3000);
          } else {
            _Notifier["default"].error(res.data.info, 3000);
          }
        }
      }).fail(function () {
        _Notifier["default"].alert(gettext('Debugger Error'), gettext('Error while depositing variable value.'));
      });
    },
    select_frame: function select_frame() {
      var self = this; // Make ajax call to listen the database message

      var baseUrl = url_for('debugger.select_frame', {
        'trans_id': pgTools.DirectDebug.trans_id,
        'frame_id': self.frame_id
      });
      $.ajax({
        url: baseUrl,
        method: 'GET'
      }).done(function (res) {
        if (res.data.status) {
          pgTools.DirectDebug.editor.setValue(res.data.result[0].src);
          self.UpdateBreakpoint(pgTools.DirectDebug.trans_id);
          self.setActiveLine(res.data.result[0].linenumber - 2); // Call function to create and update local variables ....

          self.GetLocalVariables(pgTools.DirectDebug.trans_id);
        }
      }).fail(function () {
        _Notifier["default"].alert(gettext('Debugger Error'), gettext('Error while selecting frame.'));
      });
    }
  });
  /*
    Debugger tool var view to create the button toolbar and listen to the button click event and inform the
    controller about the click and controller will take the action for the specified button click.
  */


  var DebuggerToolbarView = Backbone.View.extend({
    el: '.debugger_main_container',
    initialize: function initialize() {
      controller.on('pgDebugger:button:state:stop', this.enable_stop, this);
      controller.on('pgDebugger:button:state:step_over', this.enable_step_over, this);
      controller.on('pgDebugger:button:state:step_into', this.enable_step_into, this);
      controller.on('pgDebugger:button:state:continue', this.enable_continue, this);
      controller.on('pgDebugger:button:state:toggle_breakpoint', this.enable_toggle_breakpoint, this);
      controller.on('pgDebugger:button:state:clear_all_breakpoints', this.enable_clear_all_breakpoints, this);
    },
    events: {
      'click .btn-stop': 'on_stop',
      'click .btn-clear-breakpoint': 'on_clear_all_breakpoint',
      'click .btn-toggle-breakpoint': 'on_toggle_breakpoint',
      'click .btn-continue': 'on_continue',
      'click .btn-step-over': 'on_step_over',
      'click .btn-step-into': 'on_step_into',
      'keydown': 'keyAction'
    },
    enable_stop: function enable_stop(enable) {
      var $btn = this.$el.find('.btn-stop');

      if (enable) {
        $btn.prop('disabled', false);
        $btn.removeAttr('disabled');
      } else {
        $btn.prop('disabled', true);
        $btn.attr('disabled', 'disabled');
      }
    },
    enable_step_over: function enable_step_over(enable) {
      var $btn = this.$el.find('.btn-step-over');

      if (enable) {
        $btn.prop('disabled', false);
        $btn.removeAttr('disabled');
      } else {
        $btn.prop('disabled', true);
        $btn.attr('disabled', 'disabled');
      }
    },
    enable_step_into: function enable_step_into(enable) {
      var $btn = this.$el.find('.btn-step-into');

      if (enable) {
        $btn.prop('disabled', false);
        $btn.removeAttr('disabled');
      } else {
        $btn.prop('disabled', true);
        $btn.attr('disabled', 'disabled');
      }
    },
    enable_continue: function enable_continue(enable) {
      var $btn = this.$el.find('.btn-continue');

      if (enable) {
        $btn.prop('disabled', false);
        $btn.removeAttr('disabled');
      } else {
        $btn.prop('disabled', true);
        $btn.attr('disabled', 'disabled');
      }
    },
    enable_toggle_breakpoint: function enable_toggle_breakpoint(enable) {
      var $btn = this.$el.find('.btn-toggle-breakpoint');

      if (enable) {
        $btn.prop('disabled', false);
        $btn.removeAttr('disabled');
      } else {
        $btn.prop('disabled', true);
        $btn.attr('disabled', 'disabled');
      }
    },
    enable_clear_all_breakpoints: function enable_clear_all_breakpoints(enable) {
      var $btn = this.$el.find('.btn-clear-breakpoint');

      if (enable) {
        $btn.prop('disabled', false);
        $btn.removeAttr('disabled');
      } else {
        $btn.prop('disabled', true);
        $btn.attr('disabled', 'disabled');
      }
    },
    on_stop: function on_stop() {
      controller.Stop(pgTools.DirectDebug.trans_id);
    },
    on_clear_all_breakpoint: function on_clear_all_breakpoint() {
      controller.clear_all_breakpoint(pgTools.DirectDebug.trans_id);
    },
    on_toggle_breakpoint: function on_toggle_breakpoint() {
      controller.toggle_breakpoint(pgTools.DirectDebug.trans_id);
    },
    on_continue: function on_continue() {
      controller.Continue(pgTools.DirectDebug.trans_id);
    },
    on_step_over: function on_step_over() {
      controller.Step_over(pgTools.DirectDebug.trans_id);
    },
    on_step_into: function on_step_into() {
      controller.Step_into(pgTools.DirectDebug.trans_id);
    },
    keyAction: function keyAction(event) {
      var panel_type = '';
      panel_type = keyboardShortcuts.processEventDebugger(this.$el, event, this.preferences, pgTools.DirectDebug.docker);

      if (!_.isNull(panel_type) && !_.isUndefined(panel_type) && panel_type != '') {
        setTimeout(function () {
          pgBrowser.Events.trigger("pgadmin:debugger:".concat(panel_type, ":focus"));
        }, 100);
      }
    }
  });
  /*
    Function is responsible to create the new wcDocker instance for debugger and
    initialize the debugger panel inside the docker instance.
  */

  var DirectDebug = function DirectDebug() {};

  _.extend(DirectDebug.prototype, {
    /* We should get the transaction id from the server during initialization here */
    load: function load(trans_id, debug_type, function_name_with_arguments, layout) {
      // We do not want to initialize the module multiple times.
      var self = this;

      _.bindAll(pgTools.DirectDebug, 'messages');

      if (this.initialized) return;
      var baseUrl;
      this.initialized = true;
      this.trans_id = trans_id;
      this.debug_type = debug_type;
      this.first_time_indirect_debug = false;
      this.direct_execution_completed = false;
      this.polling_timeout_idle = false;
      this.debug_restarted = false;
      this.is_user_aborted_debugging = false;
      this.is_polling_required = true; // Flag to stop unwanted ajax calls

      this.function_name_with_arguments = function_name_with_arguments;
      this.layout = layout;
      var browser = pgWindow["default"].pgAdmin.Browser;
      this.preferences = browser.get_preferences_for_module('debugger');
      this.docker = new wcDocker('#container', {
        allowContextMenu: false,
        allowCollapse: false,
        loadingClass: 'pg-sp-icon',
        themePath: url_for('static', {
          'filename': 'css'
        }),
        theme: 'webcabin.overrides.css'
      });
      this.panels = []; // Below code will be executed for indirect debugging
      // indirect debugging - 0  and for direct debugging - 1

      if (trans_id != undefined && !debug_type) {
        // Make ajax call to execute the and start the target for execution
        baseUrl = url_for('debugger.start_listener', {
          'trans_id': trans_id
        });
        $.ajax({
          url: baseUrl,
          method: 'GET'
        }).done(function (res) {
          if (res.data.status) {
            self.intializePanels();
            controller.enable_toolbar_buttons();
            controller.poll_result(trans_id);
          }
        }).fail(function (xhr) {
          try {
            var err = JSON.parse(xhr.responseText);

            if (err.success == 0) {
              _Notifier["default"].alert(gettext('Debugger Error'), err.errormsg);
            }
          } catch (e) {
            _Notifier["default"].alert(gettext('Debugger Error'), gettext('Error while starting debugging listener.'));
          }
        });
      } else if (trans_id != undefined) {
        // Make ajax call to execute the and start the target for execution
        baseUrl = url_for('debugger.start_listener', {
          'trans_id': trans_id
        });
        $.ajax({
          url: baseUrl,
          method: 'GET'
        }).done(function (res) {
          if (res.data.status) {
            self.messages(trans_id);
          }
        }).fail(function (xhr) {
          try {
            var err = JSON.parse(xhr.responseText);

            if (err.success == 0) {
              _Notifier["default"].alert(gettext('Debugger Error'), err.errormsg);
            }
          } catch (e) {
            _Notifier["default"].alert(gettext('Debugger Error'), gettext('Error while starting debugging listener.'));
          }
        });
      } else {
        this.intializePanels();
      }
    },
    // Read the messages of the database server and get the port ID and attach
    // the executer to that port.
    messages: function messages(trans_id) {
      var self = this; // Make ajax call to listen the database message

      var baseUrl = url_for('debugger.messages', {
        'trans_id': trans_id
      });
      $.ajax({
        url: baseUrl,
        method: 'GET'
      }).done(function (res) {
        if (res.data.status === 'Success') {
          self.intializePanels();
          controller.enable_toolbar_buttons(); // If status is Success then find the port number to attach the executer.

          controller.start_execution(trans_id, res.data.result);
        } else if (res.data.status === 'Busy') {
          // If status is Busy then poll the result by recursive call to the poll function
          self.messages(trans_id);
        } else if (res.data.status === 'NotConnected') {
          _Notifier["default"].alert(gettext('Not connected to server or connection with the server has been closed.'), res.data.result);
        }
      }).fail(function () {
        _Notifier["default"].alert(gettext('Debugger Error'), gettext('Error while fetching messages information.'));
      });
    },
    // Callback function when user click on gutters of codemirror to set/clear the breakpoint
    onBreakPoint: function onBreakPoint(cm, m, gutter) {
      var self = this; // If breakpoint gutter is clicked and execution is not completed then only set the breakpoint

      if (gutter == 'breakpoints' && !pgTools.DirectDebug.polling_timeout_idle) {
        // We may want to check, if break-point is allowed at this moment or not
        var info = cm.lineInfo(m); // If gutterMarker is undefined that means there is no marker defined previously
        // So we need to set the breakpoint command here...

        if (info.gutterMarkers == undefined) {
          controller.set_breakpoint(self.trans_id, m + 1, 1); //set the breakpoint
        } else {
          if (info.gutterMarkers.breakpoints == undefined) {
            controller.set_breakpoint(self.trans_id, m + 1, 1); //set the breakpoint
          } else {
            controller.set_breakpoint(self.trans_id, m + 1, 0); //clear the breakpoint
          }
        } // If line folding is defined then gutterMarker will be defined so
        // we need to find out 'breakpoints' information


        var markers = info.gutterMarkers;
        if (markers != undefined && info.gutterMarkers.breakpoints == undefined) markers = info.gutterMarkers.breakpoints;
        cm.setGutterMarker(m, 'breakpoints', markers ? null : function () {
          var marker = document.createElement('div');
          marker.style.color = '#822';
          marker.innerHTML = '●';
          return marker;
        }());
      }
    },
    buildDefaultLayout: function buildDefaultLayout(docker) {
      var code_editor_panel = docker.addPanel('code', wcDocker.DOCK.TOP);
      var parameters_panel = docker.addPanel('parameters', wcDocker.DOCK.BOTTOM, code_editor_panel);
      docker.addPanel('local_variables', wcDocker.DOCK.STACKED, parameters_panel, {
        tabOrientation: wcDocker.TAB.TOP
      });
      docker.addPanel('messages', wcDocker.DOCK.STACKED, parameters_panel);
      docker.addPanel('results', wcDocker.DOCK.STACKED, parameters_panel);
      docker.addPanel('stack_pane', wcDocker.DOCK.STACKED, parameters_panel);
    },

    /**
     * This function is responsible for adjusting the message height
     * so that the message does not cut down.
     * @function setMessagePanelHeight
     */
    setMessagePanelHeight: function setMessagePanelHeight() {
      var self = this,
          dockerPane = self.docker.$container[0];

      if (dockerPane.children.length > 2) {
        var bottomPane = dockerPane.children[2],
            message_height = $(bottomPane).height() - 75;
        $($(dockerPane).find('#messages')[0]).css({
          'height': message_height + 'px',
          'padding-bottom': 5 + 'px'
        });
      }
    },
    // Create the debugger layout with splitter and display the appropriate data received from server.
    intializePanels: function intializePanels() {
      var self = this;
      this.registerPanel('code', self.function_name_with_arguments, '100%', '50%', function () {
        // Create the parameters panel to display the arguments of the functions
        var parameters = new pgAdmin.Browser.Panel({
          name: 'parameters',
          title: gettext('Parameters'),
          width: '100%',
          height: '100%',
          isCloseable: false,
          isPrivate: true,
          content: '<div id ="parameters" class="parameters" tabindex="0"></div>'
        }); // Create the Local variables panel to display the local variables of the function.

        var local_variables = new pgAdmin.Browser.Panel({
          name: 'local_variables',
          title: gettext('Local variables'),
          width: '100%',
          height: '100%',
          isCloseable: false,
          isPrivate: true,
          content: '<div id ="local_variables" class="local_variables" tabindex="0"></div>'
        }); // Create the messages panel to display the message returned from the database server

        var messages = new pgAdmin.Browser.Panel({
          name: 'messages',
          title: gettext('Messages'),
          width: '100%',
          height: '100%',
          isCloseable: false,
          isPrivate: true,
          content: '<div role="status" id="messages" class="messages" tabindex="0"></div>'
        }); // Create the result panel to display the result after debugging the function

        var results = new pgAdmin.Browser.Panel({
          name: 'results',
          title: gettext('Results'),
          width: '100%',
          height: '100%',
          isCloseable: false,
          isPrivate: true,
          content: '<div id="debug_results" class="debug_results" tabindex="0"></div>'
        }); // Create the stack pane panel to display the debugging stack information.

        var stack_pane = new pgAdmin.Browser.Panel({
          name: 'stack_pane',
          title: gettext('Stack'),
          width: '100%',
          height: '100%',
          isCloseable: false,
          isPrivate: true,
          content: '<div id="stack_pane" class="stack_pane" tabindex="0"></div>'
        }); // Load all the created panels

        parameters.load(self.docker);
        local_variables.load(self.docker);
        messages.load(self.docker);
        results.load(self.docker);
        stack_pane.load(self.docker);
      }); // restore the layout if present else fallback to buildDefaultLayout

      pgBrowser.restore_layout(self.docker, self.layout, this.buildDefaultLayout.bind(this));
      self.setMessagePanelHeight();
      self.docker.on(wcDocker.EVENT.LAYOUT_CHANGED, function () {
        self.setMessagePanelHeight();
        pgBrowser.save_current_layout('Debugger/Layout', self.docker);
      });
      self.code_editor_panel = self.docker.findPanels('code')[0];
      self.parameters_panel = self.docker.findPanels('parameters')[0];
      self.local_variables_panel = self.docker.findPanels('local_variables')[0];
      self.messages_panel = self.docker.findPanels('messages')[0];
      self.results_panel = self.docker.findPanels('results')[0];
      self.stack_pane_panel = self.docker.findPanels('stack_pane')[0];
      var editor_pane = $('<div id="stack_editor_pane" ' + 'class="pg-panel-content info"></div>');
      var code_editor_area = $('<textarea aria-label="Code editor area" id="debugger-editor-textarea">' + '</textarea>').appendTo(editor_pane);
      self.code_editor_panel.layout().addItem(editor_pane); // To show the line-number and set breakpoint marker details by user.

      self.editor = CodeMirror.fromTextArea(code_editor_area.get(0), {
        tabindex: -1,
        lineNumbers: true,
        foldOptions: {
          widget: "\u2026"
        },
        foldGutter: true,
        gutters: ['CodeMirror-linenumbers', 'CodeMirror-foldgutter', 'breakpoints'],
        mode: 'text/x-pgsql',
        readOnly: true,
        extraKeys: pgAdmin.Browser.editor_shortcut_keys,
        indentWithTabs: pgAdmin.Browser.editor_options.indent_with_tabs,
        indentUnit: pgAdmin.Browser.editor_options.tabSize,
        tabSize: pgAdmin.Browser.editor_options.tabSize,
        lineWrapping: pgAdmin.Browser.editor_options.wrapCode,
        autoCloseBrackets: pgAdmin.Browser.editor_options.insert_pair_brackets,
        matchBrackets: pgAdmin.Browser.editor_options.brace_matching,
        screenReaderLabel: gettext('Debugger SQL editor')
      }); // Useful for keyboard navigation, when user presses escape key we will
      // defocus from the codemirror editor allow user to navigate further

      CodeMirror.on(self.editor, 'keydown', function (cm, event) {
        if (event.keyCode == 27) {
          document.activeElement.blur();
        }
      });
      pgBrowser.Events.on('pgadmin:debugger:code:focus', function () {
        self.editor.focus();
      }); // On loading the docker, register the callbacks

      var onLoad = function onLoad() {
        self.docker.finishLoading(100);
        self.docker.off(wcDocker.EVENT.LOADED); // Register the callback when user set/clear the breakpoint on gutter area.

        self.editor.on('gutterClick', self.onBreakPoint.bind(self), self);
        /* Set focus to the debugger container
         * Focus does not work in firefox without tabindex attr
         * so, setting focus to parent of $container which is #container
         */

        if (self.docker.$container) {
          self.docker.$container.parent().focus();
        }

        var cacheIntervalId = setInterval(function () {
          try {
            var browser = pgWindow["default"].pgAdmin.Browser;

            if (browser.preference_version() > 0) {
              clearInterval(cacheIntervalId);
              self.reflectPreferences();
              /* If debugger is in a new tab, event fired is not available
               * instead, a poller is set up who will check
               */

              var browser_preferences = browser.get_preferences_for_module('browser');
              var open_new_tab = browser_preferences.new_browser_tab_open;

              if (open_new_tab && open_new_tab.includes('debugger')) {
                pgBrowser.bind_beforeunload();
                var pollIntervalId = setInterval(function () {
                  if (pgWindow["default"].pgAdmin) {
                    self.reflectPreferences();
                  } else {
                    clearInterval(pollIntervalId);
                  }
                }, 1000);
              }
            }
          } catch (err) {
            clearInterval(cacheIntervalId);
            throw err;
          }
        }, 0);
      };

      self.docker.startLoading(gettext('Loading...'));
      self.docker.on(wcDocker.EVENT.LOADED, onLoad); // Create the toolbar view for debugging the function

      this.toolbarView = new DebuggerToolbarView();
      /* wcDocker focuses on window always, and all our shortcuts are
       * bind to editor-panel. So when we use wcDocker focus, editor-panel
       * loses focus and events don't work.
       */

      $(window).on('keydown', function (e) {
        if (self.toolbarView.keyAction) {
          self.toolbarView.keyAction(e);
        }
      });
      /* Cache may take time to load for the first time
       * Keep trying till available
       */

      /* Register for preference changed event broadcasted in parent
       * to reload the shorcuts.
       */

      pgWindow["default"].pgAdmin.Browser.onPreferencesChange('debugger', function () {
        self.reflectPreferences();
      });
      /* Register to log the activity */

      pgBrowser.register_to_activity_listener(document, function () {
        _Notifier["default"].alert(gettext('Timeout'), gettext('Your session has timed out due to inactivity. Please close the window and login again.'));
      });
      controller.poll_result = pgBrowser.override_activity_event_decorator(controller.poll_result).bind(controller);
      controller.poll_end_execution_result = pgBrowser.override_activity_event_decorator(controller.poll_end_execution_result).bind(controller);
    },
    reflectPreferences: function reflectPreferences() {
      var self = this,
          browser = pgWindow["default"].pgAdmin.Browser;
      self.preferences = browser.get_preferences_for_module('debugger');
      self.toolbarView.preferences = self.preferences;
      /* Update the shortcuts of the buttons */

      self.toolbarView.$el.find('#btn-step-into').attr('title', keyboardShortcuts.shortcut_accesskey_title(gettext('Step into'), self.preferences.btn_step_into)).attr('aria-label', keyboardShortcuts.shortcut_accesskey_title(gettext('Step into'), self.preferences.btn_step_into)).attr('accesskey', keyboardShortcuts.shortcut_key(self.preferences.btn_step_into));
      self.toolbarView.$el.find('#btn-step-over').attr('title', keyboardShortcuts.shortcut_accesskey_title(gettext('Step over'), self.preferences.btn_step_over)).attr('aria-label', keyboardShortcuts.shortcut_accesskey_title(gettext('Step over'), self.preferences.btn_step_over)).attr('accesskey', keyboardShortcuts.shortcut_key(self.preferences.btn_step_over));
      self.toolbarView.$el.find('#btn-continue').attr('title', keyboardShortcuts.shortcut_accesskey_title(gettext('Continue/Start'), self.preferences.btn_start)).attr('aria-label', keyboardShortcuts.shortcut_accesskey_title(gettext('Continue/Start'), self.preferences.btn_start)).attr('accesskey', keyboardShortcuts.shortcut_key(self.preferences.btn_start));
      self.toolbarView.$el.find('#btn-toggle-breakpoint').attr('title', keyboardShortcuts.shortcut_accesskey_title(gettext('Toggle breakpoint'), self.preferences.btn_toggle_breakpoint)).attr('aria-label', keyboardShortcuts.shortcut_accesskey_title(gettext('Toggle breakpoint'), self.preferences.btn_toggle_breakpoint)).attr('accesskey', keyboardShortcuts.shortcut_key(self.preferences.btn_toggle_breakpoint));
      self.toolbarView.$el.find('#btn-clear-breakpoint').attr('title', keyboardShortcuts.shortcut_accesskey_title(gettext('Clear all breakpoints'), self.preferences.btn_clear_breakpoints)).attr('aria-label', keyboardShortcuts.shortcut_accesskey_title(gettext('Clear all breakpoints'), self.preferences.btn_clear_breakpoints)).attr('accesskey', keyboardShortcuts.shortcut_key(self.preferences.btn_clear_breakpoints));
      self.toolbarView.$el.find('#btn-stop').attr('title', keyboardShortcuts.shortcut_accesskey_title(gettext('Stop'), self.preferences.btn_stop)).attr('aria-label', keyboardShortcuts.shortcut_accesskey_title(gettext('Stop'), self.preferences.btn_stop)).attr('accesskey', keyboardShortcuts.shortcut_key(self.preferences.btn_stop));
    },
    // Register the panel with new debugger docker instance.
    registerPanel: function registerPanel(name, title, width, height, onInit) {
      var self = this;
      this.docker.registerPanelType(name, {
        title: title,
        isPrivate: true,
        onCreate: function onCreate(panel) {
          self.panels[name] = panel;
          panel.initSize(width, height);
          if (!title) panel.title(false);else panel.title(title);
          panel.closeable(false);
          panel.layout().addItem($('<div tabindex="0">', {
            'class': 'pg-debugger-panel'
          }));

          if (onInit) {
            onInit.apply(self, [panel]);
          }
        }
      });
    }
  });

  pgTools.DirectDebug = new DirectDebug();
  pgTools.DirectDebug['jquery'] = $;
  return pgTools.DirectDebug;
}).apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__),
		__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));

/***/ }),

/***/ 52677:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {



function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

__webpack_require__(4129);

__webpack_require__(78783);

__webpack_require__(66992);

__webpack_require__(33948);

__webpack_require__(69070);

__webpack_require__(38880);

__webpack_require__(82526);

__webpack_require__(41817);

__webpack_require__(32165);

__webpack_require__(88674);

__webpack_require__(41539);

__webpack_require__(35666);

var React = _interopRequireWildcard(__webpack_require__(67294));

var _reactDom = __webpack_require__(73935);

var _pgadmin4Tree = __webpack_require__(90999);

var _tree = __webpack_require__(79226);

var _tree_nodes = __webpack_require__(95197);

var _reactAspen = __webpack_require__(46521);

var _pgadmin = _interopRequireDefault(__webpack_require__(55112));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var initBrowserTree = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(pgBrowser) {
    var MOUNT_POINT, mtree, host, create, remove, update, treeModelX, itemHandle;
    return regeneratorRuntime.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            MOUNT_POINT = '/browser'; // Setup host

            mtree = new _tree_nodes.ManageTreeNodes(); // Init Tree with the Tree Parent node '/browser'

            mtree.init(MOUNT_POINT);
            host = {
              pathStyle: 'unix',
              getItems: function () {
                var _getItems = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(path) {
                  var nodes;
                  return regeneratorRuntime.wrap(function _callee$(_context) {
                    while (1) {
                      switch (_context.prev = _context.next) {
                        case 0:
                          _context.next = 2;
                          return mtree.readNode(path);

                        case 2:
                          nodes = _context.sent;
                          return _context.abrupt("return", nodes);

                        case 4:
                        case "end":
                          return _context.stop();
                      }
                    }
                  }, _callee);
                }));

                function getItems(_x2) {
                  return _getItems.apply(this, arguments);
                }

                return getItems;
              }(),
              sortComparator: function sortComparator(a, b) {
                // No nee to sort columns
                if (a._metadata && a._metadata.data._type == 'column') return 0; // Sort alphabetically

                if (a.constructor === b.constructor) {
                  return _pgadmin["default"].natural_sort(a.fileName, b.fileName);
                }

                return a.constructor === _reactAspen.Directory ? -1 : b.constructor === _reactAspen.Directory ? 1 : 0;
              }
            }; // Create Node

            create = /*#__PURE__*/function () {
              var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(parentPath, _data) {
                var _node_path;

                return regeneratorRuntime.wrap(function _callee2$(_context2) {
                  while (1) {
                    switch (_context2.prev = _context2.next) {
                      case 0:
                        _context2.prev = 0;
                        _node_path = parentPath + "/" + _data.id;
                        return _context2.abrupt("return", mtree.addNode(parentPath, _node_path, _data));

                      case 5:
                        _context2.prev = 5;
                        _context2.t0 = _context2["catch"](0);
                        return _context2.abrupt("return", null);

                      case 8:
                      case "end":
                        return _context2.stop();
                    }
                  }
                }, _callee2, null, [[0, 5]]);
              }));

              return function create(_x3, _x4) {
                return _ref2.apply(this, arguments);
              };
            }(); // Remove Node


            remove = /*#__PURE__*/function () {
              var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(path, _removeOnlyChild) {
                return regeneratorRuntime.wrap(function _callee3$(_context3) {
                  while (1) {
                    switch (_context3.prev = _context3.next) {
                      case 0:
                        _context3.prev = 0;
                        _context3.next = 3;
                        return mtree.removeNode(path, _removeOnlyChild);

                      case 3:
                        return _context3.abrupt("return", true);

                      case 6:
                        _context3.prev = 6;
                        _context3.t0 = _context3["catch"](0);
                        return _context3.abrupt("return", false);

                      case 9:
                      case "end":
                        return _context3.stop();
                    }
                  }
                }, _callee3, null, [[0, 6]]);
              }));

              return function remove(_x5, _x6) {
                return _ref3.apply(this, arguments);
              };
            }(); // Update Node


            update = /*#__PURE__*/function () {
              var _ref4 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(path, data) {
                return regeneratorRuntime.wrap(function _callee4$(_context4) {
                  while (1) {
                    switch (_context4.prev = _context4.next) {
                      case 0:
                        _context4.prev = 0;
                        _context4.next = 3;
                        return mtree.updateNode(path, data);

                      case 3:
                        return _context4.abrupt("return", true);

                      case 6:
                        _context4.prev = 6;
                        _context4.t0 = _context4["catch"](0);
                        return _context4.abrupt("return", false);

                      case 9:
                      case "end":
                        return _context4.stop();
                    }
                  }
                }, _callee4, null, [[0, 6]]);
              }));

              return function update(_x7, _x8) {
                return _ref4.apply(this, arguments);
              };
            }();

            treeModelX = new _pgadmin4Tree.TreeModelX(host, MOUNT_POINT);

            itemHandle = function onReady(handler) {
              // Initialize pgBrowser Tree
              pgBrowser.tree = new _tree.Tree(handler, mtree, pgBrowser);
              return true;
            };

            _context5.next = 11;
            return treeModelX.root.ensureLoaded();

          case 11:
            _context5.next = 13;
            return (0, _reactDom.render)( /*#__PURE__*/React.createElement(_pgadmin4Tree.FileTreeX, {
              model: treeModelX,
              onReady: itemHandle,
              create: create,
              remove: remove,
              update: update
            }), document.getElementById('tree'));

          case 13:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5);
  }));

  return function initBrowserTree(_x) {
    return _ref.apply(this, arguments);
  };
}();

module.exports = {
  initBrowserTree: initBrowserTree
};

/***/ }),

/***/ 95197:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

__webpack_require__(4129);

__webpack_require__(78783);

__webpack_require__(38880);

__webpack_require__(82526);

__webpack_require__(41817);

__webpack_require__(32165);

Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.isCollectionNode = isCollectionNode;
exports.TreeNode = exports.ManageTreeNodes = void 0;

__webpack_require__(35666);

__webpack_require__(88674);

__webpack_require__(41539);

__webpack_require__(68309);

__webpack_require__(40561);

__webpack_require__(82772);

__webpack_require__(26699);

__webpack_require__(32023);

__webpack_require__(15306);

__webpack_require__(74916);

__webpack_require__(69600);

__webpack_require__(66992);

__webpack_require__(33948);

__webpack_require__(65069);

__webpack_require__(19601);

__webpack_require__(32564);

__webpack_require__(69070);

var BrowserFS = _interopRequireWildcard(__webpack_require__(43229));

var _url_for = _interopRequireDefault(__webpack_require__(28008));

var _pgadmin = _interopRequireDefault(__webpack_require__(55112));

var _underscore = _interopRequireDefault(__webpack_require__(81311));

var _reactAspen = __webpack_require__(46521);

var _tree = __webpack_require__(79226);

var _pathFx = __webpack_require__(68016);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var ManageTreeNodes = /*#__PURE__*/function () {
  function ManageTreeNodes(fs) {
    var _this = this;

    _classCallCheck(this, ManageTreeNodes);

    _defineProperty(this, "init", function (_root) {
      return new Promise(function (res, rej) {
        var node = {
          parent: null,
          children: [],
          data: null
        };
        _this.tree = {};
        _this.tree[_root] = {
          name: 'root',
          type: _reactAspen.FileType.Directory,
          metadata: node
        };
        res();
      });
    });

    _defineProperty(this, "updateNode", function (_path, _data) {
      return new Promise(function (res, rej) {
        var item = _this.findNode(_path);

        if (item) {
          item.name = _data.label;
          item.metadata.data = _data;
        }

        res(true);
      });
    });

    _defineProperty(this, "removeNode", /*#__PURE__*/function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(_path, _removeOnlyChild) {
        var item;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                item = _this.findNode(_path);

                if (item && item.parentNode) {
                  item.children = [];
                  item.parentNode.children.splice(item.parentNode.children.indexOf(item), 1);
                }

                return _context.abrupt("return", true);

              case 3:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function (_x, _x2) {
        return _ref.apply(this, arguments);
      };
    }());

    _defineProperty(this, "addNode", function (_parent, _path, _data) {
      return new Promise(function (res, rej) {
        _data.type = _data.inode ? _reactAspen.FileType.Directory : _reactAspen.FileType.File;
        _data._label = _data.label;
        _data.label = _underscore["default"].escape(_data.label);
        _data.is_collection = isCollectionNode(_data._type);
        var nodeData = {
          parent: _parent,
          children: [],
          data: _data
        };

        var tmpParentNode = _this.findNode(_parent);

        var treeNode = new TreeNode(_data.id, _data, {}, tmpParentNode, nodeData, _data.type);
        if (tmpParentNode !== null && tmpParentNode !== undefined) tmpParentNode.children.push(treeNode);
        res(treeNode);
      });
    });

    _defineProperty(this, "readNode", function (_path) {
      return new Promise(function (res, rej) {
        var temp_tree_path = _path,
            node = _this.findNode(_path),
            base_url = _pgadmin["default"].Browser.URL;

        if (node && node.children.length > 0) {
          if (!node.type === _reactAspen.FileType.File) {
            rej("It's a leaf node");
          } else {
            if (node.children.length != 0) res(node.children);
          }
        }

        var self = _this;

        function loadData() {
          return _loadData.apply(this, arguments);
        }

        function _loadData() {
          _loadData = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4() {
            var url, _parent_url, _type, jsonData, _jsonData, treeData, Path, fill, d;

            return regeneratorRuntime.wrap(function _callee4$(_context4) {
              while (1) {
                switch (_context4.prev = _context4.next) {
                  case 0:
                    _jsonData = function _jsonData3() {
                      _jsonData = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(url) {
                        var res, json;
                        return regeneratorRuntime.wrap(function _callee3$(_context3) {
                          while (1) {
                            switch (_context3.prev = _context3.next) {
                              case 0:
                                _context3.next = 2;
                                return fetch(url, {
                                  headers: {
                                    'X-Requested-With': 'XMLHttpRequest',
                                    'X-pgA-CSRFToken': _pgadmin["default"].csrf_token
                                  }
                                });

                              case 2:
                                res = _context3.sent;

                                if (!(res.status == 200)) {
                                  _context3.next = 14;
                                  break;
                                }

                                _context3.prev = 4;
                                _context3.next = 7;
                                return res.json();

                              case 7:
                                json = _context3.sent;
                                return _context3.abrupt("return", json.data);

                              case 11:
                                _context3.prev = 11;
                                _context3.t0 = _context3["catch"](4);
                                console.warn(_context3.t0);

                              case 14:
                                throw new Error("Node Load Error...");

                              case 15:
                              case "end":
                                return _context3.stop();
                            }
                          }
                        }, _callee3, null, [[4, 11]]);
                      }));
                      return _jsonData.apply(this, arguments);
                    };

                    jsonData = function _jsonData2(_x3) {
                      return _jsonData.apply(this, arguments);
                    };

                    url = '';

                    if (_path == '/browser') {
                      url = (0, _url_for["default"])('browser.nodes');
                    } else {
                      _parent_url = self.generate_url(_path);

                      if (node.metadata.data._pid == null) {
                        url = node.metadata.data._type + '/children/' + node.metadata.data._id;
                      } else {
                        if (node.metadata.data._type.includes("coll-")) {
                          _type = node.metadata.data._type.replace("coll-", "");
                          url = _type + '/nodes/' + _parent_url + '/';
                        } else {
                          url = node.metadata.data._type + '/children/' + _parent_url + '/' + node.metadata.data._id;
                        }
                      }

                      url = base_url + url;
                      temp_tree_path = node.path;

                      if (node.metadata.data._type == 'server' && !node.metadata.data.connected) {
                        url = null;
                      }
                    }

                    treeData = null;

                    if (!url) {
                      _context4.next = 9;
                      break;
                    }

                    _context4.next = 8;
                    return jsonData(url);

                  case 8:
                    treeData = _context4.sent;

                  case 9:
                    Path = BrowserFS.BFSRequire('path');

                    fill = /*#__PURE__*/function () {
                      var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(tree) {
                        var idx, _node, _pathl;

                        return regeneratorRuntime.wrap(function _callee2$(_context2) {
                          while (1) {
                            switch (_context2.prev = _context2.next) {
                              case 0:
                                _context2.t0 = regeneratorRuntime.keys(tree);

                              case 1:
                                if ((_context2.t1 = _context2.t0()).done) {
                                  _context2.next = 9;
                                  break;
                                }

                                idx = _context2.t1.value;
                                _node = tree[idx];
                                _pathl = Path.join(_path, _node.id);
                                _context2.next = 7;
                                return self.addNode(temp_tree_path, _pathl, _node);

                              case 7:
                                _context2.next = 1;
                                break;

                              case 9:
                              case "end":
                                return _context2.stop();
                            }
                          }
                        }, _callee2);
                      }));

                      return function fill(_x4) {
                        return _ref2.apply(this, arguments);
                      };
                    }();

                    _context4.next = 13;
                    return fill(treeData);

                  case 13:
                    d = _context4.sent;
                    if (node.children.length > 0) res(node.children);else res(null);

                  case 15:
                  case "end":
                    return _context4.stop();
                }
              }
            }, _callee4);
          }));
          return _loadData.apply(this, arguments);
        }

        loadData();
      });
    });

    _defineProperty(this, "generate_url", function (path) {
      var _path = path;
      var _parent_path = [];
      var _partitions = [];

      while (_path != '/') {
        var node = _this.findNode(_path);

        var _parent = _pathFx.unix.dirname(_path);

        if (node.parentNode && node.parentNode.path == _parent) {
          if (node.parentNode.metadata.data !== null && !node.parentNode.metadata.data._type.includes('coll-')) if (node.parentNode.metadata.data._type.includes('partition')) {
            _partitions.push(node.parentNode.metadata.data._id);
          } else {
            _parent_path.push(node.parentNode.metadata.data._id);
          }
        }

        _path = _parent;
      } // Replace the table with the last partition as in reality partition node is not child of the table


      if (_partitions.length > 0) _parent_path[0] = _partitions[_partitions.length - 1];

      var _rev_arr = _parent_path.reverse();

      return _rev_arr.join("/");
    });

    this.tree = {};
    this.tempTree = new TreeNode(undefined, {});
  }

  _createClass(ManageTreeNodes, [{
    key: "findNode",
    value: function findNode(path) {
      if (path === null || path === undefined || path.length === 0 || path == '/browser') {
        return this.tempTree;
      }

      return (0, _tree.findInTree)(this.tempTree, path);
    }
  }]);

  return ManageTreeNodes;
}();

exports.ManageTreeNodes = ManageTreeNodes;

var TreeNode = /*#__PURE__*/function () {
  function TreeNode(id, data, domNode, parent, metadata, type) {
    _classCallCheck(this, TreeNode);

    this.id = id;
    this.data = data;
    this.setParent(parent);
    this.children = [];
    this.domNode = domNode;
    this.metadata = metadata;
    this.name = metadata ? metadata.data.label : "";
    this.type = type ? type : undefined;
  }

  _createClass(TreeNode, [{
    key: "hasParent",
    value: function hasParent() {
      return this.parentNode !== null && this.parentNode !== undefined;
    }
  }, {
    key: "parent",
    value: function parent() {
      return this.parentNode;
    }
  }, {
    key: "setParent",
    value: function setParent(parent) {
      this.parentNode = parent;
      this.path = this.id;
      if (this.id) if (parent !== null && parent !== undefined && parent.path !== undefined) {
        this.path = parent.path + '/' + this.id;
      } else {
        this.path = '/browser/' + this.id;
      }
    }
  }, {
    key: "getData",
    value: function getData() {
      if (this.data === undefined) {
        return undefined;
      } else if (this.data === null) {
        return null;
      }

      return Object.assign({}, this.data);
    }
  }, {
    key: "getHtmlIdentifier",
    value: function getHtmlIdentifier() {
      return this.domNode;
    }
    /*
     * Find the ancestor with matches this condition
     */

  }, {
    key: "ancestorNode",
    value: function ancestorNode(condition) {
      var node = this;

      while (node.hasParent()) {
        node = node.parent();

        if (condition(node)) {
          return node;
        }
      }

      return null;
    }
    /**
     * Given a condition returns true if the current node
     * or any of the parent nodes condition result is true
     */

  }, {
    key: "anyFamilyMember",
    value: function anyFamilyMember(condition) {
      if (condition(this)) {
        return true;
      }

      return this.ancestorNode(condition) !== null;
    }
  }, {
    key: "anyParent",
    value: function anyParent(condition) {
      return this.ancestorNode(condition) !== null;
    }
  }, {
    key: "reload",
    value: function reload(tree) {
      var _this2 = this;

      return new Promise(function (resolve) {
        _this2.unload(tree).then(function () {
          tree.setInode(_this2.domNode);
          tree.deselect(_this2.domNode);
          setTimeout(function () {
            tree.selectNode(_this2.domNode);
          }, 0);
          resolve();
        });
      });
    }
  }, {
    key: "unload",
    value: function unload(tree) {
      var _this3 = this;

      return new Promise(function (resolve, reject) {
        _this3.children = [];
        tree.unload(_this3.domNode).then(function () {
          resolve(true);
        }, function () {
          reject();
        });
      });
    }
  }, {
    key: "open",
    value: function open(tree, suppressNoDom) {
      var _this4 = this;

      return new Promise(function (resolve, reject) {
        if (suppressNoDom && (_this4.domNode == null || typeof _this4.domNode === 'undefined')) {
          resolve(true);
        } else if (tree.isOpen(_this4.domNode)) {
          resolve(true);
        } else {
          tree.open(_this4.domNode).then(function (val) {
            return resolve(true);
          }, function (err) {
            return reject(true);
          });
        }
      });
    }
  }]);

  return TreeNode;
}();

exports.TreeNode = TreeNode;

function isCollectionNode(node) {
  if (_pgadmin["default"].Browser.Nodes && node in _pgadmin["default"].Browser.Nodes) {
    if (_pgadmin["default"].Browser.Nodes[node].is_collection !== undefined) return _pgadmin["default"].Browser.Nodes[node].is_collection;else return false;
  }

  return false;
}

/***/ }),

/***/ 92026:
/***/ ((module) => {

module.exports = __WEBPACK_EXTERNAL_MODULE__92026__;

/***/ }),

/***/ 8012:
/***/ ((module) => {

module.exports = __WEBPACK_EXTERNAL_MODULE__8012__;

/***/ }),

/***/ 1506:
/***/ ((module) => {

module.exports = __WEBPACK_EXTERNAL_MODULE__1506__;

/***/ }),

/***/ 96481:
/***/ ((module) => {

module.exports = __WEBPACK_EXTERNAL_MODULE__96481__;

/***/ }),

/***/ 6537:
/***/ ((module) => {

module.exports = __WEBPACK_EXTERNAL_MODULE__6537__;

/***/ }),

/***/ 52536:
/***/ ((module) => {

module.exports = __WEBPACK_EXTERNAL_MODULE__52536__;

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		if(__webpack_module_cache__[moduleId]) {
/******/ 			return __webpack_module_cache__[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			id: moduleId,
/******/ 			loaded: false,
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = __webpack_modules__;
/******/ 	
/******/ 	// the startup function
/******/ 	// It's empty as some runtime module handles the default behavior
/******/ 	__webpack_require__.x = x => {};
/************************************************************************/
/******/ 	/* webpack/runtime/compat get default export */
/******/ 	(() => {
/******/ 		// getDefaultExport function for compatibility with non-harmony modules
/******/ 		__webpack_require__.n = (module) => {
/******/ 			var getter = module && module.__esModule ?
/******/ 				() => (module['default']) :
/******/ 				() => (module);
/******/ 			__webpack_require__.d(getter, { a: getter });
/******/ 			return getter;
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/define property getters */
/******/ 	(() => {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = (exports, definition) => {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/ensure chunk */
/******/ 	(() => {
/******/ 		// The chunk loading function for additional chunks
/******/ 		// Since all referenced chunks are already included
/******/ 		// in this file, this function is empty here.
/******/ 		__webpack_require__.e = () => (Promise.resolve());
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/global */
/******/ 	(() => {
/******/ 		__webpack_require__.g = (function() {
/******/ 			if (typeof globalThis === 'object') return globalThis;
/******/ 			try {
/******/ 				return this || new Function('return this')();
/******/ 			} catch (e) {
/******/ 				if (typeof window === 'object') return window;
/******/ 			}
/******/ 		})();
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	(() => {
/******/ 		__webpack_require__.o = (obj, prop) => (Object.prototype.hasOwnProperty.call(obj, prop))
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	(() => {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = (exports) => {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/node module decorator */
/******/ 	(() => {
/******/ 		__webpack_require__.nmd = (module) => {
/******/ 			module.paths = [];
/******/ 			if (!module.children) module.children = [];
/******/ 			return module;
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/runtimeId */
/******/ 	(() => {
/******/ 		__webpack_require__.j = 361;
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/jsonp chunk loading */
/******/ 	(() => {
/******/ 		// no baseURI
/******/ 		
/******/ 		// object to store loaded and loading chunks
/******/ 		// undefined = chunk not loaded, null = chunk preloaded/prefetched
/******/ 		// Promise = chunk loading, 0 = chunk loaded
/******/ 		var installedChunks = {
/******/ 			361: 0,
/******/ 			528: 0
/******/ 		};
/******/ 		
/******/ 		var deferredModules = [
/******/ 			[22074,688,160,196]
/******/ 		];
/******/ 		// no chunk on demand loading
/******/ 		
/******/ 		// no prefetching
/******/ 		
/******/ 		// no preloaded
/******/ 		
/******/ 		// no HMR
/******/ 		
/******/ 		// no HMR manifest
/******/ 		
/******/ 		var checkDeferredModules = x => {};
/******/ 		
/******/ 		// install a JSONP callback for chunk loading
/******/ 		var webpackJsonpCallback = (parentChunkLoadingFunction, data) => {
/******/ 			var [chunkIds, moreModules, runtime, executeModules] = data;
/******/ 			// add "moreModules" to the modules object,
/******/ 			// then flag all "chunkIds" as loaded and fire callback
/******/ 			var moduleId, chunkId, i = 0, resolves = [];
/******/ 			for(;i < chunkIds.length; i++) {
/******/ 				chunkId = chunkIds[i];
/******/ 				if(__webpack_require__.o(installedChunks, chunkId) && installedChunks[chunkId]) {
/******/ 					resolves.push(installedChunks[chunkId][0]);
/******/ 				}
/******/ 				installedChunks[chunkId] = 0;
/******/ 			}
/******/ 			for(moduleId in moreModules) {
/******/ 				if(__webpack_require__.o(moreModules, moduleId)) {
/******/ 					__webpack_require__.m[moduleId] = moreModules[moduleId];
/******/ 				}
/******/ 			}
/******/ 			if(runtime) runtime(__webpack_require__);
/******/ 			if(parentChunkLoadingFunction) parentChunkLoadingFunction(data);
/******/ 			while(resolves.length) {
/******/ 				resolves.shift()();
/******/ 			}
/******/ 		
/******/ 			// add entry modules from loaded chunk to deferred list
/******/ 			if(executeModules) deferredModules.push.apply(deferredModules, executeModules);
/******/ 		
/******/ 			// run deferred modules when all chunks ready
/******/ 			return checkDeferredModules();
/******/ 		}
/******/ 		
/******/ 		var chunkLoadingGlobal = self["webpackChunk"] = self["webpackChunk"] || [];
/******/ 		chunkLoadingGlobal.forEach(webpackJsonpCallback.bind(null, 0));
/******/ 		chunkLoadingGlobal.push = webpackJsonpCallback.bind(null, chunkLoadingGlobal.push.bind(chunkLoadingGlobal));
/******/ 		
/******/ 		function checkDeferredModulesImpl() {
/******/ 			var result;
/******/ 			for(var i = 0; i < deferredModules.length; i++) {
/******/ 				var deferredModule = deferredModules[i];
/******/ 				var fulfilled = true;
/******/ 				for(var j = 1; j < deferredModule.length; j++) {
/******/ 					var depId = deferredModule[j];
/******/ 					if(installedChunks[depId] !== 0) fulfilled = false;
/******/ 				}
/******/ 				if(fulfilled) {
/******/ 					deferredModules.splice(i--, 1);
/******/ 					result = __webpack_require__(__webpack_require__.s = deferredModule[0]);
/******/ 				}
/******/ 			}
/******/ 			if(deferredModules.length === 0) {
/******/ 				__webpack_require__.x();
/******/ 				__webpack_require__.x = x => {};
/******/ 			}
/******/ 			return result;
/******/ 		}
/******/ 		var startup = __webpack_require__.x;
/******/ 		__webpack_require__.x = () => {
/******/ 			// reset startup function so it can be called again when more startup code is added
/******/ 			__webpack_require__.x = startup || (x => {});
/******/ 			return (checkDeferredModules = checkDeferredModulesImpl)();
/******/ 		};
/******/ 	})();
/******/ 	
/************************************************************************/
/******/ 	
/******/ 	// run startup
/******/ 	var __webpack_exports__ = __webpack_require__.x();
/******/ 	__webpack_exports__ = __webpack_exports__.default;
/******/ 	
/******/ 	return __webpack_exports__;
/******/ })()
;
});;
//# sourceMappingURL=debugger_direct.js.map