(self["webpackChunk"] = self["webpackChunk"] || []).push([[196],{

/***/ 63563:
/***/ ((module, exports, __webpack_require__) => {

"use strict";
var __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;

__webpack_require__(68309);

__webpack_require__(24812);

__webpack_require__(32564);

__webpack_require__(57327);

__webpack_require__(5735);

__webpack_require__(83753);

__webpack_require__(69600);

__webpack_require__(69826);

/////////////////////////////////////////////////////////////
//
// pgAdmin 4 - PostgreSQL Tools
//
// Copyright (C) 2013 - 2022, The pgAdmin Development Team
// This software is released under the PostgreSQL Licence
//
//////////////////////////////////////////////////////////////
!(__WEBPACK_AMD_DEFINE_ARRAY__ = [__webpack_require__(91669), __webpack_require__(81311), __webpack_require__(19755), __webpack_require__(72316), __webpack_require__(95283), __webpack_require__(83879), __webpack_require__(58307), __webpack_require__(66235), __webpack_require__(44092), __webpack_require__(75270)], __WEBPACK_AMD_DEFINE_RESULT__ = (function (gettext, _, $, Backbone, Backform, Backgrid, Alertify, pgNode, commonUtils) {
  /**
   * Each Privilege, supporeted by an database object, will be represented
   * using this Model.
   *
   * Defaults:
   *   privilege_type -> Name of the permission
   *      i.e. CREATE, TEMPORARY, CONNECT, etc.
   *   privilege      -> Has privilege? (true/false)
   *   with_grant     -> Has privilege with grant option (true/false)
   **/
  var PrivilegeModel = pgNode.Model.extend({
    idAttribute: 'privilege_type',
    defaults: {
      privilege_type: undefined,
      privilege: false,
      with_grant: false
    },
    validate: function validate() {
      return null;
    }
  });
  /**
   * A database object has privileges item list (aclitem[]).
   *
   * This model represents the individual privilege item (aclitem).
   * It has basically three properties:
   *  + grantee    - Role to which that privilege applies to.
   *                Empty value represents to PUBLIC.
   *  + grantor    - Grantor who has given this permission.
   *  + privileges - Privileges for that role.
   **/

  var PrivilegeRoleModel = pgNode.PrivilegeRoleModel = pgNode.Model.extend({
    idAttribute: 'grantee',
    defaults: {
      grantee: undefined,
      grantor: undefined,
      privileges: undefined
    },
    keys: ['grantee', 'grantor'],

    /*
     * Each of the database object needs to extend this model, which should
     * provide the type of privileges (it supports).
     */
    privileges: [],
    schema: [{
      id: 'grantee',
      label: gettext('Grantee'),
      type: 'text',
      group: null,
      editable: true,
      cellHeaderClasses: 'width_percent_40',
      node: 'role',
      options_cached: false,
      disabled: function disabled(m) {
        if (!(m instanceof Backbone.Model)) {
          // This has been called during generating the header cell
          return false;
        }

        return !(m.top && m.top.node_info && m.top.node_info.server.user.name == m.get('grantor'));
      },
      transform: function transform() {
        var res = Backgrid.Extension.NodeListByNameCell.prototype.defaults.transform.apply(this, arguments);
        res.unshift({
          label: 'PUBLIC',
          value: 'PUBLIC'
        });
        return res;
      },
      cell: Backgrid.Extension.NodeListByNameCell.extend({
        initialize: function initialize(opts) {
          var self = this,
              override_opts = true; // We would like to override the original options, because - we
          // should omit the existing role/user from the privilege cell.
          // Because - the column is shared among all the cell, we can only
          // override only once.

          if (opts && opts.column && opts.column instanceof Backbone.Model && opts.column.get('options_cached')) {
            override_opts = false;
          }

          Backgrid.Extension.NodeListByNameCell.prototype.initialize.apply(self, arguments); // Let's override the options

          if (override_opts) {
            opts = self.column.get('options');
            self.column.set('options', self.omit_selected_roles.bind(self, opts));
          }

          var rerender = function (m) {
            var _self = this;

            if ('grantee' in m.changed && this.model.cid != m.cid) {
              setTimeout(function () {
                _self.render();
              }, 50);
            }
          }.bind(this); // We would like to rerender all the cells of this type for this
          // collection, because - we need to omit the newly selected roles
          // form the list. Also, the render will be automatically called for
          // the model represented by this cell, we will not do that again.


          this.listenTo(self.model.collection, 'change', rerender, this);
          this.listenTo(self.model.collection, 'remove', rerender, this);
        },
        // Remove all the selected roles (though- not mine).
        omit_selected_roles: function omit_selected_roles(opts, cell) {
          var res = opts(cell),
              selected = {},
              model = cell.model,
              cid = model.cid,
              // We need to check node_info values in parent when object is nested.
          // eg: column level privileges in table dialog
          // In this case node_info will not be avilable to column node as
          // it is not loaded yet
          node_info = _.has(model.top, 'node_info') && !_.isUndefined(model.top.node_info) ? model.top.node_info : model.handler.top.node_info,
              curr_user = node_info.server.user.name;
          model.collection.each(function (m) {
            var grantee = m.get('grantee');

            if (m.cid != cid && !_.isUndefined(grantee) && curr_user == m.get('grantor')) {
              selected[grantee] = m.cid;
            }
          });
          res = _.filter(res, function (o) {
            return !(o.value in selected);
          });
          return res;
        }
      })
    }, {
      id: 'privileges',
      label: gettext('Privileges'),
      type: 'collection',
      model: PrivilegeModel,
      group: null,
      cell: 'privilege',
      control: 'text',
      cellHeaderClasses: 'width_percent_40',
      disabled: function disabled(column) {
        if (column instanceof Backbone.Collection) {
          // This has been called during generating the header cell
          return false;
        }

        return !(this.node_info && this.node_info.server.user.name == column.get('grantor') || this.attributes.node_info.server.user.name == column.get('grantor'));
      }
    }, {
      id: 'grantor',
      label: gettext('Grantor'),
      type: 'text',
      readonly: true,
      cell: 'node-list-by-name',
      node: 'role'
    }],

    /*
     * Initialize the model, which will transform the privileges string to
     * collection of Privilege Model.
     */
    initialize: function initialize(attrs, opts) {
      pgNode.Model.prototype.initialize.apply(this, arguments);

      if (_.isNull(attrs)) {
        this.set('grantor', opts && opts.top && opts.top.node_info && opts.top.node_info.server.user.name, {
          silent: true
        });
      }
      /*
       * Define the collection of the privilege supported by this model
       */


      var self = this,
          models = self.get('privileges'),
          privileges = this.get('privileges') || {};

      if (_.isArray(privileges)) {
        privileges = new pgNode.Collection(models, {
          model: PrivilegeModel,
          top: this.top || this,
          handler: this,
          silent: true,
          parse: false
        });
        this.set('privileges', privileges, {
          silent: true
        });
      }

      var privs = {};

      _.each(self.privileges, function (p) {
        privs[p] = {
          'privilege_type': p,
          'privilege': false,
          'with_grant': false
        };
      });

      privileges.each(function (m) {
        delete privs[m.get('privilege_type')];
      });

      _.each(privs, function (p) {
        privileges.add(p, {
          silent: true
        });
      });

      self.on('change:grantee', self.granteeChanged);
      privileges.on('change', function () {
        self.trigger('change:privileges', self);
      });
      return self;
    },
    granteeChanged: function granteeChanged() {
      var privileges = this.get('privileges'),
          grantee = this.get('grantee'); // Reset all with grant options if grantee is public.

      if (grantee == 'PUBLIC') {
        privileges.each(function (m) {
          m.set('with_grant', false, {
            silent: true
          });
        });
      }
    },
    toJSON: function toJSON() {
      var privileges = [];

      if (this.attributes && !this.attributes['privileges']) {
        return null;
      }

      this.attributes['privileges'].each(function (p) {
        if (p.get('privilege')) {
          privileges.push(p.toJSON());
        }
      });
      return {
        'grantee': this.get('grantee'),
        'grantor': this.get('grantor'),
        'privileges': privileges
      };
    },
    validate: function validate() {
      var errmsg = null,
          msg;

      if (_.isUndefined(this.get('grantee'))) {
        msg = gettext('A grantee must be selected.');
        this.errorModel.set('grantee', msg);
        errmsg = msg;
      } else {
        this.errorModel.unset('grantee');
      }

      if (this.attributes && this.attributes['privileges']) {
        var anyPrivSelected = false;
        this.attributes['privileges'].each(function (p) {
          if (p.get('privilege')) {
            anyPrivSelected = true;
          }
        });

        if (!anyPrivSelected) {
          msg = gettext('At least one privilege should be selected.');
          this.errorModel.set('privileges', msg);
          errmsg = errmsg || msg;
        } else {
          this.errorModel.unset('privileges');
        }
      }

      return errmsg;
    }
  });
  /**
   Custom cell editor for editing privileges.
   */

  var PrivilegeCellEditor = Backgrid.Extension.PrivilegeCellEditor = Backgrid.CellEditor.extend({
    tagName: 'div',
    // All available privileges in the PostgreSQL database server for
    // generating the label for the specific Control
    Labels: {
      'C': 'CREATE',
      'T': 'TEMPORARY',
      'c': 'CONNECT',
      'a': 'INSERT',
      'r': 'SELECT',
      'w': 'UPDATE',
      'd': 'DELETE',
      'D': 'TRUNCATE',
      'x': 'REFERENCES',
      't': 'TRIGGER',
      'U': 'USAGE',
      'X': 'EXECUTE'
    },
    template: _.template(['<tr class="<%= header ? "header" : "" %>">', ' <td class="renderable">', '  <div class="custom-control custom-checkbox privilege-checkbox">', '    <input tabindex="0" type="checkbox" class="custom-control-input" id="<%= checkbox_id %>" name="privilege" privilege="<%- privilege_type %>" target="<%- target %>" <%= privilege ? \'checked\' : "" %>/>', '    <label class="custom-control-label" for="<%= checkbox_id %>">', '      <%- privilege_label %>', '    </label>', '  </div>', ' </td>', ' <td class="renderable">', '  <div class="custom-control custom-checkbox privilege-checkbox">', '    <input tabindex="0" type="checkbox" class="custom-control-input" id="wgo_<%= checkbox_id %>" name="with_grant" privilege="<%- privilege_type %>" target="<%- target %>" <%= with_grant ? \'checked\' : "" %> <%= enable_with_grant ? "" : \'disabled\'%>/>', '    <label class="custom-control-label" for="wgo_<%= checkbox_id %>">', '      WITH GRANT OPTION', '    </label>', '  </div>', ' </td>', '</tr>'].join(' '), null, {
      variable: null
    }),
    events: {
      'change': 'privilegeChanged',
      'blur': 'lostFocus',
      'keydown': 'lostFocus'
    },
    render: function render() {
      this.$el.empty();
      this.$el.attr('tabindex', '1');
      this.$el.attr('target', this.elId);
      var collection = this.model.get(this.column.get('name')),
          tbl = $('<table aria-label=' + this.column.get('label') + '></table>').appendTo(this.$el),
          self = this,
          privilege = true,
          with_grant = true; // For each privilege generate html template.
      // List down all the Privilege model.

      var checkbox_id = _.uniqueId();

      collection.each(function (m) {
        var d = m.toJSON();
        privilege = privilege && d.privilege;
        with_grant = with_grant && privilege && d.with_grant;

        _.extend(d, {
          'target': self.cid,
          'header': false,
          'privilege_label': self.Labels[d.privilege_type],
          'with_grant': self.model.get('grantee') != 'PUBLIC' && d.with_grant,
          'enable_with_grant': self.model.get('grantee') != 'PUBLIC' && d.privilege,
          'checkbox_id': d.privilege_type + '' + checkbox_id
        });

        privilege = privilege && d.privilege;
        with_grant = with_grant && privilege && d.with_grant;
        tbl.append(self.template(d));
      });

      if (collection.length > 1) {
        // Preprend the ALL controls on that table
        tbl.prepend(self.template({
          'target': self.cid,
          'privilege_label': 'ALL',
          'privilege_type': 'ALL',
          'privilege': privilege,
          'with_grant': self.model.get('grantee') != 'PUBLIC' && with_grant,
          'enable_with_grant': self.model.get('grantee') != 'PUBLIC' && privilege,
          'header': true,
          'checkbox_id': 'all' + '' + checkbox_id
        }));
      }

      self.$el.find('input[type=checkbox]').first().trigger('focus'); // Since blur event does not bubble we need to explicitly call parent's blur event.

      $(self.$el.find('input[type=checkbox]')).on('blur', function () {
        self.$el.trigger('blur');
      }); // Make row visible in when entering in edit mode.

      $(self.$el).pgMakeVisible('backform-tab');
      self.delegateEvents();
      return this;
    },

    /*
     * Listen to the checkbox value change and update the model accordingly.
     */
    privilegeChanged: function privilegeChanged(ev) {
      if (ev && ev.target) {
        /*
         * We're looking for checkboxes only.
         */
        var $el = $(ev.target),
            privilege_type = $el.attr('privilege'),
            type = $el.attr('name'),
            checked = $el.prop('checked'),
            $tr = $el.closest('tr'),
            $tbl = $tr.closest('table'),
            collection = this.model.get('privileges'),
            grantee = this.model.get('grantee'),
            $allGrants,
            $allPrivileges,
            $elGrant;
        this.undelegateEvents();
        /*
         * If the checkbox selected/deselected is for 'ALL', we will select all
         * the checkbox for each privilege.
         */

        if (privilege_type == 'ALL') {
          var allPrivilege, allWithGrant;
          $elGrant = $tr.find('input[name=with_grant]');
          $allPrivileges = $tbl.find('input[name=privilege][privilege!=\'ALL\']');
          $allGrants = $tbl.find('input[name=with_grant][privilege!=\'ALL\']');

          if (type == 'privilege') {
            /*
             * We clicked the privilege checkbox, and not checkbox for with
             * grant options.
             */
            allPrivilege = checked;
            allWithGrant = false;

            if (checked) {
              $allPrivileges.prop('checked', true);
              /*
               * We have clicked the ALL checkbox, we should be able to select
               * the grant options too.
               */

              if (grantee == 'PUBLIC') {
                $allGrants.prop('disabled', true);
                $elGrant.prop('disabled', true);
              } else {
                $allGrants.prop('disabled', false);
                $elGrant.prop('disabled', false);
              }
            } else {
              /*
               * ALL checkbox has been deselected, hence - we need to make
               * sure.
               * 1. Deselect all the privileges checkboxes
               * 2. Deselect and disable all with grant privilege checkboxes.
               * 3. Deselect and disable the checkbox for ALL with grant privilege.
               */
              $allPrivileges.prop('checked', false);
              $elGrant.prop('checked', false);
              $allGrants.prop('checked', false);
              $elGrant.prop('disabled', true);
              $allGrants.prop('disabled', true);
            }
          } else {
            /*
             * We were able to click the ALL with grant privilege checkbox,
             * that means, privilege for Privileges are true.
             *
             * We need to select/deselect all the with grant options
             * checkboxes, based on the current value of the ALL with grant
             * privilege checkbox.
             */
            allPrivilege = true;
            allWithGrant = checked;
            $allGrants.prop('checked', checked);
          }
          /*
           * Set the values for each Privilege Model.
           */


          collection.each(function (m) {
            m.set({
              'privilege': allPrivilege,
              'with_grant': allWithGrant
            });
          });
        } else {
          /*
           * Particular privilege has been selected/deselected, which can be
           * identified using the privilege="X" attribute.
           */
          var attrs = {};
          $tbl = $tr.closest('table');
          $allPrivileges = $tbl.find('input[name=privilege][privilege=\'ALL\']');
          $allGrants = $tbl.find('input[name=with_grant][privilege=\'ALL\']');
          attrs[type] = checked;

          if (type == 'privilege') {
            $elGrant = $el.closest('tr').find('input[name=with_grant]');

            if (!checked) {
              attrs['with_grant'] = false;
              $elGrant.prop('checked', false).prop('disabled', true);
              $allPrivileges.prop('checked', false);
              $allGrants.prop('disabled', true);
              $allGrants.prop('checked', false);
            } else if (grantee != 'PUBLIC') {
              $elGrant.prop('disabled', false);
            }
          } else if (!checked) {
            $allGrants.prop('checked', false);
          }

          collection.get(privilege_type).set(attrs);

          if (checked) {
            $allPrivileges = $tbl.find('input[name=privilege][privilege!=\'ALL\']:checked');

            if ($allPrivileges.length > 1 && $allPrivileges.length == collection.models.length) {
              $allPrivileges.prop('checked', true);

              if (type == 'with_grant') {
                $allGrants = $tbl.find('input[name=with_grant][privilege!=\'ALL\']:checked');

                if ($allGrants.length == collection.models.length) {
                  $allGrants.prop('disabled', false);
                  $allGrants.prop('checked', true);
                }
              } else if (grantee != 'PUBLIC') {
                $allGrants.prop('disabled', false);
              }
            }
          }
        }

        this.model.trigger('change', this.model);
        var anySelected = false,
            msg = null;
        collection.each(function (m) {
          anySelected = anySelected || m.get('privilege');
        });

        if (anySelected) {
          this.model.errorModel.unset('privileges');

          if (this.model.errorModel.has('grantee')) {
            msg = this.model.errorModel.get('grantee');
          }
        } else {
          this.model.errorModel.set('privileges', gettext('At least one privilege should be selected.'));
          msg = gettext('At least one privilege should be selected.');
        }

        if (msg) {
          this.model.collection.trigger('pgadmin-session:model:invalid', msg, this.model);
        } else {
          this.model.collection.trigger('pgadmin-session:model:valid', this.model);
        }
      }

      this.delegateEvents();
    },
    lostFocus: function lostFocus(ev) {
      /*
       * We lost the focus, it's time for us to exit the editor.
       */
      var self = this,

      /*
       * Function to determine whether one dom element is descendant of another
       * dom element.
       */
      isDescendant = function isDescendant(parent, child) {
        var node = child.parentNode;

        while (node != null) {
          if (node == parent) {
            return true;
          }

          node = node.parentNode;
        }

        return false;
      },
          model = this.model,
          column = this.column,
          command = new Backgrid.Command(ev),
          coll = this.model.get(this.column.get('name'));

      if (ev.key == 'Tab') {
        commonUtils.handleKeyNavigation(event);
      }

      if (command.moveUp() || command.moveDown() || command.save() || command.cancel() || command.moveLeft() && ev.target.name === 'privilege' && $(ev.target).attr('privilege') === 'ALL') {
        // undo
        ev.stopPropagation();
        model.trigger('backgrid:edited', model, column, command);
        return;
      } else if (command.moveRight()) {
        // If we are at the last privilege then we should move to next cell
        if (coll.last().get('privilege_type') === $(ev.target).attr('privilege')) {
          if (ev.target.name === 'privilege' && !ev.target.checked || $(ev.target).attr('name') === 'with_grant') {
            ev.stopPropagation();
            model.trigger('backgrid:edited', model, column, command);
            return;
          }
        }
      }
      /*
       * Between leaving the old element focus and entering the new element focus the
       * active element is the document/body itself so add timeout to get the proper
       * focused active element.
       */


      setTimeout(function () {
        /*
         * Do not close the control if user clicks outside dialog window,
         * only close the row if user clicks on add button or on another row,
         * if user clicks somewhere else then we will get tagName as 'BODY'
         * or 'WINDOW'
         */
        var is_active_element = document.activeElement.tagName == 'DIV' || document.activeElement.tagName == 'BUTTON';

        if (is_active_element && self.$el[0] != document.activeElement && !isDescendant(self.$el[0], document.activeElement)) {
          var m = self.model;
          m.trigger('backgrid:edited', m, self.column, new Backgrid.Command(ev));
        }
      }, 10);
    }
  });
  /*
   * This will help us transform the privileges value in proper format to be
   * displayed in the cell.
   */

  var PrivilegeCellFormatter = Backgrid.Extension.PrivilegeCellFormatter = function () {};

  _.extend(PrivilegeCellFormatter.prototype, {
    notation: {
      'CREATE': 'C',
      'TEMPORARY': 'T',
      'CONNECT': 'c',
      'INSERT': 'a',
      'SELECT': 'r',
      'UPDATE': 'w',
      'DELETE': 'd',
      'TRUNCATE': 'D',
      'REFERENCES': 'x',
      'TRIGGER': 't',
      'USAGE': 'U',
      'EXECUTE': 'X'
    },

    /**
     * Takes a raw value from a model and returns an optionally formatted
     * string for display.
     */
    fromRaw: function fromRaw(rawData) {
      var res = '';

      if (rawData instanceof Backbone.Collection) {
        rawData.each(function (m) {
          if (m.get('privilege')) {
            res += m.get('privilege_type');

            if (m.get('with_grant')) {
              res += '*';
            }
          }
        });
      }

      return res;
    }
  });
  /*
   *  PrivilegeCell for rendering and taking input for the privileges.
   */


  Backgrid.Extension.PrivilegeCell = Backgrid.Cell.extend({
    className: 'edit-cell',
    formatter: PrivilegeCellFormatter,
    editor: PrivilegeCellEditor,
    initialize: function initialize() {
      var self = this;
      Backgrid.Cell.prototype.initialize.apply(this, arguments);
      self.model.on('change:grantee', function () {
        if (!self.$el.hasClass('editor')) {
          /*
           * Add time out before render; As we might want to wait till model
           * is updated by PrivilegeRoleModel:granteeChanged.
           */
          setTimeout(function () {
            self.render();
          }, 10);
        }
      });
    },
    events: {
      'click': 'enterEditMode',
      'keydown': 'saveOrCancel'
    },
    saveOrCancel: function saveOrCancel(e) {
      var model = this.model;
      var column = this.column;
      var command = new Backgrid.Command(e);

      if (command.moveUp() || command.moveDown() || command.moveLeft() || command.moveRight() || command.save()) {
        e.preventDefault();
        e.stopPropagation();
        model.trigger('backgrid:edited', model, column, command);
      } // esc
      else if (command.cancel()) {
          // undo
          e.stopPropagation();
          model.trigger('backgrid:edited', model, column, command);
        }
    }
  });
  return PrivilegeRoleModel;
}).apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__),
		__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));

/***/ }),

/***/ 64096:
/***/ ((module, exports, __webpack_require__) => {

"use strict";
var __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;

__webpack_require__(91058);

__webpack_require__(54678);

__webpack_require__(32564);

__webpack_require__(82772);

__webpack_require__(68309);

__webpack_require__(5735);

__webpack_require__(83753);

__webpack_require__(15306);

__webpack_require__(74916);

__webpack_require__(69600);

__webpack_require__(69826);

__webpack_require__(5212);

/////////////////////////////////////////////////////////////
//
// pgAdmin 4 - PostgreSQL Tools
//
// Copyright (C) 2013 - 2022, The pgAdmin Development Team
// This software is released under the PostgreSQL Licence
//
//////////////////////////////////////////////////////////////
!(__WEBPACK_AMD_DEFINE_ARRAY__ = [__webpack_require__(91669), __webpack_require__(81311), __webpack_require__(19755), __webpack_require__(72316), __webpack_require__(95283), __webpack_require__(83879), __webpack_require__(58307), __webpack_require__(55112), __webpack_require__(66235), __webpack_require__(75270)], __WEBPACK_AMD_DEFINE_RESULT__ = (function (gettext, _, $, Backbone, Backform, Backgrid, Alertify, pgAdmin, pgNode) {
  /*
     * cellFunction for variable control.
     * This function returns cell class depending on vartype.
     */
  var cellFunction = function cellFunction(model) {
    var self = this,
        name = model.get('name'),
        availVariables = {};
    self.collection.each(function (col) {
      if (col.get('name') == 'name') {
        availVariables = col.get('availVariables');
      }
    });
    var variable = name ? availVariables[name] : undefined,
        value = model.get('value');

    switch (variable && variable.vartype) {
      case 'bool':
        /*
             * bool cell and variable cannot be stateless (i.e undefined).
             * It should be either true or false.
             */
        model.set('value', !!model.get('value'), {
          silent: true
        });
        return Backgrid.Extension.SwitchCell;

      case 'enum':
        model.set({
          'value': value
        }, {
          silent: true
        });
        var options = [],
            enumVals = variable && variable.enumvals;

        _.each(enumVals, function (enumVal) {
          options.push([enumVal, enumVal]);
        });

        return Backgrid.Extension.Select2Cell.extend({
          optionValues: options
        });

      case 'integer':
        if (!_.isNaN(parseInt(value))) {
          model.set({
            'value': parseInt(value)
          }, {
            silent: true
          });
        } else {
          model.set({
            'value': undefined
          }, {
            silent: true
          });
        }

        return Backgrid.IntegerCell;

      case 'real':
        if (!_.isNaN(parseFloat(value))) {
          model.set({
            'value': parseFloat(value)
          }, {
            silent: true
          });
        } else {
          model.set({
            'value': undefined
          }, {
            silent: true
          });
        }

        return Backgrid.NumberCell.extend({
          decimals: 0
        });

      case 'string':
        return Backgrid.StringCell;

      default:
        model.set({
          'value': undefined
        }, {
          silent: true
        });
        return Backgrid.Cell;
    }
  };
  /*
       * This row will define behaviour or value column cell depending upon
       * variable name.
       */


  var VariableRow = Backgrid.Row.extend({
    modelDuplicateClass: 'bg-model-duplicate',
    initialize: function initialize() {
      Backgrid.Row.prototype.initialize.apply(this, arguments);
      var self = this;
      self.model.on('change:name', function () {
        setTimeout(function () {
          self.columns.each(function (col) {
            if (col.get('name') == 'value') {
              // Reset old value
              self.model.set({
                'value': undefined
              }, {
                silent: true
              });
              var idx = self.columns.indexOf(col),
                  cf = col.get('cellFunction'),
                  cell = new (cf.apply(col, [self.model]))({
                column: col,
                model: self.model
              }),
                  oldCell = self.cells[idx];
              oldCell.remove();
              self.cells[idx] = cell;
              self.render();
            }
          });
        }, 10);
      });
      self.listenTo(self.model, 'pgadmin-session:model:duplicate', self.modelDuplicate);
      self.listenTo(self.model, 'pgadmin-session:model:unique', self.modelUnique);
    },
    modelDuplicate: function modelDuplicate() {
      $(this.el).removeClass('new');
      $(this.el).addClass(this.modelDuplicateClass);
    },
    modelUnique: function modelUnique() {
      $(this.el).removeClass(this.modelDuplicateClass);
    }
  });
  /**
       *  VariableModel used to represent configuration parameters (variables tab)
       *  for database objects.
       **/

  var VariableModel = pgNode.VariableModel = pgNode.Model.extend({
    keys: ['name'],
    defaults: {
      name: undefined,
      value: undefined,
      role: null,
      database: null
    },
    schema: [{
      id: 'name',
      label: gettext('Name'),
      type: 'text',
      cellHeaderClasses: 'width_percent_30',
      editable: function editable(m) {
        return m instanceof Backbone.Collection ? true : m.isNew();
      },
      cell: Backgrid.Extension.NodeAjaxOptionsCell.extend({
        initialize: function initialize() {
          Backgrid.Extension.NodeAjaxOptionsCell.prototype.initialize.apply(this, arguments); // Immediately process options as we need them before render.

          var opVals = _.clone(this.optionValues || (_.isFunction(this.column.get('options')) ? this.column.get('options')(this) : this.column.get('options')));

          this.column.set('options', opVals);
        }
      }),
      url: 'vopts',
      select2: {
        allowClear: false
      },
      transform: function transform(vars, cell) {
        var res = [],
            availVariables = {};

        _.each(vars, function (v) {
          res.push({
            'value': v.name,
            'image': undefined,
            'label': v.name
          });
          availVariables[v.name] = v;
        });

        cell.column.set('availVariables', availVariables);
        return res;
      }
    }, {
      id: 'value',
      label: gettext('Value'),
      type: 'text',
      editable: true,
      cellFunction: cellFunction,
      cellHeaderClasses: 'width_percent_40'
    }, {
      id: 'database',
      label: gettext('Database'),
      type: 'text',
      editable: true,
      node: 'database',
      cell: Backgrid.Extension.NodeListByNameCell
    }, {
      id: 'role',
      label: gettext('Role'),
      type: 'text',
      editable: true,
      node: 'role',
      cell: Backgrid.Extension.NodeListByNameCell
    }],
    toJSON: function toJSON() {
      var d = Backbone.Model.prototype.toJSON.apply(this); // Remove not defined values from model values.
      // i.e.
      // role, database

      if (_.isUndefined(d.database) || _.isNull(d.database)) {
        delete d.database;
      }

      if (_.isUndefined(d.role) || _.isNull(d.role)) {
        delete d.role;
      }

      return d;
    },
    validate: function validate() {
      var msg = null;

      if (_.isUndefined(this.get('name')) || _.isNull(this.get('name')) || String(this.get('name')).replace(/^\s+|\s+$/g, '') == '') {
        msg = gettext('Please select a parameter name.');
        this.errorModel.set('name', msg);
      } else if (_.isUndefined(this.get('value')) || _.isNull(this.get('value')) || String(this.get('value')).replace(/^\s+|\s+$/g, '') == '') {
        msg = gettext('Please enter a value for the parameter.');
        this.errorModel.set('value', msg);
        this.errorModel.unset('name');
      } else {
        this.errorModel.unset('name');
        this.errorModel.unset('value');
      }

      return msg;
    }
  });
  /**
       * Variable Tab Control to set/update configuration values for database object.
       *
       **/

  Backform.VariableCollectionControl = Backform.UniqueColCollectionControl.extend({
    hasDatabase: false,
    hasRole: false,
    initialize: function initialize(opts) {
      var self = this,
          keys = ['name'];
      /*
         * Read from field schema whether user wants to use database and role
         * fields in Variable control.
         */

      self.hasDatabase = opts.field.get('hasDatabase');
      self.hasRole = opts.field.get('hasRole'); // Update unique coll field based on above flag status.

      if (self.hasDatabase) {
        keys.push('database');
      } else if (self.hasRole) {
        keys.push('role');
      } // Overriding the uniqueCol in the field


      if (opts && opts.field) {
        if (opts.field instanceof Backform.Field) {
          opts.field.set({
            model: pgNode.VariableModel.extend({
              keys: keys
            })
          }, {
            silent: true
          });
        } else {
          opts.field.extend({
            model: pgNode.VariableModel.extend({
              keys: keys
            })
          });
        }
      }

      Backform.UniqueColCollectionControl.prototype.initialize.apply(self, arguments);
      self.availVariables = {};
      var gridCols = ['name', 'value'];

      if (self.hasDatabase) {
        gridCols.push('database');
      }

      if (self.hasRole) {
        gridCols.push('role');
      }

      self.gridSchema = Backform.generateGridColumnsFromModel(self.field.get('node_info'), VariableModel.extend({
        keys: keys
      }), 'edit', gridCols, self.field.get('schema_node')); // Make sure - we do have the data for variables

      self.getVariables();
    },

    /*
     * Get the variable data for this node.
     */
    getVariables: function getVariables() {
      var self = this,
          url = this.field.get('url'),
          m = self.model;
      if (!this.field.get('version_compatible')) return;

      if (url && !m.isNew()) {
        var node = self.field.get('node'),
            node_data = self.field.get('node_data'),
            node_info = self.field.get('node_info'),
            full_url = node.generate_url.apply(node, [null, url, node_data, true, node_info]),
            data,
            isTracking = self.collection.trackChanges;

        if (isTracking) {
          self.collection.stopSession();
        }

        m.trigger('pgadmin-view:fetching', m, self.field);
        $.ajax({
          async: false,
          url: full_url
        }).done(function (res) {
          data = res.data;
        }).fail(function () {
          m.trigger('pgadmin-view:fetch:error', m, self.field);
        });
        m.trigger('pgadmin-view:fetched', m, self.field);

        if (data && _.isArray(data)) {
          self.collection.reset(data, {
            silent: true
          });
        }
        /*
           * Make sure - new data will be taken care by the session management
           */


        if (isTracking) {
          self.collection.startNewSession();
        }
      }
    },
    showGridControl: function showGridControl(data) {
      var self = this,
          titleTmpl = _.template(['<div class=\'subnode-header\'>', '<span class=\'control-label\'><%-label%></span>', '<button class=\'btn btn-sm-sq btn-primary-icon add fa fa-plus\' title=\'' + gettext('Add new row') + '\' <%=canAdd ? \'\' : \'disabled="disabled"\'%>><span class="sr-only">' + gettext('Add new row') + '</span></button>', '</div>'].join('\n')),
          $gridBody = $('<div class=\'pgadmin-control-group backgrid form-group col-12 object subnode\'></div>').append(titleTmpl(data)); // Clean up existing grid if any (in case of re-render)


      if (self.grid) {
        self.grid.remove();
      }

      var gridSchema = _.clone(this.gridSchema);

      _.each(gridSchema.columns, function (col) {
        if (col.name == 'value') {
          col.availVariables = self.availVariables;
        }
      }); // Insert Delete Cell into Grid


      if (data.disabled == false && data.canDelete) {
        gridSchema.columns.unshift({
          name: 'pg-backform-delete width_percent_5',
          label: '',
          cell: Backgrid.Extension.DeleteCell,
          editable: false,
          cell_priority: -1
        });
      } // Change format of each of the data
      // Because - data coming from the server is in string format


      self.collection.each(function (model) {
        var name = model.get('name'),
            val;

        if (name in self.availVariables) {
          switch (self.availVariables[name].vartype) {
            case 'real':
              val = parseFloat(model.get('value'));
              model.set('value', isNaN(val) ? undefined : val, {
                silent: true
              });
              break;

            case 'integer':
              val = parseInt(model.get('value'));
              model.set('value', isNaN(val) ? undefined : val, {
                silent: true
              });
              break;

            default:
              break;
          }
        }
      }); // Initialize a new Grid instance

      var grid = self.grid = new Backgrid.Grid({
        columns: gridSchema.columns,
        collection: self.collection,
        row: VariableRow,
        className: 'backgrid table presentation table-bordered table-noouter-border table-hover'
      });
      self.$grid = grid.render().$el;
      $gridBody.append(self.$grid); // Add button callback

      if (!(data.disabled || data.canAdd == false)) {
        $gridBody.find('button.add').first().on('click', function (e) {
          e.preventDefault();
          var canAddRow = _.isFunction(data.canAddRow) ? data.canAddRow.apply(self, [self.model]) : true;

          if (canAddRow) {
            var allowMultipleEmptyRows = !!self.field.get('allowMultipleEmptyRows'); // If allowMultipleEmptyRows is not set or is false then don't allow second new empty row.
            // There should be only one empty row.

            if (!allowMultipleEmptyRows && self.collection) {
              var isEmpty = false;
              self.collection.each(function (model) {
                var modelValues = [];

                _.each(model.attributes, function (val) {
                  modelValues.push(val);
                });

                if (!_.some(modelValues, _.identity)) {
                  isEmpty = true;
                }
              });

              if (isEmpty) {
                return false;
              }
            }

            $(grid.body.$el.find($('tr.new'))).removeClass('new');
            var m = new data.model(null, {
              silent: true,
              handler: self.collection,
              top: self.model.top || self.model,
              collection: self.collection,
              node_info: self.model.node_info
            });
            self.collection.add(m);
            var idx = self.collection.indexOf(m),
                newRow = grid.body.rows[idx].$el;
            newRow.addClass('new');
            $(newRow).pgMakeVisible('backform-tab');
            return false;
          }
        });
      } // Render node grid


      return $gridBody;
    },
    addVariable: function addVariable(ev) {
      ev.preventDefault();
      var self = this,
          m = new (self.field.get('model'))(self.headerData.toJSON(), {
        silent: true,
        top: self.collection.top,
        handler: self.collection
      }),
          coll = self.model.get(self.field.get('name'));
      coll.add(m);
      var idx = coll.indexOf(m); // idx may not be always > -1 because our UniqueColCollection may
      // remove 'm' if duplicate value found.

      if (idx > -1) {
        self.$grid.find('.new').removeClass('new');
        var newRow = self.grid.body.rows[idx].$el;
        newRow.addClass('new');
        $(newRow).pgMakeVisible('backform-tab');
      }

      return false;
    }
  });
  return VariableModel;
}).apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__),
		__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));

/***/ }),

/***/ 33883:
/***/ ((module, exports, __webpack_require__) => {

"use strict";
/* provided dependency */ var __webpack_provided_window_dot_jQuery = __webpack_require__(19755);
var __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

__webpack_require__(47941);

__webpack_require__(82526);

__webpack_require__(57327);

__webpack_require__(38880);

__webpack_require__(89554);

__webpack_require__(54747);

__webpack_require__(49337);

__webpack_require__(33321);

__webpack_require__(4129);

__webpack_require__(41539);

__webpack_require__(78783);

__webpack_require__(66992);

__webpack_require__(33948);

__webpack_require__(41817);

__webpack_require__(32165);

__webpack_require__(68309);

__webpack_require__(69826);

__webpack_require__(24812);

__webpack_require__(32564);

__webpack_require__(82772);

__webpack_require__(2707);

__webpack_require__(64765);

__webpack_require__(74916);

__webpack_require__(91058);

__webpack_require__(4723);

__webpack_require__(40561);

__webpack_require__(69070);

var _node_ajax = __webpack_require__(77077);

var _Notifier = _interopRequireWildcard(__webpack_require__(55958));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

!(__WEBPACK_AMD_DEFINE_ARRAY__ = [__webpack_require__(91669), __webpack_require__(28008), __webpack_require__, __webpack_require__(19755), __webpack_require__(81311), __webpack_require__(43734), __webpack_require__(55112), __webpack_require__(55455), __webpack_require__(20811), __webpack_require__(86620), __webpack_require__(85530), __webpack_require__(68363), __webpack_require__(87789), __webpack_require__(44092), __webpack_require__(1950), __webpack_require__(10426), __webpack_require__(52677), __webpack_require__(96481), __webpack_require__(35816), __webpack_require__(47337), __webpack_require__(1516), __webpack_require__(89804), __webpack_require__(3650), __webpack_require__(1506), __webpack_require__(50521), __webpack_require__(75035), __webpack_require__(88799), __webpack_require__(37944), __webpack_require__(66092), __webpack_require__(58688), __webpack_require__(66235), __webpack_require__(5547), __webpack_require__(31126), __webpack_require__(90338), __webpack_require__(40634), __webpack_require__(89769), __webpack_require__(77019), __webpack_require__(1969), __webpack_require__(9049)], __WEBPACK_AMD_DEFINE_RESULT__ = (function (gettext, url_for, require, $, _, Bootstrap, pgAdmin, Alertify, codemirror, checkNodeVisibility, toolBar, help, csrfToken, pgadminUtils, pgWindow, Kerberos, InitTree) {
  __webpack_provided_window_dot_jQuery = window.$ = $; // Some scripts do export their object in the window only.
  // Generally the one, which do no have AMD support.

  var wcDocker = window.wcDocker;
  $ = $ || __webpack_provided_window_dot_jQuery || window.$;
  var CodeMirror = codemirror["default"];
  var pgBrowser = pgAdmin.Browser = pgAdmin.Browser || {};
  var select_object_msg = gettext('Please select an object in the tree view.');
  csrfToken.setPGCSRFToken(pgAdmin.csrf_token_header, pgAdmin.csrf_token);
  Kerberos.validate_kerberos_ticket();
  var panelEvents = {};

  panelEvents[wcDocker.EVENT.VISIBILITY_CHANGED] = function () {
    if (this.isVisible()) {
      var obj = pgAdmin.Browser,
          i = obj.tree ? obj.tree.selected() : undefined,
          d = i ? obj.tree.itemData(i) : undefined;

      if (d && obj.Nodes[d._type].callbacks['selected'] && _.isFunction(obj.Nodes[d._type].callbacks['selected'])) {
        return obj.Nodes[d._type].callbacks['selected'].apply(obj.Nodes[d._type], [i, d, obj]);
      }
    }
  };

  var initializeBrowserTree = pgAdmin.Browser.initializeBrowserTree = function (b) {
    InitTree.initBrowserTree(b).then(function () {
      b.tree.registerDraggableType({
        'collation domain domain_constraints fts_configuration fts_dictionary fts_parser fts_template synonym table partition type sequence package view mview foreign_table edbvar': function collationDomainDomain_constraintsFts_configurationFts_dictionaryFts_parserFts_templateSynonymTablePartitionTypeSequencePackageViewMviewForeign_tableEdbvar(data, item, treeNodeInfo) {
          var text = pgadminUtils.fully_qualify(b, data, item);
          return {
            text: text,
            objUrl: _node_ajax.generateNodeUrl.call(pgBrowser.Nodes[data._type], treeNodeInfo, 'properties', data, true),
            nodeType: data._type,
            cur: {
              from: text.length,
              to: text.length
            }
          };
        },
        'schema column database cast event_trigger extension language foreign_data_wrapper foreign_server user_mapping compound_trigger index index_constraint primary_key unique_constraint check_constraint exclusion_constraint foreign_key rule': function schemaColumnDatabaseCastEvent_triggerExtensionLanguageForeign_data_wrapperForeign_serverUser_mappingCompound_triggerIndexIndex_constraintPrimary_keyUnique_constraintCheck_constraintExclusion_constraintForeign_keyRule(data) {
          return pgadminUtils.quote_ident(data._label);
        },
        'trigger trigger_function': function triggerTrigger_function(data) {
          return data._label;
        },
        'edbfunc function edbproc procedure': function edbfuncFunctionEdbprocProcedure(data, item) {
          var newData = _objectSpread({}, data),
              parsedFunc = null,
              dropVal = '',
              curPos = {
            from: 0,
            to: 0
          };

          parsedFunc = pgadminUtils.parseFuncParams(newData._label);
          newData._label = parsedFunc.func_name;
          dropVal = pgadminUtils.fully_qualify(b, newData, item);

          if (parsedFunc.params.length > 0) {
            dropVal = dropVal + '(';
            curPos.from = dropVal.length;
            dropVal = dropVal + parsedFunc.params[0][0];
            curPos.to = dropVal.length;

            for (var i = 1; i < parsedFunc.params.length; i++) {
              dropVal = dropVal + ', ' + parsedFunc.params[i][0];
            }

            dropVal = dropVal + ')';
          } else {
            dropVal = dropVal + '()';
            curPos.from = curPos.to = dropVal.length + 1;
          }

          return {
            text: dropVal,
            cur: curPos
          };
        }
      });
    }, function () {
      console.warn('Tree Load Error');
    });
  }; // Extend the browser class attributes


  _.extend(pgAdmin.Browser, {
    // The base url for browser
    URL: url_for('browser.index'),
    // We do have docker of type wcDocker to take care of different
    // containers. (i.e. panels, tabs, frames, etc.)
    docker: null,
    // Reversed Engineer query for the selected database node object goes
    // here
    editor: null,
    // Left hand browser tree
    tree: null,
    // list of script to be loaded, when a certain type of node is loaded
    // It will be used to register extensions, tools, child node scripts,
    // etc.
    scripts: {},
    // Standard Widths and Height for dialogs in px
    stdW: {
      sm: 500,
      md: 700,
      lg: 900,
      "default": 500,
      // If you change above values then make sure to update
      // calc method logic
      calc: function calc(passed_width) {
        var iw = window.innerWidth;

        if (iw > passed_width) {
          return passed_width;
        } else {
          if (iw > pgAdmin.Browser.stdW.lg) return pgAdmin.Browser.stdW.lg;else if (iw > pgAdmin.Browser.stdW.md) return pgAdmin.Browser.stdW.md;else if (iw > pgAdmin.Browser.stdW.sm) return pgAdmin.Browser.stdW.sm;else // if avilable screen resolution is still
            // less then return the width value as it
            return iw;
        }
      }
    },
    stdH: {
      sm: 200,
      md: 400,
      lg: 550,
      "default": 550,
      // If you change above values then make sure to update
      // calc method logic
      calc: function calc(passed_height) {
        // We are excluding sm as it is too small for dialog
        var ih = window.innerHeight;

        if (ih > passed_height) {
          return passed_height;
        } else {
          if (ih > pgAdmin.Browser.stdH.lg) return pgAdmin.Browser.stdH.lg;else if (ih > pgAdmin.Browser.stdH.md) return pgAdmin.Browser.stdH.md;else // if avilable screen resolution is still
            // less then return the height value as it
            return ih;
        }
      }
    },
    // Default panels
    panels: {
      // Panel to keep the left hand browser tree
      'browser': new pgAdmin.Browser.Panel({
        name: 'browser',
        title: gettext('Browser'),
        showTitle: true,
        isCloseable: false,
        isPrivate: true,
        icon: '',
        limit: 1,
        content: '<div id="tree" class="aciTree"></div>',
        onCreate: function onCreate(panel, $container) {
          toolBar.initializeToolbar(panel, wcDocker);
          $container.addClass('pg-no-overflow');
        }
      }),
      // Properties of the object node
      'properties': new pgAdmin.Browser.Panel({
        name: 'properties',
        title: gettext('Properties'),
        icon: '',
        width: 500,
        isCloseable: false,
        isPrivate: true,
        elContainer: true,
        limit: 1,
        content: '<div class="obj_properties container-fluid h-100"><div role="status" class="pg-panel-message">' + select_object_msg + '</div></div>',
        events: panelEvents,
        onCreate: function onCreate(myPanel, $container) {
          $container.addClass('pg-no-overflow');
        }
      }),
      // Statistics of the object
      'statistics': new pgAdmin.Browser.Panel({
        name: 'statistics',
        title: gettext('Statistics'),
        icon: '',
        width: 500,
        isCloseable: true,
        isPrivate: false,
        limit: 1,
        canHide: true,
        content: '<div class="negative-space p-2"><div role="status" class="pg-panel-message pg-panel-statistics-message">' + select_object_msg + '</div><div class="pg-panel-statistics-container d-none"></div></div>',
        events: panelEvents
      }),
      // Reversed engineered SQL for the object
      'sql': new pgAdmin.Browser.Panel({
        name: 'sql',
        title: gettext('SQL'),
        icon: '',
        width: 500,
        isCloseable: false,
        isPrivate: true,
        limit: 1,
        content: '<label for="sql-textarea" class="sr-only">' + gettext('SQL Code') + '</label><div class="sql_textarea"><textarea id="sql-textarea" name="sql-textarea" title="' + gettext('SQL Code') + '"></textarea></div>'
      }),
      // Dependencies of the object
      'dependencies': new pgAdmin.Browser.Panel({
        name: 'dependencies',
        title: gettext('Dependencies'),
        icon: '',
        width: 500,
        isCloseable: true,
        isPrivate: false,
        canHide: true,
        limit: 1,
        content: '<div class="negative-space p-2"><div role="status" class="pg-panel-message pg-panel-depends-message">' + select_object_msg + '</div><div class="pg-panel-dependencies-container d-none"></div></div>',
        events: panelEvents
      }),
      // Dependents of the object
      'dependents': new pgAdmin.Browser.Panel({
        name: 'dependents',
        title: gettext('Dependents'),
        icon: '',
        width: 500,
        isCloseable: true,
        isPrivate: false,
        limit: 1,
        canHide: true,
        content: '<div class="negative-space p-2"><div role="status" class="pg-panel-message pg-panel-depends-message">' + select_object_msg + '</div><div class="pg-panel-dependents-container d-none"></div></div>',
        events: panelEvents
      })
    },
    // We also support showing dashboards, HTML file, external URL
    frames: {},

    /* Menus */
    // pgAdmin.Browser.MenuItem.add_menus(...) will register all the menus
    // in this container
    menus: {
      // All context menu goes here under certain menu types.
      // i.e. context: {'server': [...], 'server-group': [...]}
      context: {},
      // File menus
      file: {},
      // Edit menus
      edit: {},
      // Object menus
      object: {},
      // Management menus
      management: {},
      // Tools menus
      tools: {},
      // Help menus
      help: {}
    },
    add_panels: function add_panels() {
      /* Add hooked-in panels by extensions */
      var panels = JSON.parse(pgBrowser.panels_items);

      _.each(panels, function (panel) {
        if (panel.isIframe) {
          pgBrowser.frames[panel.name] = new pgBrowser.Frame({
            name: panel.name,
            title: panel.title,
            icon: panel.icon,
            width: panel.width,
            height: panel.height,
            showTitle: panel.showTitle,
            isCloseable: panel.isCloseable,
            isPrivate: panel.isPrivate,
            url: panel.content
          });
        } else {
          pgBrowser.panels[panel.name] = new pgBrowser.Panel({
            name: panel.name,
            title: panel.title,
            icon: panel.icon,
            width: panel.width,
            height: panel.height,
            showTitle: panel.showTitle,
            isCloseable: panel.isCloseable,
            isPrivate: panel.isPrivate,
            limit: panel.limit ? panel.limit : null,
            content: panel.content ? panel.content : '',
            events: panel.events ? panel.events : '',
            canHide: panel.canHide ? panel.canHide : ''
          });
        }
      });
    },
    menu_categories: {
      /* name, label (pair) */
      'create': {
        label: gettext('Create'),
        priority: 1,

        /* separator above this menu */
        above: false,
        below: true,

        /* icon: 'fa fa-magic', */
        single: true
      }
    },
    // A callback to load/fetch a script when a certain node is loaded
    register_script: function register_script(n, m, p) {
      var scripts = this.scripts;
      scripts[n] = _.isArray(scripts[n]) ? scripts[n] : [];
      scripts[n].push({
        'name': m,
        'path': p,
        loaded: false
      });
    },
    masterpass_callback_queue: [],
    // Enable/disable menu options
    enable_disable_menus: function enable_disable_menus(item) {
      // Mechanism to enable/disable menus depending on the condition.
      var obj = this,
          // menu navigation bar
      navbar = $('#navbar-menu > ul').first(),
          // Drop down menu for objects
      $obj_mnu = navbar.find('li#mnu_obj .dropdown-menu').first(),
          // data for current selected object
      d = item ? obj.tree.itemData(item) : undefined,
          update_menuitem = function update_menuitem(m) {
        if (m instanceof pgAdmin.Browser.MenuItem) {
          m.update(d, item);
        } else {
          for (var key in m) {
            update_menuitem(m[key]);
          }
        }
      };

      toolBar.enable(gettext('View Data'), false);
      toolBar.enable(gettext('Filtered Rows'), false); // All menus from the object menus (except the create drop-down
      // menu) needs to be removed.

      $obj_mnu.empty(); // All menus (except for the object menus) are already present.
      // They will just require to check, wheather they are
      // enabled/disabled.

      _.each([{
        m: 'file',
        id: '#mnu_file'
      }, {
        m: 'management',
        id: '#mnu_management'
      }, {
        m: 'tools',
        id: '#mnu_tools'
      }, {
        m: 'help',
        id: '#mnu_help'
      }], function (o) {
        _.each(obj.menus[o.m], function (m) {
          update_menuitem(m);
        });
      }); // Create the object menu dynamically


      if (item && obj.menus['object'] && obj.menus['object'][d._type]) {
        pgAdmin.Browser.MenuCreator(obj.Nodes, $obj_mnu, obj.menus['object'][d._type], obj.menu_categories, d, item);
      } else {
        // Create a dummy 'no object seleted' menu
        var create_submenu = pgAdmin.Browser.MenuGroup(obj.menu_categories['create'], [{
          $el: $('<li><a class="dropdown-item disabled" href="#" role="menuitem">' + gettext('No object selected') + '</a></li>'),
          priority: 1,
          category: 'create',
          update: function update() {}
        }], false);
        $obj_mnu.append(create_submenu.$el);
      }
    },
    init: function init() {
      var obj = this;

      if (obj.initialized) {
        return;
      }

      obj.initialized = true; // Cache preferences

      obj.cache_preferences();
      obj.add_panels(); // Initialize the Docker

      obj.docker = new wcDocker('#dockerContainer', {
        allowContextMenu: true,
        allowCollapse: false,
        loadingClass: 'pg-sp-icon',
        themePath: url_for('static', {
          'filename': 'css'
        }),
        theme: 'webcabin.overrides.css'
      });

      if (obj.docker) {
        // Initialize all the panels
        _.each(obj.panels, function (panel, name) {
          obj.panels[name].load(obj.docker);
        }); // Initialize all the frames


        _.each(obj.frames, function (frame, name) {
          obj.frames[name].load(obj.docker);
        }); // Stored layout in database from the previous session


        var layout = pgBrowser.utils.layout;
        obj.restore_layout(obj.docker, layout, obj.buildDefaultLayout.bind(obj), true);
        obj.docker.on(wcDocker.EVENT.LAYOUT_CHANGED, function () {
          obj.save_current_layout('Browser/Layout', obj.docker);
        });
      }

      initializeBrowserTree(obj);
      (0, _Notifier.initializeModalProvider)();
      (0, _Notifier.initializeNotifier)(); // Syntax highlight the SQL Pane

      if (document.getElementById('sql-textarea')) {
        obj.editor = CodeMirror.fromTextArea(document.getElementById('sql-textarea'), {
          lineNumbers: true,
          mode: 'text/x-pgsql',
          readOnly: true,
          extraKeys: pgAdmin.Browser.editor_shortcut_keys,
          screenReaderLabel: gettext('SQL')
        });
      }
      /* Cache may take time to load for the first time
       * Reflect the changes once cache is available
       */


      var cacheIntervalId = setInterval(function () {
        var sqlEditPreferences = obj.get_preferences_for_module('sqleditor');

        if (sqlEditPreferences) {
          clearInterval(cacheIntervalId);
          obj.reflectPreferences('sqleditor');
        }
      }, 500);
      /* Check for sql editor preference changes */

      obj.onPreferencesChange('sqleditor', function () {
        obj.reflectPreferences('sqleditor');
      });
      setTimeout(function () {
        var _obj$editor, _obj$editor2;

        obj === null || obj === void 0 ? void 0 : (_obj$editor = obj.editor) === null || _obj$editor === void 0 ? void 0 : _obj$editor.setValue('-- ' + select_object_msg);
        obj === null || obj === void 0 ? void 0 : (_obj$editor2 = obj.editor) === null || _obj$editor2 === void 0 ? void 0 : _obj$editor2.refresh();
      }, 10); // Build the treeview context menu

      $('#tree').contextMenu({
        selector: '.file-entry',
        autoHide: false,
        build: function build(element) {
          var item = obj.tree.itemFrom(element),
              d = obj.tree.itemData(item),
              menus = obj.menus['context'][d._type],
              $div = $('<div></div>'),
              context_menu = {};
          if (item) obj.tree.select(item);
          pgAdmin.Browser.MenuCreator(obj.Nodes, $div, menus, obj.menu_categories, d, item, context_menu);
          return {
            autoHide: false,
            items: context_menu
          };
        },
        events: {
          hide: function hide() {
            // Return focus to the tree
            obj.keyboardNavigation.bindLeftTree();
          }
        }
      }); // Register scripts and add menus

      pgBrowser.utils.registerScripts(this);
      pgBrowser.utils.addMenus(obj);
      var headers = {};
      headers[pgAdmin.csrf_token_header] = pgAdmin.csrf_token; // Ping the server every 5 minutes

      setInterval(function () {
        $.ajax({
          url: url_for('misc.cleanup'),
          type: 'POST',
          headers: headers
        }).done(function () {}).fail(function () {});
      }, 300000);
      obj.set_master_password('');
      obj.check_corrupted_db_file();
      obj.Events.on('pgadmin:browser:tree:add', obj.onAddTreeNode, obj);
      obj.Events.on('pgadmin:browser:tree:update', obj.onUpdateTreeNode, obj);
      obj.Events.on('pgadmin:browser:tree:refresh', obj.onRefreshTreeNodeReact, obj);
      obj.Events.on('pgadmin-browser:tree:loadfail', obj.onLoadFailNode, obj);
      obj.Events.on('pgadmin-browser:panel-browser:' + wcDocker.EVENT.RESIZE_ENDED, obj.onResizeEnded, obj);
      obj.bind_beforeunload();
      /* User UI activity */

      obj.log_activity();
      /* The starting point */

      obj.register_to_activity_listener(document);
      obj.start_inactivity_timeout_daemon();
    },
    onResizeEnded: function onResizeEnded() {
      if (this.tree) this.tree.resizeTree();
    },
    check_corrupted_db_file: function check_corrupted_db_file() {
      $.ajax({
        url: url_for('browser.check_corrupted_db_file'),
        type: 'GET',
        dataType: 'json',
        contentType: 'application/json'
      }).done(function (res) {
        if (res.data.length > 0) {
          _Notifier["default"].alert('Warning', 'pgAdmin detected unrecoverable corruption in it\'s SQLite configuration database. ' + 'The database has been backed up and recreated with default settings. ' + 'It may be possible to recover data such as query history manually from ' + 'the original/corrupt file using a tool such as DB Browser for SQLite if desired.' + '<br><br>Original file: ' + res.data + '<br>Replacement file: ' + res.data.substring(0, res.data.length - 14), function () {});
        }
      }).fail(function (xhr, status, error) {
        _Notifier["default"].alert(error);
      });
    },
    init_master_password: function init_master_password() {
      var self = this; // Master password dialog

      if (!Alertify.dlgMasterPass) {
        Alertify.dialog('dlgMasterPass', function factory() {
          return {
            main: function main(title, message, reset) {
              this.set('title', title);
              this.message = message;
              this.reset = reset;
            },
            build: function build() {
              Alertify.pgDialogBuild.apply(this);
            },
            setup: function setup() {
              return {
                buttons: [{
                  text: '',
                  className: 'btn btn-primary-icon pull-left fa fa-question pg-alertify-icon-button',
                  attrs: {
                    name: 'dialog_help',
                    type: 'button',
                    label: gettext('Master password'),
                    url: url_for('help.static', {
                      'filename': 'master_password.html'
                    })
                  }
                }, {
                  text: gettext('Reset Master Password'),
                  className: 'btn btn-secondary fa fa-trash-alt pg-alertify-button pull-left'
                }, {
                  text: gettext('Cancel'),
                  className: 'btn btn-secondary fa fa-times pg-alertify-button',
                  key: 27
                }, {
                  text: gettext('OK'),
                  key: 13,
                  className: 'btn btn-primary fa fa-check pg-alertify-button'
                }],
                focus: {
                  element: '#password',
                  select: true
                },
                options: {
                  modal: true,
                  resizable: false,
                  maximizable: false,
                  pinnable: false
                }
              };
            },
            prepare: function prepare() {
              var _self = this;

              _self.setContent(_self.message);
              /* Reset button hide */


              if (!_self.reset) {
                $(_self.__internal.buttons[1].element).addClass('d-none');
              } else {
                $(_self.__internal.buttons[1].element).removeClass('d-none');
              }
            },
            callback: function callback(event) {
              var parentDialog = this;

              if (event.index == 3) {
                /* OK Button */
                self.set_master_password($('#frmMasterPassword #password').val(), true, parentDialog.set_callback);
              } else if (event.index == 2) {
                /* Cancel button */
                self.masterpass_callback_queue = [];
              } else if (event.index == 1) {
                /* Reset Button */
                event.cancel = true;

                _Notifier["default"].confirm(gettext('Reset Master Password'), gettext('This will remove all the saved passwords. This will also remove established connections to ' + 'the server and you may need to reconnect again. Do you wish to continue?'), function () {
                  /* If user clicks Yes */
                  self.reset_master_password();
                  parentDialog.close();
                  return true;
                }, function () {
                  /* If user clicks No */
                  return true;
                });
              } else if (event.index == 0) {
                /* help Button */
                event.cancel = true;
                self.showHelp(event.button.element.name, event.button.element.getAttribute('url'), null, null);
                return;
              }
            }
          };
        });
      }
    },
    check_master_password: function check_master_password(on_resp_callback) {
      $.ajax({
        url: url_for('browser.check_master_password'),
        type: 'GET',
        contentType: 'application/json'
      }).done(function (res) {
        if (on_resp_callback) {
          if (res.data) {
            on_resp_callback(true);
          } else {
            on_resp_callback(false);
          }
        }
      }).fail(function (xhr, status, error) {
        _Notifier["default"].pgRespErrorNotify(xhr, error);
      });
    },
    reset_master_password: function reset_master_password() {
      var self = this;
      $.ajax({
        url: url_for('browser.set_master_password'),
        type: 'DELETE',
        contentType: 'application/json'
      }).done(function (res) {
        if (!res.data) {
          self.set_master_password('');
        }
      }).fail(function (xhr, status, error) {
        _Notifier["default"].pgRespErrorNotify(xhr, error);
      });
    },
    set_master_password: function set_master_password() {
      var password = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
      var button_click = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      var set_callback = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : function () {};
      var data = null,
          self = this;
      data = JSON.stringify({
        'password': password,
        'button_click': button_click
      });
      self.masterpass_callback_queue.push(set_callback);
      $.ajax({
        url: url_for('browser.set_master_password'),
        type: 'POST',
        data: data,
        dataType: 'json',
        contentType: 'application/json'
      }).done(function (res) {
        if (!res.data.present) {
          self.init_master_password();
          Alertify.dlgMasterPass(res.data.title, res.data.content, res.data.reset);
        } else {
          setTimeout(function () {
            while (self.masterpass_callback_queue.length > 0) {
              var callback = self.masterpass_callback_queue.shift();
              callback();
            }
          }, 500);
        }
      }).fail(function (xhr, status, error) {
        _Notifier["default"].pgRespErrorNotify(xhr, error);
      });
    },
    bind_beforeunload: function bind_beforeunload() {
      $(window).on('beforeunload', function (e) {
        /* Can open you in new tab */
        var openerBrowser = pgWindow["default"].pgAdmin.Browser;
        var tree_save_interval = pgBrowser.get_preference('browser', 'browser_tree_state_save_interval'),
            confirm_on_refresh_close = openerBrowser.get_preference('browser', 'confirm_on_refresh_close');
        if (!_.isUndefined(tree_save_interval) && tree_save_interval.value !== -1) pgAdmin.Browser.browserTreeState.save_state();

        if (!_.isUndefined(confirm_on_refresh_close) && confirm_on_refresh_close.value) {
          /* This message will not be displayed in Chrome, Firefox, Safari as they have disabled it*/
          var msg = gettext('Are you sure you want to close the %s browser?', pgBrowser.utils.app_name);
          e.originalEvent.returnValue = msg;
          return msg;
        }
      });
    },
    add_menu_category: function add_menu_category(id, label, priority, icon, above_separator, below_separator, single) {
      this.menu_categories[id] = {
        label: label,
        priority: priority,
        icon: icon,
        above: above_separator === true,
        below: below_separator === true,
        single: single
      };
    },
    // Add menus of module/extension at appropriate menu
    add_menus: function add_menus(menus) {
      var self = this,
          pgMenu = this.menus,
          MenuItem = pgAdmin.Browser.MenuItem;

      _.each(menus, function (m) {
        _.each(m.applies, function (a) {
          /* We do support menu type only from this list */
          if ($.inArray(a, ['context', 'file', 'edit', 'object', 'management', 'tools', 'help']) >= 0) {
            var _menus; // If current node is not visible in browser tree
            // then return from here


            if (!checkNodeVisibility(self, m.node)) {
              return;
            } else if (_.has(m, 'module') && !_.isUndefined(m.module)) {
              // If module to which this menu applies is not visible in
              // browser tree then also we do not display menu
              if (!checkNodeVisibility(self, m.module.type)) {
                return;
              }
            }

            pgMenu[a] = pgMenu[a] || {};

            if (_.isString(m.node)) {
              _menus = pgMenu[a][m.node] = pgMenu[a][m.node] || {};
            } else if (_.isString(m.category)) {
              _menus = pgMenu[a][m.category] = pgMenu[a][m.category] || {};
            } else {
              _menus = pgMenu[a];
            }

            var get_menuitem_obj = function get_menuitem_obj(_m) {
              return new MenuItem({
                name: _m.name,
                label: _m.label,
                module: _m.module,
                category: _m.category,
                callback: _m.callback,
                priority: _m.priority,
                data: _m.data,
                url: _m.url || '#',
                target: _m.target,
                icon: _m.icon,
                enable: _m.enable == '' ? true : _.isString(_m.enable) && _m.enable.toLowerCase() == 'false' ? false : _m.enable,
                node: _m.node,
                checked: _m.checked,
                below: _m.below
              });
            };

            if (!_.has(_menus, m.name)) {
              _menus[m.name] = get_menuitem_obj(m);

              if (m.menu_items) {
                var sub_menu_items = [];

                for (var i = 0; i < m.menu_items.length; i++) {
                  sub_menu_items.push(get_menuitem_obj(m.menu_items[i]));
                }

                _menus[m.name]['menu_items'] = sub_menu_items;
              }
            }
          } else {
            console.warn('Developer warning: Category \'' + a + '\' is not supported!\nSupported categories are: context, file, edit, object, tools, management, help');
          }
        });
      });
    },
    // Create the menus
    create_menus: function create_menus() {
      /* Create menus */
      var navbar = $('#navbar-menu > ul').first();
      var obj = this;

      _.each([{
        menu: 'file',
        id: '#mnu_file'
      }, {
        menu: 'management',
        id: '#mnu_management'
      }, {
        menu: 'tools',
        id: '#mnu_tools'
      }, {
        menu: 'help',
        id: '#mnu_help'
      }], function (o) {
        var $mnu = navbar.children(o.id).first(),
            $dropdown = $mnu.children('.dropdown-menu').first();
        $dropdown.empty();

        if (o.menu == 'help') {
          $dropdown.append('<div id="quick-search-component"></div>');
          $dropdown.append('<div class="menu-groups"><span class="fa fa-list" style="font-weight:900 !important;"></span> &nbsp;' + gettext('SUGGESTED SITES') + '</div>');
        }

        if (pgAdmin.Browser.MenuCreator(obj.Nodes, $dropdown, obj.menus[o.menu], obj.menu_categories)) {
          $mnu.removeClass('d-none');
        }
      });

      navbar.children('#mnu_obj').removeClass('d-none');
      obj.enable_disable_menus();
    },
    // General function to handle callbacks for object or dialog help.
    showHelp: function showHelp(type, url, node, item) {
      if (type == 'object_help') {
        // Construct the URL
        var server = pgBrowser.tree.getTreeNodeHierarchy(item).server;
        var baseUrl = pgBrowser.utils.pg_help_path;
        var fullUrl = help.getHelpUrl(baseUrl, url, server.version);
        window.open(fullUrl, 'postgres_help');
      } else if (type == 'dialog_help') {
        if (pgWindow && pgWindow["default"]) {
          pgWindow["default"].open(url, 'pgadmin_help');
        } else {
          window.open(url, 'pgadmin_help');
        }
      }

      $('#live-search-field').focus();
    },
    _findTreeChildNode: function _findTreeChildNode(_i, _d, _o) {
      var loaded = _o.t.wasLoad(_i),
          onLoad = function onLoad() {
        var items = _o.t.children(_i),
            i,
            d,
            n,
            idx = 0,
            size = items.length;

        for (; idx < size; idx++) {
          i = items[idx];
          d = _o.t.itemData(i);

          if (d._type === _d._type) {
            if (!_o.hasId || d._id == _d._id) {
              _o.i = i;
              _o.d = _d;

              _o.pathOfTreeItems.push({
                coll: false,
                item: i,
                d: _d
              });

              _o.success();

              return;
            }
          } else {
            n = _o.b.Nodes[d._type]; // Are we looking at the collection node for the given node?

            if (n && n.collection_node && d.nodes && _.indexOf(d.nodes, _d._type) != -1) {
              _o.i = i;
              _o.d = null;

              _o.pathOfTreeItems.push({
                coll: true,
                item: i,
                d: d
              }); // Set load to false when the current collection node's inode is false


              if (!_o.t.isInode(i)) {
                _o.load = false;
              }

              _o.b._findTreeChildNode(i, _d, _o);

              return;
            }
          }
        }

        _o.notFound && typeof _o.notFound == 'function' && _o.notFound(_d);
      };

      if (!loaded && _o.load) {
        _o.t.open(_i).then(function () {
          onLoad();
        }, function () {
          var fail = _o && _o.o && _o.o.fail;

          if (fail && typeof fail == 'function') {
            fail.apply(_o.t, []);
          }
        });
      } else if (loaded) {
        onLoad();
      } else {
        _o.notFound && typeof _o.notFound == 'function' && _o.notFound(_d);
      }

      return;
    },
    onAddTreeNode: function onAddTreeNode(_data, _hierarchy, _opts) {
      var ctx = {
        b: this,
        // Browser
        d: null,
        // current parent
        hasId: true,
        i: null,
        // current item
        p: _.toArray(_hierarchy || {}).sort(function (a, b) {
          return a.priority === b.priority ? 0 : a.priority < b.priority ? -1 : 1;
        }),
        // path of the parent
        pathOfTreeItems: [],
        // path Item
        t: this.tree,
        // Tree Api
        o: _opts
      },
          traversePath = function () {
        var _ctx = this,
            data;

        _ctx.success = traversePath;

        if (_ctx.p.length) {
          data = _ctx.p.shift(); // This is the parent node.
          // Replace the parent-id of the data, which could be different
          // from the given hierarchy.

          if (!_ctx.p.length) {
            data._id = _data._pid;
            _ctx.success = addItemNode;
          }

          _ctx.b._findTreeChildNode(_ctx.i, data, _ctx); // if parent node is null


          if (!_data._pid) {
            addItemNode.apply(_ctx, arguments);
          }
        }

        return true;
      }.bind(ctx),
          addItemNode = function () {
        var _this = this;

        // Append the new data in the tree under the current item.
        // We may need to pass it to proper collection node.
        var _ctx = this,
            first = (_ctx.i || this.t.wasLoad(_ctx.i)) && this.t.first(_ctx.i),
            findChildNode = function (success, notFound) {
          var __ctx = this;

          __ctx.success = success;
          __ctx.notFound = notFound;

          __ctx.b._findTreeChildNode(__ctx.i, _data, __ctx);
        }.bind(_ctx),
            selectNode = function () {
          this.t.openPath(this.i);
          this.t.select(this.i);

          if (_ctx.o && _ctx.o.success && typeof _ctx.o.success == 'function') {
            _ctx.o.success.apply(_ctx.t, [_ctx.i, _data]);
          }
        }.bind(_ctx),
            addNode = function () {
          var _arguments = arguments;

          var __ctx = this,
              items = __ctx.t.children(__ctx.i),
              s = 0,
              e = items.length - 1,
              i,
              linearSearch = function linearSearch() {
            while (e >= s) {
              i = items[s];

              var d = __ctx.t.itemData(i);

              if (d._type === 'column') {
                if (pgAdmin.numeric_comparator(d._id, _data._id) == 1) return true;
              } else {
                if (pgAdmin.natural_sort(d._label, _data._label) == 1) return true;
              }

              s++;
            } //when the current element is greater than the end element


            if (e != items.length - 1) {
              i = items[e + 1];
              return true;
            }

            i = null;
            return false;
          },
              binarySearch = function binarySearch() {
            var d, m; // Binary search only outperforms Linear search for n > 44.
            // Reference:
            // https://en.wikipedia.org/wiki/Binary_search_algorithm#cite_note-30
            //
            // We will try until it's half.

            while (e - s > 22) {
              i = items[s];
              d = __ctx.t.itemData(i);

              if (d._type === 'column') {
                if (pgAdmin.numeric_comparator(d._id, _data._id) != -1) return true;
              } else {
                if (pgAdmin.natural_sort(d._label, _data._label) != -1) return true;
              }

              i = items[e];
              d = __ctx.t.itemData(i);
              var result = void 0;

              if (d._type === 'column') {
                result = pgAdmin.numeric_comparator(d._id, _data._id);
              } else {
                result = pgAdmin.natural_sort(d._label, _data._label);
              }

              if (result != 1) {
                if (e != items.length - 1) {
                  i = items[e + 1];
                  return true;
                }

                i = null;
                return false;
              }

              m = s + Math.round((e - s) / 2);
              i = items[m];
              d = __ctx.t.itemData(i);

              if (d._type === 'column') {
                result = pgAdmin.numeric_comparator(d._id, _data._id);
              } else {
                result = pgAdmin.natural_sort(d._label, _data._label);
              } //result will never become 0 because of remove operation
              //which happens with updateTreeNode


              if (result == 0) return true;

              if (result == -1) {
                s = m + 1;
                e--;
              } else {
                s++;
                e = m - 1;
              }
            }

            return linearSearch();
          };

          if (binarySearch()) {
            __ctx.t.before(i, _data).then(function (_item) {
              if (__ctx.o && __ctx.o.success && typeof __ctx.o.success == 'function') {
                __ctx.o.success.apply(__ctx.t, [i, _data]);
              } else {
                __ctx.t.select(_item);
              }
            }, function () {
              console.warn('Failed to add before...', _arguments);

              if (__ctx.o && __ctx.o.fail && typeof __ctx.o.fail == 'function') {
                __ctx.o.fail.apply(__ctx.t, [i, _data]);
              }
            });
          } else {
            var _append = function () {
              var _arguments2 = arguments;

              var ___ctx = this,
                  _parent_data = ___ctx.t.itemData(___ctx.i);

              ___ctx.t.append(___ctx.i, _data).then(function (_i) {
                // Open the item path only if its parent is loaded
                // or parent type is same as nodes
                if (___ctx.t.wasLoad(___ctx.i) && _parent_data && _parent_data._type.search(_data._type) > -1) {
                  ___ctx.t.open(___ctx.i);

                  ___ctx.t.select(_i);
                } else {
                  if (_parent_data) {
                    // Unload the parent node so that we'll get
                    // latest data when we try to expand it
                    ___ctx.t.unload(___ctx.i).then(function () {
                      ___ctx.t.open(___ctx.i);
                    });
                  }
                }

                if (___ctx.o && ___ctx.o.success && typeof ___ctx.o.success == 'function') {
                  ___ctx.o.success.apply(___ctx.t, [_i, _data]);
                }
              }, function () {
                console.warn('Failed to append...', _arguments2);

                if (___ctx.o && ___ctx.o.fail && typeof ___ctx.o.fail == 'function') {
                  ___ctx.o.fail.apply(___ctx.t, [___ctx.i, _data]);
                }
              });
            }.bind(__ctx);

            if (__ctx.i && !__ctx.t.isInode(__ctx.i)) {
              __ctx.t.setInode(__ctx.i).then(function () {
                _append();
              });
            } else {
              // Handle case for node without parent i.e. server-group
              // or if parent node's inode is true.
              _append();
            }
          }
        }.bind(_ctx); // Parent node do not have any children, let me unload it.


        if (!first && _ctx.t.wasLoad(_ctx.i)) {
          _ctx.t.unload(_ctx.i).then(function () {
            findChildNode(selectNode, function () {
              var o = this && this.o;

              if (o && o.fail && typeof o.fail == 'function') {
                o.fail.apply(this.t, [this.i, _data]);
              }
            }.bind(_this));
          }, function () {
            var o = _this && _this.o;

            if (o && o.fail && typeof o.fail == 'function') {
              o.fail.apply(_this.t, [_this.i, _data]);
            }
          });

          return;
        } // We can find the collection node using _findTreeChildNode
        // indirectly.


        findChildNode(selectNode, addNode);
      }.bind(ctx);

      if (!ctx.t.wasInit() || !_data) {
        return;
      }

      _data._label = _data.label;
      _data.label = _.escape(_data.label);
      traversePath();
    },
    onUpdateTreeNode: function onUpdateTreeNode(_old, _new, _hierarchy, _opts) {
      var ctx = {
        b: this,
        // Browser
        d: null,
        // current parent
        i: null,
        // current item
        hasId: true,
        p: _.toArray(_hierarchy || {}).sort(function (a, b) {
          return a.priority === b.priority ? 0 : a.priority < b.priority ? -1 : 1;
        }),
        // path of the old object
        pathOfTreeItems: [],
        // path items
        t: this.tree,
        // Tree Api
        o: _opts,
        load: true,
        old: _old,
        "new": _new,
        op: null
      },
          errorOut = function () {
        var fail = this.o && this.o.fail;

        if (fail && typeof fail == 'function') {
          fail.apply(this.t, [this.i, _new, _old]);
        }
      }.bind(ctx),
          deleteNode = function () {
        var _arguments3 = arguments;

        var self = this,
            pathOfTreeItems = this.pathOfTreeItems,
            findParent = function () {
          if (pathOfTreeItems.length) {
            pathOfTreeItems.pop();
            var length = pathOfTreeItems.length;
            this.i = length && pathOfTreeItems[length - 1].item || null;
            this.d = length && pathOfTreeItems[length - 1].d || null; // It is a collection item, let's find the node item

            if (length && pathOfTreeItems[length - 1].coll) {
              pathOfTreeItems.pop();
              length = pathOfTreeItems.length;
              this.i = length && pathOfTreeItems[length - 1].item || null;
              this.d = length && pathOfTreeItems[length - 1].d || null;
            }
          } else {
            this.i = null;
            this.d = null;
          }
        }.bind(this);

        var _item_parent = this.i && this.t.hasParent(this.i) && this.t.parent(this.i) || null,
            _item_grand_parent = _item_parent ? this.t.hasParent(_item_parent) && this.t.parent(_item_parent) && _item_parent.root != this.t.parent(_item_parent) : null; // Remove the current node first.


        if (this.i && this.d && this.old._id == this.d._id && this.old._type == this.d._type) {
          var _parent = this.t.parent(this.i) || null; // If there is no parent then just update the node


          if (this.t.isRootNode(_parent) || _parent && _parent.length == 0 && ctx.op == 'UPDATE') {
            var that = this;
            this.t.remove(this.i).then(function () {
              that.t.before(that.i, that["new"]).then(function (new_item) {
                that.t.select(new_item);
              }, function () {
                console.warn('Failed to add before..', _arguments3);
              });
            });
          } else {
            var postRemove = function () {
              // If item has parent but no grand parent
              if (_item_parent.path !== '/browser' && !_item_grand_parent) {
                var parent = null; // We need to search in all parent siblings (eg: server groups)

                var parents = this.t.siblings(this.i) || [];
                parents.push(this.i);

                _.each(parents, function (p) {
                  var d = self.t.itemData(p); // If new server group found then assign it parent

                  if (d._id == self["new"]._pid) {
                    parent = p;
                    self.pathOfTreeItems.push({
                      coll: true,
                      item: parent,
                      d: d
                    });
                  }
                });

                if (parent) {
                  this.load = true;

                  this.success = function () {
                    addItemNode();
                  }.bind(this); // We can refresh the collection node, but - let's not bother about
                  // it right now.


                  this.notFound = errorOut; // var _d = {_id: this.new._pid, _type: self.d._type};

                  var loaded = this.t.wasLoad(parent),
                      onLoad = function onLoad() {
                    self.i = parent;
                    self.pathOfTreeItems.push({
                      coll: false,
                      item: parent,
                      d: self.d
                    });
                    self.success();
                    return;
                  };

                  if (!loaded && self.load) {
                    self.t.open(parent).then(function () {
                      onLoad();
                    }, function () {
                      var fail = self && self.o && self.o.fail;

                      if (fail && typeof fail == 'function') {
                        fail.apply(self.t, []);
                      }
                    });
                  } else {
                    onLoad();
                  }
                }

                return;
              } else {
                // This is for rest of the nodes
                var _parentData = this.d; // Find the grand-parent, or the collection node of parent.

                findParent();

                if (this.i) {
                  this.load = true;

                  this.success = function () {
                    addItemNode();
                  }.bind(this); // We can refresh the collection node, but - let's not bother about
                  // it right now.


                  this.notFound = errorOut; // Find the new parent

                  this.b._findTreeChildNode(this.i, {
                    _id: this["new"]._pid,
                    _type: _parentData._type
                  }, this);
                } else {
                  addItemNode();
                }

                return;
              }
            }.bind(this);

            this.t.remove(this.i).then(function () {
              findParent();

              if (_item_parent && !_item_grand_parent && _parent && self.t.children(_parent).length == 0) {
                self.t.unload(_parent).then(function () {
                  setTimeout(postRemove);
                });
              } else {
                setTimeout(postRemove);
              }

              return true;
            });
          }
        }

        errorOut();
      }.bind(ctx),
          findNewParent = function (_d) {
        var findParent = function () {
          var pathOfTreeItems = this.pathOfTreeItems;

          if (pathOfTreeItems.length) {
            pathOfTreeItems.pop();
            var length = pathOfTreeItems.length;
            this.i = length && pathOfTreeItems[length - 1].item || null;
            this.d = length && pathOfTreeItems[length - 1].d || null; // It is a collection item, let's find the node item

            if (length && pathOfTreeItems[length - 1].coll) {
              pathOfTreeItems.pop();
              length = pathOfTreeItems.length;
              this.i = length && pathOfTreeItems[length - 1].item || null;
              this.d = length && pathOfTreeItems[length - 1].d || null;
            }
          } else {
            this.i = null;
            this.d = null;
          }
        }.bind(this); // old parent was not found, can we find the new parent?


        if (this.i) {
          this.load = true;

          this.success = function () {
            addItemNode();
          }.bind(this);

          if (_d._type == this.old._type) {
            // We were already searching the old object under the parent.
            findParent();
            _d = this.d; // Find the grand parent

            findParent();
          }

          _d = this["new"]._pid; // We can refresh the collection node, but - let's not bother about
          // it right now.

          this.notFound = errorOut; // Find the new parent

          this.b._findTreeChildNode(this.i, _d, this);
        } else {
          addItemNode();
        }
      }.bind(ctx),
          updateNode = function () {
        if (this.i && this.d && this["new"]._type == this.d._type) {
          var self = this,
              _id = this.d._id;

          if (this["new"]._id != this.d._id) {
            // Found the new oid, update its node_id
            var node_data = this.t.itemData(ctx.i);
            node_data._id = _id = this["new"]._id;
          }

          if (this["new"]._id == _id) {
            // Found the current
            _.extend(this.d, {
              '_id': this["new"]._id,
              '_label': this["new"]._label,
              'label': this["new"].label
            });

            this.t.update(ctx.i, this["new"]);
            this.t.setLabel(ctx.i, {
              label: this["new"].label
            });
            this.t.addIcon(ctx.i, {
              icon: this["new"].icon
            });
            this.t.setId(ctx.i, {
              id: this["new"].id
            });
            this.t.openPath(this.i);
            this.t.deselect(this.i); // select tree item after few milliseconds

            setTimeout(function () {
              self.t.select(self.i);
            }, 10);
          }
        }

        var success = this.o && this.o.success;

        if (success && typeof success == 'function') {
          success.apply(this.t, [this.i, _old, _new]);
        }
      }.bind(ctx),
          traversePath = function () {
        var _ctx = this,
            data;

        _ctx.success = traversePath;

        if (_ctx.p.length) {
          data = _ctx.p.shift(); // This is the node, we can now do the required operations.
          // We should first delete the existing node, if the parent-id is
          // different.

          if (!_ctx.p.length) {
            if (_ctx.op == 'RECREATE') {
              _ctx.load = false;
              _ctx.success = deleteNode;
              _ctx.notFound = findNewParent;
            } else {
              _ctx.success = updateNode;
              _ctx.notFound = errorOut;
            }
          }

          _ctx.b._findTreeChildNode(_ctx.i, data, _ctx);
        } else if (_ctx.p.length == 1) {
          _ctx.notFound = findNewParent;
        }

        return true;
      }.bind(ctx),
          addItemNode = function () {
        var _this2 = this;

        var _ctx = this,
            first = (_ctx.i || this.t.wasLoad(_ctx.i)) && this.t.first(_ctx.i),
            findChildNode = function (success, notFound) {
          var __ctx = this;

          __ctx.success = success;
          __ctx.notFound = notFound;

          __ctx.b._findTreeChildNode(__ctx.i, _new, __ctx);
        }.bind(_ctx),
            selectNode = function () {
          this.t.openPath(this.i);
          this.t.select(this.i);

          if (_ctx.o && _ctx.o.success && typeof _ctx.o.success == 'function') {
            _ctx.o.success.apply(_ctx.t, [_ctx.i, _new]);
          }
        }.bind(_ctx),
            addNode = function () {
          var _arguments4 = arguments;

          var __ctx = this,
              items = __ctx.t.children(__ctx.i),
              s = 0,
              e = items.length - 1,
              i,
              linearSearch = function linearSearch() {
            while (e >= s) {
              i = items[s];

              var d = __ctx.t.itemData(i);

              if (d._type === 'column') {
                if (pgAdmin.numeric_comparator(d._id, _new._id) == 1) return true;
              } else {
                if (pgAdmin.natural_sort(d._label, _new._label) == 1) return true;
              }

              s++;
            }

            if (e != items.length - 1) {
              i = items[e + 1];
              return true;
            }

            i = null;
            return false;
          },
              binarySearch = function binarySearch() {
            while (e - s > 22) {
              i = items[s];

              var d = __ctx.t.itemData(i);

              if (d._type === 'column') {
                if (pgAdmin.numeric_comparator(d._id, _new._id) != -1) return true;
              } else {
                if (pgAdmin.natural_sort(d._label, _new._label) != -1) return true;
              }

              i = items[e];
              d = __ctx.t.itemData(i);
              var result = void 0;

              if (d._type === 'column') {
                result = pgAdmin.numeric_comparator(d._id, _new._id);
              } else {
                result = pgAdmin.natural_sort(d._label, _new._label);
              }

              if (result != 1) {
                if (e != items.length - 1) {
                  i = items[e + 1];
                  return true;
                }

                i = null;
                return false;
              }

              var m = s + Math.round((e - s) / 2);
              i = items[m];
              d = __ctx.t.itemData(i);

              if (d._type === 'column') {
                result = pgAdmin.numeric_comparator(d._id, _new._id);
              } else {
                result = pgAdmin.natural_sort(d._label, _new._label);
              } //result will never become 0 because of remove operation
              //which happens with updateTreeNode


              if (result == 0) return true;

              if (result == -1) {
                s = m + 1;
                e--;
              } else {
                s++;
                e = m - 1;
              }
            }

            return linearSearch();
          };

          if (binarySearch()) {
            __ctx.t.before(i, _new).then(function (new_item) {
              __ctx.t.openPath(new_item);

              __ctx.t.select(new_item);

              if (__ctx.o && __ctx.o.success && typeof __ctx.o.success == 'function') {
                __ctx.o.success.apply(__ctx.t, [i, _old, _new]);
              }
            }, function () {
              console.warn('Failed to add before..', _arguments4);

              if (__ctx.o && __ctx.o.fail && typeof __ctx.o.fail == 'function') {
                __ctx.o.fail.apply(__ctx.t, [i, _old, _new]);
              }
            });
          } else {
            var _appendNode = function _appendNode() {
              var _arguments5 = arguments;

              __ctx.t.append(__ctx.i, _new).then(function (new_item) {
                __ctx.t.openPath(new_item);

                __ctx.t.select(new_item);

                if (__ctx.o && __ctx.o.success && typeof __ctx.o.success == 'function') {
                  __ctx.o.success.apply(__ctx.t, [__ctx.i, _old, _new]);
                }
              }, function () {
                console.warn('Failed to append...', _arguments5);

                if (__ctx.o && __ctx.o.fail && typeof __ctx.o.fail == 'function') {
                  __ctx.o.fail.apply(__ctx.t, [__ctx.i, _old, _new]);
                }
              });
            }; // If the current node's inode is false


            if (__ctx.i && !__ctx.t.isInode(__ctx.i)) {
              __ctx.t.setInode(__ctx.i, {
                success: _appendNode
              });
            } else {
              // Handle case for node without parent i.e. server-group
              // or if parent node's inode is true.
              _appendNode();
            }
          }
        }.bind(_ctx); // Parent node do not have any children, let me unload it.


        if (!first && _ctx.t.wasLoad(_ctx.i)) {
          _ctx.t.unload(_ctx.i).then(function () {
            findChildNode(selectNode, function () {
              var o = this && this.o;

              if (o && o.fail && typeof o.fail == 'function') {
                o.fail.apply(this.t, [this.i, _old, _new]);
              }
            });
          }, function () {
            var o = _this2 && _this2.o;

            if (o && o.fail && typeof o.fail == 'function') {
              o.fail.apply(_this2.t, [_this2.i, _old, _new]);
            }
          });

          return;
        } // We can find the collection node using _findTreeChildNode
        // indirectly.


        findChildNode(selectNode, addNode);
      }.bind(ctx);

      if (!ctx.t.wasInit() || !_new || !_old) {
        return;
      }

      ctx.pathOfTreeItems.push(_old);
      _new._label = _new.label;
      _new.label = _.escape(_new.label); // We need to check if this is collection node and have
      // children count, if yes then add count with label too

      if (ctx.b.Nodes[_new._type].is_collection) {
        if ('collection_count' in _old && _old['collection_count'] > 0) {
          _new.label = _.escape(_new._label) + ' <span>(' + _old['collection_count'] + ')</span>';
        }
      } // If server icon/background changes then also we need to re-create it


      if (_old._type == 'server' && _new._type == 'server' && (_old._pid != _new._pid || _old._label != _new._label || _old.icon != _new.icon) || _old._pid != _new._pid || _old._label != _new._label || _old._id != _new._id) {
        ctx.op = 'RECREATE';
        traversePath();
      } else {
        ctx.op = 'UPDATE';
        traversePath();
      }
    },
    onRefreshTreeNodeReact: function onRefreshTreeNodeReact(_i, _opts) {
      this.tree.refresh(_i).then(function () {
        if (_opts && _opts.success) _opts.success();
      });
      return;
    },
    onRefreshTreeNode: function onRefreshTreeNode(_i, _opts) {
      var _d = _i && this.tree.itemData(_i),
          n = _d && _d._type && this.Nodes[_d._type],
          ctx = {
        b: this,
        // Browser
        d: _d,
        // current parent
        i: _i,
        // current item
        p: null,
        // path of the old object
        pathOfTreeItems: [],
        // path items
        t: this.tree,
        // Tree Api
        o: _opts
      },
          isOpen,
          idx = -1;

      this.Events.trigger('pgadmin-browser:tree:refreshing', _i, _d, n);

      if (!n) {
        _i = null;
        ctx.i = null;
        ctx.d = null;
      } else {
        isOpen = this.tree.isInode(_i) && this.tree.isOpen(_i);
      }

      ctx.branch = ctx.t.serialize(_i, {}, function (i, el, d) {
        idx++;

        if (!idx || d.inode && d.open) {
          return {
            _id: d._id,
            _type: d._type,
            branch: d.branch,
            open: d.open
          };
        }
      });

      if (!n) {
        ctx.t.destroy({
          success: function success() {
            initializeBrowserTree(ctx.b);
            ctx.t = ctx.b.tree;
            ctx.i = null;

            ctx.b._refreshNode(ctx, ctx.branch);
          },
          error: function error() {
            var fail = _opts.o && _opts.o.fail || _opts.fail;

            if (typeof fail == 'function') {
              fail();
            }
          }
        });
        return;
      }

      var fetchNodeInfo = function (__i, __d, __n) {
        var info = __n.getTreeNodeHierarchy(__i),
            url = __n.generate_url(__i, 'nodes', __d, true);

        $.ajax({
          url: url,
          type: 'GET',
          cache: false,
          dataType: 'json'
        }).done(function (res) {
          // Node information can come as result/data
          var newData = res.result || res.data;
          newData._label = newData.label;
          newData.label = _.escape(newData.label);
          ctx.t.setLabel(ctx.i, {
            label: newData.label
          });
          ctx.t.addIcon(ctx.i, {
            icon: newData.icon
          });
          ctx.t.setId(ctx.i, {
            id: newData.id
          });
          if (newData.inode) ctx.t.setInode(ctx.i, {
            inode: true
          }); // This will update the tree item data.

          var itemData = ctx.t.itemData(ctx.i);

          _.extend(itemData, newData);

          if (__n.can_expand && typeof __n.can_expand == 'function') {
            if (!__n.can_expand(itemData)) {
              ctx.t.unload(ctx.i);
              return;
            }
          }

          ctx.b._refreshNode(ctx, ctx.branch);

          var success = ctx.o && ctx.o.success || ctx.success;

          if (success && typeof success == 'function') {
            success();
          }
        }).fail(function (xhr, error, status) {
          if (!Alertify.pgHandleItemError(xhr, error, status, {
            item: __i,
            info: info
          })) {
            var contentType = xhr.getResponseHeader('Content-Type'),
                jsonResp = contentType && contentType.indexOf('application/json') == 0 && JSON.parse(xhr.responseText) || {};

            if (xhr.status == 410 && jsonResp.success == 0) {
              var parent = ctx.t.parent(ctx.i);
              ctx.t.remove(ctx.i, {
                success: function success() {
                  if (parent) {
                    // Try to refresh the parent on error
                    try {
                      pgBrowser.Events.trigger('pgadmin:browser:tree:refresh', parent);
                    } catch (e) {
                      console.warn(e.stack || e);
                    }
                  }
                }
              });
            }

            _Notifier["default"].pgNotifier(error, xhr, gettext('Error retrieving details for the node.'), function (msg) {
              if (msg == 'CRYPTKEY_SET') {
                fetchNodeInfo(__i, __d, __n);
              } else {
                console.warn(arguments);
              }
            });
          }
        });
      }.bind(this);

      if (n && n.collection_node) {
        var p = ctx.i = this.tree.parent(_i),
            unloadNode = function () {
          this.tree.unload(_i, {
            success: function success() {
              _i = p;
              _d = ctx.d = ctx.t.itemData(ctx.i);
              n = ctx.b.Nodes[_d._type];
              _i = p;
              fetchNodeInfo(_i, _d, n);
            },
            fail: function fail() {
              console.warn(arguments);
            }
          });
        }.bind(this);

        if (!this.tree.isInode(_i)) {
          this.tree.setInode(_i, {
            success: unloadNode
          });
        } else {
          unloadNode();
        }
      } else if (isOpen) {
        this.tree.unload(_i, {
          success: fetchNodeInfo.bind(this, _i, _d, n),
          fail: function fail() {
            console.warn(arguments);
          }
        });
      } else if (!this.tree.isInode(_i) && _d.inode) {
        this.tree.setInode(_i, {
          success: fetchNodeInfo.bind(this, _i, _d, n),
          fail: function fail() {
            console.warn(arguments);
          }
        });
      } else {
        fetchNodeInfo(_i, _d, n);
      }
    },
    onLoadFailNode: function onLoadFailNode(_nodeData) {
      var self = this,
          isSelected = self.tree.isSelected(_nodeData);
      /** Check if master password set **/

      self.check_master_password(function (is_set) {
        if (!is_set) {
          self.set_master_password('', function () {
            if (isSelected) {
              self.tree.select(_nodeData);
            }

            self.tree.open(_nodeData);
          });
        }
      });
    },
    removeChildTreeNodesById: function removeChildTreeNodesById(_parentNode, _collType, _childIds) {
      var tree_local = pgBrowser.tree;

      if (_parentNode && _collType) {
        var children = tree_local.children(_parentNode),
            idx = 0,
            size = children.length,
            childNode,
            childNodeData;
        _parentNode = null;

        for (; idx < size; idx++) {
          childNode = children[idx];
          childNodeData = tree_local.itemData(childNode);

          if (childNodeData._type == _collType) {
            _parentNode = childNode;
            break;
          }
        }
      }

      if (_parentNode) {
        children = tree_local.children(_parentNode);
        idx = 0;
        size = children.length;

        for (; idx < size; idx++) {
          childNode = children[idx];
          childNodeData = tree_local.itemData(childNode);

          if (_childIds.indexOf(childNodeData._id) != -1) {
            pgBrowser.removeTreeNode(childNode, false, _parentNode);
          }
        }

        return true;
      }

      return false;
    },
    removeTreeNode: function removeTreeNode(_node, _selectNext, _parentNode) {
      var tree_local = pgBrowser.tree,
          nodeToSelect = null;
      if (!_node) return false;

      if (_selectNext) {
        nodeToSelect = tree_local.next(_node);

        if (!nodeToSelect) {
          nodeToSelect = tree_local.prev(_node);

          if (!nodeToSelect) {
            if (!_parentNode) {
              nodeToSelect = tree_local.parent(_node);
            } else {
              nodeToSelect = _parentNode;
            }
          }
        }

        if (nodeToSelect) tree_local.select(nodeToSelect);
      }

      tree_local.remove(_node);
      return true;
    },
    findSiblingTreeNode: function findSiblingTreeNode(_node, _id) {
      var tree_local = pgBrowser.tree,
          parentNode = tree_local.parent(_node),
          siblings = tree_local.children(parentNode),
          idx = 0,
          nodeData,
          node;

      for (; idx < siblings.length; idx++) {
        node = siblings[idx];
        nodeData = tree_local.itemData(node);
        if (nodeData && nodeData._id == _id) return node;
      }

      return null;
    },
    findParentTreeNodeByType: function findParentTreeNodeByType(_node, _parentType) {
      var tree_local = pgBrowser.tree,
          nodeData,
          node = _node;

      do {
        nodeData = tree_local.itemData(node);
        if (nodeData && nodeData._type == _parentType) return node;
        node = tree_local.hasParent(node) ? tree_local.parent(node) : null;
      } while (node);

      return null;
    },
    findChildCollectionTreeNode: function findChildCollectionTreeNode(_node, _collType) {
      var tree_local = pgBrowser.tree,
          nodeData,
          idx = 0,
          node,
          children = _node && tree_local.children(_node);

      if (!children || !children.length) return null;

      for (; idx < children.length; idx++) {
        node = children[idx];
        nodeData = tree_local.itemData(node);
        if (nodeData && nodeData._type == _collType) return node;
      }

      return null;
    },
    addChildTreeNodes: function addChildTreeNodes(_treeHierarchy, _node, _type, _arrayIds, _callback) {
      var module = _type in pgBrowser.Nodes && pgBrowser.Nodes[_type],
          childTreeInfo = _arrayIds.length && _.extend({}, _.mapObject(_treeHierarchy, function (_val) {
        _val.priority -= 1;
        return _val;
      })),
          arrayChildNodeData = [],
          fetchNodeInfo = function fetchNodeInfo(__callback) {
        if (!_arrayIds.length) {
          if (__callback) {
            __callback();
          }

          return;
        }

        var childDummyInfo = {
          '_id': _arrayIds.pop(),
          '_type': _type,
          'priority': 0
        },
            childNodeUrl;
        childTreeInfo[_type] = childDummyInfo;
        childNodeUrl = module.generate_url(null, 'nodes', childDummyInfo, true, childTreeInfo);

        var _node = _node || arguments[1];

        $.ajax({
          url: childNodeUrl,
          dataType: 'json'
        }).done(function (res) {
          if (res.success) {
            arrayChildNodeData.push(res.data);
          }

          fetchNodeInfo(_callback);
        }).fail(function (xhr, status, error) {
          _Notifier["default"].pgRespErrorNotify(xhr, error);

          fetchNodeInfo(_callback);
        });
      };

      if (!module) {
        console.warn('Developer: Couldn\'t find the module for the given child: ', _.clone(arguments));
        return;
      }

      if (pgBrowser.tree.wasLoad(_node) || pgBrowser.tree.isLeaf(_node)) {
        fetchNodeInfo(function () {
          _.each(arrayChildNodeData, function (_nodData) {
            pgBrowser.Events.trigger('pgadmin:browser:tree:add', _nodData, _treeHierarchy);
          });

          if (_callback) {
            _callback();
          }
        });
      } else {
        if (_callback) {
          _callback();
        }
      }
    },
    _refreshNode: function _refreshNode(_ctx, _d) {
      var traverseNodes = function (__d) {
        var __ctx = this,
            idx = 0,
            ctx,
            d,
            size = __d.branch && __d.branch.length || 0,
            findNode = function findNode(i_findNode, d_findNode, ctx_findNode) {
          setTimeout(function () {
            ctx_findNode.b._findTreeChildNode(i_findNode, d_findNode, ctx_findNode);
          }, 0);
        };

        for (; idx < size; idx++) {
          d = __d.branch[idx];
          var n = __ctx.b.Nodes[d._type];
          ctx = {
            b: __ctx.b,
            t: __ctx.t,
            pathOfTreeItems: [],
            i: __ctx.i,
            d: d,
            select: __ctx.select,
            hasId: n && !n.collection_node,
            o: __ctx.o,
            load: true
          };

          ctx.success = function () {
            this.b._refreshNode.call(this.b, this, this.d);
          }.bind(ctx);

          findNode(__ctx.i, d, ctx);
        }
      }.bind(_ctx, _d);

      if (!_d || !_d.open) return;

      if (!_ctx.t.isOpen(_ctx.i)) {
        _ctx.t.open(_ctx.i, {
          unanimated: true,
          success: traverseNodes,
          fail: function fail() {
            /* Do nothing */
          }
        });
      } else {
        traverseNodes();
      }
    },
    editor_shortcut_keys: {
      // Autocomplete sql command
      'Ctrl-Space': 'autocomplete',
      'Cmd-Space': 'autocomplete',
      'Alt-Up': 'goLineUp',
      'Alt-Down': 'goLineDown',
      // Move word by word left/right
      'Ctrl-Alt-Left': 'goGroupLeft',
      'Cmd-Alt-Left': 'goGroupLeft',
      'Ctrl-Alt-Right': 'goGroupRight',
      'Cmd-Alt-Right': 'goGroupRight',
      // Allow user to delete Tab(s)
      'Shift-Tab': 'indentLess'
    },
    editor_options: {
      tabSize: parseInt(pgBrowser.utils.tabSize),
      wrapCode: pgBrowser.utils.wrapCode,
      insert_pair_brackets: pgBrowser.utils.insertPairBrackets,
      brace_matching: pgBrowser.utils.braceMatching,
      indent_with_tabs: pgBrowser.utils.is_indent_with_tabs
    },
    // This function will return the name and version of the browser.
    get_browser: function get_browser() {
      var ua = navigator.userAgent,
          tem,
          M = ua.match(/(opera|chrome|safari|firefox|msie|trident(?=\/))\/?\s*(\d+)/i) || [];

      if (/trident/i.test(M[1])) {
        tem = /\brv[ :]+(\d+)/g.exec(ua) || [];
        return {
          name: 'IE',
          version: tem[1] || ''
        };
      }

      if (M[1] === 'Chrome') {
        tem = ua.match(/\bOPR|Edge\/(\d+)/);

        if (tem != null) {
          return {
            name: tem[0],
            version: tem[1]
          };
        }
      }

      M = M[2] ? [M[1], M[2]] : [navigator.appName, navigator.appVersion, '-?'];

      if ((tem = ua.match(/version\/(\d+)/i)) != null) {
        M.splice(1, 1, tem[1]);
      }

      return {
        name: M[0],
        version: M[1]
      };
    }
  });
  /* Remove paste event mapping from CodeMirror's emacsy KeyMap binding
     * specific to Mac LineNumber:5797 - lib/Codemirror.js
     * It is preventing default paste event(Cmd-V) from triggering
     * in runtime.
     */


  delete CodeMirror.keyMap.emacsy['Ctrl-V']; // Use spaces instead of tab

  if (pgBrowser.utils.useSpaces == 'True') {
    pgAdmin.Browser.editor_shortcut_keys.Tab = 'insertSoftTab';
  }

  setTimeout(function () {
    $('#mnu_about').closest('li').before('<li class="dropdown-divider"></li>');
  }, 100);
  return pgAdmin.Browser;
}).apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__),
		__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));

/***/ }),

/***/ 5547:
/***/ ((module, exports, __webpack_require__) => {

"use strict";
var __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;

__webpack_require__(82772);

__webpack_require__(69826);

__webpack_require__(24812);

__webpack_require__(69600);

__webpack_require__(5735);

__webpack_require__(83753);

__webpack_require__(68309);

__webpack_require__(92222);

__webpack_require__(89554);

__webpack_require__(54747);

__webpack_require__(32564);

__webpack_require__(40561);

__webpack_require__(21249);

var _node_view = __webpack_require__(49929);

var _Notifier = _interopRequireDefault(__webpack_require__(55958));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/////////////////////////////////////////////////////////////
//
// pgAdmin 4 - PostgreSQL Tools
//
// Copyright (C) 2013 - 2022, The pgAdmin Development Team
// This software is released under the PostgreSQL Licence
//
//////////////////////////////////////////////////////////////
!(__WEBPACK_AMD_DEFINE_ARRAY__ = [__webpack_require__(91669), __webpack_require__(19755), __webpack_require__(81311), __webpack_require__(55112), __webpack_require__(72316), __webpack_require__(58307), __webpack_require__(95283), __webpack_require__(83879), __webpack_require__(61329), __webpack_require__(12030), __webpack_require__(71158), __webpack_require__(66235), __webpack_require__(14753)], __WEBPACK_AMD_DEFINE_RESULT__ = (function (gettext, $, _, pgAdmin, Backbone, Alertify, Backform, Backgrid, generateUrl) {
  var pgBrowser = pgAdmin.Browser = pgAdmin.Browser || {}; // It has already been defined.
  // Avoid running this script again.

  if (pgBrowser.Collection) return pgBrowser.Collection;

  pgBrowser.Collection = function () {};

  _.extend(pgBrowser.Collection, _.clone(pgBrowser.Node), {
    ///////
    // Initialization function
    // Generally - used to register the menus for this type of node.
    //
    // Also, look at pgAdmin.Browser.add_menus(...) function.
    //
    // Collection will not have 'Properties' menu.
    //
    // NOTE: Override this for each node for initialization purpose
    Init: function Init() {
      if (this.node_initialized) return;
      this.node_initialized = true;
      pgAdmin.Browser.add_menus([{
        name: 'refresh',
        node: this.type,
        module: this,
        applies: ['object', 'context'],
        callback: 'refresh',
        priority: 1,
        label: gettext('Refresh'),
        icon: 'fa fa-sync-alt'
      }]); // show query tool only in context menu of supported nodes.

      if (pgAdmin.unsupported_nodes && _.indexOf(pgAdmin.unsupported_nodes, this.type) == -1) {
        if (this.type == 'database' && this.allowConn || this.type != 'database') {
          pgAdmin.Browser.add_menus([{
            name: 'show_query_tool',
            node: this.type,
            module: this,
            applies: ['context'],
            callback: 'show_query_tool',
            priority: 998,
            label: gettext('Query Tool'),
            icon: 'pg-font-icon icon-query_tool'
          }]); // show search objects same as query tool

          pgAdmin.Browser.add_menus([{
            name: 'search_objects',
            node: this.type,
            module: this,
            applies: ['context'],
            callback: 'show_search_objects',
            priority: 997,
            label: gettext('Search Objects...'),
            icon: 'fa fa-search'
          }]); // show psql tool same as query tool.

          if (pgAdmin['enable_psql']) {
            pgAdmin.Browser.add_menus([{
              name: 'show_psql_tool',
              node: this.type,
              module: this,
              applies: ['context'],
              callback: 'show_psql_tool',
              priority: 998,
              label: gettext('PSQL Tool'),
              icon: 'fas fa-terminal'
            }]);
          }
        }
      }
    },
    hasId: false,
    is_collection: true,
    collection_node: true,
    // A collection will always have a collection of statistics, when the node
    // it represent will have some statistics.
    hasCollectiveStatistics: true,
    canDrop: true,
    canDropCascade: true,
    selectParentNodeOnDelete: false,
    showProperties: function showProperties(item, data, panel) {
      var that = this,
          j = panel.$container.find('.obj_properties').first(),
          view = j.data('obj-view'),
          content = $('<div></div>').addClass('pg-prop-content col-12 has-pg-prop-btn-group'),
          node = pgBrowser.Nodes[that.node],
          $msgContainer = '',
          // This will be the URL, used for object manipulation.
      urlBase = this.generate_url(item, 'properties', data),
          info = pgBrowser.tree.getTreeNodeHierarchy(item),
          gridSchema = Backform.generateGridColumnsFromModel(info, node.model, 'properties', that.columns),
          createButtons = function (buttonsList, location, extraClasses) {
        // Arguments must be non-zero length array of type
        // object, which contains following attributes:
        // label, type, extraClasses, register
        if (buttonsList && _.isArray(buttonsList) && buttonsList.length > 0) {
          // All buttons will be created within a single
          // div area.
          var btnGroup = $('<div class="pg-prop-btn-group"></div>'),
              // Template used for creating a button
          tmpl = _.template(['<button tabindex="0" type="<%= type %>" ', 'class="btn <%=extraClasses.join(\' \')%>"', '<% if (disabled) { %> disabled="disabled"<% } %> title="<%-tooltip%>">', '<span class="<%= icon %>" role="img"></span><% if (label != "") { %>&nbsp;<%-label%><% } %><span class="sr-only"><%-tooltip%></span></button>'].join(' '));

          if (location == 'header') {
            btnGroup.appendTo(that.header);
          } else {
            btnGroup.appendTo(that.footer);
          }

          if (extraClasses) {
            btnGroup.addClass(extraClasses);
          }

          _.each(buttonsList, function (btn) {
            // Create the actual button, and append to
            // the group div
            // icon may not present for this button
            if (!btn.icon) {
              btn.icon = '';
            }

            var b = $(tmpl(btn));
            btnGroup.append(b); // Register is a callback to set callback
            // for certain operation for this button.

            btn.register(b);
          });

          return btnGroup;
        }

        return null;
      }.bind(panel);

      that.collection = new (node.Collection.extend({
        url: urlBase,
        model: node.model
      }))(); // Add the new column for the multi-select menus

      if ((_.isFunction(that.canDrop) ? that.canDrop.apply(that, [data, item]) : that.canDrop) || (_.isFunction(that.canDropCascade) ? that.canDropCascade.apply(that, [data, item]) : that.canDropCascade)) {
        gridSchema.columns.unshift({
          name: 'oid',
          cell: Backgrid.Extension.SelectRowCell.extend({
            initialize: function initialize(options) {
              this.column = options.column;

              if (!(this.column instanceof Backgrid.Column)) {
                this.column = new Backgrid.Column(this.column);
              }

              var column = this.column,
                  model = this.model,
                  $el = this.$el;
              this.listenTo(column, 'change:renderable', function (col, renderable) {
                $el.toggleClass('renderable', renderable);
              });
              if (Backgrid.callByNeed(column.renderable(), column, model)) $el.addClass('renderable width_percent_3');
              this.listenTo(model, 'backgrid:select', this.toggleCheckbox);
            },
            toggleCheckbox: function toggleCheckbox(model, selected) {
              if (this.checkbox().prop('disabled') === false) {
                this.checkbox().prop('checked', selected).change();
              }
            },
            render: function render() {
              var model = this.model.toJSON(); // canDrop can be set to false for individual row from the server side to disable the checkbox

              var disabled = 'canDrop' in model && model.canDrop === false;
              var id = "row-".concat(_.uniqueId(model.oid || model.name));
              this.$el.empty().append("\n                  <div class=\"custom-control custom-checkbox custom-checkbox-no-label\">\n                    <input tabindex=\"-1\" type=\"checkbox\" class=\"custom-control-input\" id=\"".concat(id, "\" ").concat(disabled ? 'disabled' : '', "/>\n                    <label class=\"custom-control-label\" for=\"").concat(id, "\">\n                      <span class=\"sr-only\">") + gettext('Select') + "<span>\n                    </label>\n                  </div>\n                ");
              this.delegateEvents();
              return this;
            }
          }),
          headerCell: Backgrid.Extension.SelectAllHeaderCell
        });
      }
      /* Columns should be always non-editable  */


      gridSchema.columns.forEach(function (col) {
        col.disabled = true;
      }); // Get the list of selected models, before initializing the grid
      // again.

      var selectedModels = [];

      if (!_.isUndefined(that.grid) && 'collection' in that.grid) {
        selectedModels = that.grid.getSelectedModels();
      } // Initialize a new Grid instance


      that.grid = new Backgrid.Grid({
        emptyText: gettext('No data found'),
        columns: gridSchema.columns,
        collection: that.collection,
        className: 'backgrid table presentation table-bordered table-noouter-border table-hover'
      });
      var gridView = {
        'remove': function remove() {
          if (this.grid) {
            if (this.grid.collection) {
              this.grid.collection.reset([], {
                silent: true
              });
              delete this.grid.collection;
            }

            delete this.grid;
            this.grid = null;
          }
        },
        grid: that.grid
      };

      if (view) {
        // Cache the current IDs for next time
        $(panel).data('node-prop', urlBase); // Reset the data object

        j.data('obj-view', null);
      }
      /* Remove any dom rendered by getNodeView */


      (0, _node_view.removeNodeView)(j[0]); // Make sure the HTML element is empty.

      j.empty();
      j.data('obj-view', gridView);
      $msgContainer = '<div role="status" class="pg-panel-message pg-panel-properties-message">' + gettext('Retrieving data from the server...') + '</div>';
      $msgContainer = $($msgContainer).appendTo(j);
      that.header = $('<div></div>').addClass('pg-prop-header'); // Render the buttons

      var buttons = [];
      buttons.push({
        label: '',
        type: 'delete',
        tooltip: gettext('Delete/Drop'),
        extraClasses: ['btn-primary-icon m-1', 'delete_multiple'],
        icon: 'fa fa-trash-alt',
        disabled: _.isFunction(that.canDrop) ? !that.canDrop.apply(self, [data, item]) : !that.canDrop,
        register: function register(btn) {
          btn.on('click', function () {
            onDrop('drop');
          });
        }
      });
      buttons.push({
        label: '',
        type: 'delete',
        tooltip: gettext('Drop Cascade'),
        extraClasses: ['btn-primary-icon m-1', 'delete_multiple_cascade'],
        icon: 'pg-font-icon icon-drop_cascade',
        disabled: _.isFunction(that.canDropCascade) ? !that.canDropCascade.apply(self, [data, item]) : !that.canDropCascade,
        register: function register(btn) {
          btn.on('click', function () {
            onDrop('dropCascade');
          });
        }
      });
      createButtons(buttons, 'header', 'pg-prop-btn-group-above'); // Render subNode grid

      content.append('<div class="pg-prop-coll-container"></div>');
      content.find('.pg-prop-coll-container').append(that.grid.render().$el);
      var timer;

      var getAjaxHook = function getAjaxHook() {
        $.ajax({
          url: urlBase,
          type: 'GET',
          beforeSend: function beforeSend(xhr) {
            xhr.setRequestHeader(pgAdmin.csrf_token_header, pgAdmin.csrf_token); // Generate a timer for the request

            timer = setTimeout(function () {
              // notify user if request is taking longer than 1 second
              if (!$msgContainer.text() == 'Failed to retrieve data from the server.') $msgContainer.text(gettext('Retrieving data from the server...'));
              $msgContainer.removeClass('d-none');

              if (self.grid) {
                self.grid.remove();
              }
            }, 1000);
          }
        }).done(function (res) {
          clearTimeout(timer);
          if (_.isUndefined(that.grid) || _.isNull(that.grid)) return;
          that.data = res;

          if (that.data.length > 0) {
            if (!$msgContainer.hasClass('d-none')) {
              $msgContainer.addClass('d-none');
            }

            that.header.appendTo(j);
            j.append(content); // Listen scroll event to load more rows

            $('.pg-prop-content').on('scroll', that.__loadMoreRows.bind(that));
            that.collection.reset(that.data.splice(0, 50)); // Listen to select all checkbox event

            that.collection.on('backgrid:select-all', that.__loadAllRows.bind(that)); // Trigger the backgrid:select event for already selected items
            // as we have created a new grid instance.

            if (selectedModels.length > 0) {
              that.collection.each(function (model) {
                for (var inx = 0; inx < selectedModels.length; inx++) {
                  if (selectedModels[inx].id == model.id) {
                    model.trigger('backgrid:select', model, true);
                  }
                }
              });
            }
          } else {
            // Do not listen the scroll event
            $('.pg-prop-content').off('scroll', that.__loadMoreRows);
            $msgContainer.text(gettext('No properties are available for the selected object.'));
          }

          selectedModels = [];
        }).fail(function (xhr, error) {
          pgBrowser.Events.trigger('pgadmin:node:retrieval:error', 'properties', xhr, error.message, item, that);

          if (!Alertify.pgHandleItemError(xhr, error.message, {
            item: item,
            info: info
          })) {
            _Notifier["default"].pgNotifier(error, xhr, gettext('Error retrieving properties - %s', error.message || that.label), function (msg) {
              if (msg === 'CRYPTKEY_SET') {
                getAjaxHook();
              } else {
                console.warn(arguments);
              }
            });
          } // show failed message.


          $msgContainer.text(gettext('Failed to retrieve data from the server.'));
        });
      };

      getAjaxHook();

      var onDrop = function (type) {
        var confirm = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
        var sel_row_models = this.grid.getSelectedModels(),
            sel_rows = [],
            sel_item = pgBrowser.tree.selected(),
            d = sel_item ? pgBrowser.tree.itemData(sel_item) : null,
            sel_node = d && pgBrowser.Nodes[d._type],
            url = undefined,
            msg = undefined,
            title = undefined;

        if (sel_node && sel_node.type && sel_node.type == 'coll-constraints') {
          // In order to identify the constraint type, the type should be passed to the server
          sel_rows = sel_row_models.map(function (row) {
            return {
              id: row.get('oid'),
              _type: row.get('_type')
            };
          });
        } else {
          sel_rows = sel_row_models.map(function (row) {
            return row.id;
          });
        }

        if (sel_rows.length === 0) {
          _Notifier["default"].alert(gettext('Drop Multiple'), gettext('Please select at least one object to delete.'));

          return;
        }

        if (!sel_node) return;

        if (type === 'dropCascade') {
          url = sel_node.generate_url(sel_item, 'delete');
          msg = gettext('Are you sure you want to drop all the selected objects and all the objects that depend on them?');
          title = gettext('DROP CASCADE multiple objects?');
        } else {
          url = sel_node.generate_url(sel_item, 'drop');
          msg = gettext('Are you sure you want to drop all the selected objects?');
          title = gettext('DROP multiple objects?');
        }

        var dropAjaxHook = function dropAjaxHook() {
          $.ajax({
            url: url,
            type: 'DELETE',
            data: JSON.stringify({
              'ids': sel_rows
            }),
            contentType: 'application/json; charset=utf-8'
          }).done(function (res) {
            if (res.success == 0) {
              pgBrowser.report_error(res.errormsg, res.info);
            } else {
              $(pgBrowser.panels['properties'].panel).removeData('node-prop');
              pgBrowser.Events.trigger('pgadmin:browser:tree:refresh', sel_item || pgBrowser.tree.selected(), {
                success: function success() {
                  setTimeout(function () {
                    pgBrowser.tree.select(sel_item);
                    sel_node.callbacks.selected.apply(sel_node, [sel_item]);
                  }, 100);
                }
              });
            }

            return true;
          }).fail(function (xhr, error) {
            _Notifier["default"].pgNotifier(error, xhr, gettext('Error dropping %s', d._label.toLowerCase()), function (alertMsg) {
              if (alertMsg == 'CRYPTKEY_SET') {
                onDrop(type, false);
              } else {
                $(pgBrowser.panels['properties'].panel).removeData('node-prop');
                pgBrowser.Events.trigger('pgadmin:browser:tree:refresh', sel_item || pgBrowser.tree.selected(), {
                  success: function success() {
                    sel_node.callbacks.selected.apply(sel_node, [sel_item]);
                  }
                });
              }
            });
          });
        };

        if (confirm) {
          _Notifier["default"].confirm(title, msg, dropAjaxHook, null);
        } else {
          dropAjaxHook();
        }

        return;
      }.bind(that);
    },
    __loadMoreRows: function __loadMoreRows(e) {
      var elem = e.currentTarget;

      if (elem.scrollHeight - 10 < elem.scrollTop + elem.offsetHeight) {
        if (this.data.length > 0) {
          this.collection.add(this.data.splice(0, 50));
        }
      }
    },
    __loadAllRows: function __loadAllRows(tmp, checked) {
      if (this.data.length > 0) {
        this.collection.add(this.data);
        this.collection.each(function (model) {
          model.trigger('backgrid:select', model, checked);
        });
      }
    },
    generate_url: function generate_url(item, type) {
      /*
       * Using list, and collection functions of a node to get the nodes
       * under the collection, and properties of the collection respectively.
       */
      var opURL = {
        'properties': 'obj',
        'children': 'nodes',
        'drop': 'obj'
      },
          self = this;

      var collectionPickFunction = function collectionPickFunction(treeInfoValue, treeInfoKey) {
        return treeInfoKey != self.type;
      };

      var treeInfo = pgBrowser.tree.getTreeNodeHierarchy(item);
      var actionType = type in opURL ? opURL[type] : type;
      return generateUrl.generate_url(pgAdmin.Browser.URL, treeInfo, actionType, self.node, collectionPickFunction);
    },
    show_query_tool: function show_query_tool() {
      if (pgAdmin.DataGrid) {
        pgAdmin.DataGrid.show_query_tool('', pgAdmin.Browser.tree.selected());
      }
    },
    show_search_objects: function show_search_objects() {
      if (pgAdmin.SearchObjects) {
        pgAdmin.SearchObjects.show_search_objects('', pgAdmin.Browser.tree.selected());
      }
    },
    show_psql_tool: function show_psql_tool(args) {
      var input = args || {},
          t = pgBrowser.tree,
          i = input.item || t.selected(),
          d = i ? t.itemData(i) : undefined;
      pgBrowser.psql.psql_tool(d, i, true);
    }
  });

  return pgBrowser.Collection;
}).apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__),
		__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));

/***/ }),

/***/ 30794:
/***/ ((module, exports, __webpack_require__) => {

"use strict";
var __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;

__webpack_require__(82526);

__webpack_require__(41817);

__webpack_require__(32165);

__webpack_require__(78783);

__webpack_require__(47042);

__webpack_require__(91038);

__webpack_require__(79753);

__webpack_require__(41539);

__webpack_require__(66992);

__webpack_require__(33948);

__webpack_require__(68309);

__webpack_require__(5212);

__webpack_require__(39714);

__webpack_require__(83710);

__webpack_require__(5735);

__webpack_require__(83753);

__webpack_require__(34553);

__webpack_require__(32564);

__webpack_require__(69826);

__webpack_require__(24603);

__webpack_require__(74916);

__webpack_require__(40561);

__webpack_require__(47941);

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

/////////////////////////////////////////////////////////////
//
// pgAdmin 4 - PostgreSQL Tools
//
// Copyright (C) 2013 - 2022, The pgAdmin Development Team
// This software is released under the PostgreSQL Licence
//
//////////////////////////////////////////////////////////////
!(__WEBPACK_AMD_DEFINE_ARRAY__ = [__webpack_require__(81311), __webpack_require__(55112), __webpack_require__(19755), __webpack_require__(72316), __webpack_require__(44092)], __WEBPACK_AMD_DEFINE_RESULT__ = (function (_, pgAdmin, $, Backbone, pgadminUtils) {
  var pgBrowser = pgAdmin.Browser = pgAdmin.Browser || {};
  pgBrowser.DataModel = Backbone.Model.extend({
    /*
     * Parsing the existing data
     */
    on_server: false,
    parse: function parse(res) {
      var self = this;

      if (res && _.isObject(res) && 'node' in res && res['node']) {
        self.tnode = _.extend({}, res.node);
        delete res.node;
      }

      var objectOp = function objectOp(schema) {
        if (schema && _.isArray(schema)) {
          _.each(schema, function (s) {
            var obj, val;

            switch (s.type) {
              case 'collection':
                obj = self.get(s.id);
                val = res[s.id];

                if (_.isArray(val) || _.isObject(val)) {
                  if (!obj || !(obj instanceof Backbone.Collection)) {
                    obj = new pgBrowser.Node.Collection(val, {
                      model: _.isString(s.model) && s.model in pgBrowser.Nodes ? pgBrowser.Nodes[s.model].model : s.model,
                      top: self.top || self,
                      handler: self,
                      parse: true,
                      silent: true,
                      attrName: s.id
                    });
                    /*
                       * Nested collection models may or may not have idAttribute.
                       * So to decide whether model is new or not set 'on_server'
                       * flag on such models.
                       */

                    self.set(s.id, obj, {
                      silent: true,
                      parse: true,
                      on_server: true
                    });
                  } else {
                    /*
                       * Nested collection models may or may not have idAttribute.
                       * So to decide whether model is new or not set 'on_server'
                       * flag on such models.
                       */
                    obj.reset(val, {
                      silent: true,
                      parse: true,
                      on_server: true
                    });
                  }
                } else {
                  obj = null;
                }

                self.set(s.id, obj, {
                  silent: true
                });
                res[s.id] = obj;
                break;

              case 'model':
                obj = self.get(s.id);
                val = res[s.id];

                if (!_.isUndefined(val) && !_.isNull(val)) {
                  if (!obj || !(obj instanceof Backbone.Model)) {
                    if (_.isString(s.model) && s.model in pgBrowser.Nodes[s.model]) {
                      obj = new pgBrowser.Nodes[s.model].Model(obj, {
                        silent: true,
                        top: self.top || self,
                        handler: self,
                        attrName: s.id
                      });
                    } else {
                      obj = new s.model(obj, {
                        silent: true,
                        top: self.top || self,
                        handler: self,
                        attrName: s.id
                      });
                    }
                  }

                  obj.set(val, {
                    parse: true,
                    silent: true
                  });
                } else {
                  obj = null;
                }

                res[s.id] = obj;
                break;

              case 'nested':
                objectOp(s.schema);
                break;

              default:
                break;
            }
          });
        }
      };

      objectOp(self.schema);
      return res;
    },
    isNew: function isNew() {
      if (this.has(this.idAttribute)) {
        return !this.has(this.idAttribute);
      }

      return !this.on_server;
    },
    primary_key: function primary_key() {
      if (this.keys && _.isArray(this.keys)) {
        var res = {},
            self = this;

        _.each(self.keys, function (k) {
          res[k] = self.attributes[k];
        });

        return JSON.stringify(res);
      }

      return this.cid;
    },
    initialize: function initialize(attributes, options) {
      var self = this;
      self._previous_key_values = {};

      if (!_.isUndefined(options) && 'on_server' in options && options.on_server) {
        self.on_server = true;
      }

      Backbone.Model.prototype.initialize.apply(self, arguments);

      if (_.isUndefined(options) || _.isNull(options)) {
        options = attributes || {};
      }

      self.sessAttrs = {};
      self.fieldData = {};
      self.origSessAttrs = {};
      self.objects = [];
      self.arrays = [];
      self.attrName = options.attrName;
      self.top = options.top || self.collection && self.collection.top || self.collection || self;
      self.handler = options.handler || self.collection && self.collection.handler;
      self.trackChanges = false;
      self.errorModel = new Backbone.Model();
      self.node_info = options.node_info;
      var obj;

      var objectOp = function objectOp(schema) {
        if (schema && _.isArray(schema)) {
          _.each(schema, function (s) {
            switch (s.type) {
              case 'int':
              case 'numeric':
                self.fieldData[s.id] = {
                  id: s.id,
                  label: s.label,
                  type: s.type,
                  min: !_.isUndefined(s.min) ? s.min : undefined,
                  max: !_.isUndefined(s.max) ? s.max : undefined
                };
                break;

              default:
                self.fieldData[s.id] = {
                  id: s.id,
                  label: s.label,
                  type: s.type
                };
            }

            switch (s.type) {
              case 'array':
                self.arrays.push(s.id);
                break;

              case 'collection':
                obj = self.get(s.id);

                if (!obj || !(obj instanceof pgBrowser.Node.Collection)) {
                  if (_.isString(s.model) && s.model in pgBrowser.Nodes) {
                    var node = pgBrowser.Nodes[s.model];
                    obj = new node.Collection(obj, {
                      model: node.model,
                      top: self.top || self,
                      handler: self,
                      attrName: s.id
                    });
                  } else {
                    obj = new pgBrowser.Node.Collection(obj, {
                      model: s.model,
                      top: self.top || self,
                      handler: self,
                      attrName: s.id
                    });
                  }
                }

                obj.name = s.id;
                self.objects.push(s.id);
                self.set(s.id, obj, {
                  silent: true
                });
                break;

              case 'model':
                obj = self.get(s.id);

                if (!obj || !(obj instanceof Backbone.Model)) {
                  if (_.isString(s.model) && s.model in pgBrowser.Nodes[s.model]) {
                    obj = new pgBrowser.Nodes[s.model].Model(obj, {
                      top: self.top || self,
                      handler: self,
                      attrName: s.id
                    });
                  } else {
                    obj = new s.model(obj, {
                      top: self.top || self,
                      handler: self,
                      attrName: s.id
                    });
                  }
                }

                obj.name = s.id;
                self.objects.push(s.id);
                self.set(s.id, obj, {
                  silent: true
                });
                break;

              case 'nested':
                objectOp(s.schema);
                break;

              default:
                return;
            }
          });
        }
      };

      objectOp(self.schema);

      if (self.handler && self.handler.trackChanges) {
        self.startNewSession();
      }

      if ('keys' in self && _.isArray(self.keys)) {
        _.each(self.keys, function (key) {
          self.on('change:' + key, function (m) {
            self._previous_key_values[key] = m.previous(key);
          });
        });
      }

      return self;
    },
    // Create a reset function, which allow us to remove the nested object.
    reset: function reset(opts) {
      var obj,
          reindex = !!(opts && opts.reindex);
      if (opts && opts.stop) this.stopSession(); // Let's not touch the child attributes, if reindex is false.

      if (!reindex) {
        return;
      }

      for (var id in this.objects) {
        obj = this.get(id);

        if (obj) {
          if (obj instanceof pgBrowser.DataModel) {
            obj.reset(opts);
          } else if (obj instanceof Backbone.Model) {
            obj.clear(opts);
          } else if (obj instanceof pgBrowser.DataCollection) {
            obj.reset([], opts);
          } else if (obj instanceof Backbone.Collection) {
            obj.each(function (m) {
              if (m instanceof Backbone.DataModel) {
                obj.reset();
                obj.clear(opts);
              }
            });
            Backbone.Collection.prototype.reset.call(obj, [], opts);
          }
        }
      }

      Backbone.Collection.prototype.reset.apply(this, arguments);
    },
    sessChanged: function sessChanged() {
      var self = this;
      return _.size(self.sessAttrs) > 0 || _.some(self.objects, function (k) {
        var obj = self.get(k);

        if (!(_.isNull(obj) || _.isUndefined(obj))) {
          return obj.sessChanged();
        }

        return false;
      });
    },
    sessValid: function sessValid() {
      var self = this; // Perform default validations.

      if ('default_validate' in self && typeof self.default_validate == 'function' && _.isString(self.default_validate())) {
        return false;
      }

      if ('validate' in self && _.isFunction(self.validate) && _.isString(self.validate.apply(self))) {
        return false;
      }

      return true;
    },
    set: function set(key, val, options) {
      var opts = _.isObject(key) ? val : options;
      this._changing = true;
      this._previousAttributes = _.clone(this.attributes);
      this.changed = {};
      var res = Backbone.Model.prototype.set.call(this, key, val, options);
      this._changing = false;

      if (opts && opts.internal || !this.trackChanges) {
        return true;
      }

      if (key != null && res) {
        var attrs = {},
            self = this,
            msg;

        var attrChanged = function attrChanged(v, k) {
          if (k in self.objects) {
            return;
          }

          attrs[k] = v;
          var attrsDefined = self.origSessAttrs[k] && v;
          /* If the orig value was null and new one is empty string, then its a "no change" */

          /* If the orig value and new value are of different datatype but of same value(numeric) "no change" */

          if (_.isEqual(self.origSessAttrs[k], v) || self.origSessAttrs[k] === null && v === '' || (attrsDefined ? _.isEqual(self.origSessAttrs[k].toString(), v.toString()) : false)) {
            delete self.sessAttrs[k];
          } else {
            self.sessAttrs[k] = v;
          }
        }; // Handle both `"key", value` and `{key: value}` -style arguments.


        if (_typeof(key) === 'object') {
          _.each(key, attrChanged);
        } else {
          attrChanged(val, key);
        }

        self.trigger('pgadmin-session:set', self, attrs);

        if (!opts || !opts.silent) {
          self.trigger('change', self, opts);
        } // Perform default validations.


        if ('default_validate' in self && typeof self.default_validate == 'function') {
          msg = self.default_validate();
        }

        if ('validate' in self && typeof self['validate'] === 'function') {
          if (!msg) {
            msg = self.validate(_.keys(attrs));
          }
        }
        /*
         * If any parent present, we will need to inform the parent - that
         * I have some issues/fixed the issue.
         *
         * If not parent found, we will raise the issue
         */


        if (_.size(self.errorModel.attributes) == 0) {
          if (self.collection || self.handler) {
            (self.collection || self.handler).trigger('pgadmin-session:model:valid', self, self.collection || self.handler);
          } else {
            self.trigger('pgadmin-session:valid', self.sessChanged(), self);
          }
        } else {
          msg = msg || _.values(self.errorModel.attributes)[0];

          if (self.collection || self.handler) {
            (self.collection || self.handler).trigger('pgadmin-session:model:invalid', msg, self, self.collection || self.handler);
          } else {
            self.trigger('pgadmin-session:invalid', msg, self);
          }
        }

        return res;
      }

      return res;
    },

    /*
     * We do support modified data only through session by tracking changes.
     *
     * In normal mode, we will use the toJSON function of Backbone.Model.
     * In session mode, we will return all the modified data only. And, the
     * objects (collection, and model) will be return as stringified JSON,
     * only from the parent object.
     */
    toJSON: function toJSON(session, method) {
      var self = this,
          res,
          isNew = self.isNew();
      session = typeof session != 'undefined' && session == true;

      if (!session || isNew) {
        res = Backbone.Model.prototype.toJSON.call(this, arguments);
      } else {
        res = {};
        res[self.idAttribute || '_id'] = self.get(self.idAttribute || '_id');
        res = _.extend(res, self.sessAttrs);
      }
      /*
       * We do have number objects (models, collections), which needs to be
       * converted to JSON data manually.
       */


      _.each(self.objects, function (k) {
        var obj = self.get(k);
        /*
         * For session changes, we only need the modified data to be
         * transformed to JSON data.
         */

        if (session) {
          if (res[k] instanceof Array) {
            res[k] = JSON.stringify(res[k]);
          } else if (obj && obj.sessChanged && obj.sessChanged() || isNew) {
            res[k] = obj && obj.toJSON(!isNew);
            /*
             * We will run JSON.stringify(..) only from the main object,
             * not for the JSON object within the objects, that only when
             * HTTP method is 'GET'.
             *
             * We do stringify the object, so that - it will not be
             * translated to wierd format using jQuery.
             */

            if (obj && method && method == 'GET') {
              res[k] = JSON.stringify(res[k]);
            }
          } else {
            delete res[k];
          }
        } else if (!(res[k] instanceof Array)) {
          res[k] = obj && obj.toJSON();
        }
      });

      if (session) {
        _.each(self.arrays, function (a) {
          /*
           * For session changes, we only need the modified data to be
           * transformed to JSON data.
           */
          if (res[a] && res[a] instanceof Array) {
            res[a] = JSON.stringify(res[a]);
          }
        });
      }

      return res;
    },
    startNewSession: function startNewSession() {
      var self = this;

      if (self.trackChanges) {
        self.trigger('pgadmin-session:stop', self);
        self.off('pgadmin-session:model:invalid', self.onChildInvalid);
        self.off('pgadmin-session:model:valid', self.onChildValid);
        self.off('pgadmin-session:changed', self.onChildChanged);
        self.off('pgadmin-session:added', self.onChildChanged);
        self.off('pgadmin-session:removed', self.onChildChanged);
      }

      self.trackChanges = true;
      self.sessAttrs = {};
      self.origSessAttrs = _.clone(self.attributes);

      _.each(self.objects, function (o) {
        var obj = self.get(o);

        if (_.isUndefined(obj) || _.isNull(obj)) {
          return;
        }

        delete self.origSessAttrs[o];

        if (obj && 'startNewSession' in obj && _.isFunction(obj.startNewSession)) {
          obj.startNewSession();
        }
      }); // Let people know, I have started session hanlding


      self.trigger('pgadmin-session:start', self); // Let me listen to the my child invalid/valid messages

      self.on('pgadmin-session:model:invalid', self.onChildInvalid);
      self.on('pgadmin-session:collection:changed', self.onChildCollectionChanged);
      self.on('pgadmin-session:model-msg:changed', self.onModelChangedMsg);
      self.on('pgadmin-session:model:valid', self.onChildValid);
      self.on('pgadmin-session:changed', self.onChildChanged);
      self.on('pgadmin-session:added', self.onChildChanged);
      self.on('pgadmin-session:removed', self.onChildChanged);
    },
    onChildInvalid: function onChildInvalid(msg, obj) {
      var self = this;

      if (self.trackChanges && obj) {
        var objName = obj.attrName;

        if (!objName) {
          var hasPrimaryKey = obj.primary_key && typeof obj.primary_key === 'function';
          var key = hasPrimaryKey ? obj.primary_key() : obj.cid,
              comparator = hasPrimaryKey ? function (k) {
            var o = self.get('k');

            if (o && o.primary_key() === key) {
              objName = k;
              return true;
            }

            return false;
          } : function (k) {
            var o = self.get(k);

            if (o.cid === key) {
              objName = k;
              return true;
            }

            return false;
          };

          _.findIndex(self.objects, comparator);
        }

        if (objName) {
          /*
           * Update the error message for this object.
           */
          self.errorModel.set(objName, msg);

          if (self.handler) {
            self.handler.trigger('pgadmin-session:model:invalid', msg, self, self.handler);
          } else {
            self.trigger('pgadmin-session:invalid', msg, self);
          }
        }
      }

      return this;
    },
    onChildValid: function onChildValid(obj) {
      var self = this;

      if (self.trackChanges && obj) {
        var objName = obj.attrName;

        if (!objName) {
          var hasPrimaryKey = obj.primary_key && typeof obj.primary_key === 'function';
          var key = hasPrimaryKey ? obj.primary_key() : obj.cid,
              comparator = hasPrimaryKey ? function (k) {
            var o = self.get('k');

            if (o && o.primary_key() === key) {
              objName = k;
              return true;
            }

            return false;
          } : function (k) {
            var o = self.get('k');

            if (o && o.cid === key) {
              objName = k;
              return true;
            }

            return false;
          };

          _.findIndex(self.objects, comparator);
        }

        var msg = null,
            validate = function validate(m, attrs) {
          if ('default_validate' in m && typeof m.default_validate == 'function') {
            msg = m.default_validate();

            if (_.isString(msg)) {
              return msg;
            }
          }

          if ('validate' in m && typeof m.validate == 'function') {
            msg = m.validate(attrs);
            return msg;
          }

          return null;
        };

        if (obj instanceof Backbone.Collection) {
          for (var idx in obj.models) {
            if (validate(obj.models[idx])) break;
          }
        } else if (obj instanceof Backbone.Model) {
          validate(obj);
        }

        if (objName && self.errorModel.has(objName)) {
          if (!msg) {
            self.errorModel.unset(objName);
          } else {
            self.errorModel.set(objName, msg);
          }
        }
        /*
         * The object is valid, but does this has any effect on parent?
         * Let's validate this object itself, before making it clear.
         *
         * We will trigger validation information.
         */


        if (_.size(self.errorModel.attributes) == 0 && !validate(self, objName && [objName])) {
          if (self.handler) {
            self.handler.trigger('pgadmin-session:model:valid', self, self.handler);
            self.handler.trigger('pgadmin-session:collection:changed', self, self.handler);
          } else {
            self.trigger('pgadmin-session:valid', self.sessChanged(), self);
            self.trigger('pgadmin-session:collection:changed', self.sessChanged(), self);
          }
        } else {
          msg = msg || _.values(self.errorModel.attributes)[0];

          if (self.handler) {
            self.handler.trigger('pgadmin-session:model:invalid', msg, self, self.handler);
            self.handler.trigger('pgadmin-session:collection:changed', self, self.handler);
          } else {
            self.trigger('pgadmin-session:invalid', msg, self);
            self.trigger('pgadmin-session:collection:changed', self);
          }
        }
      }
    },
    onChildCollectionChanged: function onChildCollectionChanged(obj, obj_hand) {
      var _this = this;

      var self = this;
      setTimeout(function () {
        var msg = null,
            validate = function validate(m, attrs) {
          if ('default_validate' in m && typeof m.default_validate == 'function') {
            msg = m.default_validate();

            if (_.isString(msg)) {
              return msg;
            }
          }

          if ('validate' in m && typeof m.validate == 'function') {
            msg = m.validate(attrs);
            return msg;
          }

          return null;
        };

        var handler, parentTr;
        var collection = self.collection || obj_hand;

        if (collection) {
          var collection_selector = collection.attrName || collection.name;
          var activeTab = $('.show.active div.' + collection_selector);
          $(activeTab).find('.error-in-grid').removeClass('error-in-grid');

          model_collection_exit: if (collection instanceof Backbone.Collection) {
            for (var cid in collection.models) {
              var model = collection.models[cid];

              var _iterator = _createForOfIteratorHelper(model.objects),
                  _step;

              try {
                for (_iterator.s(); !(_step = _iterator.n()).done;) {
                  var mod_obj = _step.value;
                  var mod_attr = model.attributes[mod_obj];

                  if (mod_attr && mod_attr.models.length > 0) {
                    for (var mod_attr_prop in mod_attr.models) {
                      if (validate(mod_attr.models[mod_attr_prop])) {
                        handler = mod_attr.models[mod_attr_prop];
                        parentTr = model.parentTr;
                        break model_collection_exit;
                      }
                    }
                  }
                }
              } catch (err) {
                _iterator.e(err);
              } finally {
                _iterator.f();
              }
            }
          }
        }

        if (msg && handler) {
          msg = msg || _.values(handler.errorModel.attributes)[0];
          handler.trigger('pgadmin-session:model:invalid', msg, handler);
          $(parentTr).addClass('error-in-grid');
        }

        return _this;
      }, 120);
    },
    onChildChanged: function onChildChanged(obj) {
      var self = this;

      if (self.trackChanges && self.collection) {
        self.collection.trigger('change', self);
      }

      self.trigger('pgadmin-session:collection:changed', self, obj);
    },
    stopSession: function stopSession() {
      var self = this;

      if (self.trackChanges) {
        self.off('pgadmin-session:model:invalid', self.onChildInvalid);
        self.off('pgadmin-session:model:valid', self.onChildValid);
        self.off('pgadmin-session:changed', self.onChildChanged);
        self.off('pgadmin-session:added', self.onChildChanged);
        self.off('pgadmin-session:removed', self.onChildChanged);
        self.off('pgadmin-session:collection:changed', self.onChildCollectionChanged);
      }

      self.trackChanges = false;
      self.sessAttrs = {};
      self.origSessAttrs = {};

      _.each(self.objects, function (o) {
        var obj = self.get(o);

        if (_.isUndefined(obj) || _.isNull(obj)) {
          return;
        }

        self.origSessAttrs[o] = null;
        delete self.origSessAttrs[o];

        if (obj && 'stopSession' in obj && _.isFunction(obj.stopSession)) {
          obj.stopSession();
        }
      });

      self.trigger('pgadmin-session:stop');
    },
    default_validate: function default_validate() {
      var msg, field, value, type;

      for (var i = 0, keys = _.keys(this.attributes), l = keys.length; i < l; i++) {
        value = this.attributes[keys[i]];
        field = this.fieldData[keys[i]];
        msg = null;

        if (!(_.isUndefined(value) || _.isNull(value) || String(value) === '')) {
          if (!field) {
            continue;
          }

          type = field.type || undefined;

          if (!type) {
            continue;
          }

          switch (type) {
            case 'int':
              msg = this.integer_validate(value, field);
              break;

            case 'numeric':
              msg = this.number_validate(value, field);
              break;
          }

          if (msg) {
            this.errorModel.set(field.id, msg);
            return msg;
          } else {
            this.errorModel.unset(field.id);
          }
        } else {
          if (field) {
            this.errorModel.unset(field.id);
          }
        }
      }

      return null;
    },
    check_min_max: function check_min_max(value, field) {
      var label = field.label,
          min_value = field.min,
          max_value = field.max;

      if (!_.isUndefined(min_value) && value < min_value) {
        return pgadminUtils.sprintf(pgAdmin.Browser.messages.MUST_GR_EQ, label, min_value);
      } else if (!_.isUndefined(max_value) && value > max_value) {
        return pgadminUtils.sprintf(pgAdmin.Browser.messages.MUST_LESS_EQ, label, max_value);
      }

      return null;
    },
    number_validate: function number_validate(value, field) {
      var pattern = new RegExp('^-?[0-9]+(\.?[0-9]*)?$');

      if (!pattern.test(value)) {
        return pgadminUtils.sprintf(pgAdmin.Browser.messages.MUST_BE_NUM, field.label);
      }

      return this.check_min_max(value, field);
    },
    integer_validate: function integer_validate(value, field) {
      var pattern = new RegExp('^-?[0-9]*$');

      if (!pattern.test(value)) {
        return pgadminUtils.sprintf(pgAdmin.Browser.messages.MUST_BE_INT, field.label);
      }

      return this.check_min_max(value, field);
    }
  });
  pgBrowser.DataCollection = Backbone.Collection.extend({
    // Model collection
    initialize: function initialize(attributes, options) {
      var self = this;
      options = options || {};
      /*
       * Session changes will be kept in this object.
       */

      self.sessAttrs = {
        'changed': [],
        'added': [],
        'deleted': [],
        'invalid': []
      };
      self.top = options.top || self;
      self.attrName = options.attrName;
      self.handler = options.handler;
      self.trackChanges = false;
      /*
       * Listen to the model changes for the session changes.
       */

      self.on('add', self.onModelAdd);
      self.on('remove', self.onModelRemove);
      self.on('change', self.onModelChange);
      /*
       * We need to start the session, if the handler is already in session
       * tracking mode.
       */

      if (self.handler && self.handler.trackChanges) {
        self.startNewSession();
      }

      return self;
    },
    startNewSession: function startNewSession() {
      var self = this,
          msg;

      if (self.trackChanges) {
        // We're stopping the existing session.
        self.trigger('pgadmin-session:stop', self);
        self.off('pgadmin-session:model:invalid', self.onModelInvalid);
        self.off('pgadmin-session:model:valid', self.onModelValid);
      }

      self.trackChanges = true;
      self.sessAttrs = {
        'changed': [],
        'added': [],
        'deleted': [],
        'invalid': []
      };

      _.each(self.models, function (m) {
        if ('startNewSession' in m && _.isFunction(m.startNewSession)) {
          m.startNewSession();
        }

        if ('default_validate' in m && typeof m.default_validate == 'function') {
          msg = m.default_validate();
        }

        if (_.isString(msg)) {
          self.sessAttrs['invalid'][m.cid] = msg;
        } else if ('validate' in m && typeof m.validate === 'function') {
          msg = m.validate();

          if (msg) {
            self.sessAttrs['invalid'][m.cid] = msg;
          }
        }
      }); // Let people know, I have started session hanlding


      self.trigger('pgadmin-session:start', self);
      self.on('pgadmin-session:model:invalid', self.onModelInvalid);
      self.on('pgadmin-session:model:valid', self.onModelValid);
    },
    onModelInvalid: function onModelInvalid(msg, m) {
      var self = this,
          invalidModels = self.sessAttrs['invalid'];

      if (self.trackChanges) {
        // Do not add the existing invalid object
        invalidModels[m.cid] = msg; // Inform the parent that - I am an invalid model.

        if (self.handler) {
          self.handler.trigger('pgadmin-session:model:invalid', msg, self, self.handler);
        } else {
          self.trigger('pgadmin-session:invalid', msg, self);
        }
      }

      return true;
    },
    onModelValid: function onModelValid(m) {
      var self = this,
          invalidModels = self.sessAttrs['invalid'];

      if (self.trackChanges) {
        // Now check uniqueness of current model with other models.
        var isUnique = self.checkDuplicateWithModel(m); // If unique then find the object the invalid list, if found remove it from the list
        // and inform the parent that - I am a valid object now.

        if (isUnique && m.cid in invalidModels) {
          delete invalidModels[m.cid];
        }

        if (isUnique) {
          this.triggerValidationEvent.apply(this);
        }
      }

      return true;
    },
    stopSession: function stopSession() {
      var self = this;
      self.trackChanges = false;
      self.sessAttrs = {
        'changed': [],
        'added': [],
        'deleted': [],
        'invalid': []
      };

      _.each(self.models, function (m) {
        if ('stopSession' in m && _.isFunction(m.stopSession)) {
          m.stopSession();
        }
      });
    },
    sessChanged: function sessChanged() {
      return this.sessAttrs['changed'].length > 0 || this.sessAttrs['added'].length > 0 || this.sessAttrs['deleted'].length > 0;
    },

    /*
     * We do support the changes through session tracking in general.
     *
     * In normal mode, we will use the general toJSON(..) function of
     * Backbone.Colletion.
     *
     * In session mode, we will return session changes as:
     * We will be returning the session changes as:
     * {
     *  'added': [JSON of each new model],
     *  'delete': [JSON of each deleted model],
     *  'changed': [JSON of each modified model with session changes]
     * }
     */
    toJSON: function toJSON(session) {
      var self = this;
      session = typeof session != 'undefined' && session == true;

      if (!session) {
        return Backbone.Collection.prototype.toJSON.call(self);
      } else {
        var res = {};
        res['added'] = [];

        _.each(this.sessAttrs['added'], function (o) {
          res['added'].push(o.toJSON());
        });

        if (res['added'].length == 0) {
          delete res['added'];
        }

        res['changed'] = [];

        _.each(self.sessAttrs['changed'], function (o) {
          res['changed'].push(o.toJSON(true));
        });

        if (res['changed'].length == 0) {
          delete res['changed'];
        }

        res['deleted'] = [];

        _.each(self.sessAttrs['deleted'], function (o) {
          res['deleted'].push(o.toJSON());
        });

        if (res['deleted'].length == 0) {
          delete res['deleted'];
        }

        return _.size(res) == 0 ? null : res;
      }
    },
    // Override the reset function, so that - we can reset the model
    // properly.
    reset: function reset(_set, opts) {
      if (opts && opts.stop) this.stopSession();
      this.each(function (m) {
        if (!m) return;

        if (m instanceof pgBrowser.DataModel) {
          m.reset(opts);
        } else {
          m.clear(opts);
        }
      });
      Backbone.Collection.prototype.reset.apply(this, arguments);
    },
    objFindInSession: function objFindInSession(m, type) {
      var hasPrimaryKey = m.primary_key && typeof m.primary_key == 'function',
          key = hasPrimaryKey ? m.primary_key() : m.cid,
          comparator = hasPrimaryKey ? function (o) {
        return o.primary_key() === key;
      } : function (o) {
        return o.cid === key;
      };
      return _.findIndex(this.sessAttrs[type], comparator);
    },
    onModelAdd: function onModelAdd(obj) {
      if (this.trackChanges) {
        var self = this,
            msg,
            idx = self.objFindInSession(obj, 'deleted'); // Hmm.. - it was originally deleted from this collection, we should
        // remove it from the 'deleted' list.

        if (idx >= 0) {
          var origObj = self.sessAttrs['deleted'][idx];
          obj.origSessAttrs = _.clone(origObj.origSessAttrs);
          obj.attributes = _.extend(obj.attributes, origObj.attributes);
          obj.sessAttrs = _.clone(origObj.sessAttrs);
          self.sessAttrs['deleted'].splice(idx, 1); // It has been changed originally!

          if (!('sessChanged' in obj) || obj.sessChanged()) {
            self.sessAttrs['changed'].push(obj);
          }

          (self.handler || self).trigger('pgadmin-session:added', self, obj);

          if ('default_validate' in obj && typeof obj.default_validate == 'function') {
            msg = obj.default_validate();
          }

          if (_.isString(msg)) {
            self.sessAttrs['invalid'][obj.cid] = msg;
          } else if ('validate' in obj && typeof obj.validate === 'function') {
            msg = obj.validate();

            if (msg) {
              self.sessAttrs['invalid'][obj.cid] = msg;
            }
          }
        } else {
          if ('default_validate' in obj && typeof obj.default_validate == 'function') {
            msg = obj.default_validate();
          }

          if (_.isString(msg)) {
            self.sessAttrs['invalid'][obj.cid] = msg;
          } else if ('validate' in obj && typeof obj.validate === 'function') {
            msg = obj.validate();

            if (msg) {
              self.sessAttrs['invalid'][obj.cid] = msg;
            }
          }

          self.sessAttrs['added'].push(obj);
          /*
           * Session has been changed
           */

          (self.handler || self).trigger('pgadmin-session:added', self, obj);
        } // Let the parent/listener know about my status (valid/invalid).


        this.triggerValidationEvent.apply(this);
        self.trigger('pgadmin-session:collection:changed', self);
      }

      return true;
    },
    onModelRemove: function onModelRemove(obj) {
      if (this.trackChanges) {
        /* Once model is removed from collection clear its errorModel as it's no longer relevant
         * for us. Otherwise it creates problem in 'clearInvalidSessionIfModelValid' function.
         */
        obj.errorModel.clear();

        var self = this,
            invalidModels = self.sessAttrs['invalid'],
            copy = _.clone(obj),
            idx = self.objFindInSession(obj, 'added'); // We need to remove it from the invalid object list first.


        if (obj.cid in invalidModels) {
          delete invalidModels[obj.cid];
        } // Hmm - it was newly added, we can safely remove it.


        if (idx >= 0) {
          self.sessAttrs['added'].splice(idx, 1);
          (self.handler || self).trigger('pgadmin-session:removed', self, copy);
          self.checkDuplicateWithModel(copy); // Let the parent/listener know about my status (valid/invalid).

          this.triggerValidationEvent.apply(this);
        } else {
          // Hmm - it was changed in this session, we should remove it from the
          // changed models.
          idx = self.objFindInSession(obj, 'changed');

          if (idx >= 0) {
            self.sessAttrs['changed'].splice(idx, 1);
            (self.handler || self).trigger('pgadmin-session:removed', self, copy);
          } else {
            (self.handler || self).trigger('pgadmin-session:removed', self, copy);
          }
          /* When removing the object use the original session attrs and not the changed ones */


          obj.set(obj.origSessAttrs, {
            silent: true
          });
          self.sessAttrs['deleted'].push(obj);
          self.checkDuplicateWithModel(obj); // Let the parent/listener know about my status (valid/invalid).

          this.triggerValidationEvent.apply(this);
        }
        /*
         * This object has been remove, we need to check (if we still have any
         * other invalid message pending).
         */

      }

      return true;
    },
    triggerValidationEvent: function triggerValidationEvent() {
      var self = this,
          msg = null,
          invalidModels = self.sessAttrs['invalid'],
          validModels = [];

      for (var key in invalidModels) {
        msg = invalidModels[key];

        if (msg) {
          break;
        } else {
          // Hmm..
          // How come - you have been assigned in invalid list.
          // I will make a list of it, and remove it later.
          validModels.push(key);
        }
      } // Let's remove the un


      for (key in validModels) {
        delete invalidModels[validModels[key]];
      }

      if (!msg) {
        if (self.handler) {
          self.handler.trigger('pgadmin-session:model:valid', self, self.handler);
        } else {
          self.trigger('pgadmin-session:valid', self.sessChanged(), self);
        }
      } else {
        if (self.handler) {
          self.handler.trigger('pgadmin-session:model:invalid', msg, self, self.handler);
        } else {
          self.trigger('pgadmin-session:invalid', msg, self);
        }
      }
    },
    onModelChange: function onModelChange(obj) {
      var self = this;

      if (this.trackChanges && obj instanceof pgBrowser.Node.Model) {
        var idx = self.objFindInSession(obj, 'added'); // It was newly added model, we don't need to add into the changed
        // list.

        if (idx >= 0) {
          (self.handler || self).trigger('pgadmin-session:changed', self, obj);
        } else {
          idx = self.objFindInSession(obj, 'changed');

          if (!('sessChanged' in obj)) {
            (self.handler || self).trigger('pgadmin-session:changed', self, obj);

            if (idx < 0) {
              self.sessAttrs['changed'].push(obj);
            }
          } else {
            if (idx >= 0) {
              if (!obj.sessChanged()) {
                // This object is no more updated, removing it from the changed
                // models list.
                self.sessAttrs['changed'].splice(idx, 1);
                (self.handler || self).trigger('pgadmin-session:changed', self, obj);
              } else {
                (self.handler || self).trigger('pgadmin-session:changed', self, obj);
              }
            } else if (obj.sessChanged()) {
              self.sessAttrs['changed'].push(obj);
              (self.handler || self).trigger('pgadmin-session:changed', self, obj);
            }
          }
        }
      }

      return true;
    },

    /*
     * This function will check if given model is unique or duplicate in
     * collection and set/clear duplicate errors on models.
     */
    checkDuplicateWithModel: function checkDuplicateWithModel(model) {
      if (!('keys' in model) || _.isEmpty(model.keys)) {
        return true;
      }

      var self = this,
          condition = {},
          previous_condition = {};

      _.each(model.keys, function (key) {
        condition[key] = model.get(key);

        if (key in model._previous_key_values) {
          previous_condition[key] = model._previous_key_values[key];
        } else {
          previous_condition[key] = model.previous(key);
        }
      }); // Reset previously changed values.


      model._previous_key_values = {};
      var old_conflicting_models = self.where(previous_condition);

      if (old_conflicting_models.length == 1) {
        var m = old_conflicting_models[0];
        self.clearInvalidSessionIfModelValid(m);
      }

      var new_conflicting_models = self.where(condition);

      if (new_conflicting_models.length == 0) {
        self.clearInvalidSessionIfModelValid(model);
      } else if (new_conflicting_models.length == 1) {
        self.clearInvalidSessionIfModelValid(model);
        self.clearInvalidSessionIfModelValid(new_conflicting_models[0]);
      } else {
        var msg = 'Duplicate rows.';
        setTimeout(function () {
          _.each(new_conflicting_models, function (local_model) {
            self.trigger('pgadmin-session:model:invalid', msg, local_model, self.handler);
            local_model.trigger('pgadmin-session:model:duplicate', local_model, msg);
          });
        }, 10);
        return false;
      }

      return true;
    },
    clearInvalidSessionIfModelValid: function clearInvalidSessionIfModelValid(m) {
      var errors = m.errorModel.attributes,
          invalidModels = this.sessAttrs['invalid'];
      m.trigger('pgadmin-session:model:unique', m);

      if (_.size(errors) == 0) {
        delete invalidModels[m.cid];
      } else {
        invalidModels[m.cid] = errors[Object.keys(errors)[0]];
      }
    }
  });
  pgBrowser.Events = _.extend({}, Backbone.Events);
  return pgBrowser;
}).apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__),
		__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));

/***/ }),

/***/ 66092:
/***/ ((module, exports, __webpack_require__) => {

"use strict";
var __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;

var _Notifier = _interopRequireDefault(__webpack_require__(55958));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/////////////////////////////////////////////////////////////
//
// pgAdmin 4 - PostgreSQL Tools
//
// Copyright (C) 2013 - 2022, The pgAdmin Development Team
// This software is released under the PostgreSQL Licence
//
//////////////////////////////////////////////////////////////
!(__WEBPACK_AMD_DEFINE_ARRAY__ = [__webpack_require__(91669), __webpack_require__(81311), __webpack_require__(55112)], __WEBPACK_AMD_DEFINE_RESULT__ = (function (gettext, _, pgAdmin) {
  pgAdmin.Browser = pgAdmin.Browser || {};

  _.extend(pgAdmin.Browser, {
    report_error: function report_error(title, message, info, callback) {
      title = _.escape(title);
      message = _.escape(message);
      info = _.escape(info);
      var text = '<div class="panel-group" id="accordion" role="tablist" aria-multiselectable="true">' + '<div class="panel panel-default">' + '<div class="panel-heading" role="tab" id="headingOne">' + '<h4 class="panel-title">' + '<a data-toggle="collapse" data-parent="#accordion" href="#collapseOne" aria-expanded="true" aria-controls="collapseOne">' + gettext('Error message') + '</a>' + '</h4>' + '</div>' + '<div id="collapseOne" class="panel-collapse collapse show" role="tabpanel" aria-labelledby="headingOne">' + '<div class="panel-body" style="overflow: auto;">' + message + '</div>' + '</div>' + '</div>';

      if (info != null && info != '') {
        text += '<div class="panel panel-default">' + '<div class="panel-heading" role="tab" id="headingTwo">' + '<h4 class="panel-title">' + '<a class="collapsed" data-toggle="collapse" data-parent="#accordion" href="#collapseTwo" aria-expanded="false" aria-controls="collapseTwo">' + gettext('Additional info') + '</a>' + '</h4>' + '</div>' + '<div id="collapseTwo" class="panel-collapse collapse" role="tabpanel" aria-labelledby="headingTwo">' + '<div class="panel-body" style="overflow: auto;">' + info + '</div>' + '</div>' + '</div>' + '</div>';
      }

      text += '</div>';

      _Notifier["default"].alert(_.unescape(title), text).set({
        'closable': true,
        'onok': function onok() {
          if (callback) {
            callback();
          }
        }
      });
    }
  });

  return pgAdmin.Browser.report_error;
}).apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__),
		__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));

/***/ }),

/***/ 58688:
/***/ ((module, exports, __webpack_require__) => {

"use strict";
var __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;

__webpack_require__(68309);

__webpack_require__(32564);

__webpack_require__(24812);

/////////////////////////////////////////////////////////////
//
// pgAdmin 4 - PostgreSQL Tools
//
// Copyright (C) 2013 - 2022, The pgAdmin Development Team
// This software is released under the PostgreSQL Licence
//
//////////////////////////////////////////////////////////////
!(__WEBPACK_AMD_DEFINE_ARRAY__ = [__webpack_require__(81311), __webpack_require__(55112), __webpack_require__(19755), __webpack_require__(35816)], __WEBPACK_AMD_DEFINE_RESULT__ = (function (_, pgAdmin, $) {
  var pgBrowser = pgAdmin.Browser = pgAdmin.Browser || {},
      wcDocker = window.wcDocker,
      wcIFrame = window.wcIFrame;

  pgAdmin.Browser.Frame = function (options) {
    var defaults = ['name', 'title', 'width', 'height', 'showTitle', 'isCloseable', 'isPrivate', 'url', 'icon', 'onCreate', 'isLayoutMember'];

    _.extend(this, _.pick(options, defaults));
  };

  _.extend(pgAdmin.Browser.Frame.prototype, {
    name: '',
    title: '',
    width: 300,
    height: 600,
    showTitle: true,
    isClosable: true,
    isRenamable: false,
    isPrivate: false,
    isLayoutMember: false,
    url: '',
    icon: '',
    panel: null,
    frame: null,
    onCreate: null,
    load: function load(docker) {
      var that = this;

      if (!that.panel) {
        docker.registerPanelType(this.name, {
          title: that.title,
          isPrivate: that.isPrivate,
          isLayoutMember: that.isLayoutMember,
          onCreate: function onCreate(myPanel) {
            $(myPanel).data('pgAdminName', that.name);
            myPanel.initSize(that.width, that.height);
            if (myPanel.showTitle == false) myPanel.title(false);
            myPanel.icon(that.icon);
            myPanel.closeable(!!that.isCloseable);
            myPanel.renamable(that.isRenamable);
            var $frameArea = $('<div style="position:absolute;top:0 !important;width:100%;height:100%;display:table;z-index:0;">');
            myPanel.layout().addItem($frameArea);
            that.panel = myPanel;
            var frame = new wcIFrame($frameArea, myPanel);
            $(myPanel).data('frameInitialized', false);
            $(myPanel).data('embeddedFrame', frame);

            if (that.url != '' && that.url != 'about:blank') {
              setTimeout(function () {
                frame.openURL(that.url);
                $(myPanel).data('frameInitialized', true);
                pgBrowser.Events.trigger('pgadmin-browser:frame:urlloaded:' + that.name, frame, that.url, self);
              }, 50);
            } else {
              frame.openURL('about:blank');
              $(myPanel).data('frameInitialized', true);
              pgBrowser.Events.trigger('pgadmin-browser:frame:urlloaded:' + that.name, frame, that.url, self);
            }

            if (that.events && _.isObject(that.events)) {
              _.each(that.events, function (v, k) {
                if (v && _.isFunction(v)) {
                  myPanel.on(k, v);
                }
              });
            }

            _.each([wcDocker.EVENT.UPDATED, wcDocker.EVENT.VISIBILITY_CHANGED, wcDocker.EVENT.BEGIN_DOCK, wcDocker.EVENT.END_DOCK, wcDocker.EVENT.GAIN_FOCUS, wcDocker.EVENT.LOST_FOCUS, wcDocker.EVENT.CLOSED, wcDocker.EVENT.BUTTON, wcDocker.EVENT.ATTACHED, wcDocker.EVENT.DETACHED, wcDocker.EVENT.MOVE_STARTED, wcDocker.EVENT.MOVE_ENDED, wcDocker.EVENT.MOVED, wcDocker.EVENT.RESIZE_STARTED, wcDocker.EVENT.RESIZE_ENDED, wcDocker.EVENT.RESIZED, wcDocker.EVENT.SCROLLED], function (ev) {
              myPanel.on(ev, that.eventFunc.bind(myPanel, ev));
            });

            if (that.onCreate && _.isFunction(that.onCreate)) {
              that.onCreate.apply(that, [myPanel, frame]);
            }
          }
        });
      }
    },
    eventFunc: function eventFunc(eventName) {
      var name = $(this).data('pgAdminName');

      try {
        pgBrowser.Events.trigger('pgadmin-browser:frame', eventName, this, arguments);
        pgBrowser.Events.trigger('pgadmin-browser:frame:' + eventName, this, arguments);

        if (name) {
          pgBrowser.Events.trigger('pgadmin-browser:frame-' + name, eventName, this, arguments);
          pgBrowser.Events.trigger('pgadmin-browser:frame-' + name + ':' + eventName, this, arguments);
        }
      } catch (e) {
        console.warn(e.stack || e);
      }
    }
  });

  return pgAdmin.Browser.Frame;
}).apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__),
		__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));

/***/ }),

/***/ 50521:
/***/ ((module, exports, __webpack_require__) => {

"use strict";
var __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;

__webpack_require__(82526);

__webpack_require__(41817);

__webpack_require__(41539);

__webpack_require__(32165);

__webpack_require__(78783);

__webpack_require__(66992);

__webpack_require__(33948);

__webpack_require__(24812);

__webpack_require__(68309);

__webpack_require__(69826);

__webpack_require__(82772);

__webpack_require__(69600);

__webpack_require__(2707);

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

/////////////////////////////////////////////////////////////
//
// pgAdmin 4 - PostgreSQL Tools
//
// Copyright (C) 2013 - 2022, The pgAdmin Development Team
// This software is released under the PostgreSQL Licence
//
//////////////////////////////////////////////////////////////
!(__WEBPACK_AMD_DEFINE_ARRAY__ = [__webpack_require__(81311), __webpack_require__(55112), __webpack_require__(19755), __webpack_require__(44092), __webpack_require__(91669)], __WEBPACK_AMD_DEFINE_RESULT__ = (function (_, pgAdmin, $, pgadminUtils, gettext) {
  'use strict';

  pgAdmin.Browser = pgAdmin.Browser || {}; // Individual menu-item class

  var MenuItem = pgAdmin.Browser.MenuItem = function (opts) {
    var menu_opts = ['name', 'label', 'priority', 'module', 'callback', 'data', 'enable', 'category', 'target', 'url'
    /* Do not show icon in the menus, 'icon' */
    , 'node', 'checked', 'below', 'menu_items'],
        defaults = {
      url: '#',
      target: '_self',
      enable: true
    };

    _.extend(this, defaults, _.pick(opts, menu_opts));
  };

  _.extend(pgAdmin.Browser.MenuItem.prototype, {
    /*
     *  Keeps track of the jQuery object representing this menu-item. This will
     *  be used by the update function to enable/disable the individual item.
     */
    $el: null,

    /*
     * Generate the UI for this menu-item. enable/disable, based on the
     * currently selected object.
     */
    generate: function generate(node, item) {
      this.create_el(node, item);
      this.context = {
        name: this.label,

        /* icon: this.icon || this.module && (this.module.type), */
        disabled: this.is_disabled,
        callback: this.context_menu_callback.bind(this, item)
      };
      return this.$el;
    },

    /*
     * Create the jquery element for the menu-item.
     */
    create_el: function create_el(node, item) {
      if (this.menu_items) {
        _.each(this.menu_items, function (submenu_item) {
          submenu_item.generate(node, item);
        });

        var create_submenu = pgAdmin.Browser.MenuGroup({
          'label': this.label,
          'id': this.name
        }, this.menu_items);
        this.$el = create_submenu.$el;
      } else {
        var data_disabled = null;

        if (this.data != undefined && this.data.data_disabled != undefined) {
          data_disabled = this.data.data_disabled;
        }

        var url = $('<a></a>', {
          'id': this.name,
          'href': this.url,
          'target': this.target,
          'data-toggle': 'pg-menu',
          'role': 'menuitem',
          'data-disabled': data_disabled
        }).data('pgMenu', {
          module: this.module || pgAdmin.Browser,
          cb: this.callback,
          data: this.data
        }).addClass('dropdown-item');
        this.is_disabled = this.disabled(node, item);

        if (this.icon) {
          url.append($('<i></i>', {
            'class': this.icon
          }));
        } else if (!_.isUndefined(this.checked)) {
          url.append($('<i></i>', {
            'class': 'fa fa-check ' + (this.checked ? '' : 'visibility-hidden')
          }));
        }

        url.addClass(this.is_disabled ? ' disabled' : '');
        var textSpan = $('<span data-test="menu-item-text"></span>').text('  ' + this.label);
        url.append(textSpan);
        var mnu_element = $('<li/>').append(url); // Check if below parameter is defined and true then we need to add
        // separator.

        if (!_.isUndefined(this.below) && this.below === true) {
          mnu_element.append('<li class="dropdown-divider"></li>');
        }

        this.$el = mnu_element;
      }
    },

    /*
     * Updates the enable/disable state of the menu-item based on the current
     * selection using the disabled function. This also creates a object
     * for this menu, which can be used in the context-menu.
     */
    update: function update(node, item) {
      if (this.$el && !this.$el.find('.dropdown-item').hasClass('disabled')) {
        this.$el.find('.dropdown-item').addClass('disabled');
      }

      this.is_disabled = this.disabled(node, item);

      if (this.$el && !this.is_disabled) {
        this.$el.find('.dropdown-item').removeClass('disabled');
      }

      this.context = {
        name: this.label,

        /* icon: this.icon || (this.module && this.module.type), */
        disabled: this.is_disabled,
        callback: this.context_menu_callback.bind(this, item)
      };
    },

    /*
     * This will be called when context-menu is clicked.
     */
    context_menu_callback: function context_menu_callback(item) {
      var o = this,
          cb;

      if (o.module['callbacks'] && o.callback in o.module['callbacks']) {
        cb = o.module['callbacks'][o.callback];
      } else if (o.callback in o.module) {
        cb = o.module[o.callback];
      }

      if (cb) {
        cb.apply(o.module, [o.data, item]);
      } else {
        pgAdmin.Browser.report_error(pgadminUtils.sprintf('Developer Warning: Callback - "%s" not found!', o.cb));
      }
    },

    /*
     * Checks this menu enable/disable state based on the selection.
     */
    disabled: function disabled(node, item) {
      if (this.enable == undefined) {
        return false;
      }

      if (this.node) {
        if (!node) {
          return true;
        }

        if (_.isArray(this.node) ? _.indexOf(this.node, node) == -1 : this.node != node._type) {
          return true;
        }
      }

      if (_.isBoolean(this.enable)) return !this.enable;
      if (_.isFunction(this.enable)) return !this.enable.apply(this.module, [node, item, this.data]);
      if (this.module && _.isBoolean(this.module[this.enable])) return !this.module[this.enable];
      if (this.module && _.isFunction(this.module[this.enable])) return !this.module[this.enable].apply(this.module, [node, item, this.data]);
      return false;
    },

    /*
     * Change the checked value and update the checked icon on the menu
     */
    change_checked: function change_checked(isChecked) {
      if (!_.isUndefined(this.checked)) {
        this.checked = isChecked;

        if (this.checked) {
          this.$el.find('.fa-check').removeClass('visibility-hidden');
        } else {
          this.$el.find('.fa-check').addClass('visibility-hidden');
        }
      }
    }
  });
  /*
   * This a class for creating a menu group, mainly used by the submenu
   * creation logic.
   *
   * Arguments:
   * 1. Options to render the submenu DOM Element.
   *    i.e. label, icon, above (separator), below (separator)
   * 2. List of menu-items comes under this submenu.
   * 3. Did we rendered separator after the menu-item/submenu?
   * 4. A unique-id for this menu-item.
   *
   * Returns a object, similar to the menu-item, which has his own jQuery
   * Element, context menu representing object, etc.
   *
   */


  pgAdmin.Browser.MenuGroup = function (opts, items, prev, ctx) {
    var template = _.template(['<% if (above) { %><li class="dropdown-divider"></li><% } %>', '<li class="dropdown-submenu" role="menuitem">', ' <a href="#" class="dropdown-item">', '  <% if (icon) { %><i class="<%= icon %>"></i><% } %>', '  <span><%= label %></span>', ' </a>', ' <ul class="dropdown-menu">', ' </ul>', '</li>', '<% if (below) { %><li class="dropdown-divider"></li><% } %>'].join('\n')),
        data = {
      'label': opts.label,
      'icon': opts.icon,
      'above': opts.above && !prev,
      'below': opts.below
    },
        m,
        $el = $(template(data)),
        $menu = $el.find('.dropdown-menu'),
        submenus = {},
        ctxId = 1;

    ctx = _.uniqueId(ctx + '_sub_'); // Sort by alphanumeric ordered first

    items.sort(function (a, b) {
      return a.label.localeCompare(b.label);
    }); // Sort by priority

    items.sort(function (a, b) {
      return a.priority - b.priority;
    });

    for (var idx in items) {
      m = items[idx];
      $menu.append(m.$el);

      if (!m.is_disabled) {
        submenus[ctx + ctxId] = m.context;
      }

      ctxId++;
    }

    var is_disabled = _.size(submenus) == 0;
    return {
      $el: $el,
      priority: opts.priority || 10,
      label: opts.label,
      above: data['above'],
      below: opts.below,
      is_disabled: is_disabled,
      context: {
        name: opts.label,
        icon: opts.icon,
        items: submenus,
        disabled: is_disabled
      }
    };
  };
  /*
   * A function to generate menus (submenus) based on the categories.
   * Attach the current selected browser tree node to each of the generated
   * menu-items.
   *
   * Arguments:
   * 1. nodes_obj - Nodes object contains each node object.
   * 2. jQuery Element on which you may want to created the menus
   * 3. list of menu-items
   * 4. categories - metadata information about the categories, based on which
   *                 the submenu (menu-group) will be created (if any).
   * 5. d - Data object for the selected browser tree item.
   * 6. item - The selected browser tree item
   * 7. menu_items - A empty object on which the context menu for the given
   *                 list of menu-items.
   *
   * Returns if any menu generated for the given input.
   */


  pgAdmin.Browser.MenuCreator = function (nodes_obj, $mnu, menus, categories, d, item, menu_items) {
    var showMenu = true;
    /* We check showMenu function is defined by the respective node, if it is
     * defined then call the function which will return true or false.
     */

    if (d && nodes_obj[d._type] && !_.isUndefined(nodes_obj[d._type].showMenu)) showMenu = nodes_obj[d._type].showMenu(d, item);

    if (!showMenu) {
      menu_items = menu_items || {};
      menu_items[_.uniqueId('ctx_') + '1_1_ms'] = {
        disabled: true,
        name: gettext('No menu available for this object.')
      };
      return;
    }

    var groups = {
      'common': []
    },
        common,
        idx = 0,
        ctxId = _.uniqueId('ctx_'),
        update_menuitem = function update_menuitem(m) {
      if (m instanceof MenuItem) {
        if (m.$el) {
          m.$el.remove();
          delete m.$el;
        }

        m.generate(d, item);
        var group = groups[m.category || 'common'] = groups[m.category || 'common'] || [];
        group.push(m);
      } else {
        for (var key in m) {
          update_menuitem(m[key]);
        }
      }
    },
        ctxIdx = 1;

    for (idx in menus) {
      update_menuitem(menus[idx]);
    } // Not all menu creator requires the context menu structure.


    menu_items = menu_items || {};
    common = groups['common'];
    delete groups['common'];
    var prev = true;

    for (var name in groups) {
      var g = groups[name],
          c = categories[name] || {
        'label': name,
        single: false
      },
          menu_group = pgAdmin.Browser.MenuGroup(c, g, prev, ctxId);

      if (g.length <= 1 && !c.single) {
        prev = false;

        for (idx in g) {
          common.push(g[idx]);
        }
      } else {
        prev = g.below;
        common.push(menu_group);
      }
    } // The menus will be created based on the priority given.
    // Menu with lowest value has the highest priority. If the priority is
    // same, then - it will be ordered by label.
    // Sort by alphanumeric ordered first


    common.sort(function (a, b) {
      return a.label.localeCompare(b.label);
    }); // Sort by priority

    common.sort(function (a, b) {
      return a.priority - b.priority;
    });

    var len = _.size(common);

    for (idx in common) {
      item = common[idx];
      item.priority = item.priority || 10;
      $mnu.append(item.$el);
      var prefix = ctxId + '_' + item.priority + '_' + ctxIdx;

      if (ctxIdx != 1 && item.above && !item.is_disabled) {
        // For creatign the seprator any string will do.
        menu_items[prefix + '_ma'] = '----';
      }

      if (!item.is_disabled) {
        menu_items[prefix + '_ms'] = item.context;
      }

      if (ctxId != len && item.below && !item.is_disabled) {
        menu_items[prefix + '_mz'] = '----';
      }

      ctxIdx++;
    }

    return len > 0;
  }; // MENU PUBLIC CLASS DEFINITION
  // ==============================


  var Menu = function Menu(element, options) {
    this.$element = $(element);
    this.options = $.extend({}, Menu.DEFAULTS, options);
    this.isLoading = false;
  };

  Menu.DEFAULTS = {};

  Menu.prototype.toggle = function (ev) {
    var $parent = this.$element.closest('.dropdown-item');

    if ($parent.hasClass('disabled')) {
      ev.preventDefault();
      return false;
    }

    var d = this.$element.data('pgMenu');

    if (d.cb) {
      var cb = d.module && d.module['callbacks'] && d.module['callbacks'][d.cb] || d.module && d.module[d.cb];

      if (cb) {
        cb.apply(d.module, [d.data, pgAdmin.Browser.tree.selected()]);
        ev.preventDefault();
      } else {
        pgAdmin.Browser.report_error('Developer Warning: Callback - "' + d.cb + '" not found!');
      }
    }
  }; // BUTTON PLUGIN DEFINITION
  // ========================


  function Plugin(option, ev) {
    return this.each(function () {
      var $this = $(this);
      var data = $this.data('pg.menu');
      var options = _typeof(option) == 'object' && option;
      if (!data) $this.data('pg.menu', data = new Menu(this, options));
      data.toggle(ev);
    });
  }

  var old = $.fn.button;
  $.fn.pgmenu = Plugin;
  $.fn.pgmenu.Constructor = Menu; // BUTTON NO CONFLICT
  // ==================

  $.fn.pgmenu.noConflict = function () {
    $.fn.pgmenu = old;
    return this;
  }; // MENU DATA-API
  // =============


  $(document).on('click.pg.menu.data-api', '[data-toggle^="pg-menu"]', function (ev) {
    var $menu = $(ev.target);
    if (!$menu.hasClass('dropdown-item')) $menu = $menu.closest('.dropdown-item');
    Plugin.call($menu, 'toggle', ev);
  }).on('focus.pg.menu.data-api blur.pg.menu.data-api', '[data-toggle^="pg-menu"]', function (ev) {
    $(ev.target).closest('.menu').toggleClass('focus', /^focus(in)?$/.test(ev.type));
  }).on('mouseenter', '.dropdown-submenu', function (ev) {
    $(ev.currentTarget).removeClass('dropdown-submenu-visible').addClass('dropdown-submenu-visible');
    $(ev.currentTarget).find('.dropdown-menu').first().addClass('show');
  }).on('mouseleave', '.dropdown-submenu', function (ev) {
    $(ev.currentTarget).removeClass('dropdown-submenu-visible');
    $(ev.currentTarget).find('.dropdown-menu').first().removeClass('show');
  }).on('hidden.bs.dropdown', function (ev) {
    $(ev.target).find('.dropdown-submenu.dropdown-submenu-visible').removeClass('dropdown-submenu-visible').find('.dropdown-menu.show').removeClass('show');
  });
  return pgAdmin.Browser.MenuItem;
}).apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__),
		__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));

/***/ }),

/***/ 66235:
/***/ ((module, exports, __webpack_require__) => {

"use strict";
var __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;

__webpack_require__(24812);

__webpack_require__(41539);

__webpack_require__(66992);

__webpack_require__(33948);

__webpack_require__(82772);

__webpack_require__(69826);

__webpack_require__(32564);

__webpack_require__(26699);

__webpack_require__(32023);

__webpack_require__(23123);

__webpack_require__(74916);

__webpack_require__(69600);

__webpack_require__(5735);

__webpack_require__(83753);

__webpack_require__(3843);

__webpack_require__(83710);

var _node_view = __webpack_require__(49929);

var _Notifier = _interopRequireDefault(__webpack_require__(55958));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/////////////////////////////////////////////////////////////
//
// pgAdmin 4 - PostgreSQL Tools
//
// Copyright (C) 2013 - 2022, The pgAdmin Development Team
// This software is released under the PostgreSQL Licence
//
//////////////////////////////////////////////////////////////
!(__WEBPACK_AMD_DEFINE_ARRAY__ = [__webpack_require__(28008), __webpack_require__(91669), __webpack_require__(19755), __webpack_require__(81311), __webpack_require__(55112), __webpack_require__(50521), __webpack_require__(72316), __webpack_require__(55455), __webpack_require__(30794), __webpack_require__(95283), __webpack_require__(61329), __webpack_require__(68363), __webpack_require__(44092), __webpack_require__(96481), __webpack_require__(12030)], __WEBPACK_AMD_DEFINE_RESULT__ = (function (url_for, gettext, $, _, pgAdmin, Menu, Backbone, Alertify, pgBrowser, Backform, generateUrl, help, commonUtils) {
  var wcDocker = window.wcDocker,
      keyCode = {
    ENTER: 13,
    ESCAPE: 27,
    F1: 112
  }; // It has already been defined.
  // Avoid running this script again.

  if (pgBrowser.Node) return pgBrowser.Node;
  pgBrowser.Nodes = pgBrowser.Nodes || {}; // A helper (base) class for all the nodes, this has basic
  // operations/callbacks defined for basic operation.

  pgBrowser.Node = function () {}; // Helper function to correctly set up the property chain, for subclasses.
  // Uses a hash of class properties to be extended.
  //
  // It is unlikely - we will instantiate an object for this class.
  // (Inspired by Backbone.extend function)


  pgBrowser.Node.extend = function (props, initialize) {
    var parent = this;
    var child; // The constructor function for the new subclass is defined to simply call
    // the parent's constructor.

    child = function child() {
      return parent.apply(this, arguments);
    }; // Add static properties to the constructor function, if supplied.


    _.extend(child, parent, _.omit(props, 'callbacks')); // Make sure - a child have all the callbacks of the parent.


    child.callbacks = _.extend({}, parent.callbacks, props.callbacks); // Let's not bind the callbacks, or initialize the child.

    if (initialize === false) return child;

    var bindToChild = function bindToChild(cb) {
      if (typeof child.callbacks[cb] == 'function') {
        child.callbacks[cb] = child.callbacks[cb].bind(child);
      }
    },
        callbacks = _.keys(child.callbacks);

    for (var idx = 0; idx < callbacks.length; idx++) {
      bindToChild(callbacks[idx]);
    } // Registering the node by calling child.Init(...) function


    child.Init.apply(child); // Initialize the parent

    this.Init.apply(child);
    return child;
  };

  _.extend(pgAdmin.Browser.Node, Backbone.Events, {
    // Node type
    type: undefined,
    // Label
    label: '',
    // Help pages
    sqlAlterHelp: '',
    sqlCreateHelp: '',
    dialogHelp: '',
    epasHelp: false,
    title: function title(o, d) {
      return o.label + (d ? ' - ' + d.label : '');
    },
    hasId: true,
    ///////
    // Initialization function
    // Generally - used to register the menus for this type of node.
    //
    // Also, look at pgAdmin.Browser.add_menus(...) function.
    //
    // NOTE: Override this for each node for initialization purpose
    Init: function Init() {
      var self = this;
      if (self.node_initialized) return;
      self.node_initialized = true;
      pgAdmin.Browser.add_menus([{
        name: 'refresh',
        node: self.type,
        module: self,
        applies: ['object', 'context'],
        callback: 'refresh',
        priority: 1,
        label: gettext('Refresh'),
        icon: 'fa fa-sync-alt'
      }]);

      if (self.canEdit) {
        pgAdmin.Browser.add_menus([{
          name: 'show_obj_properties',
          node: self.type,
          module: self,
          applies: ['object', 'context'],
          callback: 'show_obj_properties',
          priority: 999,
          label: gettext('Properties...'),
          data: {
            'action': 'edit'
          },
          icon: 'fa fa-edit',
          enable: _.isFunction(self.canEdit) ? function () {
            return !!self.canEdit.apply(self, arguments);
          } : !!self.canEdit
        }]);
      }

      if (self.canDrop) {
        pgAdmin.Browser.add_menus([{
          name: 'delete_object',
          node: self.type,
          module: self,
          applies: ['object', 'context'],
          callback: 'delete_obj',
          priority: self.dropPriority,
          label: self.dropAsRemove ? gettext('Remove %s', self.label) : gettext('Delete/Drop'),
          data: {
            'url': 'drop',
            data_disabled: gettext('The selected tree node does not support this option.')
          },
          icon: 'fa fa-trash-alt',
          enable: _.isFunction(self.canDrop) ? function () {
            return !!self.canDrop.apply(self, arguments);
          } : !!self.canDrop
        }]);

        if (self.canDropCascade) {
          pgAdmin.Browser.add_menus([{
            name: 'delete_object_cascade',
            node: self.type,
            module: self,
            applies: ['object', 'context'],
            callback: 'delete_obj',
            priority: 3,
            label: gettext('Drop Cascade'),
            data: {
              'url': 'delete'
            },
            icon: 'fa fa-trash-alt',
            enable: _.isFunction(self.canDropCascade) ? function () {
              return self.canDropCascade.apply(self, arguments);
            } : !!self.canDropCascade
          }]);
        }
      } // Show query tool only in context menu of supported nodes.


      if (_.indexOf(pgAdmin.unsupported_nodes, self.type) == -1) {
        var enable = function enable(itemData) {
          if (itemData._type == 'database' && itemData.allowConn) return true;else if (itemData._type != 'database') return true;else return false;
        };

        pgAdmin.Browser.add_menus([{
          name: 'show_query_tool',
          node: self.type,
          module: self,
          applies: ['context'],
          callback: 'show_query_tool',
          priority: 998,
          label: gettext('Query Tool'),
          icon: 'pg-font-icon icon-query_tool',
          enable: enable
        }]); // show search objects same as query tool

        pgAdmin.Browser.add_menus([{
          name: 'search_objects',
          node: self.type,
          module: pgAdmin.SearchObjects,
          applies: ['context'],
          callback: 'show_search_objects',
          priority: 997,
          label: gettext('Search Objects...'),
          icon: 'fa fa-search',
          enable: enable
        }]);

        if (pgAdmin['enable_psql']) {
          // show psql tool same as query tool.
          pgAdmin.Browser.add_menus([{
            name: 'show_psql_tool',
            node: this.type,
            module: this,
            applies: ['context'],
            callback: 'show_psql_tool',
            priority: 998,
            label: gettext('PSQL Tool'),
            icon: 'fas fa-terminal'
          }]);
        }
      } // This will add options of scripts eg:'CREATE Script'


      if (self.hasScriptTypes && _.isArray(self.hasScriptTypes) && self.hasScriptTypes.length > 0) {
        // For each script type create menu
        _.each(self.hasScriptTypes, function (stype) {
          var type_label = gettext('%s Script', stype.toUpperCase());
          stype = stype.toLowerCase(); // Adding menu for each script type

          pgAdmin.Browser.add_menus([{
            name: 'show_script_' + stype,
            node: self.type,
            module: self,
            applies: ['object', 'context'],
            callback: 'show_script',
            priority: 4,
            label: type_label,
            category: gettext('Scripts'),
            data: {
              'script': stype,
              data_disabled: gettext('The selected tree node does not support this option.')
            },
            icon: 'fa fa-pencil-alt',
            enable: self.check_user_permission
          }]);
        });
      }
    },
    ///////
    // Checks if Script Type is allowed to user
    // First check if role node & create role allowed
    // Otherwise test rest of database objects
    // if no permission matched then do not allow create script
    ///////
    check_user_permission: function check_user_permission(itemData, item, data) {
      // Do not display CREATE script on server group and server node
      if (itemData._type == 'server_group' || itemData._type == 'server') {
        return false;
      } // Do not display the menu if the database connection is not allowed


      if (itemData._type == 'database' && !itemData.allowConn) return false;
      var parentData = pgBrowser.tree.getTreeNodeHierarchy(item);

      if (_.indexOf(['create', 'insert', 'update', 'delete'], data.script) != -1) {
        if (itemData.type == 'role' && parentData.server.user.can_create_role) {
          return true;
        } else if (parentData.server && (parentData.server.user.is_superuser || parentData.server.user.can_create_db) || parentData.schema && parentData.schema.can_create) {
          return true;
        } else {
          return false;
        }
      } else {
        return true;
      }
    },
    ///////
    // Generate a Backform view using the node's model type
    //
    // Used to generate view for the particular node properties, edit,
    // creation.
    getView: function getView(item, type, el, node, formType, callback, ctx, cancelFunc) {
      var that = this;
      if (!this.type || this.type == '') // We have no information, how to generate view for this type.
        return null;

      if (this.model) {
        // This will be the URL, used for object manipulation.
        // i.e. Create, Update in these cases
        var urlBase = this.generate_url(item, type, node, false, null, that.url_jump_after_node);
        if (!urlBase) // Ashamed of myself, I don't know how to manipulate this
          // node.
          return null;
        var attrs = {}; // In order to get the object data from the server, we must set
        // object-id in the model (except in the create mode).

        if (type !== 'create') {
          attrs[this.model.idAttribute || this.model.prototype.idAttribute || 'id'] = node._id;
        } // We know - which data model to be used for this object.


        var info = pgBrowser.tree.getTreeNodeHierarchy(item),
            newModel = new (this.model.extend({
          urlRoot: urlBase
        }))(attrs, {
          node_info: info
        }),
            fields = Backform.generateViewSchema(info, newModel, type, this, node);

        if (type == 'create' || type == 'edit') {
          if (callback && ctx) {
            callback = callback.bind(ctx);
          } else {
            callback = function callback() {
              console.warn('Broke something!!! Why we don\'t have the callback or the context???');
            };
          }

          var onSessionInvalid = function onSessionInvalid(msg) {
            var alertMessage = "\n            <div class=\"error-in-footer\">\n              <div class=\"d-flex px-2 py-1\">\n                <div class=\"pr-2\">\n                  <i class=\"fa fa-exclamation-triangle text-danger\" aria-hidden=\"true\" role=\"img\"></i>\n                </div>\n                <div role=\"alert\" class=\"alert-text\">".concat(msg, "</div>\n                <div class=\"ml-auto close-error-bar\">\n                  <a class=\"close-error fa fa-times text-danger\"></a>\n                </div>\n              </div>\n            </div>");

            if (!_.isUndefined(that.statusBar)) {
              that.statusBar.html(alertMessage).css('visibility', 'visible');
              that.statusBar.find('a.close-error').bind('click', function () {
                this.empty().css('visibility', 'hidden');
              }.bind(that.statusBar));
            }

            var sessHasChanged = false;

            if (this.sessChanged && this.sessChanged()) {
              sessHasChanged = true;
            }

            callback(true, sessHasChanged);
            return true;
          };

          var onSessionValidated = function onSessionValidated(sessHasChanged) {
            if (!_.isUndefined(that.statusBar)) {
              that.statusBar.empty().css('visibility', 'hidden');
            }

            callback(false, sessHasChanged);
          };

          callback(false, false);
          newModel.on('pgadmin-session:valid', onSessionValidated);
          newModel.on('pgadmin-session:invalid', onSessionInvalid);
        } // 'schema' has the information about how to generate the form.


        if (_.size(fields)) {
          // This will contain the actual view
          var view;

          if (formType == 'fieldset') {
            // It is used to show, edit, create the object in the
            // properties tab.
            view = new Backform.Accordian({
              el: el,
              model: newModel,
              schema: fields
            });
          } else {
            // This generates a view to be used by the node dialog
            // (for create/edit operation).
            view = new Backform.Dialog({
              el: el,
              model: newModel,
              schema: fields
            });
          }

          var setFocusOnEl = function setFocusOnEl() {
            var container = $(el).find('.tab-content:first > .tab-pane.active:first');
            commonUtils.findAndSetFocus(container);
          };

          if (!newModel.isNew()) {
            // This is definetely not in create mode
            var msgDiv = '<div role="status" class="pg-panel-message pg-panel-properties-message">' + gettext('Retrieving data from the server...') + '</div>',
                $msgDiv = $(msgDiv);
            var timer = setTimeout(function (_ctx) {
              // notify user if request is taking longer than 1 second
              if (!_.isUndefined(_ctx)) {
                $msgDiv.appendTo(_ctx);
              }
            }, 1000, ctx);

            var fetchAjaxHook = function fetchAjaxHook() {
              newModel.fetch({
                success: function success() {
                  // Clear timeout and remove message
                  clearTimeout(timer);
                  $msgDiv.addClass('d-none'); // We got the latest attributes of the object. Render the view
                  // now.

                  view.render();
                  setFocusOnEl();
                  newModel.startNewSession();
                },
                error: function error(model, xhr, options) {
                  var _label = that && item ? pgBrowser.tree.getTreeNodeHierarchy(item)[that.type].label : '';

                  pgBrowser.Events.trigger('pgadmin:node:retrieval:error', 'properties', xhr, options.textStatus, options.errorThrown, item);

                  if (!Alertify.pgHandleItemError(xhr, options.textStatus, options.errorThrown, {
                    item: item,
                    info: info
                  })) {
                    _Notifier["default"].pgNotifier(options.textStatus, xhr, gettext('Error retrieving properties - %s', options.errorThrown || _label), function (msg) {
                      if (msg === 'CRYPTKEY_SET') {
                        fetchAjaxHook();
                      } else {
                        console.warn(arguments);
                      }
                    });
                  } // Close the panel (if could not fetch properties)


                  if (cancelFunc) {
                    cancelFunc();
                  }
                }
              });
            };

            fetchAjaxHook();
          } else {
            // Yay - render the view now!
            view.render();
            setFocusOnEl();
            newModel.startNewSession();
          }
        }

        return view;
      }

      return null;
    },
    addUtilityPanel: function addUtilityPanel(width, height) {
      var body = window.document.body,
          el = document.createElement('div');
      body.insertBefore(el, body.firstChild);
      var new_panel = pgBrowser.docker.addPanel('utility_props', window.wcDocker.DOCK.FLOAT, undefined, {
        w: !_.isUndefined(width) && !_.isNull(width) ? width : screen.width < 700 ? screen.width * 0.95 : screen.width * 0.5,
        h: !_.isUndefined(height) && !_.isNull(height) ? height : screen.height < 500 ? screen.height * 0.95 : screen.height * 0.4,
        x: screen.width < 700 ? '2%' : '25%',
        y: screen.height < 500 ? '2%' : '25%'
      });
      /*set movable false to prevent dialog from docking,
      by setting this we can able to move the dialog but can't dock it
      in to the frame. e.g: can't dock it in to properties and other tabs. */

      setTimeout(function () {
        new_panel.moveable(false);
      }, 0);
      body.removeChild(el);
      return new_panel;
    },
    registerUtilityPanel: function registerUtilityPanel() {
      var w = pgBrowser.docker,
          p = w.findPanels('utility_props');
      if (p && p.length == 1) return;
      var events = {};

      events[wcDocker.EVENT.RESIZE_ENDED] = function () {
        var $container = this.$container.find('.obj_properties').first(),
            v = $container.data('obj-view');

        if (v && v.model && v.model) {
          v.model.trigger('pg-browser-resized', {
            'view': v,
            'panel': this,
            'container': $container
          });
        }
      };

      p = new pgBrowser.Panel({
        name: 'utility_props',
        showTitle: true,
        isCloseable: true,
        isPrivate: true,
        isLayoutMember: false,
        canMaximise: true,
        elContainer: true,
        content: '<div class="obj_properties container-fluid h-100"><div role="status" class="pg-panel-message">' + gettext('Please wait while we fetch information ...') + '</div></div>',
        onCreate: function onCreate(myPanel, $container) {
          $container.addClass('pg-no-overflow');
        },
        events: events
      });
      p.load(pgBrowser.docker);
    },
    register_node_panel: function register_node_panel() {
      var w = pgBrowser.docker,
          p = w.findPanels('node_props');
      if (p && p.length == 1) return;
      var events = {};

      events[wcDocker.EVENT.RESIZE_ENDED] = function () {
        var $container = this.$container.find('.obj_properties').first(),
            v = $container.data('obj-view');

        if (v && v.model && v.model) {
          v.model.trigger('pg-browser-resized', {
            'view': v,
            'panel': this,
            'container': $container
          });
        }
      };

      p = new pgBrowser.Panel({
        name: 'node_props',
        showTitle: true,
        isCloseable: true,
        isPrivate: true,
        isLayoutMember: false,
        canMaximise: true,
        elContainer: true,
        content: '<div class="obj_properties container-fluid h-100"><div role="status" class="pg-panel-message">' + gettext('Please wait while we fetch information about the node from the server...') + '</div></div>',
        onCreate: function onCreate(myPanel, $container) {
          $container.addClass('pg-no-overflow');
        },
        events: events
      });
      p.load(pgBrowser.docker);
    },

    /*
     * Default script type menu for node.
     *
     * Override this, to show more script type menus (e.g hasScriptTypes: ['create', 'select', 'insert', 'update', 'delete'])
     *
     * Or set it to empty array to disable script type menu on node (e.g hasScriptTypes: [])
     */
    hasScriptTypes: ['create'],

    /******************************************************************
     * This function determines the given item is editable or not.
     *
     * Override this, when a node is not editable.
     */
    canEdit: true,

    /******************************************************************
     * This function determines the given item is deletable or not.
     *
     * Override this, when a node is not deletable.
     */
    canDrop: false,

    /************************************************************************
     * This function determines the given item and children are deletable or
     * not.
     *
     * Override this, when a node is not deletable.
     */
    canDropCascade: false,

    /*********************************************************************************
    dropAsRemove should be true in case, Drop object label needs to be replaced by Remove
    */
    dropAsRemove: false,

    /******************************************************************************
    dropPriority is set to 2 by default, override it when change is required
    */
    dropPriority: 2,

    /******************************************************************************
    select collection node on deletion.
    */
    selectParentNodeOnDelete: false,
    // List of common callbacks - that can be used for different
    // operations!
    callbacks: {
      /******************************************************************
       * This function allows to create/edit/show properties of any
       * object depending on the arguments provided.
       *
       * args must be a object containing:
       *   action - create/edit/properties
       *   item   - The properties of the item (tree node item)
       *
       * NOTE:
       * if item is not provided, the action will be done on the
       * currently selected tree item node.
       *
       **/
      show_obj_properties: function show_obj_properties(args, item) {
        var t = pgBrowser.tree,
            i = args && args.item || item || t.selected(),
            d = i ? t.itemData(i) : undefined,
            o = this,
            l = o.title.apply(this, [d]); // Make sure - the properties dialog type registered

        pgBrowser.Node.register_node_panel(); // No node selected.

        if (!d) return;

        var self = this,
            isParent = _.isArray(this.parent_type) ? function (_d) {
          return _.indexOf(self.parent_type, _d._type) != -1;
        } : function (_d) {
          return self.parent_type == _d._type;
        },
            addPanel = function addPanel() {
          var body = window.document.body,
              el = document.createElement('div');
          body.insertBefore(el, body.firstChild);
          var w, h, x, y;

          if (screen.width < 800) {
            w = pgAdmin.toPx(el, '95%', 'width', true);
          } else {
            w = pgAdmin.toPx(el, self.width || pgBrowser.stdW["default"] + 'px', 'width', true);
            /* Fit to standard sizes */

            if (w <= pgBrowser.stdW.sm) {
              w = pgBrowser.stdW.sm;
            } else {
              if (w <= pgBrowser.stdW.md) {
                w = pgBrowser.stdW.md;
              } else {
                w = pgBrowser.stdW.lg;
              }
            }
          }

          if (screen.height < 600) {
            h = pgAdmin.toPx(el, '95%', 'height', true);
          } else {
            h = pgAdmin.toPx(el, self.height || pgBrowser.stdH["default"] + 'px', 'height', true);
            /* Fit to standard sizes */

            if (h <= pgBrowser.stdH.sm) {
              h = pgBrowser.stdH.sm;
            } else {
              if (h <= pgBrowser.stdH.md) {
                h = pgBrowser.stdH.md;
              } else {
                h = pgBrowser.stdH.lg;
              }
            }
          }

          x = (body.offsetWidth - w) / 2;
          y = (body.offsetHeight - h) / 4; // If the screen resolution is higher, but - it is zoomed, dialog
          // may be go out of window, and will not be accessible through the
          // keyboard.

          if (w > window.innerWidth) {
            x = 0;
            w = window.innerWidth;
          }

          if (h > window.innerHeight) {
            y = 0;
            h = window.innerHeight;
          }

          var new_panel = pgBrowser.docker.addPanel('node_props', wcDocker.DOCK.FLOAT, undefined, {
            w: w + 'px',
            h: h + 'px',
            x: x + 'px',
            y: y + 'px'
          });
          body.removeChild(el);
          return new_panel;
        };

        if (args.action == 'create') {
          // If we've parent, we will get the information of it for
          // proper object manipulation.
          //
          // You know - we're working with RDBMS, relation is everything
          // for us.
          if (self.parent_type && !isParent(d)) {
            // In browser tree, I can be under any node, But - that
            // does not mean, it is my parent.
            //
            // We have some group nodes too.
            //
            // i.e.
            // Tables, Views, etc. nodes under Schema node
            //
            // And, actual parent of a table is schema, not Tables.
            while (i && t.hasParent(i)) {
              i = t.parent(i);
              var pd = t.itemData(i);

              if (isParent(pd)) {
                // Assign the data, this is my actual parent.
                d = pd;
                break;
              }
            }
          } // Seriously - I really don't have parent data present?
          //
          // The only node - which I know - who does not have parent
          // node, is the Server Group (and, comes directly under root
          // node - which has no parent.)


          if (!d || this.parent_type != null && !isParent(d)) {
            // It should never come here.
            // If it is here, that means - we do have some bug in code.
            return;
          }

          l = gettext('Create - %s', this.label);
          p = addPanel();
          setTimeout(function () {
            o.showProperties(i, d, p, args.action);
          }, 10);
        } else {
          if (pgBrowser.Node.panels && pgBrowser.Node.panels[d.id] && pgBrowser.Node.panels[d.id].$container) {
            var p = pgBrowser.Node.panels[d.id];
            /**  TODO ::
             *  Run in edit mode (if asked) only when it is
             *  not already been running edit mode
             **/

            var mode = p.$container.attr('action-mode');

            if (mode) {
              var msg = gettext('Are you sure want to stop editing the properties of %s "%s"?');

              if (args.action == 'edit') {
                msg = gettext('Are you sure want to reset the current changes and re-open the panel for %s "%s"?');
              }

              _Notifier["default"].confirm(gettext('Edit in progress?'), commonUtils.sprintf(msg, o.label.toLowerCase(), d.label), function () {
                setTimeout(function () {
                  o.showProperties(i, d, p, args.action);
                }, 10);
              }, null).show();
            } else {
              setTimeout(function () {
                o.showProperties(i, d, p, args.action);
              }, 10);
            }
          } else {
            pgBrowser.Node.panels = pgBrowser.Node.panels || {};
            p = pgBrowser.Node.panels[d.id] = addPanel();
            setTimeout(function () {
              o.showProperties(i, d, p, args.action);
            }, 10);
          }
        }

        p.title(l);
        p.icon('icon-' + this.type); // Make sure the properties dialog is visible

        p.focus();
      },
      // Delete the selected object
      delete_obj: function delete_obj(args, item) {
        var input = args || {
          'url': 'drop'
        },
            obj = this,
            t = pgBrowser.tree,
            i = input.item || item || t.selected(),
            d = i ? t.itemData(i) : undefined;
        if (!d) return;
        /*
         * Make sure - we're using the correct version of node
         */

        obj = pgBrowser.Nodes[d._type];

        var objName = _.unescape(d.label);

        var msg, title;

        if (input.url == 'delete') {
          msg = gettext('Are you sure you want to drop %s "%s" and all the objects that depend on it?', obj.label.toLowerCase(), d.label);
          title = gettext('DROP CASCADE %s?', obj.label);

          if (!(_.isFunction(obj.canDropCascade) ? obj.canDropCascade.apply(obj, [d, i]) : obj.canDropCascade)) {
            _Notifier["default"].error(gettext('The %s "%s" cannot be dropped.', obj.label, d.label), 10000);

            return;
          }
        } else {
          if (obj.dropAsRemove) {
            msg = gettext('Are you sure you want to remove %s "%s"?', obj.label.toLowerCase(), d.label);
            title = gettext('Remove %s?', obj.label);
          } else {
            msg = gettext('Are you sure you want to drop %s "%s"?', obj.label.toLowerCase(), d.label);
            title = gettext('Drop %s?', obj.label);
          }

          if (!(_.isFunction(obj.canDrop) ? obj.canDrop.apply(obj, [d, i]) : obj.canDrop)) {
            _Notifier["default"].error(gettext('The %s "%s" cannot be dropped/removed.', obj.label, d.label), 10000);

            return;
          }
        }

        _Notifier["default"].confirm(title, msg, function () {
          $.ajax({
            url: obj.generate_url(i, input.url, d, true),
            type: 'DELETE'
          }).done(function (res) {
            if (res.success == 2) {
              _Notifier["default"].error(res.info, null);

              return;
            }

            if (res.success == 0) {
              pgBrowser.report_error(res.errormsg, res.info);
            } else {
              // Remove the node from tree and set collection node as selected.
              var selectNextNode = true;

              if (obj.selectParentNodeOnDelete) {
                var prv_i = t.parent(i);
                setTimeout(function () {
                  t.select(prv_i);
                }, 10);
                selectNextNode = false;
              }

              pgBrowser.removeTreeNode(i, selectNextNode);
            }

            return true;
          }).fail(function (jqx) {
            var errmsg = jqx.responseText;
            /* Error from the server */

            if (jqx.status == 417 || jqx.status == 410 || jqx.status == 500) {
              try {
                var data = JSON.parse(jqx.responseText);
                errmsg = data.info || data.errormsg;
              } catch (e) {
                console.warn(e.stack || e);
              }
            }

            pgBrowser.report_error(gettext('Error dropping/removing %s: "%s"', obj.label, objName), errmsg);
          });
        });
      },
      // Callback for creating script(s) & opening them in Query editor
      show_script: function show_script(args, item) {
        var scriptType = args.script,
            obj,
            t = pgBrowser.tree,
            i = item || t.selected(),
            d = i ? t.itemData(i) : undefined;
        if (!d) return;
        /*
         * Make sure - we're using the correct version of node
         */

        obj = pgBrowser.Nodes[d._type];
        var sql_url; // URL for script type

        if (scriptType == 'insert') {
          sql_url = 'insert_sql';
        } else if (scriptType == 'update') {
          sql_url = 'update_sql';
        } else if (scriptType == 'delete') {
          sql_url = 'delete_sql';
        } else if (scriptType == 'select') {
          sql_url = 'select_sql';
        } else if (scriptType == 'exec') {
          sql_url = 'exec_sql';
        } else {
          // By Default get CREATE SQL
          sql_url = 'sql';
        } // Open data grid & pass the URL for fetching


        pgAdmin.DataGrid.show_query_tool(obj.generate_url(i, sql_url, d, true), i, scriptType);
      },
      // Callback to render query editor
      show_query_tool: function show_query_tool(args, item) {
        var preference = pgBrowser.get_preference('sqleditor', 'copy_sql_to_query_tool');
        var t = pgBrowser.tree,
            i = item || t.selected(),
            d = i ? t.itemData(i) : undefined;
        if (!d) return; // Here call data grid method to render query tool
        //Open query tool with create script if copy_sql_to_query_tool is true else open blank query tool

        if (preference.value && !d._type.includes('coll-')) {
          var stype = d._type.toLowerCase();

          var data = {
            'script': stype,
            data_disabled: gettext('The selected tree node does not support this option.')
          };
          pgBrowser.Node.callbacks.show_script(data);
        } else {
          pgAdmin.DataGrid.show_query_tool('', i);
        }
      },
      // Callback to render psql tool.
      show_psql_tool: function show_psql_tool(args) {
        var input = args || {},
            t = pgBrowser.tree,
            i = input.item || t.selected(),
            d = i ? t.itemData(i) : undefined;
        pgBrowser.psql.psql_tool(d, i, true);
      },
      // Logic to change the server background colour
      // There is no way of applying CSS to parent element so we have to
      // do it via JS code only
      change_server_background: function change_server_background(item, data) {
        if (!item || !data) return;
        var treeH = pgBrowser.tree.getTreeNodeHierarchy(item);
        var serverData = treeH['server'];

        if (!serverData) {
          return;
        }

        var index = item.path.indexOf(serverData.id); // Go further only if node type is a Server

        if (index !== -1) {
          // First element will be icon and second will be colour code
          var bgcolor = serverData.icon.split(' ')[1] || null,
              fgcolor = serverData.icon.split(' ')[2] || '';

          if (bgcolor) {
            var dynamic_class = 'pga_server_' + serverData._id + '_bgcolor',
                style_tag; // Prepare dynamic style tag

            style_tag = '<style id=' + dynamic_class + ' type=\'text/css\'> \n';
            style_tag += '.' + dynamic_class + ' .file-label {';
            style_tag += ' border-radius: 3px; margin-bottom: 2px;';
            style_tag += ' background: ' + bgcolor + ' !important;} \n';

            if (fgcolor) {
              style_tag += '.' + dynamic_class + ' span.file-name {';
              style_tag += ' color: ' + fgcolor + ' !important;} \n';
            }

            style_tag += '</style>'; // Prepare dynamic style tag using template

            $('#' + dynamic_class).remove();
            $(style_tag).appendTo('head'); // Add dynamic class to the tree node.

            pgBrowser.tree.addCssClass(item, dynamic_class);
          }
        }
      },
      added: function added(item, data) {
        pgBrowser.Events.trigger('pgadmin:browser:tree:expand-from-previous-tree-state', item);
        pgBrowser.Node.callbacks.change_server_background(item, data);
      },
      // Callback called - when a node is selected in browser tree.
      selected: function selected(item, data, browser) {
        // Show the information about the selected node in the below panels,
        // which are visible at this time:
        // + Properties
        // + Query (if applicable, otherwise empty)
        // + Dependents
        // + Dependencies
        // + Statistics
        var b = browser || pgBrowser,
            t = b.tree,
            d = data || t.itemData(item); // Update the menu items

        pgAdmin.Browser.enable_disable_menus.apply(b, [item]);

        if (d && b) {
          if ('properties' in b.panels && b.panels['properties'] && b.panels['properties'].panel && b.panels['properties'].panel.isVisible()) {
            // Show object properties (only when the 'properties' tab
            // is active).
            this.showProperties(item, d, b.panels['properties'].panel);
          }
        }

        pgBrowser.Events.trigger('pgadmin:browser:tree:update-tree-state', item);
        return true;
      },
      removed: function removed(item) {
        var self = this;
        setTimeout(function () {
          self.clear_cache.apply(self, item);
        }, 0);
      },
      refresh: function refresh(cmd, _item) {
        var self = this,
            t = pgBrowser.tree,
            data = _item && t.itemData(_item);

        $(pgBrowser.panels['properties'].panel).removeData('node-prop');
        pgBrowser.Events.trigger('pgadmin:browser:tree:refresh', _item || pgBrowser.tree.selected(), {
          success: function success() {
            self.callbacks.selected.apply(self, [_item, data, pgBrowser]);
          }
        });
      },
      opened: function opened(item) {
        var tree = pgBrowser.tree,
            auto_expand = pgBrowser.get_preference('browser', 'auto_expand_sole_children');

        if (auto_expand && auto_expand.value == true && tree.children(item).length == 1) {
          // Automatically expand the child node, if a treeview node has only a single child.
          var first_child = tree.first(item);

          if (first_child._loaded == true) {
            tree.open(first_child);
          } else {
            var openSoleItem = setInterval(function () {
              if (first_child._loaded) {
                tree.open(first_child);
                clearSoleItemInterval();
              }
            }, 200);

            var clearSoleItemInterval = function clearSoleItemInterval() {
              clearInterval(openSoleItem);
            };
          }
        }

        pgBrowser.Events.trigger('pgadmin:browser:tree:update-tree-state', item);
      },
      closed: function closed(item) {
        pgBrowser.Events.trigger('pgadmin:browser:tree:remove-from-tree-state', item);
      }
    },

    /**********************************************************************
     * A hook (not a callback) to show object properties in given HTML
     * element.
     *
     * This has been used for the showing, editing properties of the node.
     * This has also been used for creating a node.
     **/
    showProperties: function showProperties(item, data, panel, action) {
      var that = this,
          tree = pgAdmin.Browser.tree,
          j = panel.$container.find('.obj_properties').first(),
          view = j.data('obj-view'),
          content = $('<div></div>').addClass('pg-prop-content col-12'),
          confirm_close = true; // Handle key press events for Cancel, save and help button

      var handleKeyDown = function (event, context) {
        // If called on panel other than node_props, return
        if (panel && panel['_type'] !== 'node_props') return;

        switch (event.which) {
          case keyCode.ESCAPE:
            closePanel(true);
            break;

          case keyCode.ENTER:
            // Return if event is fired from child element
            if (event.target !== context) return;

            if (view && view.model && view.model.sessChanged()) {
              var btn = $(event.target).closest('.obj_properties').find('.pg-prop-btn-group').find('button.btn-primary');
              onSave.call(this, view, btn);
            }

            break;

          case keyCode.F1:
            onDialogHelp();
            break;

          default:
            break;
        }
      }.bind(panel);

      setTimeout(function () {
        // Register key press events with panel element
        panel.$container.find('.backform-tab').on('keydown', function (event) {
          handleKeyDown(event, this);
        });
      }, 200); // wait for panel tab to render
      // Template function to create the status bar

      var createStatusBar = function (location) {
        var statusBar = $('<div role="status"></div>').addClass('pg-prop-status-bar').appendTo(j);
        statusBar.css('visibility', 'hidden');

        if (location == 'header') {
          statusBar.appendTo(that.header);
        } else {
          statusBar.prependTo(that.footer);
        }

        that.statusBar = statusBar;
        return statusBar;
      }.bind(panel),
          // Template function to create the button-group
      createButtons = function (buttons, location, extraClasses) {
        // Arguments must be non-zero length array of type
        // object, which contains following attributes:
        // label, type, extraClasses, register
        if (buttons && _.isArray(buttons) && buttons.length > 0) {
          // All buttons will be created within a single
          // div area.
          var btnGroup = $('<div class="pg-prop-btn-group"></div>'),
              // Template used for creating a button
          tmpl = _.template(['<button tabindex="0" type="<%= type %>" ', 'class="btn <%=extraClasses.join(\' \')%>"', '<% if (disabled) { %> disabled="disabled"<% } %> title="<%-tooltip%>"', '<% if (label != "") {} else { %> aria-label="<%-tooltip%>"<% } %> >', '<span class="<%= icon %>"></span><% if (label != "") { %>&nbsp;<%-label%><% } %></button>'].join(' '));

          if (location == 'header') {
            btnGroup.appendTo(that.header);
          } else {
            btnGroup.appendTo(that.footer);
          }

          if (extraClasses) {
            btnGroup.addClass(extraClasses);
          }

          _.each(buttons, function (btn) {
            // Create the actual button, and append to
            // the group div
            // icon may not present for this button
            if (!btn.icon) {
              btn.icon = '';
            }

            var b = $(tmpl(btn));
            btnGroup.append(b); // Register is a callback to set callback
            // for certain operation for this button.

            btn.register(b);
          });

          return btnGroup;
        }

        return null;
      }.bind(panel),
          // Callback to show object properties
      properties = function () {
        // Avoid unnecessary reloads
        var i = tree.selected(),
            d = i && tree.itemData(i),
            treeHierarchy = tree.getTreeNodeHierarchy(i);

        if (_.isEqual($(this).data('node-prop'), treeHierarchy)) {
          return;
        } // Cache the current IDs for next time


        $(this).data('node-prop', treeHierarchy);
        /* Remove any dom rendered by getNodeView */

        (0, _node_view.removeNodeView)(j[0]);
        /* getSchema is a schema for React. Get the react node view */

        if (that.getSchema) {
          var treeNodeInfo = pgBrowser.tree.getTreeNodeHierarchy(item);
          (0, _node_view.getNodeView)(that.type, treeNodeInfo, 'properties', data, 'tab', j[0], this, onEdit);
          return;
        }

        if (!content.hasClass('has-pg-prop-btn-group')) content.addClass('has-pg-prop-btn-group'); // We need to release any existing view, before
        // creating new view.

        if (view) {
          // Release the view
          view.remove({
            data: true,
            internal: true,
            silent: true
          }); // Deallocate the view
          // delete view;

          view = null; // Reset the data object

          j.data('obj-view', null);
        } // Make sure the HTML element is empty.


        j.empty();
        that.header = $('<div></div>').addClass('pg-prop-header').appendTo(j);
        that.footer = $('<div></div>').addClass('pg-prop-footer').appendTo(j); // Create a view to show the properties in fieldsets

        view = that.getView(item, 'properties', content, data, 'fieldset', undefined, j);

        if (view) {
          // Save it for release it later
          j.data('obj-view', view); // Create proper buttons

          var buttons = [];
          buttons.push({
            label: gettext('Edit'),
            type: 'edit',
            tooltip: gettext('Edit'),
            extraClasses: ['btn', 'btn-primary', 'pull-right', 'm-1'],
            icon: 'fa fa-sm fa-pencil-alt',
            disabled: _.isFunction(that.canEdit) ? !that.canEdit.apply(that, [d, i]) : !that.canEdit,
            register: function register(btn) {
              btn.on('click', function () {
                onEdit();
              });
            }
          });
          buttons.push({
            label: '',
            type: 'help',
            tooltip: gettext('SQL help for this object type.'),
            extraClasses: ['btn-primary-icon', 'btn-primary-icon', 'm-1'],
            icon: 'fa fa-info',
            disabled: that.sqlAlterHelp == '' && that.sqlCreateHelp == '' && !that.epasHelp ? true : false,
            register: function register(btn) {
              btn.on('click', function () {
                onSqlHelp();
              });
            }
          });
          createButtons(buttons, 'header', 'pg-prop-btn-group-above');
        }

        j.append(content);
      }.bind(panel),
          onSqlHelp = function () {
        // Construct the URL
        var server = pgBrowser.tree.getTreeNodeHierarchy(item).server;
        var url = pgBrowser.utils.pg_help_path;
        var fullUrl = '';

        if (server.server_type == 'ppas' && that.epasHelp) {
          fullUrl = help.getEPASHelpUrl(server.version);
        } else {
          if (that.sqlCreateHelp == '' && that.sqlAlterHelp != '') {
            fullUrl = help.getHelpUrl(url, that.sqlAlterHelp, server.version);
          } else if (that.sqlCreateHelp != '' && that.sqlAlterHelp == '') {
            fullUrl = help.getHelpUrl(url, that.sqlCreateHelp, server.version);
          } else {
            if (view.model.isNew()) {
              fullUrl = help.getHelpUrl(url, that.sqlCreateHelp, server.version);
            } else {
              fullUrl = help.getHelpUrl(url, that.sqlAlterHelp, server.version);
            }
          }
        }

        window.open(fullUrl, 'postgres_help');
      }.bind(panel),
          onDialogHelp = function () {
        window.open(that.dialogHelp, 'pgadmin_help');
      }.bind(panel),
          warnBeforeChangesLost = function (warn_text, yes_callback) {
        var $props = this.$container.find('.obj_properties').first(),
            objview = $props && $props.data('obj-view'),
            self = this;
        var confirm_on_properties_close = pgBrowser.get_preferences_for_module('browser').confirm_on_properties_close;

        if (confirm_on_properties_close && confirm_close && objview && objview.model) {
          if (objview.model.sessChanged()) {
            _Notifier["default"].confirm(gettext('Warning'), warn_text, function () {
              setTimeout(function () {
                yes_callback();
              }.bind(self), 50);
              return true;
            }, function () {
              return true;
            });
          } else {
            return true;
          }
        } else {
          yes_callback();
          return true;
        }
      }.bind(panel),
          warnBeforeAttributeChange = function (yes_callback) {
        var $props = this.$container.find('.obj_properties').first(),
            objview = $props && $props.data('obj-view'),
            self = this;

        if (objview && objview.model && !_.isUndefined(objview.model.warn_text) && !_.isNull(objview.model.warn_text)) {
          var warn_text;
          warn_text = gettext(objview.model.warn_text);

          if (objview.model.sessChanged()) {
            _Notifier["default"].confirm(gettext('Warning'), warn_text, function () {
              setTimeout(function () {
                yes_callback();
              }.bind(self), 50);
              return true;
            }, function () {
              return true;
            });
          } else {
            return true;
          }
        } else {
          yes_callback();
          return true;
        }
      }.bind(panel),
          informBeforeAttributeChange = function (ok_callback) {
        var $props = this.$container.find('.obj_properties').first(),
            objview = $props && $props.data('obj-view');

        if (objview && objview.model && !_.isUndefined(objview.model.inform_text) && !_.isNull(objview.model.inform_text)) {
          _Notifier["default"].alert(gettext('Warning'), gettext(objview.model.inform_text));
        }

        ok_callback();
        return true;
      }.bind(panel),
          onSave = function (_view, saveBtn) {
        var m = _view.model,
            d = m.toJSON(true),
            // Generate a timer for the request
        timer = setTimeout(function () {
          $('.obj_properties').addClass('show_progress');
        }, 1000); // Prevent subsequent save operation by disabling Save button

        if (saveBtn) $(saveBtn).prop('disabled', true);

        if (d && !_.isEmpty(d)) {
          m.save({}, {
            attrs: d,
            validate: false,
            cache: false,
            wait: true,
            success: function success() {
              onSaveFunc.call(); // Hide progress cursor

              $('.obj_properties').removeClass('show_progress');
              clearTimeout(timer); // Removing the node-prop property of panel
              // so that we show updated data on panel

              var pnlProperties = pgBrowser.docker.findPanels('properties')[0],
                  pnlSql = pgBrowser.docker.findPanels('sql')[0],
                  pnlStats = pgBrowser.docker.findPanels('statistics')[0],
                  pnlDependencies = pgBrowser.docker.findPanels('dependencies')[0],
                  pnlDependents = pgBrowser.docker.findPanels('dependents')[0];
              if (pnlProperties) $(pnlProperties).removeData('node-prop');
              if (pnlSql) $(pnlSql).removeData('node-prop');
              if (pnlStats) $(pnlStats).removeData('node-prop');
              if (pnlDependencies) $(pnlDependencies).removeData('node-prop');
              if (pnlDependents) $(pnlDependents).removeData('node-prop');
            },
            error: function error(_m, jqxhr) {
              _Notifier["default"].pgNotifier('error', jqxhr, gettext('Error saving properties')); // Hide progress cursor


              $('.obj_properties').removeClass('show_progress');
              clearTimeout(timer);
              if (saveBtn) $(saveBtn).prop('disabled', false);
            }
          });
        }
      }.bind(panel),
          editFunc = function () {
        var self = this;

        if (action && action == 'properties') {
          action = 'edit';
        }

        self.$container.attr('action-mode', action);
        self.icon(_.isFunction(that['node_image']) ? that['node_image'].apply(that, [data]) : that['node_image'] || 'icon-' + that.type);
        /* Remove any dom rendered by getNodeView */

        (0, _node_view.removeNodeView)(j[0]);
        /* getSchema is a schema for React. Get the react node view */

        if (that.getSchema) {
          var treeNodeInfo = pgBrowser.tree.getTreeNodeHierarchy(item);
          (0, _node_view.getNodeView)(that.type, treeNodeInfo, action, data, 'dialog', j[0], this, onEdit, function (nodeData) {
            if (nodeData.node) {
              onSaveFunc(nodeData.node, treeNodeInfo); // Removing the node-prop property of panel
              // so that we show updated data on panel

              var pnlProperties = pgBrowser.docker.findPanels('properties')[0],
                  pnlSql = pgBrowser.docker.findPanels('sql')[0],
                  pnlStats = pgBrowser.docker.findPanels('statistics')[0],
                  pnlDependencies = pgBrowser.docker.findPanels('dependencies')[0],
                  pnlDependents = pgBrowser.docker.findPanels('dependents')[0];
              if (pnlProperties) $(pnlProperties).removeData('node-prop');
              if (pnlSql) $(pnlSql).removeData('node-prop');
              if (pnlStats) $(pnlStats).removeData('node-prop');
              if (pnlDependencies) $(pnlDependencies).removeData('node-prop');
              if (pnlDependents) $(pnlDependents).removeData('node-prop');

              if (nodeData.success === 0) {
                _Notifier["default"].alert(gettext('Error'), gettext(nodeData.errormsg));
              }
            }
          });
          return;
        } // We need to release any existing view, before
        // creating the new view.


        if (view) {
          // Release the view
          view.remove({
            data: true,
            internal: true,
            silent: true
          }); // Deallocate the view

          view = null; // Reset the data object

          j.data('obj-view', null);
        } // Make sure the HTML element is empty.


        j.empty();
        that.header = $('<div></div>').addClass('pg-prop-header').appendTo(j);
        that.footer = $('<div></div>').addClass('pg-prop-footer').appendTo(j);

        var updateButtons = function updateButtons(hasError, modified) {
          var btnGroup = this.find('.pg-prop-btn-group'),
              btnSave = btnGroup.find('button.btn-primary'),
              btnReset = btnGroup.find('button.btn-secondary[type="reset"]');

          if (hasError || !modified) {
            btnSave.prop('disabled', true);
            btnSave.attr('disabled', 'disabled');
          } else {
            btnSave.prop('disabled', false);
            btnSave.removeAttr('disabled');
          }

          if (!modified) {
            btnReset.prop('disabled', true);
            btnReset.attr('disabled', 'disabled');
          } else {
            btnReset.prop('disabled', false);
            btnReset.removeAttr('disabled');
          }
        }; // Create a view to edit/create the properties in fieldsets


        view = that.getView(item, action, content, data, 'dialog', updateButtons, j, onCancelFunc);

        if (view) {
          // Save it to release it later
          j.data('obj-view', view);
          self.icon(_.isFunction(that['node_image']) ? that['node_image'].apply(that, [data, view.model]) : that['node_image'] || 'icon-' + that.type); // Create proper buttons

          var btn_grp = createButtons([{
            label: '',
            type: 'help',
            tooltip: gettext('SQL help for this object type.'),
            extraClasses: ['btn-primary-icon', 'pull-left', 'mx-1'],
            icon: 'fa fa-info',
            disabled: that.sqlAlterHelp == '' && that.sqlCreateHelp == '' && !that.epasHelp ? true : false,
            register: function register(btn) {
              btn.on('click', function () {
                onSqlHelp();
              });
            }
          }, {
            label: '',
            type: 'help',
            tooltip: gettext('Help for this dialog.'),
            extraClasses: ['btn-primary-icon', 'pull-left', 'mx-1'],
            icon: 'fa fa-question',
            disabled: that.dialogHelp == '' ? true : false,
            register: function register(btn) {
              btn.on('click', function () {
                onDialogHelp();
              });
            }
          }, {
            label: gettext('Cancel'),
            type: 'cancel',
            tooltip: gettext('Cancel changes to this object.'),
            extraClasses: ['btn-secondary', 'mx-1'],
            icon: 'fa fa-times pg-alertify-button',
            disabled: false,
            register: function register(btn) {
              btn.on('click', function () {
                // Removing the action-mode
                self.$container.removeAttr('action-mode');
                onCancelFunc.call(true);
              });
            }
          }, {
            label: gettext('Reset'),
            type: 'reset',
            tooltip: gettext('Reset the fields on this dialog.'),
            extraClasses: ['btn-secondary', 'mx-1'],
            icon: 'fa fa-recycle pg-alertify-button',
            disabled: true,
            register: function register(btn) {
              btn.on('click', function () {
                warnBeforeChangesLost.call(self, gettext('Changes will be lost. Are you sure you want to reset?'), function () {
                  setTimeout(function () {
                    editFunc.call();
                  }, 0);
                });
              });
            }
          }, {
            label: gettext('Save'),
            type: 'save',
            tooltip: gettext('Save this object.'),
            extraClasses: ['btn-primary', 'mx-1'],
            icon: 'fa fa-save pg-alertify-button',
            disabled: true,
            register: function register(btn) {
              // Save the changes
              btn.on('click', function () {
                warnBeforeAttributeChange.call(self, function () {
                  informBeforeAttributeChange.call(self, function () {
                    setTimeout(function () {
                      onSave.call(this, view, btn);
                    }, 0);
                  });
                });
              });
            }
          }], 'footer', 'pg-prop-btn-group-below');
          btn_grp.on('keydown', 'button', function (event) {
            if (!event.shiftKey && event.keyCode == 9 && $(this).nextAll('button:not([disabled])').length == 0) {
              // set focus back to first focusable element on dialog
              view.$el.closest('.wcFloating').find('[tabindex]:not([tabindex="-1"]').first().focus();
              return false;
            }

            var btnGroup = $(self.$container.find('.pg-prop-btn-group'));
            var el = $(btnGroup).find('button:first');

            if (self.$container.find('.number-cell.editable:last').is(':visible')) {
              if (event.keyCode === 9 && event.shiftKey) {
                if ($(el).is($(event.target))) {
                  $(self.$container.find('td.editable:last').trigger('click'));
                  event.preventDefault();
                  event.stopPropagation();
                }
              }
            }
          });
          setTimeout(function () {
            pgBrowser.keyboardNavigation.getDialogTabNavigator(self.pgElContainer);
          }, 200);
        } // Create status bar.


        createStatusBar('footer'); // Add some space, so that - button group does not override the
        // space

        content.addClass('pg-prop-has-btn-group-below'); // Show contents before buttons

        j.prepend(content); // add required attributes to select2 input to resolve accessibility issue.

        $('.select2-search__field').attr('aria-label', 'select2');
        view.$el.closest('.wcFloating').find('.wcFrameButtonBar > .wcFrameButton[style!="display: none;"]').on('keydown', function (e) {
          if (e.shiftKey && e.keyCode === 9) {
            e.stopPropagation();
            setTimeout(function () {
              view.$el.closest('.wcFloating').find('[tabindex]:not([tabindex="-1"]):not([disabled])').last().focus();
            }, 10);
          }
        });
      }.bind(panel),
          closePanel = function (confirm_close_flag) {
        if (!_.isUndefined(confirm_close_flag)) {
          confirm_close = confirm_close_flag;
        } // Closing this panel


        this.close();
      }.bind(panel),
          updateTreeItem = function updateTreeItem(obj, tnode, node_info) {
        var _old = data,
            _new = tnode || _.clone(view.model.tnode),
            info = node_info || _.clone(view.model.node_info); // Clear the cache for this node now.


        setTimeout(function () {
          obj.clear_cache.apply(obj, item);
        }, 0);
        pgBrowser.Events.trigger('pgadmin:browser:tree:update', _old, _new, info, {
          success: function success(_item, _newNodeData, _oldNodeData) {
            pgBrowser.Events.trigger('pgadmin:browser:node:updated', _item, _newNodeData, _oldNodeData);
            pgBrowser.Events.trigger('pgadmin:browser:node:' + _newNodeData._type + ':updated', _item, _newNodeData, _oldNodeData);
          }
        });
        closePanel(false);
      },
          saveNewNode = function (obj, tnode, node_info) {
        var $props = this.$container.find('.obj_properties').first(),
            objview = $props.data('obj-view'); // Clear the cache for this node now.

        setTimeout(function () {
          obj.clear_cache.apply(obj, item);
        }, 0);

        try {
          pgBrowser.Events.trigger('pgadmin:browser:tree:add', _.clone(tnode || objview.model.tnode), _.clone(node_info || objview.model.node_info));
        } catch (e) {
          console.warn(e.stack || e);
        }

        closePanel(false);
      }.bind(panel, that),
          editInNewPanel = function editInNewPanel() {
        // Open edit in separate panel
        setTimeout(function () {
          that.callbacks.show_obj_properties.apply(that, [{
            'action': 'edit',
            'item': item
          }]);
        }, 0);
      },
          onCancelFunc = closePanel,
          onSaveFunc = updateTreeItem.bind(panel, that),
          onEdit = editFunc.bind(panel);

      if (action) {
        if (action == 'create') {
          onSaveFunc = saveNewNode;
        }

        if (action != 'properties') {
          // We need to keep track edit/create mode for this panel.
          editFunc();
        } else {
          properties();
        }
      } else {
        /* Show properties */
        onEdit = editInNewPanel.bind(panel);
        properties();
      }

      if (panel.closeable() && !that.getSchema) {
        panel.on(wcDocker.EVENT.CLOSING, warnBeforeChangesLost.bind(panel, gettext('Changes will be lost. Are you sure you want to close the dialog?'), function () {
          panel.off(wcDocker.EVENT.CLOSING);
          panel.close();
        }));

        var onCloseFunc = function () {
          var $props = this.$container.find('.obj_properties').first(),
              objview = $props && $props.data('obj-view');

          if (objview) {
            objview.remove({
              data: true,
              internal: true,
              silent: true
            });
          }
        }.bind(panel);

        panel.on(wcDocker.EVENT.CLOSED, onCloseFunc);
      }
    },
    _find_parent_node: function _find_parent_node(t, i, d) {
      if (this.parent_type) {
        d = d || t.itemData(i);

        if (_.isString(this.parent_type)) {
          if (this.parent_type == d._type) {
            return i;
          }

          while (t.hasParent(i)) {
            i = t.parent(i);
            d = t.itemData(i);
            if (this.parent_type == d._type) return i;
          }
        } else {
          if (_.indexOf(this.parent_type, d._type) >= 0) {
            return i;
          }

          while (t.hasParent(i)) {
            i = t.parent(i);
            d = t.itemData(i);
            if (_.indexOf(this.parent_type, d._type) >= 0) return i;
          }
        }
      }

      return null;
    },

    /**********************************************************************
     * Generate the URL for different operations
     *
     * arguments:
     *   type:  Create/drop/edit/properties/sql/depends/statistics
     *   d:     Provide the ItemData for the current item node
     *   with_id: Required id information at the end?
     *   jump_after_node: This will skip all the value between jump_after_node
     *   to the last node, excluding jump_after_node and the last node. This is particularly
     *   helpful in partition table where we need to skip parent table OID of a partitioned
     *   table in URL formation. Partitioned table itself is a "table" and can be multilevel
     * Supports url generation for create, drop, edit, properties, sql,
     * depends, statistics
     */
    generate_url: function generate_url(item, type, d, with_id, info, jump_after_node) {
      var opURL = {
        'create': 'obj',
        'drop': 'obj',
        'edit': 'obj',
        'properties': 'obj',
        'statistics': 'stats'
      },
          self = this,
          priority = -Infinity;
      var treeInfo = _.isUndefined(item) || _.isNull(item) ? info || {} : pgBrowser.tree.getTreeNodeHierarchy(item);
      var actionType = type in opURL ? opURL[type] : type;
      var itemID = with_id && d._type == self.type ? encodeURIComponent(d._id) : '';

      if (self.parent_type) {
        if (_.isString(self.parent_type)) {
          var p = treeInfo[self.parent_type];

          if (p) {
            priority = p.priority;
          }
        } else {
          _.each(self.parent_type, function (o) {
            var p = treeInfo[o];

            if (p) {
              if (priority < p.priority) {
                priority = p.priority;
              }
            }
          });
        }
      }

      var jump_after_priority = priority;

      if (jump_after_node && treeInfo[jump_after_node]) {
        jump_after_priority = treeInfo[jump_after_node].priority;
      }

      var nodePickFunction = function nodePickFunction(treeInfoValue) {
        return treeInfoValue.priority <= jump_after_priority || treeInfoValue.priority == priority;
      };

      return generateUrl.generate_url(pgBrowser.URL, treeInfo, actionType, self.type, nodePickFunction, itemID);
    },
    // Base class for Node Data Collection
    Collection: pgBrowser.DataCollection,
    // Base class for Node Data Model
    Model: pgBrowser.DataModel,
    cache: function cache(url, node_info, level, data) {
      var cached = this.cached = this.cached || {},
          hash = url,
          min_priority = node_info && node_info[level] && node_info[level].priority || 0;

      if (node_info) {
        _.each(_.sortBy(_.values(_.pick(node_info, function (v) {
          return v.priority <= min_priority;
        })), function (o) {
          return o.priority;
        }), function (o) {
          hash = commonUtils.sprintf('%s_%s', hash, encodeURI(o._id));
        });
      }

      if (_.isUndefined(data)) {
        var res = cached[hash];

        if (!_.isUndefined(res) && res.at - Date.now() > 300000) {
          res = undefined;
        }

        return res;
      }

      res = cached[hash] = {
        data: data,
        at: Date.now(),
        level: level
      };
      return res;
    },
    clear_cache: function clear_cache(item) {
      /*
       * Reset the cache, when new node is created.
       *
       * FIXME:
       * At the moment, we will clear all the cache for this node. But - we
       * would like to clear the cache only this nodes parent, so that - it
       * fetches the new data.
       */
      this.cached = {}; // Trigger Notify event about node's cache

      var self = this;
      pgBrowser.Events.trigger('pgadmin:browser:node:' + self.type + ':cache_cleared', item, self);
    },
    cache_level: function cache_level(node_info, with_id) {
      if (node_info) {
        if (with_id && this.type in node_info) {
          return this.type;
        }

        if (_.isArray(this.parent_type)) {
          for (var parent in this.parent_type) {
            if (parent in node_info) {
              return parent;
            }
          }

          return this.type;
        }

        return this.parent_type;
      }
    }
  });

  return pgAdmin.Browser.Node;
}).apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__),
		__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));

/***/ }),

/***/ 75270:
/***/ ((module, exports, __webpack_require__) => {

"use strict";
var __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;

__webpack_require__(69600);

__webpack_require__(69826);

__webpack_require__(24812);

/////////////////////////////////////////////////////////////
//
// pgAdmin 4 - PostgreSQL Tools
//
// Copyright (C) 2013 - 2022, The pgAdmin Development Team
// This software is released under the PostgreSQL Licence
//
//////////////////////////////////////////////////////////////
!(__WEBPACK_AMD_DEFINE_ARRAY__ = [__webpack_require__(91669), __webpack_require__(19755), __webpack_require__(81311), __webpack_require__(55112), __webpack_require__(72316), __webpack_require__(95283), __webpack_require__(58307), __webpack_require__(83879), __webpack_require__(20454), __webpack_require__(66235)], __WEBPACK_AMD_DEFINE_RESULT__ = (function (gettext, $, _, pgAdmin, Backbone, Backform, Alertify, Backgrid) {
  /*
   * Define the selectAll adapter for select2.
   *
   * Reference:
   * https://github.com/select2/select2/issues/195#issuecomment-240130634
   */
  $.fn.select2.amd.define('select2/selectAllAdapter', ['select2/utils', 'select2/dropdown', 'select2/dropdown/attachBody'], function (Utils, Dropdown, AttachBody) {
    function SelectAll() {}

    SelectAll.prototype.render = function (decorated) {
      var self = this;
      var $rendered = decorated.call(this);
      var $selectAll = $(['<button class="btn btn-secondary btn-sm" type="button"', ' style="width: 49%;margin: 0 0.5%;">', '<i class="fa fa-check-square" role="img"></i>', '<span style="padding: 0px 5px;">', gettext('Select All'), '</span></button>'].join(''));
      var $unselectAll = $(['<button class="btn btn-secondary btn-sm" type="button"', ' style="width: 49%;margin: 0 0.5%;">', '<i class="fa fa-square"></i><span style="padding: 0px 5px;" role="img">', gettext('Unselect All'), '</span></button>'].join(''));
      var $btnContainer = $('<div class="select2-select-all-adapter-container">').append($selectAll).append($unselectAll);

      if (!this.$element.prop('multiple')) {
        // this isn't a multi-select -> don't add the buttons!
        return $rendered;
      }

      $rendered.find('.select2-dropdown').prepend($btnContainer); // Select All button click

      $selectAll.on('click', function () {
        $rendered.find('.select2-results__option[aria-selected=false]').each(function () {
          // Note: With latest version we do not get data in the data attribute of a element
          // Hence as per new logic we will fetch the data from the cache created by Select2.
          var data = Utils.GetData($(this)[0], 'data');
          self.trigger('select', {
            data: data
          });
        });
        self.trigger('close');
      }); // Unselect All button click

      $unselectAll.on('click', function () {
        $rendered.find('.select2-results__option[aria-selected=true]').each(function () {
          var data = Utils.GetData($(this)[0], 'data');
          self.trigger('unselect', {
            data: data
          });
        });
        self.trigger('close');
      });
      return $rendered;
    };

    return Utils.Decorate(Utils.Decorate(Dropdown, AttachBody), SelectAll);
  });
  /*
   * NodeAjaxOptionsControl
   *   This control will fetch the options required to render the select
   *   control, from the url specific to the pgAdmin.Browser node object.
   *
   *   In order to use this properly, schema require to set the 'url' property,
   *   which exposes the data for this node.
   *
   *   In case the url is not providing the data in proper format, we can
   *   specify the 'transform' function too, which will convert the fetched
   *   data to proper 'label', 'value' format.
   */

  var NodeAjaxOptionsControl = Backform.NodeAjaxOptionsControl = Backform.Select2Control.extend({
    defaults: _.extend(Backform.Select2Control.prototype.defaults, {
      url: undefined,
      transform: undefined,
      url_with_id: false,
      select2: {
        allowClear: true,
        placeholder: gettext('Select an item...'),
        width: 'style'
      }
    }),
    initialize: function initialize() {
      /*
       * Initialization from the original control.
       */
      Backform.Select2Control.prototype.initialize.apply(this, arguments);
      /*
       * We're about to fetch the options required for this control.
       */

      var self = this,
          url = self.field.get('url') || self.defaults.url,
          m = self.model.top || self.model,
          url_jump_after_node = self.field.get('url_jump_after_node') || null; // Hmm - we found the url option.
      // That means - we needs to fetch the options from that node.

      if (url) {
        var node = this.field.get('schema_node'),
            node_info = this.field.get('node_info'),
            with_id = this.field.get('url_with_id') || false,
            full_url = node.generate_url.apply(node, [null, url, this.field.get('node_data'), with_id, node_info, url_jump_after_node]),
            cache_level,
            cache_node = this.field.get('cache_node');
        cache_node = cache_node && pgAdmin.Browser.Nodes[cache_node] || node;

        if (this.field.has('cache_level')) {
          cache_level = this.field.get('cache_level');
        } else {
          cache_level = cache_node.cache_level(node_info, with_id);
        }
        /*
         * We needs to check, if we have already cached data for this url.
         * If yes - use that, and do not bother about fetching it again,
         * and use it.
         */


        var data = cache_node.cache(node.type + '#' + url, node_info, cache_level);

        if (this.field.get('version_compatible') && (_.isUndefined(data) || _.isNull(data))) {
          m.trigger('pgadmin:view:fetching', m, self.field);
          $.ajax({
            async: false,
            url: full_url
          }).done(function (res) {
            /*
             * We will cache this data for short period of time for avoiding
             * same calls.
             */
            data = cache_node.cache(node.type + '#' + url, node_info, cache_level, res.data);
          }).fail(function () {
            m.trigger('pgadmin:view:fetch:error', m, self.field);
          });
          m.trigger('pgadmin:view:fetched', m, self.field);
        } // To fetch only options from cache, we do not need time from 'at'
        // attribute but only options.
        //
        // It is feasible that the data may not have been fetched.


        data = data && data.data || [];
        /*
         * Transform the data
         */

        var transform = this.field.get('transform') || self.defaults.transform;

        if (transform && _.isFunction(transform)) {
          // We will transform the data later, when rendering.
          // It will allow us to generate different data based on the
          // dependencies.
          self.field.set('options', transform.bind(self, data));
        } else {
          self.field.set('options', data);
        }
      }
    }
  });

  var formatNode = function formatNode(opt) {
    if (!opt.id) {
      return opt.text;
    }

    var optimage = $(opt.element).data('image');

    if (!optimage) {
      return opt.text;
    } else {
      return $('<span></span>').append($('<span></span>', {
        "class": 'wcTabIcon ' + optimage
      })).append($('<span></span>').text(opt.text));
    }
  };

  var NodeListByIdControl = Backform.NodeListByIdControl = NodeAjaxOptionsControl.extend({
    controlClassName: 'pgadmin-node-select form-control',
    defaults: _.extend({}, NodeAjaxOptionsControl.prototype.defaults, {
      url: 'nodes',
      filter: undefined,
      transform: function transform(rows) {
        var self = this,
            node = self.field.get('schema_node'),
            res = [],
            filter = self.field.get('filter') || function () {
          return true;
        };

        filter = filter.bind(self);

        _.each(rows, function (r) {
          if (filter(r)) {
            var l = _.isFunction(node['node_label']) ? node['node_label'].apply(node, [r, self.model, self]) : r.label,
                image = _.isFunction(node['node_image']) ? node['node_image'].apply(node, [r, self.model, self]) : node['node_image'] || 'icon-' + node.type;
            res.push({
              'value': r._id,
              'image': image,
              'label': l
            });
          }
        });

        return res;
      },
      select2: {
        allowClear: true,
        placeholder: gettext('Select an item...'),
        width: 'style',
        templateResult: formatNode,
        templateSelection: formatNode
      }
    })
  });
  Backform.NodeListByNameControl = NodeListByIdControl.extend({
    defaults: _.extend({}, NodeListByIdControl.prototype.defaults, {
      transform: function transform(rows) {
        var self = this,
            node = self.field.get('schema_node'),
            res = [],
            filter = self.field.get('filter') || function () {
          return true;
        };

        filter = filter.bind(self);

        _.each(rows, function (r) {
          if (filter(r)) {
            var l = _.isFunction(node['node_label']) ? node['node_label'].apply(node, [r, self.model, self]) : r.label,
                image = _.isFunction(node['node_image']) ? node['node_image'].apply(node, [r, self.model, self]) : node['node_image'] || 'icon-' + node.type;
            res.push({
              'value': r.label,
              'image': image,
              'label': l
            });
          }
        });

        return res;
      }
    })
  });
  /*
   * Global function to make visible  particular dom element in it's parent
   * with given class.
   */

  $.fn.pgMakeVisible = function (cls) {
    return this.each(function () {
      if (!this || !$(this.length)) return;

      var top,
          p = $(this),
          hasScrollbar = function hasScrollbar(j) {
        if (j && j.length > 0) {
          return j.get(0).scrollHeight > j.height();
        }

        return false;
      }; // check if p is not empty


      while (p && p.length > 0) {
        top = p.get(0).offsetTop + p.height();
        p = p.parent();

        if (hasScrollbar(p)) {
          p.scrollTop(top);
        }

        if (p.hasClass(cls)) //'backform-tab'
          return;
      }
    });
  };
  /*
  * Global function to make visible backgrid new row
  */


  $.fn.pgMakeBackgridVisible = function (cls) {
    return this.each(function () {
      if (!this || !$(this.length)) return;
      var elem = $(this),
          backgridDiv = $(this).offsetParent().parent(),
          // Backgrid div.subnode
      backgridDivTop = backgridDiv.offset().top,
          backgridDivHeight = backgridDiv.height(),
          backformTab = $(this).closest(cls),
          // Backform-tab
      gridScroll = null;

      if (backformTab.length == 0) {
        return false;
      }

      gridScroll = backformTab[0].offsetHeight - backgridDivTop;

      if (backgridDivHeight > gridScroll) {
        var top = elem.get(0).offsetTop + elem.height();
        backformTab.find('.tab-content').scrollTop(top);
      }

      return true;
    });
  };
  /*
   * NodeAjaxOptionsCell
   *   This cell will fetch the options required to render the select
   *   cell, from the url specific to the pgAdmin.Browser node object.
   *
   *   In order to use this properly, schema require to set the 'url' property,
   *   which exposes the data for this node.
   *
   *   In case the url is not providing the data in proper format, we can
   *   specify the 'transform' function too, which will convert the fetched
   *   data to proper 'label', 'value' format.
   */


  var NodeAjaxOptionsCell = Backgrid.Extension.NodeAjaxOptionsCell = Backgrid.Extension.Select2Cell.extend({
    defaults: _.extend({}, Backgrid.Extension.Select2Cell.prototype.defaults, {
      url: undefined,
      transform: undefined,
      url_with_id: false,
      select2: {
        allowClear: true,
        placeholder: gettext('Select an item...'),
        width: 'style'
      },
      opt: {
        label: null,
        value: null,
        image: null,
        selected: false
      }
    }),
    template: _.template('<option <% if (image) { %> data-image=<%= image %> <% } %> value="<%- value %>" <%= selected ? \'selected="selected"\' : "" %>><%- label %></option>'),
    initialize: function initialize() {
      Backgrid.Extension.Select2Cell.prototype.initialize.apply(this, arguments);

      var url = this.column.get('url') || this.defaults.url,
          is_options_cached = _.has(this.column.attributes, 'options_cached'),
          options_cached = is_options_cached && this.column.get('options_cached'); // Hmm - we found the url option.
      // That means - we needs to fetch the options from that node.


      if (url && !options_cached) {
        var self = this,
            m = this.model,
            column = this.column,
            eventHandler = m.top || m,
            node = column.get('schema_node'),
            node_info = column.get('node_info'),
            with_id = column.get('url_with_id') || false,
            url_jump_after_node = this.column.get('url_jump_after_node') || null,
            full_url = node.generate_url.apply(node, [null, url, column.get('node_data'), with_id, node_info, url_jump_after_node]),
            cache_level,
            cache_node = column.get('cache_node');
        cache_node = cache_node && pgAdmin.Browser.Nodes[cache_node] || node;

        if (column.has('cache_level')) {
          cache_level = column.get('cache_level');
        } else {
          cache_level = cache_node.cache_level(node_info, with_id);
        }
        /*
         * We needs to check, if we have already cached data for this url.
         * If yes - use that, and do not bother about fetching it again,
         * and use it.
         */


        var data = cache_node.cache(node.type + '#' + url, node_info, cache_level);

        if (column.get('version_compatible') && (_.isUndefined(data) || _.isNull(data))) {
          eventHandler.trigger('pgadmin:view:fetching', m, column);
          $.ajax({
            async: false,
            url: full_url
          }).done(function (res) {
            /*
             * We will cache this data for short period of time for avoiding
             * same calls.
             */
            data = cache_node.cache(node.type + '#' + url, node_info, cache_level, res.data);
          }).fail(function () {
            eventHandler.trigger('pgadmin:view:fetch:error', m, column);
          });
          eventHandler.trigger('pgadmin:view:fetched', m, column);
        } // To fetch only options from cache, we do not need time from 'at'
        // attribute but only options.
        //
        // It is feasible that the data may not have been fetched.


        data = data && data.data || [];
        /*
         * Transform the data
         */

        var transform = column.get('transform') || self.defaults.transform;

        if (transform && _.isFunction(transform)) {
          // We will transform the data later, when rendering.
          // It will allow us to generate different data based on the
          // dependencies.
          column.set('options', transform.bind(column, data));
        } else {
          column.set('options', data);
        }

        if (is_options_cached) {
          column.set('options_cached', true);
        }
      }
    }
  });
  Backgrid.Extension.NodeListByIdCell = NodeAjaxOptionsCell.extend({
    controlClassName: 'pgadmin-node-select backgrid-cell',
    defaults: _.extend({}, NodeAjaxOptionsCell.prototype.defaults, {
      url: 'nodes',
      filter: undefined,
      transform: function transform(rows, control) {
        var self = control || this,
            node = self.column.get('schema_node'),
            res = [],
            filter = self.column.get('filter') || function () {
          return true;
        };

        filter = filter.bind(self);

        _.each(rows, function (r) {
          if (filter(r)) {
            var l = _.isFunction(node['node_label']) ? node['node_label'].apply(node, [r, self.model, self]) : r.label,
                image = _.isFunction(node['node_image']) ? node['node_image'].apply(node, [r, self.model, self]) : node['node_image'] || 'icon-' + node.type;
            res.push({
              'value': r._id,
              'image': image,
              'label': l
            });
          }
        });

        return res;
      },
      select2: {
        placeholder: gettext('Select an item...'),
        width: 'style',
        templateResult: formatNode,
        templateSelection: formatNode
      }
    })
  });
  Backgrid.Extension.NodeListByNameCell = NodeAjaxOptionsCell.extend({
    controlClassName: 'pgadmin-node-select backgrid-cell',
    defaults: _.extend({}, NodeAjaxOptionsCell.prototype.defaults, {
      url: 'nodes',
      filter: undefined,
      transform: function transform(rows, control) {
        var self = control || this,
            node = self.column.get('schema_node'),
            res = [],
            filter = self.column.get('filter') || function () {
          return true;
        };

        filter = filter.bind(self);

        _.each(rows, function (r) {
          if (filter(r)) {
            var l = _.isFunction(node['node_label']) ? node['node_label'].apply(node, [r, self.model, self]) : r.label,
                image = _.isFunction(node['node_image']) ? node['node_image'].apply(node, [r, self.model, self]) : node['node_image'] || 'icon-' + node.type;
            res.push({
              'value': r.label,
              'image': image,
              'label': l
            });
          }
        });

        return res;
      },
      select2: {
        placeholder: gettext('Select an item...'),
        width: 'style',
        templateResult: formatNode,
        templateSelection: formatNode
      }
    })
  }); // Extend the browser's node model class to create a option/value pair

  Backgrid.Extension.MultiSelectAjaxCell = Backgrid.Extension.NodeAjaxOptionsCell.extend({
    defaults: _.extend({}, NodeAjaxOptionsCell.prototype.defaults, {
      transform: undefined,
      url_with_id: false,
      select2: {
        allowClear: true,
        placeholder: gettext('Select an item...'),
        width: 'style',
        multiple: true
      },
      opt: {
        label: null,
        value: null,
        image: null,
        selected: false
      }
    }),
    getValueFromDOM: function getValueFromDOM() {
      var res = [];
      this.$el.find('select').find(':selected').each(function () {
        res.push($(this).attr('value'));
      });
      return res;
    }
  });
  /*
   * Control to select multiple columns.
   */

  Backform.MultiSelectAjaxControl = NodeAjaxOptionsControl.extend({
    defaults: _.extend({}, NodeAjaxOptionsControl.prototype.defaults, {
      select2: {
        multiple: true,
        allowClear: true,
        width: 'style'
      }
    })
  });
  return Backform;
}).apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__),
		__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));

/***/ }),

/***/ 75035:
/***/ ((module, exports, __webpack_require__) => {

"use strict";
var __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;

__webpack_require__(68309);

__webpack_require__(24812);

__webpack_require__(89554);

__webpack_require__(32564);

/////////////////////////////////////////////////////////////
//
// pgAdmin 4 - PostgreSQL Tools
//
// Copyright (C) 2013 - 2022, The pgAdmin Development Team
// This software is released under the PostgreSQL Licence
//
//////////////////////////////////////////////////////////////
!(__WEBPACK_AMD_DEFINE_ARRAY__ = [__webpack_require__(81311), __webpack_require__(55112), __webpack_require__(19755), __webpack_require__(35816)], __WEBPACK_AMD_DEFINE_RESULT__ = (function (_, pgAdmin, $) {
  var pgBrowser = pgAdmin.Browser = pgAdmin.Browser || {},
      wcDocker = window.wcDocker;

  pgAdmin.Browser.Panel = function (options) {
    var defaults = ['name', 'title', 'width', 'height', 'showTitle', 'isCloseable', 'isPrivate', 'isLayoutMember', 'content', 'icon', 'events', 'onCreate', 'elContainer', 'canHide', 'limit', 'extraClasses', 'canMaximise'];

    _.extend(this, _.pick(options, defaults));
  };

  _.extend(pgAdmin.Browser.Panel.prototype, {
    name: '',
    title: '',
    width: 300,
    height: 600,
    showTitle: true,
    isCloseable: true,
    isPrivate: false,
    isLayoutMember: true,
    content: '',
    icon: '',
    panel: null,
    onCreate: null,
    elContainer: false,
    canMaximise: false,
    limit: null,
    extraClasses: null,
    load: function load(docker, title) {
      var that = this;

      if (!that.panel) {
        docker.registerPanelType(that.name, {
          title: that.title,
          isPrivate: that.isPrivate,
          limit: that.limit,
          isLayoutMember: that.isLayoutMember,
          onCreate: function onCreate(myPanel) {
            $(myPanel).data('pgAdminName', that.name);
            myPanel.initSize(that.width, that.height);
            if (!that.showTitle) myPanel.title(false);else {
              var title_elem = '<a href="#" tabindex="-1" class="panel-link-heading">' + (title || that.title) + '</a>';
              myPanel.title(title_elem);
              if (that.icon != '') myPanel.icon(that.icon);
            }
            var $container = $('<div>', {
              'class': 'pg-panel-content'
            }).append($(that.content)); // Add extra classes

            if (!_.isNull('extraClasses')) {
              $container.addClass(that.extraClasses);
            }

            myPanel.maximisable(!!that.canMaximise);
            myPanel.closeable(!!that.isCloseable);
            myPanel.layout().addItem($container);
            that.panel = myPanel;

            if (that.events && _.isObject(that.events)) {
              _.each(that.events, function (v, k) {
                if (v && _.isFunction(v)) {
                  myPanel.on(k, v);
                }
              });
            }

            _.each([wcDocker.EVENT.UPDATED, wcDocker.EVENT.VISIBILITY_CHANGED, wcDocker.EVENT.BEGIN_DOCK, wcDocker.EVENT.END_DOCK, wcDocker.EVENT.GAIN_FOCUS, wcDocker.EVENT.LOST_FOCUS, wcDocker.EVENT.CLOSED, wcDocker.EVENT.BUTTON, wcDocker.EVENT.ATTACHED, wcDocker.EVENT.DETACHED, wcDocker.EVENT.MOVE_STARTED, wcDocker.EVENT.MOVE_ENDED, wcDocker.EVENT.MOVED, wcDocker.EVENT.RESIZE_STARTED, wcDocker.EVENT.RESIZE_ENDED, wcDocker.EVENT.RESIZED, wcDocker.EVENT.SCROLLED], function (ev) {
              myPanel.on(ev, that.eventFunc.bind(myPanel, ev));
            });

            if (that.onCreate && _.isFunction(that.onCreate)) {
              that.onCreate.apply(that, [myPanel, $container]);
            } // Prevent browser from opening the drag file.
            // Using addEventListener to avoid conflict with jquery.drag


            ['dragover', 'drop'].forEach(function (eventName) {
              $container[0].addEventListener(eventName, function (event) {
                event.stopPropagation();
                event.preventDefault();
              });
            });

            if (that.elContainer) {
              myPanel.pgElContainer = $container;
              $container.addClass('pg-el-container');

              _.each([wcDocker.EVENT.RESIZED, wcDocker.EVENT.ATTACHED, wcDocker.EVENT.DETACHED, wcDocker.EVENT.VISIBILITY_CHANGED], function (ev) {
                myPanel.on(ev, that.resizedContainer.bind(myPanel));
              });

              that.resizedContainer.apply(myPanel);
            } // Bind events only if they are configurable


            if (that.canHide) {
              _.each([wcDocker.EVENT.CLOSED, wcDocker.EVENT.VISIBILITY_CHANGED], function (ev) {
                myPanel.on(ev, that.handleVisibility.bind(myPanel, ev));
              });
            }
          }
        });
      }
    },
    eventFunc: function eventFunc(eventName) {
      var name = $(this).data('pgAdminName');

      try {
        pgBrowser.Events.trigger('pgadmin-browser:panel', eventName, this, arguments);
        pgBrowser.Events.trigger('pgadmin-browser:panel:' + eventName, this, arguments);

        if (name) {
          pgBrowser.Events.trigger('pgadmin-browser:panel-' + name, eventName, this, arguments);
          pgBrowser.Events.trigger('pgadmin-browser:panel-' + name + ':' + eventName, this, arguments);
        }
      } catch (e) {
        console.warn(e.stack || e);
      }
    },
    resizedContainer: function resizedContainer() {
      var p = this;

      if (p.pgElContainer && !p.pgResizeTimeout) {
        if (!p.isVisible()) {
          clearTimeout(p.pgResizeTimeout);
          p.pgResizeTimeout = null;
          return;
        }

        p.pgResizeTimeout = setTimeout(function () {
          var w = p.width(),
              elAttr = 'xs';
          p.pgResizeTimeout = null;
          /** Calculations based on https://getbootstrap.com/docs/4.1/layout/grid/#grid-options **/

          if (w < 480) {
            elAttr = 'xs';
          }

          if (w >= 480) {
            elAttr = 'sm';
          }

          if (w >= 768) {
            elAttr = 'md';
          }

          if (w >= 992) {
            elAttr = 'lg';
          }

          if (w >= 1200) {
            elAttr = 'xl';
          }

          p.pgElContainer.attr('el', elAttr);
        }, 100);
      }
    },
    handleVisibility: function handleVisibility(eventName) {
      // Supported modules
      var type_module = {
        'dashboard': pgAdmin.Dashboard,
        'statistics': pgBrowser.NodeStatistics,
        'dependencies': pgBrowser.NodeDependencies,
        'dependents': pgBrowser.NodeDependents
      };
      var module = type_module[this._type];
      if (_.isUndefined(module)) return;
      if (_.isUndefined(module.toggleVisibility)) return;

      if (eventName == 'panelClosed') {
        /* Pass the closed flag also */
        module.toggleVisibility.call(module, false, true);
      } else if (eventName == 'panelVisibilityChanged') {
        module.toggleVisibility.call(module, pgBrowser.docker.findPanels(this._type)[0].isVisible(), false);
      }
    }
  });

  return pgAdmin.Browser.Panel;
}).apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__),
		__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));

/***/ }),

/***/ 58386:
/***/ ((module, exports, __webpack_require__) => {

"use strict";
var __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;

__webpack_require__(62032);

__webpack_require__(65894);

__webpack_require__(63867);

/////////////////////////////////////////////////////////////
//
// pgAdmin 4 - PostgreSQL Tools
//
// Copyright (C) 2013 - 2022, The pgAdmin Development Team
// This software is released under the PostgreSQL Licence
//
//////////////////////////////////////////////////////////////
!(__WEBPACK_AMD_DEFINE_ARRAY__ = [__webpack_require__(91669), __webpack_require__(28008), __webpack_require__(19755), __webpack_require__(81311), __webpack_require__(55112), __webpack_require__(55455)], __WEBPACK_AMD_DEFINE_RESULT__ = (function (gettext, url_for, $, _, pgAdmin, Alertify) {
  pgAdmin = pgAdmin || window.pgAdmin || {};
  /*
   *
   *
   * Hmm... this module is already been initialized, we can refer to the old
   * object from here.
   */

  if (pgAdmin.FileManager) {
    return pgAdmin.FileManager;
  }

  pgAdmin.FileManager = {
    init: function init() {
      if (this.initialized) {
        return;
      }

      this.initialized = true;
    },
    // Call dialogs subject to dialog_type param
    show_dialog: function show_dialog(params) {
      var dialogWidth = pgAdmin.Browser.stdW.calc(pgAdmin.Browser.stdW.md);
      var dialogHeight = pgAdmin.Browser.stdH.calc(pgAdmin.Browser.stdH.lg);

      if (params.dialog_type == 'create_file') {
        Alertify.createModeDlg(params).resizeTo(dialogWidth, dialogHeight);
      } else if (params.dialog_type == 'storage_dialog') {
        Alertify.fileStorageDlg(params).resizeTo(dialogWidth, dialogHeight);
      } else {
        Alertify.fileSelectionDlg(params).resizeTo(dialogWidth, dialogHeight);
      }
    }
  };
  return pgAdmin.FileManager;
}).apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__),
		__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));

/***/ }),

/***/ 55455:
/***/ ((module, exports, __webpack_require__) => {

"use strict";
/* provided dependency */ var _ = __webpack_require__(10084);
var __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;

__webpack_require__(32564);

__webpack_require__(24812);

__webpack_require__(26833);

__webpack_require__(69826);

__webpack_require__(82772);

__webpack_require__(68309);

/////////////////////////////////////////////////////////////
//
// pgAdmin 4 - PostgreSQL Tools
//
// Copyright (C) 2013 - 2022, The pgAdmin Development Team
// This software is released under the PostgreSQL Licence
//
//////////////////////////////////////////////////////////////
!(__WEBPACK_AMD_DEFINE_ARRAY__ = [__webpack_require__(91669), __webpack_require__(58307), __webpack_require__(19755), __webpack_require__(44092)], __WEBPACK_AMD_DEFINE_RESULT__ = (function (gettext, alertify, $, commonUtils) {
  alertify.defaults.transition = 'zoom';
  alertify.defaults.theme.ok = 'btn btn-primary fa fa-lg fa-check pg-alertify-button';
  alertify.defaults.theme.cancel = 'btn btn-secondary fa fa-lg fa-times pg-alertify-button';
  alertify.defaults.theme.input = 'form-control';
  alertify.defaults.closable = false;

  var alertifyDialogResized = function alertifyDialogResized(stop) {
    var self = this;

    if (stop) {
      self.pgResizeRecursion = false;
    }

    if (self.pgResizeTimeout) {
      return;
    }

    self.pgResizeTimeout = setTimeout(function () {
      var $el = $(this.elements.dialog),
          w = $el.width(),
          elAttr = 'xs';
      this.pgResizeTimeout = null;
      /** Calculations based on https://getbootstrap.com/docs/4.1/layout/grid/#grid-options **/

      if (w < 480) {
        elAttr = 'xs';
      }

      if (w >= 480) {
        elAttr = 'sm';
      }

      if (w >= 768) {
        elAttr = 'md';
      }

      if (w >= 992) {
        elAttr = 'lg';
      }

      if (w >= 1200) {
        elAttr = 'xl';
      }

      $el.attr('el', elAttr);
    }.bind(self), 100);
  };

  var alertifyDialogStartResizing = function alertifyDialogStartResizing(start) {
    var self = this;

    if (start) {
      self.pgResizeRecursion = true;
    }

    setTimeout(function () {
      alertifyDialogResized.apply(self);

      if (self.pgResizeRecursion) {
        alertifyDialogStartResizing.apply(self, [false]);
      }
    }, 100);
  };

  alertify.pgDialogBuild = function () {
    this.set('onshow', function () {
      var _this = this;

      this.elements.dialog.classList.add('pg-el-container');
      $(this.elements.commands.close).attr('title', gettext('Close'));
      $(this.elements.commands.maximize).attr('title', gettext('Maximize'));
      $(this.elements.commands.close).attr('aria-label', gettext('Close'));
      $(this.elements.commands.maximize).attr('aria-label', gettext('Maximize'));
      alertifyDialogResized.apply(this, arguments);

      var _self = this;

      var cmds = Object.values(this.elements.commands);
      $(cmds).on('keydown', 'button', function (event) {
        if (event.shiftKey && event.keyCode == 9 && $(_this).nextAll('button:not([disabled])').length == 0) {
          var container = $(_self.elements.footer);
          commonUtils.findAndSetFocus(container.find('button:not([disabled]):last'));
        }
      });
    });
    this.set('onresize', alertifyDialogStartResizing.bind(this, true));
    this.set('onresized', alertifyDialogResized.bind(this, true));
    this.set('onmaximized', alertifyDialogResized);
    this.set('onrestored', alertifyDialogResized);
    /* Set the key to null if it is not defined
     * When Browser autofill drop down value is clicked it raises a keyup event
     * with undefined keyCode. The undefined keyCode matches the undefined key
     * of alertify and triggers the button
     */

    for (var i = 0; i < this.__internal.buttons.length; i++) {
      if (_.isUndefined(this.__internal.buttons[i]['key'])) {
        this.__internal.buttons[i]['key'] = null;
      }
    }

    var self = this;
    $(this.elements.footer).on('keydown', 'button', function (event) {
      if (!event.shiftKey && event.keyCode == 9 && $(this).nextAll('button:not([disabled])').length == 0) {
        // set focus back to first editable input element of current active tab once we cycle through all enabled buttons.
        commonUtils.findAndSetFocus($(self.elements.dialog));
        return false;
      }
    });
  };

  alertify.pgHandleItemError = function (xhr, error, message, args) {
    var pgBrowser = window.pgAdmin.Browser;

    if (!xhr || !pgBrowser) {
      return;
    }

    var contentType = xhr.getResponseHeader('Content-Type'),
        jsonResp = contentType && contentType.indexOf('application/json') == 0 && JSON.parse(xhr.responseText);

    if (jsonResp && (xhr.status == 503 ? jsonResp.info == 'CONNECTION_LOST' && 'server' in args.info && jsonResp.data.sid >= 0 && jsonResp.data.sid == args.info.server._id : xhr.status == 428 && jsonResp.errormsg && jsonResp.errormsg == gettext('Connection to the server has been lost.'))) {
      if (args.preHandleConnectionLost && typeof args.preHandleConnectionLost == 'function') {
        args.preHandleConnectionLost.apply(this, arguments);
      } // Check the status of the maintenance server connection.


      var server = pgBrowser.Nodes['server'],
          ctx = {
        resp: jsonResp,
        xhr: xhr,
        args: args
      },
          reconnectServer = function () {
        var ctx_local = this,
            onServerConnect = function (_sid, _i, _d) {
          // Yay - server is reconnected.
          if (this.args.info.server._id == _sid) {
            pgBrowser.Events.off('pgadmin:server:connected', onServerConnect);
            pgBrowser.Events.off('pgadmin:server:connect:cancelled', onConnectCancel); // Do we need to connect the disconnected server now?

            if (this.resp.data.database && this.resp.data.database != _d.db) {
              // Server is connected now, we will need to inform the
              // database to connect it now.
              pgBrowser.Events.trigger('pgadmin:database:connection:lost', this.args.item, this.resp, true);
            }
          }
        }.bind(ctx_local),
            onConnectCancel = function (_sid, _item, _data) {
          // User has cancelled the operation in between.
          if (_sid == this.args.info.server.id) {
            pgBrowser.Events.off('pgadmin:server:connected', onServerConnect);
            pgBrowser.Events.off('pgadmin:server:connect:cancelled', onConnectCancel); // Connection to the database will also be cancelled

            pgBrowser.Events.trigger('pgadmin:database:connect:cancelled', _sid, this.resp.data.database || _data.db, _item, _data);
          }
        }.bind(ctx_local);

        pgBrowser.Events.on('pgadmin:server:connected', onServerConnect);
        pgBrowser.Events.on('pgadmin:server:connect:cancelled', onConnectCancel); // Connection to the server has been lost, we need to inform the
        // server first to take the action first.

        pgBrowser.Events.trigger('pgadmin:server:connection:lost', this.args.item, this.resp);
      }.bind(ctx);

      $.ajax({
        url: server.generate_url(null, 'connect', args.info.server, true, args.info),
        dataType: 'json'
      }).done(function (res) {
        if (res.success && 'connected' in res.data) {
          if (res.data.connected) {
            // Server is connected, but - the connection with the
            // particular database has been lost.
            pgBrowser.Events.trigger('pgadmin:database:connection:lost', args.item, jsonResp);
            return;
          }
        } // Serever was not connected, we should first try to connect
        // the server.


        reconnectServer();
      }).fail(function () {
        reconnectServer();
      });
      return true;
    } else if (jsonResp && jsonResp.info == 'CRYPTKEY_MISSING' && xhr.status == 503) {
      /* Suppress the error here and handle in Alertify.pgNotifier wherever
       * required, as it has callback option
       */
      return false;
    }

    return false;
  }; // Confirm dialogue: Set title attribute


  alertify.confirm().set({
    onshow: function onshow() {
      $(this.elements.commands.close).attr('title', gettext('Close'));
      $(this.elements.commands.maximize).attr('title', gettext('Maximize'));
      $(this.elements.content).addClass('ajs-wrap-text');
      $(this.elements.header).attr('id', 'confirm-dialog-header');
      $(this.elements.body).attr('id', 'confirm-dialog-body');
      $(this.elements.dialog).attr({
        role: 'alertdialog',
        'aria-modal': 'true',
        'aria-labelledby': 'confirm-dialog-header',
        'aria-describedby': 'confirm-dialog-body'
      });
    },
    reverseButtons: true
  });
  alertify.prompt().set({
    reverseButtons: true
  });
  alertify.alert().set({
    onshow: function onshow() {
      $(this.elements.header).attr('id', 'alert-dialog-header');
      $(this.elements.body).attr('id', 'alert-dialog-body');
      $(this.elements.modal).attr({
        role: 'alertdialog',
        'aria-modal': 'true',
        'aria-labelledby': 'alert-dialog-header',
        'aria-describedby': 'alert-dialog-body'
      });
    }
  });
  /* Suppress the enter key events occurring from select2 boxes
   * so that the dialog does not close.
   * Alertify listens to keyup events on the body element unfortunately
   * instead of alertify dialog
   */

  $('body').off('keyup').on('keyup', function (ev) {
    if (ev.which === 13 || ev.which === 27) {
      var suppressForClasses = ['select2-selection', 'select2-search__field'];
      var $el = $(ev.target);

      for (var i = 0; i < suppressForClasses.length; i++) {
        if ($el.hasClass(suppressForClasses[i])) {
          ev.preventDefault();
          ev.stopImmediatePropagation();
          ev.stopPropagation();
          break;
        }
      }

      var el_name = ev.target.name;

      if (el_name == 'key') {
        var $parentDiv = $el.closest('.value'),
            $nextField = $parentDiv.find('.shift .btn-checkbox');

        if ($nextField.length == 0) {
          $nextField = $el.closest('.value').next().find('input.form-control');
        }

        if ($nextField.length) {
          $nextField.focus();
          ev.preventDefault();
          ev.stopImmediatePropagation();
          ev.stopPropagation();
        }
      }
    }
  });
  return alertify;
}).apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__),
		__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));

/***/ }),

/***/ 12030:
/***/ ((module, exports, __webpack_require__) => {

"use strict";
var __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;

__webpack_require__(69070);

__webpack_require__(82526);

__webpack_require__(57327);

__webpack_require__(38880);

__webpack_require__(89554);

__webpack_require__(54747);

__webpack_require__(49337);

__webpack_require__(33321);

__webpack_require__(23123);

__webpack_require__(74916);

__webpack_require__(69600);

__webpack_require__(69826);

__webpack_require__(5735);

__webpack_require__(83753);

__webpack_require__(68309);

__webpack_require__(32564);

__webpack_require__(24812);

__webpack_require__(92222);

__webpack_require__(82772);

__webpack_require__(47941);

__webpack_require__(5212);

__webpack_require__(73210);

__webpack_require__(21249);

__webpack_require__(15306);

__webpack_require__(91058);

__webpack_require__(41539);

__webpack_require__(39714);

__webpack_require__(83710);

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/////////////////////////////////////////////////////////////
//
// pgAdmin 4 - PostgreSQL Tools
//
// Copyright (C) 2013 - 2022, The pgAdmin Development Team
// This software is released under the PostgreSQL Licence
//
//////////////////////////////////////////////////////////////
!(__WEBPACK_AMD_DEFINE_ARRAY__ = [__webpack_require__(91669), __webpack_require__(81311), __webpack_require__(19755), __webpack_require__(72316), __webpack_require__(95283), __webpack_require__(83879), __webpack_require__(4631), __webpack_require__(81240), __webpack_require__(72945), __webpack_require__(1950), __webpack_require__(75471), __webpack_require__(76573), __webpack_require__(71158), __webpack_require__(20454), __webpack_require__(56796)], __WEBPACK_AMD_DEFINE_RESULT__ = (function (gettext, _, $, Backbone, Backform, Backgrid, CodeMirror, SqlEditorUtils, keyboardShortcuts, pgWindow, configure_show_on_scroll, Pickr) {
  var pgAdmin = window.pgAdmin = window.pgAdmin || {},
      pgBrowser = pgAdmin.Browser;

  pgAdmin.editableCell = function () {
    if (this.attributes && !_.isUndefined(this.attributes.disabled) && !_.isNull(this.attributes.disabled)) {
      if (_.isFunction(this.attributes.disabled)) {
        return !this.attributes.disabled.apply(this, arguments);
      }

      if (_.isBoolean(this.attributes.disabled)) {
        return !this.attributes.disabled;
      }
    }
  }; // HTML markup global class names. More can be added by individual controls
  // using _.extend. Look at RadioControl as an example.


  _.extend(Backform, {
    controlLabelClassName: 'control-label pg-el-sm-3 pg-el-12',
    controlsClassName: 'pgadmin-controls pg-el-sm-9 pg-el-12',
    controlContainerClassName: 'pgadmin-controls pg-el-sm-9 pg-el-12',
    groupClassName: 'pgadmin-control-group form-group row pg-el-12',
    setGroupClassName: 'set-group pg-el-12',
    tabClassName: 'backform-tab pg-el-12',
    setGroupContentClassName: 'fieldset-content pg-el-12',
    accordianGroupClassName: 'accordian-group pg-el-12',
    accordianContentClassName: 'accordian-content pg-el-12',
    hiddenClassName: 'd-none',
    helpMessageClassName: 'form-text text-muted help-block',
    helpBlockControlClass: 'pgadmin-controls offset-sm-3 pg-el-sm-9 pg-el-12'
  });

  Backform.controlMapper = {
    'int': ['uneditable-input', 'numeric', 'integer'],
    'text': ['uneditable-input', 'input', 'string'],
    'numeric': ['uneditable-input', 'numeric', 'numeric'],
    'date': 'datepicker',
    'datetime': 'datetimepicker',
    'boolean': 'boolean',
    'options': ['readonly-option', 'select', Backgrid.Extension.PGSelectCell],
    'multiline': ['textarea', 'textarea', 'string'],
    'collection': ['sub-node-collection', 'sub-node-collection', 'string'],
    'uniqueColCollection': ['unique-col-collection', 'unique-col-collection', 'string'],
    'switch': 'switch',
    'select2': 'select2',
    'note': 'note',
    'color': 'color',
    'radioModern': 'radioModern'
  };

  Backform.getMappedControl = function (type, mode) {
    if (type in Backform.controlMapper) {
      var m = Backform.controlMapper[type];

      if (!_.isArray(m)) {
        return m;
      }

      var idx = 1,
          len = _.size(m);

      switch (mode) {
        case 'properties':
          idx = 0;
          break;

        case 'edit':
        case 'create':
        case 'control':
          idx = 1;
          break;

        case 'cell':
          idx = 2;
          break;

        default:
          idx = 0;
          break;
      }

      return m[idx > len ? 0 : idx];
    }

    return type;
  };
  /* Returns raw data as it is */


  var RawFormatter = Backform.RawFormatter = function () {};

  _.extend(RawFormatter.prototype, {
    fromRaw: function fromRaw(rawData) {
      return rawData;
    },
    toRaw: function toRaw(formattedData) {
      return formattedData;
    }
  });

  var BackformControlInit = Backform.Control.prototype.initialize,
      BackformControlRemove = Backform.Control.prototype.remove; // Override the Backform.Control to allow to track changes in dependencies,
  // and rerender the View element

  _.extend(Backform.Control.prototype, {
    defaults: _.extend(Backform.Control.prototype.defaults, {
      helpMessage: null
    }),
    initialize: function initialize() {
      BackformControlInit.apply(this, arguments); // Listen to the dependent fields in the model for any change

      var deps = this.field.get('deps');
      var self = this;

      if (deps && _.isArray(deps)) {
        _.each(deps, function (d) {
          var attrArr = d.split('.');
          var name = attrArr.shift();
          self.listenTo(self.model, 'change:' + name, self.render);
        });
      }
    },
    remove: function remove() {
      // Remove the events for the dependent fields in the model
      var self = this,
          deps = self.field.get('deps');
      var attrArr = this.field.get('name').split('.');
      var name = attrArr.shift();
      self.stopListening(self.model, 'change:' + name, self.render);

      if (self.model.errorModel instanceof Backbone.Model) {
        self.stopListening(self.model.errorModel, 'change:' + name, self.updateInvalid);
      }

      if (deps && _.isArray(deps)) {
        _.each(deps, function (d) {
          var attrArray = d.split('.');
          var depname = attrArray.shift();
          self.stopListening(self.model, 'change:' + depname, self.render);
        });
      }

      if (this.cleanup) {
        this.cleanup.apply(this);
      }

      if (BackformControlRemove) {
        BackformControlRemove.apply(self, arguments);
      } else {
        Backbone.View.prototype.remove.apply(self, arguments);
      }
    },
    template: _.template(['<label class="<%=Backform.controlLabelClassName%>" for="<%=cId%>"><%=label%></label>', '<div class="<%=Backform.controlsClassName%>">', '  <input id="<%=cId%>" class="<%=Backform.controlClassName%> uneditable-input" <%=disabled ? "disabled" : ""%> <%=readonly ? "readonly aria-readonly=true" : ""%> id="<%=cId%>" value="<%-value%>" />', '  <% if (helpMessage && helpMessage.length) { %>', '    <span class="<%=Backform.helpMessageClassName%>"><%=helpMessage%></span>', '  <% } %>', '</div>'].join('\n')),
    clearInvalid: function clearInvalid() {
      this.$el.removeClass(Backform.errorClassName);
      this.$el.find('.pgadmin-control-error-message').remove();
      return this;
    },
    updateInvalid: function updateInvalid() {
      var self = this,
          errorModel = this.model.errorModel;
      if (!(errorModel instanceof Backbone.Model)) return this;
      this.clearInvalid();
      /*
       * Find input which have name attribute.
       */

      this.$el.find(':input[name]').not('button').each(function (ix, el) {
        var error = self.keyPathAccessor(errorModel.toJSON(), $(el).attr('name'));
        if (_.isEmpty(error)) return;
        self.$el.addClass(Backform.errorClassName);
      });
    },

    /*
     * Overriding the render function of the control to allow us to eval the
     * values properly.
     */
    render: function render() {
      var field = _.defaults(this.field.toJSON(), this.defaults),
          attributes = this.model.toJSON(),
          attrArr = field.name.split('.'),
          name = attrArr.shift(),
          path = attrArr.join('.'),
          rawValue = this.keyPathAccessor(attributes[name], path),
          data = _.extend(field, {
        rawValue: rawValue,
        value: this.formatter.fromRaw(rawValue, this.model),
        attributes: attributes,
        formatter: this.formatter
      }),
          evalF = function evalF(f, d, m) {
        return _.isFunction(f) ? !!f.apply(d, [m]) : !!f;
      }; // Evaluate the disabled, visible, and required option


      _.extend(data, {
        disabled: evalF(data.disabled, data, this.model),
        readonly: evalF(data.readonly, data, this.model),
        visible: evalF(data.visible, data, this.model),
        required: evalF(data.required, data, this.model)
      });

      data.cId = data.cId || _.uniqueId('pgC_'); // Clean up first

      this.$el.removeClass(Backform.hiddenClassName);
      if (!data.visible) this.$el.addClass(Backform.hiddenClassName);
      this.$el.html(this.template(data)).addClass(field.name);
      this.updateInvalid();
      return this;
    }
  });
  /*
   * Override the input control events in order to reslove the issue related to
   * not updating the value sometimes in the input control.
   */


  _.extend(Backform.InputControl.prototype, {
    defaults: _.extend(Backform.InputControl.prototype.defaults, {
      controlLabelClassName: Backform.controlLabelClassName,
      controlsClassName: Backform.controlsClassName
    }),
    template: _.template(['<label class="<%=controlLabelClassName%>" for="<%=cId%>"><%=label%></label>', '<div class="<%=controlsClassName%>">', '  <input type="<%=type%>" id="<%=cId%>" class="<%=Backform.controlClassName%> <%=extraClasses.join(\' \')%>" name="<%=name%>" maxlength="<%=maxlength%>" value="<%-value%>" placeholder="<%-placeholder%>" <%=disabled ? "disabled" : ""%> <%=readonly ? "readonly aria-readonly=true" : ""%> <%=required ? "required" : ""%> />', '  <% if (helpMessage && helpMessage.length) { %>', '    <span class="<%=Backform.helpMessageClassName%>"><%=helpMessage%></span>', '  <% } %>', '</div>'].join('\n')),
    events: {
      'change input': 'onChange',
      'blur input': 'onChange',
      'keyup input': 'onKeyUp',
      'focus input': 'clearInvalid'
    },
    onKeyUp: function onKeyUp(ev) {
      if (this.key_timeout) {
        clearTimeout(this.key_timeout);
      }

      this.keyup_timeout = setTimeout(function () {
        this.onChange(ev);
      }.bind(this), 400);
    }
  });
  /*
   * Override the textarea control events in order to resolve the issue related
   * to not updating the value in model on certain browsers in few situations
   * like copy/paste, deletion using backspace.
   *
   * Reference:
   * http://stackoverflow.com/questions/11338592/how-can-i-bind-to-the-change-event-of-a-textarea-in-jquery
   */


  _.extend(Backform.TextareaControl.prototype, {
    defaults: _.extend(Backform.TextareaControl.prototype.defaults, {
      rows: 5,
      helpMessage: null,
      maxlength: null
    }),
    events: {
      'change textarea': 'onChange',
      'keyup textarea': 'onKeyUp',
      'paste textarea': 'onChange',
      'selectionchange textarea': 'onChange',
      'focus textarea': 'clearInvalid'
    },
    template: _.template(['<label class="<%=Backform.controlLabelClassName%>" for="<%=cId%>"><%=label%></label>', '<div class="<%=Backform.controlsClassName%>">', '  <textarea id="<%=cId%>"', '    class="<%=Backform.controlClassName%> <%=extraClasses.join(\' \')%>" name="<%=name%>" aria-label="<%=name%>"', '  <% if (maxlength) { %>', '    maxlength="<%=maxlength%>"', '  <% } %>', '    placeholder="<%-placeholder%>" <%=disabled ? "disabled" : ""%> <%=readonly ? "readonly aria-readonly=true" : ""%>', '    rows=<%=rows ? rows : ""%>', '    <%=required ? "required" : ""%>><%-value%></textarea>', '  <% if (helpMessage && helpMessage.length) { %>', '    <span class="<%=Backform.helpMessageClassName%>"><%=helpMessage%></span>', '  <% } %>', '</div>'].join('\n')),
    onKeyUp: function onKeyUp(ev) {
      if (this.key_timeout) {
        clearTimeout(this.key_timeout);
      }

      this.keyup_timeout = setTimeout(function () {
        this.onChange(ev);
      }.bind(this), 400);
    }
  });
  /*
   * Overriding the render function of the select control to allow us to use
   * options as function, which should return array in the format of
   * (label, value) pair.
   */


  Backform.SelectControl.prototype.render = function () {
    var field = _.defaults(this.field.toJSON(), this.defaults),
        attributes = this.model.toJSON(),
        attrArr = field.name.split('.'),
        name = attrArr.shift(),
        path = attrArr.join('.'),
        rawValue = this.keyPathAccessor(attributes[name], path),
        data = _.extend(field, {
      rawValue: rawValue,
      value: this.formatter.fromRaw(rawValue, this.model),
      attributes: attributes,
      formatter: this.formatter
    }),
        evalF = function evalF(f, d, m) {
      return _.isFunction(f) ? !!f.apply(d, [m]) : !!f;
    }; // Evaluate the disabled, visible, and required option


    _.extend(data, {
      disabled: evalF(data.disabled, data, this.model),
      visible: evalF(data.visible, data, this.model),
      required: evalF(data.required, data, this.model)
    }); // Evaluation the options


    if (_.isFunction(data.options)) {
      try {
        data.options = data.options(this);
      } catch (e) {
        // Do nothing
        data.options = [];
        this.model.trigger('pgadmin-view:transform:error', this.model, this.field, e);
      }
    }

    data.cId = data.cId || _.uniqueId('pgC_'); // Clean up first

    this.$el.removeClass(Backform.hiddenClassName);
    if (!data.visible) this.$el.addClass(Backform.hiddenClassName);
    this.$el.html(this.template(data)).addClass(field.name);
    this.updateInvalid();
    return this;
  };

  Backform.SelectControl.prototype.template = _.template(['<label class="<%=Backform.controlLabelClassName%>" for="<%=cId%>"><%=label%></label>', '<div class="<%=Backform.controlContainerClassName%>">', '  <select id="<%=cId%>" class="<%=Backform.controlClassName%> <%=extraClasses.join(\' \')%>" name="<%=name%>" value="<%-value%>" <%=disabled ? "disabled" : ""%> <%=readonly ? "disabled" : ""%> <%=required ? "required" : ""%> >', '    <% for (var i=0; i < options.length; i++) { %>', '      <% var option = options[i]; %>', '      <option value="<%-formatter.fromRaw(option.value)%>" <%=option.value === rawValue ? "selected=\'selected\'" : ""%> <%=option.disabled ? "disabled=\'disabled\'" : ""%>><%-option.label%></option>', '    <% } %>', '  </select>', '</div>'].join('\n'));

  _.extend(Backform.SelectControl.prototype.defaults, {
    helpMessage: null
  });

  Backform.ReadonlyOptionControl = Backform.SelectControl.extend({
    template: _.template(['<label class="<%=Backform.controlLabelClassName%>" for="<%=cId%>"><%=label%></label>', '<div class="<%=Backform.controlsClassName%>">', '<% for (var i=0; i < options.length; i++) { %>', ' <% var option = options[i]; %>', ' <% if (option.value === rawValue) { %>', ' <input id="<%=cId%>" class="<%=Backform.controlClassName%> uneditable-input" readonly value="<%-option.label%>"></span>', ' <% } %>', '<% } %>', '<% if (helpMessage && helpMessage.length) { %>', '  <span class="<%=Backform.helpMessageClassName%>"><%=helpMessage%></span>', '<% } %>', '</div>'].join('\n')),
    events: {},
    getValueFromDOM: function getValueFromDOM() {
      return this.formatter.toRaw(this.$el.find('span').text(), this.model);
    }
  });
  /*
   * Override the function 'updateInvalid' of the radio control to resolve an
   * issue, which will not render the error block multiple times for each
   * options.
   */

  _.extend(Backform.RadioControl.prototype, {
    updateInvalid: function updateInvalid() {
      var self = this,
          errorModel = this.model.errorModel;
      if (!(errorModel instanceof Backbone.Model)) return this;
      this.clearInvalid();
      /*
       * Find input which have name attribute.
       */

      this.$el.find(':input[name]').not('button').each(function (ix, el) {
        var error = self.keyPathAccessor(errorModel.toJSON(), $(el).attr('name'));
        if (_.isEmpty(error)) return;
        self.$el.addClass(Backform.errorClassName).find('[type="radio"]').append($('<div></div>').addClass('pgadmin-control-error-message pg-el-offset-4 pg-el-8 pg-el-8 help-block').text(error));
      });
    }
  });

  Backform.RadioModernControl = Backform.RadioControl.extend({
    defaults: {
      controlLabelClassName: Backform.controlLabelClassName,
      controlsClassName: Backform.controlsClassName,
      extraClasses: [],
      helpMessage: '',
      name: ''
    },
    events: _.extend({}, Backform.InputControl.prototype.events, {
      'click label.btn': 'toggle'
    }),
    toggle: function toggle(e) {
      /* Toggle the other buttons to unchecked and current to checked */
      var $curr = $(e.currentTarget),
          $btn_group = $curr.closest('.btn-group');
      $btn_group.find('.btn').removeClass('btn-primary').addClass('btn-secondary').find('.fa').addClass('visibility-hidden').siblings('input').prop('checked', false);
      $curr.removeClass('btn-secondary').addClass('btn-primary').find('.fa').removeClass('visibility-hidden').siblings('input').prop('checked', true).trigger('change');
      e.preventDefault();
      e.stopPropagation();
    },
    template: _.template(['<% if (label) { %>', '<label class="<%=controlLabelClassName%>" id="<%=cId%>_grplabel"><%=label%></label>', '<% } %>', '<div class="<%=controlsClassName%> <%=extraClasses.join(\' \')%>">', ' <div class="btn-group pgadmin-controls-radio-none<% if (disabled) {%> disabled <%}%>" role="radiogroup" <% if (label) {%> aria-labelledby="<%=cId%>_grplabel" <%}%>>', '  <% for (var i=0; i < options.length; i++) { %>', '  <% var option = options[i]; %>', '  <label role="radio" class="btn btn-radiomodern <% if (option.value == value) { %> btn-primary <%} else {%> btn-secondary <%}%> <% if (!option.disabled && !disabled) { %>" tabindex="0"<% } else { %> disabled"<% } %>>', '    <i class="fa fa-check  <% if (option.value != value) { %>visibility-hidden <%}%>" role="img"></i>', '    <input type="radio" name="<%=name%>" autocomplete="off" value=<%-formatter.fromRaw(option.value)%> <% if (option.value == value) { %> checked<%}%> <% if (option.disabled || disabled) { %> disabled <%}%>> <%-option.label%>', '  </label>', '  <% } %>', ' </div>', ' <% if (helpMessage && helpMessage.length) { %>', '  <span class="<%=Backform.helpMessageClassName%>"><%=helpMessage%></span>', ' <% } %>', '</div>'].join('\n')),
    formatter: RawFormatter,
    getValueFromDOM: function getValueFromDOM() {
      return this.formatter.toRaw(this.$el.find('input[type="radio"]:checked').attr('value'), this.model);
    },
    render: function render() {
      var field = _.defaults(this.field.toJSON(), this.defaults),
          attributes = this.model.toJSON(),
          attrArr = field.name.split('.'),
          name = attrArr.shift(),
          path = attrArr.join('.'),
          rawValue = this.keyPathAccessor(attributes[name], path),
          data = _.extend(field, {
        rawValue: rawValue,
        value: this.formatter.fromRaw(rawValue, this.model),
        attributes: attributes,
        formatter: this.formatter
      }),
          // Evaluate the disabled, visible, and required option
      evalF = function evalF(f, d, m) {
        return _.isFunction(f) ? !!f.apply(d, [m]) : !!f;
      };

      _.extend(data, {
        disabled: evalF(data.disabled, data, this.model),
        visible: evalF(data.visible, data, this.model),
        required: evalF(data.required, data, this.model)
      }); // Clean up first


      data.cId = data.cId || _.uniqueId('pgC_');
      data.options = _.isFunction(data.options) ? data.options.apply(data, [this.model]) : data.options;
      this.$el.removeClass(Backform.hiddenClassName);
      if (!data.visible) this.$el.addClass(Backform.hiddenClassName);
      this.$el.html(this.template(data)).addClass(field.name);
      this.updateInvalid();
      this.$el.find('.btn').on('keyup', function (e) {
        /* Spacebar click */
        if (e.keyCode == 32) {
          $(e.currentTarget).trigger('click');
        }
      });
      return this;
    }
  }); // Requires the Bootstrap Switch to work.

  Backform.SwitchControl = Backform.InputControl.extend({
    defaults: {
      label: '',
      options: {
        onText: gettext('Yes'),
        offText: gettext('No'),
        onColor: 'success',
        offColor: 'ternary',
        size: 'mini',
        width: null,
        height: null
      },
      controlLabelClassName: Backform.controlLabelClassName,
      controlsClassName: Backform.controlsClassName,
      extraClasses: [],
      helpMessage: null,
      extraToggleClasses: null
    },
    template: _.template(['<span class="<%=controlLabelClassName%>"><%=label%></span>', '<div class="<%=controlsClassName%> <%=extraClasses.join(\' \')%>">', '      <input tabindex="-1" type="checkbox" aria-hidden="true" aria-label="' + gettext('Toggle button') + '" data-style="quick" data-toggle="toggle"', '      data-size="<%=options.size%>" data-height="<%=options.height%>"  ', '      data-on="<%=options.onText%>" data-off="<%=options.offText%>" ', '      data-onstyle="<%=options.onColor%>" data-offstyle="<%=options.offColor%>" data-width="<%=options.width%>" ', '      name="<%=name%>" <%=value ? "checked=\'checked\'" : ""%> <%=disabled ? "disabled" : ""%> <%=readonly ? "disabled" : ""%> <%=required ? "required" : ""%> />', '  <% if (helpMessage && helpMessage.length) { %>', '    <span class="<%=Backform.helpMessageClassName%>"><%=helpMessage%></span>', '  <% } %>', '</div>'].join('\n')),
    getValueFromDOM: function getValueFromDOM() {
      return this.formatter.toRaw(this.$input.prop('checked'), this.model);
    },
    events: {
      'change input': 'onChange',
      'keyup': 'toggleSwitch'
    },
    setSrValue: function setSrValue() {
      var _$defaults = _.defaults(this.field.get('options'), this.defaults.options),
          onText = _$defaults.onText,
          offText = _$defaults.offText;

      var label = this.field.get('label');

      if (this.$el.find('.toggle.btn').hasClass('off')) {
        this.$el.find('.sr-value').text("\n          ".concat(label, ", ").concat(offText, ", ") + gettext('Toggle') + "\n        ");
      } else {
        this.$el.find('.sr-value').text("\n          ".concat(label, ", ").concat(onText, ", ") + gettext('Toggle') + "\n        ");
      }
    },
    onChange: function onChange() {
      Backform.InputControl.prototype.onChange.apply(this, arguments);
      this.setSrValue();
    },
    toggleSwitch: function toggleSwitch(e) {
      if (e.keyCode == 32) {
        this.$el.find('input[type=checkbox]').bootstrapToggle('toggle');
        e.preventDefault();
        this.setSrValue();
      }
    },
    render: function render() {
      var field = _.defaults(this.field.toJSON(), this.defaults),
          attributes = this.model.toJSON(),
          attrArr = field.name.split('.'),
          name = attrArr.shift(),
          path = attrArr.join('.'),
          rawValue = this.keyPathAccessor(attributes[name], path),
          data = _.extend(field, {
        rawValue: rawValue,
        value: this.formatter.fromRaw(rawValue, this.model),
        attributes: attributes,
        formatter: this.formatter
      }),
          evalF = function evalF(f, d, m) {
        return _.isFunction(f) ? !!f.apply(d, [m]) : !!f;
      }; // Evaluate the disabled, visible, and required option


      _.extend(data, {
        disabled: evalF(field.disabled, field, this.model),
        readonly: evalF(field.readonly, field, this.model),
        visible: evalF(data.visible, field, this.model),
        required: evalF(data.required, field, this.model)
      });

      data.cId = data.cId || _.uniqueId('pgC_'); // Clean up first

      this.$el.removeClass(Backform.hiddenClassName);
      if (!data.visible) this.$el.addClass(Backform.hiddenClassName);

      if (Backform.requiredInputClassName) {
        this.$el.removeClass(Backform.requiredInputClassName);
      }

      if (data.required) {
        this.$el.addClass(Backform.requiredInputClassName);
      }
      /* Set disabled for both disabled and readonly */


      data.options = _.defaults({
        disabled: data.disabled || data.readonly
      }, this.field.get('options'), this.defaults.options, $.fn.bootstrapToggle.defaults);
      this.$el.html(this.template(data)).addClass(field.name); // Add Extra Toggle classes to render multiple toggles in a single row

      if (!_.isNull(field.extraToggleClasses)) this.$el.addClass(field.extraToggleClasses);
      this.$input = this.$el.find('input[type=checkbox]').first();
      this.$input.bootstrapToggle(); // When disable then set tabindex value to -1

      this.$el.find('.toggle.btn').attr('tabindex', data.disabled ? '-1' : '0').attr('id', data.cId);
      this.$el.find('.toggle.btn .toggle-group .btn').attr('aria-hidden', true);
      this.$el.find('div.toggle').append('<label class="sr-value sr-only" for="<%=cId%>"></label>');
      this.setSrValue();
      this.updateInvalid();
      /* Bootstrap toggle does not have option for readonly
       * If readonly, then let it focus.
       */

      if (data.readonly) {
        this.$el.find('.select2-selection').attr('tabindex', 0);
      }

      return this;
    }
  }); // Backform Dialog view (in bootstrap tabbular form)
  // A collection of field models.

  Backform.Dialog = Backform.Form.extend({
    /* Array of objects having attributes [label, fields] */
    schema: undefined,
    tagName: 'div',
    legend: true,
    className: function className() {
      return 'pg-el-sm-12 pg-el-md-12 pg-el-lg-12 pg-el-12';
    },
    tabPanelClassName: function tabPanelClassName() {
      return Backform.tabClassName;
    },
    tabIndex: 0,
    initialize: function initialize(opts) {
      var s = opts.schema;

      if (s && _.isArray(s)) {
        this.schema = _.each(s, function (o) {
          if (o.fields && !(o.fields instanceof Backbone.Collection)) o.fields = new Backform.Fields(o.fields);
          o.cId = o.cId || _.uniqueId('pgC_');
          o.hId = o.hId || _.uniqueId('pgH_');
          o.disabled = o.disabled || false;
          o.legend = opts.legend;
        });

        if (opts.tabPanelClassName && _.isFunction(opts.tabPanelClassName)) {
          this.tabPanelClassName = opts.tabPanelClassName;
        }
      }

      this.model.errorModel = opts.errorModel || this.model.errorModel || new Backbone.Model();
      this.controls = [];
    },
    template: {
      'header': _.template(['<li class="nav-item" <%=disabled ? "disabled" : ""%>>', ' <a class="nav-link" data-toggle="tab" role="tab" tabindex="-1" data-tab-index="<%=tabIndex%>" href="#<%=cId%>"', '  id="<%=hId%>" aria-controls="<%=cId%>">', '<%=label%></a></li>'].join(' ')),
      'panel': _.template('<div role="tabpanel" tabindex="-1" class="tab-pane <%=label%> <%=tabPanelCodeClass%> pg-el-sm-12 pg-el-md-12 pg-el-lg-12 pg-el-12 fade" id="<%=cId%>" aria-labelledby="<%=hId%>"></div>')
    },
    render: function render() {
      this.cleanup();

      var c = this.$el.children().first().children('.active').first().attr('id'),
          m = this.model,
          controls = this.controls,
          tmpls = this.template,
          self = this,
          idx = this.tabIndex * 100,
          evalF = function evalF(f, d, model) {
        return _.isFunction(f) ? !!f.apply(d, [model]) : !!f;
      };

      this.$el.empty().attr('role', 'tabpanel').attr('class', _.result(this, 'tabPanelClassName'));
      m.panelEl = this.$el;
      var tabHead = $('<ul class="nav nav-tabs" role="tablist"></ul>').appendTo(this.$el);
      var tabContent = $('<div class="tab-content pg-el-sm-12 pg-el-md-12 pg-el-lg-12 pg-el-12"></div>').appendTo(this.$el);

      _.each(this.schema, function (o) {
        idx++;

        if (!o.version_compatible || !evalF(o.visible, o, m)) {
          return;
        }

        var el = $(tmpls['panel'](_.extend(o, {
          'tabIndex': idx,
          'tabPanelCodeClass': o.tabPanelCodeClass ? o.tabPanelCodeClass : ''
        }))).appendTo(tabContent).removeClass('collapse').addClass('collapse');
        $(tmpls['header'](o)).appendTo(tabHead);
        o.fields.each(function (f) {
          var cntr = new (f.get('control'))({
            field: f,
            model: m,
            dialog: self,
            tabIndex: idx
          });
          el.append(cntr.render().$el);
          controls.push(cntr);
        });
        tabHead.find('a[data-toggle="tab"]').off('shown.bs.tab').off('hidden.bs.tab').on('hidden.bs.tab', function () {
          self.hidden_tab = $(this).data('tabIndex');
        }).on('shown.bs.tab', function () {
          var ctx = this;
          ctx.shown_tab = $(ctx).data('tabIndex');
          m.trigger('pg-property-tab-changed', {
            'model': m,
            'shown': ctx.shown_tab,
            'hidden': ctx.hidden_tab,
            'tab': ctx
          });
        });
      });

      var makeActive = tabHead.find('[id="' + c + '"]').first();

      if (makeActive.length == 1) {
        makeActive.addClass('active show');
        tabContent.find('#' + makeActive.attr('aria-controls')).addClass('active show');
      } else {
        tabHead.find('.nav-link').first().addClass('active show');
        tabContent.find('.tab-pane').first().addClass('active show');
      }

      return this;
    },
    remove: function remove(opts) {
      if (opts && opts.data) {
        if (this.model) {
          if (this.model.reset) {
            this.model.reset({
              validate: false,
              silent: true,
              stop: true
            });
          }

          this.model.clear({
            validate: false,
            silent: true,
            stop: true
          });
          delete this.model;
        }

        if (this.errorModel) {
          this.errorModel.clear({
            validate: false,
            silent: true,
            stop: true
          });
          delete this.errorModel;
        }
      }

      this.cleanup();
      Backform.Form.prototype.remove.apply(this, arguments);
    }
  });
  Backform.Accordian = Backform.Dialog.extend({
    className: function className() {
      return 'set-group pg-el-12';
    },
    tabPanelClassName: function tabPanelClassName() {
      return Backform.tabClassName;
    },
    legendClass: 'badge',
    contentClass: Backform.accordianContentClassName + ' collapse show',
    template: {
      'header': _.template(['<div class="<%=Backform.accordianGroupClassName%>" <%=disabled ? "disabled" : ""%>>', ' <% if (legend != false) { %>', '  <div class="<%=legendClass%>" <%=collapse ? "data-toggle=\'collapse\'" : ""%> data-target="#<%=cId%>" aria-controls="<%=cId%>" aria-level="3" role="heading"><%=collapse ? "<span class=\'caret\'></span>" : "" %><%=label%></legend>', ' <% } %>', '</div>'].join('\n')),
      'content': _.template('  <div id="<%= cId %>" class="<%=contentClass%>"></div>')
    },
    collapse: true,
    render: function render() {
      this.cleanup();

      var m = this.model,
          $el = this.$el,
          tmpl = this.template,
          controls = this.controls,
          data = {
        'className': _.result(this, 'className'),
        'legendClass': _.result(this, 'legendClass'),
        'contentClass': _.result(this, 'contentClass'),
        'collapse': _.result(this, 'collapse')
      },
          idx = this.tabIndex * 100,
          evalF = function evalF(f, d, model) {
        return _.isFunction(f) ? !!f.apply(d, [model]) : !!f;
      };

      this.$el.empty();

      _.each(this.schema, function (o) {
        idx++;

        if (!o.version_compatible || !evalF(o.visible, o, m)) {
          return;
        }

        if (!o.fields) return;

        var d = _.extend({}, data, o),
            h = $(tmpl['header'](d)).appendTo($el),
            el = $(tmpl['content'](d)).appendTo(h);

        o.fields.each(function (f) {
          var cntr = new (f.get('control'))({
            field: f,
            model: m,
            tabIndex: idx
          });
          el.append(cntr.render().$el);
          controls.push(cntr);
        });
      });

      return this;
    },
    getValueFromDOM: function getValueFromDOM() {
      return '';
    },
    events: {}
  });
  Backform.Fieldset = Backform.Dialog.extend({
    className: function className() {
      return 'set-group pg-el-12';
    },
    tabPanelClassName: function tabPanelClassName() {
      return Backform.tabClassName;
    },
    fieldsetClass: Backform.setGroupClassName,
    legendClass: 'badge',
    contentClass: Backform.setGroupContentClassName + ' collapse show',
    template: {
      'header': _.template(['<fieldset class="<%=fieldsetClass%>" <%=disabled ? "disabled" : ""%>>', ' <% if (legend != false) { %>', '  <legend class="<%=legendClass%>" <%=collapse ? "data-toggle=\'collapse\'" : ""%> data-target="#<%=cId%>"><%=collapse ? "<span class=\'caret\'></span>" : "" %><%=label%></legend>', ' <% } %>', '</fieldset>'].join('\n')),
      'content': _.template('  <div id="<%= cId %>" class="<%=contentClass%>"></div>')
    },
    collapse: true,
    render: function render() {
      this.cleanup();

      var m = this.model,
          $el = this.$el,
          tmpl = this.template,
          controls = this.controls,
          data = {
        'className': _.result(this, 'className'),
        'fieldsetClass': _.result(this, 'fieldsetClass'),
        'legendClass': _.result(this, 'legendClass'),
        'contentClass': _.result(this, 'contentClass'),
        'collapse': _.result(this, 'collapse')
      },
          idx = this.tabIndex * 100,
          evalF = function evalF(f, d, model) {
        return _.isFunction(f) ? !!f.apply(d, [model]) : !!f;
      };

      this.$el.empty();

      _.each(this.schema, function (o) {
        idx++;

        if (!o.version_compatible || !evalF(o.visible, o, m)) {
          return;
        }

        if (!o.fields) return;

        var d = _.extend({}, data, o),
            h = $(tmpl['header'](d)).appendTo($el),
            el = $(tmpl['content'](d)).appendTo(h);

        o.fields.each(function (f) {
          var cntr = new (f.get('control'))({
            field: f,
            model: m,
            tabIndex: idx
          });
          el.append(cntr.render().$el);
          controls.push(cntr);
        });
      });

      return this;
    },
    getValueFromDOM: function getValueFromDOM() {
      return '';
    },
    events: {}
  });

  Backform.generateGridColumnsFromModel = function (node_info, m, type, cols, node) {
    var groups = Backform.generateViewSchema(node_info, m, type, node, true, true),
        schema = [],
        columns = [],
        func,
        idx = 0; // Create another array if cols is of type object & store its keys in that array,
    // If cols is object then chances that we have custom width class attached with in.

    if (_.isNull(cols) || _.isUndefined(cols)) {
      func = function func(f) {
        f.cell_priority = idx;
        idx = idx + 1; // We can also provide custom header cell class in schema itself,
        // But we will give priority to extraClass attached in cols
        // If headerCell property is already set by cols then skip extraClass property from schema

        if (!f.headerCell && f.cellHeaderClasses) {
          f.headerCell = Backgrid.Extension.CustomHeaderCell;
        }
      };
    } else if (_.isArray(cols)) {
      func = function func(f) {
        f.cell_priority = _.indexOf(cols, f.name); // We can also provide custom header cell class in schema itself,
        // But we will give priority to extraClass attached in cols
        // If headerCell property is already set by cols then skip extraClass property from schema

        if (!f.headerCell && f.cellHeaderClasses) {
          f.headerCell = Backgrid.Extension.CustomHeaderCell;
        }
      };
    } else if (_.isObject(cols)) {
      var tblCols = Object.keys(cols);

      func = function func(f) {
        var val = f.name in cols && cols[f.name],
            i;

        if (_.isNull(val) || _.isUndefined(val)) {
          f.cell_priority = -1;
          return;
        }

        if (_.isObject(val)) {
          if ('index' in val) {
            f.cell_priority = val['index'];
            idx = idx > val['index'] ? idx + 1 : val['index'];
          } else {
            i = _.indexOf(tblCols, f.name);
            f.cell_priority = idx = i > idx ? i : idx;
            idx = idx + 1;
          } // We can also provide custom header cell class in schema itself,
          // But we will give priority to extraClass attached in cols
          // If headerCell property is already set by cols then skip extraClass property from schema


          if (!f.headerCell) {
            if (f.cellHeaderClasses) {
              f.headerCell = Backgrid.Extension.CustomHeaderCell;
            }

            if ('class' in val && _.isString(val['class'])) {
              f.headerCell = Backgrid.Extension.CustomHeaderCell;
              f.cellHeaderClasses = (f.cellHeaderClasses || '') + ' ' + val['class'];
            }
          }
        }

        if (_.isString(val)) {
          i = _.indexOf(tblCols, f.name);
          f.cell_priority = idx = i > idx ? i : idx;
          idx = idx + 1;

          if (!f.headerCell) {
            f.headerCell = Backgrid.Extension.CustomHeaderCell;
          }

          f.cellHeaderClasses = (f.cellHeaderClasses || '') + ' ' + val;
        }
      };
    } // Prepare columns for backgrid


    _.each(groups, function (group) {
      _.each(group.fields, function (f) {
        if (!f.cell) {
          return;
        } // Check custom property in cols & if it is present then attach it to current cell


        func(f);

        if (f.cell_priority != -1) {
          columns.push(f);
        }
      });

      schema.push(group);
    });

    return {
      'columns': _.sortBy(columns, function (c) {
        return c.cell_priority;
      }),
      'schema': schema
    };
  };

  Backform.BinaryPathsGridControl = Backform.Control.extend({
    initialize: function initialize() {
      Backform.Control.prototype.initialize.apply(this, arguments);
      var BinaryPathModel = Backbone.Model.extend({
        idAttribute: 'serverType',
        defaults: {
          serverType: undefined,
          binaryPath: undefined,
          isDefault: false
        }
      });
      this.gridColumns = [{
        name: 'isDefault',
        label: gettext('Set as default'),
        sortable: false,
        cell: Backgrid.RadioCell,
        cellHeaderClasses: 'width_percent_10',
        headerCell: Backgrid.Extension.CustomHeaderCell,
        deps: ['binaryPath'],
        editable: function editable(m) {
          if (!_.isUndefined(m.get('binaryPath')) && !_.isNull(m.get('binaryPath')) && m.get('binaryPath') !== '') {
            return true;
          } else if (!_.isUndefined(m.get('isDefault')) && !_.isNull(m.get('isDefault'))) {
            setTimeout(function () {
              m.set('isDefault', false);
            }, 10);
          }

          return false;
        }
      }, {
        name: 'serverType',
        label: gettext('Database Server'),
        editable: false,
        cell: 'string',
        cellHeaderClasses: 'width_percent_20',
        headerCell: Backgrid.Extension.CustomHeaderCell
      }, {
        name: 'binaryPath',
        label: gettext('Binary Path'),
        sortable: false,
        cell: Backgrid.Extension.SelectFileCell,
        dialog_type: 'select_folder',
        dialog_title: gettext('Select Folder'),
        placeholder: pgAdmin.server_mode === 'False' ? gettext('Select binary path...') : pgAdmin.enable_binary_path_browsing ? gettext('Select binary path...') : gettext('Enter binary path...'),
        browse_btn_label: gettext('Select path'),
        check_btn_label: gettext('Validate utilities'),
        browse_btn_visible: pgAdmin.server_mode === 'False' ? true : pgAdmin.enable_binary_path_browsing ? true : false
      }];
      var BinPathCollection = this.BinPathCollection = new (Backbone.Collection.extend({
        model: BinaryPathModel
      }))(null);
      var bin_value = JSON.parse(this.model.get(this.field.get('name')));
      this.BinPathCollection.add(bin_value);
      this.listenTo(BinPathCollection, 'change', this.binPathCollectionChanged);
    },
    render: function render() {
      var self = this,
          gridHeader = ['<div class=\'subnode-header\'>', '  <span class=\'control-label pg-el-sm-12\'>' + gettext(this.field.get('label')) + '</span>', '</div>'].join('\n'),
          gridBody = $('<div class=\'pgadmin-control-group backgrid form-group pg-el-12 object subnode\'></div>').append(gridHeader);
      self.grid = new Backgrid.Grid({
        columns: self.gridColumns,
        collection: self.BinPathCollection,
        className: 'backgrid table presentation table-bordered table-noouter-border table-hover'
      });
      this.$el.empty();
      this.$el.append(gridBody.append(self.grid.render().$el));
      this.$el.append(['<span class="pg-el-sm-12 form-text text-muted help-block">' + gettext('Enter the directory in which the psql, pg_dump, pg_dumpall, and pg_restore' + ' utilities can be found for the corresponding database server version.' + ' The default path will be used for server versions that do not have a' + ' path specified.') + '</span>'].join('\n'));
      return this;
    },
    binPathCollectionChanged: function binPathCollectionChanged() {
      var bin_value = JSON.stringify(this.BinPathCollection.toJSON());
      this.model.set(this.field.get('name'), bin_value, {
        silent: false
      });
    }
  });
  Backform.UniqueColCollectionControl = Backform.Control.extend({
    initialize: function initialize() {
      Backform.Control.prototype.initialize.apply(this, arguments);
      var uniqueCol = this.field.get('uniqueCol') || [],
          m = this.field.get('model'),
          schema = m.prototype.schema || m.__super__.schema,
          columns = [],
          self = this;

      _.each(schema, function (s) {
        columns.push(s.id);
      }); // Check if unique columns provided are also in model attributes.


      if (uniqueCol.length > _.intersection(columns, uniqueCol).length) {
        var errorMsg = 'Developer: Unique columns [ ' + _.difference(uniqueCol, columns) + ' ] not found in collection model [ ' + columns + ' ].';
        throw errorMsg;
      }

      var collection = self.collection = self.model.get(self.field.get('name'));

      if (!collection) {
        collection = self.collection = new pgAdmin.Browser.Node.Collection(null, {
          model: self.field.get('model'),
          silent: true,
          handler: self.model,
          top: self.model.top || self.model,
          attrName: self.field.get('name')
        });
        self.model.set(self.field.get('name'), collection, {
          silent: true
        });
      }

      if (this.field.get('version_compatible')) {
        self.listenTo(collection, 'add', self.collectionChanged);
        self.listenTo(collection, 'change', self.collectionChanged);
      }
    },
    cleanup: function cleanup() {
      this.stopListening(this.collection, 'change', this.collectionChanged);

      if (this.field.get('version_compatible')) {
        this.stopListening(self.collection, 'add', this.collectionChanged);
        this.stopListening(self.collection, 'change', this.collectionChanged);
      }

      if (this.grid) {
        this.grid.remove();
        delete this.grid;
      }

      this.$el.empty();
    },
    collectionChanged: function collectionChanged(newModel, coll, op) {
      var uniqueCol = this.field.get('uniqueCol') || [],
          uniqueChangedAttr = [],
          self = this; // Check if changed model attributes are also in unique columns. And then only check for uniqueness.

      if (newModel.attributes) {
        _.each(uniqueCol, function (col) {
          if (_.has(newModel.attributes, col)) {
            uniqueChangedAttr.push(col);
          }
        });

        if (uniqueChangedAttr.length == 0) {
          return;
        }
      } else {
        return;
      }

      var collection = this.model.get(this.field.get('name'));
      this.stopListening(collection, 'change', this.collectionChanged); // Check if changed attribute's value of new/updated model also exist for another model in collection.
      // If duplicate value exists then set the attribute's value of new/updated model to its previous values.

      var m = undefined,
          oldModel = undefined;
      collection.each(function (model) {
        if (newModel != model) {
          var duplicateAttrValues = [];

          _.each(uniqueCol, function (attr) {
            var attrValue = newModel.get(attr);

            if (!_.isUndefined(attrValue) && attrValue == model.get(attr)) {
              duplicateAttrValues.push(attrValue);
            }
          });

          if (duplicateAttrValues.length == uniqueCol.length) {
            m = newModel; // Keep reference of model to make it visible in dialog.

            oldModel = model;
          }
        }
      });

      if (m) {
        if (op && op.add) {
          // Remove duplicate model.
          setTimeout(function () {
            collection.remove(m);
          }, 0);
        } else {
          /*
           * Set model value to its previous value as its new value is
           * conflicting with another model value.
           */
          m.set(uniqueChangedAttr[0], m.previous(uniqueChangedAttr[0]));
        }

        if (oldModel) {
          var idx = collection.indexOf(oldModel);

          if (idx > -1) {
            var newRow = self.grid.body.rows[idx].$el;
            newRow.addClass('new');
            $(newRow).pgMakeVisible('backform-tab');
            setTimeout(function () {
              newRow.removeClass('new');
            }, 3000);
          }
        }
      }

      this.listenTo(collection, 'change', this.collectionChanged);
    },
    render: function render() {
      // Clean up existing elements
      this.undelegateEvents();
      this.$el.empty();

      var field = _.defaults(this.field.toJSON(), this.defaults),
          attributes = this.model.toJSON(),
          attrArr = field.name.split('.'),
          name = attrArr.shift(),
          path = attrArr.join('.'),
          rawValue = this.keyPathAccessor(attributes[name], path),
          data = _.extend(field, {
        rawValue: rawValue,
        value: this.formatter.fromRaw(rawValue, this.model),
        attributes: attributes,
        formatter: this.formatter
      }),
          evalF = function evalF(f, d, m) {
        return _.isFunction(f) ? !!f.apply(d, [m]) : !!f;
      }; // Evaluate the disabled, visible, required, canAdd, & canDelete option


      _.extend(data, {
        disabled: field.version_compatible && evalF.apply(this.field, [data.disabled, data, this.model]),
        visible: evalF.apply(this.field, [data.visible, data, this.model]),
        required: evalF.apply(this.field, [data.required, data, this.model]),
        canAdd: field.version_compatible && evalF.apply(this.field, [data.canAdd, data, this.model]),
        canAddRow: data.canAddRow,
        canDelete: evalF.apply(this.field, [data.canDelete, data, this.model]),
        canEdit: evalF.apply(this.field, [data.canEdit, data, this.model])
      });

      _.extend(data, {
        add_label: ''
      }); // This control is not visible, we should remove it.


      if (!data.visible) {
        return this;
      }

      this.control_data = _.clone(data); // Show Backgrid Control

      var grid = this.showGridControl(data);
      this.$el.html(grid).addClass(field.name);
      this.updateInvalid();
      this.delegateEvents();
      return this;
    },
    showGridControl: function showGridControl(data) {
      data.cId = data.cId || _.uniqueId('pgC_');

      var self = this,
          gridHeader = _.template(['<div class="subnode-header">', '  <span  class="control-label pg-el-sm-10" id="<%=cId%>"><%-label%></span>', '  <button aria-label="' + gettext('Add new row') + '" class="btn btn-sm-sq btn-primary-icon add fa fa-plus" <%=canAdd ? "" : "disabled=\'disabled\'"%> title="' + gettext('Add new row') + '"><%-add_label%></button>', '</div>'].join('\n')),
          gridBody = $('<div class="pgadmin-control-group backgrid form-group pg-el-12 object subnode "></div>').append(gridHeader(data)); // Clean up existing grid if any (in case of re-render)


      if (self.grid) {
        self.grid.remove();
      }

      if (!data.subnode) {
        return '';
      }

      var subnode = data.subnode.schema ? data.subnode : data.subnode.prototype,
          gridSchema = Backform.generateGridColumnsFromModel(data.node_info, subnode, this.field.get('mode'), data.columns); // Set visibility of Add button

      if (data.mode == 'properties') {
        $(gridBody).find('button.add').remove();
      } // Insert Delete Cell into Grid


      if (!data.disabled && data.canDelete) {
        gridSchema.columns.unshift({
          name: 'pg-backform-delete',
          label: '',
          cell: Backgrid.Extension.DeleteCell,
          editable: false,
          cell_priority: -1,
          canDeleteRow: data.canDeleteRow
        });
      } // Insert Edit Cell into Grid


      if (data.disabled == false && data.canEdit) {
        var editCell = Backgrid.Extension.ObjectCell.extend({
          schema: gridSchema.schema
        });
        gridSchema.columns.unshift({
          name: 'pg-backform-edit',
          label: '',
          cell: editCell,
          cell_priority: -2,
          canEditRow: data.canEditRow
        });
      }

      var collection = this.model.get(data.name);

      var cellEditing = function cellEditing(args) {
        var that = this,
            cell = args[0]; // Search for any other rows which are open.

        this.each(function (m) {
          // Check if row which we are about to close is not current row.
          if (cell.model != m) {
            var idx = that.indexOf(m);

            if (idx > -1) {
              var row = self.grid.body.rows[idx],
                  rowEditCell = row.$el.find('.subnode-edit-in-process').parent(); // Only close row if it's open.

              if (rowEditCell.length > 0) {
                var event = new Event('click');
                rowEditCell[0].dispatchEvent(event);
              }
            }
          }
        });
      }; // Listen for any row which is about to enter in edit mode.


      collection.on('enteringEditMode', cellEditing, collection); // Initialize a new Grid instance

      self.grid = new Backgrid.Grid({
        columns: gridSchema.columns,
        collection: collection,
        className: 'backgrid table presentation table-bordered table-noouter-border table-hover',
        attr: {
          'aria-labelledby': data.cId
        }
      });

      for (var i = 0; i < collection.length; i++) {
        collection.at(i).parentTr = self.grid.body.rows[i].$el;
      } // Render subNode grid


      var subNodeGrid = self.grid.render().$el; // Combine Edit and Delete Cell

      if (data.canDelete && data.canEdit) {
        $(subNodeGrid).find('th.pg-backform-delete').remove();
        $(subNodeGrid).find('th.pg-backform-edit').attr('colspan', '2');
      }

      var $dialog = gridBody.append(subNodeGrid);
      var tmp_browser = pgBrowser;
      if (pgBrowser.preferences_cache.length == 0) tmp_browser = pgWindow["default"].pgAdmin.Browser;
      var preferences = tmp_browser.get_preferences_for_module('browser');

      if (preferences) {
        var addBtn = $dialog.find('.add'); // Add title to the buttons

        $(addBtn).attr('title', keyboardShortcuts.shortcut_title(gettext('Add new row'), preferences.add_grid_row));
      } // Add button callback


      if (!(data.disabled || data.canAdd == false)) {
        $dialog.find('button.add').first().on('click', function (e) {
          e.preventDefault();
          var canAddRow = _.isFunction(data.canAddRow) ? data.canAddRow.apply(self, [self.model]) : true;

          if (canAddRow) {
            // Close any existing expanded row before adding new one.
            _.each(self.grid.body.rows, function (row) {
              var rowEditCell = row.$el.find('.subnode-edit-in-process').parent(); // Only close row if it's open.

              if (rowEditCell.length > 0) {
                var event = new Event('click');
                rowEditCell[0].dispatchEvent(event);
              }
            });

            var allowMultipleEmptyRows = !!self.field.get('allowMultipleEmptyRows'); // If allowMultipleEmptyRows is not set or is false then don't allow second new empty row.
            // There should be only one empty row.

            if (!allowMultipleEmptyRows && collection) {
              var isEmpty = false;
              collection.each(function (model) {
                var modelValues = [];

                _.each(model.attributes, function (val) {
                  modelValues.push(val);
                });

                if (!_.some(modelValues, _.identity)) {
                  isEmpty = true;
                }
              });

              if (isEmpty) {
                return false;
              }
            }

            $(self.grid.body.$el.find($('tr.new'))).removeClass('new');
            var m = new data.model(null, {
              silent: true,
              handler: collection,
              top: self.model.top || self.model,
              collection: collection,
              node_info: self.model.node_info
            });

            if (data.beforeAdd) {
              m = data.beforeAdd.apply(self, [m]);
            }

            collection.add(m);
            var idx = collection.indexOf(m),
                newRow = self.grid.body.rows[idx].$el;
            collection.get(m).parentTr = newRow;
            m.parentTr = newRow;
            newRow.addClass('new');

            if (!$(newRow).pgMakeBackgridVisible('.backform-tab')) {
              // We can have subnode controls in Panels
              $(newRow).pgMakeBackgridVisible('.set-group');
            }

            return false;
          }
        });
      }

      return $dialog;
    },
    clearInvalid: function clearInvalid() {
      this.$el.removeClass('subnode-error');
      this.$el.find('.pgadmin-control-error-message').remove();
      return this;
    },
    updateInvalid: function updateInvalid() {
      var self = this,
          errorModel = self.model.errorModel;
      if (!(errorModel instanceof Backbone.Model)) return this;
      this.clearInvalid();
    }
  });
  Backform.SubNodeCollectionControl = Backform.Control.extend({
    row: Backgrid.Row,
    render: function render() {
      var field = _.defaults(this.field.toJSON(), this.defaults),
          attributes = this.model.toJSON(),
          attrArr = field.name.split('.'),
          name = attrArr.shift(),
          path = attrArr.join('.'),
          rawValue = this.keyPathAccessor(attributes[name], path),
          data = _.extend(field, {
        rawValue: rawValue,
        value: this.formatter.fromRaw(rawValue, this.model),
        attributes: attributes,
        formatter: this.formatter
      }),
          evalF = function evalF(f, d, m) {
        return _.isFunction(f) ? !!f.apply(d, [m]) : !!f;
      }; // Evaluate the disabled, visible, required, canAdd, cannEdit & canDelete option


      _.extend(data, {
        disabled: evalF(data.disabled, data, this.model),
        visible: evalF(data.visible, data, this.model),
        required: evalF(data.required, data, this.model),
        canAdd: evalF(data.canAdd, data, this.model),
        canAddRow: data.canAddRow,
        canEdit: evalF(data.canEdit, data, this.model),
        canDelete: evalF(data.canDelete, data, this.model),
        showError: data.showError || true
      }); // Show Backgrid Control


      var grid = data.subnode == undefined ? '' : this.showGridControl(data); // Clean up first

      this.$el.removeClass(Backform.hiddenClassName);
      if (!data.visible) this.$el.addClass(Backform.hiddenClassName);
      this.$el.html(grid).addClass(field.name);
      this.updateInvalid();
      return this;
    },
    updateInvalid: function updateInvalid() {
      var self = this;
      var errorModel = this.model.errorModel;
      if (!(errorModel instanceof Backbone.Model)) return this;
      this.clearInvalid();
      var attrArr = self.field.get('name').split('.'),
          path = attrArr.join('.'),
          error = self.keyPathAccessor(errorModel.toJSON(), path);
      if (_.isEmpty(error)) return;

      if (self.field.get('showError')) {
        self.$el.addClass('subnode-error').append($('<div></div>').addClass('pgadmin-control-error-message pg-el-offset-4 pg-el-8 help-block').text(error));
      }
    },
    cleanup: function cleanup() {
      // Clean up existing grid if any (in case of re-render)
      if (this.grid) {
        this.grid.remove();
      }

      if (this.collection) {
        this.collection.off('enteringEditMode');
      }
    },
    clearInvalid: function clearInvalid() {
      if (this.field.get('showError')) {
        this.$el.removeClass('subnode-error');
        this.$el.find('.pgadmin-control-error-message').remove();
      }

      return this;
    },
    showGridControl: function showGridControl(data) {
      var _this = this;

      var self = this,
          gridHeader = ['<div class=\'subnode-header\'>', '  <span class=\'control-label pg-el-sm-10\'>' + data.label + '</span>', '  <button aria-label="' + gettext('Add') + '" class=\'btn btn-sm-sq btn-primary-icon add fa fa-plus\' title=\'' + gettext('Add new row') + '\'></button>', '</div>'].join('\n'),
          gridBody = $('<div class=\'pgadmin-control-group backgrid form-group pg-el-12 object subnode\'></div>').append(gridHeader);
      var subnode = data.subnode.schema ? data.subnode : data.subnode.prototype,
          gridSchema = Backform.generateGridColumnsFromModel(data.node_info, subnode, this.field.get('mode'), data.columns, data.schema_node); // Clean up existing grid if any (in case of re-render)

      if (self.grid) {
        self.grid.remove();
      } // Set visibility of Add button


      if (data.disabled || data.canAdd == false) {
        $(gridBody).find('button.add').remove();
      } // Insert Delete Cell into Grid


      if (data.disabled == false && data.canDelete) {
        gridSchema.columns.unshift({
          name: 'pg-backform-delete',
          label: '',
          cell: Backgrid.Extension.DeleteCell,
          editable: false,
          cell_priority: -1,
          canDeleteRow: data.canDeleteRow,
          customDeleteMsg: data.customDeleteMsg,
          customDeleteTitle: data.customDeleteTitle
        });
      } // Insert Edit Cell into Grid


      if (data.disabled == false && data.canEdit) {
        var editCell = Backgrid.Extension.ObjectCell.extend({
          schema: gridSchema.schema
        }),
            canEdit = self.field.has('canEdit') && self.field.get('canEdit') || true;
        gridSchema.columns.unshift({
          name: 'pg-backform-edit',
          label: '',
          cell: editCell,
          cell_priority: -2,
          editable: canEdit,
          canEditRow: data.canEditRow
        });
      }

      var collection = self.model.get(data.name);

      if (!collection) {
        collection = new pgBrowser.Node.Collection(null, {
          handler: self.model.handler || self.model,
          model: data.model,
          top: self.model.top || self.model,
          silent: true
        });
        self.model.set(data.name, collection, {
          silent: true
        });
      }

      var cellEditing = function cellEditing(args) {
        var ctx = this,
            cell = args[0]; // Search for any other rows which are open.

        this.each(function (m) {
          // Check if row which we are about to close is not current row.
          if (cell.model != m) {
            var idx = ctx.indexOf(m);

            if (idx > -1) {
              var row = grid.body.rows[idx],
                  rowEditCell = row.$el.find('.subnode-edit-in-process').parent(); // Only close row if it's open.

              if (rowEditCell.length > 0) {
                var event = new Event('click');
                rowEditCell[0].dispatchEvent(event);
              }
            }
          }
        });
      }; // Listen for any row which is about to enter in edit mode.


      collection.on('enteringEditMode', cellEditing, collection); // Initialize a new Grid instance

      var grid = self.grid = new Backgrid.Grid({
        columns: gridSchema.columns,
        collection: collection,
        row: this.row,
        className: 'backgrid table presentation table-bordered table-noouter-border table-hover'
      }); // Render subNode grid

      var subNodeGrid = grid.render().$el; // Combine Edit and Delete Cell

      if (data.canDelete && data.canEdit) {
        $(subNodeGrid).find('th.pg-backform-delete').remove();
        $(subNodeGrid).find('th.pg-backform-edit').attr('colspan', '2');
      }

      var $dialog = gridBody.append(subNodeGrid);
      var tmp_browser = pgBrowser;
      if (pgBrowser.preferences_cache.length == 0) tmp_browser = pgWindow["default"].pgAdmin.Browser;
      var preferences = tmp_browser.get_preferences_for_module('browser');

      if (preferences) {
        var addBtn = $dialog.find('.add'); // Add title to the buttons

        $(addBtn).attr('title', keyboardShortcuts.shortcut_title(gettext('Add new row'), preferences.add_grid_row));
      } // Add button callback


      $dialog.find('button.add').on('click', function (e) {
        e.preventDefault();
        var canAddRow = _.isFunction(data.canAddRow) ? data.canAddRow.apply(self, [self.model]) : true;

        if (canAddRow) {
          // Close any existing expanded row before adding new one.
          _.each(grid.body.rows, function (row) {
            var rowEditCell = row.$el.find('.subnode-edit-in-process').parent(); // Only close row if it's open.

            if (rowEditCell.length > 0) {
              var event = new Event('click');
              rowEditCell[0].dispatchEvent(event);
            }
          });

          grid.insertRow({});
          var newRow = $(grid.body.rows[collection.length - 1].$el);
          newRow.attr('class', 'new').on('click', function () {
            $(_this).attr('class', 'editable');
          });

          if (!$(newRow).pgMakeBackgridVisible('.backform-tab')) {
            // We can have subnode controls in Panels
            $(newRow).pgMakeBackgridVisible('.set-group');
          }

          return false;
        }
      });
      return $dialog;
    }
  });
  /*
   * SQL Tab Control for showing the modified SQL for the node with the
   * property 'hasSQL' is set to true.
   *
   * When the user clicks on the SQL tab, we will send the modified data to the
   * server and fetch the SQL for it.
   */

  Backform.SqlTabControl = Backform.Control.extend({
    defaults: {
      label: '',
      controlsClassName: 'pgadmin-controls pg-el-sm-12 SQL',
      extraClasses: [],
      helpMessage: null
    },
    template: _.template(['<label for="<%=cId%>" class="sr-only"><%=(label==""?"SQL":label)%></label>', '<div class="<%=controlsClassName%>">', '  <textarea id="<%=cId%>" class="<%=Backform.controlClassName%> <%=extraClasses.join(\' \')%>" name="<%=name%>" aria-label="<%=name%>" placeholder="<%-placeholder%>" <%=disabled ? "disabled" : ""%> <%=readonly ? "readonly aria-readonly=true" : ""%> <%=required ? "required" : ""%>><%-value%></textarea>', '  <% if (helpMessage && helpMessage.length) { %>', '    <span class="<%=Backform.helpMessageClassName%>"><%=helpMessage%></span>', '  <% } %>', '</div>'].join('\n')),

    /*
     * Initialize the SQL Tab control properly
     */
    initialize: function initialize(o) {
      Backform.Control.prototype.initialize.apply(this, arguments); // Save the required information for using it later.

      this.dialog = o.dialog;
      this.tabIndex = o.tabIndex;

      _.bindAll(this, 'onTabChange', 'onPanelResized');
    },
    getValueFromDOM: function getValueFromDOM() {
      return this.formatter.toRaw(this.$el.find('textarea').val(), this.model);
    },
    reflectPreferences: function reflectPreferences() {
      var self = this;
      /* self.sqlCtrl is null when SQL tab is not active */

      if (self.sqlCtrl) {
        var sqlEditPreferences = pgAdmin.Browser.get_preferences_for_module('sqleditor');
        $(self.sqlCtrl.getWrapperElement()).css('font-size', SqlEditorUtils.calcFontSize(sqlEditPreferences.sql_font_size));
        self.sqlCtrl.setOption('tabSize', sqlEditPreferences.tab_size);
        self.sqlCtrl.setOption('lineWrapping', sqlEditPreferences.wrap_code);
        self.sqlCtrl.setOption('autoCloseBrackets', sqlEditPreferences.insert_pair_brackets);
        self.sqlCtrl.setOption('matchBrackets', sqlEditPreferences.brace_matching);
        self.sqlCtrl.refresh();
      }
    },
    render: function render() {
      if (this.sqlCtrl) {
        this.sqlCtrl.toTextArea();
        delete this.sqlCtrl;
        this.sqlCtrl = null;
        this.$el.empty();
        this.model.off('pg-property-tab-changed', this.onTabChange, this);
        this.model.off('pg-browser-resized', this.onPanelResized, this);
      } // Use the Backform Control's render function


      Backform.Control.prototype.render.apply(this, arguments);
      this.sqlCtrl = CodeMirror.fromTextArea(this.$el.find('textarea')[0], {
        lineNumbers: true,
        mode: 'text/x-pgsql',
        readOnly: true,
        extraKeys: pgAdmin.Browser.editor_shortcut_keys,
        screenReaderLabel: 'SQL'
      });
      this.reflectPreferences();
      /* Check for sql editor preference changes */

      var self = this;
      this.$el.find('textarea').attr('tabindex', -1);
      pgBrowser.onPreferencesChange('sqleditor', function () {
        self.reflectPreferences();
      });
      /*
       * We will listen to the tab change event to check, if the SQL tab has
       * been clicked or, not.
       */

      this.model.on('pg-property-tab-changed', this.onTabChange, this);
      this.model.on('pg-browser-resized', this.onPanelResized, this);
      return this;
    },
    onTabChange: function onTabChange(obj) {
      // Fetch the information only if the SQL tab is visible at the moment.
      if (this.dialog && obj.shown == this.tabIndex) {
        // We will send a request to the sever only if something has changed
        // in a model and also it does not contain any error.
        if (this.model.sessChanged()) {
          if (_.size(this.model.errorModel.attributes) == 0) {
            var self = this,
                node = self.field.get('schema_node'),
                msql_url = node.generate_url.apply(node, [null, 'msql', this.field.get('node_data'), !self.model.isNew(), this.field.get('node_info'), node.url_jump_after_node]); // Fetching the modified SQL

            self.model.trigger('pgadmin-view:msql:fetching', self.method, node);
            $.ajax({
              url: msql_url,
              type: 'GET',
              cache: false,
              data: self.model.toJSON(true, 'GET'),
              dataType: 'json',
              contentType: 'application/json'
            }).done(function (res) {
              self.sqlCtrl.clearHistory();
              self.sqlCtrl.setValue(res.data);
            }).fail(function () {
              self.model.trigger('pgadmin-view:msql:error', self.method, node, arguments);
            }).always(function () {
              self.model.trigger('pgadmin-view:msql:fetched', self.method, node, arguments);
            });
          } else {
            this.sqlCtrl.clearHistory();
            this.sqlCtrl.setValue('-- ' + gettext('Definition incomplete.'));
          }
        } else {
          this.sqlCtrl.clearHistory();
          this.sqlCtrl.setValue('-- ' + gettext('No updates.'));
        }

        this.sqlCtrl.refresh.apply(this.sqlCtrl);
      }
    },
    onPanelResized: function onPanelResized(o) {
      if (o && o.container) {
        var $tabContent = o.container.find('.backform-tab > .tab-content').first(),
            $sqlPane = $tabContent.find('div[role=tabpanel].tab-pane.SQL');

        if ($sqlPane.hasClass('active')) {
          $sqlPane.find('.CodeMirror').css('cssText', 'height: ' + ($tabContent.height() + 8) + 'px !important;');
        }
      }
    },
    remove: function remove() {
      if (this.sqlCtrl) {
        this.sqlCtrl.toTextArea();
        delete this.sqlCtrl;
        this.sqlCtrl = null;
        this.$el.empty();
      }

      this.model.off('pg-property-tab-changed', this.onTabChange, this);
      this.model.off('pg-browser-resized', this.onPanelResized, this);

      Backform.Control.__super__.remove.apply(this, arguments);
    }
  });
  /*
   * Numeric input Control functionality just like backgrid
   */

  Backform.NumericControl = Backform.InputControl.extend({
    defaults: {
      type: 'number',
      label: '',
      min: undefined,
      max: undefined,
      maxlength: 255,
      extraClasses: [],
      helpMessage: null
    },
    template: _.template(['<label for="<%=cId%>" class="<%=Backform.controlLabelClassName%> text-wrap"><%=label%></label>', '<div class="<%=Backform.controlsClassName%>">', '  <input type="<%=type%>" id="<%=cId%>" class="<%=Backform.controlClassName%> <%=extraClasses.join(\' \')%>" name="<%=name%>" min="<%=min%>" max="<%=max%>"maxlength="<%=maxlength%>" value="<%-value%>" placeholder="<%-placeholder%>" <%=disabled ? "disabled" : ""%> <%=readonly ? "readonly aria-readonly=true" : ""%> <%=required ? "required" : ""%> />', '  <% if (helpMessage && helpMessage.length) { %>', '    <span class="<%=Backform.helpMessageClassName%>"><%=helpMessage%></span>', '  <% } %>', '</div>'].join('\n'))
  }); ///////
  // Generate a schema (as group members) based on the model's schema
  //
  // It will be used by the grid, properties, and dialog view generation
  // functions.

  Backform.generateViewSchema = function (node_info, Model, mode, node, treeData, noSQL, subschema) {
    var proto = Model && Model.prototype || Model,
        schema = subschema || proto && proto.schema,
        fields = [],
        groupInfo = {}; // 'schema' has the information about how to generate the form.

    if (schema && _.isArray(schema)) {
      var evalASFunc = evalASFunc = function evalASFunc(prop) {
        return prop && proto[prop] && typeof proto[prop] == 'function' ? proto[prop] : prop;
      };

      var groups = {},
          server_info = node_info && 'server' in node_info && pgBrowser.serverInfo && pgBrowser.serverInfo[node_info.server._id],
          in_catalog = node_info && 'catalog' in node_info,
          ver_in_limit;

      _.each(schema, function (s) {
        // Do we understand - what control, we're creating
        // here?
        if (s.type == 'group') {
          var visible = true;
          ver_in_limit = _.isUndefined(server_info) ? true : (_.isUndefined(s.server_type) ? true : server_info.type in s.server_type) && (_.isUndefined(s.min_version) ? true : server_info.version >= s.min_version) && (_.isUndefined(s.max_version) ? true : server_info.version <= s.max_version);
          if (s.mode && _.isObject(s.mode)) visible = _.indexOf(s.mode, mode) > -1;
          if (visible) visible = evalASFunc(s.visible);
          groupInfo[s.id] = {
            label: s.label || s.id,
            version_compatible: ver_in_limit,
            visible: visible,
            tabPanelCodeClass: ''
          };
          return;
        }

        if (!s.mode || s && s.mode && _.isObject(s.mode) && _.indexOf(s.mode, mode) != -1) {
          // Each field is kept in specified group, or in
          // 'General' category.
          var group = s.group || gettext('General'),
              control = s.control || Backform.getMappedControl(s.type, mode),
              cell = s.cell || Backform.getMappedControl(s.type, 'cell');

          if (control == null) {
            return;
          } // Generate the empty group list (if not exists)


          groups[group] = groups[group] || [];
          ver_in_limit = _.isUndefined(server_info) ? true : (_.isUndefined(s.server_type) ? true : server_info.type in s.server_type) && (_.isUndefined(s.min_version) ? true : server_info.version >= s.min_version) && (_.isUndefined(s.max_version) ? true : server_info.version <= s.max_version);
          var disabled = !ver_in_limit || in_catalog,
              readonly = mode == 'properties',
              schema_node = s.node && _.isString(s.node) && s.node in pgBrowser.Nodes && pgBrowser.Nodes[s.node] || node;

          var o = _.extend(_.clone(s), {
            name: s.id,
            // This can be disabled in some cases (if not hidden)
            disabled: disabled ? true : evalASFunc(s.disabled),
            readonly: readonly ? true : evalASFunc(s.readonly),
            editable: _.isUndefined(s.editable) ? pgAdmin.editableCell : evalASFunc(s.editable),
            subnode: _.isString(s.model) && s.model in pgBrowser.Nodes ? pgBrowser.Nodes[s.model].model : s.model,
            canAdd: disabled || readonly ? false : evalASFunc(s.canAdd),
            canAddRow: disabled || readonly ? false : evalASFunc(s.canAddRow),
            canEdit: disabled || readonly ? false : evalASFunc(s.canEdit),
            canDelete: disabled || readonly ? false : evalASFunc(s.canDelete),
            canEditRow: disabled || readonly ? false : evalASFunc(s.canEditRow),
            canDeleteRow: disabled || readonly ? false : evalASFunc(s.canDeleteRow),
            transform: evalASFunc(s.transform),
            mode: mode,
            control: control,
            cell: cell,
            node_info: node_info,
            schema_node: schema_node,
            // Do we need to show this control in this mode?
            visible: evalASFunc(s.visible),
            node: node,
            node_data: treeData,
            version_compatible: ver_in_limit
          });

          delete o.id; // Temporarily store in dictionary format for
          // utilizing it later.

          groups[group].push(o);

          if (s.type == 'nested') {
            delete o.name;
            delete o.cell;
            o.schema = Backform.generateViewSchema(node_info, Model, mode, node, treeData, true, s.schema);
            o.control = o.control || 'tab';
          }
        }
      }); // Do we have fields to genreate controls, which we
      // understand?


      if (_.isEmpty(groups)) {
        return null;
      }

      if (!noSQL && node && node.hasSQL && (mode == 'create' || mode == 'edit')) {
        groups[gettext('SQL')] = [{
          name: 'sql',
          visible: true,
          disabled: false,
          type: 'text',
          control: 'sql-tab',
          node_info: node_info,
          schema_node: node,
          node_data: treeData
        }];
      } // Create an array from the dictionary with proper required
      // structure.


      _.each(groups, function (val, key) {
        var tabPanelCodeClass = _.pluck(val, 'tabPanelCodeClass');

        if (tabPanelCodeClass) {
          tabPanelCodeClass = tabPanelCodeClass.join(' ').trim();
        }

        fields.push(_.extend(_.defaults(groupInfo[key] || {
          label: key,
          tabPanelCodeClass: tabPanelCodeClass
        }, {
          version_compatible: true,
          visible: true
        }), {
          fields: val
        }));
      });
    }

    return fields;
  };

  var Select2Formatter = function Select2Formatter() {};

  _.extend(Select2Formatter.prototype, {
    fromRaw: function fromRaw(rawData) {
      return encodeURIComponent(rawData);
    },
    toRaw: function toRaw(formattedData, model, opts) {
      if (_.isArray(formattedData)) {
        if (opts && opts.tags) return formattedData;
        return _.map(formattedData, decodeURIComponent);
      } else {
        if (!_.isNull(formattedData) && !_.isUndefined(formattedData)) {
          return decodeURIComponent(formattedData);
        } else {
          return null;
        }
      }
    }
  });
  /*
   *  Backform Select2 control.
   */


  Backform.Select2Control = Backform.SelectControl.extend({
    defaults: _.extend({}, Backform.SelectControl.prototype.defaults, {
      select2: {
        first_empty: true,
        multiple: false,
        emptyOptions: false,
        preserveSelectionOrder: false,
        isDropdownParent: false
      },
      // To accept the label and conrol classes while extending control if
      // required(e.g. if we want to show label and control in 50-50% or in
      //different width of dialog/form) otherwise default classes will be added
      controlLabelClassName: Backform.controlLabelClassName,
      controlsClassName: Backform.controlsClassName
    }),
    events: function events() {
      // Inherit all default events of InputControl
      return _.extend({}, Backform.SelectControl.prototype.events, {
        'select2:select': 'onSelect'
      });
    },
    onSelect: function onSelect(evt) {
      var sel2Options = this.field.get('select2');

      if (!_.isUndefined(sel2Options) && !_.isNull(sel2Options) && sel2Options.multiple && sel2Options.preserveSelectionOrder) {
        var element = evt.params.data.element;
        var $element = $(element);
        $element.detach();
        $(this.$sel).append($element);
        $(this.$sel).trigger('change');
      }

      var new_value = _.findWhere(this.field.get('options'), {
        value: evt.params.data.id
      });

      if (new_value && !_.isUndefined(new_value.preview_src) && new_value.preview_src) {
        this.$el.find('.preview-img img').attr('src', new_value.preview_src);
      }
    },
    formatter: Select2Formatter,
    template: _.template(['<% if(label == false) {} else {%>', '  <label class="<%=controlLabelClassName%>" for="<%=cId%>"><%=label%></label>', '<% }%>', '<div class="<%=controlsClassName%>">', ' <select title="<%=name%>" id="<%=cId%>" class="<%=Backform.controlClassName%> <%=extraClasses.join(\' \')%>"', '  name="<%=name%>" value="<%-value%>" <%=disabled ? "disabled" : ""%> <%=readonly ? "disabled" : ""%>', '  <%=required ? "required" : ""%><%= select2.multiple ? " multiple>" : ">" %>', '  <%=select2.first_empty ? " <option></option>" : ""%>', '  <% for (var i=0; i < options.length; i++) {%>', '   <% var option = options[i]; %>', '   <option ', '    <% if (option.image) { %> data-image=<%=option.image%> <%}%>', '    value=<%- formatter.fromRaw(option.value) %>', '    <% if (option.selected) {%>selected="selected"<%} else {%>', '    <% if (!select2.multiple && option.value === rawValue) {%>selected="selected"<%}%>', '    <% if (select2.multiple && rawValue && rawValue.indexOf(option.value) != -1){%>selected="selected" data-index="rawValue.indexOf(option.value)"<%}%>', '    <%}%>', '    <%= disabled ? "disabled" : ""%> <%=readonly ? "disabled" : ""%>><%-option.label%></option>', '  <%}%>', ' </select>', ' <% if (helpMessage && helpMessage.length) { %>', ' <span class="<%=Backform.helpMessageClassName%>"><%=helpMessage%></span>', ' <% } %>', ' <% for (var i=0; i < options.length; i++) {%>', '   <% var option = options[i]; %>', '     <% if (option.preview_src && option.value === rawValue) { %>', '       <div class="preview-img mt-2">', '         <img src="<%=option.preview_src%>" class="img-fluid mx-auto d-block w-50 border" alt="' + gettext('Preview not available...') + '">', '       </div>', '    <%}%>', ' <%}%>', '</div>'].join('\n')),
    render: function render() {
      var _this2 = this;

      if (this.$sel && this.$sel.select2 && this.$sel.select2.hasOwnProperty('destroy')) {
        this.$sel.select2('destroy');
      }

      var field = _.defaults(this.field.toJSON(), this.defaults),
          attributes = this.model.toJSON(),
          attrArr = field.name.split('.'),
          name = attrArr.shift(),
          path = attrArr.join('.'),
          rawValue = this.keyPathAccessor(attributes[name], path),
          data = _.extend(field, {
        rawValue: rawValue,
        value: this.formatter.fromRaw(rawValue, this.model),
        attributes: attributes,
        formatter: this.formatter
      }),
          evalF = function evalF(f, d, m) {
        return _.isFunction(f) ? !!f.apply(d, [m]) : !!f;
      };

      data.select2 = data.select2 || {};

      _.defaults(data.select2, this.defaults.select2, {
        first_empty: true,
        multiple: false,
        emptyOptions: false,
        preserveSelectionOrder: false,
        isDropdownParent: false,
        showOnScroll: true
      }); // Evaluate the disabled, visible, and required option
      // disable for readonly also and later handle readonly programmatically.


      _.extend(data, {
        disabled: evalF(data.disabled, data, this.model),
        readonly: evalF(data.readonly, data, this.model),
        visible: evalF(data.visible, data, this.model),
        required: evalF(data.required, data, this.model)
      }); // Evaluation the options


      if (_.isFunction(data.options)) {
        try {
          data.options = data.options(this);
        } catch (e) {
          // Do nothing
          data.options = [];
          this.model.trigger('pgadmin-view:transform:error', this.model, this.field, e);
        }
      }

      data.cId = data.cId || _.uniqueId('pgC_'); // Clean up first

      this.$el.removeClass(Backform.hiddenClassName);
      if (!data.visible) this.$el.addClass(Backform.hiddenClassName);
      this.$el.html(this.template(data)).addClass(field.name);

      var select2Opts = _.extend({
        disabled: data.disabled || data.readonly
      }, field.select2, {
        options: this.field.get('options') || this.defaults.options
      }); // Dropdown body can be render at user given location
      // If isDropdownParent flag is set to true then, By default we will
      // display it on the control itself.


      if (data.select2.isDropdownParent) {
        select2Opts.dropdownParent = data.select2.dropdownParent || this.$el;
      } // If disabled then no need to show placeholder


      if (data.disabled || data.readonly) {
        select2Opts['placeholder'] = '';
      }
      /*
       * Add empty option as Select2 requires any empty '<option><option>' for
       * some of its functionality to work and initialize select2 control.
       */


      if (data.select2.tags && data.select2.emptyOptions) {
        select2Opts.data = data.rawValue;
      }
      /* Configure show on scroll if required */


      select2Opts = configure_show_on_scroll["default"](select2Opts);
      this.$sel = this.$el.find('select').select2(select2Opts); // Add or remove tags from select2 control

      if (data.select2.tags && data.select2.emptyOptions) {
        this.$sel.val(data.rawValue);
        this.$sel.trigger('change.select2');
        this.$sel.on('select2:unselect', function (evt) {
          $(this).find('option[value="' + evt.params.data.text.replace('\'', '\\\'').replace('"', '\\"') + '"]').remove();
          $(this).trigger('change.select2');

          if ($(this).val() == null) {
            $(this).empty();
          }
        });
      } // Select the highlighted item on Tab press.


      if (this.$sel) {
        this.$sel.data('select2').on('keypress', function (ev) {
          var self = this; // keycode 9 is for TAB key

          if (ev.which === 9 && self.isOpen()) {
            ev.preventDefault();
            self.trigger('results:select', {});
          }
        });
      }
      /* Select2 does not have option for readonly
       * If readonly, then let it focus.
       */


      if (data.readonly && !data.disabled) {
        setTimeout(function () {
          _this2.$el.find('.select2-selection').attr('tabindex', 0);
        }, 500);
      }

      this.updateInvalid();
      return this;
    },
    getValueFromDOM: function getValueFromDOM() {
      var select2Opts = _.extend({}, this.field.get('select2') || this.defaults.select2),
          val = this.formatter.toRaw(this.$sel.val(), this.model, select2Opts);

      if (select2Opts.multiple && val == null) {
        return [];
      }

      return val;
    }
  });
  Backform.FieldsetControl = Backform.Fieldset.extend({
    initialize: function initialize(opts) {
      Backform.Control.prototype.initialize.apply(this, arguments);
      Backform.Dialog.prototype.initialize.apply(this, [{
        schema: opts.field.get('schema')
      }]);
      this.dialog = opts.dialog;
      this.tabIndex = opts.tabIndex;
      this.contentClass = opts.field.get('contentClass') ? opts.field.get('contentClass') : ''; // Listen to the dependent fields in the model for any change

      var deps = this.field.get('deps');
      var self = this;

      if (deps && _.isArray(deps)) {
        _.each(deps, function (d) {
          var attrArr = d.split('.'),
              name = attrArr.shift();
          self.listenTo(self.model, 'change:' + name, self.render);
        });
      }
    },
    // Render using Backform.Fieldset (only if this control is visible)
    orig_render: Backform.Fieldset.prototype.render,
    render: function render() {
      var field = _.defaults(this.field.toJSON(), this.defaults),
          evalF = function evalF(f, d, m) {
        return _.isFunction(f) ? !!f.apply(d, [m]) : !!f;
      };

      if (!field.version_compatible || !evalF(field.visible, field, this.model)) {
        this.cleanup();
        this.$el.empty();
      } else {
        this.orig_render.apply(this, arguments);
      }

      return this;
    },
    formatter: function formatter() {},
    cleanup: function cleanup() {
      Backform.Fieldset.prototype.cleanup.apply(this);
    },
    remove: function remove() {
      Backform.Control.prototype.remove.apply(this, arguments);
      Backform.Dialog.prototype.remove.apply(this, arguments);
    },
    className: function className() {
      return 'set-group';
    },
    tabPanelClassName: function tabPanelClassName() {
      return Backform.tabClassName;
    },
    fieldsetClass: 'inline-fieldset',
    legendClass: '',
    collapse: false
  }); // Backform Tab Control (in bootstrap tabbular)
  // A collection of field models.

  Backform.TabControl = Backform.FieldsetControl.extend({
    tagName: 'div',
    className: 'inline-tab-panel',
    tabPanelClassName: 'inline-tab-panel',
    tabPanelExtraClasses: '',
    initialize: function initialize(opts) {
      Backform.FieldsetControl.prototype.initialize.apply(this, arguments);
      this.tabIndex = (opts.tabIndex || parseInt(Math.random() * 1000)) + 1;

      if (opts.field.get('tabPanelExtraClasses')) {
        this.tabPanelExtraClasses = opts.field.get('tabPanelExtraClasses');
      }

      this.tabPanelClassName = this.tabPanelClassName + ' ' + this.tabPanelExtraClasses;
    },
    // Render using Backform.Dialog (tabular UI) (only if this control is
    // visible).
    orig_render: Backform.Dialog.prototype.render,
    template: Backform.Dialog.prototype.template
  }); // Backform Tab Control (in bootstrap tabbular)
  // A collection of field models.

  Backform.PlainFieldsetControl = Backform.FieldsetControl.extend({
    initialize: function initialize() {
      Backform.FieldsetControl.prototype.initialize.apply(this, arguments);
    },
    template: {
      'header': _.template(['<fieldset class="<%=fieldsetClass%>" <%=disabled ? "disabled" : ""%>>', ' <% if (legend != false) { %>', '  <div><legend class="<%=legendClass%>" <%=collapse ? "data-toggle=\'collapse\'" : ""%> data-target="#<%=cId%>"><%=collapse ? "<span class=\'caret\'></span>" : "" %></legend></div>', ' <% } %>', '</fieldset>'].join('\n')),
      'content': _.template('  <div id="<%= cId %>" class="<%=contentClass%>"></div>')
    },
    fieldsetClass: 'inline-fieldset-without-border',
    legend: false
  });
  /*
   * Control For Code Mirror SQL text area.
   */

  Backform.SqlFieldControl = Backform.TextareaControl.extend({
    defaults: {
      label: '',
      extraClasses: [],
      // Add default control height
      helpMessage: null,
      maxlength: 4096,
      rows: undefined
    },
    // Customize template to add new styles
    template: _.template(['<label class="<%=Backform.controlLabelClassName%>" for="<%=cId%>"><%=label%></label>', '<div class="<%=Backform.controlsClassName%> sql_field_layout <%=extraClasses.join(\' \')%>">', '  <textarea id="<%=cId%>"', '    class="<%=Backform.controlClassName%> " name="<%=name%>" aria-label="<%=name%>"', '    maxlength="<%=maxlength%>" placeholder="<%-placeholder%>" <%=disabled ? "disabled" : ""%> <%=readonly ? "readonly aria-readonly=true" : ""%>', '    rows=<%=rows%>', '    <%=required ? "required" : ""%>><%-value%></textarea>', '  <% if (helpMessage && helpMessage.length) { %>', '    <span class="<%=Backform.helpMessageClassName%>"><%=helpMessage%></span>', '  <% } %>', '</div>'].join('\n')),

    /*
     * Initialize the SQL Field control properly
     */
    initialize: function initialize() {
      Backform.TextareaControl.prototype.initialize.apply(this, arguments);
      this.sqlCtrl = null;

      _.bindAll(this, 'onFocus', 'onBlur', 'refreshTextArea');
    },
    getValueFromDOM: function getValueFromDOM() {
      return this.sqlCtrl.getValue();
    },
    reflectPreferences: function reflectPreferences() {
      var self = this;
      /* self.sqlCtrl is null when Definition tab is not active */

      if (self.sqlCtrl) {
        /* This control is used by filter dialog in query editor, so taking preferences from window
         * SQL Editor can be in different tab
         */
        var browser = pgWindow["default"].pgAdmin.Browser;
        var sqlEditPreferences = browser.get_preferences_for_module('sqleditor');
        $(self.sqlCtrl.getWrapperElement()).css('font-size', SqlEditorUtils.calcFontSize(sqlEditPreferences.sql_font_size));
        self.sqlCtrl.setOption('indentWithTabs', !sqlEditPreferences.use_spaces);
        self.sqlCtrl.setOption('indentUnit', sqlEditPreferences.tab_size);
        self.sqlCtrl.setOption('tabSize', sqlEditPreferences.tab_size);
        self.sqlCtrl.setOption('lineWrapping', sqlEditPreferences.wrap_code);
        self.sqlCtrl.setOption('autoCloseBrackets', sqlEditPreferences.insert_pair_brackets);
        self.sqlCtrl.setOption('matchBrackets', sqlEditPreferences.brace_matching);
        setTimeout(function () {
          if (self.sqlCtrl) self.sqlCtrl.refresh();
        }, 500);
      }
    },
    render: function render() {
      // Clean up the existing sql control
      if (this.sqlCtrl) {
        this.model.off('pg-property-tab-changed', this.refreshTextArea, this);
        this.sqlCtrl.off('focus', this.onFocus);
        this.sqlCtrl.off('blur', this.onBlur);
        this.sqlCtrl.toTextArea();
        delete this.sqlCtrl;
        this.sqlCtrl = null;
        this.$el.empty();
      } // Use the Backform TextareaControl's render function


      Backform.TextareaControl.prototype.render.apply(this, arguments);

      var field = _.defaults(this.field.toJSON(), this.defaults),
          attributes = this.model.toJSON(),
          attrArr = field.name.split('.'),
          name = attrArr.shift(),
          path = attrArr.join('.'),
          rawValue = this.keyPathAccessor(attributes[name], path),
          data = _.extend(field, {
        rawValue: rawValue,
        value: this.formatter.fromRaw(rawValue, this.model),
        attributes: attributes,
        formatter: this.formatter
      }),
          evalF = function evalF(f, d, m) {
        return _.isFunction(f) ? !!f.apply(d, [m]) : !!f;
      };

      data.cId = data.cId || _.uniqueId('pgC_'); // Evaluate the disabled, visible option

      var isDisabled = evalF(data.disabled, data, this.model),
          isVisible = evalF(data.visible, data, this.model),
          isReadonly = evalF(data.readonly, data, this.model),
          self = this;
      self.sqlCtrl = CodeMirror.fromTextArea(self.$el.find('textarea')[0], {
        lineNumbers: true,
        mode: 'text/x-pgsql',
        extraKeys: pgAdmin.Browser.editor_shortcut_keys,
        screenReaderLabel: data.label
      });
      self.reflectPreferences();
      /* Check for sql editor preference changes */

      pgBrowser.onPreferencesChange('sqleditor', function () {
        self.reflectPreferences();
      }); // Disable editor

      if (isDisabled || isReadonly) {
        // set read only mode to true instead of 'nocursor', and hide cursor using a class so that copying is enabled
        self.sqlCtrl.setOption('readOnly', true);
        self.sqlCtrl.setOption('extraKeys', {
          Tab: false,
          'Shift-Tab': false
        });
        var cm = self.sqlCtrl.getWrapperElement();

        if (cm) {
          cm.className += ' cm_disabled hide-cursor-workaround';
        }
      }

      if (!isVisible) self.$el.addClass(Backform.hiddenClassName); // There is an issue with the Code Mirror SQL.
      //
      // It does not initialize the code mirror object completely when the
      // referenced textarea is hidden (not visible), hence - we need to
      // refresh the code mirror object on 'pg-property-tab-changed' event to
      // make it work properly.

      self.model.on('pg-property-tab-changed', this.refreshTextArea, this);
      this.sqlCtrl.setOption('dragDrop', true);
      this.sqlCtrl.on('focus', this.onFocus);
      this.sqlCtrl.on('blur', this.onBlur);
      this.sqlCtrl.on('drop', this.onDrop); // Refresh SQL Field to refresh the control lazily after it renders

      setTimeout(function () {
        self.refreshTextArea.apply(self);
      }, 0);
      return self;
    },
    onDrop: function onDrop(editor, e) {
      var dropDetails = null;

      try {
        dropDetails = JSON.parse(e.dataTransfer.getData('text'));
        /* Stop firefox from redirecting */

        if (e.preventDefault) {
          e.preventDefault();
        }

        if (e.stopPropagation) {
          e.stopPropagation();
        }
      } catch (error) {
        /* if parsing fails, it must be the drag internal of codemirror text */
        return;
      }

      var cursor = editor.coordsChar({
        left: e.x,
        top: e.y
      });
      editor.replaceRange(dropDetails.text, cursor);
      editor.focus();
      editor.setSelection(_objectSpread(_objectSpread({}, cursor), {}, {
        ch: cursor.ch + dropDetails.cur.from
      }), _objectSpread(_objectSpread({}, cursor), {}, {
        ch: cursor.ch + dropDetails.cur.to
      }));
    },
    onFocus: function onFocus() {
      var $ctrl = this.$el.find('.pgadmin-controls').first();
      if (!$ctrl.hasClass('focused')) $ctrl.addClass('focused');
    },
    onBlur: function onBlur() {
      this.$el.find('.pgadmin-controls').first().removeClass('focused');
    },
    refreshTextArea: function refreshTextArea() {
      if (this.sqlCtrl) {
        this.sqlCtrl.refresh();
      }
    },
    remove: function remove() {
      // Clean up the sql control
      if (this.sqlCtrl) {
        this.sqlCtrl.off('focus', this.onFocus);
        this.sqlCtrl.off('blur', this.onBlur);
        delete this.sqlCtrl;
        this.sqlCtrl = null;
        this.$el.empty();
      }

      this.model.off('pg-property-tab-changed', this.refreshTextArea, this);
      Backform.TextareaControl.prototype.remove.apply(this, arguments);
    }
  });
  /*
   * Control For Code Mirror with FULL text area.
   */

  Backform.SqlCodeControl = Backform.SqlFieldControl.extend({
    // Customize template to add new styles
    template: _.template(['<label class="sr-only" for="<%=cId%>"><%=(label==""?"Code":label)%></label>', '<div class="pgadmin-controls pg-el-12 <%=extraClasses.join(\' \')%>">', '  <textarea id="<%=cId%>" ', '    class="<%=Backform.controlClassName%> " name="<%=name%>" aria-label="<%=name%>"', '    maxlength="<%=maxlength%>" placeholder="<%-placeholder%>" <%=disabled ? "disabled" : ""%> <%=readonly ? "readonly aria-readonly=true" : ""%> ', '    rows=<%=rows%>', '    <%=required ? "required" : ""%>><%-value%></textarea>', '  <% if (helpMessage && helpMessage.length) { %>', '    <span class="<%=Backform.helpMessageClassName%>"><%=helpMessage%></span>', '  <% } %>', '</div>'].join('\n'))
  }); // We will use this control just as a annotate in Backform

  Backform.NoteControl = Backform.Control.extend({
    defaults: {
      label: gettext('Note'),
      text: '',
      extraClasses: ['pg-el-12', 'd-flex'],
      noteClass: 'backform-note',
      faIcon: 'fa-file-alt',
      faExtraClass: 'fa-rotate-180 fa-flip-vertical',
      iconWidthClass: 'col-0 pr-2',
      textWidthClass: 'col-sm'
    },
    template: _.template(['<div class="<%=noteClass%> <%=extraClasses.join(\' \')%>">', '  <div class="icon <%=iconWidthClass%>">', '    <i class="fa <%=faIcon%> <%=faExtraClass%>" aria-hidden="true"></i>', '  </div>', '  <div class="<%=textWidthClass%>">', '    <span><%=text%></span>', '  </div>', '</div>'].join('\n'))
  });
  /*
   * Input File Control: This control is used with Storage Manager Dialog,
   * It allows user to perform following operations:
   * - Select File
   * - Select Folder
   * - Create File
   * - Opening Storage Manager Dialog itself.
   */

  Backform.FileControl = Backform.InputControl.extend({
    defaults: {
      type: 'text',
      label: '',
      min: undefined,
      max: undefined,
      maxlength: 255,
      extraClasses: [],
      dialog_title: '',
      btn_primary: '',
      helpMessage: null,
      dialog_type: 'select_file'
    },
    initialize: function initialize() {
      Backform.InputControl.prototype.initialize.apply(this, arguments);
    },
    template: _.template(['<label class="<%=Backform.controlLabelClassName%>" for="<%=cId%>"><%=label%></label>', '<div class="<%=Backform.controlsClassName%>">', '<div class="input-group">', '<input type="<%=type%>" id="<%=cId%>" class="form-control <%=extraClasses.join(\' \')%>" name="<%=name%>" min="<%=min%>" max="<%=max%>"maxlength="<%=maxlength%>" value="<%-value%>" placeholder="<%-placeholder%>" <%=disabled ? "disabled" : ""%> <%=readonly ? "readonly aria-readonly=true" : ""%> <%=required ? "required" : ""%> />', '<div class="input-group-append">', '<button class="btn btn-primary-icon fa fa-ellipsis-h select_item" <%=disabled ? "disabled" : ""%> <%=readonly ? "disabled" : ""%> aria-hidden="true" aria-label="' + gettext('Select file') + '" title="' + gettext('Select file') + '"></button>', '</div>', '</div>', '<% if (helpMessage && helpMessage.length) { %>', '<span class="<%=Backform.helpMessageClassName%>"><%=helpMessage%></span>', '<% } %>', '</div>'].join('\n')),
    events: function events() {
      // Inherit all default events of InputControl
      return _.extend({}, Backform.InputControl.prototype.events, {
        'click .select_item': 'onSelect'
      });
    },
    onSelect: function onSelect() {
      var dialog_type = this.field.get('dialog_type'),
          supp_types = this.field.get('supp_types'),
          btn_primary = this.field.get('btn_primary'),
          dialog_title = this.field.get('dialog_title'),
          params = {
        supported_types: supp_types,
        dialog_type: dialog_type,
        dialog_title: dialog_title,
        btn_primary: btn_primary
      };
      pgAdmin.FileManager.init();
      pgAdmin.FileManager.show_dialog(params); // Listen click events of Storage Manager dialog buttons

      this.listen_file_dlg_events();
    },
    storage_dlg_hander: function storage_dlg_hander(value) {
      var attrArr = this.field.get('name').split('.'),
          name = attrArr.shift();
      this.remove_file_dlg_event_listeners(); // Set selected value into the model

      this.model.set(name, decodeURI(value));
      this.$el.find('input[type=text]').focus();
    },
    storage_close_dlg_hander: function storage_close_dlg_hander() {
      this.remove_file_dlg_event_listeners();
    },
    listen_file_dlg_events: function listen_file_dlg_events() {
      pgAdmin.Browser.Events.on('pgadmin-storage:finish_btn:' + this.field.get('dialog_type'), this.storage_dlg_hander, this);
      pgAdmin.Browser.Events.on('pgadmin-storage:cancel_btn:' + this.field.get('dialog_type'), this.storage_close_dlg_hander, this);
    },
    remove_file_dlg_event_listeners: function remove_file_dlg_event_listeners() {
      pgAdmin.Browser.Events.off('pgadmin-storage:finish_btn:' + this.field.get('dialog_type'), this.storage_dlg_hander, this);
      pgAdmin.Browser.Events.off('pgadmin-storage:cancel_btn:' + this.field.get('dialog_type'), this.storage_close_dlg_hander, this);
    },
    clearInvalid: function clearInvalid() {
      Backform.InputControl.prototype.clearInvalid.apply(this, arguments);
      this.$el.removeClass('pgadmin-file-has-error');
      return this;
    },
    updateInvalid: function updateInvalid() {
      Backform.InputControl.prototype.updateInvalid.apply(this, arguments); // Introduce a new class to fix the error icon placement on the control

      this.$el.addClass('pgadmin-file-has-error');
    },
    disable_button: function disable_button() {
      this.$el.find('button.select_item').attr('disabled', 'disabled');
    },
    enable_button: function enable_button() {
      this.$el.find('button.select_item').removeAttr('disabled');
    }
  });
  Backform.DatetimepickerControl = Backform.InputControl.extend({
    defaults: {
      type: 'text',
      label: '',
      options: {
        format: 'YYYY-MM-DD HH:mm:ss Z',
        icons: {
          time: 'fa fa-clock',
          data: 'fa fa-calendar-alt',
          today: 'fa fa-calendar-check',
          clear: 'fa fa-trash-alt'
        },
        buttons: {
          showToday: true
        },
        toolbarPlacement: 'top',
        widgetPositioning: {
          horizontal: 'auto',
          vertical: 'bottom'
        },
        keepOpen: false
      },
      placeholder: 'YYYY-MM-DD HH:mm:ss Z',
      extraClasses: [],
      helpMessage: null,
      setMinDate: true
    },
    events: {
      'blur input': 'onChange',
      'change input': 'onChange',
      'changeDate input': 'onChange',
      'focus input': 'clearInvalid',
      'focusout input': 'closePicker',
      'change.datetimepicker': 'onChange',
      'click .input-group': 'togglePicker',
      'keydown .datetimepicker-input': 'keyboardEvent'
    },
    togglePicker: function togglePicker() {
      if (this.has_datepicker) {
        this.$el.find('input').datetimepicker('toggle');
      }
    },
    closePicker: function closePicker() {
      if (this.has_datepicker) {
        this.$el.find('input').datetimepicker('hide');
      }
    },
    template: _.template(['<label for="<%=cId%>" class="<%=Backform.controlLabelClassName%>"><%=label%></label>', '<div class="input-group  <%=Backform.controlsClassName%>">', ' <input id="<%=cId%>" type="text" class="<%=Backform.controlClassName%> datetimepicker-input <%=extraClasses.join(\' \')%>" name="<%=name%>" value="<%-value%>" placeholder="<%-placeholder%>" <%=disabled ? "disabled" : ""%> <%=readonly ? "readonly aria-readonly=true" : ""%> <%=required ? "required" : ""%> data-toggle="datetimepicker"/>', ' <div class="input-group-append">', '   <span class="input-group-text fa fa-calendar-alt"></span>', ' </div>', '</div>', '<% if (helpMessage && helpMessage.length) { %>', '<div class="<%=Backform.helpBlockControlClass%>">', ' <span class="<%=Backform.helpMessageClassName%>"><%=helpMessage%></span>', '</div>', '<% } %>'].join('\n')),
    keyboardEvent: function keyboardEvent(event) {
      var stopBubble = false;

      if (!event.altKey && event.keyCode == 38) {
        this.up();
      }

      if (!event.altKey && event.keyCode == 40) {
        this.down();
      }

      if (event.keyCode == 37) {
        this.left();
      }

      if (event.keyCode == 39) {
        this.right();
      }

      if (event.keyCode == 27) {
        this.$el.find('input').datetimepicker('hide');
        stopBubble = true;
      }

      if (event.keyCode == 13) {
        if (this.$el.find('.datepicker').is(':visible') || this.$el.find('.timepicker').is(':visible')) {
          this.$el.find('input').datetimepicker('hide');
        } else {
          this.$el.find('input').datetimepicker('show');
        }
      }

      if (event.altKey && event.keyCode == 84) {
        this.timePicker();
      }

      if (event.altKey && event.keyCode == 38) {
        this.controlUp();
      }

      if (event.altKey && event.keyCode == 40) {
        this.controlDown();
      }

      if (stopBubble) {
        event.stopImmediatePropagation();
      }
    },
    down: function down() {
      var $el = this.$el.find('.datetimepicker-input');
      var currdate = $el.data('datetimepicker').date().clone();

      if (this.$el.find('.datepicker').is(':visible')) {
        $el.datetimepicker('date', currdate.add(7, 'd'));
      } else {
        $el.datetimepicker('date', currdate.subtract(1, 'm'));
      }
    },
    up: function up() {
      var $el = this.$el.find('.datetimepicker-input');
      var currdate = $el.data('datetimepicker').date().clone();

      if (this.$el.find('.datepicker').is(':visible')) {
        $el.datetimepicker('date', currdate.subtract(7, 'd'));
      } else {
        $el.datetimepicker('date', currdate.add(1, 'm'));
      }
    },
    left: function left() {
      var $el = this.$el.find('.datetimepicker-input');
      var currdate = $el.data('datetimepicker').date().clone();

      if (this.$el.find('.datepicker').is(':visible')) {
        $el.datetimepicker('date', currdate.subtract(1, 'd'));
      }
    },
    right: function right() {
      var $el = this.$el.find('.datetimepicker-input');
      var currdate = $el.data('datetimepicker').date().clone();

      if (this.$el.find('.datepicker').is(':visible')) {
        $el.datetimepicker('date', currdate.add(1, 'd'));
      }
    },
    timePicker: function timePicker() {
      if (this.$el.find('.timepicker').is(':visible')) {
        this.$el.find('.fa-calendar-alt').click();
      } else {
        this.$el.find('.fa-clock').click();
      }
    },
    controlUp: function controlUp() {
      this.$el.find('.fa-clock').click();
      var $el = this.$el.find('.datetimepicker-input');
      var currdate = $el.data('datetimepicker').date().clone();
      $el.datetimepicker('date', currdate.add(1, 'h'));
    },
    controlDown: function controlDown() {
      this.$el.find('.fa-clock').click();
      var $el = this.$el.find('.datetimepicker-input');
      var currdate = $el.data('datetimepicker').date().clone();
      $el.datetimepicker('date', currdate.subtract(1, 'h'));
    },
    render: function render() {
      var field = _.defaults(this.field.toJSON(), this.defaults),
          attributes = this.model.toJSON(),
          attrArr = field.name.split('.'),
          name = attrArr.shift(),
          path = attrArr.join('.'),
          rawValue = this.keyPathAccessor(attributes[name], path),
          data = _.extend(field, {
        rawValue: rawValue,
        value: this.formatter.fromRaw(rawValue, this.model),
        attributes: attributes,
        formatter: this.formatter
      }),
          evalF = function evalF(f, m) {
        return _.isFunction(f) ? !!f(m) : !!f;
      }; // disable when mode is properties.


      if (data.mode == 'properties') {
        data.disabled = true;
      } // Evaluate the disabled, visible, and required option


      _.extend(data, {
        disabled: evalF(data.disabled, this.model),
        readonly: evalF(data.readonly, this.model),
        visible: evalF(data.visible, this.model),
        required: evalF(data.required, this.model)
      });

      data.cId = data.cId || _.uniqueId('pgC_');

      if (!data.disabled && data.mode != 'properties') {
        data.placeholder = data.placeholder || this.defaults.placeholder;
      } // Clean up first


      if (this.has_datepicker) this.$el.find('input').datetimepicker('destroy');
      this.$el.empty();
      this.$el.removeClass(Backform.hiddenClassName);
      this.$el.html(this.template(data)).addClass(field.name);

      if (!data.visible) {
        this.has_datepicker = false;
        this.$el.addClass(Backform.hiddenClassName);
      } else {
        this.has_datepicker = true;
        var self = this;

        if (!_.isUndefined(data.value) && !_.isNull(data.value) && data.value.toLowerCase() === 'infinity') {
          data.value = null;
        }

        var dateSettings = {};

        if (!data.setMinDate) {
          dateSettings = {
            'date': data.value
          };
        } else {
          dateSettings = {
            'date': data.value,
            'minDate': data.value
          };
        }

        this.$el.find('input').first().datetimepicker(_.extend({
          keyBinds: {
            enter: function enter(widget) {
              var picker = this;

              if (widget) {
                setTimeout(function () {
                  picker.toggle();
                  self.$el.find('input').first().trigger('blur');
                }, 10);
              } else {
                setTimeout(function () {
                  picker.toggle();
                }, 10);
              }
            },
            tab: function tab(widget) {
              if (!widget) {
                // blur the input
                setTimeout(function () {
                  self.$el.find('input').first().trigger('blur');
                }, 10);
              }
            },
            escape: function escape(widget) {
              if (widget) {
                var picker = this;
                setTimeout(function () {
                  picker.toggle();
                  self.$el.find('input').first().trigger('blur');
                }, 10);
              }
            }
          }
        }, this.defaults.options, this.field.get('options'), dateSettings));
      }

      this.updateInvalid();
      return this;
    },
    clearInvalid: function clearInvalid() {
      Backform.InputControl.prototype.clearInvalid.apply(this, arguments);
      this.$el.removeClass('pgadmin-datepicker-has-error');
      return this;
    },
    updateInvalid: function updateInvalid() {
      Backform.InputControl.prototype.updateInvalid.apply(this, arguments); // Introduce a new class to fix the error icon placement on the control

      this.$el.addClass('pgadmin-datepicker-has-error');
    },
    cleanup: function cleanup() {
      if (this.has_datepicker) this.$el.find('input').datetimepicker('destroy');
      this.$el.empty();
    }
  }); // Color Picker control

  Backform.ColorControl = Backform.InputControl.extend({
    defaults: {
      label: '',
      extraClasses: [],
      helpMessage: null,
      showPalette: true,
      allowEmpty: true,
      colorFormat: 'HEX',
      defaultColor: null,
      position: 'right-middle',
      clearText: gettext('No color')
    },
    template: _.template(['<label class="<%=Backform.controlLabelClassName%>" for="<%=cId%>"><%=label%></label>', '<div class="<%=Backform.controlsClassName%>">', '  <input id="<%=cId%>" class="<%=Backform.controlClassName%> <%=extraClasses.join(\' \')%> d-none" name="<%=name%>" value="<%-value%>" <%=disabled ? "disabled" : ""%> <%=required ? "required" : ""%> />', '  <p></p>', '  <% if (helpMessage && helpMessage.length) { %>', '    <span class="<%=Backform.helpMessageClassName%>"><%=helpMessage%></span>', '  <% } %>', '</div>'].join('\n')),
    applyColor: function applyColor(name, instance, color) {
      if (!color) {
        this.model.set(name, '', {
          silent: true
        });
      } else {
        instance.applyColor(true);
        this.model.set(name, instance.getSelectedColor().toHEXA().toString(), {
          silent: true
        });
      }
    },
    render: function render() {
      var _this3 = this;

      // Clear first
      if (this.picker) {
        this.picker.destroyAndRemove();
        this.picker = null;
      }

      var field = _.defaults(this.field.toJSON(), this.defaults),
          attributes = this.model.toJSON(),
          attrArr = field.name.split('.'),
          name = attrArr.shift(),
          path = attrArr.join('.'),
          rawValue = this.keyPathAccessor(attributes[name], path),
          data = _.extend(field, {
        rawValue: rawValue,
        value: this.formatter.fromRaw(rawValue, this.model),
        attributes: attributes,
        formatter: this.formatter
      }),
          evalF = function evalF(f, d, m) {
        return _.isFunction(f) ? !!f.apply(d, [m]) : !!f;
      }; // Evaluate the disabled, visible, and required option


      _.extend(data, {
        disabled: evalF(data.disabled, data, this.model),
        visible: evalF(data.visible, data, this.model),
        required: evalF(data.required, data, this.model)
      });

      data.cId = data.cId || _.uniqueId('pgC_'); // Clean up first

      this.$el.empty();
      if (!data.visible) this.$el.addClass(Backform.hiddenClassname);
      this.$el.html(this.template(data)).addClass(field.name);
      data.colorFormat = data.colorFormat ? data.colorFormat.toUpperCase() : 'HEX';
      data.value = !data.value || data.value == '' ? data.defaultColor : data.value; // Creating default Color picker

      this.picker = new Pickr({
        el: this.$el.find('p')[0],
        theme: 'monolith',
        swatches: ['#000', '#666', '#ccc', '#fff', '#f90', '#ff0', '#0f0', '#f0f', '#f4cccc', '#fce5cd', '#d0e0e3', '#cfe2f3', '#ead1dc', '#ea9999', '#b6d7a8', '#a2c4c9', '#d5a6bd', '#e06666', '#93c47d', '#76a5af', '#c27ba0', '#f1c232', '#6aa84f', '#45818e', '#a64d79', '#bf9000', '#0c343d', '#4c1130'],
        position: data.position,
        strings: {
          clear: data.clearText
        },
        components: {
          palette: data.showPalette,
          preview: true,
          hue: data.showPalette,
          interaction: {
            clear: data.allowEmpty,
            defaultRepresentation: data.colorFormat,
            disabled: data.disabled
          }
        }
      });
      this.picker.on('init', function (instance) {
        _this3.picker.setColor(data.value, true);

        data.disabled && _this3.picker.disable();
        var lastColor = instance.getRoot().preview.lastColor;
        var clear = instance.getRoot().interaction.clear;
        /* Cycle the keyboard navigation within the color picker */

        clear.addEventListener('keydown', function (e) {
          if (e.keyCode === 9) {
            e.preventDefault();
            e.stopPropagation();
            lastColor.focus();
          }
        });
        lastColor.addEventListener('keydown', function (e) {
          if (e.keyCode === 9 && e.shiftKey) {
            e.preventDefault();
            e.stopPropagation();
            clear.focus();
          }
        });
      }).on('clear', function (instance) {
        _this3.applyColor(name, instance, null);
      }).on('change', function (color, source, instance) {
        _this3.applyColor(name, instance, color);
      }).on('show', function (color, instance) {
        var palette = instance.getRoot().palette.palette;
        palette.focus();
      }).on('hide', function (instance) {
        var button = instance.getRoot().button;
        button.focus();
      });
      this.updateInvalid();
      return this;
    }
  });

  var KeyCodeControlFormatter = Backform.KeyCodeControlFormatter = function () {};

  _.extend(KeyCodeControlFormatter.prototype, {
    fromRaw: function fromRaw(rawData) {
      return rawData['char'];
    },
    // we don't need toRaw
    toRaw: undefined
  });

  Backform.KeyCodeControl = Backform.InputControl.extend({
    defaults: _.defaults({
      escapeKeyCodes: [16, 17, 18, 27] // Shift, Ctrl, Alt/Option, Escape

    }, Backform.InputControl.prototype.defaults),
    events: {
      'keydown input': 'onkeyDown',
      'keyup input': 'preventEvent',
      'focus select': 'clearInvalid'
    },
    formatter: KeyCodeControlFormatter,
    preventEvent: function preventEvent(e) {
      var key_code = e.which || e.keyCode,
          field = _.defaults(this.field.toJSON(), this.defaults);

      if (field.escapeKeyCodes.indexOf(key_code) != -1) {
        return;
      }

      e.preventDefault();
      e.stopImmediatePropagation();
      e.stopPropagation();
    },
    template: _.template(['<label class="<%=Backform.controlLabelClassName%> keyboard-shortcut-label"><%=label%></label>', '<div class="<%=Backform.controlsClassName%>">', '  <input aria-label="<%=name%>" type="<%=type%>" class="<%=Backform.controlClassName%> <%=extraClasses.join(\' \')%>" name="<%=name%>" oncopy="return false; oncut="return false; onpaste="return false;" maxlength="<%=maxlength%>" value="<%-value%>" placeholder="<%-placeholder%>" <%=disabled ? "disabled" : ""%> <%=required ? "required" : ""%> />', '  <% if (helpMessage && helpMessage.length) { %>', '    <span class="<%=Backform.helpMessageClassName%>"><%=helpMessage%></span>', '  <% } %>', '</div>'].join('\n')),
    onkeyDown: function onkeyDown(e) {
      var self = this,
          model = this.model,
          attrArr = this.field.get('name').split('.'),
          name = attrArr.shift(),
          changes = {},
          key_code = e.which || e.keyCode,
          key,
          field = _.defaults(this.field.toJSON(), this.defaults);

      if (field.escapeKeyCodes.indexOf(key_code) != -1) {
        return;
      }

      if (this.model.errorModel instanceof Backbone.Model) {
        this.model.errorModel.unset(name);
      }

      key = gettext(e.key);

      if (key_code == 32) {
        key = gettext('Space');
      }

      changes = {
        'key_code': e.which || e.keyCode,
        'char': key
      };
      this.stopListening(this.model, 'change:' + name, this.render);
      model.set(name, changes);
      this.listenTo(this.model, 'change:' + name, this.render);
      setTimeout(function () {
        self.$el.find('input').val(key);
      });
      e.preventDefault();
    },
    keyPathAccessor: function keyPathAccessor(obj, path) {
      var res = obj;
      path = path.split('.');

      for (var i = 0; i < path.length; i++) {
        if (_.isNull(res)) return null;
        if (_.isEmpty(path[i])) continue;
        if (!_.isUndefined(res[path[i]])) res = res[path[i]];
      }

      return res;
    }
  });
  Backform.KeyboardShortcutControl = Backform.Control.extend({
    initialize: function initialize() {
      Backform.Control.prototype.initialize.apply(this, arguments);
      var fields = this.field.get('fields');

      if (!fields) {
        throw new ReferenceError('"fields" not found in keyboard shortcut');
      }

      this.innerModel = new Backbone.Model();
      this.controls = [];
    },
    cleanup: function cleanup() {
      this.stopListening(this.innerModel, 'change', this.onInnerModelChange);

      _.each(this.controls, function (c) {
        c.remove();
      });

      this.controls.length = 0;
    },
    template: _.template(['<label class="<%=Backform.controlLabelClassName%>"><%=label%></label>', '<div class="<%=Backform.controlsClassName%> d-flex flex-row">', '</div>'].join('\n')),
    onInnerModelChange: function onInnerModelChange() {
      var name = this.field.get('name'),
          val = $.extend(true, {}, this.model.get(name));
      this.stopListening(this.model, 'change:' + name, this.render);
      this.model.set(name, $.extend(true, val, this.innerModel.toJSON()));
      this.listenTo(this.model, 'change:' + name, this.render);
    },
    render: function render() {
      this.cleanup();
      this.$el.empty();

      var self = this,
          initial_value = {},
          field = _.defaults(this.field.toJSON(), this.defaults),
          value = self.model.get(field['name']),
          innerFields = field['fields'];

      this.$el.html(self.template(field)).addClass(field.name);
      var $container = $(self.$el.find('.pgadmin-controls'));

      _.each(innerFields, function (inField) {
        initial_value[inField['name']] = value[inField['name']];
      });

      self.innerModel.set(initial_value);
      self.listenTo(self.innerModel, 'change', self.onInnerModelChange);

      _.each(innerFields, function (fld) {
        var f = new Backform.Field(_.extend({}, {
          id: fld['name'],
          name: fld['name'],
          control: fld['type'] == 'checkbox' ? 'checkboxWithBox' : fld['type'],
          label: fld['label']
        })),
            cntr = new (f.get('control'))({
          field: f,
          model: self.innerModel
        });
        cntr.render();

        if (fld['type'] == 'checkbox') {
          // Remove control label for keyboard shortcuts to
          // align it properly.
          var label = cntr.$el.find('label.control-label').text().trim();

          if (label.length <= 0) {
            cntr.$el.find('label.control-label').remove();
          }

          if (fld['name'] == 'alt') {
            $container.append($('<div class="pg-el-sm-3 pg-el-12"></div>').append(cntr.$el));
          } else {
            $container.append($('<div class="pg-el-sm-2 pg-el-12"></div>').append(cntr.$el));
          }
        } else {
          $container.append($('<div class="pg-el-sm-5 pg-el-12"></div>').append(cntr.$el));
        } // We will keep track of all the controls rendered at the
        // moment.


        self.controls.push(cntr);
      });

      return self;
    },
    remove: function remove() {
      /* First do the clean up */
      this.cleanup();
      Backform.Control.prototype.remove.apply(this, arguments);
    }
  });
  Backform.CheckboxWithBoxControl = Backform.CheckboxControl.extend({
    events: _.extend({}, Backform.CheckboxControl.prototype.events, {
      'click button': 'onButtonClick'
    }),
    template: _.template(['<label class="<%=Backform.controlLabelClassName%>"><%=controlLabel%></label>', '<div class="<%=Backform.controlContainerClassName%>">', '  <button class="btn btn-secondary btn-checkbox">', '  <div class="custom-control custom-checkbox <%=extraClasses.join(\' \')%>">', '    <input tabindex="-1" type="checkbox" class="custom-control-input" id="<%=cId%>" name="<%=name%>" <%=value ? "checked=\'checked\'" : ""%> <%=disabled ? "disabled" : ""%> <%=required ? "required" : ""%> />', '    <label class="custom-control-label" for="<%=cId%>" aria-label="<%=cId%>">', '      <%=label%>', '    </label>', '  </div>', '  </button>', '</div>'].join('\n')),
    onButtonClick: function onButtonClick(e) {
      if (e.target.nodeName !== 'BUTTON') return;
      this.$el.find('input[type=checkbox]').trigger('click');
    }
  });
  Backform.ThresholdControl = Backform.Control.extend({
    template: _.template(['<label class="<%=Backform.controlLabelClassName%>"><%=label%></label>', '<div class="<%=Backform.controlContainerClassName%>">', '  <span class="control-label pg-el-sm-2 pg-el-12"><%=warning_label%></span>', '  <input type="text" id="warning_threshold" class="pg-el-sm-2" value="<%=warning_value%>" />', '  <span class="control-label pg-el-sm-1 pg-el-12"><%=alert_label%></span>', '  <input type="text" id="alert_threshold" class="pg-el-sm-2" value="<%=alert_value%>" />', '  <span class="control-label pg-el-sm-3 pg-el-12"><%=unit%></span>', '  <% if (helpMessage && helpMessage.length) { %>', '    <span class="<%=Backform.helpMessageClassName%>"><%=helpMessage%></span>', '  <% } %>', '</div>'].join('\n')),
    events: {
      'change input#warning_threshold': 'onChange',
      'change input#alert_threshold': 'onChange'
    },
    initialize: function initialize() {
      Backform.Control.prototype.initialize.apply(this, arguments);
    },
    render: function render() {
      var field = _.defaults(this.field.toJSON(), this.defaults),
          attributes = this.model.toJSON(),
          threshold_val = [];

      if (!_.isUndefined(this.model.get('value')) && !_.isNull(this.model.get('value'))) {
        threshold_val = this.model.get('value').split('|');
      }

      var data = _.extend(field, {
        attributes: attributes,
        'warning_value': threshold_val.length > 0 ? threshold_val[0] : '',
        'alert_value': threshold_val.length > 1 ? threshold_val[1] : ''
      });

      this.$el.html(this.template(data));
      return this;
    },
    onChange: function onChange() {
      // Get the value from raw jquery and concat it using |
      // and set the value
      var warning_threshold = $('input#warning_threshold').val(),
          alert_threshold = $('input#alert_threshold').val();
      var threshold_val = warning_threshold + '|' + alert_threshold;
      this.model.set(this.field.get('name'), threshold_val, {
        silent: false
      });
    }
  });
  return Backform;
}).apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__),
		__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));

/***/ }),

/***/ 71158:
/***/ ((module, exports, __webpack_require__) => {

"use strict";
/* provided dependency */ var __webpack_provided_window_dot_jQuery = __webpack_require__(19755);
var __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;

__webpack_require__(73210);

__webpack_require__(15306);

__webpack_require__(74916);

__webpack_require__(2707);

__webpack_require__(82772);

__webpack_require__(32564);

__webpack_require__(69600);

__webpack_require__(69826);

__webpack_require__(24812);

__webpack_require__(92222);

__webpack_require__(5735);

__webpack_require__(83753);

__webpack_require__(41539);

__webpack_require__(91058);

__webpack_require__(54678);

__webpack_require__(23123);

__webpack_require__(56977);

__webpack_require__(21249);

__webpack_require__(66992);

__webpack_require__(33948);

__webpack_require__(68309);

__webpack_require__(64765);

var _Notifier = _interopRequireDefault(__webpack_require__(55958));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/////////////////////////////////////////////////////////////
//
// pgAdmin 4 - PostgreSQL Tools
//
// Copyright (C) 2013 - 2022, The pgAdmin Development Team
// This software is released under the PostgreSQL Licence
//
//////////////////////////////////////////////////////////////
!(__WEBPACK_AMD_DEFINE_ARRAY__ = [__webpack_require__(91669), __webpack_require__(81311), __webpack_require__(19755), __webpack_require__(72316), __webpack_require__(95283), __webpack_require__(83879), __webpack_require__(58307), __webpack_require__(30381), __webpack_require__(44431), __webpack_require__(4631), __webpack_require__(44092), __webpack_require__(72945), __webpack_require__(75471), __webpack_require__(1950), __webpack_require__(28008), __webpack_require__(75084), __webpack_require__(63790), __webpack_require__(56796)], __WEBPACK_AMD_DEFINE_RESULT__ = (function (gettext, _, $, Backbone, Backform, Backgrid, Alertify, moment, BigNumber, CodeMirror, commonUtils, keyboardShortcuts, configure_show_on_scroll, pgWindow, url_for) {
  /*
   * Add mechanism in backgrid to render different types of cells in
   * same column;
   */
  var pgAdmin = window.pgAdmin = window.pgAdmin || {},
      pgBrowser = pgAdmin.Browser; // Add new property cellFunction in Backgrid.Column.

  _.extend(Backgrid.Column.prototype.defaults, {
    cellFunction: undefined
  }); // Add tooltip to cell if cell content is larger than
  // cell width


  _.extend(Backgrid.Cell.prototype.events, {
    'mouseover': function mouseover() {
      var $el = $(this.el);

      if ($el.text().length > 0 && !$el.attr('title') && $el.innerWidth() + 1 < $el[0].scrollWidth) {
        $el.attr('title', $.trim($el.text()));
      }
    }
  }); // bind shortcut in cell edit mode


  _.extend(Backgrid.InputCellEditor.prototype.events, {
    'keydown': function keydown(e) {
      var preferences = pgWindow["default"].pgAdmin.Browser.get_preferences_for_module('browser');

      if (preferences && keyboardShortcuts.validateShortcutKeys(preferences.add_grid_row, e)) {
        pgBrowser.keyboardNavigation.bindAddGridRow();
      } else {
        Backgrid.InputCellEditor.prototype.saveOrCancel.apply(this, arguments);
      }
    }
  });
  /* Overriding backgrid sort method.
   * As we are getting numeric, integer values as string
   * from server side, but on client side javascript truncates
   * large numbers automatically due to which backgrid was unable
   * to sort numeric values properly in the grid.
   * To fix this issue, now we check if cell type is integer/number
   * convert it into BigNumber object and make comparison to perform sorting.
   */


  _.extend(Backgrid.Body.prototype, {
    sort: function sort(column, direction) {
      if (!_.contains(['ascending', 'descending', null], direction)) {
        throw new RangeError('direction must be one of "ascending", "descending" or `null`');
      }

      if (_.isString(column)) column = this.columns.findWhere({
        name: column
      });
      var collection = this.collection;
      var order;
      if (direction === 'ascending') order = -1;else if (direction === 'descending') order = 1;else order = null; // Get column type and pass it to comparator.

      var col_type = column.get('cell').prototype.className || 'string-cell',
          comparator = this.makeComparator(column.get('name'), order, order ? column.sortValue() : function (model) {
        return model.cid.replace('c', '') * 1;
      }, col_type);

      if (Backbone.PageableCollection && collection instanceof Backbone.PageableCollection) {
        collection.setSorting(order && column.get('name'), order, {
          sortValue: column.sortValue()
        });

        if (collection.fullCollection) {
          // If order is null, pageable will remove the comparator on both sides,
          // in this case the default insertion order comparator needs to be
          // attached to get back to the order before sorting.
          if (collection.fullCollection.comparator == null) {
            collection.fullCollection.comparator = comparator;
          }

          collection.fullCollection.sort();
          collection.trigger('backgrid:sorted', column, direction, collection);
        } else collection.fetch({
          reset: true,
          success: function success() {
            collection.trigger('backgrid:sorted', column, direction, collection);
          }
        });
      } else {
        collection.comparator = comparator;
        collection.sort();
        collection.trigger('backgrid:sorted', column, direction, collection);
      }

      column.set('direction', direction);
      return this;
    },
    makeComparator: function makeComparator(attr, order, func, type) {
      return function (left, right) {
        // extract the values from the models
        var l = func(left, attr),
            r = func(right, attr),
            t;
        if (_.isUndefined(l) || _.isUndefined(r)) return;
        var types = ['number-cell', 'integer-cell'];

        if (_.include(types, type)) {
          var _l, _r; // NaN if invalid number


          try {
            _l = new BigNumber(l);
          } catch (err) {
            _l = NaN;
          }

          try {
            _r = new BigNumber(r);
          } catch (err) {
            _r = NaN;
          } // if descending order, swap left and right


          if (order === 1) {
            t = _l;
            _l = _r;
            _r = t;
          }

          if (_l.eq(_r)) // If both are equals
            return 0;else if (_l.lt(_r)) // If left is less than right
            return -1;else return 1;
        } else {
          // if descending order, swap left and right
          if (order === 1) {
            t = l;
            l = r;
            r = t;
          } // compare as usual


          if (l === r) return 0;else if (l === null && r != null) return -1;else if (l != null && r === null) return 1;else if (l < r) return -1;
          return 1;
        }
      };
    },
    moveToNextCell: function moveToNextCell(model, column, command) {
      var i = this.collection.indexOf(model);
      var j = this.columns.indexOf(column);
      var cell, renderable, editable, m, n; // return if model being edited in a different grid

      if (j === -1) return this;
      this.rows[i].cells[j].exitEditMode();

      if (command.moveUp() || command.moveDown() || command.moveLeft() || command.moveRight() || command.save()) {
        var l = this.columns.length;
        var maxOffset = l * this.collection.length;

        if (command.moveUp() || command.moveDown()) {
          m = i + (command.moveUp() ? -1 : 1);
          var row = this.rows[m];

          if (row) {
            cell = row.cells[j];

            if (Backgrid.callByNeed(cell.column.editable(), cell.column, model)) {
              cell.enterEditMode();
              model.trigger('backgrid:next', m, j, false);
            }
          } else model.trigger('backgrid:next', m, j, true);
        } else if (command.moveLeft() || command.moveRight()) {
          var right = command.moveRight();

          for (var offset = i * l + j + (right ? 1 : -1); offset >= 0 && offset < maxOffset; right ? offset++ : offset--) {
            m = ~~(offset / l);
            n = offset - m * l;
            cell = this.rows[m].cells[n];
            renderable = Backgrid.callByNeed(cell.column.renderable(), cell.column, cell.model);
            editable = Backgrid.callByNeed(cell.column.editable(), cell.column, model);

            if (cell && cell.$el.hasClass('edit-cell') && !cell.$el.hasClass('privileges') || cell.$el.hasClass('delete-cell')) {
              model.trigger('backgrid:next', m, n, false);

              if (cell.$el.hasClass('delete-cell')) {
                setTimeout(function () {
                  $(cell.$el).trigger('focus');
                }, 50);
              }

              break;
            } else if (renderable && editable) {
              cell.enterEditMode();
              model.trigger('backgrid:next', m, n, false);
              break;
            }
          }

          if (offset == maxOffset) {
            model.trigger('backgrid:next', ~~(offset / l), offset - m * l, true);
          }
        }
      }

      return this;
    }
  });

  _.extend(Backgrid.Row.prototype, {
    makeCell: function makeCell(column) {
      return new (this.getCell(column))({
        column: column,
        model: this.model
      });
    },

    /*
     * getCell function will check and execute user given cellFunction to get
     * appropriate cell class for current cell being rendered.
     * User provided cellFunction must return valid cell class.
     * cellFunction will be called with context (this) as column and model as
     * argument.
     */
    getCell: function getCell(column) {
      var cf = column.get('cellFunction');

      if (_.isFunction(cf)) {
        var cell = cf.apply(column, [this.model]);

        try {
          return Backgrid.resolveNameToClass(cell, 'Cell');
        } catch (e) {
          if (e instanceof ReferenceError) {
            // Fallback to column cell.
            return column.get('cell');
          } else {
            throw e; // Let other exceptions bubble up
          }
        }
      } else {
        return column.get('cell');
      }
    }
  });

  var ObjectCellEditor = Backgrid.Extension.ObjectCellEditor = Backgrid.CellEditor.extend({
    modalTemplate: _.template(['<div class="subnode-dialog" tabindex="0">', '    <div class="subnode-body"></div>', '</div>'].join('\n')),
    stringTemplate: _.template(['<div class="form-group">', '  <label class="control-label col-sm-4"><%=label%></label>', '  <div class="col-sm-8">', '    <input type="text" class="form-control" name="<%=name%>" value="<%=value%>" placeholder="<%=placeholder%>" />', '  </div>', '</div>'].join('\n')),
    extendWithOptions: function extendWithOptions(options) {
      _.extend(this, options);
    },
    render: function render() {
      return this;
    },
    postRender: function postRender(model, column) {
      var columns_length = this.columns_length,
          // To render schema directly from Backgrid cell we use columns schema
      // attribute.
      schema = this.schema.length ? this.schema : this.column.get('schema');
      if (column != null && column.get('name') != this.column.get('name')) return false;
      if (!_.isArray(schema)) throw new TypeError('schema must be an array'); // Create a Backbone model from our object if it does not exist

      var $dialog = this.createDialog(columns_length); // Add the Bootstrap form

      var $form = $('<form class="form-dialog"></form>');
      $dialog.find('div.subnode-body').append($form); // Call Backform to prepare dialog

      var back_el = $dialog.find('form.form-dialog');
      this.objectView = new Backform.Dialog({
        el: back_el,
        model: this.model,
        schema: schema,
        tabPanelClassName: function tabPanelClassName() {
          return 'sub-node-form col-sm-12';
        },
        events: {
          'keydown': function keydown(event) {
            var preferences = pgWindow["default"].pgAdmin.Browser.get_preferences_for_module('browser');

            if (preferences && keyboardShortcuts.validateShortcutKeys(preferences.add_grid_row, event)) {
              pgBrowser.keyboardNavigation.bindAddGridRow();
            }
          }
        }
      });
      this.objectView.render();
      return this;
    },
    createDialog: function createDialog(noofcol) {
      noofcol = noofcol || 1;
      var $dialog = this.$dialog = $(this.modalTemplate({
        title: ''
      })),
          tr = $('<tr class="nohover editor-row">'),
          td = $('<td>', {
        "class": 'editable sortable renderable',
        style: 'height: auto',
        colspan: noofcol + 2
      }).appendTo(tr);
      this.tr = tr; // Show the Bootstrap modal dialog

      td.append($dialog.css('display', 'block'));
      this.el.parent('tr').after(tr);
      return $dialog;
    },
    save: function save() {
      // Retrieve values from the form, and store inside the object model
      this.model.trigger('backgrid:edited', this.model, this.column, new Backgrid.Command({
        keyCode: 13
      }));

      if (this.tr) {
        this.tr.remove();
      }

      return this;
    },
    remove: function remove() {
      this.objectView.remove();
      Backgrid.CellEditor.prototype.remove.apply(this, arguments);

      if (this.tr) {
        this.tr.remove();
      }

      return this;
    }
  });
  Backgrid.Extension.PGSelectCell = Backgrid.SelectCell.extend({
    // It's possible to render an option group or use a
    // function to provide option values too.
    optionValues: function optionValues() {
      var res = [],
          opts = _.result(this.column.attributes, 'options');

      _.each(opts, function (o) {
        res.push([o.label, o.value]);
      });

      return res;
    }
  });
  Backgrid.Extension.ObjectCell = Backgrid.Cell.extend({
    editorOptionDefaults: {
      schema: []
    },
    className: 'edit-cell',
    editor: ObjectCellEditor,
    initialize: function initialize(options) {
      Backgrid.Cell.prototype.initialize.apply(this, arguments); // Pass on cell options to the editor

      var cell = this,
          editorOptions = {};

      _.each(this.editorOptionDefaults, function (def, opt) {
        if (!cell[opt]) cell[opt] = def;
        if (options && options[opt]) cell[opt] = options[opt];
        editorOptions[opt] = cell[opt];
      });

      editorOptions['el'] = $(this.el);
      editorOptions['columns_length'] = this.column.collection.length;
      editorOptions['el'].attr('tabindex', 0);
      this.listenTo(this.model, 'backgrid:edit', function (model, column, sel_cell, editor) {
        if (column.get('name') == this.column.get('name')) editor.extendWithOptions(editorOptions);
      }); // Listen for Tab key, open subnode dialog on space key

      this.$el.on('keydown', function (e) {
        if (e.keyCode == 32) {
          $(this).click();
        }
      });
    },
    enterEditMode: function enterEditMode() {
      // Notify that we are about to enter in edit mode for current cell.
      // We will check if this row is editable first
      var canEditRow = !_.isUndefined(this.column.get('canEditRow')) && _.isFunction(this.column.get('canEditRow')) ? Backgrid.callByNeed(this.column.get('canEditRow'), this.column, this.model) : true;

      if (canEditRow) {
        // Notify that we are about to enter in edit mode for current cell.
        this.model.trigger('enteringEditMode', [this]);
        Backgrid.Cell.prototype.enterEditMode.apply(this, arguments);
        /* Make sure - we listen to the click event */

        this.delegateEvents();
        var editable = Backgrid.callByNeed(this.column.editable(), this.column, this.model);

        if (editable) {
          this.$el.html('<i class=\'fa fa-pen-square subnode-edit-in-process\' title=\'' + gettext('Edit row') + '\' aria-label=\'' + gettext('Edit row') + '\'></i>');
          var body = $(this.$el).parents()[1],
              container = $(body).find('.tab-content:first > .tab-pane.active:first');
          commonUtils.findAndSetFocus(container);
          pgBrowser.keyboardNavigation.getDialogTabNavigator($(body).find('.subnode-dialog'));
          this.model.trigger('pg-sub-node:opened', this.model, this);
        }
      } else {
        _Notifier["default"].alert(gettext('Edit object'), gettext('This object is not user editable.'), function () {
          return true;
        });
      }
    },
    render: function render() {
      this.$el.empty();
      this.$el.html('<i class=\'fa fa-edit\' title=\'' + gettext('Edit row') + '\' aria-label=\'' + gettext('Edit row') + '\'></i>');
      this.delegateEvents();
      if (this.grabFocus) this.$el.trigger('focus');
      return this;
    },
    exitEditMode: function exitEditMode() {
      if (!_.isUndefined(this.currentEditor) || !_.isEmpty(this.currentEditor)) {
        var index = $(this.currentEditor.objectView.el).find('.nav-tabs > .active > a[data-toggle="tab"]').first().data('tabIndex');
        Backgrid.Cell.prototype.exitEditMode.apply(this, arguments);
        this.model.trigger('pg-sub-node:closed', this, index);
        this.grabFocus = true;
      }
    },
    events: {
      'click': function click(e) {
        if (this.$el.find('i').first().hasClass('subnode-edit-in-process')) {
          // Need to redundantly undelegate events for Firefox
          this.undelegateEvents();
          this.currentEditor.save();
        } else {
          this.enterEditMode.call(this, []);
        }

        e.preventDefault();
      },
      'keydown': function keydown(e) {
        var model = this.model;
        var column = this.column;
        var command = new Backgrid.Command(e);

        if (command.moveLeft()) {
          setTimeout(function () {
            model.trigger('backgrid:edited', model, column, command);
          }, 20);
        }
      }
    }
  });
  Backgrid.Extension.DeleteCell = Backgrid.Cell.extend({
    defaults: _.defaults({
      defaultDeleteMsg: gettext('Are you sure you wish to delete this row?'),
      defaultDeleteTitle: gettext('Delete Row')
    }, Backgrid.Cell.prototype.defaults),

    /** @property */
    className: 'delete-cell',
    events: {
      'click': 'deleteRow'
    },
    deleteRow: function deleteRow(e) {
      e.preventDefault();
      var that = this; // We will check if row is deletable or not

      var canDeleteRow = !_.isUndefined(this.column.get('canDeleteRow')) && _.isFunction(this.column.get('canDeleteRow')) ? Backgrid.callByNeed(this.column.get('canDeleteRow'), this.column, this.model) : true;

      if (canDeleteRow) {
        var delete_msg = !_.isUndefined(this.column.get('customDeleteMsg')) ? this.column.get('customDeleteMsg') : that.defaults.defaultDeleteMsg;
        var delete_title = !_.isUndefined(this.column.get('customDeleteTitle')) ? this.column.get('customDeleteTitle') : that.defaults.defaultDeleteTitle;

        _Notifier["default"].confirm(delete_title, delete_msg, function () {
          var tbody = $(that.el).parents('tbody').eq(0);
          that.model.collection.remove(that.model);
          var row = $(tbody).find('tr');

          if (row.length > 0) {
            // set focus to first tr
            row.first().children()[0].focus();
          } else {
            // set focus to add button
            $(tbody).parents('.subnode').eq(0).find('.add').focus();
          }
        }, function () {
          return true;
        });
      } else {
        _Notifier["default"].alert(gettext('Delete object'), gettext('This object cannot be deleted.'), function () {
          return true;
        });
      }
    },
    exitEditMode: function exitEditMode() {
      this.$el.removeClass('editor');
    },
    initialize: function initialize() {
      Backgrid.Cell.prototype.initialize.apply(this, arguments);
    },
    render: function render() {
      var self = this;
      this.$el.empty();
      $(this.$el).attr('tabindex', 0);
      this.$el.html('<i aria-label="' + gettext('Delete row') + '" class=\'fa fa-trash-alt\' title=\'' + gettext('Delete row') + '\'></i>'); // Listen for Tab/Shift-Tab key

      this.$el.on('keydown', function (e) {
        // with keyboard navigation on space key, mark row for deletion
        if (e.keyCode == 32) {
          self.$el.click();
        }

        var gotoCell;

        if (e.keyCode == 9 || e.keyCode == 16) {
          // go to Next Cell & if Shift is also pressed go to Previous Cell
          gotoCell = e.shiftKey ? self.$el.prev() : self.$el.next();
        }

        if (gotoCell) {
          var command = new Backgrid.Command({
            key: 'Tab',
            keyCode: 9,
            which: 9,
            shiftKey: e.shiftKey
          });
          setTimeout(function () {
            // When we have Editable Cell
            if (gotoCell.hasClass('editable')) {
              e.preventDefault();
              e.stopPropagation();
              self.model.trigger('backgrid:edited', self.model, self.column, command);
            } else {
              // When we have Non-Editable Cell
              self.model.trigger('backgrid:edited', self.model, self.column, command);
            }
          }, 20);
        }
      });
      this.delegateEvents();
      return this;
    }
  });
  Backgrid.Extension.ClearCell = Backgrid.Cell.extend({
    defaults: _.defaults({
      defaultClearMsg: gettext('Are you sure you wish to clear this row?'),
      defaultClearTitle: gettext('Clear Row')
    }, Backgrid.Cell.prototype.defaults),

    /** @property */
    className: 'clear-cell',
    events: {
      'click': 'clearRow'
    },
    clearRow: function clearRow(e) {
      e.preventDefault();
      if (_.isEmpty(e.currentTarget.innerHTML)) return false;
      var that = this; // We will check if row is deletable or not

      var clear_msg = !_.isUndefined(this.column.get('customClearMsg')) ? this.column.get('customClearMsg') : that.defaults.defaultClearMsg;
      var clear_title = !_.isUndefined(this.column.get('customClearTitle')) ? this.column.get('customClearTitle') : that.defaults.defaultClearTitle;

      _Notifier["default"].confirm(clear_title, clear_msg, function () {
        that.model.set('name', null);
        that.model.set('sql', null);
      }, function () {
        return true;
      });
    },
    exitEditMode: function exitEditMode() {
      this.$el.removeClass('editor');
    },
    initialize: function initialize() {
      Backgrid.Cell.prototype.initialize.apply(this, arguments);
    },
    render: function render() {
      var self = this;
      this.$el.empty();
      $(this.$el).attr('tabindex', 0);
      if (this.model.get('name') !== null && this.model.get('sql') !== null) this.$el.html('<i aria-label="' + gettext('Clear row') + '" class=\'fa fa-eraser\' title=\'' + gettext('Clear row') + '\'></i>'); // Listen for Tab/Shift-Tab key

      this.$el.on('keydown', function (e) {
        // with keyboard navigation on space key, mark row for deletion
        if (e.keyCode == 32) {
          self.$el.click();
        }

        var gotoCell;

        if (e.keyCode == 9 || e.keyCode == 16) {
          // go to Next Cell & if Shift is also pressed go to Previous Cell
          gotoCell = e.shiftKey ? self.$el.prev() : self.$el.next();
        }

        if (gotoCell) {
          var command = new Backgrid.Command({
            key: 'Tab',
            keyCode: 9,
            which: 9,
            shiftKey: e.shiftKey
          });
          setTimeout(function () {
            // When we have Editable Cell
            if (gotoCell.hasClass('editable')) {
              e.preventDefault();
              e.stopPropagation();
              self.model.trigger('backgrid:edited', self.model, self.column, command);
            } else {
              // When we have Non-Editable Cell
              self.model.trigger('backgrid:edited', self.model, self.column, command);
            }
          }, 20);
        }
      });
      this.delegateEvents();
      return this;
    }
  });
  Backgrid.Extension.CustomHeaderCell = Backgrid.HeaderCell.extend({
    initialize: function initialize() {
      // Here, we will add custom classes to header cell
      Backgrid.HeaderCell.prototype.initialize.apply(this, arguments);
      var getClassName = this.column.get('cellHeaderClasses');
      var getAriaLabel = this.column.get('cellAriaLabel');

      if (getClassName) {
        this.$el.addClass(getClassName);
      }

      if (getAriaLabel) {
        this.$el.attr('aria-label', getAriaLabel);
      }
    },
    render: function render() {
      Backgrid.HeaderCell.prototype.render.apply(this, arguments); // If table header label is not present then screen reader will raise
      // an error we will add span for screen reader only

      if (this.column.get('label') == '' || !this.column.get('label')) {
        var getAriaLabel = this.column.get('cellAriaLabel');
        if (getAriaLabel) this.$el.append("<span class=\"sr-only\">".concat(getAriaLabel, "</span>"));
      }

      return this;
    }
  });
  /**
    SwitchCell renders a Bootstrap Switch in backgrid cell
  */

  if (__webpack_provided_window_dot_jQuery && __webpack_provided_window_dot_jQuery.fn.bootstrapToggle) $.fn.bootstrapToggle = __webpack_provided_window_dot_jQuery.fn.bootstrapToggle;
  Backgrid.Extension.SwitchCell = Backgrid.BooleanCell.extend({
    defaults: {
      options: _.defaults({
        onText: gettext('Yes'),
        offText: gettext('No'),
        onColor: 'success',
        offColor: 'ternary',
        size: 'mini',
        width: null,
        height: null
      }, $.fn.bootstrapToggle.defaults)
    },
    className: 'switch-cell',
    initialize: function initialize() {
      Backgrid.BooleanCell.prototype.initialize.apply(this, arguments);
      this.onChange = this.onChange.bind(this);
    },
    enterEditMode: function enterEditMode() {
      this.$el.addClass('editor');
      $(this.$el.find('.toggle.btn')).trigger('focus');
    },
    exitEditMode: function exitEditMode() {
      this.$el.removeClass('editor');
    },
    events: {
      'change input': 'onChange',
      'blur input': 'exitEditMode',
      'keydown': 'onKeyDown'
    },
    onKeyDown: function onKeyDown(e) {
      var preferences = pgWindow["default"].pgAdmin.Browser.get_preferences_for_module('browser');

      if (keyboardShortcuts.validateShortcutKeys(preferences.add_grid_row, e)) {
        pgBrowser.keyboardNavigation.bindAddGridRow();
      }
    },
    onChange: function onChange() {
      var model = this.model,
          column = this.column,
          val = this.formatter.toRaw(this.$input.prop('checked'), model);
      this.enterEditMode(); // on bootstrap change we also need to change model's value

      model.set(column.get('name'), val);
      this.setSrValue();
    },
    setSrValue: function setSrValue() {
      var _$defaults = _.defaults({}, this.column.get('options'), this.defaults.options),
          onText = _$defaults.onText,
          offText = _$defaults.offText;

      if (this.$el.find('.toggle.btn').hasClass('off')) {
        this.$el.find('.sr-value').text("\n          ".concat(offText, ", ").concat(gettext('Toggle button'), "\n        "));
      } else {
        this.$el.find('.sr-value').text("\n          ".concat(onText, ", ").concat(gettext('Toggle button'), "\n        "));
      }
    },
    render: function render() {
      var self = this,
          col = _.defaults(this.column.toJSON(), this.defaults),
          model = this.model,
          column = this.column,
          rawValue = this.formatter.fromRaw(model.get(column.get('name')), model),
          editable = Backgrid.callByNeed(col.editable, column, model),
          options = _.defaults({}, col.options, this.defaults.options),
          cId = _.uniqueId('pgC_');

      this.undelegateEvents();
      this.$el.empty();
      this.$el.append('<label class="sr-value sr-only" for="' + cId + '"></label>');
      this.$el.append($('<input>', {
        tabIndex: -1,
        type: 'checkbox',
        'aria-hidden': 'true',
        'aria-label': column.get('name')
      }).prop('checked', rawValue).prop('disabled', !editable).attr('data-toggle', 'toggle').attr('data-size', options.size).attr('data-on', options.onText).attr('data-off', options.offText).attr('data-width', options.width).attr('data-height', options.height).attr('data-onstyle', options.onColor).attr('data-offstyle', options.offColor));
      this.$input = this.$el.find('input[type=checkbox]').first(); // Override BooleanCell checkbox with Bootstraptoggle

      this.$input.bootstrapToggle();
      this.$el.find('.toggle.btn').attr('tabindex', !editable ? '-1' : '0').attr('id', cId).on('keydown', function (e) {
        if (e.keyCode == 32) {
          self.$el.find('input[type=checkbox]').bootstrapToggle('toggle');
          e.preventDefault();
          e.stopPropagation();
          self.setSrValue();
        }
      });
      this.$el.find('.toggle.btn .toggle-group .btn').attr('aria-hidden', true);
      this.setSrValue(); // Listen for Tab key

      this.$el.on('keydown', function (e) {
        var gotoCell;

        if (e.keyCode == 9) {
          // go to Next Cell & if Shift is also pressed go to Previous Cell
          gotoCell = e.shiftKey ? self.$el.prev() : self.$el.next();
        }

        if (gotoCell && gotoCell.length > 0) {
          if (gotoCell.hasClass('editable')) {
            e.preventDefault();
            e.stopPropagation();
          }

          var command = new Backgrid.Command({
            key: 'Tab',
            keyCode: 9,
            which: 9,
            shiftKey: e.shiftKey
          });
          setTimeout(function () {
            // When we have Editable Cell
            if (gotoCell.hasClass('editable') && gotoCell.hasClass('edit-cell')) {
              gotoCell.trigger('focus');
            } else if (gotoCell.hasClass('editable')) {
              setTimeout(function () {
                self.model.trigger('backgrid:edited', self.model, self.column, command);
              }, 10);
              gotoCell.trigger('focus');
            } else {
              // When we have Non-Editable Cell
              setTimeout(function () {
                self.model.trigger('backgrid:edited', self.model, self.column, command);
              }, 10);
            }
          }, 20);
        }
      });
      this.delegateEvents();
      return this;
    }
  });
  /*
   *  Select2Cell for backgrid.
   */

  Backgrid.Extension.Select2Cell = Backgrid.SelectCell.extend({
    className: 'select2-cell',

    /** @property */
    editor: null,
    defaults: _.defaults({
      select2: {},
      opt: {
        label: null,
        value: null,
        selected: false
      }
    }, Backgrid.SelectCell.prototype.defaults),
    enterEditMode: function enterEditMode() {
      if (!this.$el.hasClass('editor')) this.$el.addClass('editor');
      this.$select.select2('focus');
      this.$select.select2('open');
      this.$select.on('blur', this.exitEditMode);
    },
    exitEditMode: function exitEditMode() {
      this.$select.off('blur', this.exitEditMode);
      this.$select.select2('close');
      this.$el.removeClass('editor');
      this.$el.find('.select2-selection').trigger('focus');
    },
    saveOrCancel: function saveOrCancel(e) {
      var self = this;
      var command = new Backgrid.Command(e);
      var blurred = e.type === 'blur';

      if (command.moveUp() || command.moveDown() || command.moveLeft() || command.moveRight() || command.save() || blurred) {
        var gotoCell; // go to Next Cell & if Shift is also pressed go to Previous Cell

        if (e.keyCode == 9 || e.keyCode == 16) {
          gotoCell = e.shiftKey ? self.$el.prev() : self.$el.next();

          if (self.$el.next().length == 0) {
            setTimeout(function () {
              self.$el.find('.select2-selection').blur();
            }, 100);
          }
        }

        if (gotoCell) {
          var cmd = new Backgrid.Command({
            key: 'Tab',
            keyCode: 9,
            which: 9,
            shiftKey: e.shiftKey
          });
          setTimeout(function () {
            // When we have Editable Cell
            if (gotoCell.hasClass('editable')) {
              e.preventDefault();
              e.stopPropagation();
              self.model.trigger('backgrid:edited', self.model, self.column, cmd);
            } else {
              // When we have Non-Editable Cell
              self.model.trigger('backgrid:edited', self.model, self.column, cmd);
            }
          }, 20);
        }
      }
    },
    events: {
      'select2:open': 'enterEditMode',
      'select2:close': 'exitEditMode',
      'change': 'onSave',
      'select2:unselect': 'onSave',
      'blur': 'saveOrCancel',
      'keydown': 'saveOrCancel'
    },

    /** @property {function(Object, ?Object=): string} template */
    template: _.template(['<option value="<%- value %>" ', '<%= selected ? \'selected="selected"\' : "" %>>', '<%- label %></option>'].join(''), null, {
      variable: null
    }),
    initialize: function initialize() {
      Backgrid.SelectCell.prototype.initialize.apply(this, arguments);
      this.onSave = this.onSave.bind(this);
      this.enterEditMode = this.enterEditMode.bind(this);
      this.exitEditMode = this.exitEditMode.bind(this);
    },
    render: function render() {
      var col = _.defaults(this.column.toJSON(), this.defaults),
          model = this.model,
          column = this.column,
          editable = Backgrid.callByNeed(col.editable, column, model),
          optionValues = _.clone(this.optionValues || (_.isFunction(this.column.get('options')) ? this.column.get('options')(this) : this.column.get('options')));

      this.undelegateEvents();

      if (this.$select) {
        if (this.$select.data('select2')) {
          this.$select.select2('destroy');
        }

        delete this.$select;
        this.$select = null;
      }

      this.$el.empty();
      if (!_.isArray(optionValues)) throw new TypeError('optionValues must be an array');

      var optionText = null,
          optionValue = null,
          self = this,
          selectedValues = model.get(this.column.get('name')),
          select2_opts = _.extend({
        openOnEnter: false,
        multiple: false,
        showOnScroll: true,
        first_empty: true
      }, self.defaults.select2, col.select2 || {}),
          selectTpl = _.template('<select <%=multiple ? "multiple" : "" %>></select>');

      var $select = self.$select = $(selectTpl({
        multiple: select2_opts.multiple
      })).appendTo(self.$el);
      /*
       * Add empty option as Select2 requires any empty '<option><option>' for
       * some of its functionality to work.
       */

      if (select2_opts.first_empty) {
        optionValues.unshift(this.defaults.opt);
      }

      for (var i = 0; i < optionValues.length; i++) {
        var opt = optionValues[i];

        if (_.isArray(opt)) {
          optionText = opt[0];
          optionValue = opt[1];
          $select.append(self.template({
            label: optionText,
            value: optionValue,
            selected: selectedValues == optionValue || select2_opts.multiple && _.indexOf(selectedValues, optionValue) > -1
          }));
        } else {
          opt = _.defaults({}, opt, {
            selected: selectedValues == opt.value || select2_opts.multiple && _.indexOf(selectedValues, opt.value) > -1
          }, self.defaults.opt);
          $select.append(self.template(opt));
        }
      }

      if (col && _.has(col.disabled)) {
        var evalF = function evalF() {
          var args = [];
          Array.prototype.push.apply(args, arguments);
          var f = args.shift();

          if (typeof f === 'function') {
            return f.apply(self, args);
          }

          return f;
        };

        _.extend(select2_opts, {
          disabled: evalF(col.disabled, col, model)
        });
      } else {
        _.extend(select2_opts, {
          disabled: !editable
        });
      }

      this.delegateEvents(); // If disabled then no need to show placeholder

      if (!editable || col.mode === 'properties') {
        select2_opts['placeholder'] = '';
      }
      /* Configure show on scroll if required */


      select2_opts = configure_show_on_scroll["default"](select2_opts); // Initialize select2 control.

      this.$sel = this.$select.select2(select2_opts); // Select the highlighted item on Tab press.

      if (this.$sel) {
        this.$sel.data('select2').on('keypress', function (ev) {
          var ctx = this; // keycode 9 is for TAB key

          if (ev.which === 9 && ctx.isOpen()) {
            ctx.trigger('results:select', {});
            ev.preventDefault();
          }
        });
      }

      return this;
    },

    /**
         Saves the value of the selected option to the model attribute.
         */
    onSave: function onSave() {
      var model = this.model;
      var column = this.column;
      model.set(column.get('name'), this.$select.val());
    },
    remove: function remove() {
      this.$select.off('change', this.onSave);

      if (this.$select.data('select2')) {
        this.$select.select2('destroy');
      }

      this.$el.empty();
      Backgrid.SelectCell.prototype.remove.apply(this, arguments);
    }
  });
  /**
    TextareaCellEditor the cell editor renders a textarea multi-line text input
    box as its editor.
     @class Backgrid.TextareaCellEditor
    @extends Backgrid.InputCellEditor
  */

  var TextareaCellEditor = Backgrid.TextareaCellEditor = Backgrid.InputCellEditor.extend({
    /** @property */
    tagName: 'textarea',
    events: {
      'blur': 'saveOrCancel',
      'keydown': ''
    }
  });
  /**
    TextareaCell displays multiline HTML strings.
       @class Backgrid.Extension.TextareaCell
      @extends Backgrid.Cell
  */

  Backgrid.Extension.TextareaCell = Backgrid.Cell.extend({
    /** @property */
    className: 'textarea-cell',
    editor: TextareaCellEditor
  });
  /**
   * Custom header icon cell to add the icon in table header.
   */

  Backgrid.Extension.CustomHeaderIconCell = Backgrid.HeaderCell.extend({
    /** @property */
    className: 'header-icon-cell',
    events: {
      'click': 'addHeaderIcon'
    },
    addHeaderIcon: function addHeaderIcon(e) {
      this.collection.add(new this.collection.model());
      e.preventDefault();
    },
    render: function render() {
      this.$el.empty();
      this.$el.html('<label><a><span style=\'font-weight:normal;\'>' + gettext('Array Values') + '</a></span></label> <button class=\'btn-sm btn-secondary add\'>' + gettext('Add') + '</button>');
      this.delegateEvents();
      return this;
    }
  });
  var arrayCellModel = Backbone.Model.extend({
    defaults: {
      value: null
    }
  });
  /**
     Custom InputArrayCellEditor for editing user input array for debugger.
   */

  var InputArrayCellEditor = Backgrid.Extension.InputArrayCellEditor = Backgrid.CellEditor.extend({
    tagName: 'div',
    events: {
      'blur': 'lostFocus'
    },
    render: function render() {
      var self = this,
          arrayValuesCol = this.model.get(this.column.get('name')),
          cell_type = 'string';
      var data_type = this.model.get('type').replace('[]', '');

      switch (data_type) {
        case 'boolean':
          cell_type = 'boolean';
          break;

        case 'integer':
        case 'smallint':
        case 'bigint':
        case 'serial':
        case 'smallserial':
        case 'bigserial':
        case 'oid':
        case 'cid':
        case 'xid':
        case 'tid':
          cell_type = 'integer';
          break;

        case 'real':
        case 'numeric':
        case 'double precision':
        case 'decimal':
          cell_type = 'number';
          break;

        case 'date':
          cell_type = 'date';
          break;
      }

      var gridCols = [{
        name: 'value',
        label: gettext('Array Values'),
        type: 'text',
        cell: cell_type,
        headerCell: Backgrid.Extension.CustomHeaderIconCell,
        cellHeaderClasses: 'width_percent_100'
      }],
          gridBody = $('<div class=\'pgadmin-control-group backgrid form-group col-12 object subnode\'></div>');
      this.$el.attr('tabindex', '1');
      gridCols.unshift({
        name: 'pg-backform-delete',
        label: '',
        cell: Backgrid.Extension.DeleteCell,
        //headerCell: Backgrid.Extension.CustomHeaderIconCell,
        editable: false,
        cell_priority: -1
      });
      this.$el.empty();
      var grid = self.grid = new Backgrid.Grid({
        columns: gridCols,
        collection: arrayValuesCol
      });
      this.grid.listenTo(arrayValuesCol, 'backgrid:error', function (obj) {
        return function (ev) {
          obj.model.trigger('backgrid:error', obj.model, obj.column, new Backgrid.Command(ev));
        };
      }(this));
      this.grid.listenTo(arrayValuesCol, 'backgrid:edited', function (obj) {
        return function (ev) {
          obj.model.trigger('backgrid:edited', obj.model, obj.column, new Backgrid.Command(ev));
        };
      }(this));
      grid.render();
      gridBody.append(grid.$el);
      this.$el.html(gridBody);
      $(self.$el).pgMakeVisible('backform-tab');
      self.delegateEvents();
      return this;
    },

    /*
     * Call back function when the grid lost the focus
     */
    lostFocus: function lostFocus(ev) {
      var self = this,

      /*
       * Function to determine whether one dom element is descendant of another
       * dom element.
       */
      isDescendant = function isDescendant(parent, child) {
        var node = child.parentNode;

        while (node != null) {
          if (node == parent) {
            return true;
          }

          node = node.parentNode;
        }

        return false;
      };
      /*
       * Between leaving the old element focus and entering the new element focus the
       * active element is the document/body itself so add timeout to get the proper
       * focused active element.
       */


      setTimeout(function () {
        if (self.$el[0] != document.activeElement && !isDescendant(self.$el[0], document.activeElement)) {
          var m = self.model,
              column = self.column;
          m.trigger('backgrid:edited', m, column, new Backgrid.Command(ev));
          setTimeout(function () {
            if (self.grid) {
              self.grid.remove();
              self.grid = null;
            }
          }, 10);
        }
      }, 10);
      return;
    }
  });
  /*
   * This will help us transform the user input string array values in proper format to be
   * displayed in the cell.
   */

  var InputStringArrayCellFormatter = Backgrid.Extension.InputStringArrayCellFormatter = function () {};

  _.extend(InputStringArrayCellFormatter.prototype, {
    /**
     * Takes a raw value from a model and returns an optionally formatted
     * string for display.
     */
    fromRaw: function fromRaw(rawData) {
      var values = [];
      rawData.each(function (m) {
        var val = m.get('value');

        if (_.isUndefined(val)) {
          values.push('null');
        } else {
          values.push(m.get('value'));
        }
      });
      return values.toString();
    },
    toRaw: function toRaw(formattedData) {
      return formattedData;
    }
  });
  /*
   * This will help us transform the user input integer array values in proper format to be
   * displayed in the cell.
   */


  var InputIntegerArrayCellFormatter = Backgrid.Extension.InputIntegerArrayCellFormatter = function () {};

  _.extend(InputIntegerArrayCellFormatter.prototype, {
    /**
     * Takes a raw value from a model and returns an optionally formatted
     * string for display.
     */
    fromRaw: function fromRaw(rawData) {
      var values = [];
      rawData.each(function (m) {
        var val = m.get('value');

        if (_.isUndefined(val) || _.isNull(val)) {
          values.push('NULL');
        } else {
          values.push(m.get('value'));
        }
      });
      return values.toString();
    },
    toRaw: function toRaw(formattedData) {
      formattedData.each(function (m) {
        m.set('value', parseInt(m.get('value')), {
          silent: true
        });
      });
      return formattedData;
    }
  });
  /*
   * This will help us transform the user input numeric array values in proper format to be
   * displayed in the cell.
   */


  var InputNumberArrayCellFormatter = Backgrid.Extension.InputNumberArrayCellFormatter = function () {};

  _.extend(InputNumberArrayCellFormatter.prototype, {
    /**
     * Takes a raw value from a model and returns an optionally formatted
     * string for display.
     */
    fromRaw: function fromRaw(rawData) {
      var values = [];
      rawData.each(function (m) {
        var val = m.get('value');

        if (_.isUndefined(val) || _.isNull(val)) {
          values.push('NULL');
        } else {
          values.push(m.get('value'));
        }
      });
      return values.toString();
    },
    toRaw: function toRaw(formattedData) {
      formattedData.each(function (m) {
        m.set('value', parseFloat(m.get('value')), {
          silent: true
        });
      });
      return formattedData;
    }
  });
  /*
   *  InputStringArrayCell for rendering and taking input for string array type in debugger
   */


  Backgrid.Extension.InputStringArrayCell = Backgrid.Cell.extend({
    className: 'width_percent_25',
    formatter: InputStringArrayCellFormatter,
    editor: InputArrayCellEditor,
    initialize: function initialize() {
      Backgrid.Cell.prototype.initialize.apply(this, arguments); // set value to empty array.

      var m = arguments[0].model;

      if (_.isUndefined(this.collection)) {
        this.collection = new (Backbone.Collection.extend({
          model: arrayCellModel
        }))(m.get('value'));
      }

      this.model.set(this.column.get('name'), this.collection);
      this.listenTo(this.collection, 'remove', this.render);
    }
  });
  /*
   *  InputIntegerArrayCell for rendering and taking input for integer array type in debugger
   */

  Backgrid.Extension.InputIntegerArrayCell = Backgrid.IntegerCell.extend({
    className: 'width_percent_25',
    formatter: InputIntegerArrayCellFormatter,
    editor: InputArrayCellEditor,
    initialize: function initialize() {
      Backgrid.IntegerCell.prototype.initialize.apply(this, arguments); // set value to empty array.

      var m = arguments[0].model;

      _.each(m.get('value'), function (arrVal) {
        if (arrVal.value === 'NULL') {
          arrVal.value = null;
        }
      });

      if (_.isUndefined(this.collection)) {
        this.collection = new (Backbone.Collection.extend({
          model: arrayCellModel
        }))(m.get('value'));
      }

      this.model.set(this.column.get('name'), this.collection);
      this.listenTo(this.collection, 'remove', this.render);
    }
  });
  /*
   *  InputNumberArrayCell for rendering and taking input for numeric array type in debugger
   */

  Backgrid.Extension.InputNumberArrayCell = Backgrid.NumberCell.extend({
    className: 'width_percent_25',
    formatter: InputNumberArrayCellFormatter,
    editor: InputArrayCellEditor,
    initialize: function initialize() {
      Backgrid.NumberCell.prototype.initialize.apply(this, arguments); // set value to empty array.

      var m = arguments[0].model;

      _.each(m.get('value'), function (arrVal) {
        if (arrVal.value === 'NULL') {
          arrVal.value = null;
        }
      });

      if (_.isUndefined(this.collection)) {
        this.collection = new (Backbone.Collection.extend({
          model: arrayCellModel
        }))(m.get('value'));
      }

      this.model.set(this.column.get('name'), this.collection);
      this.listenTo(this.collection, 'remove', this.render);
    }
  });
  /*
   *  InputBooleanArrayCell for rendering and taking input for boolean array type in debugger
   */

  Backgrid.Extension.InputBooleanArrayCell = Backgrid.BooleanCell.extend({
    className: 'width_percent_25',
    editor: InputArrayCellEditor,
    initialize: function initialize() {
      Backgrid.BooleanCell.prototype.initialize.apply(this, arguments); // set value to empty array.

      var m = arguments[0].model;

      if (_.isUndefined(this.collection)) {
        this.collection = new (Backbone.Collection.extend({
          model: arrayCellModel
        }))(m.get('value'));
      }

      this.model.set(this.column.get('name'), this.collection);
      this.listenTo(this.collection, 'remove', this.render);
    }
  });
  /**
   * DependentCell functions can be used with the different cell type in order
   * to setup the callback for the depedent attribute change in the model.
   *
   * Please implement the 'dependentChanged' as the callback in the used cell.
   *
   * @class Backgrid.Extension.DependentCell
   **/

  var DependentCell = Backgrid.Extension.DependentCell = function () {};

  _.extend(DependentCell.prototype, {
    initialize: function initialize() {
      // Listen to the dependent fields in the model for any change
      var deps = this.column.get('deps');
      var self = this;

      if (deps && _.isArray(deps)) {
        _.each(deps, function (d) {
          var attrArr = d.split('.'),
              name = attrArr.shift();
          self.listenTo(self.model, 'change:' + name, self.dependentChanged);
        });
      }
    },
    remove: function remove() {
      // Remove the events for the dependent fields in the model
      var self = this,
          deps = self.column.get('deps');

      if (deps && _.isArray(deps)) {
        _.each(deps, function (d) {
          var attrArr = d.split('.'),
              name = attrArr.shift();
          self.stopListening(self.model, 'change:' + name, self.dependentChanged);
        });
      }
    }
  });
  /**
   Formatter for PasswordCell.
    @class Backgrid.PasswordFormatter
   @extends Backgrid.CellFormatter
   @constructor
  */


  var PasswordFormatter = Backgrid.PasswordFormatter = function () {};

  PasswordFormatter.prototype = new Backgrid.CellFormatter();

  _.extend(PasswordFormatter.prototype, {
    fromRaw: function fromRaw(rawValue) {
      if (_.isUndefined(rawValue) || _.isNull(rawValue)) return '';
      var pass = '';

      for (var i = 0; i < rawValue.length; i++) {
        pass += '*';
      }

      return pass;
    }
  });

  Backgrid.Extension.PasswordCell = Backgrid.StringCell.extend({
    formatter: PasswordFormatter,
    editor: Backgrid.InputCellEditor.extend({
      attributes: {
        type: 'password',
        autocomplete: 'new-password'
      },
      render: function render() {
        var model = this.model;
        this.$el.val(model.get(this.column.get('name')));
        return this;
      }
    })
  });
  /*
   * Override NumberFormatter to support NaN, Infinity values.
   * On client side, JSON do not directly support NaN & Infinity,
   * we explicitly converted it into string format at server side
   * and we need to parse it again in float at client side.
   */

  _.extend(Backgrid.NumberFormatter.prototype, {
    fromRaw: function fromRaw(number) {
      if (_.isNull(number) || _.isUndefined(number)) return '';
      number = parseFloat(number).toFixed(~~this.decimals);
      var parts = number.split('.');
      var integerPart = parts[0];
      var decimalPart = parts[1] ? (this.decimalSeparator || '.') + parts[1] : '';
      return integerPart.replace(this.HUMANIZED_NUM_RE, '$1' + this.orderSeparator) + decimalPart;
    }
  });
  /*
   *  JSONBCell Formatter.
   */


  var JSONBCellFormatter = Backgrid.Extension.JSONBCellFormatter = function () {};

  _.extend(JSONBCellFormatter.prototype, {
    fromRaw: function fromRaw(rawData) {
      // json data
      if (_.isArray(rawData)) {
        var converted_data = '';
        converted_data = _.map(rawData, function (data) {
          return JSON.stringify(JSON.stringify(data));
        });
        return '{' + converted_data.join() + '}';
      } else if (_.isObject(rawData)) {
        return JSON.stringify(rawData);
      } else {
        return rawData;
      }
    },
    toRaw: function toRaw(formattedData) {
      return formattedData;
    }
  });
  /*
   *  JSONBCell for backgrid.
   */


  Backgrid.Extension.JSONBCell = Backgrid.StringCell.extend({
    className: 'jsonb-cell',
    formatter: JSONBCellFormatter
  });
  var DatepickerCellEditor = Backgrid.InputCellEditor.extend({
    events: {},
    initialize: function initialize() {
      Backgrid.InputCellEditor.prototype.initialize.apply(this, arguments);
      var input = this;
      $(this.el).prop('readonly', true);
      $(this.el).datepicker({
        onClose: function onClose(newValue) {
          var command = new Backgrid.Command({});
          input.model.set(input.column.get('name'), newValue);
          input.model.trigger('backgrid:edited', input.model, input.column, command);
          input = null;
        }
      });
    }
  });
  Backgrid.Extension.DatepickerCell = Backgrid.Cell.extend({
    editor: DatepickerCellEditor
  }); // Reference:
  // https://github.com/wyuenho/backgrid-moment-cell/blob/master/backgrid-moment-cell.js

  /**
   MomentFormatter converts bi-directionally any datetime values in any format
   supported by [moment()](http://momentjs.com/docs/#/parsing/) to any
   datetime format
   [moment.fn.format()](http://momentjs.com/docs/#/displaying/format/)
   supports.
   @class Backgrid.Extension.MomentFormatter
   @extends Backgrid.CellFormatter
   @constructor
   */

  var MomentFormatter = Backgrid.Extension.MomentFormatter = function (options) {
    _.extend(this, this.defaults, options);
  };

  MomentFormatter.prototype = new Backgrid.CellFormatter();

  _.extend(MomentFormatter.prototype, {
    /**
       @cfg {Object} options
       @cfg {boolean} [options.modelInUnixOffset=false] Whether the model values
       should be read/written as the number of milliseconds since UNIX Epoch.
       @cfg {boolean} [options.modelInUnixTimestamp=false] Whether the model
       values should be read/written as the number of seconds since UNIX Epoch.
       @cfg {boolean} [options.modelInUTC=true] Whether the model values should
       be read/written in UTC mode or local mode.
       @cfg {string} [options.modelLang=moment.locale() moment>=2.8.0 |
       moment.lang() moment<2.8.0] The locale the model values should be
       read/written in.
       @cfg {string} [options.modelFormat=moment.defaultFormat] The format this
       moment formatter should use to read/write model values. Only meaningful if
       the values are strings.
       @cfg {boolean} [options.displayInUnixOffset=false] Whether the display
       values should be read/written as the number of milliseconds since UNIX
       Epoch.
       @cfg {boolean} [options.displayInUnixTimestamp=false] Whether the display
       values should be read/written as the number of seconds since UNIX Epoch.
       @cfg {boolean} [options.displayInUTC=true] Whether the display values
       should be read/written in UTC mode or local mode.
       @cfg {string} [options.displayLang=moment.locale() moment>=2.8.0 |
       moment.lang() moment<2.8.0] The locale the display values should be
       read/written in.
       @cfg {string} [options.displayFormat=moment.defaultFormat] The format
       this moment formatter should use to read/write dislay values.
       */
    defaults: {
      modelInUnixOffset: false,
      modelInUnixTimestamp: false,
      modelInUTC: true,
      modelLang: moment.locale(),
      modelFormat: moment.defaultFormat,
      displayInUnixOffset: false,
      displayInUnixTimestamp: false,
      displayInUTC: true,
      displayLang: moment.locale(),
      displayFormat: moment.defaultFormat,
      allowEmpty: false
    },

    /**
       Converts datetime values from the model for display.
       @member Backgrid.Extension.MomentFormatter
       @param {*} rawData
       @return {string}
       */
    fromRaw: function fromRaw(rawData) {
      if (rawData == null) return '';
      var m = this.modelInUnixOffset ? moment(rawData) : this.modelInUnixTimestamp ? moment.unix(rawData) : this.modelInUTC ? moment.utc(rawData, this.modelFormat, this.modelLang) : moment(rawData, this.modelFormat, this.modelLang);
      if (this.displayInUnixOffset) return +m;
      if (this.displayInUnixTimestamp) return m.unix();
      if (this.displayLang) m.locale(this.displayLang);
      if (this.displayInUTC) m.utc();else m.local();

      if (this.displayFormat != moment.defaultFormat) {
        return m.format(this.displayFormat);
      }

      return m.format();
    },

    /**
       Converts datetime values from user input to model values.
       @member Backgrid.Extension.MomentFormatter
       @param {string} formattedData
       @return {string}
       */
    toRaw: function toRaw(formattedData) {
      var m = this.displayInUnixOffset ? moment(+formattedData) : this.displayInUnixTimestamp ? moment.unix(+formattedData) : this.displayInUTC ? moment.utc(formattedData, this.displayFormat, this.displayLang) : moment(formattedData, this.displayFormat, this.displayLang);
      if (!m || !m.isValid()) return this.allowEmpty && formattedData === '' ? null : undefined;
      if (this.modelInUnixOffset) return +m;
      if (this.modelInUnixTimestamp) return m.unix();
      if (this.modelLang) m.locale(this.modelLang);
      if (this.modelInUTC) m.utc();else m.local();

      if (this.modelFormat != moment.defaultFormat) {
        return m.format(this.modelFormat);
      }

      return m.format();
    }
  });

  var MomentCell = Backgrid.Extension.MomentCell = Backgrid.Cell.extend({
    editor: Backgrid.InputCellEditor,

    /** @property */
    className: 'datetime-cell',

    /** @property {Backgrid.CellFormatter} [formatter=Backgrid.Extension.MomentFormatter] */
    formatter: MomentFormatter,

    /**
       Initializer. Accept Backgrid.Extension.MomentFormatter.options and
       Backgrid.Cell.initialize required parameters.
     */
    initialize: function initialize(options) {
      MomentCell.__super__.initialize.apply(this, arguments);

      var formatterDefaults = MomentFormatter.prototype.defaults;

      var formatterDefaultKeys = _.keys(formatterDefaults);

      var classAttrs = _.pick(this, formatterDefaultKeys);

      var formatterOptions = _.pick(options, formatterDefaultKeys);

      var columnsAttrs = _.pick(this.column.toJSON(), formatterDefaultKeys); // Priority of the options for the formatter, from highest to lowerest
      // 1. MomentCell instance options
      // 2. MomentCell class attributes
      // 3. MomentFormatter defaults
      // this.formatter will have been instantiated now


      _.extend(this.formatter, formatterDefaults, classAttrs, formatterOptions, columnsAttrs);

      this.editor = this.editor.extend({
        attributes: _.extend({}, this.editor.prototype.attributes || this.editor.attributes || {}, {
          placeholder: this.formatter.displayFormat
        }),
        options: this.column.get('options')
      });
    }
  });
  Backgrid.Extension.DatetimePickerEditor = Backgrid.InputCellEditor.extend({
    postRender: function postRender() {
      var self = this,
          evalF = function evalF() {
        var args = [];
        Array.prototype.push.apply(args, arguments);
        var f = args.shift();

        if (typeof f === 'function') {
          return f.apply(self, args);
        }

        return f;
      },
          options = _.extend({
        format: 'YYYY-MM-DD HH:mm:ss Z',
        icons: {
          time: 'fa fa-clock',
          data: 'fa fa-calendar-alt',
          today: 'fa fa-calendar-check',
          clear: 'fa fa-trash'
        },
        buttons: {
          showToday: true
        },
        toolbarPlacement: 'top',
        widgetPositioning: {
          horizontal: 'auto',
          vertical: 'bottom'
        },
        keepOpen: false
      }, evalF(this.column.get('options')), {
        keyBinds: {
          'shift tab': function shiftTab(widget) {
            if (widget) {
              // blur the input
              setTimeout(function () {
                self.closeIt({
                  keyCode: 9,
                  shiftKey: true
                });
              }, 10);
            }
          },
          tab: function tab(widget) {
            if (widget) {
              // blur the input
              setTimeout(function () {
                self.closeIt({
                  keyCode: 9
                });
              }, 10);
            }
          }
        }
      });

      this.tabKeyPress = false;
      this.$el.datetimepicker(options);
      this.$el.datetimepicker('show');
      this.picker = this.$el.data('datetimepicker');
    },
    events: {
      'hide.datetimepicker': 'closeIt',
      'focusout': 'closeIt',
      'keydown': 'keydownHandler'
    },
    keydownHandler: function keydownHandler(event) {
      var stopBubble = false;
      var self = this;

      if (!event.altKey && event.keyCode == 38) {
        var currdate = self.$el.data('datetimepicker').date().clone();

        if (self.$el.data('datetimepicker').widget.find('.datepicker').is(':visible')) {
          $(this.el).datetimepicker('date', currdate.subtract(7, 'd'));
        } else {
          $(this.el).datetimepicker('date', currdate.add(7, 'm'));
        }
      } else if (!event.altKey && event.keyCode == 40) {
        var _currdate = self.$el.data('datetimepicker').date().clone();

        if (self.$el.data('datetimepicker').widget.find('.datepicker').is(':visible')) {
          $(this.el).datetimepicker('date', _currdate.add(7, 'd'));
        } else {
          $(this.el).datetimepicker('date', _currdate.subtract(7, 'm'));
        }
      } else if (event.keyCode == 39) {
        var _currdate2 = self.$el.data('datetimepicker').date().clone();

        $(this.el).datetimepicker('date', _currdate2.add(1, 'd'));
      } else if (event.keyCode == 37) {
        var _currdate3 = self.$el.data('datetimepicker').date().clone();

        $(this.el).datetimepicker('date', _currdate3.subtract(1, 'd'));
      }

      if (event.altKey && event.keyCode == 84) {
        if (self.$el.data('datetimepicker').widget.find('.timepicker').is(':visible')) {
          self.$el.data('datetimepicker').widget.find('.fa-calendar-alt').click();
        } else {
          self.$el.data('datetimepicker').widget.find('.fa-clock').click();
        }
      }

      if (event.altKey && event.keyCode == 38) {
        var _currdate4 = self.$el.data('datetimepicker').date().clone();

        $(this.el).datetimepicker('date', _currdate4.add(1, 'h'));
      } else if (event.altKey && event.keyCode == 40) {
        var _currdate5 = self.$el.data('datetimepicker').date().clone();

        $(this.el).datetimepicker('date', _currdate5.subtract(1, 'h'));
      }

      if (event.keyCode == 27) {
        this.$el.datetimepicker('hide');
        stopBubble = true;
      }

      if (stopBubble) {
        event.stopImmediatePropagation();
      } // If Tab key pressed from Cell and not from Datetime picker element
      // then we should trigger edited event so that we can goto next cell


      var tabKeyPressed = true;

      if (event.keyCode === 9 && self.el === event.target) {
        self.closeIt(event, tabKeyPressed);
      }
    },
    closeIt: function closeIt(ev, isTabKeyPressed) {
      if (this.is_closing || this.tabKeyPress) return;
      this.is_closing = true;
      this.tabKeyPress = isTabKeyPressed;
      var formatter = this.formatter,
          model = this.model,
          column = this.column,
          val = this.$el.val(),
          newValue = formatter.toRaw(val, model);
      this.$el.datetimepicker('destroy');
      this.is_closing = false;
      /* set the model default value in case of empty or undefined */

      if (_.isUndefined(newValue) || String(val).replace(/^\s+|\s+$/g, '') == '') {
        newValue = null;
      }

      model.set(column.get('name'), newValue);
      var command = new Backgrid.Command(ev);
      model.trigger('backgrid:edited', model, column, command);
    }
  });

  _.extend(MomentCell.prototype, MomentFormatter.prototype.defaults);

  Backgrid.Extension.StringDepCell = Backgrid.StringCell.extend({
    initialize: function initialize() {
      Backgrid.StringCell.prototype.initialize.apply(this, arguments);
      Backgrid.Extension.DependentCell.prototype.initialize.apply(this, arguments);
    },
    dependentChanged: function dependentChanged() {
      this.$el.empty();
      var self = this,
          model = this.model,
          column = this.column,
          editable = this.column.get('editable');
      this.render();
      var is_editable = _.isFunction(editable) ? !!editable.apply(column, [model]) : !!editable;
      setTimeout(function () {
        self.$el.removeClass('editor');

        if (is_editable) {
          self.$el.addClass('editable');
        } else {
          self.$el.removeClass('editable');
        }
      }, 10);
      this.delegateEvents();
      return this;
    },
    remove: Backgrid.Extension.DependentCell.prototype.remove
  });
  Backgrid.Extension.Select2DepCell = Backgrid.Extension.Select2Cell.extend({
    initialize: function initialize() {
      Backgrid.Extension.Select2Cell.prototype.initialize.apply(this, arguments);
      Backgrid.Extension.DependentCell.prototype.initialize.apply(this, arguments);
    },
    dependentChanged: function dependentChanged() {
      var model = this.model,
          column = this.column,
          editable = this.column.get('editable');
      this.render();

      if (_.isFunction(editable) ? !!editable.apply(column, [model]) : !!editable) {
        this.$el.addClass('editable');
      } else {
        this.$el.removeClass('editable');
      }

      this.delegateEvents();
      return this;
    },
    remove: Backgrid.Extension.DependentCell.prototype.remove
  });
  /* Custom search box was added to give user defined text box for search
   * instead of backgrid rendered textbox
   */

  Backgrid.Extension.ClientSideFilter = Backgrid.Extension.ClientSideFilter.extend({
    $customSearchBox: null,
    template: function template(data) {
      return '<span class="search">&nbsp;</span><input type="search" ' + (data.placeholder ? 'aria-label= "' + data.placeholder + '"' : '') + ' ' + (data.placeholder ? 'placeholder="' + data.placeholder + '"' : '') + ' name="' + data.name + '" ' + (data.value ? 'value="' + data.value + '"' : '') + '/><a class="clear" data-backgrid-action="clear" href="#">&times;</a>';
    },
    searchBox: function searchBox() {
      if (this.$customSearchBox) {
        return this.$customSearchBox;
      } else {
        return this.$el.find('input[type=search]');
      }
    },
    setCustomSearchBox: function setCustomSearchBox($el) {
      this.$customSearchBox = $el;
      this.$customSearchBox.attr('type', 'search');
      this.$customSearchBox.on('keydown', this.search.bind(this));
      this.$customSearchBox.on('mousedown', this.search.bind(this));
      return this;
    },
    unsetCustomSearchBox: function unsetCustomSearchBox() {
      this.$customSearchBox.off('keydown', this.search.bind(this));
      this.$customSearchBox = null;
      return this;
    }
  });

  var BooleanCellFormatter = Backgrid.BooleanCellFormatter = function () {};

  _.extend(BooleanCellFormatter.prototype, {
    fromRaw: function fromRaw(rawValue) {
      if (_.isUndefined(rawValue) || _.isNull(rawValue)) {
        return false;
      } else if (rawValue === '1' || rawValue === 'True') {
        return true;
      } else if (rawValue === '0' || rawValue === 'False') {
        return false;
      }

      return rawValue;
    },
    toRaw: function toRaw(formattedData) {
      return formattedData;
    }
  });

  Backgrid.BooleanCell = Backgrid.BooleanCell.extend({
    className: 'boolean-cell',
    enterEditMode: function enterEditMode() {
      this.$el.addClass('editor');
      $(this.$el.find('input[type=checkbox]')).trigger('focus');
    },
    exitEditMode: function exitEditMode() {
      this.$el.removeClass('editor');
    },
    events: {
      'change input': 'onChange',
      'blur input': 'exitEditMode',
      'keydown': 'onKeyDown'
    },
    onChange: function onChange(e) {
      var model = this.model,
          column = this.column,
          val = this.formatter.toRaw(this.$input.prop('checked'), model);
      this.enterEditMode(); // on bootstrap change we also need to change model's value

      model.set(column.get('name'), val);
      model.trigger('backgrid:edited', model, column, new Backgrid.Command(e));
    },
    render: function render() {
      this.$el.empty();
      var model = this.model,
          column = this.column;
      var editable = Backgrid.callByNeed(column.editable(), column, model);
      var align_center = column.get('align_center') || false;
      var checked = this.formatter.fromRaw(model.get(column.get('name')), model);
      var id = "".concat(column.get('name'), "_").concat(_.uniqueId());
      this.$el.empty();
      this.$el.append($("<div class=\"custom-control custom-checkbox custom-checkbox-no-label ".concat(align_center ? 'text-center' : '', "\">\n          <input tabindex=\"0\" type=\"checkbox\" class=\"custom-control-input\" id=\"").concat(id, "\" ").concat(!editable ? 'disabled' : '', " ").concat(checked ? 'checked' : '', "/>\n          <label class=\"custom-control-label\" for=\"").concat(id, "\">\n            <span class=\"sr-only\">") + gettext('Select') + "<span>\n          </label>\n        </div>"));
      this.$input = this.$el.find('input');
      this.delegateEvents();
      return this;
    }
  });
  Backgrid.Extension.SqlCell = Backgrid.Extension.TextareaCell.extend({
    className: 'sql-cell',
    defaults: {
      lineWrapping: true
    },
    template: _.template(['<div data-toggle="tooltip" data-placement="top" data-html="true" title="<%- val %>"><textarea aria-label="' + gettext('SQL') + '" + style="display: none;"><%- val %></textarea><div>'].join('\n')),
    render: function render() {
      var self = this,
          col = _.defaults(this.column.toJSON(), this.defaults),
          model = this.model,
          column = this.column,
          columnName = this.column.get('name'),
          editable = Backgrid.callByNeed(col.editable, column, model);

      if (this.sqlCell) {
        this.sqlCell.toTextArea();
        delete this.sqlCell;
        this.sqlCell = null;
      }

      this.$el.empty();
      this.$el.append(this.template({
        val: this.formatter.fromRaw(model.get(columnName), model)
      }));
      this.$el.addClass(columnName);
      this.updateStateClassesMaybe();
      this.delegateEvents();
      setTimeout(function () {
        self.sqlCell = CodeMirror.fromTextArea(self.$el.find('textarea')[0], {
          mode: 'text/x-pgsql',
          readOnly: !editable,
          singleCursorHeightPerLine: true,
          screenReaderLabel: columnName
        });
      });
      return this;
    },
    enterEditMode: function enterEditMode() {
      if (!this.$el.hasClass('editor')) this.$el.addClass('editor');
      this.sqlCell.focus();
      this.sqlCell.on('blur', this.exitEditMode.bind(this));
    },
    exitEditMode: function exitEditMode() {
      this.$el.removeClass('editor');
      this.saveOrCancel.apply(this, arguments);
    },
    saveOrCancel: function saveOrCancel() {
      var model = this.model;
      var column = this.column;

      if (this.sqlCell) {
        var val = this.sqlCell.getTextArea().value;
        var newValue = this.sqlCell.getValue();

        if (_.isUndefined(newValue)) {
          model.trigger('backgrid:error', model, column, val);
        } else {
          model.set(column.get('name'), newValue);
        }
      }
    },
    remove: function remove() {
      if (this.sqlCell) {
        $(this.$el.find('[data-toggle="tooltip"]')).tooltip('dispose');
        this.sqlCell.toTextArea();
        delete this.sqlCell;
        this.sqlCell = null;
      }

      return Backgrid.Extension.TextareaCell.prototype.remove.apply(this, arguments);
    }
  });
  Backgrid.RadioCell = Backgrid.BooleanCell.extend({
    className: 'radio-cell',
    initialize: function initialize() {
      Backgrid.BooleanCell.prototype.initialize.apply(this, arguments);
      Backgrid.Extension.DependentCell.prototype.initialize.apply(this, arguments);
    },
    dependentChanged: function dependentChanged() {
      return this.render();
    },
    enterEditMode: function enterEditMode() {
      this.$el.addClass('editor');
      $(this.$el.find('input[type=radio]')).trigger('focus');
    },
    exitEditMode: function exitEditMode() {
      this.$el.removeClass('editor');
    },
    events: {
      'change input': 'onChange',
      'blur input': 'exitEditMode'
    },
    onChange: function onChange(e) {
      var model = this.model,
          column = this.column,
          val = this.formatter.toRaw(this.$input.prop('checked'), model);
      this.enterEditMode();

      _.each(this.model.collection.models, function (sub_model) {
        sub_model.set(column.get('name'), false);
        sub_model.trigger('backgrid:edited', sub_model, column, new Backgrid.Command(e));
      }); // on bootstrap change we also need to change model's value


      model.set(column.get('name'), val);
      model.trigger('backgrid:edited', model, column, new Backgrid.Command(e));
    },
    render: function render() {
      this.$el.empty();
      var model = this.model,
          column = this.column;
      var editable = Backgrid.callByNeed(column.editable(), column, model);
      var checked = this.formatter.fromRaw(model.get(column.get('name')), model);
      var id = "".concat(column.get('name'), "_").concat(_.uniqueId());
      this.$el.empty();
      this.$el.append($("<div style=\"text-align: center\">\n          <input tabindex=\"0\" type=\"radio\" id=\"".concat(id, "\" ").concat(!editable ? 'disabled' : '', " ").concat(checked ? 'checked' : '', "/>\n        </div>")));
      this.$input = this.$el.find('input');
      this.delegateEvents();
      return this;
    }
  });
  Backgrid.Extension.SelectFileCell = Backgrid.Cell.extend({
    /** @property */
    className: 'file-cell',
    defaults: {
      supported_types: ['*'],
      dialog_type: 'select_file',
      dialog_title: gettext('Select file'),
      type: 'text',
      value: '',
      placeholder: gettext('Select file...'),
      disabled: false,
      browse_btn_label: gettext('Select file'),
      check_btn_label: gettext('Validate file'),
      browse_btn_visible: true,
      validate_btn_visible: true
    },
    initialize: function initialize() {
      Backgrid.Cell.prototype.initialize.apply(this, arguments);
      this.data = _.extend(this.defaults, this.column.toJSON());
    },
    template: _.template(['<div class="input-group">', '<input type="<%=type%>" id="<%=cId%>" class="form-control" value="<%-value%>" placeholder="<%-placeholder%>" <%=disabled ? "disabled" : ""%> />', '<% if (browse_btn_visible) { %>', '<div class="input-group-append">', '<button class="btn btn-primary-icon fa fa-ellipsis-h select_item" <%=disabled ? "disabled" : ""%>  aria-hidden="true" aria-label=<%=browse_btn_label%> title=<%=browse_btn_label%>></button>', '</div>', '<% } %>', '<% if (validate_btn_visible) { %>', '<div class="input-group-append">', '<button class="btn btn-primary-icon fa fa-clipboard-check validate_item" <%=disabled ? "disabled" : ""%> <%=(value=="" || value==null) ? "disabled" : ""%>  aria-hidden="true" aria-label=<%=check_btn_label%> title=<%=check_btn_label%>></button>', '</div>', '<% } %>', '</div>'].join('\n')),
    events: {
      'change input': 'onChange',
      'click .select_item': 'onSelect',
      'click .validate_item': 'onValidate'
    },
    render: function render() {
      this.$el.empty();
      this.data = _.extend(this.data, {
        value: this.model.get(this.column.get('name'))
      }); // Adding unique id

      this.data['cId'] = _.uniqueId('pgC_');
      this.$el.append(this.template(this.data));
      this.$input = this.$el.find('input');
      this.delegateEvents();
      return this;
    },
    onChange: function onChange() {
      var model = this.model,
          column = this.column,
          val = this.formatter.toRaw(this.$input.prop('value'), model);
      model.set(column.get('name'), val);
    },
    onSelect: function onSelect() {
      var self = this;
      var params = {
        supported_types: self.data.supported_types,
        dialog_type: self.data.dialog_type,
        dialog_title: self.data.dialog_title
      };
      pgAdmin.FileManager.init();
      pgAdmin.FileManager.show_dialog(params); // Listen click events of Storage Manager dialog buttons

      this.listen_file_dlg_events();
    },
    storage_dlg_hander: function storage_dlg_hander(value) {
      var attrArr = this.column.get('name').split('.'),
          name = attrArr.shift();
      this.remove_file_dlg_event_listeners(); // Set selected value into the model

      this.model.set(name, decodeURI(value));
    },
    storage_close_dlg_hander: function storage_close_dlg_hander() {
      this.remove_file_dlg_event_listeners();
    },
    listen_file_dlg_events: function listen_file_dlg_events() {
      pgAdmin.Browser.Events.on('pgadmin-storage:finish_btn:' + this.data.dialog_type, this.storage_dlg_hander, this);
      pgAdmin.Browser.Events.on('pgadmin-storage:cancel_btn:' + this.data.dialog_type, this.storage_close_dlg_hander, this);
    },
    remove_file_dlg_event_listeners: function remove_file_dlg_event_listeners() {
      pgAdmin.Browser.Events.off('pgadmin-storage:finish_btn:' + this.data.dialog_type, this.storage_dlg_hander, this);
      pgAdmin.Browser.Events.off('pgadmin-storage:cancel_btn:' + this.data.dialog_type, this.storage_close_dlg_hander, this);
    },
    onValidate: function onValidate() {
      var model = this.model,
          val = this.formatter.toRaw(this.$input.prop('value'), model);

      if (_.isNull(val) || val.trim() === '') {
        _Notifier["default"].alert(gettext('Validate Path'), gettext('Path should not be empty.'));
      }

      $.ajax({
        url: url_for('misc.validate_binary_path'),
        method: 'POST',
        contentType: 'application/json',
        data: JSON.stringify({
          'utility_path': val
        })
      }).done(function (res) {
        _Notifier["default"].alert(gettext('Validate binary path'), gettext(res.data));
      }).fail(function (xhr, error) {
        _Notifier["default"].pgNotifier(error, xhr, gettext('Failed to validate binary path.'));
      });
    }
  });
  return Backgrid;
}).apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__),
		__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));

/***/ }),

/***/ 63828:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {

"use strict";
/* provided dependency */ var _ = __webpack_require__(10084);
/* provided dependency */ var __webpack_provided_window_dot_jQuery = __webpack_require__(19755);


__webpack_require__(82526);

__webpack_require__(41817);

__webpack_require__(41539);

__webpack_require__(32165);

__webpack_require__(78783);

__webpack_require__(66992);

__webpack_require__(33948);

__webpack_require__(73210);

__webpack_require__(69826);

__webpack_require__(79753);

__webpack_require__(69600);

__webpack_require__(23123);

__webpack_require__(74916);

__webpack_require__(47042);

var _jsonBignumber = _interopRequireDefault(__webpack_require__(28210));

var _gettext = _interopRequireDefault(__webpack_require__(91669));

var _Notifier = _interopRequireDefault(__webpack_require__(55958));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

(function ($, JSONBigNumber) {
  // register namespace
  $.extend(true, window, {
    'Slick': {
      'Editors': {
        'pgText': pgTextEditor,
        'JsonText': JsonTextEditor,
        'CustomNumber': CustomNumberEditor,
        'Checkbox': pgCheckboxEditor,
        // Below editor will read only editors, Just to display data
        'ReadOnlyText': ReadOnlyTextEditor,
        'ReadOnlyCheckbox': ReadOnlyCheckboxEditor,
        'ReadOnlypgText': ReadOnlypgTextEditor,
        'ReadOnlyJsonText': ReadOnlyJsonTextEditor
      }
    }
  }); // return wrapper element

  function getWrapper() {
    return $('<div class=\'pg-text-editor\' />');
  } // return textarea element


  function getTextArea() {
    return $('<textarea class=\'pg-textarea text-12\' hidefocus rows=5\'>');
  } // return json editor element


  function getJsonEditor() {
    return $('<div id=\'pg-json-editor\' hidefocus>');
  } // Generate and return editor buttons


  function getButtons(editable) {
    var $buttons = $('<div class=\'pg_buttons\' />'),
        label = editable ? (0, _gettext["default"])('Cancel') : (0, _gettext["default"])('OK'),
        button_type = editable ? 'btn-secondary' : 'btn-primary',
        button_icon = editable ? 'fa-times' : 'fa-check';
    $('<button class=\'btn ' + button_type + ' long_text_editor pg-alertify-button\' data-label="' + label + '">' + '<span class="fa ' + button_icon + ' pg-alertify-button"></span>&nbsp;' + label + '</button>').appendTo($buttons);

    if (editable) {
      $('<button class=\'btn btn-primary long_text_editor\' data-label="' + (0, _gettext["default"])('OK') + '">' + '<span class="fa fa-check pg-alertify-button"></span>&nbsp;' + (0, _gettext["default"])('OK') + '</button>').appendTo($buttons);
    }

    return $buttons;
  }

  function is_valid_array(val) {
    val = $.trim(val);
    return !(val != '' && (val.charAt(0) != '{' || val.charAt(val.length - 1) != '}'));
  }
  /*
   * This function handles the [default] and [null] values for cells
   * if row is copied, otherwise returns the editor value.
   * @param {args} editor object
   * @param {item} row cell values
   * @param {state} entered value
   * @param {column_type} type of column
   */


  function setValue(args, item, state, column_type) {
    // declare a 2-d array which tracks the status of each updated cell
    // If a cell is edited for the 1st time and state is null,
    // set cell value to [default] and update its status [row][cell] to 1.
    // If same cell is edited again, and kept blank, set cell value to [null]
    // If a row is copied
    var grid = args.grid;

    if (item.is_row_copied) {
      if (!grid.copied_rows) {
        grid.copied_rows = [[]];
      }

      var active_cell = grid.getActiveCell(),
          row = active_cell['row'],
          cell = active_cell['cell'],
          last_value = item[args.column.pos];
      last_value = column_type === 'number' ? _.isEmpty(last_value) || last_value : last_value;
      item[args.column.field] = state;

      if (last_value && _.isNull(state) && (_.isUndefined(grid.copied_rows[row]) || _.isUndefined(grid.copied_rows[row][cell]))) {
        item[args.column.field] = undefined;
        if (grid.copied_rows[row] == undefined) grid.copied_rows[row] = [];
        grid.copied_rows[row][cell] = 1;
      }
    } else {
      if (column_type === 'jsonb' && state != null) {
        item[args.column.field] = JSONBigNumber.stringify(JSONBigNumber.parse(state));
      } else {
        item[args.column.field] = state;
      }
    }
  }

  function calculateEditorPosition(position, $wrapper) {
    var $edit_grid = $wrapper.parent().find('#datagrid');
    position.top = position.top - $wrapper.height();
    var grid_width = $edit_grid.width(),
        popup_width = $wrapper.width() + 32;
    popup_width += position.left;

    if (popup_width > grid_width) {
      position.left -= popup_width - grid_width;
    }

    return position;
  } // Text data type editor


  function pgTextEditor(args) {
    var $input, $wrapper, $buttons;
    var defaultValue;
    var scope = this;

    this.init = function () {
      var $container = $('body');
      $wrapper = getWrapper().appendTo($container);
      $input = getTextArea().appendTo($wrapper);
      $buttons = getButtons(true).appendTo($wrapper);
      $buttons.find('button:first').on('click', this.cancel);
      $buttons.find('button:last').on('click', this.save);
      $input.on('keydown', this.handleKeyDown);
      scope.position(args.position);
      $input.trigger('focus').trigger('select');
    };

    this.handleKeyDown = function (e) {
      if (e.which == $.ui.keyCode.ENTER && e.ctrlKey) {
        scope.save();
      } else if (e.which == $.ui.keyCode.ESCAPE) {
        e.preventDefault();
        scope.cancel();
      } else if (e.which == $.ui.keyCode.TAB && e.shiftKey) {
        e.preventDefault();
        args.grid.navigatePrev();
      } else if (e.which == $.ui.keyCode.TAB) {
        e.preventDefault();
        args.grid.navigateNext();
      }
    };

    this.save = function () {
      args.commitChanges();
    };

    this.cancel = function () {
      $input.val(defaultValue);
      args.cancelChanges();
    };

    this.hide = function () {
      $wrapper.hide();
    };

    this.show = function () {
      $wrapper.show();
    };

    this.position = function (position) {
      calculateEditorPosition(position, $wrapper);
      $wrapper.css('top', position.top).css('left', position.left);
    };

    this.destroy = function () {
      $wrapper.remove();
    };

    this.focus = function () {
      $input.trigger('focus');
    }; // When text editor opens


    this.loadValue = function (item) {
      if (_.isUndefined(item[args.column.field]) || _.isNull(item[args.column.field])) {
        $input.val(defaultValue = '');
        return;
      }

      if (!args.column.is_array) {
        if (item[args.column.field] === '') {
          $input.val(defaultValue = '\'\'');
          $input.trigger('select');
        } else if (item[args.column.field] === '\'\'') {
          $input.val(defaultValue = '\\\'\\\'');
        } else if (item[args.column.field] === '""') {
          $input.val(defaultValue = '\\"\\"');
        } else {
          $input.val(defaultValue = item[args.column.field]);
          $input.trigger('select');
        }
      } else {
        $input.val(defaultValue = item[args.column.field]);
        $input.trigger('select');
      }
    };

    this.serializeValue = function () {
      var value = $input.val(); // If empty return null

      if (value === '') {
        return null;
      }

      if (!args.column.is_array) {
        if (value === '\'\'' || value === '""') {
          return '';
        } else if (value === '\\\'\\\'') {
          return '\'\'';
        } else if (value === '\\"\\"') {
          return '""';
        } else {
          return value;
        }
      } else {
        return $.trim(value);
      }
    };

    this.applyValue = function (item, state) {
      setValue(args, item, state, 'text');
    };

    this.isValueChanged = function () {
      // Use _.isNull(value) for comparison for null instead of
      // defaultValue == null, because it returns true for undefined value.
      if ($input.val() == '' && _.isUndefined(defaultValue)) {
        return false;
      } else {
        return !($input.val() == '' && _.isNull(defaultValue)) && $input.val() !== defaultValue;
      }
    };

    this.validate = function () {
      if (args.column.validator) {
        var validationResults = args.column.validator($input.val());

        if (!validationResults.valid) {
          return validationResults;
        }
      }

      if (args.column.is_array && !is_valid_array($input.val())) {
        return {
          valid: false,
          msg: (0, _gettext["default"])('Arrays must start with "{" and end with "}"')
        };
      }

      return {
        valid: true,
        msg: null
      };
    };

    this.init();
  } // JSON data type editor


  function JsonTextEditor(args) {
    var $input, $wrapper, $buttons, $editor;
    var defaultValue, tmpdata;
    var scope = this;
    var editorInitialized = false;

    this.init = function () {
      var $container = $('body');
      $wrapper = getWrapper().appendTo($container);
      $input = getJsonEditor().appendTo($wrapper);
      $buttons = getButtons(true).appendTo($wrapper);
      $buttons.find('button:first').on('click', this.cancel);
      $buttons.find('button:last').on('click', this.save);
      $input.on('keydown', this.handleKeyDown);
      scope.position(args.position);
    };

    this.handleKeyDown = function (e) {
      if (e.which == $.ui.keyCode.ENTER && e.ctrlKey) {
        scope.save();
      } else if (e.which == $.ui.keyCode.ESCAPE) {
        e.preventDefault();
        scope.cancel();
      }
    };

    this.resizeJsoneditorObserver = new ResizeObserver(function () {
      if ($editor) {
        $editor.resize();
      }
    });

    this.save = function () {
      args.commitChanges();
    };

    this.cancel = function () {
      args.cancelChanges();
    };

    this.hide = function () {
      $wrapper.hide();
    };

    this.show = function () {
      $wrapper.show();
    };

    this.position = function (position) {
      calculateEditorPosition(position, $wrapper);
      position.top = Math.max(position.top, 0);
      $wrapper.css('top', position.top).css('left', position.left);
    };

    this.destroy = function () {
      this.resizeJsoneditorObserver.unobserve(document.getElementById('pg-json-editor'));
      $editor.destroy();
      $wrapper.remove();
    };

    this.focus = function () {
      $editor.focus();
    };

    this.loadValue = function (item) {
      var data = defaultValue = item[args.column.field];
      /* Can be useful until JSON editor loads */

      tmpdata = data;
      /* If jsonb or array */

      if (args.column.column_type_internal === 'jsonb' && !Array.isArray(data) && data != null) {
        data = JSONBigNumber.stringify(JSONBigNumber.parse(data), null, 2);
      } else if (Array.isArray(data)) {
        var temp = [];
        $.each(data, function (i, val) {
          if (_typeof(val) === 'object') {
            temp.push(JSONBigNumber.stringify(val, null, 2));
          } else {
            temp.push(val);
          }
        });
        data = '[' + temp.join() + ']';
      }
      /* set editor content to empty if value is null*/


      if (_.isNull(data)) {
        defaultValue = '';
        data = '';
      }
      /* Create editor if required & set data*/


      if ($editor) {
        $editor.setText(data);
        $editor.focus();
      } else {
        editorInitialized = true;

        __webpack_require__.e(/* require.ensure | jsoneditorchunk */ 708).then((function (require) {
          var JSONEditor = __webpack_require__(13807);

          var jsonContainer = document.getElementById('pg-json-editor');
          var options = {
            modes: ['code', 'form', 'tree', 'preview'],
            onError: function onError(error) {
              var msg = 'Invalid Json: ' + error.message.split(':')[0];

              _Notifier["default"].error((0, _gettext["default"])(msg));
            }
          };
          $editor = new JSONEditor(jsonContainer, options);
          $editor.setText(data);
          $editor.focus();
        }).bind(null, __webpack_require__)).catch(function (error) {
          throw error;
        });
      }

      this.resizeJsoneditorObserver.observe(document.getElementById('pg-json-editor'));
    };

    this.serializeValue = function () {
      /* Create editor if data is null/new data entry */
      if (!editorInitialized) {
        __webpack_require__.e(/* require.ensure | jsoneditorchunk */ 708).then((function (require) {
          var JSONEditor = __webpack_require__(13807);

          var jsonContainer = document.getElementById('pg-json-editor');
          var options = {
            modes: ['code', 'form', 'tree', 'preview'],
            onError: function onError(error) {
              var msg = 'Invalid Json: ' + error.message.split(':')[0];

              _Notifier["default"].error((0, _gettext["default"])(msg));
            }
          };

          if (jsonContainer) {
            $editor = new JSONEditor(jsonContainer, options);
            var data = '';
            $editor.setText(data);
            $editor.focus();
            return null;
          }
        }).bind(null, __webpack_require__)).catch(function (error) {
          throw error;
        });
      }

      if ($editor) {
        var data = $editor.getText();

        if (data === '') {
          return null;
        }

        return data;
      } else {
        // The loader is not loaded yet ?
        return tmpdata;
      }
    };

    this.applyValue = function (item, state) {
      if (args.column.column_type_internal === 'jsonb') {
        setValue(args, item, state, 'jsonb');
      } else {
        setValue(args, item, state, 'text');
      }
    };

    this.isValueChanged = function () {
      var data = $editor.getText();

      if (data == '' && (_.isUndefined(defaultValue) || _.isNull(defaultValue))) {
        return false;
      } else {
        if (args.column.column_type_internal === 'jsonb' && !_.isUndefined(defaultValue) && defaultValue != '') {
          defaultValue = JSON.stringify(JSON.parse(defaultValue), null, 2);
        }

        return !(data == '' && _.isNull(defaultValue)) && data != defaultValue;
      }
    };

    this.validate = function () {
      if (args.column.column_type_internal === 'jsonb' || args.column.column_type_internal === 'json') {
        var data = $editor.getText();

        try {
          if (data != '') {
            JSON.parse(data);
          }
        } catch (e) {
          $input.addClass('pg-text-invalid');
          return {
            valid: false,
            msg: e.message
          };
        }
      }

      return {
        valid: true,
        msg: null
      };
    };

    this.init();
  } // Text data type editor


  function ReadOnlypgTextEditor(args) {
    var $input, $wrapper, $buttons;
    var defaultValue;
    var scope = this;

    this.init = function () {
      var $container = $('body');
      $wrapper = getWrapper().appendTo($container);
      $input = getTextArea().appendTo($wrapper);
      $buttons = getButtons(false).appendTo($wrapper);
      $buttons.find('button:first').on('click', this.cancel);
      $input.on('keydown', this.handleKeyDown);
      scope.position(args.position);
      $input.trigger('focus').trigger('select');
    };

    this.handleKeyDown = function (e) {
      if (e.which == $.ui.keyCode.ENTER && e.ctrlKey) {
        scope.cancel();
      } else if (e.which == $.ui.keyCode.ESCAPE) {
        e.preventDefault();
        scope.cancel();
      } else if (e.which == $.ui.keyCode.TAB && e.shiftKey) {
        scope.cancel();
        e.preventDefault();
        args.grid.navigatePrev();
      } else if (e.which == $.ui.keyCode.TAB) {
        scope.cancel();
        e.preventDefault();
        args.grid.navigateNext();
      }
    };

    this.cancel = function () {
      $input.val(defaultValue);
      args.cancelChanges();
    };

    this.hide = function () {
      $wrapper.hide();
    };

    this.show = function () {
      $wrapper.show();
    };

    this.position = function (position) {
      calculateEditorPosition(position, $wrapper);
      $wrapper.css('top', position.top).css('left', position.left);
    };

    this.destroy = function () {
      $wrapper.remove();
    };

    this.focus = function () {
      $input.trigger('focus');
    };

    this.loadValue = function (item) {
      $input.val(defaultValue = item[args.column.field]);
      $input.trigger('select');
    };

    this.serializeValue = function () {
      return $input.val();
    };

    this.applyValue = function (item, state) {
      item[args.column.field] = state;
    };

    this.isValueChanged = function () {
      return !($input.val() == '' && defaultValue == null) && $input.val() != defaultValue;
    };

    this.validate = function () {
      if (args.column.validator) {
        var validationResults = args.column.validator($input.val());

        if (!validationResults.valid) {
          return validationResults;
        }
      }

      return {
        valid: true,
        msg: null
      };
    };

    this.init();
  } // JSON data type editor


  function ReadOnlyJsonTextEditor(args) {
    var $input, $wrapper, $buttons, $editor;
    var defaultValue;
    var scope = this;
    var tmpdata;

    this.init = function () {
      var $container = $('body');
      $wrapper = getWrapper().appendTo($container);
      $input = getJsonEditor().appendTo($wrapper);
      $buttons = getButtons(false).appendTo($wrapper);
      $buttons.find('button:first').on('click', this.cancel);
      $input.on('keydown', this.handleKeyDown);
      scope.position(args.position);
    };

    this.handleKeyDown = function (e) {
      if (e.which == $.ui.keyCode.ENTER && e.ctrlKey) {
        scope.cancel();
      } else if (e.which == $.ui.keyCode.ESCAPE) {
        e.preventDefault();
        scope.cancel();
      }
    };

    this.cancel = function () {
      $input.val(defaultValue);
      args.cancelChanges();
    };

    this.hide = function () {
      $wrapper.hide();
    };

    this.show = function () {
      $wrapper.show();
    };

    this.position = function (position) {
      calculateEditorPosition(position, $wrapper);
      position.top = Math.max(position.top, 0);
      $wrapper.css('top', position.top).css('left', position.left);
    };

    this.destroy = function () {
      this.resizeJsoneditorObserver.unobserve(document.getElementById('pg-json-editor'));
      $editor.destroy();
      $wrapper.remove();
    };

    this.focus = function () {
      $editor.focus();
    }; // listen to resize event for json editor


    this.resizeJsoneditorObserver = new ResizeObserver(function () {
      if ($editor) {
        $editor.resize();
      }
    });

    this.loadValue = function (item) {
      var data = defaultValue = item[args.column.field];
      tmpdata = data;

      if (args.column.column_type_internal === 'jsonb' && !Array.isArray(data) && data != null) {
        data = JSONBigNumber.stringify(JSONBigNumber.parse(data), null, 2);
      } else if (Array.isArray(data)) {
        var temp = [];
        $.each(data, function (i, val) {
          if (_typeof(val) === 'object') {
            temp.push(JSONBigNumber.stringify(val, null, 2));
          } else {
            temp.push(val);
          }
        });
        data = '[' + temp.join() + ']';
      }
      /* set editor content to empty if value is null*/


      if (_.isNull(data)) {
        defaultValue = '';
        data = '';
      }
      /* Create editor if required & set data*/


      __webpack_require__.e(/* require.ensure | jsoneditorchunk */ 708).then((function (require) {
        var JSONEditor = __webpack_require__(13807);

        var jsonContainer = document.getElementById('pg-json-editor');
        jsonContainer.setAttribute('readonly', true);
        var options = {
          modes: ['code', 'form', 'tree', 'preview'],
          onEditable: function onEditable() {
            return false;
          }
        };

        if (jsonContainer) {
          $editor = new JSONEditor(jsonContainer, options);
          $editor.setText(data);
        }
      }).bind(null, __webpack_require__)).catch(function (error) {
        throw error;
      });

      this.resizeJsoneditorObserver.observe(document.getElementById('pg-json-editor'));
    };

    this.serializeValue = function () {
      if ($editor) {
        var data = $editor.getText();

        if (data === '') {
          return null;
        }

        return data;
      } else {
        // The loader is not loaded yet ?
        return tmpdata;
      }
    };

    this.applyValue = function (item, state) {
      item[args.column.field] = state;
    };

    this.isValueChanged = function () {
      var data = $editor.getText();
      return !(data == '' && defaultValue == null) && data != defaultValue;
    };

    this.validate = function () {
      if (args.column.validator) {
        var validationResults = args.column.validator($editor.getText());

        if (!validationResults.valid) {
          return validationResults;
        }
      }

      return {
        valid: true,
        msg: null
      };
    };

    this.init();
  }

  function ReadOnlyTextEditor(args) {
    var $input;
    var defaultValue;

    this.init = function () {
      $input = $('<input type=text class=\'editor-text\' readonly/>').appendTo(args.container).on('keydown.nav', function (e) {
        if (e.keyCode === $.ui.keyCode.LEFT || e.keyCode === $.ui.keyCode.RIGHT) {
          e.stopImmediatePropagation();
        }
      }).trigger('focus').trigger('select');
    };

    this.destroy = function () {
      $input.remove();
    };

    this.focus = function () {
      $input.trigger('focus');
    };

    this.getValue = function () {
      return $input.val();
    };

    this.loadValue = function (item) {
      var value = item[args.column.field]; // Check if value is null or undefined

      if (value === null || typeof value === 'undefined') {
        value = '';
      }

      defaultValue = value;
      $input.val(defaultValue);
      $input[0].defaultValue = defaultValue;
      $input.trigger('select');
    };

    this.serializeValue = function () {
      return $input.val();
    };

    this.applyValue = function (item, state) {
      item[args.column.field] = state;
    };

    this.isValueChanged = function () {
      return !($input.val() == '' && defaultValue == null) && $input.val() != defaultValue;
    };

    this.validate = function () {
      if (args.column.validator) {
        var validationResults = args.column.validator($input.val());

        if (!validationResults.valid) {
          return validationResults;
        }
      }

      return {
        valid: true,
        msg: null
      };
    };

    this.init();
  }

  function ReadOnlyCheckboxEditor(args) {
    var $select;
    var defaultValue;

    this.init = function () {
      $select = $('<input type=checkbox value=\'true\' class=\'editor-checkbox\' hideFocus disabled>');
      $select.appendTo(args.container);
      $select.trigger('focus');
    };

    this.destroy = function () {
      $select.remove();
    };

    this.focus = function () {
      $select.trigger('focus');
    };

    this.loadValue = function (item) {
      defaultValue = item[args.column.pos];

      if (_.isNull(defaultValue) || _.isUndefined(defaultValue)) {
        $select.prop('indeterminate', true);
        $select.data('checked', 2);
      } else {
        defaultValue = !!item[args.column.pos];

        if (defaultValue) {
          $select.prop('checked', true);
          $select.data('checked', 0);
        } else {
          $select.prop('checked', false);
          $select.data('checked', 1);
        }
      }
    };

    this.serializeValue = function () {
      if ($select.prop('indeterminate')) {
        return null;
      }

      return $select.prop('checked');
    };

    this.applyValue = function (item, state) {
      item[args.column.pos] = state;
    };

    this.isValueChanged = function () {
      // var select_value = this.serializeValue();
      var select_value = $select.data('checked');
      return !(select_value === 2 && (defaultValue == null || defaultValue == undefined)) && select_value !== defaultValue;
    };

    this.validate = function () {
      return {
        valid: true,
        msg: null
      };
    };

    this.init();
  }

  function CustomNumberEditor(args) {
    var $input;
    var defaultValue;

    this.init = function () {
      $input = $('<input type=text class=\'editor-text\' />');
      $input.on('keydown.nav', function (e) {
        if (e.keyCode === $.ui.keyCode.LEFT || e.keyCode === $.ui.keyCode.RIGHT) {
          e.stopImmediatePropagation();
        }
      });
      $input.appendTo(args.container);
      $input.trigger('focus').trigger('select');
    };

    this.destroy = function () {
      $input.remove();
    };

    this.focus = function () {
      $input.trigger('focus');
    };

    this.loadValue = function (item) {
      defaultValue = item[args.column.field];

      if (Array.isArray(defaultValue) && !_.isNull(defaultValue) && !_.isUndefined(defaultValue)) {
        $input.val('{' + defaultValue.join() + '}');
      } else {
        $input.val(defaultValue);
      }

      $input[0].defaultValue = defaultValue;
      $input.trigger('select');
    };

    this.serializeValue = function () {
      var value = $input.val();

      if (value === '') {
        return null;
      }

      return value;
    };

    this.applyValue = function (item, state) {
      setValue(args, item, state, 'number');
    };

    this.isValueChanged = function () {
      if ($input.val() == '' && _.isUndefined(defaultValue)) {
        return false;
      } else if ($input.val() == '' && defaultValue == '') {
        return true;
      } else {
        return !($input.val() == '' && _.isNull(defaultValue)) && $input.val() != defaultValue;
      }
    };

    this.validate = function () {
      var value = $input.val();

      if (!args.column.is_array && isNaN(value)) {
        return {
          valid: false,
          msg: (0, _gettext["default"])('Please enter a valid number')
        };
      }

      if (args.column.validator) {
        var validationResults = args.column.validator(value);

        if (!validationResults.valid) {
          return validationResults;
        }
      }

      if (args.column.is_array) {
        if (!is_valid_array(value)) {
          return {
            valid: false,
            msg: (0, _gettext["default"])('Arrays must start with "{" and end with "}"')
          };
        }

        var val = value.trim().slice(1, -1),
            arr;

        if (val == '') {
          arr = [];
        } else {
          arr = val.split(',');
        }

        for (var k in arr) {
          if (isNaN(arr[k])) {
            return {
              valid: false,
              msg: (0, _gettext["default"])('Please enter a valid number')
            };
          }
        }
      }

      return {
        valid: true,
        msg: null
      };
    };

    this.init();
  } // Custom checkbox editor, We need it for runtime as it does not render
  // indeterminate checkbox state


  function pgCheckboxEditor(args) {
    var $select;
    var defaultValue, previousState;

    this.init = function () {
      var _this = this;

      $select = $('<div class=\'multi-checkbox\' tabindex="0"><span class=\'check\' hideFocus></span></div>');
      $select.appendTo(args.container);
      $select.trigger('focus');
      $select.on('click', this.changeValue);
      $select.on('keydown', function (e) {
        if (e.which == $.ui.keyCode.SPACE) {
          e.preventDefault();

          _this.changeValue(e);
        }
      });
    };

    this.changeValue = function () {
      // The following code is taken from https://css-tricks.com/indeterminate-checkboxes/
      var states = ['unchecked', 'partial', 'checked'];
      var curState = $select.find('.check').data('state') || 0;
      curState++;
      $select.find('.check').removeClass('unchecked partial checked').addClass(states[curState % states.length]).data('state', curState % states.length);
    };

    this.destroy = function () {
      $select.remove();
    };

    this.focus = function () {
      $select.trigger('focus');
    };

    this.loadValue = function (item) {
      defaultValue = item[args.column.field];
      previousState = 1;

      if (_.isNull(defaultValue) || _.isUndefined(defaultValue)) {
        $select.find('.check').data('state', 1).addClass('partial');
      } else {
        defaultValue = !!item[args.column.field];

        if (defaultValue) {
          $select.find('.check').data('state', 2).addClass('checked');
          previousState = 2;
        } else {
          $select.find('.check').data('state', 0).addClass('unchecked');
          previousState = 0;
        }
      }
    };

    this.serializeValue = function () {
      if ($select.find('.check').data('state') == 1) {
        return null;
      }

      return $select.find('.check').data('state') == 2 ? true : false;
    };

    this.applyValue = function (item, state) {
      item[args.column.field] = state;
    };

    this.isValueChanged = function () {
      var currentState = $select.find('.check').data('state');
      return currentState !== previousState;
    };

    this.validate = function () {
      if (args.column.validator) {
        var validationResults = args.column.validator(this.serializeValue());

        if (!validationResults.valid) {
          return validationResults;
        }
      }

      return {
        valid: true,
        msg: null
      };
    };

    this.init();
  }
})(__webpack_provided_window_dot_jQuery, _jsonBignumber["default"]);

/***/ }),

/***/ 27528:
/***/ ((__unused_webpack_module, __unused_webpack_exports, __webpack_require__) => {

"use strict";
/* provided dependency */ var _ = __webpack_require__(10084);
/* provided dependency */ var __webpack_provided_window_dot_jQuery = __webpack_require__(19755);


__webpack_require__(79753);

__webpack_require__(69600);

__webpack_require__(55674);

__webpack_require__(82526);

__webpack_require__(41817);

__webpack_require__(41539);

__webpack_require__(32165);

__webpack_require__(78783);

__webpack_require__(66992);

__webpack_require__(33948);

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

/////////////////////////////////////////////////////////////
//
// pgAdmin 4 - PostgreSQL Tools
//
// Copyright (C) 2013 - 2022, The pgAdmin Development Team
// This software is released under the PostgreSQL Licence
//
//////////////////////////////////////////////////////////////

/***
 * Contains pgAdmin4 related SlickGrid formatters.
 *
 * @module Formatters
 * @namespace Slick
 */
(function ($) {
  // register namespace
  $.extend(true, window, {
    'Slick': {
      'Formatters': {
        'JsonString': JsonFormatter,
        'Numbers': NumbersFormatter,
        'Checkmark': CheckmarkFormatter,
        'Text': TextFormatter,
        'Binary': BinaryFormatter
      }
    }
  });

  function NullAndDefaultFormatter(row, cell, value, columnDef) {
    if (_.isUndefined(value) && columnDef.has_default_val) {
      return '<span class=\'pull-left disabled_cell\'>[default]</span>';
    } else if (_.isUndefined(value) && columnDef.not_null || _.isUndefined(value) || value === null) {
      return '<span class=\'pull-left disabled_cell\'>[null]</span>';
    }

    return null;
  }

  function NullAndDefaultNumberFormatter(row, cell, value, columnDef) {
    if (_.isUndefined(value) && columnDef.has_default_val) {
      return '<span class=\'pull-right disabled_cell\'>[default]</span>';
    } else if (_.isUndefined(value) && columnDef.not_null || _.isUndefined(value) || value === null) {
      return '<span class=\'pull-right disabled_cell\'>[null]</span>';
    }

    return null;
  }

  function JsonFormatter(row, cell, value, columnDef) {
    // If column has default value, set placeholder
    var data = NullAndDefaultFormatter(row, cell, value, columnDef);

    if (data) {
      return data;
    } else {
      // Stringify only if it's json object
      if (_typeof(value) === 'object' && !Array.isArray(value)) {
        return _.escape(JSON.stringify(value));
      } else if (Array.isArray(value)) {
        var temp = [];
        $.each(value, function (i, val) {
          if (_typeof(val) === 'object') {
            temp.push(JSON.stringify(val));
          } else {
            temp.push(val);
          }
        });
        return _.escape('[' + temp.join() + ']');
      } else {
        return _.escape(value);
      }
    }
  }

  function NumbersFormatter(row, cell, value, columnDef) {
    // If column has default value, set placeholder
    var data = NullAndDefaultNumberFormatter(row, cell, value, columnDef);

    if (data) {
      return data;
    } else {
      return '<span style=\'float:right\'>' + _.escape(value) + '</span>';
    }
  }

  function CheckmarkFormatter(row, cell, value, columnDef) {
    /* Checkbox has 3 states
     * 1) checked=true
     * 2) unchecked=false
     * 3) indeterminate=null
     */
    var data = NullAndDefaultFormatter(row, cell, value, columnDef);

    if (data) {
      return data;
    } else {
      return value ? 'true' : 'false';
    }
  }

  function TextFormatter(row, cell, value, columnDef) {
    // If column has default value, set placeholder
    var raw = NullAndDefaultFormatter(row, cell, value, columnDef);
    var data;

    if (raw) {
      data = raw;
    } else {
      data = _.escape(value);
    } // Replace leading whitespace with a marker so we don't just show blank lines


    if (data.trimStart() != data) {
      data = '[...] ' + data.trimStart();
    }

    return data;
  }

  function BinaryFormatter(row, cell, value, columnDef) {
    // If column has default value, set placeholder
    var data = NullAndDefaultFormatter(row, cell, value, columnDef);

    if (data) {
      return data;
    } else {
      return '<span class=\'pull-left disabled_cell\'>[' + _.escape(value) + ']</span>';
    }
  }
})(__webpack_provided_window_dot_jQuery);

/***/ })

}]);
//# sourceMappingURL=pgadmin_commons.js.map